This patch changes ltmain.sh to add directories found in -R options of
dependent libraries to the final link command, such that non-libtool
dynamic libraries (which are a shared object inside the .a file on AIX) are
handled appropriately.

This patch changes ltmain.sh to keep the relative order of the GNU ld library
options --as-needed/--no-as-needed and --whole-archive/--no-whole-archive on the
command line.

The patch was originally taken from the Debian dh-autoreconf project
(https://salsa.debian.org/debian/dh-autoreconf) and then combined with the
existing 03ltmain-ld-groups-patch.

To allow for multiple appearances of the options on the command line, the patch
was further extended following (some of) the recommendations in
https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=347650#65

The patches are taken the Debian project:
https://sources.debian.org/patches/libtool/2.4.7-7/deplib_binary.patch
https://sources.debian.org/patches/libtool/2.4.7-7/link_all_deplibs.patch

The patches prevent overlinking.

The comment in link_all_deplibs.patch says:
## Do not link against deplibs.  This is not needed for shared libs
## on atleast ELF systems since those already know which libs they
## need themself.  This seems to break a few things and will be fixed
## in a better way in a future upstream version.

This patch is needed so that -Wl,-rpath option arguments make it into
the dependent libraries of a library and also ensures that -Wl,-Wl,,
options are passed to the compiler unaltered.

It is intended for libtool 2.4.2 and can be applied after
e.g. autoreconf by

$ patch -p1 <contrib/nagfor-libtool-patch/nagfor-libtool.patch

This patch changes ltmain.sh to keep the GNU ld library grouping options
-- -(, --start-group, -), and --end-group -- in the list of dependency
libraries so that the desired behaviour is retained (i.e. libraries with
cyclic dependencies can be linked).

!> @file xt_idxsection_f.f90
!! @brief Fortran interface to yaxt implementation
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE xt_idxsection
  USE iso_c_binding, ONLY: c_int, c_ptr
  USE xt_core, ONLY: xt_int_kind, xt_abort, i2, i4, i8
  USE xt_idxlist_abstract, ONLY: xt_idxlist, xt_idxlist_c2f
  IMPLICIT NONE
  PRIVATE
  PUBLIC :: xt_idxsection_new, xt_idxfsection_new

  INTERFACE xt_idxsection_new
    MODULE PROCEDURE xt_idxsection_new_a
    MODULE PROCEDURE xt_idxsection_new_i2
    MODULE PROCEDURE xt_idxsection_new_i4
    MODULE PROCEDURE xt_idxsection_new_i8
  END INTERFACE xt_idxsection_new

  INTERFACE
    FUNCTION xt_idxsection_new_c(start, num_dimensions, global_size, &
         local_size, local_start) BIND(c, name='xt_idxsection_new') &
         RESULT(idxsection)
      IMPORT :: c_int, c_ptr, xt_idxlist, xt_int_kind
      INTEGER(xt_int_kind), VALUE, INTENT(in) :: start
      INTEGER(c_int), VALUE, INTENT(in) :: num_dimensions
      INTEGER(xt_int_kind), INTENT(in) :: global_size(num_dimensions), &
           local_start(num_dimensions)
      INTEGER(c_int), INTENT(in) :: local_size(num_dimensions)
      TYPE(c_ptr) :: idxsection
    END FUNCTION xt_idxsection_new_c
  END INTERFACE

  CHARACTER(len=*), PARAMETER :: filename = 'xt_idxsection_f.f90'
CONTAINS

  FUNCTION xt_idxsection_new_a(start, global_size, local_size, local_start) &
       RESULT(idxsection)
    INTEGER(xt_int_kind), INTENT(in) :: start, local_start(:), global_size(:)
    INTEGER, INTENT(in) :: local_size(:)
    TYPE(xt_idxlist) :: idxsection
    INTEGER :: num_dimensions
    INTEGER(c_int) :: num_dimensions_c
    num_dimensions = SIZE(global_size)
    IF (SIZE(local_size) /= num_dimensions &
         .OR. SIZE(local_start) /= num_dimensions) &
         CALL xt_abort("non-matching array sizes", filename, __LINE__)
    num_dimensions_c = INT(num_dimensions, c_int)
    idxsection = xt_idxlist_c2f(&
         xt_idxsection_new_c(start, num_dimensions_c, global_size, &
         &                   INT(local_size, c_int), local_start))
  END FUNCTION xt_idxsection_new_a

  FUNCTION xt_idxsection_new_i2(start, num_dimensions, global_size, &
       local_size, local_start) RESULT(idxsection)
    INTEGER(i2), INTENT(in) :: num_dimensions
    INTEGER(xt_int_kind), INTENT(in) :: start, global_size(num_dimensions), &
         local_start(num_dimensions)
    INTEGER, INTENT(in) :: local_size(num_dimensions)
    TYPE(xt_idxlist) :: idxsection
    INTEGER(c_int) :: num_dimensions_c

    num_dimensions_c = INT(num_dimensions, c_int)
    idxsection = xt_idxlist_c2f(&
         xt_idxsection_new_c(start, num_dimensions_c, global_size, &
         &                   INT(local_size, c_int), local_start))
  END FUNCTION xt_idxsection_new_i2

  FUNCTION xt_idxsection_new_i4(start, num_dimensions, global_size, &
       local_size, local_start) RESULT(idxsection)
    INTEGER(i4), INTENT(in) :: num_dimensions
    INTEGER(xt_int_kind), INTENT(in) :: start, global_size(num_dimensions), &
         local_start(num_dimensions)
    INTEGER, INTENT(in) :: local_size(num_dimensions)
    TYPE(xt_idxlist) :: idxsection
    INTEGER(c_int), PARAMETER :: dummy = 1
    INTEGER(c_int) :: num_dimensions_c

    IF (num_dimensions > HUGE(dummy)) &
         CALL xt_abort("num_dimensions too large", filename, __LINE__)
    num_dimensions_c = INT(num_dimensions, c_int)
    idxsection = xt_idxlist_c2f(&
         xt_idxsection_new_c(start, num_dimensions_c, global_size, &
         &                   INT(local_size, c_int), local_start))
  END FUNCTION xt_idxsection_new_i4

  FUNCTION xt_idxsection_new_i8(start, num_dimensions, global_size, &
       local_size, local_start) RESULT(idxsection)
    INTEGER(i8), INTENT(in) :: num_dimensions
    INTEGER(xt_int_kind), INTENT(in) :: start, global_size(num_dimensions), &
         local_start(num_dimensions)
    INTEGER, INTENT(in) :: local_size(num_dimensions)
    TYPE(xt_idxlist) :: idxsection
    INTEGER(c_int), PARAMETER :: dummy = 1
    INTEGER(c_int) :: num_dimensions_c

    IF (num_dimensions > HUGE(dummy)) &
         CALL xt_abort("num_dimensions too large", filename, __LINE__)
    num_dimensions_c = INT(num_dimensions, c_int)
    idxsection = xt_idxlist_c2f(&
         xt_idxsection_new_c(start, num_dimensions_c, global_size, &
         &                   INT(local_size, c_int), local_start))
  END FUNCTION xt_idxsection_new_i8

  !> Fortran style version of \ref xt_idxsection_new. Compared to xt_idxsection_new, here
  !! the elements of the vector arguments are used in reversed order and the values of the elements
  !! of local_start are shifted by one. This means that, e.g.,  to start your local section with
  !! the global start index you have to set all coords in local_start to ONE instead of ZERO (as it would be required
  !! in xt_idxsection_new). The local section must be contained within the global index space.
  !! @param[in] start       start index of the global index space
  !! @param[in] global_size vector holding the global size for each dimension
  !! @param[in] local_size  vector holding the local section size for each dimension
  !! @param[in] local_start vector holding the coordinates of the section start; lowest coodinate is ONE for each dimension
  FUNCTION xt_idxfsection_new(start, global_size, local_size, local_start) &
       RESULT(idxfsection)
    INTEGER(xt_int_kind), INTENT(in) :: start, global_size(:), local_start(:)
    INTEGER, INTENT(in) :: local_size(:)
    TYPE(xt_idxlist) :: idxfsection

    INTEGER :: idim, ndim
    LOGICAL :: err_state

    ndim = SIZE(global_size)
    IF (SIZE(local_size) /= ndim .OR. SIZE(local_start) /= ndim) &
         CALL xt_abort("non-matching array sizes", filename, __LINE__)

    ! check if local indices are a subset of global indices:
    err_state = .FALSE.
    DO idim = 1, ndim
      err_state = err_state .OR. (local_start(idim) < 1) .OR. &
           (local_start(idim) + local_size(idim) - 1 >  global_size(idim))
    ENDDO
    IF (err_state) CALL xt_abort("local indices out of global index space", &
         filename, __LINE__)

    ! Fortran style map of mult-dim coords to indices:
    ! => reverse order of dimensions and coords starting at 1 (instead of 0 as in c)
    idxfsection = xt_idxsection_new(start, &
         global_size(ndim:1:-1), &
         local_size(ndim:1:-1), &
         local_start(ndim:1:-1) - 1_xt_int_kind )

  END FUNCTION xt_idxfsection_new

END MODULE xt_idxsection
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_collection_static_parallel_f.f90
!! @brief Fortran test of redist_collection_static class
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_redist_collection_static_parallel
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_int_kind, xi => xt_int_kind, &
       xt_idxlist, xt_idxlist_delete, xt_stripe, xt_idxvec_new, &
       xt_idxsection_new, xt_idxlist_collection_new, xt_idxstripes_new, &
       xt_xmap, xt_xmap_all2all_new, xt_xmap_delete, &
       xt_redist, xt_redist_p2p_new, xt_redist_collection_static_new, &
       xt_redist_copy, xt_redist_delete, xt_redist_s_exchange, &
       xt_idxlist_get_indices, xt_int_mpidt, &
       xt_request, xt_redist_a_exchange, xt_config, xt_config_delete
  USE test_redist_common, ONLY: check_redist_xi, check_wait_request, &
       redist_exchanger_option
  USE iso_c_binding, ONLY: c_loc, c_ptr
  ! older PGI compilers do not handle generic interface correctly
#if defined __PGI && (__PGIC__ < 12 || (__PGIC__ ==  12 && __PGIC_MINOR__ <= 10))
  USE xt_redist_base, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
#endif
  IMPLICIT NONE
  CHARACTER(len=*), PARAMETER :: &
       filename = 'test_redist_collection_static_parallel_f.f90'
  CHARACTER(len=*), PARAMETER :: err_msg(2) = &
       (/ "xt_redist_s_exchange", "xt_redist_a_exchange" /)
  TYPE(xt_config) :: config
  INTEGER :: rank, comm_size, ierror
  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  CALL mpi_comm_rank(mpi_comm_world, rank, ierror)
  IF (ierror /= MPI_SUCCESS) &
       CALL test_abort('mpi_comm_rank failed', filename, __LINE__)
  CALL mpi_comm_size(mpi_comm_world, comm_size, ierror)
  IF (ierror /= MPI_SUCCESS) &
       CALL test_abort('mpi_comm_size failed', filename, __LINE__)

  IF (comm_size > 1) THEN
    CALL test_4redist(mpi_comm_world, config)
    CALL test_rr_exchange(mpi_comm_world, config)
  END IF

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi
CONTAINS
  SUBROUTINE build_idxlists(indices_a, indices_b, indices_all)
    ! redist test with four different redists
    TYPE(xt_idxlist), INTENT(out) :: indices_a, indices_b, indices_all

    TYPE(xt_idxlist) :: indices_a_(2)
    INTEGER :: i
    INTEGER(xt_int_kind), PARAMETER :: start = 0_xi
    INTEGER(xt_int_kind) :: global_size(2), local_start(2, 2)
    INTEGER :: local_size(2)

    TYPE(xt_stripe) :: stripe

    global_size(1) = INT(2 * comm_size, xi)
    global_size(2) = INT(comm_size**2, xi)
    local_size = comm_size
    local_start = RESHAPE((/ 0_xi, INT(rank*comm_size, xi), &
         INT(comm_size, xi), INT(comm_size**2-(rank+1)*comm_size, xi) /), &
         (/ 2, 2 /))

    DO i = 1, 2
      indices_a_(i) = xt_idxsection_new(start, global_size, local_size, &
           local_start(:, i))
    END DO
    indices_a = xt_idxlist_collection_new(indices_a_)

    CALL xt_idxlist_delete(indices_a_(1))
    CALL xt_idxlist_delete(indices_a_(2))

    stripe = xt_stripe(INT(rank * 2 * comm_size**2, xi), 1_xi, 2*comm_size**2)
    indices_b = xt_idxstripes_new(stripe)

    stripe = xt_stripe(0_xi, 1_xi, 2*comm_size**3)
    indices_all = xt_idxstripes_new(stripe)
  END SUBROUTINE build_idxlists

  SUBROUTINE test_4redist(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    INTEGER, PARAMETER :: num_tx = 4
    TYPE(xt_idxlist) :: indices_a, indices_b, indices_all
    INTEGER(xt_int_kind), ALLOCATABLE, TARGET :: src(:), dst(:)
    INTEGER(xt_int_kind), POINTER :: index_vector_a(:), &
         index_vector_b(:), index_vector_all(:)
    TYPE(xt_xmap) :: xmaps(num_tx)
    TYPE(xt_redist) :: redists(num_tx), redist, redist_copy
    INTEGER(mpi_address_kind) :: src_displacements(num_tx), &
         dst_displacements(num_tx)
    INTEGER :: i, ierror, size_a, size_b, size_all
    INTEGER(xt_int_kind), POINTER :: results_1(:), &
         results_2(:), results_3(:), results_4(:)
#if defined __NVCOMPILER && __NVCOMPILER_MAJOR__ == 26
    TYPE(c_ptr) :: results_c(4), index_vector_a_c, index_vector_b_c
#endif

    size_a = 2 * comm_size**2
    size_b = 2 * comm_size**2
    size_all = 2 * comm_size**3

    ALLOCATE(src(size_a + size_b + size_all), dst(size_b + size_a + 2*size_all))

    index_vector_a => src(1:size_a)
    index_vector_b => src(size_a+1:size_a+size_b)
    index_vector_all => src(size_a+size_b+1:)

    results_1 => dst(1:size_b)
    results_2 => dst(size_b+1:size_b+size_a)
    results_3 => dst(size_b+size_a+1:size_b+size_a+size_all)
    results_4 => dst(size_b+size_a+size_all+1:size_b+size_a+2*size_all)

    CALL build_idxlists(indices_a, indices_b, indices_all)

    CALL xt_idxlist_get_indices(indices_a, index_vector_a)
    CALL xt_idxlist_get_indices(indices_b, index_vector_b)
    CALL xt_idxlist_get_indices(indices_all, index_vector_all)

    xmaps(1) = xt_xmap_all2all_new(indices_a, indices_b, comm)
    xmaps(2) = xt_xmap_all2all_new(indices_b, indices_a, comm)
    xmaps(3) = xt_xmap_all2all_new(indices_a, indices_all, comm)
    xmaps(4) = xt_xmap_all2all_new(indices_b, indices_all, comm)

    CALL xt_idxlist_delete(indices_a)
    CALL xt_idxlist_delete(indices_b)
    CALL xt_idxlist_delete(indices_all)

    DO i = 1, num_tx
      redists(i) = xt_redist_p2p_new(xmaps(i), xt_int_mpidt)
      CALL xt_xmap_delete(xmaps(i))
    END DO

#if !defined __NVCOMPILER || __NVCOMPILER_MAJOR__ != 26
    CALL mpi_get_address(index_vector_a, src_displacements(1), ierror)
    CALL mpi_get_address(index_vector_b, src_displacements(2), ierror)
    CALL mpi_get_address(index_vector_a, src_displacements(3), ierror)
    CALL mpi_get_address(index_vector_b, src_displacements(4), ierror)
#else
    ! when using nvfortran 26.1, the displacements obtained from
    ! mpi_get_address are all the same value, meaning that for some reason,
    ! the array arguments to mpi_get_address are incorrectly passed
    index_vector_a_c = C_LOC(index_vector_a)
    index_vector_b_c = C_LOC(index_vector_b)
    src_displacements(1) = TRANSFER(index_vector_a_c, 1_mpi_address_kind)
    src_displacements(2) = TRANSFER(index_vector_b_c, 1_mpi_address_kind)
    src_displacements(3) = src_displacements(1)
    src_displacements(4) = src_displacements(2)
#endif

    src_displacements = src_displacements - src_displacements(1)

#if !defined __NVCOMPILER || __NVCOMPILER_MAJOR__ != 26
    CALL mpi_get_address(results_1, dst_displacements(1), ierror)
    CALL mpi_get_address(results_2, dst_displacements(2), ierror)
    CALL mpi_get_address(results_3, dst_displacements(3), ierror)
    CALL mpi_get_address(results_4, dst_displacements(4), ierror)
#else
    ! work-around for defect in nvfortran 26
    results_c(1) = C_LOC(results_1)
    results_c(2) = C_LOC(results_2)
    results_c(3) = C_LOC(results_3)
    results_c(4) = C_LOC(results_4)
    DO i = 1, num_tx
      dst_displacements(i) = TRANSFER(results_c(i), 1_mpi_address_kind)
    END DO
#endif

    dst_displacements = dst_displacements - dst_displacements(1)

    redist = xt_redist_collection_static_new(redists, num_tx, &
         src_displacements, dst_displacements, comm, config)

    ! test communicator of redist
    ! if (!test_communicator(xt_redist_get_MPI_Comm(redist), COMM))
    !   PUT_ERR("error in xt_redist_get_MPI_Comm\n");

    CALL xt_redist_delete(redists)

    CALL test_transpose_gather(redist, dst, size_a, size_b, size_all, &
         index_vector_a, index_vector_b, index_vector_all)
    redist_copy = xt_redist_copy(redist)
    CALL xt_redist_delete(redist)
    CALL test_transpose_gather(redist_copy, dst, size_a, size_b, size_all, &
         index_vector_a, index_vector_b, index_vector_all)

    ! clean up
    CALL xt_redist_delete(redist_copy)
  END SUBROUTINE test_4redist

  SUBROUTINE test_transpose_gather(redist, dst, size_a, size_b, &
       size_all, index_vector_a, index_vector_b, index_vector_all)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER, INTENT(in) :: size_a, size_b, size_all
    INTEGER(xi), TARGET, INTENT(inout) :: dst(size_b+size_a+2*size_all)
    INTEGER(xi), TARGET, INTENT(in) :: index_vector_a(size_a)
    INTEGER(xi), INTENT(in) :: index_vector_b(size_b), &
         index_vector_all(size_all)

    INTEGER(xi), POINTER :: results_1(:), &
         results_2(:), results_3(:), results_4(:)
    TYPE(c_ptr) :: results(1), input(1)
    INTEGER :: iexch
    TYPE(xt_request) :: request

    results_1 => dst(1:size_b)
    results_2 => dst(size_b+1:size_b+size_a)
    results_3 => dst(size_b+size_a+1:size_b+size_a+size_all)
    results_4 => dst(size_b+size_a+size_all+1:size_b+size_a+2*size_all)

    input(1) = C_LOC(index_vector_a(1))
    results(1) = C_LOC(results_1(1))

    DO iexch = 1, 2
      dst = 0_xi

      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist, 1, input, results)
      ELSE
        CALL xt_redist_a_exchange(redist, 1, input, results, request)
        CALL check_wait_request(request, filename, __LINE__)
      ENDIF
      ! check results
      IF (ANY(results_1(:) /= index_vector_b)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)

      IF (ANY(results_2(:) /= index_vector_a)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)

      IF (ANY(results_3(:) /= index_vector_all)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)

      IF (ANY(results_4(:) /= index_vector_all)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE test_transpose_gather

  ! redist test with two redists that do a round robin exchange in
  ! different directions
  SUBROUTINE test_rr_exchange(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    INTEGER, PARAMETER :: num_local_indices = 5
    INTEGER(xi) :: src_indices(num_local_indices)
    INTEGER(xi) :: i_xi, temp, dst_indices(num_local_indices, 2)
    INTEGER(xi) :: num_indices_global
    INTEGER :: i
    TYPE(xt_xmap) :: xmaps(2)
    TYPE(xt_redist) :: redists(2), redist
    INTEGER(xi) :: results(num_local_indices, 2)
    INTEGER(mpi_address_kind) :: src_displacements(2), dst_displacements(2), &
         addr_temp
    INTEGER :: ierror

    num_indices_global = INT(comm_size, xi) * INT(num_local_indices, xi)
    DO i = 1, num_local_indices
      i_xi = INT(i, xi)
      src_indices(i) &
           = INT(rank, xi) * INT(num_local_indices, xi) + (i_xi - 1_xi)
      dst_indices(i, 1) = MOD(src_indices(i) + 1_xi, num_indices_global)
      temp = src_indices(i) - 1_xi
      dst_indices(i, 2) = MERGE(num_indices_global - 1_xi, temp, temp < 0_xi)
    END DO

    src_idxlist = xt_idxvec_new(src_indices, num_local_indices)
    DO i = 1, 2
      dst_idxlist = xt_idxvec_new(dst_indices(:, i))
      xmaps(i) = xt_xmap_all2all_new(src_idxlist, dst_idxlist, comm)
      CALL xt_idxlist_delete(dst_idxlist)
      redists(i) = xt_redist_p2p_new(xmaps(i), xt_int_mpidt)
      CALL xt_xmap_delete(xmaps(i))
    END DO

    CALL xt_idxlist_delete(src_idxlist)

    src_displacements = 0_mpi_address_kind
    dst_displacements(1) = 0_mpi_address_kind
    CALL mpi_get_address(results(1, 2), dst_displacements(2), ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error in mpi_get_address", filename, __LINE__)
    CALL mpi_get_address(results(1, 1), addr_temp, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error in mpi_get_address", filename, __LINE__)
    dst_displacements(2) = dst_displacements(2) - addr_temp

    redist = xt_redist_collection_static_new(redists, 2, src_displacements, &
         dst_displacements, comm, config)

    ! test communicator of redist
    ! IF (!test_communicator(xt_redist_get_MPI_Comm(redist), COMM))
    !     PUT_ERR("error in xt_redist_get_MPI_Comm\n");

    CALL xt_redist_delete(redists)

    CALL check_redist_xi(redist, num_local_indices, src_indices, &
         SIZE(results), results, dst_indices)

    ! clean up
    CALL xt_redist_delete(redist)
  END SUBROUTINE test_rr_exchange

END PROGRAM test_redist_collection_static_parallel
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_collection_static_parallel_f.f90
!! @brief Fortran test of redist_collection_static class
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_redist_collection_static_parallel
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_int_kind, xi => xt_int_kind, &
       xt_idxlist, xt_idxlist_delete, xt_stripe, xt_idxvec_new, &
       xt_idxsection_new, xt_idxlist_collection_new, xt_idxstripes_new, &
       xt_xmap, xt_xmap_all2all_new, xt_xmap_delete, &
       xt_redist, xt_redist_p2p_new, xt_redist_collection_static_new, &
       xt_redist_copy, xt_redist_delete, xt_redist_s_exchange, &
       xt_idxlist_get_indices, xt_int_mpidt, &
       xt_request, xt_redist_a_exchange, xt_config, xt_config_delete
  USE test_redist_common, ONLY: check_redist_xi, check_wait_request, &
       redist_exchanger_option
  USE iso_c_binding, ONLY: c_loc, c_ptr
  ! older PGI compilers do not handle generic interface correctly
#if defined __PGI && (__PGIC__ < 12 || (__PGIC__ ==  12 && __PGIC_MINOR__ <= 10))
  USE xt_redist_base, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
#endif
  IMPLICIT NONE
  CHARACTER(len=*), PARAMETER :: &
       filename = 'test_redist_collection_static_parallel_f.f90'
  CHARACTER(len=*), PARAMETER :: err_msg(2) = &
       (/ "xt_redist_s_exchange", "xt_redist_a_exchange" /)
  TYPE(xt_config) :: config
  INTEGER :: rank, comm_size, ierror
  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  CALL mpi_comm_rank(mpi_comm_world, rank, ierror)
  IF (ierror /= MPI_SUCCESS) &
       CALL test_abort('mpi_comm_rank failed', filename, __LINE__)
  CALL mpi_comm_size(mpi_comm_world, comm_size, ierror)
  IF (ierror /= MPI_SUCCESS) &
       CALL test_abort('mpi_comm_size failed', filename, __LINE__)

  IF (comm_size > 1) THEN
    CALL test_4redist(mpi_comm_world, config)
    CALL test_rr_exchange(mpi_comm_world, config)
  END IF

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi
CONTAINS
  SUBROUTINE build_idxlists(indices_a, indices_b, indices_all)
    ! redist test with four different redists
    TYPE(xt_idxlist), INTENT(out) :: indices_a, indices_b, indices_all

    TYPE(xt_idxlist) :: indices_a_(2)
    INTEGER :: i
    INTEGER(xt_int_kind), PARAMETER :: start = 0_xi
    INTEGER(xt_int_kind) :: global_size(2), local_start(2, 2)
    INTEGER :: local_size(2)

    TYPE(xt_stripe) :: stripe

    global_size(1) = INT(2 * comm_size, xi)
    global_size(2) = INT(comm_size**2, xi)
    local_size = comm_size
    local_start = RESHAPE((/ 0_xi, INT(rank*comm_size, xi), &
         INT(comm_size, xi), INT(comm_size**2-(rank+1)*comm_size, xi) /), &
         (/ 2, 2 /))

    DO i = 1, 2
      indices_a_(i) = xt_idxsection_new(start, global_size, local_size, &
           local_start(:, i))
    END DO
    indices_a = xt_idxlist_collection_new(indices_a_)

    CALL xt_idxlist_delete(indices_a_(1))
    CALL xt_idxlist_delete(indices_a_(2))

    stripe = xt_stripe(INT(rank * 2 * comm_size**2, xi), 1_xi, 2*comm_size**2)
    indices_b = xt_idxstripes_new(stripe)

    stripe = xt_stripe(0_xi, 1_xi, 2*comm_size**3)
    indices_all = xt_idxstripes_new(stripe)
  END SUBROUTINE build_idxlists

  SUBROUTINE test_4redist(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    INTEGER, PARAMETER :: num_tx = 4
    TYPE(xt_idxlist) :: indices_a, indices_b, indices_all
    INTEGER(xt_int_kind), ALLOCATABLE, TARGET :: src(:), dst(:)
    INTEGER(xt_int_kind), POINTER :: index_vector_a(:), &
         index_vector_b(:), index_vector_all(:)
    TYPE(xt_xmap) :: xmaps(num_tx)
    TYPE(xt_redist) :: redists(num_tx), redist, redist_copy
    INTEGER(mpi_address_kind) :: src_displacements(num_tx), &
         dst_displacements(num_tx)
    INTEGER :: i, ierror, size_a, size_b, size_all
    INTEGER(xt_int_kind), POINTER :: results_1(:), &
         results_2(:), results_3(:), results_4(:)

    size_a = 2 * comm_size**2
    size_b = 2 * comm_size**2
    size_all = 2 * comm_size**3

    ALLOCATE(src(size_a + size_b + size_all), dst(size_b + size_a + 2*size_all))

    index_vector_a => src(1:size_a)
    index_vector_b => src(size_a+1:size_a+size_b)
    index_vector_all => src(size_a+size_b+1:)

    results_1 => dst(1:size_b)
    results_2 => dst(size_b+1:size_b+size_a)
    results_3 => dst(size_b+size_a+1:size_b+size_a+size_all)
    results_4 => dst(size_b+size_a+size_all+1:size_b+size_a+2*size_all)

    CALL build_idxlists(indices_a, indices_b, indices_all)

    CALL xt_idxlist_get_indices(indices_a, index_vector_a)
    CALL xt_idxlist_get_indices(indices_b, index_vector_b)
    CALL xt_idxlist_get_indices(indices_all, index_vector_all)

    xmaps(1) = xt_xmap_all2all_new(indices_a, indices_b, comm)
    xmaps(2) = xt_xmap_all2all_new(indices_b, indices_a, comm)
    xmaps(3) = xt_xmap_all2all_new(indices_a, indices_all, comm)
    xmaps(4) = xt_xmap_all2all_new(indices_b, indices_all, comm)

    CALL xt_idxlist_delete(indices_a)
    CALL xt_idxlist_delete(indices_b)
    CALL xt_idxlist_delete(indices_all)

    DO i = 1, num_tx
      redists(i) = xt_redist_p2p_new(xmaps(i), xt_int_mpidt)
      CALL xt_xmap_delete(xmaps(i))
    END DO

    CALL mpi_get_address(index_vector_a, src_displacements(1), ierror)
    CALL mpi_get_address(index_vector_b, src_displacements(2), ierror)
    CALL mpi_get_address(index_vector_a, src_displacements(3), ierror)
    CALL mpi_get_address(index_vector_b, src_displacements(4), ierror)

    src_displacements = src_displacements - src_displacements(1)

    CALL mpi_get_address(results_1, dst_displacements(1), ierror)
    CALL mpi_get_address(results_2, dst_displacements(2), ierror)
    CALL mpi_get_address(results_3, dst_displacements(3), ierror)
    CALL mpi_get_address(results_4, dst_displacements(4), ierror)

    dst_displacements = dst_displacements - dst_displacements(1)

    redist = xt_redist_collection_static_new(redists, num_tx, &
         src_displacements, dst_displacements, comm, config)

    ! test communicator of redist
    ! if (!test_communicator(xt_redist_get_MPI_Comm(redist), COMM))
    !   PUT_ERR("error in xt_redist_get_MPI_Comm\n");

    CALL xt_redist_delete(redists)

    CALL test_transpose_gather(redist, dst, size_a, size_b, size_all, &
         index_vector_a, index_vector_b, index_vector_all)
    redist_copy = xt_redist_copy(redist)
    CALL xt_redist_delete(redist)
    CALL test_transpose_gather(redist_copy, dst, size_a, size_b, size_all, &
         index_vector_a, index_vector_b, index_vector_all)

    ! clean up
    CALL xt_redist_delete(redist_copy)
  END SUBROUTINE test_4redist

  SUBROUTINE test_transpose_gather(redist, dst, size_a, size_b, &
       size_all, index_vector_a, index_vector_b, index_vector_all)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER, INTENT(in) :: size_a, size_b, size_all
    INTEGER(xi), TARGET, INTENT(inout) :: dst(size_b+size_a+2*size_all)
    INTEGER(xi), TARGET, INTENT(in) :: index_vector_a(size_a)
    INTEGER(xi), INTENT(in) :: index_vector_b(size_b), &
         index_vector_all(size_all)

    INTEGER(xi), POINTER :: results_1(:), &
         results_2(:), results_3(:), results_4(:)
    TYPE(c_ptr) :: results(1), input(1)
    INTEGER :: iexch
    TYPE(xt_request) :: request

    results_1 => dst(1:size_b)
    results_2 => dst(size_b+1:size_b+size_a)
    results_3 => dst(size_b+size_a+1:size_b+size_a+size_all)
    results_4 => dst(size_b+size_a+size_all+1:size_b+size_a+2*size_all)

    input(1) = C_LOC(index_vector_a(1))
    results(1) = C_LOC(results_1(1))

    DO iexch = 1, 2
      dst = 0_xi

      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist, 1, input, results)
      ELSE
        CALL xt_redist_a_exchange(redist, 1, input, results, request)
        CALL check_wait_request(request, filename, __LINE__)
      ENDIF
      ! check results
      IF (ANY(results_1(:) /= index_vector_b)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)

      IF (ANY(results_2(:) /= index_vector_a)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)

      IF (ANY(results_3(:) /= index_vector_all)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)

      IF (ANY(results_4(:) /= index_vector_all)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE test_transpose_gather

  ! redist test with two redists that do a round robin exchange in
  ! different directions
  SUBROUTINE test_rr_exchange(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    INTEGER, PARAMETER :: num_local_indices = 5
    INTEGER(xi) :: src_indices(num_local_indices)
    INTEGER(xi) :: i_xi, temp, dst_indices(num_local_indices, 2)
    INTEGER(xi) :: num_indices_global
    INTEGER :: i
    TYPE(xt_xmap) :: xmaps(2)
    TYPE(xt_redist) :: redists(2), redist
    INTEGER(xi) :: results(num_local_indices, 2)
    INTEGER(mpi_address_kind) :: src_displacements(2), dst_displacements(2), &
         addr_temp
    INTEGER :: ierror

    num_indices_global = INT(comm_size, xi) * INT(num_local_indices, xi)
    DO i = 1, num_local_indices
      i_xi = INT(i, xi)
      src_indices(i) &
           = INT(rank, xi) * INT(num_local_indices, xi) + (i_xi - 1_xi)
      dst_indices(i, 1) = MOD(src_indices(i) + 1_xi, num_indices_global)
      temp = src_indices(i) - 1_xi
      dst_indices(i, 2) = MERGE(num_indices_global - 1_xi, temp, temp < 0_xi)
    END DO

    src_idxlist = xt_idxvec_new(src_indices, num_local_indices)
    DO i = 1, 2
      dst_idxlist = xt_idxvec_new(dst_indices(:, i))
      xmaps(i) = xt_xmap_all2all_new(src_idxlist, dst_idxlist, comm)
      CALL xt_idxlist_delete(dst_idxlist)
      redists(i) = xt_redist_p2p_new(xmaps(i), xt_int_mpidt)
      CALL xt_xmap_delete(xmaps(i))
    END DO

    CALL xt_idxlist_delete(src_idxlist)

    src_displacements = 0_mpi_address_kind
    dst_displacements(1) = 0_mpi_address_kind
    CALL mpi_get_address(results(1, 2), dst_displacements(2), ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error in mpi_get_address", filename, __LINE__)
    CALL mpi_get_address(results(1, 1), addr_temp, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error in mpi_get_address", filename, __LINE__)
    dst_displacements(2) = dst_displacements(2) - addr_temp

    redist = xt_redist_collection_static_new(redists, 2, src_displacements, &
         dst_displacements, comm, config)

    ! test communicator of redist
    ! IF (!test_communicator(xt_redist_get_MPI_Comm(redist), COMM))
    !     PUT_ERR("error in xt_redist_get_MPI_Comm\n");

    CALL xt_redist_delete(redists)

    CALL check_redist_xi(redist, num_local_indices, src_indices, &
         SIZE(results), results, dst_indices)

    ! clean up
    CALL xt_redist_delete(redist)
  END SUBROUTINE test_rr_exchange

END PROGRAM test_redist_collection_static_parallel
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_common_f.f90
!! @brief common routines for Fortran test of redist classes
!!
!! @copyright Copyright  (C)  2013 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE test_redist_common
  USE xt_core, ONLY: i2, i4, i8
  USE, INTRINSIC :: iso_c_binding, ONLY: c_ptr, c_loc
#include "xt_slice_c_loc.inc"
  USE mpi
  USE yaxt, ONLY: xt_idxlist, xt_int_kind, xt_idxvec_new, xt_idxlist_delete, &
       xt_xmap, xt_xmap_all2all_new, xt_redist, xt_redist_msg, xt_redist_copy, &
       xt_redist_single_array_base_new, xt_redist_delete, &
       xt_redist_s_exchange1, &
       xt_redist_s_exchange, xt_redist_a_exchange1, xt_redist_get_mpi_comm, &
       xt_request, xt_request_wait, xt_request_test, xt_is_null, &
       xt_redist_get_num_recv_msg, xt_redist_get_num_send_msg, &
       xi => xt_int_kind, xt_config, xt_config_new, &
       xt_config_set_exchange_method, xt_exchanger_id_by_name
#ifdef __PGI
  ! PGI up to at least 15.4 has a bug that prevents proper import of
  ! multiply extended generics. This is a separate bug from the one exhibited
  ! in 12.7 and older (see test_xmap_intersection_parallel_f.f90 for that)
  USE xt_redist_real_dp, ONLY: xt_redist_s_exchange
  USE xt_redist_int_i2, ONLY: xt_redist_s_exchange
  USE xt_redist_int_i4, ONLY: xt_redist_s_exchange
  USE xt_redist_int_i8, ONLY: xt_redist_s_exchange
#endif
#if defined(__GNUC__) && __GNUC__ < 4 || (__GNUC__ == 4 && __GNUC_MINOR__ <= 4)
  ! gfortran 4.4 botches default initialization for xt_request
  USE xt_requests, ONLY: xt_request_init
  USE iso_c_binding, ONLY: c_null_ptr
#  define REQ_DEFAULT_INIT_FIXUP(req) CALL xt_request_init(req, c_null_ptr)
#else
#  define REQ_DEFAULT_INIT_FIXUP(req)
#endif
  USE ftest_common, ONLY: test_abort, cmp_arrays
  IMPLICIT NONE
  PRIVATE
  INTERFACE check_redist
    MODULE PROCEDURE check_redist_dp
    MODULE PROCEDURE check_redist_dp_i2
    MODULE PROCEDURE check_redist_dp_i4
    MODULE PROCEDURE check_redist_dp_i8
    MODULE PROCEDURE check_redist_dp_2d
    MODULE PROCEDURE check_redist_xi
    MODULE PROCEDURE check_redist_i2
    MODULE PROCEDURE check_redist_i4
    MODULE PROCEDURE check_redist_i8
  END INTERFACE check_redist

  INTERFACE xt_redist_s_exchange
    MODULE PROCEDURE xt_rse_int_a2d_a3d
  END INTERFACE xt_redist_s_exchange

  INTERFACE wrap_a_exchange
    MODULE PROCEDURE wrap_a_exchange_dp
    MODULE PROCEDURE wrap_a_exchange_dp2d
    MODULE PROCEDURE wrap_a_exchange_i2
    MODULE PROCEDURE wrap_a_exchange_i4
    MODULE PROCEDURE wrap_a_exchange_i8
  END INTERFACE wrap_a_exchange

  INTERFACE test_redist_single_array_base
    MODULE PROCEDURE test_redist_single_array_base_dp
  END INTERFACE test_redist_single_array_base

  INTERFACE check_redist_extended
    MODULE PROCEDURE check_redist_extended_dp
  END INTERFACE check_redist_extended

  PUBLIC :: build_odd_selection_xmap, check_redist, communicators_are_congruent
  PUBLIC :: check_wait_request, check_test_request, check_redist_xi
  PUBLIC :: test_redist_single_array_base
  PUBLIC :: redist_exchanger_option
  PUBLIC :: xt_redist_s_exchange

  CHARACTER(len=*), PARAMETER :: filename = 'test_redist_common_f.f90'

  CHARACTER(len=29), PARAMETER :: check_redist_err_msg(2) = (/ &
       "error in xt_redist_s_exchange", &
       "error in xt_redist_a_exchange" /)

CONTAINS
  ! build xmap for destination list containing all odd elements of
  ! source list dimensioned 1 to src_slice_len
  FUNCTION build_odd_selection_xmap(src_slice_len, comm) RESULT(xmap)
    INTEGER, INTENT(in) :: src_slice_len, comm
    TYPE(xt_xmap) :: xmap
    INTEGER :: i, j, dst_slice_len
    INTEGER, PARAMETER :: dst_step = 2
    INTEGER(xt_int_kind), ALLOCATABLE :: index_list(:)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist

    dst_slice_len = (src_slice_len + dst_step - 1)/dst_step
    ALLOCATE(index_list(src_slice_len))
    DO i = 1, src_slice_len
      index_list(i) = INT(i, xt_int_kind)
    END DO
    src_idxlist = xt_idxvec_new(index_list)
    j = 1
    DO i = 1, src_slice_len, dst_step
      index_list(j) = INT(i, xt_int_kind)
      j = j + 1
    END DO
    dst_idxlist = xt_idxvec_new(index_list, dst_slice_len)
    DEALLOCATE(index_list)

    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist, comm)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)
  END FUNCTION build_odd_selection_xmap

  FUNCTION communicators_are_congruent(comm1, comm2) RESULT(congruent)
    INTEGER, INTENT(in) :: comm1, comm2
    LOGICAL :: congruent

    INTEGER :: ierror, rcode

    CALL mpi_comm_compare(comm1, comm2, rcode, ierror)
    congruent = ((rcode == mpi_ident) .OR. (rcode == mpi_congruent))
  END FUNCTION communicators_are_congruent

  SUBROUTINE assert_request_is_null(request, file, line)
    TYPE(xt_request), INTENT(in) :: request
    INTEGER, INTENT(in) :: line
    CHARACTER(len=*), INTENT(in) :: file
    IF (.NOT. xt_is_null(request)) &
      CALL test_abort("error: expected null request", &
           file, line)
  END SUBROUTINE assert_request_is_null

  SUBROUTINE assert_request_is_not_null(request, file, line)
    TYPE(xt_request), INTENT(in) :: request
    INTEGER, INTENT(in) :: line
    CHARACTER(len=*), INTENT(in) :: file
    IF (xt_is_null(request)) &
      CALL test_abort("error: expected non-null request", &
           file, line)
  END SUBROUTINE assert_request_is_not_null

  SUBROUTINE check_wait_request(request, file, line)
    TYPE(xt_request), INTENT(inout) :: request
    CHARACTER(len=*), INTENT(in) :: file
    INTEGER, INTENT(in) :: line
    CALL assert_request_is_not_null(request, file, line)
    CALL xt_request_wait(request)
    CALL assert_request_is_null(request, file, line)
  END SUBROUTINE check_wait_request

  SUBROUTINE check_test_request(request, file, line)
    TYPE(xt_request), INTENT(inout) :: request
    CHARACTER(len=*), INTENT(in) :: file
    INTEGER, INTENT(in) :: line
    LOGICAL :: flag
    CALL xt_request_test(request, flag)
    IF (xt_is_null(request) .AND. .NOT. flag) &
        CALL test_abort("error: expected flag set to .true.", file, line)
  END SUBROUTINE check_test_request

  SUBROUTINE wrap_a_exchange_dp(redist, src, dst)
    TYPE(xt_redist), INTENT(in) :: redist
    DOUBLE PRECISION, TARGET, INTENT(in) :: src(:)
    DOUBLE PRECISION, TARGET, INTENT(inout) :: dst(:)
    DOUBLE PRECISION, TARGET :: dummy(1)
    DOUBLE PRECISION, POINTER :: src_p(:), dst_p(:)

    IF (SIZE(src) > 0) THEN
      src_p => src
    ELSE
      src_p => dummy
    END IF
    IF (SIZE(dst) > 0) THEN
      dst_p => dst
    ELSE
      dst_p => dummy
    END IF
    CALL wrap_a_exchange_dp_as(redist, src_p, dst_p)
  END SUBROUTINE wrap_a_exchange_dp

  SUBROUTINE wrap_a_exchange_dp_as(redist, src, dst)
    TYPE(xt_redist), INTENT(in) :: redist
    DOUBLE PRECISION, TARGET, INTENT(in) :: src(*)
    DOUBLE PRECISION, TARGET, INTENT(inout) :: dst(*)
    TYPE(xt_request) :: request

    REQ_DEFAULT_INIT_FIXUP(request)
    CALL assert_request_is_null(request, filename, __LINE__)
    CALL xt_redist_a_exchange1(redist, C_LOC(src), C_LOC(dst), request)
    CALL check_wait_request(request, filename, __LINE__)
    CALL check_test_request(request, filename, __LINE__)
  END SUBROUTINE wrap_a_exchange_dp_as

  SUBROUTINE wrap_a_exchange_dp2d(redist, src, dst)
    TYPE(xt_redist), INTENT(in) :: redist
    DOUBLE PRECISION, TARGET, INTENT(in) :: src(:,:)
    DOUBLE PRECISION, TARGET, INTENT(inout) :: dst(:,:)
    DOUBLE PRECISION, TARGET :: dummy(1,1)
    DOUBLE PRECISION, POINTER :: src_p(:,:), dst_p(:,:)
    IF (SIZE(src) > 0) THEN
      src_p => src
    ELSE
      src_p => dummy
    END IF
    IF (SIZE(dst) > 0) THEN
      dst_p => dst
    ELSE
      dst_p => dummy
    END IF
    CALL wrap_a_exchange_dp_as(redist, src_p, dst_p)
  END SUBROUTINE wrap_a_exchange_dp2d

  SUBROUTINE wrap_a_exchange_i2(redist, src, dst)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i2), TARGET, INTENT(in) :: src(:)
    INTEGER(i2), TARGET, INTENT(inout) :: dst(:)
    INTEGER(i2), TARGET :: dummy(1)
    INTEGER(i2), POINTER :: src_p(:), dst_p(:)
    IF (SIZE(src) > 0) THEN
      src_p => src
    ELSE
      src_p => dummy
    END IF
    IF (SIZE(dst) > 0) THEN
      dst_p => dst
    ELSE
      dst_p => dummy
    END IF
    CALL wrap_a_exchange_i2_as(redist, src_p, dst_p)
  END SUBROUTINE wrap_a_exchange_i2

  SUBROUTINE wrap_a_exchange_i2_as(redist, src, dst)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i2), TARGET, INTENT(in) :: src(*)
    INTEGER(i2), TARGET, INTENT(inout) :: dst(*)
    TYPE(xt_request) :: request

    REQ_DEFAULT_INIT_FIXUP(request)
    CALL assert_request_is_null(request, filename, __LINE__)
    CALL xt_redist_a_exchange1(redist, C_LOC(src), C_LOC(dst), request)
    CALL check_wait_request(request, filename, __LINE__)
    CALL check_test_request(request, filename, __LINE__)
  END SUBROUTINE wrap_a_exchange_i2_as

  SUBROUTINE wrap_a_exchange_i4(redist, src, dst)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i4), TARGET, INTENT(in) :: src(:)
    INTEGER(i4), TARGET, INTENT(inout) :: dst(:)
    INTEGER(I4), TARGET :: dummy(1)
    INTEGER(I4), POINTER :: src_p(:), dst_p(:)

    IF (SIZE(src) > 0) THEN
      src_p => src
    ELSE
      src_p => dummy
    END IF
    IF (SIZE(dst) > 0) THEN
      dst_p => dst
    ELSE
      dst_p => dummy
    END IF
    CALL wrap_a_exchange_i4_as(redist, src_p, dst_p)
  END SUBROUTINE wrap_a_exchange_i4

  SUBROUTINE wrap_a_exchange_i4_as(redist, src, dst)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i4), TARGET, INTENT(in) :: src(*)
    INTEGER(i4), TARGET, INTENT(inout) :: dst(*)
    TYPE(xt_request) :: request

    REQ_DEFAULT_INIT_FIXUP(request)
    CALL assert_request_is_null(request, filename, __LINE__)
    CALL xt_redist_a_exchange1(redist, C_LOC(src), C_LOC(dst), request)
    CALL check_wait_request(request, filename, __LINE__)
    CALL check_test_request(request, filename, __LINE__)
  END SUBROUTINE wrap_a_exchange_i4_as

  SUBROUTINE wrap_a_exchange_i8(redist, src, dst)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src(:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst(:)
    INTEGER(I8), TARGET :: dummy(1)
    INTEGER(I8), POINTER :: src_p(:), dst_p(:)

    IF (SIZE(src) > 0) THEN
      src_p => src
    ELSE
      src_p => dummy
    END IF
    IF (SIZE(dst) > 0) THEN
      dst_p => dst
    ELSE
      dst_p => dummy
    END IF
    CALL wrap_a_exchange_i8_as(redist, src_p, dst_p)
  END SUBROUTINE wrap_a_exchange_i8

  SUBROUTINE wrap_a_exchange_i8_as(redist, src, dst)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src(*)
    INTEGER(i8), TARGET, INTENT(inout) :: dst(*)
    TYPE(xt_request) :: request

    REQ_DEFAULT_INIT_FIXUP(request)
    CALL assert_request_is_null(request, filename, __LINE__)
    CALL xt_redist_a_exchange1(redist, C_LOC(src), C_LOC(dst), request)
    CALL check_wait_request(request, filename, __LINE__)
    CALL check_test_request(request, filename, __LINE__)
  END SUBROUTINE wrap_a_exchange_i8_as

  SUBROUTINE check_redist_dp(redist, src, dst, ref_dst)
    TYPE(xt_redist), INTENT(in) :: redist
    DOUBLE PRECISION, INTENT(in) :: src(:), ref_dst(:)
    DOUBLE PRECISION, INTENT(inout) :: dst(:)
    INTEGER :: dst_size, ref_dst_size, iexch

    dst_size = SIZE(dst)
    ref_dst_size = SIZE(ref_dst)
    IF (dst_size /= ref_dst_size) &
         CALL test_abort("error: ref_dst larger than dst", filename, __LINE__)
    DO iexch = 1, 2
      dst = -1.0d0
      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist, src, dst)
      ELSE
        CALL wrap_a_exchange(redist, src, dst)
      ENDIF
      IF (cmp_arrays(dst, ref_dst)) &
           CALL test_abort(check_redist_err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE check_redist_dp

  SUBROUTINE check_redist_dp_i2(redist, src, dst, ref_dst)
    TYPE(xt_redist), INTENT(in) :: redist
    DOUBLE PRECISION, INTENT(in) :: src(:)
    INTEGER(i2), INTENT(in) :: ref_dst(:)
    DOUBLE PRECISION, INTENT(inout) :: dst(:)
    INTEGER :: dst_size, ref_dst_size, iexch

    dst_size = SIZE(dst)
    ref_dst_size = SIZE(ref_dst)
    IF (dst_size /= ref_dst_size) &
         CALL test_abort("error: ref_dst larger than dst", filename, __LINE__)
    DO iexch = 1, 2
      dst = -1.0d0
      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist, src, dst)
      ELSE
        CALL wrap_a_exchange(redist, src, dst)
      ENDIF
      IF (cmp_arrays(dst, DBLE(ref_dst))) &
           CALL test_abort(check_redist_err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE check_redist_dp_i2

  SUBROUTINE check_redist_dp_i4(redist, src, dst, ref_dst)
    TYPE(xt_redist), INTENT(in) :: redist
    DOUBLE PRECISION, INTENT(in) :: src(:)
    INTEGER(i4), INTENT(in) :: ref_dst(:)
    DOUBLE PRECISION, INTENT(inout) :: dst(:)
    INTEGER :: dst_size, ref_dst_size, iexch

    dst_size = SIZE(dst)
    ref_dst_size = SIZE(ref_dst)
    IF (dst_size /= ref_dst_size) &
         CALL test_abort("error: ref_dst larger than dst", filename, __LINE__)
    DO iexch = 1, 2
      dst = -1.0d0
      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist, src, dst)
      ELSE
        CALL wrap_a_exchange(redist, src, dst)
      ENDIF
      IF (cmp_arrays(dst, DBLE(ref_dst))) &
           CALL test_abort(check_redist_err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE check_redist_dp_i4

  SUBROUTINE check_redist_dp_i8(redist, src, dst, ref_dst)
    TYPE(xt_redist), INTENT(in) :: redist
    DOUBLE PRECISION, INTENT(in) :: src(:)
    INTEGER(i8), INTENT(in) :: ref_dst(:)
    DOUBLE PRECISION, INTENT(inout) :: dst(:)
    INTEGER :: dst_size, ref_dst_size, iexch

    dst_size = SIZE(dst)
    ref_dst_size = SIZE(ref_dst)
    IF (dst_size /= ref_dst_size) &
         CALL test_abort("error: ref_dst larger than dst", filename, __LINE__)
    DO iexch = 1, 2
      dst = -1.0d0
      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist, src, dst)
      ELSE
        CALL wrap_a_exchange(redist, src, dst)
      ENDIF
      IF (cmp_arrays(dst, DBLE(ref_dst))) &
           CALL test_abort(check_redist_err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE check_redist_dp_i8

  SUBROUTINE check_redist_dp_2d(redist, src, dst, ref_dst)
    TYPE(xt_redist), INTENT(in) :: redist
    DOUBLE PRECISION, INTENT(in) :: src(:,:), ref_dst(:,:)
    DOUBLE PRECISION, INTENT(inout) :: dst(:,:)
    INTEGER :: dst_size, ref_dst_size, iexch

    dst_size = SIZE(dst)
    ref_dst_size = SIZE(ref_dst)
    IF (dst_size /= ref_dst_size) &
         CALL test_abort("error: ref_dst larger than dst", filename, __LINE__)
    DO iexch = 1, 2
      dst = -1.0d0
      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist, src, dst)
      ELSE
        CALL wrap_a_exchange(redist, src, dst)
      ENDIF
      IF (cmp_arrays(dst, ref_dst)) &
           CALL test_abort(check_redist_err_msg(iexch), &
           filename, __LINE__)
    ENDDO
  END SUBROUTINE check_redist_dp_2d

  SUBROUTINE check_redist_xi(redist, src_size, src, dst_size, dst, ref_dst)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER, INTENT(in) :: src_size, dst_size
    INTEGER(xi), TARGET, INTENT(in) :: src(src_size)
    INTEGER(xi), INTENT(in) :: ref_dst(dst_size)
    INTEGER(xi), TARGET, INTENT(inout) :: dst(dst_size)
    CALL check_redist(redist, src, dst, ref_dst)
  END SUBROUTINE check_redist_xi

  SUBROUTINE check_redist_i2(redist, src, dst, ref_dst)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i2), INTENT(in) :: src(:), ref_dst(:)
    INTEGER(i2), INTENT(inout) :: dst(:)
    INTEGER :: dst_size, ref_dst_size, iexch

    dst_size = SIZE(dst)
    ref_dst_size = SIZE(ref_dst)
    IF (dst_size /= ref_dst_size) &
         CALL test_abort("error: ref_dst larger than dst", filename, __LINE__)
    DO iexch = 1, 2
      dst = -1_i2
      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist, src, dst)
      ELSE
        CALL wrap_a_exchange(redist, src, dst)
      ENDIF
      IF (cmp_arrays(dst, ref_dst)) &
           CALL test_abort(check_redist_err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE check_redist_i2

  SUBROUTINE check_redist_i4(redist, src, dst, ref_dst)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i4), INTENT(in) :: src(:), ref_dst(:)
    INTEGER(i4), INTENT(inout) :: dst(:)
    INTEGER :: dst_size, ref_dst_size, iexch

    dst_size = SIZE(dst)
    ref_dst_size = SIZE(ref_dst)
    IF (dst_size /= ref_dst_size) &
         CALL test_abort("error: ref_dst larger than dst", filename, __LINE__)
    DO iexch = 1, 2
      dst = -1_i4
      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist, src, dst)
      ELSE
        CALL wrap_a_exchange(redist, src, dst)
      ENDIF
      IF (cmp_arrays(dst, ref_dst)) &
           CALL test_abort(check_redist_err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE check_redist_i4

  SUBROUTINE check_redist_i8(redist, src, dst, ref_dst)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), INTENT(in) :: src(:), ref_dst(:)
    INTEGER(i8), INTENT(inout) :: dst(:)
    INTEGER :: dst_size, ref_dst_size, iexch

    dst_size = SIZE(dst)
    ref_dst_size = SIZE(ref_dst)
    IF (dst_size /= ref_dst_size) &
         CALL test_abort("error: ref_dst larger than dst", filename, __LINE__)
    DO iexch = 1, 2
      dst = -1_i8
      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist, src, dst)
      ELSE
        CALL wrap_a_exchange(redist, src, dst)
      ENDIF
      IF (cmp_arrays(dst, ref_dst)) &
           CALL test_abort(check_redist_err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE check_redist_i8

  SUBROUTINE test_redist_single_array_base_dp( &
      send_msgs, recv_msgs, src_data, ref_dst_data, comm, config)
    TYPE(xt_redist_msg), INTENT(in) :: send_msgs(:)
    TYPE(xt_redist_msg), INTENT(in) :: recv_msgs(:)
    DOUBLE PRECISION, INTENT(in) :: src_data(:)
    DOUBLE PRECISION, INTENT(in) :: ref_dst_data(:)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config

    TYPE(xt_redist) :: redist
    INTEGER :: nsend, nrecv

    redist = &
      xt_redist_single_array_base_new(send_msgs, recv_msgs, comm, config)
    nsend = SIZE(send_msgs)
    IF (nsend /= xt_redist_get_num_send_msg(redist)) &
         CALL test_abort("error in xt_redist_get_num_send_msg", &
         filename, __LINE__)
    nrecv = SIZE(recv_msgs)
    IF (nrecv /= xt_redist_get_num_recv_msg(redist)) &
         CALL test_abort("error in xt_redist_get_num_send_msg", &
         filename, __LINE__)
    ! test communicator of redist
    IF (.NOT. communicators_are_congruent(xt_redist_get_mpi_comm(redist), &
         comm)) &
         CALL test_abort("error in xt_redist_get_mpi_comm", filename, __LINE__)
    CALL check_redist_extended(redist, src_data, ref_dst_data)

  END SUBROUTINE test_redist_single_array_base_dp

  SUBROUTINE check_redist_extended_dp(redist, src_data, ref_dst_data)
    TYPE(xt_redist), INTENT(inout) :: redist
    DOUBLE PRECISION, INTENT(in) :: src_data(:)
    DOUBLE PRECISION, INTENT(in) :: ref_dst_data(:)

    DOUBLE PRECISION :: dst_data(SIZE(ref_dst_data))

    TYPE(xt_redist) :: redist_copy

    ! test exchange
    CALL check_redist(redist, src_data, dst_data, ref_dst_data)
    redist_copy = xt_redist_copy(redist)
    CALL xt_redist_delete(redist)
    CALL check_redist(redist_copy, src_data, dst_data, ref_dst_data)
    CALL xt_redist_delete(redist_copy)

  END SUBROUTINE check_redist_extended_dp

  FUNCTION redist_exchanger_option() RESULT(config)
    TYPE(xt_config) :: config
    INTEGER :: i, num_cmd_args, arg_len
    INTEGER :: exchanger_id
    INTEGER, PARAMETER :: max_opt_arg_len = 80
    CHARACTER(max_opt_arg_len) :: optarg
    config = xt_config_new()
    num_cmd_args = COMMAND_ARGUMENT_COUNT()
    i = 1
    DO WHILE (i < num_cmd_args)
      CALL GET_COMMAND_ARGUMENT(i, optarg, arg_len)
      IF (optarg(1:2) == '-m' .AND. i < num_cmd_args .AND. arg_len == 2) THEN
        CALL GET_COMMAND_ARGUMENT(i + 1, optarg, arg_len)
        IF (arg_len > max_opt_arg_len) &
             CALL test_abort('incorrect argument to command-line option -s', &
             filename, __LINE__)
        exchanger_id = xt_exchanger_id_by_name(optarg)
        IF (exchanger_id == -1) THEN
          WRITE (0, *) 'arg to -m: ', optarg(1:arg_len)
          CALL test_abort('incorrect argument to command-line option -m', &
               filename, __LINE__)
        END IF
        CALL xt_config_set_exchange_method(config, exchanger_id)
        i = i + 2
      ELSE
        WRITE (0, *) 'unexpected command-line argument parsing error: ', &
             optarg(1:arg_len)
        FLUSH(0)
        CALL test_abort('unexpected command-line argument', &
             filename, __LINE__)
      END IF
    END DO
  END FUNCTION redist_exchanger_option

  SUBROUTINE xt_rse_int_a2d_a3d(redist, src_data, target_data)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER, TARGET, INTENT(in) :: src_data(:,:)
    INTEGER, TARGET, INTENT(out) :: target_data(:,:,:)
    TYPE(c_ptr) :: src_p, dst_p

    XT_SLICE_C_LOC(src_data, src_p)
    XT_SLICE_C_LOC(target_data, dst_p)
    CALL xt_redist_s_exchange1(redist, src_p, dst_p)
  END SUBROUTINE xt_rse_int_a2d_a3d

END MODULE test_redist_common
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_collection_displace_f.f90
!! @brief Fortran cache displacement test of redist_collection class
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
#define XT_UNUSED(x) IF (SIZE( (/(x)/) ) < 0) CONTINUE
MODULE redist_collection_displace
  USE mpi
  USE ftest_common, ONLY: test_abort, cmp_arrays
  USE yaxt, ONLY: &
       xt_xmap, xt_xmap_delete, &
       xt_redist, xt_redist_p2p_new, xt_redist_collection_new, &
       Xt_redist_copy, xt_redist_delete, xt_redist_s_exchange, &
       xt_request, xt_redist_a_exchange, xt_config
  ! older PGI compilers do not handle generic interface correctly
#if defined __PGI && (__PGIC__ < 12 || (__PGIC__ ==  12 && __PGIC_MINOR__ <= 10))
  USE xt_redist_base, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
#endif
  USE test_redist_common, ONLY: build_odd_selection_xmap, &
       check_wait_request
  USE iso_c_binding, ONLY: c_ptr, c_loc
  IMPLICIT NONE
  PRIVATE
  INTEGER, PARAMETER :: cache_size = 16, cache_overrun = 2
  INTEGER, PARAMETER :: num_slice = 3, dst_step = 2
  INTEGER, PARAMETER :: src_slice_len = 5
  INTEGER, PARAMETER :: dst_slice_len &
       = (src_slice_len + dst_step - 1)/dst_step
  CHARACTER(len=*), PARAMETER :: &
       filename = 'test_redist_collection_displace_f.f90'
  CHARACTER(len=*), PARAMETER :: err_msg(2) = &
       (/ "error on xt_redist_s_exchange", "error on xt_redist_a_exchange" /)
  PUBLIC :: test_displacement_variations
CONTAINS
  ! test with one redist used three times (with different input
  ! data displacements until the cache is full)
  ! set up data
  SUBROUTINE test_displacement_variations(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redists(num_slice), redist_coll, &
         redist_coll_copy

    xmap = build_odd_selection_xmap(src_slice_len, comm)
    redist = xt_redist_p2p_new(xmap, mpi_double_precision, config)

    CALL xt_xmap_delete(xmap)

    ! generate redist_collection
    redists = redist

    redist_coll = xt_redist_collection_new(redists, num_slice, &
         cache_size, comm, config)

    CALL xt_redist_delete(redist)

    CALL run_displacement_check(redist_coll)
    redist_coll_copy = xt_redist_copy(redist_coll)
    CALL run_displacement_check(redist_coll_copy)

    ! clean up
    CALL xt_redist_delete(redist_coll)
    CALL xt_redist_delete(redist_coll_copy)
  END SUBROUTINE test_displacement_variations

  SUBROUTINE run_displacement_check(redist_coll)
    TYPE(xt_redist), INTENT(in) :: redist_coll
    INTEGER :: i, j, k
    DOUBLE PRECISION, TARGET :: &
         src(src_slice_len * (num_slice+1) + cache_size + cache_overrun), &
         dst(dst_slice_len * (num_slice+1) + cache_size + cache_overrun)
    TYPE(c_ptr) :: src_data_p(num_slice), dst_data_p(num_slice)
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(dst_slice_len, num_slice) = &
         RESHAPE((/ ((DBLE(i + j * src_slice_len), &
         &            i = 1, src_slice_len, dst_step), &
         &           j = 0, num_slice - 1) /), &
         &       (/ dst_slice_len, num_slice /))

    CALL init_displacement_check_src(src)

    DO i = 1, num_slice - 1
      src_data_p(i) = C_LOC(src((i-1)*src_slice_len+1))
      dst_data_p(i) = C_LOC(dst((i-1)*dst_slice_len+1))
    END DO

    ! test exchange
    DO k = 1, cache_size + cache_overrun
      src(src_slice_len*num_slice+k:src_slice_len*(num_slice+1)+k-1) &
           = src(src_slice_len*(num_slice-1)+1:src_slice_len*num_slice)
      CALL run_displacement_check_exchange(redist_coll, src, dst, &
           src(src_slice_len*num_slice+k), &
           dst(dst_slice_len*num_slice+k), &
           src_data_p, dst_data_p, ref_dst_data)
    END DO
  END SUBROUTINE run_displacement_check

  SUBROUTINE init_displacement_check_src(src)
    DOUBLE PRECISION, INTENT(out) :: src(src_slice_len, num_slice)
    INTEGER :: i, j
    DO j = 1, num_slice
      DO i = 1, src_slice_len
        src(i, j) = DBLE(i + (j - 1) * src_slice_len)
      END DO
    END DO
  END SUBROUTINE init_displacement_check_src

  SUBROUTINE run_displacement_check_exchange(redist_coll, &
       src1, dst1, src2, dst2, src_data_p, dst_data_p, ref_dst_data)
    TYPE(xt_redist), INTENT(in) :: redist_coll
    DOUBLE PRECISION, TARGET, INTENT(in) :: src1(src_slice_len, num_slice-1), &
         src2(src_slice_len)
    DOUBLE PRECISION, TARGET, INTENT(inout) :: &
         dst1(dst_slice_len, num_slice-1), dst2(dst_slice_len)
    DOUBLE PRECISION, INTENT(in) :: ref_dst_data(dst_slice_len, num_slice)
    TYPE(c_ptr), INTENT(inout) :: src_data_p(num_slice), dst_data_p(num_slice)
    TYPE(xt_request) :: request
    INTEGER :: iexch

    XT_UNUSED(src1)
    src_data_p(3) = C_LOC(src2)
    dst_data_p(3) = C_LOC(dst2)

    DO iexch = 1, 2
      dst1 = -1.0d0
      dst2 = -1.0d0
      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist_coll, num_slice, src_data_p, &
             dst_data_p)
      ELSE
        CALL xt_redist_a_exchange(redist_coll, num_slice, src_data_p, &
             dst_data_p, request)
        CALL check_wait_request(request, filename, __LINE__)
      ENDIF
      IF (cmp_arrays(ref_dst_data(:, 1:num_slice-1), dst1) &
           .OR. cmp_arrays(ref_dst_data(:,num_slice), dst2)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE run_displacement_check_exchange

END MODULE redist_collection_displace
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file xt_xmap_dist_dir_bucket_gen2f.f90
!! @brief Fortran interface to yaxt bucket generator definition
!!
!! @copyright Copyright  (C)  2024 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE xt_xmap_dist_dir_bucket_gen2
  USE iso_c_binding, ONLY: c_int, c_ptr, c_size_t
  USE xt_core, ONLY: xt_mpi_fint_kind
  USE xt_config_f, ONLY: xt_config
  USE xt_xmap_intersection, ONLY: xt_com_list
  USE xt_idxlist_abstract, ONLY: xt_idxlist
  USE xt_xmap_dist_dir_bucket_gen, ONLY: xt_xmdd_bucket_gen
  IMPLICIT NONE
  PRIVATE

  INTEGER(c_int), PUBLIC, PARAMETER :: &
       xt_dist_dir_bucket_gen_type_send = 1, &
       xt_dist_dir_bucket_gen_type_recv = 2, &
       xt_dist_dir_bucket_gen_type_sendrecv = 3

  TYPE, BIND(c), PUBLIC :: xt_xmdd_bucket_gen_comms
    INTEGER(xt_mpi_fint_kind) :: intra_comm, inter_comm, &
         tag_offset_intra, tag_offset_inter
  END TYPE xt_xmdd_bucket_gen_comms

  ! Interface of bucket generator
  !
  ! Essentially, the generator needs to be able to enumerate all
  ! buckets used to form intersections. This means the generator only
  ! needs to produce buckets that actually can intersect and,
  ! consequently, buckets that won't intersect the requested type of
  ! list can be skipped.
  PUBLIC :: xt_xmdd_bucket_gen_define_interface
  INTERFACE xt_xmdd_bucket_gen_define_interface
    SUBROUTINE xt_xmdd_bucket_gen_define_interface_f(gen, init, destroy, &
         get_intersect_max_num, next, gen_state_size, init_params)
      IMPORT :: xt_xmdd_bucket_gen, xt_config, xt_idxlist, c_int, &
           c_ptr, c_size_t, xt_mpi_fint_kind, xt_com_list, &
           xt_xmdd_bucket_gen_comms
      TYPE(xt_xmdd_bucket_gen), INTENT(inout) :: gen
      INTERFACE
        !  The init function sets up the generator state.
        FUNCTION init(gen_state, src_idxlist, &
             dst_idxlist, config, comms, init_params) BIND(c) RESULT(stripify)
          IMPORT :: c_int, c_ptr, xt_idxlist, xt_config, &
               xt_xmdd_bucket_gen_comms
          INTEGER(c_int) :: stripify
          TYPE(c_ptr), VALUE :: gen_state
          TYPE(xt_idxlist), VALUE, INTENT(in) :: src_idxlist,dst_idxlist
          TYPE(xt_config), VALUE, INTENT(in) :: config
          TYPE(xt_xmdd_bucket_gen_comms), intent(in) :: comms
          TYPE(c_ptr), VALUE, INTENT(in) :: init_params
        END FUNCTION init

        !  The destroy function clean up the generator state. Can be zero
        !  if no cleaning is needed.
        SUBROUTINE destroy(gen_state) BIND(c)
          IMPORT :: c_ptr
          TYPE(c_ptr), VALUE, INTENT(in) :: gen_state
        END SUBROUTINE destroy

        FUNCTION get_intersect_max_num(gen_state, &
             bucket_type) BIND(C) RESULT(max_num)
          IMPORT :: c_ptr, c_int
          TYPE(c_ptr), VALUE :: gen_state
          INTEGER(c_int), VALUE :: bucket_type
          INTEGER(c_int) :: max_num
        END FUNCTION get_intersect_max_num

        ! The next function returns the next bucket and corresponding rank
        ! (ranks can be skipped when the intersection will be empty
        ! anyway).
        ! Any previously returned buckets become invalid.
        FUNCTION next(gen_state, bucket_type) &
             BIND(C) RESULT(bucket)
          IMPORT :: c_ptr, c_int, xt_com_list
          TYPE(c_ptr), VALUE :: gen_state
          INTEGER(c_int), VALUE :: bucket_type
          TYPE(xt_com_list) :: bucket
        END FUNCTION next
      END INTERFACE
      ! INTERFACE
      !   SUBROUTINE xt_xmdd_bucket_gen_def_if_f2c(gen, init, destroy, &
      !        get_intersect_max_num, next, gen_state_size) &
      !        BIND(c, name='xt_xmdd_bucket_gen_def_if_f2c')
      !     IMPORT :: c_funptr, c_size_t, c_ptr
      !     IMPLICIT NONE
      !     TYPE(c_ptr), VALUE :: gen
      !     TYPE(c_funptr), VALUE :: init, destroy, get_intersect_max_num, next
      !     INTEGER(c_size_t), VALUE :: gen_state_size
      !     TYPE(c_ptr), VALUE :: gen
      !   END SUBROUTINE xt_xmdd_bucket_gen_def_if_f2c
      ! END INTERFACE
          ! gen_state_size is the size of the generator state
      !
      ! The distributed directory will provide memory aligned to
      ! TYPE(c_ptr) variables of this size.
      INTEGER(c_size_t) :: gen_state_size
      TYPE(c_ptr), VALUE :: init_params
    END SUBROUTINE xt_xmdd_bucket_gen_define_interface_f
  END INTERFACE xt_xmdd_bucket_gen_define_interface
END MODULE xt_xmap_dist_dir_bucket_gen2
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_collection_displace_f.f90
!! @brief Fortran cache displacement test of redist_collection class
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
#define XT_UNUSED(x) IF (SIZE( (/(x)/) ) < 0) CONTINUE
MODULE redist_collection_displace
  USE mpi
  USE ftest_common, ONLY: test_abort, cmp_arrays
  USE yaxt, ONLY: &
       xt_xmap, xt_xmap_delete, &
       xt_redist, xt_redist_p2p_new, xt_redist_collection_new, &
       Xt_redist_copy, xt_redist_delete, xt_redist_s_exchange, &
       xt_request, xt_redist_a_exchange, xt_config
  ! older PGI compilers do not handle generic interface correctly
#if defined __PGI && (__PGIC__ < 12 || (__PGIC__ ==  12 && __PGIC_MINOR__ <= 10))
  USE xt_redist_base, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
#endif
  USE test_redist_common, ONLY: build_odd_selection_xmap, &
       check_wait_request
  USE iso_c_binding, ONLY: c_ptr, c_loc
  IMPLICIT NONE
  PRIVATE
  INTEGER, PARAMETER :: cache_size = 16, cache_overrun = 2
  INTEGER, PARAMETER :: dst_step = 2
  INTEGER, PARAMETER :: src_slice_len = 5
  INTEGER, PARAMETER :: dst_slice_len &
       = (src_slice_len + dst_step - 1)/dst_step
  CHARACTER(len=*), PARAMETER :: &
       filename = 'test_redist_collection_displace_f.f90'
  CHARACTER(len=*), PARAMETER :: err_msg(2) = &
       (/ "error on xt_redist_s_exchange", "error on xt_redist_a_exchange" /)
  PUBLIC :: test_displacement_variations
CONTAINS
  ! test with one redist used three times (with different input
  ! data displacements until the cache is full)
  ! set up data
  SUBROUTINE test_displacement_variations(comm, config, num_redists)
    INTEGER, INTENT(in) :: comm, num_redists
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redists(num_redists), redist_coll, &
         redist_coll_copy

    xmap = build_odd_selection_xmap(src_slice_len, comm)
    redist = xt_redist_p2p_new(xmap, mpi_double_precision, config)

    CALL xt_xmap_delete(xmap)

    ! generate redist_collection
    redists = redist

    redist_coll = xt_redist_collection_new(redists, num_redists, &
         cache_size, comm, config)

    CALL xt_redist_delete(redist)

    CALL run_displacement_check(redist_coll, num_redists)
    redist_coll_copy = xt_redist_copy(redist_coll)
    CALL run_displacement_check(redist_coll_copy, num_redists)

    ! clean up
    CALL xt_redist_delete(redist_coll)
    CALL xt_redist_delete(redist_coll_copy)
  END SUBROUTINE test_displacement_variations

  SUBROUTINE run_displacement_check(redist_coll, num_slice)
    TYPE(xt_redist), INTENT(in) :: redist_coll
    INTEGER, INTENT(in) :: num_slice
    INTEGER :: i, j, k
    DOUBLE PRECISION, ALLOCATABLE, TARGET :: src(:), dst(:)
#ifndef __G95__
    TYPE(c_ptr) :: src_data_p(num_slice), dst_data_p(num_slice)
#else
    TYPE(c_ptr) :: src_data_p(512), dst_data_p(512)
#endif
    DOUBLE PRECISION, ALLOCATABLE :: ref_dst_data(:,:)

    ALLOCATE(src(src_slice_len * (num_slice+1) + cache_size + cache_overrun), &
         dst(dst_slice_len * (num_slice+1) + cache_size + cache_overrun), &
         ref_dst_data(dst_slice_len, num_slice))
    CALL init_displacement_check_src(src, num_slice, src_data_p)
    DO j = 1, num_slice
      DO i = 1, dst_slice_len
        ref_dst_data(i, j) = DBLE((i-1)*dst_step + (j-1) * src_slice_len + 1)
      END DO
    END DO

    DO j = 1, num_slice - 1
      dst_data_p(j) = C_LOC(dst((j-1)*dst_slice_len+1))
    END DO

    ! test exchange
    DO k = 1, cache_size + cache_overrun
      src(src_slice_len*num_slice+k:src_slice_len*(num_slice+1)+k-1) &
           = src(src_slice_len*(num_slice-1)+1:src_slice_len*num_slice)
      CALL run_displacement_check_exchange(redist_coll, num_slice, &
           src, dst, src(src_slice_len*num_slice+k), &
           dst(dst_slice_len*num_slice+k), &
           src_data_p, dst_data_p, ref_dst_data)
    END DO
  END SUBROUTINE run_displacement_check

  SUBROUTINE init_displacement_check_src(src, num_slice, src_data_p)
    INTEGER, INTENT(in) :: num_slice
    DOUBLE PRECISION, TARGET, INTENT(out) :: src(src_slice_len, num_slice)
    TYPE(c_ptr), INTENT(out) :: src_data_p(num_slice)
    INTEGER :: i, j
    DO j = 1, num_slice
      DO i = 1, src_slice_len
        src(i, j) = DBLE(i + (j - 1) * src_slice_len)
      END DO
    END DO
    DO j = 1, num_slice - 1
      src_data_p(j) = C_LOC(src(1, j))
    END DO
  END SUBROUTINE init_displacement_check_src

  SUBROUTINE run_displacement_check_exchange(redist_coll, num_slice, &
       src1, dst1, src2, dst2, src_data_p, dst_data_p, ref_dst_data)
    TYPE(xt_redist), INTENT(in) :: redist_coll
    INTEGER, INTENT(in) :: num_slice
    DOUBLE PRECISION, TARGET, INTENT(in) :: src1(src_slice_len, num_slice-1), &
         src2(src_slice_len)
    DOUBLE PRECISION, TARGET, INTENT(inout) :: &
         dst1(dst_slice_len, num_slice-1), dst2(dst_slice_len)
    DOUBLE PRECISION, INTENT(in) :: ref_dst_data(dst_slice_len, num_slice)
    TYPE(c_ptr), INTENT(inout) :: src_data_p(num_slice), dst_data_p(num_slice)
    TYPE(xt_request) :: request
    INTEGER :: iexch

    XT_UNUSED(src1)
    src_data_p(num_slice) = C_LOC(src2)
    dst_data_p(num_slice) = C_LOC(dst2)

    DO iexch = 1, 2
      dst1 = -1.0d0
      dst2 = -1.0d0
      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist_coll, num_slice, src_data_p, &
             dst_data_p)
      ELSE
        CALL xt_redist_a_exchange(redist_coll, num_slice, src_data_p, &
             dst_data_p, request)
        CALL check_wait_request(request, filename, __LINE__)
      ENDIF
      IF (cmp_arrays(ref_dst_data(:, 1:num_slice-1), dst1) &
           .OR. cmp_arrays(ref_dst_data(:,num_slice), dst2)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE run_displacement_check_exchange

END MODULE redist_collection_displace
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file xt_xmap_dist_dir_bucket_gen2f.f90
!! @brief Fortran interface to yaxt bucket generator definition
!!
!! @copyright Copyright  (C)  2024 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE xt_xmap_dist_dir_bucket_gen2
  USE iso_c_binding, ONLY: c_int, c_ptr, c_size_t
#ifdef HAVE_FC_C_FUNLOC
  USE iso_c_binding, ONLY: c_funptr
#endif
#if defined HAVE_FC_C_FUNLOC && defined HAVE_FC_ABSTRACT_INTERFACE
  USE iso_c_binding, ONLY: c_f_procpointer
#endif
  USE xt_core, ONLY: xt_mpi_fint_kind
  USE xt_config_f, ONLY: xt_config
  USE xt_xmap_intersection, ONLY: xt_com_list
  USE xt_idxlist_abstract, ONLY: xt_idxlist
  USE xt_xmap_dist_dir_bucket_gen, ONLY: xt_xmdd_bucket_gen, &
       xt_xmdd_bucket_gen_f2c
  IMPLICIT NONE
  PRIVATE

  INTEGER(c_int), PUBLIC, PARAMETER :: &
       xt_dist_dir_bucket_gen_type_send = 1, &
       xt_dist_dir_bucket_gen_type_recv = 2, &
       xt_dist_dir_bucket_gen_type_sendrecv = 3

  TYPE, BIND(c), PUBLIC :: xt_xmdd_bucket_gen_comms
    INTEGER(xt_mpi_fint_kind) :: intra_comm, inter_comm, &
         tag_offset_intra, tag_offset_inter
  END TYPE xt_xmdd_bucket_gen_comms

#ifdef HAVE_FC_ABSTRACT_INTERFACE
  ABSTRACT INTERFACE
    !  The init function sets up the generator state.
    FUNCTION xt_xmdd_bucket_gen_init_state(gen_state, src_idxlist, &
         dst_idxlist, config, comms, init_params) BIND(c) RESULT(stripify)
      IMPORT :: c_int, c_ptr, xt_idxlist, xt_config, &
           xt_xmdd_bucket_gen_comms
      INTEGER(c_int) :: stripify
      TYPE(c_ptr), VALUE :: gen_state
      TYPE(xt_idxlist), VALUE :: src_idxlist, dst_idxlist
      TYPE(xt_config), VALUE :: config
      TYPE(xt_xmdd_bucket_gen_comms), INTENT(in) :: comms
      TYPE(c_ptr), VALUE :: init_params
    END FUNCTION xt_xmdd_bucket_gen_init_state
  END INTERFACE
  PUBLIC :: xt_xmdd_bucket_gen_init_state
#endif

  ! Interface of bucket generator
  !
  ! Essentially, the generator needs to be able to enumerate all
  ! buckets used to form intersections. This means the generator only
  ! needs to produce buckets that actually can intersect and,
  ! consequently, buckets that won't intersect the requested type of
  ! list can be skipped.
  PUBLIC :: xt_xmdd_bucket_gen_define_interface
  INTERFACE xt_xmdd_bucket_gen_define_interface
    SUBROUTINE xt_xmdd_bucket_gen_define_interface_f(gen, init, destroy, &
         get_intersect_max_num, next, gen_state_size, init_params)
      IMPORT :: xt_xmdd_bucket_gen, xt_config, xt_idxlist, c_int, &
           c_ptr, c_size_t, xt_mpi_fint_kind, xt_com_list, &
           xt_xmdd_bucket_gen_comms
#ifdef HAVE_FC_ABSTRACT_INTERFACE
      IMPORT :: xt_xmdd_bucket_gen_init_state
#endif
      TYPE(xt_xmdd_bucket_gen), INTENT(inout) :: gen
#ifdef HAVE_FC_ABSTRACT_INTERFACE
      PROCEDURE(xt_xmdd_bucket_gen_init_state) :: init
      INTERFACE
#else
      INTERFACE
        !  The init function sets up the generator state.
        FUNCTION init(gen_state, src_idxlist, &
             dst_idxlist, config, comms, init_params) BIND(c) RESULT(stripify)
          IMPORT :: c_int, c_ptr, xt_idxlist, xt_config, &
               xt_xmdd_bucket_gen_comms
          INTEGER(c_int) :: stripify
          TYPE(c_ptr), VALUE :: gen_state
          TYPE(xt_idxlist), VALUE :: src_idxlist, dst_idxlist
          TYPE(xt_config), VALUE :: config
          TYPE(xt_xmdd_bucket_gen_comms), INTENT(in) :: comms
          TYPE(c_ptr), VALUE :: init_params
        END FUNCTION init
#endif
        !  The destroy function clean up the generator state. Can be zero
        !  if no cleaning is needed.
        SUBROUTINE destroy(gen_state) BIND(c)
          IMPORT :: c_ptr
          TYPE(c_ptr), VALUE :: gen_state
        END SUBROUTINE destroy

        FUNCTION get_intersect_max_num(gen_state, &
             bucket_type) BIND(C) RESULT(max_num)
          IMPORT :: c_ptr, c_int
          TYPE(c_ptr), VALUE :: gen_state
          INTEGER(c_int), VALUE :: bucket_type
          INTEGER(c_int) :: max_num
        END FUNCTION get_intersect_max_num

        ! The next function returns the next bucket and corresponding rank
        ! (ranks can be skipped when the intersection will be empty
        ! anyway).
        ! Any previously returned buckets become invalid.
        FUNCTION next(gen_state, bucket_type) &
             BIND(C) RESULT(bucket)
          IMPORT :: c_ptr, c_int, xt_com_list
          TYPE(c_ptr), VALUE :: gen_state
          INTEGER(c_int), VALUE :: bucket_type
          TYPE(xt_com_list) :: bucket
        END FUNCTION next
      END INTERFACE
          ! gen_state_size is the size of the generator state
      !
      ! The distributed directory will provide memory aligned to
      ! TYPE(c_ptr) variables of this size.
      INTEGER(c_size_t), INTENT(in) :: gen_state_size
      TYPE(c_ptr), INTENT(in) :: init_params
    END SUBROUTINE xt_xmdd_bucket_gen_define_interface_f
#ifdef HAVE_FC_C_FUNLOC
    SUBROUTINE xt_xmdd_bucket_gen_def_if_f2c(gen, init, destroy, &
         get_intersect_max_num, next, gen_state_size, init_params) &
         BIND(c, name='xt_xmdd_bucket_gen_def_if_f2c')
      IMPORT :: c_funptr, c_size_t, c_ptr
      IMPLICIT NONE
      TYPE(c_ptr), VALUE :: gen
      TYPE(c_funptr), VALUE :: init, destroy, get_intersect_max_num, next
      INTEGER(c_size_t), VALUE :: gen_state_size
      TYPE(c_ptr), VALUE :: init_params
    END SUBROUTINE xt_xmdd_bucket_gen_def_if_f2c
#endif
  END INTERFACE xt_xmdd_bucket_gen_define_interface
  PUBLIC :: xt_xmdd_bucket_gen_define_interface_f
  PUBLIC :: xt_xmdd_bucket_gen_def_if_f2c

  PUBLIC :: xt_xmdd_bucket_gen_get_init_params, &
       xt_xmdd_bucket_gen_set_init_params

  INTERFACE xt_xmdd_bucket_gen_set_extended_init_params
    SUBROUTINE xt_xmddbg_set_ext_init_params_f(gen, &
         init_params_size, destroy, cpy)
      IMPORT :: xt_xmdd_bucket_gen, c_ptr, c_size_t
      TYPE(xt_xmdd_bucket_gen), INTENT(inout) :: gen
      INTEGER(c_size_t), INTENT(in) :: init_params_size
      INTERFACE
        SUBROUTINE destroy(init_params, init_params_size_)
          IMPORT :: c_ptr, c_size_t
          TYPE(c_ptr), VALUE :: init_params
          INTEGER(c_size_t), VALUE :: init_params_size_
        END SUBROUTINE destroy
        SUBROUTINE cpy(dest_init_params, src_init_params, init_params_size)
          IMPORT :: c_ptr, c_size_t
          TYPE(c_ptr), VALUE :: dest_init_params, src_init_params
          INTEGER(c_size_t), VALUE :: init_params_size
        END SUBROUTINE cpy
      END INTERFACE
      OPTIONAL :: destroy, cpy
    END SUBROUTINE xt_xmddbg_set_ext_init_params_f
  END INTERFACE xt_xmdd_bucket_gen_set_extended_init_params
  PUBLIC :: xt_xmdd_bucket_gen_set_extended_init_params

  INTERFACE xt_xmdd_bucket_gen_set_init
    SUBROUTINE xt_xmdd_bucket_gen_set_init_f(gen, init)
      IMPORT :: xt_xmdd_bucket_gen, xt_xmdd_bucket_gen_comms
#ifdef HAVE_FC_ABSTRACT_INTERFACE
      IMPORT :: xt_xmdd_bucket_gen_init_state
#else
      IMPORT :: c_int, c_ptr, xt_idxlist, xt_config
#endif
      TYPE(xt_xmdd_bucket_gen), INTENT(in) :: gen
#ifdef HAVE_FC_ABSTRACT_INTERFACE
      PROCEDURE(xt_xmdd_bucket_gen_init_state) :: init
#else
      INTERFACE
        FUNCTION init(gen_state, src_idxlist, &
             dst_idxlist, config, comms, init_params) BIND(c) RESULT(stripify)
          IMPORT :: c_int, c_ptr, xt_idxlist, xt_config, &
               xt_xmdd_bucket_gen_comms
          INTEGER(c_int) :: stripify
          TYPE(c_ptr), VALUE :: gen_state
          TYPE(xt_idxlist), VALUE :: src_idxlist, dst_idxlist
          TYPE(xt_config), VALUE :: config
          TYPE(xt_xmdd_bucket_gen_comms), INTENT(in) :: comms
          TYPE(c_ptr), VALUE :: init_params
        END FUNCTION init
      END INTERFACE
#endif
    END SUBROUTINE xt_xmdd_bucket_gen_set_init_f
  END INTERFACE xt_xmdd_bucket_gen_set_init
  PUBLIC :: xt_xmdd_bucket_gen_set_init

#if defined HAVE_FC_C_FUNLOC && defined HAVE_FC_ABSTRACT_INTERFACE
  PUBLIC :: xt_xmdd_bucket_gen_get_init
#endif

CONTAINS


  FUNCTION xt_xmdd_bucket_gen_get_init_params(gen) &
       RESULT(init_params)
    TYPE(xt_xmdd_bucket_gen), INTENT(in) :: gen
    TYPE(c_ptr) :: init_params
    INTERFACE
      FUNCTION xt_xmdd_bg_get_init_params_c(gen) &
           BIND(c, name='xt_xmdd_bucket_gen_get_init_params') &
           RESULT(init_params)
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: gen
        TYPE(c_ptr) :: init_params
      END FUNCTION xt_xmdd_bg_get_init_params_c
    END INTERFACE
    init_params = xt_xmdd_bg_get_init_params_c(&
         xt_xmdd_bucket_gen_f2c(gen))
  END FUNCTION xt_xmdd_bucket_gen_get_init_params

  SUBROUTINE xt_xmdd_bucket_gen_set_init_params(gen, init_params)
    TYPE(xt_xmdd_bucket_gen), INTENT(in) :: gen
    TYPE(c_ptr), INTENT(in) :: init_params
    INTERFACE
      SUBROUTINE xt_xmdd_bg_set_init_params_c(gen, init_params_) &
           BIND(c, name='xt_xmdd_bucket_gen_set_init_params')
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: gen
        TYPE(c_ptr), VALUE, INTENT(in) :: init_params_
      END SUBROUTINE xt_xmdd_bg_set_init_params_c
    END INTERFACE
    CALL xt_xmdd_bg_set_init_params_c(xt_xmdd_bucket_gen_f2c(gen), &
         init_params)
  END SUBROUTINE xt_xmdd_bucket_gen_set_init_params

#if defined HAVE_FC_C_FUNLOC && defined HAVE_FC_ABSTRACT_INTERFACE
  FUNCTION xt_xmdd_bucket_gen_get_init(gen) RESULT(ini)
    TYPE(Xt_xmdd_bucket_gen), INTENT(in) :: gen
    PROCEDURE(xt_xmdd_bucket_gen_init_state), POINTER :: ini
    TYPE(c_funptr) :: ini_c

    INTERFACE
      FUNCTION xt_xmdd_bucket_gen_get_init_c(gen) &
           BIND(c, name='Xt_xmdd_bucket_gen_get_init_f2c') RESULT(ini_ptr)
        IMPORT :: c_funptr, c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: gen
        TYPE(c_funptr) :: ini_ptr
      END FUNCTION xt_xmdd_bucket_gen_get_init_c
    END INTERFACE

    ini_c = xt_xmdd_bucket_gen_get_init_c(xt_xmdd_bucket_gen_f2c(gen))
    CALL C_F_PROCPOINTER(ini_c, ini)
  END FUNCTION xt_xmdd_bucket_gen_get_init
#endif


END MODULE xt_xmap_dist_dir_bucket_gen2
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_sort_f.f90
!! @brief Test Fortran interface to yaxt sorting functions
!!
!! @copyright Copyright  (C)  2021 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_sort
  USE iso_c_binding, ONLY: c_int, c_double, c_int32_t
  USE mpi
  USE yaxt, ONLY: xt_initialize, xt_finalize, &
       xt_sort_index, xt_sort_int, xt_sort_permutation, &
       xi => xt_int_kind
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort, &
       random_fill, crc32, permute
  IMPLICIT NONE
  INTEGER, PARAMETER :: range_size=500000
  CHARACTER(len=*), PARAMETER :: filename = 'test_sort_f.f90'
  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  CALL test_int_sort()
  CALL test_xt_int_sort()
  CALL xt_finalize
  CALL finish_mpi
CONTAINS
  SUBROUTINE test_int_sort()
    INTEGER(c_int), ALLOCATABLE :: a(:), permutation(:)
    REAL(c_double) :: rnd
    INTEGER :: n, i
    INTEGER(c_int32_t) :: crc_before, crc_after
    LOGICAL :: err_found
    CALL RANDOM_NUMBER(rnd)
    n = NINT(rnd * range_size)
    ALLOCATE(a(n), permutation(n))
    CALL random_fill(a)
    CALL xt_sort_int(a)
    err_found = .FALSE.
    DO i = 2, n
      err_found = err_found .OR. a(i-1) > a(i)
    END DO
    IF (err_found) CALL test_abort("discontinuity found!", filename, __LINE__)
    CALL random_fill(a)
    DO i = 1, n
      permutation(i) = i
    END DO
    crc_before = crc32(a)
    CALL xt_sort_permutation(a, permutation)
    DO i = 2, n
      err_found = err_found .OR. a(i-1) > a(i)
    END DO
    IF (err_found) CALL test_abort("discontinuity found!", filename, __LINE__)
    CALL permute(a, permutation)
    crc_after = crc32(a)
    IF (crc_after /= crc_before) &
         CALL test_abort("error in data reconstruction!", filename, __LINE__)
  END SUBROUTINE test_int_sort

  SUBROUTINE test_xt_int_sort()
    INTEGER(c_int), ALLOCATABLE :: permutation(:)
    INTEGER(xi), ALLOCATABLE :: b(:)
    REAL(c_double) :: rnd
    INTEGER :: n, i
    INTEGER(c_int32_t) :: crc_before, crc_after
    LOGICAL :: err_found
    CALL RANDOM_NUMBER(rnd)
    n = NINT(rnd * range_size)
    ALLOCATE(b(n), permutation(n))
    CALL random_fill(b)
    crc_before = crc32(b)
    DO i = 1, n
      permutation(i) = i
    END DO
    CALL xt_sort_index(b, permutation, reset_positions=.FALSE.)
    err_found = .FALSE.
    DO i = 2, n
      err_found = err_found .OR. b(i-1) > b(i)
    END DO
    IF (err_found) CALL test_abort("discontinuity found!", filename, __LINE__)
    CALL permute(b, permutation)
    crc_after = crc32(b)
    IF (crc_after /= crc_before) &
         CALL test_abort("error in data reconstruction!", filename, __LINE__)
  END SUBROUTINE test_xt_int_sort

END PROGRAM test_sort
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! license-project-url: "https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/"
! license-default: "bsd"
! End:
!

!>
!! @file xt_xmap_intersection_f.f90
!! @brief Fortran interface to yaxt xmap declarations
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!

!>
!! @example test_xmap_intersection_parallel_f.f90

#include "fc_feature_defs.inc"
MODULE xt_xmap_intersection
  USE iso_c_binding, ONLY: c_int, c_loc, c_null_ptr, c_ptr
  USE xt_core, ONLY: xt_abort, xt_mpi_fint_kind
  USE xt_idxlist_abstract, ONLY: xt_idxlist, xt_idxlist_f2c
  USE xt_xmap_abstract, ONLY: xt_xmap, xt_xmap_c2f
#include "xt_slice_c_loc.inc"
  IMPLICIT NONE
  PRIVATE

  TYPE, BIND(c), PUBLIC :: xt_com_list
    TYPE(xt_idxlist) :: list
    INTEGER(c_int) :: rank
  END TYPE xt_com_list

  TYPE, PUBLIC :: xt_com_pos
    INTEGER, POINTER :: transfer_pos(:)
    INTEGER :: rank
  END TYPE xt_com_pos

  TYPE, BIND(c) :: xt_com_pos_c
    TYPE(c_ptr) :: transfer_pos
    INTEGER(c_int) :: num_transfer_pos
    INTEGER(c_int) :: rank
  END TYPE xt_com_pos_c

  PUBLIC :: xt_xmap_intersection_new, xt_xmap_intersection_ext_new, &
            xt_xmap_intersection_pos_new

  INTERFACE
    FUNCTION xmi_new_f2c(num_src_intersections, src_com, &
         num_dst_intersections, dst_com, &
         src_idxlist, dst_idxlist, comm) RESULT(xmap) &
         BIND(c, name='xt_xmap_intersection_new_f2c')
      IMPORT :: c_int, c_ptr, xt_mpi_fint_kind
      INTEGER(c_int), VALUE, INTENT(in) :: num_src_intersections, &
           num_dst_intersections
      TYPE(c_ptr), VALUE, INTENT(in) :: src_com, dst_com, src_idxlist, &
           dst_idxlist
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: comm
      TYPE(c_ptr) :: xmap
    END FUNCTION xmi_new_f2c

    FUNCTION xmi_ext_new_f2c(num_src_intersections, src_com, &
         num_dst_intersections, dst_com, &
         src_idxlist, dst_idxlist, comm) RESULT(xmap) &
         BIND(c, name='xt_xmap_intersection_ext_new_f2c')
      IMPORT :: c_int, c_ptr, xt_mpi_fint_kind
      INTEGER(c_int), VALUE, INTENT(in) :: num_src_intersections, &
           num_dst_intersections
      TYPE(c_ptr), VALUE, INTENT(in) :: src_com, dst_com, src_idxlist, &
           dst_idxlist
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: comm
      TYPE(c_ptr) :: xmap
    END FUNCTION xmi_ext_new_f2c

    FUNCTION xmi_pos_new_f2c(num_src_msg, src_com, num_dst_msg, dst_com, comm) &
         RESULT(xmap) &
         BIND(c, name='xt_xmap_intersection_pos_new_f2c')
      IMPORT :: c_int, c_ptr, xt_mpi_fint_kind, xt_com_pos_c
      INTEGER(c_int), VALUE, INTENT(in) :: num_src_msg, num_dst_msg
      TYPE(xt_com_pos_c), INTENT(in) :: src_com(*), dst_com(*)
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: comm
      TYPE(c_ptr) :: xmap
    END FUNCTION xmi_pos_new_f2c
  END INTERFACE

  INTERFACE xt_xmap_intersection_new
    MODULE PROCEDURE xmi_new_i_a_i_a
    MODULE PROCEDURE xmi_new_a_a
  END INTERFACE xt_xmap_intersection_new

  INTERFACE xt_xmap_intersection_ext_new
    MODULE PROCEDURE xmi_ext_new_i_a_i_a
    MODULE PROCEDURE xmi_ext_new_a_a
  END INTERFACE xt_xmap_intersection_ext_new

  INTERFACE xt_xmap_intersection_pos_new
    MODULE PROCEDURE xmi_pos_new_a_a
    MODULE PROCEDURE xmi_pos_new_i_a_i_a
  END INTERFACE xt_xmap_intersection_pos_new

  CHARACTER(len=*), PARAMETER :: filename = 'xt_xmap_intersection_f.f90'
CONTAINS
  FUNCTION xmi_new_i_a_i_a(num_src_intersections, src_com, &
       num_dst_intersections, dst_com, &
       src_idxlist, dst_idxlist, comm) RESULT(xmap)
    INTEGER(c_int), VALUE, INTENT(in) :: num_src_intersections, &
         num_dst_intersections
    TYPE(xt_com_list), TARGET, INTENT(in) :: src_com(num_src_intersections), &
         dst_com(num_dst_intersections)
    TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_xmap) :: xmap
    TYPE(c_ptr) :: src_com_p, dst_com_p

    IF (num_src_intersections > 0) THEN
      src_com_p = C_LOC(src_com)
    ELSE
      src_com_p = c_null_ptr
    END IF
    IF (num_dst_intersections > 0) THEN
      dst_com_p = C_LOC(dst_com)
    ELSE
      dst_com_p = c_null_ptr
    END IF
    xmap = xt_xmap_c2f(xmi_new_f2c(&
         num_src_intersections, src_com_p, &
         num_dst_intersections, dst_com_p, &
         xt_idxlist_f2c(src_idxlist), xt_idxlist_f2c(dst_idxlist), comm))
  END FUNCTION xmi_new_i_a_i_a

  FUNCTION xmi_new_a_a(src_com, dst_com, src_idxlist, dst_idxlist, comm) &
       RESULT(xmap)
    TYPE(xt_com_list), TARGET, INTENT(in) :: src_com(:), dst_com(:)
    TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_xmap) :: xmap

    TYPE(xt_com_list), ALLOCATABLE, TARGET :: src_com_a(:), dst_com_a(:)
    TYPE(c_ptr) :: src_com_p, dst_com_p
    INTEGER(c_int) :: num_src_intersections_c, num_dst_intersections_c
    num_src_intersections_c = INT(SIZE(src_com), c_int)
    num_dst_intersections_c = INT(SIZE(dst_com), c_int)
    CALL com_p_arg(src_com, src_com_a, src_com_p)
    CALL com_p_arg(dst_com, dst_com_a, dst_com_p)

    xmap = xt_xmap_c2f(xmi_new_f2c(num_src_intersections_c, src_com_p, &
         num_dst_intersections_c, dst_com_p, &
         xt_idxlist_f2c(src_idxlist), xt_idxlist_f2c(dst_idxlist), comm))
  END FUNCTION xmi_new_a_a

  FUNCTION xmi_ext_new_i_a_i_a(num_src_intersections, src_com, &
       num_dst_intersections, dst_com, &
       src_idxlist, dst_idxlist, comm) RESULT(xmap)
    INTEGER(c_int), VALUE, INTENT(in) :: num_src_intersections, &
         num_dst_intersections
    TYPE(xt_com_list), TARGET, INTENT(in) :: src_com(num_src_intersections), &
         dst_com(num_dst_intersections)
    TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_xmap) :: xmap
    INTEGER(c_int) :: num_src_intersections_c, num_dst_intersections_c
    num_src_intersections_c = INT(num_src_intersections, c_int)
    num_dst_intersections_c = INT(num_dst_intersections, c_int)

    xmap = xt_xmap_c2f(xmi_ext_new_f2c(&
         num_src_intersections_c, C_LOC(src_com), &
         num_dst_intersections_c, C_LOC(dst_com), &
         xt_idxlist_f2c(src_idxlist), xt_idxlist_f2c(dst_idxlist), comm))
  END FUNCTION xmi_ext_new_i_a_i_a

  FUNCTION xmi_ext_new_a_a(src_com, dst_com, src_idxlist, dst_idxlist, comm) &
       RESULT(xmap)
    TYPE(xt_com_list), TARGET, INTENT(in) :: src_com(:), dst_com(:)
    TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_xmap) :: xmap

    TYPE(xt_com_list), ALLOCATABLE, TARGET :: src_com_a(:), dst_com_a(:)
    TYPE(c_ptr) :: src_com_p, dst_com_p
    INTEGER(c_int) :: num_src_intersections_c, num_dst_intersections_c
    num_src_intersections_c = INT(SIZE(src_com), c_int)
    num_dst_intersections_c = INT(SIZE(dst_com), c_int)

    CALL com_p_arg(src_com, src_com_a, src_com_p)
    CALL com_p_arg(dst_com, dst_com_a, dst_com_p)

    xmap = xt_xmap_c2f(xmi_ext_new_f2c(&
         num_src_intersections_c, src_com_p, &
         num_dst_intersections_c, dst_com_p, &
         xt_idxlist_f2c(src_idxlist), xt_idxlist_f2c(dst_idxlist), comm))
  END FUNCTION xmi_ext_new_a_a

  FUNCTION xmi_pos_new_i_a_i_a( &
      num_src_msg, src_com, num_dst_msg, dst_com, comm) RESULT(xmap)
    TYPE(xt_com_pos), TARGET, INTENT(in) :: src_com(:), dst_com(:)
    INTEGER, INTENT(in) :: num_src_msg, num_dst_msg
    INTEGER, INTENT(in) :: comm
    TYPE(xt_xmap) :: xmap

    INTEGER(c_int) :: num_src_msg_c, num_dst_msg_c
    TYPE(xt_com_pos_c), ALLOCATABLE :: src_com_c(:), dst_com_c(:)
    INTEGER(c_int), TARGET, ALLOCATABLE :: pos_buffer(:)
    INTEGER :: pos_buffer_offset, size_pos_buf

    size_pos_buf = num_pos_copy(num_src_msg, src_com) + &
                    num_pos_copy(num_dst_msg, dst_com)
    ALLOCATE(pos_buffer(size_pos_buf))

    num_src_msg_c = INT(num_src_msg, c_int)
    num_dst_msg_c = INT(num_dst_msg, c_int)

    pos_buffer_offset = 0
    CALL generate_xt_com_pos_c(num_src_msg, src_com, src_com_c, &
         size_pos_buf, pos_buffer, pos_buffer_offset)
    CALL generate_xt_com_pos_c(num_dst_msg, dst_com, dst_com_c, &
         size_pos_buf, pos_buffer, pos_buffer_offset)

    xmap = &
      xt_xmap_c2f(xmi_pos_new_f2c(&
        num_src_msg_c, src_com_c, num_dst_msg_c, dst_com_c, comm))

  END FUNCTION xmi_pos_new_i_a_i_a

  PURE FUNCTION num_pos_copy(num_msg, com_pos) RESULT(total_num_pos)
    INTEGER, INTENT(in) :: num_msg
    TYPE(xt_com_pos), INTENT(in) :: com_pos(:)
    INTEGER :: i
    INTEGER :: total_num_pos
#if defined __PGI && __PGIC__  > 15 && __PGIC__ <= 20
    INTEGER, POINTER :: pos(:)
#endif
    total_num_pos = 0
#ifdef HAVE_FC_IS_CONTIGUOUS
    IF (KIND(com_pos(i)%transfer_pos) == c_int) THEN
      DO i = 1, num_msg
#if defined __PGI && __PGIC__  > 15 && __PGIC__ <= 20
        pos => com_pos(i)%transfer_pos
        IF (.NOT. IS_CONTIGUOUS(pos)) THEN
#else
        IF (.NOT. IS_CONTIGUOUS(com_pos(i)%transfer_pos)) THEN
#endif
          total_num_pos = total_num_pos &
               + SIZE(com_pos(i)%transfer_pos)
        END IF
      END DO
    ELSE
#endif
      DO i = 1, num_msg
        total_num_pos = total_num_pos + SIZE(com_pos(i)%transfer_pos)
      END DO
#ifdef HAVE_FC_IS_CONTIGUOUS
    ENDIF
#endif
  END FUNCTION num_pos_copy

  SUBROUTINE generate_xt_com_pos_c(num_msg, com_pos, com_pos_c, &
       size_pos_buf, pos_buffer, &
       pos_buffer_offset)
    INTEGER, INTENT(in) :: num_msg
    TYPE(xt_com_pos), TARGET, INTENT(in) :: com_pos(:)
    TYPE(xt_com_pos_c), ALLOCATABLE, INTENT(out) :: com_pos_c(:)
    INTEGER, INTENT(in) :: size_pos_buf
    INTEGER(c_int), TARGET, INTENT(inout) :: pos_buffer(size_pos_buf)
    INTEGER, INTENT(inout) :: pos_buffer_offset
    INTEGER :: i, j, num_pos
#if defined __PGI && __PGIC__  > 15 && __PGIC__ <= 20
    INTEGER, POINTER :: pos(:)
#endif
    ALLOCATE(com_pos_c(num_msg))

    DO i = 1, num_msg
      num_pos = SIZE(com_pos(i)%transfer_pos)
#ifdef HAVE_FC_IS_CONTIGUOUS
#  if defined __PGI && __PGIC__ > 15 && __PGIC__ <= 20
      pos => com_pos(i)%transfer_pos
      IF (KIND(1) == c_int .AND. IS_CONTIGUOUS(pos)) THEN
#  else
      IF (KIND(1) == c_int .AND. IS_CONTIGUOUS(com_pos(i)%transfer_pos)) THEN
#  endif
        com_pos_c(i)%transfer_pos = C_LOC(com_pos(i)%transfer_pos(1))
      ELSE
#endif
        DO j = 1, num_pos
          pos_buffer(pos_buffer_offset + j) = &
                 INT(com_pos(i)%transfer_pos(j), c_int)
        END DO
        com_pos_c(i)%transfer_pos = C_LOC(pos_buffer(pos_buffer_offset+1))
        pos_buffer_offset = pos_buffer_offset + num_pos
#ifdef HAVE_FC_IS_CONTIGUOUS
      END IF
#endif
      com_pos_c(i)%num_transfer_pos = INT(num_pos, c_int)
      com_pos_c(i)%rank = INT(com_pos(i)%rank, c_int)
    END DO

  END SUBROUTINE generate_xt_com_pos_c

  FUNCTION xmi_pos_new_a_a(src_com, dst_com, comm) RESULT(xmap)
    TYPE(xt_com_pos), INTENT(in) :: src_com(:), dst_com(:)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_xmap) :: xmap

    xmap = &
      xmi_pos_new_i_a_i_a(SIZE(src_com), src_com, SIZE(dst_com), dst_com, comm)
  END FUNCTION xmi_pos_new_a_a

  SUBROUTINE com_p_arg(com, com_a, com_p)
    TYPE(xt_com_list), TARGET, INTENT(in) :: com(:)
    TYPE(xt_com_list), TARGET, ALLOCATABLE, INTENT(inout) :: com_a(:)
    TYPE(c_ptr), INTENT(out) :: com_p

    INTEGER :: com_size
    LOGICAL :: com_is_contiguous
#ifndef HAVE_FC_IS_CONTIGUOUS
    INTERFACE
      FUNCTION xt_com_list_contiguous(com_a, com_b) RESULT(p) &
            BIND(c, name='xt_com_list_contiguous')
        IMPORT :: c_int, xt_com_list
        TYPE(xt_com_list), INTENT(in) :: com_a, com_b
        INTEGER(c_int) :: p
      END FUNCTION xt_com_list_contiguous
    END INTERFACE
#endif

    com_size = SIZE(com)
    IF (com_size > HUGE(1_c_int)) &
         CALL xt_abort('invalid size', filename, __LINE__)
    IF (com_size > 0) THEN
      IF (com_size > 1) THEN
#ifdef HAVE_FC_IS_CONTIGUOUS
        com_is_contiguous = IS_CONTIGUOUS(com)
#else
        com_is_contiguous = xt_com_list_contiguous(com(1), com(2)) /= 0
#endif
        IF (com_is_contiguous) THEN
          XT_SLICE_C_LOC(com(1), com_p)
        ELSE
          ALLOCATE(com_a(com_size))
          com_a = com
          com_p = C_LOC(com_a)
        END IF
      ELSE
        XT_SLICE_C_LOC(com(1), com_p)
      END IF
    ELSE
      com_p = c_null_ptr
    END IF
  END SUBROUTINE com_p_arg

END MODULE xt_xmap_intersection
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_perf.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_perf
  USE mpi
  USE yaxt, ONLY: xt_finalize, xt_idxlist, xt_idxvec_new, xt_xmap, &
       xt_xmap_all2all_new, xt_redist, xt_redist_p2p_new, &
       xt_redist_p2p_off_new, xt_redist_s_exchange, xt_idxlist_delete, &
       xt_xmap_delete, xt_redist_delete, xt_int_kind, xt_initialize, &
       xi => xt_int_kind
  USE ftest_common, ONLY: finish_mpi, init_mpi, treset, tstart, tstop, &
       treport, timer, id_map, factorize, regular_deco, set_verbose, icmp, &
       test_abort
  USE test_redist_common, only: xt_redist_s_exchange
  USE yaxt, ONLY: xt_finalize
#ifdef __PGI
  ! PGI up to at least 15.4 has a bug that prevents proper import of
  ! multiply extended generics. This is a separate bug from the one exhibited
  ! in 12.7 and older (see test_xmap_intersection_parallel_f.f90 for that)
  USE xt_redist_int_i2, ONLY: xt_redist_s_exchange
  USE xt_redist_int_i4, ONLY: xt_redist_s_exchange
  USE xt_redist_int_i8, ONLY: xt_redist_s_exchange
#endif
  IMPLICIT NONE
  ! global extents including halos:

  INTEGER, PARAMETER :: nlev = 30
  INTEGER, PARAMETER :: undef_int = (HUGE(undef_int)-1)/2 - 1
  INTEGER(xt_int_kind), PARAMETER :: undef_index = -1_xi
  INTEGER, PARAMETER :: nhalo = 1 ! 1dim. halo border size

  CHARACTER(len=8) :: grid_label
  INTEGER :: g_ie, g_je ! global domain extents
  INTEGER :: ie, je, ke ! local extents, including halos
  INTEGER :: p_ioff, p_joff ! offsets within global domain
  INTEGER :: nprocx, nprocy ! process space extents
  INTEGER :: nprocs ! == nprocx*nprocy
  ! process rank, process coords within (0:, 0:) process space
  INTEGER :: mype, mypx, mypy
  LOGICAL :: lroot ! true only for proc 0
  CHARACTER(len=*), PARAMETER :: filename = 'test_perf.f90'

  INTEGER(xt_int_kind), ALLOCATABLE :: g_id(:,:) ! global id
  ! global "tripolar-like" toy bounds exchange
  INTEGER(xt_int_kind), ALLOCATABLE :: g_tpex(:, :)

  INTEGER(xt_int_kind), ALLOCATABLE :: loc_id_2d(:,:), loc_tpex_2d(:,:)
  INTEGER(xt_int_kind), ALLOCATABLE :: loc_id_3d(:,:,:), loc_tpex_3d(:,:,:)
  INTEGER, ALLOCATABLE :: fval_2d(:,:), gval_2d(:,:)
  INTEGER, ALLOCATABLE :: fval_3d(:,:,:), gval_3d(:,:,:)
  INTEGER, ALLOCATABLE :: id_pos(:,:), pos3d_surf(:,:)
  INTEGER, ALLOCATABLE :: ref_m1(:,:)
  LOGICAL :: verbose

  TYPE(timer) :: t_all, t_surf_redist, t_exch_surf
  TYPE(timer) :: t_idxlist_2d, t_xmap_2d, t_redist_2d, t_exch_2d
  TYPE(timer) :: t_idxlist_3d, t_xmap_3d, t_redist_3d, t_exch_3d

  ! yaxt data:
  TYPE(xt_idxlist) :: id_2d_idxlist, tpex_2d_idxlist
  TYPE(xt_idxlist) :: id_3d_idxlist, tpex_3d_idxlist
  TYPE(xt_xmap) :: tpex_2d_xmap, tpex_3d_xmap
  TYPE(xt_redist) :: tpex_2d_redist, surf_tpex_redist
  TYPE(xt_redist) :: tpex_3d_redist

  CALL treset(t_all, 'all')
  CALL treset(t_surf_redist, 'surf_redist')
  CALL treset(t_exch_surf, 'exch_surf')
  CALL treset(t_idxlist_2d, 'idxlist_2d')
  CALL treset(t_xmap_2d, 'xmap_2d')
  CALL treset(t_redist_2d, 'redist_2d')
  CALL treset(t_exch_2d, 'exch_2d')
  CALL treset(t_idxlist_3d, 'idxlist_3d')
  CALL treset(t_xmap_3d, 'xmap_3d')
  CALL treset(t_redist_3d, 'redist_3d')
  CALL treset(t_exch_3d, 'exch_3d')

  CALL init_mpi

  CALL tstart(t_all)

  ! mpi & decomposition & allocate mem:
  CALL init_all

  ! full global index space:
  CALL id_map(g_id)

  ! local window of global index space:
  CALL get_window(g_id, loc_id_2d)


  ! define bounds exchange for full global index space
  CALL def_exchange(g_id, g_tpex)
  DEALLOCATE(g_id)
  ! local window of global bounds exchange:
  CALL get_window(g_tpex, loc_tpex_2d)
  DEALLOCATE(g_tpex)

  ! gen xmap: loc_id_2d -> loc_tpex_2d
  CALL tstart(t_idxlist_2d)
  id_2d_idxlist = xt_idxvec_new(loc_id_2d)
  tpex_2d_idxlist = xt_idxvec_new(loc_tpex_2d)
  CALL tstop(t_idxlist_2d)
  CALL tstart(t_xmap_2d)
  tpex_2d_xmap = xt_xmap_all2all_new(id_2d_idxlist, tpex_2d_idxlist, MPI_COMM_WORLD)
  CALL tstop(t_xmap_2d)

  ! gen redist: loc_id_2d:data -> loc_tpex_2d:data
  CALL tstart(t_redist_2d)
  tpex_2d_redist = xt_redist_p2p_new(tpex_2d_xmap,  MPI_INTEGER)
  CALL tstop(t_redist_2d)

  ! test 2d-to-2d redist
  CALL copy_xi(loc_id_2d, fval_2d)
  CALL tstart(t_exch_2d)
  CALL xt_redist_s_exchange(tpex_2d_redist, fval_2d, gval_2d)
  CALL tstop(t_exch_2d)
  CALL icmp('2d to 2d check', gval_2d, loc_tpex_2d, mype)

  ! define positions of surface elements within (i,k,j) array
  CALL id_map(id_pos, 0)
  CALL id_map(pos3d_surf, 0)
  CALL gen_pos3d_surf(pos3d_surf)

  ! gen surface redist:
  CALL tstart(t_surf_redist)
  surf_tpex_redist = xt_redist_p2p_off_new(tpex_2d_xmap, id_pos, pos3d_surf, MPI_INTEGER)
  CALL tstop(t_surf_redist)
  DEALLOCATE(id_pos, pos3d_surf)

  ! 2d to surface boundsexchange:
  ALLOCATE(gval_3d(ie,nlev,je))
  gval_3d = -1
  CALL tstart(t_exch_surf)
  CALL xt_redist_s_exchange(surf_tpex_redist, fval_2d, gval_3d)
  CALL tstop(t_exch_surf)

  CALL icmp('surface check', gval_3d(:,1,:), loc_tpex_2d, mype)

  ! check sub surface:
  ALLOCATE(ref_m1(SIZE(loc_tpex_2d, 1), SIZE(loc_tpex_2d, 2)))
  ref_m1 = -1
  CALL icmp('sub surface check', gval_3d(:,2,:), ref_m1, mype)

  DEALLOCATE(ref_m1)
  ! cleanup 2d:
  CALL xt_idxlist_delete(id_2d_idxlist)
  CALL xt_idxlist_delete(tpex_2d_idxlist)
  CALL xt_xmap_delete(tpex_2d_xmap)
  CALL xt_redist_delete(surf_tpex_redist)
  CALL xt_redist_delete(tpex_2d_redist)

  ! inflate 2d -> 3d
  CALL inflate_idx(3, loc_id_2d, loc_id_3d)
  DEALLOCATE(loc_id_2d)
  CALL inflate_idx(3, loc_tpex_2d, loc_tpex_3d)
  DEALLOCATE(loc_tpex_2d)

  ! gen xmap: loc_id_3d -> loc_tpex_3d
  CALL tstart(t_idxlist_3d)
  id_3d_idxlist = xt_idxvec_new(loc_id_3d)
  tpex_3d_idxlist = xt_idxvec_new(loc_tpex_3d)
  CALL tstop(t_idxlist_3d)
  CALL tstart(t_xmap_3d)
  tpex_3d_xmap = xt_xmap_all2all_new(id_3d_idxlist, tpex_3d_idxlist, MPI_COMM_WORLD)
  CALL tstop(t_xmap_3d)

  ! gen redist: loc_id_3d:data -> loc_tpex_3d:data
  CALL tstart(t_redist_3d)
  tpex_3d_redist = xt_redist_p2p_new(tpex_3d_xmap,  MPI_INTEGER)
  CALL tstop(t_redist_3d)

  ! test 3d-to-3d redist:
  DEALLOCATE(gval_3d)
  ALLOCATE(fval_3d(ie,je,nlev), gval_3d(ie,je,nlev))
  CALL copy_xi_3d(loc_id_3d, fval_3d)
  CALL tstart(t_exch_3d)
  CALL xt_redist_s_exchange(tpex_3d_redist, fval_3d, gval_3d)
  CALL tstop(t_exch_3d)
  DEALLOCATE(fval_3d)
  CALL icmp('3d to 3d check', gval_3d, loc_tpex_3d, mype)
  DEALLOCATE(gval_3d)

  ! cleanup 3d:
  CALL xt_idxlist_delete(id_3d_idxlist)
  CALL xt_idxlist_delete(tpex_3d_idxlist)
  CALL xt_xmap_delete(tpex_3d_xmap)
  CALL xt_redist_delete(tpex_3d_redist)

  CALL tstop(t_all)

  IF (verbose) WRITE(0,*) 'timer report for nprocs=',nprocs

  CALL tvec_report((/t_all, t_surf_redist, t_exch_surf, t_idxlist_2d, t_xmap_2d, &
       t_redist_2d, t_exch_2d, t_idxlist_3d, t_xmap_3d,t_redist_3d, t_exch_3d/), &
       TRIM(grid_label), mpi_comm_world)

  DEALLOCATE(loc_tpex_3d, loc_id_3d, fval_2d, gval_2d)

  ! finalize:
  CALL xt_finalize
  CALL finish_mpi

CONTAINS

  SUBROUTINE copy_xi(s, d)
    INTEGER(xt_int_kind), INTENT(in) :: s(:,:)
    INTEGER, INTENT(out) :: d(:,:)
    INTEGER :: i, j, m, n
    m = SIZE(s, 1)
    n = SIZE(s, 2)
    DO j = 1, n
      DO i = 1, m
        d(i, j) = INT(s(i, j))
      END DO
    END DO
  END SUBROUTINE copy_xi

  SUBROUTINE copy_xi_3d(s, d)
    INTEGER(xt_int_kind), INTENT(in) :: s(:,:,:)
    INTEGER, INTENT(out) :: d(:,:,:)
    INTEGER :: i, j, k, m, n, o
    m = SIZE(s, 1)
    n = SIZE(s, 2)
    o = SIZE(s, 3)
    DO k = 1, o
      DO j = 1, n
        DO i = 1, m
          d(i, j, k) = INT(s(i, j, k))
        END DO
      END DO
    END DO
  END SUBROUTINE copy_xi_3d

  SUBROUTINE tvec_report(tvec, extra_label, comm)
    TYPE(timer), INTENT(in) :: tvec(:)
    CHARACTER(len=*), INTENT(in) :: extra_label
    INTEGER, INTENT(in) :: comm
    INTEGER :: it
    DO it = 1, SIZE(tvec)
      CALL treport(tvec(it), extra_label, comm)
    ENDDO
  END SUBROUTINE tvec_report

  SUBROUTINE inflate_idx(inflate_pos, idx_2d, idx_3d)
    CHARACTER(len=*), PARAMETER :: context = 'test_perf::inflate_idx: '
    INTEGER, INTENT(in) :: inflate_pos
    INTEGER(xt_int_kind), INTENT(in) :: idx_2d(:,:)
    INTEGER(xt_int_kind), ALLOCATABLE, INTENT(out) :: idx_3d(:,:,:)

    INTEGER :: i, j, k

    IF (inflate_pos == 3) THEN
      ALLOCATE(idx_3d(ie, je, ke))
      DO k=1,ke
        DO j=1,je
          DO i=1,ie
            idx_3d(i,j,k) = idx_2d(i,j) + INT(k-1,xi) * INT(g_ie, xi)&
                 & * INT(g_je, xi)
          ENDDO
        ENDDO
      ENDDO
    ELSE
      CALL test_abort(context//' unsupported inflate position', &
           filename, __LINE__)
    ENDIF

  END SUBROUTINE inflate_idx

  SUBROUTINE gen_pos3d_surf(pos)
    INTEGER, INTENT(inout) :: pos(:,:)
    ! positions for zero based arrays (ECHAM grid point dim order)
    ! old pos = i + j*ie
    ! new pos = i + k*ie + j*ie*nlev
    INTEGER :: ii,jj, i,j,k, p

    k = 0 ! surface
    DO jj=1,je
      DO ii=1,ie
        p = pos(ii,jj)
        j = p/ie
        i = MOD(p,ie)
        pos(ii,jj) = i + k*ie + j*ie*nlev
      ENDDO
    ENDDO

  END SUBROUTINE gen_pos3d_surf

  SUBROUTINE init_all
    CHARACTER(len=*), PARAMETER :: context = 'init_all: '
    INTEGER :: ierror
    CHARACTER(len=20) :: grid_str

    CALL get_environment_variable('YAXT_TEST_PERF_GRID', grid_str)

    verbose = .TRUE.

    SELECT CASE (ADJUSTL(grid_str))
    CASE('TOY')
      grid_label = 'TOY'
      g_ie = 66
      g_je = 36
    CASE('TP10')
      grid_label = 'TP10'
      g_ie = 362
      g_je = 192
    CASE('TP04')
      grid_label = 'TP04'
      g_ie = 802
      g_je = 404
    CASE('TP6M')
      grid_label = 'TP6M'
      g_ie = 3602
      g_je = 2394
    CASE default
      grid_label = 'TEST'
      g_ie = 32
      g_je = 12
      verbose = .FALSE.
    END SELECT

    CALL MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierror)
    IF (ierror /= MPI_SUCCESS) CALL test_abort(context//'MPI_COMM_SIZE failed', &
         filename, __LINE__)

    CALL MPI_COMM_RANK(MPI_COMM_WORLD, mype, ierror)
    IF (ierror /= MPI_SUCCESS) CALL test_abort(context//'MPI_COMM_RANK failed', &
         filename, __LINE__)
    IF (mype==0) THEN
      lroot = .true.
    ELSE
      lroot = .FALSE.
      verbose = .FALSE.
    ENDIF
    CALL set_verbose(verbose)
    CALL factorize(nprocs, nprocx, nprocy)
    IF (verbose) WRITE(0,*) 'nprocx, nprocy=',nprocx, nprocy
    IF (verbose) WRITE(0,*) 'g_ie, g_je=',g_ie, g_je
    mypy = mype / nprocx
    mypx = MOD(mype, nprocx)

    CALL deco
    ke = nlev

    ALLOCATE(g_id(g_ie, g_je), g_tpex(g_ie, g_je))

    ALLOCATE(fval_2d(ie,je), gval_2d(ie,je))
    ALLOCATE(loc_id_2d(ie,je), loc_tpex_2d(ie,je))
    ALLOCATE(id_pos(ie,je), pos3d_surf(ie,je))

    fval_2d = undef_int
    gval_2d = undef_int
    loc_id_2d = undef_index
    loc_tpex_2d = undef_index
    id_pos = undef_int
    pos3d_surf = undef_int

    CALL xt_initialize(MPI_COMM_WORLD)

  END SUBROUTINE init_all

  SUBROUTINE get_window(gval, win)
    INTEGER(xt_int_kind), INTENT(in) :: gval(:,:)
    INTEGER(xt_int_kind), INTENT(out) :: win(:,:)
    INTEGER :: i, j, ig, jg
    DO j = 1, je
      jg = p_joff + j
      DO i = 1, ie
        ig = p_ioff + i
        win(i,j) =  gval(ig,jg)
      ENDDO
    ENDDO
  END SUBROUTINE get_window

  SUBROUTINE def_exchange(g_id, g_tpex)
    INTEGER(xt_int_kind), INTENT(in) :: g_id(:, :)
    INTEGER(xt_int_kind), INTENT(out) :: g_tpex(:, :)
    LOGICAL, PARAMETER :: increased_north_halo = .FALSE.
    LOGICAL, PARAMETER :: with_north_halo = .true.
    INTEGER :: i, j
    INTEGER :: g_core_is, g_core_ie, g_core_js, g_core_je
    INTEGER :: north_halo

    ! global core domain:
    g_core_is = nhalo + 1
    g_core_ie = g_ie-nhalo
    g_core_js = nhalo + 1
    g_core_je = g_je-nhalo

    ! global tripolar boundsexchange:
    g_tpex = undef_index
    g_tpex(g_core_is:g_core_ie, g_core_js:g_core_je) &
         = g_id(g_core_is:g_core_ie, g_core_js:g_core_je)

    IF (with_north_halo) THEN

      ! north inversion, (maybe with increased north halo)
      IF (increased_north_halo) THEN
        north_halo = nhalo+1
      ELSE
        north_halo = nhalo
      ENDIF

      IF (2*north_halo > g_core_je) &
           CALL test_abort('def_exchange: grid too small (or halo too large) &
           &for tripolar north exchange', &
           filename, __LINE__)
      DO j = 1, north_halo
        DO i = g_core_is, g_core_ie
          g_tpex(i,j) = g_tpex(g_core_ie + (g_core_is-i), 2*north_halo + (1-j))
        ENDDO
      ENDDO

    ELSE

      DO j = 1, nhalo
        DO i = nhalo+1, g_ie-nhalo
          g_tpex(i,j) = g_id(i,j)
        ENDDO
      ENDDO

    ENDIF

    ! south: no change
    DO j = g_core_je+1, g_je
      DO i = nhalo+1, g_ie-nhalo
        g_tpex(i,j) = g_id(i,j)
      ENDDO
    ENDDO

    ! PBC
    DO j = 1, g_je
      DO i = 1, nhalo
        g_tpex(g_core_is-i,j) = g_tpex(g_core_ie+(1-i),j)
      ENDDO
      DO i = 1, nhalo
        g_tpex(g_core_ie+i,j) = g_tpex(nhalo+i,j)
      ENDDO
    ENDDO

    CALL check_g_idx (g_tpex)

  END SUBROUTINE def_exchange

  SUBROUTINE check_g_idx(gidx)
    INTEGER(xt_int_kind),INTENT(in) :: gidx(:,:)

    IF (ANY(gidx == undef_index)) THEN
      CALL test_abort('check_g_idx: check failed', filename, __LINE__)
    ENDIF
  END SUBROUTINE check_g_idx

  SUBROUTINE deco
    INTEGER :: cx0(0:nprocx-1), cxn(0:nprocx-1)
    INTEGER :: cy0(0:nprocy-1), cyn(0:nprocy-1)

    cx0 = 0
    cxn = 0
    CALL regular_deco(g_ie-2*nhalo, cx0, cxn)

    cy0 = 0
    cyn = 0
    CALL regular_deco(g_je-2*nhalo, cy0, cyn)

    ! process local deco variables:
    ie = cxn(mypx) + 2*nhalo
    je = cyn(mypy) + 2*nhalo
    p_ioff = cx0(mypx)
    p_joff = cy0(mypy)

  END SUBROUTINE deco

END PROGRAM test_perf
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_perf_stripes.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_perf_stripes
  USE mpi
  USE yaxt, ONLY: xt_idxlist, xt_idxlist_delete, xt_idxvec_new, &
       xt_xmap, xt_xmap_all2all_new, xt_xmap_delete, xt_redist, &
       xt_redist_p2p_new, xt_redist_delete, xt_redist_p2p_off_new, &
       xt_redist_p2p_blocks_off_new, xt_redist_s_exchange, &
       xt_stripe, xt_idxstripes_new, xt_int_kind, xt_initialize, xt_finalize

  USE ftest_common, ONLY: finish_mpi, init_mpi, timer, treset, tstart, &
       tstop, treport, id_map, test_abort, factorize, regular_deco, &
       cmp_arrays

  ! PGI compilers up to at least version 15 do not handle generic
  ! interfaces correctly
#if defined __PGI
  USE xt_redist_int_i2, ONLY: xt_redist_s_exchange
  USE xt_redist_int_i4, ONLY: xt_redist_s_exchange
  USE xt_redist_int_i8, ONLY: xt_redist_s_exchange
#endif
  IMPLICIT NONE
  ! global extents including halos:

  INTEGER, PARAMETER :: nlev = 20
  INTEGER, PARAMETER :: undef_int = - 1
  INTEGER(xt_int_kind), PARAMETER :: undef_index = -1
  INTEGER, PARAMETER :: nhalo = 1 ! 1dim. halo border size

  INTEGER, PARAMETER :: grid_kind_test = 1
  INTEGER, PARAMETER :: grid_kind_toy  = 2
  INTEGER, PARAMETER :: grid_kind_tp10 = 3
  INTEGER, PARAMETER :: grid_kind_tp04 = 4
  INTEGER, PARAMETER :: grid_kind_tp6M = 5
  INTEGER :: grid_kind = grid_kind_test

  CHARACTER(len=10) :: grid_label
  INTEGER :: g_ie, g_je ! global domain extents
  INTEGER :: ie, je, ke ! local extents, including halos
  INTEGER :: p_ioff, p_joff ! offsets within global domain
  INTEGER :: nprocx, nprocy ! process space extents
  INTEGER :: nprocs ! == nprocx*nprocy
  ! process rank, process coords within (0:, 0:) process space
  INTEGER :: mype, mypx, mypy
  LOGICAL :: lroot ! true only for proc 0

  INTEGER, ALLOCATABLE :: g_id(:,:) ! global id
  ! global "tripolar-like" toy bounds exchange
  INTEGER, ALLOCATABLE :: g_tpex(:, :)
  TYPE(xt_xmap) :: xmap_tpex_2d, xmap_tpex_3d, xmap_tpex_3d_ws
  TYPE(xt_redist) :: redist_tpex_2d, redist_surf_tpex_2d, redist_tpex_3d, &
       redist_tpex_3d_ws, redist_tpex_3d_wb
  TYPE(Xt_idxlist) :: loc_id_3d_ws, loc_tpex_3d_ws

  INTEGER(xt_int_kind), ALLOCATABLE :: loc_id_2d(:,:), loc_tpex_2d(:,:)
  INTEGER(xt_int_kind), ALLOCATABLE :: loc_id_3d(:,:,:), loc_tpex_3d(:,:,:)
  INTEGER, ALLOCATABLE :: fval_2d(:,:), gval_2d(:,:)
  INTEGER, ALLOCATABLE :: fval_3d(:,:,:), gval_3d(:,:,:)
  INTEGER, ALLOCATABLE :: id_pos(:,:), pos3d_surf(:,:)
  LOGICAL, PARAMETER :: full_test = .TRUE.
  LOGICAL :: verbose
  CHARACTER(len=*), PARAMETER :: filename = 'test_perf_stripes.f90'

  TYPE(timer) :: t_all, t_surf_redist, t_exch_surf
  TYPE(timer) :: t_xmap_2d, t_redist_2d, t_exch_2d
  TYPE(timer) :: t_xmap_3d, t_redist_3d, t_exch_3d
  TYPE(timer) :: t_xmap_3d_ws, t_redist_3d_ws, t_exch_3d_ws, t_exch_3d_wb
  TYPE(timer) :: t_redist_3d_wb

  !WRITE(0,*) '(debug) test_perf_stripes: verbose=', verbose

  CALL treset(t_all, 'all')
  CALL treset(t_surf_redist, 'surf_redist')
  CALL treset(t_exch_surf, 'exch_surf')
  CALL treset(t_xmap_2d, 'xmap_2d')
  CALL treset(t_redist_2d, 'redist_2d')
  CALL treset(t_exch_2d, 'exch_2d')
  CALL treset(t_xmap_3d, 'xmap_3d')
  CALL treset(t_redist_3d, 'redist_3d')
  CALL treset(t_exch_3d, 'exch_3d')

  CALL treset(t_xmap_3d_ws, 'xmap_3d_ws')
  CALL treset(t_redist_3d_ws, 'redist_3d_ws')
  CALL treset(t_exch_3d_ws, 'exch_3d_ws')

  CALL treset(t_redist_3d_wb, 'redist_3d_wb')
  CALL treset(t_exch_3d_wb, 'exch_3d_wb')

  CALL init_mpi

  CALL tstart(t_all)

  ! mpi & decomposition & allocate mem:
  CALL init_all

  ALLOCATE(fval_3d(nlev,ie,je), gval_3d(nlev,ie,je))

  ! full global index space:
  CALL id_map(g_id)

  ! local window of global index space:
  CALL get_window(g_id, loc_id_2d)

  ! define bounds exchange for full global index space
  CALL def_exchange(g_id, g_tpex)
  !g_tpex = g_id
  DEALLOCATE(g_id)
  ! local window of global bounds exchange:
  CALL get_window(g_tpex, loc_tpex_2d)
  DEALLOCATE(g_tpex)

  IF (full_test) THEN
  ! xmap: loc_id_2d -> loc_tpex_2d
  CALL tstart(t_xmap_2d)
  CALL gen_xmap_2d(loc_id_2d, loc_tpex_2d, xmap_tpex_2d)
  CALL tstop(t_xmap_2d)

  ! transposition: loc_id_2d:data -> loc_tpex_2d:data
  CALL tstart(t_redist_2d)
  CALL gen_redist(xmap_tpex_2d, MPI_INTEGER, MPI_INTEGER, redist_tpex_2d)
  CALL tstop(t_redist_2d)

  ! test 2d-to-2d transposition:
  fval_2d = INT(loc_id_2d)
  CALL tstart(t_exch_2d)
  CALL xt_redist_s_exchange(redist_tpex_2d, fval_2d, gval_2d)
  CALL tstop(t_exch_2d)
  IF (cmp_arrays(gval_2d, loc_tpex_2d)) &
       CALL test_abort('array eqivalence test failed', filename, __LINE__)

  ! define positions of surface elements within (k,i,j) array
  CALL id_map(id_pos)
  CALL id_map(pos3d_surf)
  CALL gen_pos3d_surf(pos3d_surf)

  ! generate surface transposition:
  CALL tstart(t_surf_redist)
  CALL gen_off_redist(xmap_tpex_2d, MPI_INTEGER, id_pos(:,:)-1, &
       MPI_INTEGER, pos3d_surf(:,:)-1, redist_surf_tpex_2d)
  CALL tstop(t_surf_redist)
  DEALLOCATE(id_pos, pos3d_surf)

  ! 2d to surface boundsexchange:
  gval_3d = -1
  CALL tstart(t_exch_surf)
  CALL xt_redist_s_exchange(redist_surf_tpex_2d, &
       RESHAPE(fval_2d, (/ 1, ie, je /)), gval_3d)
  CALL tstop(t_exch_surf)

  ! check surface:
  IF (cmp_arrays(gval_3d(1, :, :), loc_tpex_2d)) &
       CALL test_abort('surface check failed', filename, __LINE__)

  IF (nlev>1) THEN
    ! check sub surface:
    IF (ANY(gval_3d(2, :, :) /= -1)) &
         CALL test_abort('surface check failed', filename, __LINE__)
  ENDIF
  endif

  ! inflate (i,j) -> (k,i,j)
  CALL inflate_idx(1, loc_id_2d, loc_id_3d)
  DEALLOCATE(loc_id_2d)
  CALL inflate_idx(1, loc_tpex_2d, loc_tpex_3d)
  DEALLOCATE(loc_tpex_2d)

  IF (full_test) THEN

  ! xmap: loc_id_3d -> loc_tpex_3d
  CALL tstart(t_xmap_3d)
  CALL gen_xmap_3d(loc_id_3d, loc_tpex_3d, xmap_tpex_3d)
  CALL tstop(t_xmap_3d)

  ! transposition: loc_id_3d:data -> loc_tpex_3d:data
  CALL tstart(t_redist_3d)
  CALL gen_redist(xmap_tpex_3d, MPI_INTEGER, MPI_INTEGER, redist_tpex_3d)
  CALL tstop(t_redist_3d)

  CALL xt_xmap_delete(xmap_tpex_3d)

  ! test 3d-to-3d transposition:
  fval_3d = INT(loc_id_3d)
  gval_3d = -1
  CALL tstart(t_exch_3d)
  CALL xt_redist_s_exchange(redist_tpex_3d, fval_3d, gval_3d)
  CALL tstop(t_exch_3d)

  CALL xt_redist_delete(redist_tpex_3d)

  ! check 3d exchange:
  IF (cmp_arrays(gval_3d, loc_tpex_3d)) &
       CALL test_abort('3D array eqivalence test failed', filename, __LINE__)
  endif


  ! gen stripes, xmap, redist:
  CALL gen_stripes(loc_id_3d, loc_id_3d_ws)
  CALL gen_stripes(loc_tpex_3d, loc_tpex_3d_ws)

  xmap_tpex_3d_ws = xt_xmap_all2all_new(loc_id_3d_ws, loc_tpex_3d_ws, &
       MPI_COMM_WORLD)

  CALL tstart(t_redist_3d_ws)
  redist_tpex_3d_ws  = xt_redist_p2p_new(xmap_tpex_3d_ws, MPI_INTEGER)
  CALL tstop(t_redist_3d_ws)

  ! test redist_tpex_3d_ws:
  fval_3d = INT(loc_id_3d)
  gval_3d = -1

  CALL tstart(t_exch_3d_ws)
  CALL xt_redist_s_exchange(redist_tpex_3d_ws, fval_3d, gval_3d)
  CALL tstop(t_exch_3d_ws)
  if (full_test) then
  ! check 3d exchange:
  IF (cmp_arrays(gval_3d, loc_tpex_3d)) &
       CALL test_abort('3D array eqivalence test (using stripes) failed', &
       filename, __LINE__)
  endif

  CALL tstart(t_redist_3d_wb)
  CALL gen_redist_3d_wb(xmap_tpex_2d, MPI_INTEGER, redist_tpex_3d_wb)
  CALL tstop(t_redist_3d_wb)

  fval_3d = INT(loc_id_3d)
  gval_3d = -1
  CALL tstart(t_exch_3d_wb)
  CALL xt_redist_s_exchange(redist_tpex_3d_wb, fval_3d, gval_3d)
  CALL tstop(t_exch_3d_wb)

  DEALLOCATE(fval_3d)
  CALL xt_redist_delete(redist_tpex_3d_wb)

  IF (cmp_arrays(gval_3d, loc_tpex_3d)) &
       CALL test_abort('3D array eqivalence test after redist failed', &
       filename, __LINE__)

  ! cleanup:
  IF (full_test) THEN
    CALL xt_redist_delete(redist_tpex_3d_ws)
    CALL xt_xmap_delete(xmap_tpex_3d_ws)
    CALL xt_xmap_delete(xmap_tpex_2d)
    CALL xt_redist_delete(redist_tpex_2d)
    CALL xt_redist_delete(redist_surf_tpex_2d)
  ENDIF

  CALL tstop(t_all)

  IF (verbose) WRITE(0,*) 'timer report for nprocs=',nprocs

  CALL treport(t_all, TRIM(grid_label), mpi_comm_world)
  CALL treport(t_surf_redist, TRIM(grid_label), mpi_comm_world)
  CALL treport(t_exch_surf, TRIM(grid_label), mpi_comm_world)
  CALL treport(t_xmap_2d, TRIM(grid_label), mpi_comm_world)
  CALL treport(t_redist_2d, TRIM(grid_label), mpi_comm_world)
  CALL treport(t_exch_2d, TRIM(grid_label), mpi_comm_world)
  CALL treport(t_xmap_3d, TRIM(grid_label), mpi_comm_world)
  CALL treport(t_redist_3d, TRIM(grid_label), mpi_comm_world)
  CALL treport(t_exch_3d, TRIM(grid_label), mpi_comm_world)

  CALL treport(t_xmap_3d_ws, TRIM(grid_label), mpi_comm_world)
  CALL treport(t_redist_3d_ws, TRIM(grid_label), mpi_comm_world)
  CALL treport(t_exch_3d_ws, TRIM(grid_label), mpi_comm_world)

  CALL treport(t_redist_3d_wb, TRIM(grid_label), mpi_comm_world)
  CALL treport(t_exch_3d_wb, TRIM(grid_label), mpi_comm_world)

  DEALLOCATE(loc_tpex_3d, loc_id_3d, fval_2d, gval_2d, gval_3d)
  CALL xt_finalize()
  CALL finish_mpi

CONTAINS

  SUBROUTINE gen_redist_3d_wb(xmap_2d, dt, redist_3d)
    TYPE(xt_xmap), INTENT(in) :: xmap_2d
    INTEGER, INTENT(in) :: dt
    TYPE(xt_redist), INTENT(out) :: redist_3d

    INTEGER :: block_disp(ie,je), block_size(ie,je)
    INTEGER :: i, j
    ! data(k,i,j)
    DO j = 1, je
      DO i = 1, ie
        block_disp(i,j) = ( (j-1) * ie + i - 1 ) * nlev
        block_size(i,j) =  nlev
      ENDDO
    ENDDO
    !WRITE(0,*) '(gen_redist_3d_wb) call redist with field sizes =',ie*je
    redist_3d = xt_redist_p2p_blocks_off_new(xmap_2d, block_disp, block_size, &
         SIZE(block_size), block_disp, block_size, SIZE(block_size),dt)

  END SUBROUTINE gen_redist_3d_wb

  SUBROUTINE inflate_idx(inflate_pos, idx_2d, idx_3d)
    CHARACTER(len=*), PARAMETER :: context = 'test_perf::inflate_idx: '
    INTEGER, INTENT(in) :: inflate_pos
    INTEGER(xt_int_kind), INTENT(in) :: idx_2d(:,:)
    INTEGER(xt_int_kind), ALLOCATABLE, INTENT(out) :: idx_3d(:,:,:)

    INTEGER :: i, j, k

    SELECT CASE(inflate_pos)
    CASE(1)
      ALLOCATE(idx_3d(ke, ie, je))
      DO j=1,je
        DO i=1,ie
          DO k=1,ke
            idx_3d(k,i,j) = INT(k + (idx_2d(i,j)-1) * ke, xt_int_kind)
          ENDDO
        ENDDO
      ENDDO
    CASE(3)
      ALLOCATE(idx_3d(ie, je, ke))
      DO k=1,ke
        DO j=1,je
          DO i=1,ie
            idx_3d(i,j,k) = INT(idx_2d(i,j) + (k-1) * g_ie * g_je, xt_int_kind)
          ENDDO
        ENDDO
      ENDDO
    CASE DEFAULT
      CALL test_abort(context//' unsupported inflate position', &
           filename, __LINE__)
    END SELECT

  END SUBROUTINE inflate_idx

  SUBROUTINE gen_pos3d_surf(pos)
    INTEGER, INTENT(inout) :: pos(:,:)

    ! positions for zero based arrays ([k,i,j] dim order):
    ! old pos = i + j*ie
    ! new pos = k + (i + j*ie)*nlev

    INTEGER :: ii,jj, i,j,k, p,q

    k = 0 ! surface
    DO jj=1,je
      DO ii=1,ie
        p = pos(ii,jj) - 1 ! shift to 0-based index
        j = p/ie
        i = MOD(p,ie)
        q = k +  (i + j*ie)*nlev
        pos(ii,jj) = q + 1 ! shift to 1-based index
      ENDDO
    ENDDO

  END SUBROUTINE gen_pos3d_surf

  SUBROUTINE init_all
    CHARACTER(len=*), PARAMETER :: context = 'init_all: '
    INTEGER :: ierror
    CHARACTER(len=20) :: grid_str

    CALL xt_initialize(MPI_COMM_WORLD)

    CALL get_environment_variable('YAXT_TEST_PERF_GRID', grid_str)

    verbose = .TRUE.

    SELECT CASE (TRIM(ADJUSTL(grid_str)))
    CASE('TOY')
      grid_kind = grid_kind_toy
      grid_label = 'TOY'
      g_ie = 66
      g_je = 36
    CASE('TP10')
      grid_kind = grid_kind_tp10
      grid_label = 'TP10'
      g_ie = 362
      g_je = 192
    CASE('TP04')
      grid_kind = grid_kind_tp04
      grid_label = 'TP04'
      g_ie = 802
      g_je = 404
    CASE('TP6M')
      grid_kind = grid_kind_tp6m
      grid_label = 'TP6M'
      g_ie = 3602
      g_je = 2394
    CASE default
      grid_kind = grid_kind_test
      grid_label = 'TEST'
      g_ie = 32
      g_je = 12
      verbose = .FALSE.
    END SELECT

    CALL MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierror)
    IF (ierror /= MPI_SUCCESS) &
         CALL test_abort(context//'MPI_COMM_SIZE failed', filename, __LINE__)

    CALL MPI_COMM_RANK(MPI_COMM_WORLD, mype, ierror)
    IF (ierror /= MPI_SUCCESS) &
         CALL test_abort(context//'MPI_COMM_RANK failed', filename, __LINE__)
    IF (mype==0) THEN
      lroot = .true.
    ELSE
      lroot = .FALSE.
      verbose = .FALSE.
    ENDIF

    CALL factorize(nprocs, nprocx, nprocy)
    IF (lroot .AND. verbose) WRITE(0,*) 'nprocx, nprocy=',nprocx, nprocy
    IF (lroot .AND. verbose) WRITE(0,*) 'g_ie, g_je=',g_ie, g_je
    mypy = mype / nprocx
    mypx = MOD(mype, nprocx)

    CALL deco
    ke = nlev

    ALLOCATE(g_id(g_ie, g_je), g_tpex(g_ie, g_je))

    ALLOCATE(fval_2d(ie,je), gval_2d(ie,je))
    ALLOCATE(loc_id_2d(ie,je), loc_tpex_2d(ie,je))
    ALLOCATE(id_pos(ie,je), pos3d_surf(ie,je))

    fval_2d = undef_int
    gval_2d = undef_int
    loc_id_2d = INT(undef_int, xt_int_kind)
    loc_tpex_2d = INT(undef_int, xt_int_kind)
    id_pos = undef_int
    pos3d_surf = undef_int

  END SUBROUTINE init_all

  SUBROUTINE gen_redist(xmap, send_dt, recv_dt, redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER, INTENT(in) :: send_dt, recv_dt
    TYPE(xt_redist),INTENT(out) :: redist

    INTEGER :: dt

    IF (send_dt /= recv_dt) &
         CALL test_abort('gen_redist: (send_dt /= recv_dt) unsupported', &
         filename, __LINE__)
    dt = send_dt
    redist = xt_redist_p2p_new(xmap, dt)

  END SUBROUTINE gen_redist

  SUBROUTINE gen_off_redist(xmap, send_dt, send_off, recv_dt, recv_off, redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER,INTENT(in) :: send_dt, recv_dt
    INTEGER,INTENT(in) :: send_off(:,:), recv_off(:,:)
    TYPE(xt_redist),INTENT(out) :: redist

    INTEGER :: dt

    IF (send_dt /= recv_dt) &
         CALL test_abort('gen_off_redist: (send_dt /= recv_dt) unsupported', &
         filename, __LINE__)
    dt = send_dt

    redist = xt_redist_p2p_off_new(xmap, send_off, recv_off, dt)
  END SUBROUTINE gen_off_redist

  SUBROUTINE get_window(gval, win)
    INTEGER, INTENT(in) :: gval(:,:)
    INTEGER(xt_int_kind), INTENT(out) :: win(:,:)

    INTEGER :: i, j, ig, jg

    DO j = 1, je
      jg = p_joff + j
      DO i = 1, ie
        ig = p_ioff + i
        win(i,j) = INT(gval(ig,jg), xt_int_kind)
      ENDDO
    ENDDO

  END SUBROUTINE get_window

  SUBROUTINE gen_stripes(local_idx, local_stripes)
    CHARACTER(len=*), PARAMETER :: context = 'gen_stripes: '

    INTEGER(xt_int_kind), INTENT(in) :: local_idx(:,:,:)
    TYPE(Xt_idxlist), INTENT(out) :: local_stripes

    TYPE(xt_stripe), ALLOCATABLE :: stripes(:,:)
    INTEGER :: i, j, k, ni, nj, nk

    ! FIXME: assert nk matches xt_int_kind representable values
    nk = SIZE(local_idx,1)
    ni = SIZE(local_idx,2)
    nj = SIZE(local_idx,3)

    ALLOCATE(stripes(ni,nj))

    DO j = 1, nj
      DO i = 1, ni
        ! start, nstrides, stride
        stripes(i,j) = xt_stripe(local_idx(1,i,j), 1_xt_int_kind, nk)
        DO k = 1, nk
          IF (local_idx(1,i,j)-1+k /= local_idx(k,i,j)) &
               CALL test_abort(context//'stripe condition violated', &
               filename, __LINE__)
        ENDDO
      ENDDO
    ENDDO

    local_stripes = xt_idxstripes_new(stripes, SIZE(stripes))

  END SUBROUTINE gen_stripes

  SUBROUTINE gen_xmap_2d(local_src_idx, local_dst_idx, xmap)
    INTEGER(xt_int_kind), INTENT(in) :: local_src_idx(:,:)
    INTEGER(xt_int_kind), INTENT(in) :: local_dst_idx(:,:)
    TYPE(xt_xmap), INTENT(out) :: xmap

    TYPE(Xt_idxlist) :: src_idxlist, dst_idxlist

    src_idxlist = xt_idxvec_new(local_src_idx, SIZE(local_src_idx))
    dst_idxlist = xt_idxvec_new(local_dst_idx, SIZE(local_dst_idx))
    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist,  MPI_COMM_WORLD)

    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

  END SUBROUTINE gen_xmap_2d

  SUBROUTINE gen_xmap_3d(local_src_idx, local_dst_idx, xmap)
    INTEGER(xt_int_kind), INTENT(in) :: local_src_idx(:,:,:)
    INTEGER(xt_int_kind), INTENT(in) :: local_dst_idx(:,:,:)
    TYPE(xt_xmap), INTENT(out) :: xmap

    TYPE(Xt_idxlist) :: src_idxlist, dst_idxlist

    src_idxlist = xt_idxvec_new(local_src_idx, SIZE(local_src_idx))
    dst_idxlist = xt_idxvec_new(local_dst_idx, SIZE(local_dst_idx))
    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist,  MPI_COMM_WORLD)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)


  END SUBROUTINE gen_xmap_3d


  SUBROUTINE def_exchange(g_id, g_tpex)
    INTEGER, INTENT(in) :: g_id(:, :)
    INTEGER, INTENT(out) :: g_tpex(:, :)
    LOGICAL, PARAMETER :: increased_north_halo = .FALSE.
    LOGICAL, PARAMETER :: with_north_halo = .true.
    INTEGER :: i, j
    INTEGER :: g_core_is, g_core_ie, g_core_js, g_core_je
    INTEGER :: north_halo

    ! global core domain:
    g_core_is = nhalo + 1
    g_core_ie = g_ie-nhalo
    g_core_js = nhalo + 1
    g_core_je = g_je-nhalo

    ! global tripolar boundsexchange:
    g_tpex = undef_index
    g_tpex(g_core_is:g_core_ie, g_core_js:g_core_je) &
         = g_id(g_core_is:g_core_ie, g_core_js:g_core_je)

    IF (with_north_halo) THEN

      ! north inversion, (maybe with increased north halo)
      IF (increased_north_halo) THEN
        north_halo = nhalo+1
      ELSE
        north_halo = nhalo
      ENDIF

      IF (2*north_halo > g_core_je) &
           CALL test_abort('def_exchange: grid too small (or halo too large&
           &) for tripolar north exchange', &
           filename, __LINE__)
      DO j = 1, north_halo
        DO i = g_core_is, g_core_ie
          g_tpex(i,j) = g_tpex(g_core_ie + (g_core_is-i), 2*north_halo + (1-j))
        ENDDO
      ENDDO

    ELSE

      DO j = 1, nhalo
        DO i = nhalo+1, g_ie-nhalo
          g_tpex(i,j) = g_id(i,j)
        ENDDO
      ENDDO

    ENDIF

    ! south: no change
    DO j = g_core_je+1, g_je
      DO i = nhalo+1, g_ie-nhalo
        g_tpex(i,j) = g_id(i,j)
      ENDDO
    ENDDO

    ! PBC
    DO j = 1, g_je
      DO i = 1, nhalo
        g_tpex(g_core_is-i,j) = g_tpex(g_core_ie+(1-i),j)
      ENDDO
      DO i = 1, nhalo
        g_tpex(g_core_ie+i,j) = g_tpex(nhalo+i,j)
      ENDDO
    ENDDO

    CALL check_g_idx (g_tpex)

  END SUBROUTINE def_exchange

  SUBROUTINE check_g_idx(gidx)
    INTEGER,INTENT(in) :: gidx(:,:)

    IF (ANY(gidx == undef_index)) THEN
      CALL test_abort('check_g_idx: check failed', filename, __LINE__)
    ENDIF
  END SUBROUTINE check_g_idx

  SUBROUTINE deco
    INTEGER :: cx0(0:nprocx-1), cxn(0:nprocx-1)
    INTEGER :: cy0(0:nprocy-1), cyn(0:nprocy-1)

    cx0 = 0
    cxn = 0
    CALL regular_deco(g_ie-2*nhalo, cx0, cxn)

    cy0 = 0
    cyn = 0
    CALL regular_deco(g_je-2*nhalo, cy0, cyn)

    ! process local deco variables:
    ie = cxn(mypx) + 2*nhalo
    je = cyn(mypy) + 2*nhalo
    p_ioff = cx0(mypx)
    p_joff = cy0(mypy)

  END SUBROUTINE deco

END PROGRAM test_perf_stripes
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_collection_f.f90
!! @brief Fortran test of redist_collection class
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!

#include "fc_feature_defs.inc"
PROGRAM test_redist_collection
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort, cmp_arrays
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, &
       xt_xmap, xt_xmap_delete, xt_xmap_all2all_new, &
       xt_redist, xt_redist_p2p_new, xt_redist_collection_new, &
       xt_redist_delete, xt_redist_copy, &
       xt_redist_s_exchange, xt_redist_a_exchange, &
       xt_idxempty_new, xt_idxlist_delete, &
       xt_idxlist, xt_request, xt_config, xt_config_delete
#if !defined HAVE_FC_LOGICAL_INTEROP || !defined(__GNUC__) || __GNUC__ > 4 \
  || (__GNUC__ == 4 && __GNUC_MINOR__ > 8)
#else
  USE yaxt, ONLY: xt_slice_c_loc
#endif
  ! older PGI compilers do not handle generic interface correctly
#if defined __PGI && (__PGIC__ < 12 || (__PGIC__ ==  12 && __PGIC_MINOR__ <= 10))
  USE xt_redist_base, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
#endif
  USE test_redist_common, ONLY: build_odd_selection_xmap, check_redist, &
       check_wait_request, redist_exchanger_option
  USE iso_c_binding, ONLY: c_loc, c_ptr
  USE redist_collection_displace, ONLY: test_displacement_variations
#include "xt_slice_c_loc.inc"
  IMPLICIT NONE
  CHARACTER(len=*), PARAMETER :: filename = 'test_redist_collection_f.f90'
  CHARACTER(len=*), PARAMETER :: err_msg(2) = &
       (/ "error on xt_redist_s_exchange", "error on xt_redist_a_exchange" /)
  TYPE(xt_config) :: config

  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  CALL simple_test(mpi_comm_world, config)
  CALL simple_test2(mpi_comm_world, config)
  CALL test_empty_redist(mpi_comm_world, config)
  CALL test_repeated_redist(mpi_comm_world, config, -1)
  CALL test_repeated_redist(mpi_comm_world, config, 0)
  CALL test_displacement_variations(mpi_comm_world, config)

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi
CONTAINS
  SUBROUTINE simple_test(comm, config)
    ! general test with one redist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    ! set up data
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_coll, redist_copy
    INTEGER, PARAMETER :: src_slice_len = 5, dst_slice_len = 3
    DOUBLE PRECISION, PARAMETER :: &
         ref_dst_data(dst_slice_len) = (/ 1.0d0, 3.0d0, 5.0d0 /), &
         src_data(src_slice_len) = (/ 1.0d0, 2.0d0, 3.0d0, 4.0d0, 5.0d0 /)
    DOUBLE PRECISION :: dst_data(dst_slice_len)


    xmap = build_odd_selection_xmap(src_slice_len, comm)

    redist = xt_redist_p2p_new(xmap, mpi_double_precision)
    CALL xt_xmap_delete(xmap)
    redist_copy = xt_redist_copy(redist)
    CALL xt_redist_delete(redist)
    redist = redist_copy

    ! generate redist_collection
    redist_coll = xt_redist_collection_new((/ redist /), 1, -1, comm, config)

    CALL xt_redist_delete(redist)

    ! test exchange
    CALL check_redist(redist_coll, src_data, dst_data, ref_dst_data)

    ! clean up
    CALL xt_redist_delete(redist_coll)
  END SUBROUTINE simple_test

  SUBROUTINE simple_test2(comm, config)
    ! general test with one redist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    ! set up data
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist_coll, redist_copy, &
         redist_components(2)
    INTEGER, PARAMETER :: src_slice_len = 5, dst_slice_len = 3
    TYPE src_data_collection
      DOUBLE PRECISION :: dp(src_slice_len)
      LOGICAL :: l(src_slice_len)
    END TYPE src_data_collection
    TYPE dst_data_collection
      DOUBLE PRECISION :: dp(dst_slice_len)
      LOGICAL :: l(dst_slice_len)
    END TYPE dst_data_collection
    TYPE(src_data_collection), SAVE, TARGET :: src_data = src_data_collection(&
         (/ 1.0d0, 2.0d0, 3.0d0, 4.0d0, 5.0d0 /), &
         (/ .TRUE., .FALSE., .TRUE., .FALSE., .TRUE. /))
    TYPE(dst_data_collection), PARAMETER :: &
         ref_dst_data = dst_data_collection((/ 1.0d0, 3.0d0, 5.0d0 /), &
         (/ .TRUE., .TRUE., .TRUE. /))
    TYPE(dst_data_collection), TARGET :: dst_data
    TYPE(c_ptr) :: src_data_p(2), dst_data_p(2)

    xmap = build_odd_selection_xmap(src_slice_len, comm)

    redist_components(1) = xt_redist_p2p_new(xmap, mpi_double_precision)
    redist_components(2) = xt_redist_p2p_new(xmap, mpi_logical)
    CALL xt_xmap_delete(xmap)

    ! generate redist_collection
    redist_coll = xt_redist_collection_new(redist_components, comm, config)
    CALL xt_redist_delete(redist_components)
    redist_copy = xt_redist_copy(redist_coll)
    CALL xt_redist_delete(redist_coll)
    redist_coll = redist_copy

    ! test exchange
    ! GNU Fortran versions up to 4.8 cannot call c_loc for type components,
    ! instant ICE, and
#if !defined(__GNUC__) || __GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ > 8)
#  define COMP_C_LOC(v, p) p = C_LOC(v)
#else
#  define COMP_C_LOC(v, p) CALL xt_slice_c_loc(v, p)
#endif
    ! some compilers won't create c_ptr's to LOGICALs and gfortran
    ! version 8 and below  has a bug that prevents it from noticing the escaped
    ! pointer (and computes ANY(dst_data%l .NEQV. ref_dst_data%l early
    ! for that reason).
#if defined HAVE_FC_LOGICAL_INTEROP && ( !defined __GNUC__ || __GNUC__ > 8 )
#  define L_COMP_C_LOC(v, p) p = C_LOC(v)
#else
#  define L_COMP_C_LOC(v, p) CALL xt_slice_c_loc(v, p)
#endif

    COMP_C_LOC(src_data%dp, src_data_p(1))
    L_COMP_C_LOC(src_data%l, src_data_p(2))
    dst_data%dp = -1.0d0
    dst_data%l = .FALSE.
    COMP_C_LOC(dst_data%dp, dst_data_p(1))
    L_COMP_C_LOC(dst_data%l, dst_data_p(2))
    CALL xt_redist_s_exchange(redist_coll, src_data_p, dst_data_p)
    IF (ANY(dst_data%l .NEQV. ref_dst_data%l)) &
         CALL test_abort("error in xt_redist_s_exchange", filename, __LINE__)
    IF (cmp_arrays(dst_data%dp, ref_dst_data%dp)) &
         CALL test_abort("error in xt_redist_s_exchange", filename, __LINE__)

    ! clean up
    CALL xt_redist_delete(redist_coll)
  END SUBROUTINE simple_test2

  SUBROUTINE test_empty_redist(comm, config)
    ! general test with empty redist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    ! set up data
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_coll, redist_copy


    src_idxlist = xt_idxempty_new()
    dst_idxlist = xt_idxempty_new()

    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist, comm)

    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    redist = xt_redist_p2p_new(xmap, mpi_double_precision)
    CALL xt_xmap_delete(xmap)
    redist_copy = xt_redist_copy(redist)
    CALL xt_redist_delete(redist)
    redist = redist_copy

    ! generate redist_collection
    redist_coll = xt_redist_collection_new((/ redist /), 1, -1, comm, config)

    CALL xt_redist_delete(redist)

    ! clean up
    CALL xt_redist_delete(redist_coll)
  END SUBROUTINE test_empty_redist

  SUBROUTINE test_repeated_redist_ds(redist_coll, src_data, permutation)
    TYPE(xt_redist), INTENT(in) :: redist_coll
    DOUBLE PRECISION, INTENT(in), TARGET :: src_data(5, 3)
    INTEGER, INTENT(in) :: permutation(3)
    INTEGER :: i, j
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(3, 3) &
         = RESHAPE((/ ((DBLE(i + j), i = 1,5,2), j = 0,10,5) /), (/ 3, 3 /))
    DOUBLE PRECISION, TARGET :: dst_data(3, 3)
    TYPE(c_ptr) :: src_data_p(3), dst_data_p(3)

    INTEGER :: iexch
    TYPE(xt_request) :: request

    DO i = 1, 3
      XT_SLICE_C_LOC(src_data(:, permutation(i)), src_data_p(i))
      XT_SLICE_C_LOC(dst_data(:, permutation(i)), dst_data_p(i))
    END DO
    DO iexch = 1, 2
      dst_data = -1.0d0
      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist_coll, 3, src_data_p, dst_data_p)
      ELSE
        CALL xt_redist_a_exchange(redist_coll, 3, src_data_p, dst_data_p, &
             request)
        CALL check_wait_request(request, filename, __LINE__)
      ENDIF
      IF (cmp_arrays(ref_dst_data, dst_data)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE test_repeated_redist_ds

  SUBROUTINE test_repeated_redist(comm, config, cache_size)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    INTEGER, INTENT(in) :: cache_size
    ! test with one redist used three times (with two different input data
    ! displacements -> test of cache) (with default cache size)
    ! set up data
    INTEGER, PARAMETER :: num_slice = 3
    INTEGER, PARAMETER :: src_slice_len = 5
    INTEGER :: i
    DOUBLE PRECISION, PARAMETER :: src_data(5, num_slice) = RESHAPE((/&
         (DBLE(i), i = 1, 15)/), (/ 5, num_slice /))
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redists(num_slice), redist_coll, redist_coll_copy
    INTEGER, PARAMETER :: permutation(3, 3) &
         = RESHAPE((/ 1, 2, 3, 2, 1, 3, 1, 2, 3 /), (/ 3, 3 /))

    xmap = build_odd_selection_xmap(src_slice_len, comm)

    redists = xt_redist_p2p_new(xmap, mpi_double_precision)

    CALL xt_xmap_delete(xmap)

    ! generate redist_collection

    redist_coll = xt_redist_collection_new(redists, 3, cache_size, &
         comm, config)

    CALL xt_redist_delete(redists(1))

    DO i = 1, 3
      ! test exchange, first with simple sequence, then permuted
      ! offsets and then original offsets again
      CALL test_repeated_redist_ds(redist_coll, src_data, permutation(:, i))
    END DO

    ! and the copy
    redist_coll_copy = xt_redist_copy(redist_coll)
    CALL xt_redist_delete(redist_coll)
    DO i = 1, 3
      ! test exchange, first with simple sequence, then permuted
      ! offsets and then original offsets again
      CALL test_repeated_redist_ds(redist_coll_copy, src_data, permutation(:, i))
    END DO

    ! clean up
    CALL xt_redist_delete(redist_coll_copy)
  END SUBROUTINE test_repeated_redist

END PROGRAM test_redist_collection
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file xt_exchanger_f.f90
!! @brief Fortran interface to yaxt xmap declarations
!!
!! @copyright Copyright  (C)  2024 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE xt_exchanger_abstract
  USE iso_c_binding, ONLY: c_int, c_ptr, c_null_ptr, &
       c_associated
  USE xt_core, ONLY: xt_mpi_fint_kind, xt_pos_ext, i2, i4, i8
  USE xt_mpi, ONLY: mpi_address_kind
  USE xt_config_f, ONLY: xt_config, xt_config_f2c
  USE xt_requests, ONLY: xt_request
  IMPLICIT NONE
  PRIVATE
  PUBLIC :: xt_exchanger_c2f, xt_exchanger_f2c, xt_is_null
  PUBLIC :: xt_exchanger_iter_f2c, &
       xt_exchanger_iter_c2f
  PUBLIC :: xt_exchanger_copy, xt_exchanger_delete, &
       xt_exchanger_get_num_msg
  PUBLIC :: xt_exchanger_new
  PUBLIC :: xt_exchanger_s_exchange, xt_exchanger_a_exchange
  PUBLIC :: xt_exchanger_get_iterator, &
       xt_exchanger_iter_next, &
       xt_exchanger_iter_get_rank, &
       xt_exchanger_iter_get_direction, &
       xt_exchanger_iter_get_mpi_datatype, &
       xt_exchanger_iter_get_displacement, &
       xt_exchanger_iter_get_count, &
       xt_exchanger_iter_delete


  ! note: this type must not be extended to contain any other
  ! components, its memory pattern has to match void * exactly, which
  ! it does because of C constraints
  TYPE, BIND(C), PUBLIC :: xt_exchanger
#ifndef __G95__
    PRIVATE
#endif
    TYPE(c_ptr) :: cptr = c_null_ptr
  END TYPE xt_exchanger

  TYPE, BIND(c), PUBLIC :: xt_exchanger_iter
#ifndef __G95__
    PRIVATE
#endif
    TYPE(c_ptr) :: cptr = c_null_ptr
  END TYPE xt_exchanger_iter

  INTERFACE
    ! this function must not be implemented in Fortran because
    ! PGI 11.x chokes on that
    FUNCTION xt_exchanger_f2c(exchanger) BIND(c, name='xt_exchanger_f2c') &
         RESULT(p)
      IMPORT :: c_ptr, xt_exchanger
      IMPLICIT NONE
      TYPE(xt_exchanger), INTENT(in) :: exchanger
      TYPE(c_ptr) :: p
    END FUNCTION xt_exchanger_f2c

    SUBROUTINE xt_exchanger_delete_c(exchanger) BIND(C, name='xt_exchanger_delete')
      IMPORT :: c_ptr
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in) :: exchanger
    END SUBROUTINE xt_exchanger_delete_c

    ! this function must not be implemented in Fortran because
    ! PGI 11.x chokes on that
    FUNCTION xt_exchanger_iter_f2c(iter) BIND(c, name='xt_exchanger_iter_f2c') &
         RESULT(p)
      IMPORT :: c_ptr, xt_exchanger_iter
      IMPLICIT NONE
      TYPE(xt_exchanger_iter), INTENT(in) :: iter
      TYPE(c_ptr) :: p
    END FUNCTION xt_exchanger_iter_f2c

    SUBROUTINE xt_exchanger_iter_delete_c(iter) &
         BIND(C, name='xt_exchanger_iter_delete')
      IMPORT :: c_ptr
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in) :: iter
    END SUBROUTINE xt_exchanger_iter_delete_c

  END INTERFACE

  INTERFACE xt_exchanger_delete
    MODULE PROCEDURE xt_exchanger_delete_1
    MODULE PROCEDURE xt_exchanger_delete_a1d
  END INTERFACE xt_exchanger_delete

  INTERFACE xt_is_null
    MODULE PROCEDURE xt_exchanger_is_null
    MODULE PROCEDURE xt_exchanger_iter_is_null
  END INTERFACE xt_is_null

  INTERFACE
    FUNCTION xt_exchanger_iter_get_mpi_datatype(iter) RESULT(dt) &
         BIND(c, name='xt_exchanger_iter_get_MPI_datatype_f2c')
      IMPORT :: xt_mpi_fint_kind, xt_exchanger_iter
      TYPE(xt_exchanger_iter), INTENT(in) :: iter
      INTEGER(xt_mpi_fint_kind) :: dt
    END FUNCTION xt_exchanger_iter_get_mpi_datatype
  END INTERFACE

  TYPE, BIND(c), PUBLIC :: xt_msg_param
    INTEGER(mpi_address_kind) :: displacement
    INTEGER(xt_mpi_fint_kind) :: datatype, rank, count
  END TYPE xt_msg_param

  CHARACTER(len=*), PARAMETER :: filename = 'xt_exchanger_f.f90'
CONTAINS

  FUNCTION xt_exchanger_is_null(exchanger) RESULT(p)
    TYPE(xt_exchanger), INTENT(in) :: exchanger
    LOGICAL :: p
    p = .NOT. C_ASSOCIATED(exchanger%cptr)
  END FUNCTION xt_exchanger_is_null


  FUNCTION xt_exchanger_c2f(exchanger) RESULT(p)
    TYPE(c_ptr), INTENT(in) :: exchanger
    TYPE(xt_exchanger) :: p
    p%cptr = exchanger
  END FUNCTION xt_exchanger_c2f

  FUNCTION xt_exchanger_copy(exchanger) RESULT(exchanger_copy)
    TYPE(xt_exchanger), INTENT(in) :: exchanger
    TYPE(xt_exchanger) :: exchanger_copy
    INTERFACE
      FUNCTION xt_exchanger_copy_c(exchanger) &
           BIND(C, name='xt_exchanger_copy') RESULT(res_ptr)
        IMPORT :: xt_exchanger, c_ptr
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: exchanger
        TYPE(c_ptr) :: res_ptr
      END FUNCTION xt_exchanger_copy_c
    END INTERFACE
    exchanger_copy%cptr = xt_exchanger_copy_c(exchanger%cptr)
  END FUNCTION xt_exchanger_copy

  SUBROUTINE xt_exchanger_delete_1(exchanger)
    TYPE(xt_exchanger), INTENT(inout) :: exchanger
    CALL xt_exchanger_delete_c(exchanger%cptr)
    exchanger%cptr = c_null_ptr
  END SUBROUTINE xt_exchanger_delete_1

  SUBROUTINE xt_exchanger_delete_a1d(exchangers)
    TYPE(xt_exchanger), INTENT(inout) :: exchangers(:)
    INTEGER :: i, n
    n = SIZE(exchangers)
    DO i = 1, n
      CALL xt_exchanger_delete_c(exchangers(i)%cptr)
      exchangers(i)%cptr = c_null_ptr
    END DO
  END SUBROUTINE xt_exchanger_delete_a1d

  FUNCTION xt_exchanger_new(nsend, nrecv, send_msgs, recv_msgs, &
       comm, tag_offset, config) RESULT(exchanger)
    IMPLICIT NONE
    INTEGER, INTENT(in) :: nsend, nrecv, comm, tag_offset
    TYPE(xt_msg_param), INTENT(in) :: send_msgs(nsend), recv_msgs(nrecv)
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_exchanger) :: exchanger

    INTEGER(c_int) :: nsend_c, nrecv_c
    TYPE(c_ptr) :: config_cptr

    INTERFACE
      FUNCTION xt_exchanger_new_f2c(nsend, nrecv, send_msgs, recv_msgs, &
           comm, tag_offset, config) &
           BIND(C, name='xt_exchanger_new_f2c') RESULT(exchanger_ptr)
        IMPORT :: c_int, xt_exchanger, xt_mpi_fint_kind, c_ptr, &
             xt_msg_param
        IMPLICIT NONE
        INTEGER(c_int), VALUE, INTENT(in) :: nsend, nrecv
        TYPE(xt_msg_param), INTENT(in) :: send_msgs(nsend), recv_msgs(nrecv)
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: comm, tag_offset
        TYPE(c_ptr), VALUE, INTENT(in) :: config
        TYPE(c_ptr) :: exchanger_ptr
      END FUNCTION xt_exchanger_new_f2c
    END INTERFACE
    nsend_c = INT(nsend, c_int)
    nrecv_c = INT(nrecv, c_int)
    config_cptr = xt_config_f2c(config)
    exchanger%cptr = xt_exchanger_new_f2c(nsend_c, nrecv_c, &
         send_msgs, recv_msgs, comm, tag_offset, config_cptr)
  END FUNCTION xt_exchanger_new

  FUNCTION xt_exchanger_get_num_msg(exchanger, direction) RESULT(num)
    TYPE(xt_exchanger), INTENT(in) :: exchanger
    INTEGER, INTENT(in) :: direction
    INTEGER :: num
    INTERFACE
      FUNCTION xt_exchanger_get_num_msg_c(exchanger, direction) RESULT(num) &
           BIND(c, name='xt_exchanger_get_num_msg')
        IMPORT :: c_ptr, c_int
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: exchanger
        INTEGER(c_int), VALUE, INTENT(in) :: direction
        INTEGER(c_int) :: num
      END FUNCTION xt_exchanger_get_num_msg_c
    END INTERFACE
    num = INT(xt_exchanger_get_num_msg_c(exchanger%cptr, direction))
  END FUNCTION xt_exchanger_get_num_msg

  SUBROUTINE xt_exchanger_s_exchange(exchanger, src_data, dst_data)
    TYPE(xt_exchanger), INTENT(inout) :: exchanger
    TYPE(c_ptr) :: src_data, dst_data
    INTERFACE
      SUBROUTINE xt_exchanger_s_exchange_c(exchanger, src_data, dst_data) &
           BIND(c, name='xt_exchanger_s_exchange')
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: exchanger
        TYPE(c_ptr), VALUE :: src_data, dst_data
      END SUBROUTINE xt_exchanger_s_exchange_c
    END INTERFACE
    CALL xt_exchanger_s_exchange_c(exchanger%cptr, src_data, dst_data)
  END SUBROUTINE xt_exchanger_s_exchange

  SUBROUTINE xt_exchanger_a_exchange(exchanger, src_data, dst_data, request)
    TYPE(xt_exchanger), INTENT(inout) :: exchanger
    TYPE(xt_request) :: request
    TYPE(c_ptr) :: src_data, dst_data
    INTERFACE
      SUBROUTINE xt_exchanger_a_exchange_c(exchanger, src_data, dst_data, &
           request) &
           BIND(c, name='xt_exchanger_a_exchange')
        IMPORT :: c_ptr, xt_request
        TYPE(c_ptr), VALUE, INTENT(in) :: exchanger
        TYPE(c_ptr), VALUE :: src_data, dst_data
        TYPE(xt_request), INTENT(out) :: request
      END SUBROUTINE xt_exchanger_a_exchange_c
    END INTERFACE
    CALL xt_exchanger_a_exchange_c(exchanger%cptr, src_data, dst_data, request)
  END SUBROUTINE xt_exchanger_a_exchange

  FUNCTION xt_exchanger_get_iterator(exchanger) RESULT(iter)
    TYPE(xt_exchanger), INTENT(in) :: exchanger
    TYPE(xt_exchanger_iter) :: iter
    INTERFACE
      FUNCTION xt_exchanger_get_iterator_c(exchanger) RESULT(cptr) &
           BIND(c, name='xt_exchanger_get_iterator')
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: exchanger
        TYPE(c_ptr) :: cptr
      END FUNCTION xt_exchanger_get_iterator_c
    END INTERFACE
    iter%cptr = xt_exchanger_get_iterator_c(exchanger%cptr)
  END FUNCTION xt_exchanger_get_iterator

  FUNCTION xt_exchanger_iter_c2f(iter) RESULT(p)
    TYPE(c_ptr), INTENT(in) :: iter
    TYPE(xt_exchanger_iter) :: p
    p%cptr = iter
  END FUNCTION xt_exchanger_iter_c2f

  FUNCTION xt_exchanger_iter_is_null(iter) RESULT(p)
    TYPE(xt_exchanger_iter), INTENT(in) :: iter
    LOGICAL :: p
    p = .NOT. C_ASSOCIATED(iter%cptr)
  END FUNCTION xt_exchanger_iter_is_null

  FUNCTION xt_exchanger_iter_next(iter) RESULT(avail)
    TYPE(xt_exchanger_iter), INTENT(inout) :: iter
    LOGICAL :: avail
    INTERFACE
      FUNCTION xt_exchanger_iter_next_c(iter) RESULT(avail) &
           BIND(c, name='xt_exchanger_iter_next')
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE, INTENT(in) :: iter
        INTEGER(c_int) :: avail
      END FUNCTION xt_exchanger_iter_next_c
    END INTERFACE
    avail = xt_exchanger_iter_next_c(iter%cptr) /= 0
  END FUNCTION xt_exchanger_iter_next

  FUNCTION xt_exchanger_iter_get_rank(iter) RESULT(rank)
    TYPE(xt_exchanger_iter), INTENT(in) :: iter
    INTEGER :: rank
    INTERFACE
      FUNCTION xt_exchanger_iter_get_rank_c(iter) RESULT(rank) &
           BIND(c, name='xt_exchanger_iter_get_rank')
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE, INTENT(in) :: iter
        INTEGER(c_int) :: rank
      END FUNCTION xt_exchanger_iter_get_rank_c
    END INTERFACE
    rank = INT(xt_exchanger_iter_get_rank_c(iter%cptr))
  END FUNCTION xt_exchanger_iter_get_rank

  FUNCTION xt_exchanger_iter_get_count(iter) RESULT(msg_count)
    TYPE(xt_exchanger_iter), INTENT(in) :: iter
    INTEGER :: msg_count
    INTERFACE
      FUNCTION xt_exchanger_iter_get_count_c(iter) RESULT(msg_count) &
           BIND(c, name='xt_exchanger_iter_get_count')
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE, INTENT(in) :: iter
        INTEGER(c_int) :: msg_count
      END FUNCTION xt_exchanger_iter_get_count_c
    END INTERFACE
    msg_count = INT(xt_exchanger_iter_get_count_c(iter%cptr))
  END FUNCTION xt_exchanger_iter_get_count

  FUNCTION xt_exchanger_iter_get_direction(iter) RESULT(direction)
    TYPE(xt_exchanger_iter), INTENT(in) :: iter
    INTEGER :: direction
    INTERFACE
      FUNCTION xt_exchanger_iter_get_direction_c(iter) RESULT(direction) &
           BIND(c, name='xt_exchanger_iter_get_direction')
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE, INTENT(in) :: iter
        INTEGER(c_int) :: direction
      END FUNCTION xt_exchanger_iter_get_direction_c
    END INTERFACE
    direction = INT(xt_exchanger_iter_get_direction_c(iter%cptr))
  END FUNCTION xt_exchanger_iter_get_direction

  FUNCTION xt_exchanger_iter_get_displacement(iter) RESULT(displacement)
    TYPE(xt_exchanger_iter), INTENT(in) :: iter
    INTEGER(mpi_address_kind) :: displacement
    INTERFACE
      FUNCTION xt_exchanger_iter_get_displacement_c(iter) RESULT(displacement) &
           BIND(c, name='xt_exchanger_iter_get_displacement')
        IMPORT :: c_ptr, mpi_address_kind
        TYPE(c_ptr), VALUE, INTENT(in) :: iter
        INTEGER(mpi_address_kind) :: displacement
      END FUNCTION xt_exchanger_iter_get_displacement_c
    END INTERFACE
    displacement = xt_exchanger_iter_get_displacement_c(iter%cptr)
  END FUNCTION xt_exchanger_iter_get_displacement

  SUBROUTINE xt_exchanger_iter_delete(iter)
    TYPE(xt_exchanger_iter), INTENT(inout) :: iter
    INTERFACE
      SUBROUTINE xt_exchanger_iter_delete_c(iter) &
           BIND(c, name='xt_exchanger_iter_delete')
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: iter
      END SUBROUTINE xt_exchanger_iter_delete_c
    END INTERFACE
    CALL xt_exchanger_iter_delete_c(iter%cptr)
    iter%cptr = c_null_ptr
  END SUBROUTINE xt_exchanger_iter_delete
END MODULE xt_exchanger_abstract

!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_collection_f.f90
!! @brief Fortran test of redist_collection class
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!

#include "fc_feature_defs.inc"
PROGRAM test_redist_collection
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort, cmp_arrays
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, &
       xt_xmap, xt_xmap_delete, xt_xmap_all2all_new, &
       xt_redist, xt_redist_p2p_new, xt_redist_collection_new, &
       xt_redist_delete, xt_redist_copy, &
       xt_redist_s_exchange, xt_redist_a_exchange, &
       xt_idxempty_new, xt_idxlist_delete, &
       xt_idxlist, xt_request, xt_config, xt_config_delete
#if !defined HAVE_FC_LOGICAL_INTEROP || !defined(__GNUC__) || __GNUC__ > 4 \
  || (__GNUC__ == 4 && __GNUC_MINOR__ > 8)
#else
  USE yaxt, ONLY: xt_slice_c_loc
#endif
  ! older PGI compilers do not handle generic interface correctly
#if defined __PGI && (__PGIC__ < 12 || (__PGIC__ ==  12 && __PGIC_MINOR__ <= 10))
  USE xt_redist_base, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
#endif
  USE test_redist_common, ONLY: build_odd_selection_xmap, check_redist, &
       check_wait_request, redist_exchanger_option
  USE iso_c_binding, ONLY: c_loc, c_ptr
  USE redist_collection_displace, ONLY: test_displacement_variations
#include "xt_slice_c_loc.inc"
  IMPLICIT NONE
  CHARACTER(len=*), PARAMETER :: filename = 'test_redist_collection_f.f90'
  CHARACTER(len=*), PARAMETER :: err_msg(2) = &
       (/ "error on xt_redist_s_exchange", "error on xt_redist_a_exchange" /)
  TYPE(xt_config) :: config

  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  CALL simple_test(mpi_comm_world, config)
  CALL simple_test2(mpi_comm_world, config)
  CALL test_empty_redist(mpi_comm_world, config)
  CALL test_repeated_redist(mpi_comm_world, config, -1)
  CALL test_repeated_redist(mpi_comm_world, config, 0)
  CALL test_displacement_variations(mpi_comm_world, config, 3)
  CALL test_displacement_variations(mpi_comm_world, config, 40)

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi
CONTAINS
  SUBROUTINE simple_test(comm, config)
    ! general test with one redist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    ! set up data
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_coll, redist_copy
    INTEGER, PARAMETER :: src_slice_len = 5, dst_slice_len = 3
    DOUBLE PRECISION, PARAMETER :: &
         ref_dst_data(dst_slice_len) = (/ 1.0d0, 3.0d0, 5.0d0 /), &
         src_data(src_slice_len) = (/ 1.0d0, 2.0d0, 3.0d0, 4.0d0, 5.0d0 /)
    DOUBLE PRECISION :: dst_data(dst_slice_len)


    xmap = build_odd_selection_xmap(src_slice_len, comm)

    redist = xt_redist_p2p_new(xmap, mpi_double_precision)
    CALL xt_xmap_delete(xmap)
    redist_copy = xt_redist_copy(redist)
    CALL xt_redist_delete(redist)
    redist = redist_copy

    ! generate redist_collection
    redist_coll = xt_redist_collection_new((/ redist /), 1, -1, comm, config)

    CALL xt_redist_delete(redist)

    ! test exchange
    CALL check_redist(redist_coll, src_data, dst_data, ref_dst_data)

    ! clean up
    CALL xt_redist_delete(redist_coll)
  END SUBROUTINE simple_test

  SUBROUTINE simple_test2(comm, config)
    ! general test with one redist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    ! set up data
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist_coll, redist_copy, &
         redist_components(2)
    INTEGER, PARAMETER :: src_slice_len = 5, dst_slice_len = 3
    TYPE src_data_collection
      DOUBLE PRECISION :: dp(src_slice_len)
      LOGICAL :: l(src_slice_len)
    END TYPE src_data_collection
    TYPE dst_data_collection
      DOUBLE PRECISION :: dp(dst_slice_len)
      LOGICAL :: l(dst_slice_len)
    END TYPE dst_data_collection
    TYPE(src_data_collection), SAVE, TARGET :: src_data = src_data_collection(&
         (/ 1.0d0, 2.0d0, 3.0d0, 4.0d0, 5.0d0 /), &
         (/ .TRUE., .FALSE., .TRUE., .FALSE., .TRUE. /))
    TYPE(dst_data_collection), PARAMETER :: &
         ref_dst_data = dst_data_collection((/ 1.0d0, 3.0d0, 5.0d0 /), &
         (/ .TRUE., .TRUE., .TRUE. /))
    TYPE(dst_data_collection), TARGET :: dst_data
    TYPE(c_ptr) :: src_data_p(2), dst_data_p(2)

    xmap = build_odd_selection_xmap(src_slice_len, comm)

    redist_components(1) = xt_redist_p2p_new(xmap, mpi_double_precision)
    redist_components(2) = xt_redist_p2p_new(xmap, mpi_logical)
    CALL xt_xmap_delete(xmap)

    ! generate redist_collection
    redist_coll = xt_redist_collection_new(redist_components, comm, config)
    CALL xt_redist_delete(redist_components)
    redist_copy = xt_redist_copy(redist_coll)
    CALL xt_redist_delete(redist_coll)
    redist_coll = redist_copy

    ! test exchange
    ! GNU Fortran versions up to 4.8 cannot call c_loc for type components,
    ! instant ICE, and
#if !defined(__GNUC__) || __GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ > 8)
#  define COMP_C_LOC(v, p) p = C_LOC(v)
#else
#  define COMP_C_LOC(v, p) CALL xt_slice_c_loc(v, p)
#endif
    ! some compilers won't create c_ptr's to LOGICALs and gfortran
    ! version 8 and below  has a bug that prevents it from noticing the escaped
    ! pointer (and computes ANY(dst_data%l .NEQV. ref_dst_data%l early
    ! for that reason).
#if defined HAVE_FC_LOGICAL_INTEROP && ( !defined __GNUC__ || __GNUC__ > 8 )
#  define L_COMP_C_LOC(v, p) p = C_LOC(v)
#else
#  define L_COMP_C_LOC(v, p) CALL xt_slice_c_loc(v, p)
#endif

    COMP_C_LOC(src_data%dp, src_data_p(1))
    L_COMP_C_LOC(src_data%l, src_data_p(2))
    dst_data%dp = -1.0d0
    dst_data%l = .FALSE.
    COMP_C_LOC(dst_data%dp, dst_data_p(1))
    L_COMP_C_LOC(dst_data%l, dst_data_p(2))
    CALL xt_redist_s_exchange(redist_coll, src_data_p, dst_data_p)
    IF (ANY(dst_data%l .NEQV. ref_dst_data%l)) &
         CALL test_abort("error in xt_redist_s_exchange", filename, __LINE__)
    IF (cmp_arrays(dst_data%dp, ref_dst_data%dp)) &
         CALL test_abort("error in xt_redist_s_exchange", filename, __LINE__)

    ! clean up
    CALL xt_redist_delete(redist_coll)
  END SUBROUTINE simple_test2

  SUBROUTINE test_empty_redist(comm, config)
    ! general test with empty redist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    ! set up data
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_coll, redist_copy


    src_idxlist = xt_idxempty_new()
    dst_idxlist = xt_idxempty_new()

    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist, comm)

    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    redist = xt_redist_p2p_new(xmap, mpi_double_precision)
    CALL xt_xmap_delete(xmap)
    redist_copy = xt_redist_copy(redist)
    CALL xt_redist_delete(redist)
    redist = redist_copy

    ! generate redist_collection
    redist_coll = xt_redist_collection_new((/ redist /), 1, -1, comm, config)

    CALL xt_redist_delete(redist)

    ! clean up
    CALL xt_redist_delete(redist_coll)
  END SUBROUTINE test_empty_redist

  SUBROUTINE test_repeated_redist_ds(redist_coll, src_data, permutation)
    TYPE(xt_redist), INTENT(in) :: redist_coll
    DOUBLE PRECISION, INTENT(in), TARGET :: src_data(5, 3)
    INTEGER, INTENT(in) :: permutation(3)
    INTEGER :: i, j
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(3, 3) &
         = RESHAPE((/ ((DBLE(i + j), i = 1,5,2), j = 0,10,5) /), (/ 3, 3 /))
    DOUBLE PRECISION, TARGET :: dst_data(3, 3)
    TYPE(c_ptr) :: src_data_p(3), dst_data_p(3)

    INTEGER :: iexch
    TYPE(xt_request) :: request

    DO i = 1, 3
      XT_SLICE_C_LOC(src_data(:, permutation(i)), src_data_p(i))
      XT_SLICE_C_LOC(dst_data(:, permutation(i)), dst_data_p(i))
    END DO
    DO iexch = 1, 2
      dst_data = -1.0d0
      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist_coll, 3, src_data_p, dst_data_p)
      ELSE
        CALL xt_redist_a_exchange(redist_coll, 3, src_data_p, dst_data_p, &
             request)
        CALL check_wait_request(request, filename, __LINE__)
      ENDIF
      IF (cmp_arrays(ref_dst_data, dst_data)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE test_repeated_redist_ds

  SUBROUTINE test_repeated_redist(comm, config, cache_size)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    INTEGER, INTENT(in) :: cache_size
    ! test with one redist used three times (with two different input data
    ! displacements -> test of cache) (with default cache size)
    ! set up data
    INTEGER, PARAMETER :: num_slice = 3
    INTEGER, PARAMETER :: src_slice_len = 5
    INTEGER :: i
    DOUBLE PRECISION, PARAMETER :: src_data(5, num_slice) = RESHAPE((/&
         (DBLE(i), i = 1, 15)/), (/ 5, num_slice /))
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redists(num_slice), redist_coll, redist_coll_copy
    INTEGER, PARAMETER :: permutation(3, 3) &
         = RESHAPE((/ 1, 2, 3, 2, 1, 3, 1, 2, 3 /), (/ 3, 3 /))

    xmap = build_odd_selection_xmap(src_slice_len, comm)

    redists = xt_redist_p2p_new(xmap, mpi_double_precision)

    CALL xt_xmap_delete(xmap)

    ! generate redist_collection

    redist_coll = xt_redist_collection_new(redists, 3, cache_size, &
         comm, config)

    CALL xt_redist_delete(redists(1))

    DO i = 1, 3
      ! test exchange, first with simple sequence, then permuted
      ! offsets and then original offsets again
      CALL test_repeated_redist_ds(redist_coll, src_data, permutation(:, i))
    END DO

    ! and the copy
    redist_coll_copy = xt_redist_copy(redist_coll)
    CALL xt_redist_delete(redist_coll)
    DO i = 1, 3
      ! test exchange, first with simple sequence, then permuted
      ! offsets and then original offsets again
      CALL test_repeated_redist_ds(redist_coll_copy, src_data, permutation(:, i))
    END DO

    ! clean up
    CALL xt_redist_delete(redist_coll_copy)
  END SUBROUTINE test_repeated_redist

END PROGRAM test_redist_collection
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_collection_static_f.f90
!! @brief Fortran test of redist_collection_static class
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_redist_collection_static
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, &
       xt_xmap, xt_xmap_delete, &
       xt_redist, xt_redist_p2p_new, xt_redist_collection_static_new, &
       xt_redist_delete, xt_config, xt_config_delete
  USE test_redist_common, ONLY: build_odd_selection_xmap, check_redist, &
       redist_exchanger_option
  IMPLICIT NONE
  TYPE(xt_config) :: config
  CHARACTER(len=*), PARAMETER :: &
       filename = 'test_redist_collection_static_f.f90'
  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  CALL simple_test(mpi_comm_world, config)
  CALL test_repeated_redist(mpi_comm_world, config)

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi
CONTAINS
  SUBROUTINE simple_test(comm, config)
    ! general test with one redist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    ! set up data
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_coll
    INTEGER, PARAMETER :: src_slice_len = 5, dst_slice_len = 3
    DOUBLE PRECISION, PARAMETER :: &
         src_data(src_slice_len) = (/ 1.0d0, 2.0d0, 3.0d0, 4.0d0, 5.0d0 /), &
         ref_dst_data(dst_slice_len) = (/ 1.0d0, 3.0d0, 5.0d0 /)
    DOUBLE PRECISION :: dst_data(dst_slice_len)
    INTEGER(mpi_address_kind), PARAMETER :: &
         displacements(1) = 0_mpi_address_kind

    xmap = build_odd_selection_xmap(src_slice_len, comm)

    redist = xt_redist_p2p_new(xmap, mpi_double_precision)

    CALL xt_xmap_delete(xmap)

    ! generate redist_collection
    redist_coll = xt_redist_collection_static_new((/ redist /), 1, &
         displacements, displacements, comm, config)

    CALL xt_redist_delete(redist)

    ! test exchange
    CALL check_redist(redist_coll, src_data, dst_data, ref_dst_data)

    ! clean up
    CALL xt_redist_delete(redist_coll)
  END SUBROUTINE simple_test

  SUBROUTINE test_repeated_redist_ds1(redist_coll)
    TYPE(xt_redist), INTENT(in) :: redist_coll
    INTEGER :: i, j
    DOUBLE PRECISION, PARAMETER :: src_data(5, 3) &
         = RESHAPE((/ (DBLE(i), i = 1, 15)/), (/ 5, 3 /)), &
         ref_dst_data(3, 3) &
         = RESHAPE((/ ((DBLE(i + j), i = 1,5,2), j = 0,10,5) /), (/ 3, 3 /))
    DOUBLE PRECISION :: dst_data(3, 3)

    CALL check_redist(redist_coll, src_data, dst_data, ref_dst_data)
  END SUBROUTINE test_repeated_redist_ds1

  SUBROUTINE test_repeated_redist_ds2(redist_coll)
    TYPE(xt_redist), INTENT(in) :: redist_coll
    INTEGER :: i, j
    DOUBLE PRECISION, PARAMETER :: src_data(5, 3) = RESHAPE((/&
         (DBLE(i), i = 20, 34)/), (/ 5, 3 /)), &
         ref_dst_data(3, 3) &
         = RESHAPE((/ ((DBLE(i + j), i = 1,5,2), j = 19,33,5) /), (/ 3, 3 /))
    DOUBLE PRECISION, SAVE :: dst_data(3, 3)

    CALL check_redist(redist_coll, src_data, dst_data, ref_dst_data)
  END SUBROUTINE test_repeated_redist_ds2

  SUBROUTINE test_repeated_redist(comm, config)
    ! test with one redist used three times (with two different input data
    ! displacements -> test of cache) (with default cache size)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    ! set up data
    INTEGER, PARAMETER :: num_slice = 3
    INTEGER, PARAMETER :: src_slice_len = 5
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redists(num_slice), redist_coll
    INTEGER(mpi_address_kind) :: src_displacements(num_slice), &
         dst_displacements(num_slice), src_base, dst_base, temp
    DOUBLE PRECISION, TARGET :: src_template(5, 3), dst_template(3, 3)
    INTEGER :: i, ierror

    xmap = build_odd_selection_xmap(src_slice_len, comm)

    redist = xt_redist_p2p_new(xmap, mpi_double_precision)

    CALL xt_xmap_delete(xmap)

    ! generate redist_collection
    redists = redist
    src_displacements(1) = 0_mpi_address_kind
    dst_displacements(1) = 0_mpi_address_kind
    CALL mpi_get_address(src_template(1, 1), src_base, ierror)
    CALL mpi_get_address(dst_template(1, 1), dst_base, ierror)
    DO i = 2, num_slice
      CALL mpi_get_address(src_template(1, i), temp, ierror)
      src_displacements(i) = temp - src_base
      CALL mpi_get_address(dst_template(1, i), temp, ierror)
      dst_displacements(i) = temp - dst_base
    END DO

    redist_coll = xt_redist_collection_static_new(redists, num_slice, &
         src_displacements, dst_displacements, comm, config)
    CALL xt_redist_delete(redist)

    ! test exchange
    CALL test_repeated_redist_ds1(redist_coll)
    ! test exchange with changed displacements
    CALL test_repeated_redist_ds2(redist_coll)
    ! test exchange with original displacements
    CALL test_repeated_redist_ds1(redist_coll)
    ! clean up
    CALL xt_redist_delete(redist_coll)
  END SUBROUTINE test_repeated_redist

END PROGRAM test_redist_collection_static
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_p2p_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
!  Keywords:
!  Maintainer: Jörg Behrens <behrens@dkrz.de>
!              Moritz Hanke <hanke@dkrz.de>
!              Thomas Jahns <jahns@dkrz.de>
!  URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
!  Redistribution and use in source and binary forms, with or without
!  modification, are  permitted provided that the following conditions are
!  met:
!
!  Redistributions of source code must retain the above copyright notice,
!  this list of conditions and the following disclaimer.
!
!  Redistributions in binary form must reproduce the above copyright
!  notice, this list of conditions and the following disclaimer in the
!  documentation and/or other materials provided with the distribution.
!
!  Neither the name of the DKRZ GmbH nor the names of its contributors
!  may be used to endorse or promote products derived from this software
!  without specific prior written permission.
!
!  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
!  IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
!  TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
!  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
!  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
!  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
!  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
!  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
!  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
!  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_redist_p2p_f
  USE mpi
  USE yaxt, ONLY: xt_int_kind, xt_xmap, xt_idxlist, xt_redist, xt_offset_ext, &
       xi => xt_int_kind, xt_int_mpidt, xt_initialize, xt_finalize, &
       xt_idxvec_new, xt_idxlist_delete, &
       xt_redist_p2p_new, xt_redist_p2p_off_custom_new, xt_redist_p2p_ext_new, &
       xt_redist_s_exchange, &
       xt_redist_copy, xt_redist_delete,  xt_redist_get_mpi_comm, &
       xt_xmap_all2all_new, xt_xmap_delete, &
       xt_config, xt_config_delete
  ! pgfortran is in most versions well incapable of handling multiply extended
  ! generic interfaces
#ifdef __PGI
  USE xt_redist_logical, ONLY: xt_redist_s_exchange
#endif
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_redist_common, ONLY: check_redist, communicators_are_congruent, &
       redist_exchanger_option
  USE test_idxlist_utils, ONLY: test_err_count
  IMPLICIT NONE
  CHARACTER(len=*), PARAMETER :: filename = 'test_redist_p2p_f.f90'
  TYPE(xt_config) :: config

  CALL init_mpi

  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  ! offset-free test:
  ! source index list
  CALL test_without_offsets
  CALL test_with_offsets
  CALL test_offset_extents

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)

  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi

CONTAINS

  SUBROUTINE test_without_offsets
    INTEGER, PARAMETER :: src_num_indices = 14, dst_num_indices = 13
    INTEGER(xt_int_kind), PARAMETER :: src_index_list(src_num_indices) &
         = (/  5_xi, 67_xi,  4_xi,  5_xi, 13_xi, &
         &     9_xi,  2_xi,  1_xi,  0_xi, 96_xi, &
         &    13_xi, 12_xi,  1_xi,  3_xi /), &
         dst_index_list(dst_num_indices) = &
         & (/  5_xi,  4_xi,  3_xi, 96_xi,  1_xi, &
         &     5_xi,  4_xi,  5_xi,  4_xi,  3_xi, &
         &    13_xi,  2_xi,  1_xi /)
    INTEGER :: i
#ifndef __PGI
    DOUBLE PRECISION, PARAMETER :: src_data(src_num_indices) = &
         (/ (DBLE(i), i=0,src_num_indices-1) /)
#else
    ! for PGI Fortran DBLE must be evaluated at run-time
    DOUBLE PRECISION :: src_data(src_num_indices)
#endif
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(dst_num_indices) &
         = (/ 0.0d0,  2.0d0, 13.0d0,  9.0d0,  7.0d0, &
         &    0.0d0,  2.0d0,  0.0d0,  2.0d0, 13.0d0, &
         &    4.0d0,  6.0d0,  7.0d0 /)
    LOGICAL :: src_l(src_num_indices), &
         dst_l(dst_num_indices), ref_dst_l(dst_num_indices)
    DOUBLE PRECISION :: dst_data(dst_num_indices)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist_dp, redist_copy, redist_l

#ifdef __PGI
    DO i = 1, src_num_indices
      src_data(i) = DBLE(i - 1)
    END DO
#endif

    src_idxlist = xt_idxvec_new(src_index_list, src_num_indices)

    dst_idxlist = xt_idxvec_new(dst_index_list, dst_num_indices)

    ! xmap
    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist, mpi_comm_world)

    ! redist_p2p
    redist_dp = xt_redist_p2p_new(xmap, mpi_double_precision, config)

    ! test communicator of redist
    IF (.NOT. communicators_are_congruent(xt_redist_get_mpi_comm(redist_dp), &
         mpi_comm_world)) &
         CALL test_abort("error in xt_redist_get_mpi_Comm", filename, __LINE__)

    ! test exchange
    CALL check_redist(redist_dp, src_data, dst_data, ref_dst_data)

    ! repeat for logicals
    src_l = NINT(MOD(src_data, 2.0d0)) == 1
    dst_l = .FALSE.
    ref_dst_l = NINT(MOD(ref_dst_data, 2.0d0)) == 1
    redist_l = xt_redist_p2p_new(xmap, mpi_logical, config)
    IF (.NOT. communicators_are_congruent(xt_redist_get_mpi_comm(redist_l), &
         mpi_comm_world)) &
         CALL test_abort("error in xt_redist_get_mpi_Comm", filename, __LINE__)
    CALL xt_redist_s_exchange(redist_l, src_l, dst_l)
    IF (ANY(dst_l .NEQV. ref_dst_l)) &
         CALL test_abort("error in xt_redist_s_exchange for 1D logical array", &
         filename, __LINE__)
    redist_copy = xt_redist_copy(redist_dp)
    CALL xt_redist_delete(redist_dp)
    CALL check_redist(redist_copy, src_data, dst_data, ref_dst_data)

    ! clean up
    CALL xt_redist_delete(redist_copy)
    CALL xt_redist_delete(redist_l)
    CALL xt_xmap_delete(xmap)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)
  END SUBROUTINE test_without_offsets

  SUBROUTINE test_with_offsets
    ! source index list
    INTEGER, PARAMETER :: src_num = 14, dst_num = 13
    INTEGER(xt_int_kind), PARAMETER :: src_index_list(src_num) = &
         (/  5_xi, 67_xi,  4_xi,  5_xi, 13_xi, &
         &   9_xi,  2_xi,  1_xi,  0_xi, 96_xi, &
         &  13_xi, 12_xi,  1_xi,  3_xi /), &
         dst_index_list(dst_num) = &
         (/  5_xi,  4_xi,  3_xi, 96_xi,  1_xi, &
         &   5_xi,  4_xi,  5_xi,  4_xi,  3_xi, &
         &  13_xi,  2_xi,  1_xi /)
    INTEGER :: i
    INTEGER, PARAMETER :: src_pos(src_num) = (/ (i, i = 0, src_num - 1) /), &
         dst_pos(dst_num) = (/ ( dst_num - i, i = 1, dst_num ) /)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_copy
#ifndef __PGI
    DOUBLE PRECISION, PARAMETER :: src_data(src_num) = &
         (/ (DBLE(i), i=0,src_num-1) /)
#else
    ! for PGI Fortran DBLE must be evaluated at run-time
    DOUBLE PRECISION :: src_data(src_num)
#endif
    DOUBLE PRECISION :: dst_data(dst_num)
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(dst_num) = &
         (/  0.0d0,  2.0d0, 13.0d0,  9.0d0,  7.0d0, &
         &   0.0d0,  2.0d0,  0.0d0,  2.0d0, 13.0d0, &
         &   4.0d0,  6.0d0,  7.0d0 /)

#ifdef __PGI
    DO i = 1, src_num
      src_data(i) = DBLE(i - 1)
    END DO
#endif

    src_idxlist = xt_idxvec_new(src_index_list)

    dst_idxlist = xt_idxvec_new(dst_index_list, dst_num)

    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist, mpi_comm_world)

    ! redist_p2p with offsets
    redist = xt_redist_p2p_off_custom_new(xmap, src_pos, dst_pos, &
         mpi_double_precision, config)

    ! test communicator of redist
    IF (.NOT. communicators_are_congruent(xt_redist_get_mpi_comm(redist), &
         mpi_comm_world)) &
         CALL test_abort("error in xt_redist_get_MPI_Comm", filename, __LINE__)

    ! test exchange
    CALL check_redist(redist, src_data, dst_data, ref_dst_data(dst_num:1:-1))

    redist_copy = xt_redist_copy(redist)
    CALL xt_redist_delete(redist)
    CALL check_redist(redist_copy, src_data, dst_data, &
         ref_dst_data(dst_num:1:-1))

    ! clean up
    CALL xt_redist_delete(redist_copy)
    CALL xt_xmap_delete(xmap)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)
  END SUBROUTINE test_with_offsets

  SUBROUTINE test_offset_extents
    ! source/destination index lists
    INTEGER, PARAMETER :: src_num = 14, dst_num = 13
    INTEGER(xt_int_kind), PARAMETER :: src_index_list(src_num) = &
         (/  5_xi, 67_xi,  4_xi,  5_xi, 13_xi, &
         &   9_xi,  2_xi,  1_xi,  0_xi, 96_xi, &
         &  13_xi, 12_xi,  1_xi,  3_xi /), &
         dst_index_list(dst_num) = &
         (/  5_xi,  4_xi,  3_xi, 96_xi,  1_xi, &
         &   5_xi,  4_xi,  5_xi,  4_xi,  3_xi, &
         &  13_xi, 2_xi, 1_xi /)
#ifdef __G95__
    INTEGER :: i
    INTEGER(xt_int_kind), PARAMETER :: src_data(src_num) &
         = (/ (INT(i, xi), i = 0, 13) /)
#else
    INTEGER(xt_int_kind) :: i
    INTEGER(xt_int_kind), PARAMETER :: src_data(src_num) &
         = (/ (i, i = 0_xi, 13_xi) /)
#endif
    INTEGER(xt_int_kind) :: dst_data(dst_num)
    INTEGER(xt_int_kind), PARAMETER :: ref_dst_data(dst_num) = &
         (/  7_xi,  6_xi,  4_xi, 13_xi,  2_xi, &
         &   0_xi,  2_xi,  0_xi,  7_xi,  9_xi, &
         &  13_xi,  2_xi,  0_xi /)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_copy
    TYPE(xt_offset_ext), PARAMETER :: &
         src_pos(1) = (/ xt_offset_ext(0, src_num, 1) /), &
         dst_pos(1) = (/ xt_offset_ext(dst_num - 1, dst_num, -1) /)

    src_idxlist = xt_idxvec_new(src_index_list)
    dst_idxlist = xt_idxvec_new(dst_index_list)

    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist, mpi_comm_world)

    ! redist_p2p with extents of offsets
    redist = xt_redist_p2p_ext_new(xmap, src_pos, dst_pos, xt_int_mpidt, config)
    ! test communicator of redist
    IF (.NOT. communicators_are_congruent(xt_redist_get_MPI_Comm(redist), &
         mpi_comm_world)) &
         CALL test_abort("error in xt_redist_get_MPI_Comm", &
         filename, __LINE__)

    ! test exchange
    CALL check_redist(redist, src_data, dst_data, ref_dst_data)

    redist_copy = xt_redist_copy(redist)
    CALL xt_redist_delete(redist)
    CALL check_redist(redist_copy, src_data, dst_data, ref_dst_data)

    ! clean up
    CALL xt_redist_delete(redist_copy)
    CALL xt_xmap_delete(xmap)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)
  END SUBROUTINE test_offset_extents

END PROGRAM test_redist_p2p_f
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_p2p_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
!  Keywords:
!  Maintainer: Jörg Behrens <behrens@dkrz.de>
!              Moritz Hanke <hanke@dkrz.de>
!              Thomas Jahns <jahns@dkrz.de>
!  URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
!  Redistribution and use in source and binary forms, with or without
!  modification, are  permitted provided that the following conditions are
!  met:
!
!  Redistributions of source code must retain the above copyright notice,
!  this list of conditions and the following disclaimer.
!
!  Redistributions in binary form must reproduce the above copyright
!  notice, this list of conditions and the following disclaimer in the
!  documentation and/or other materials provided with the distribution.
!
!  Neither the name of the DKRZ GmbH nor the names of its contributors
!  may be used to endorse or promote products derived from this software
!  without specific prior written permission.
!
!  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
!  IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
!  TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
!  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
!  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
!  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
!  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
!  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
!  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
!  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_redist_p2p_f
  USE mpi
  USE yaxt, ONLY: xt_int_kind, xt_xmap, xt_idxlist, xt_redist, xt_offset_ext, &
       xi => xt_int_kind, xt_int_mpidt, xt_initialize, xt_finalize, &
       xt_idxvec_new, xt_idxlist_delete, &
       xt_redist_p2p_new, xt_redist_p2p_off_custom_new, xt_redist_p2p_ext_new, &
       xt_redist_s_exchange, &
       xt_redist_copy, xt_redist_delete,  xt_redist_get_mpi_comm, &
       xt_xmap_all2all_new, xt_xmap_delete, &
       xt_config, xt_config_delete, xt_config_set_ddt_cache_limit
  ! pgfortran is in most versions well incapable of handling multiply extended
  ! generic interfaces
#ifdef __PGI
  USE xt_redist_logical, ONLY: xt_redist_s_exchange
#endif
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_redist_common, ONLY: check_redist, communicators_are_congruent, &
       redist_exchanger_option
  USE test_idxlist_utils, ONLY: test_err_count
  IMPLICIT NONE
  CHARACTER(len=*), PARAMETER :: filename = 'test_redist_p2p_f.f90'
  TYPE(xt_config) :: config
  INTEGER, PARAMETER :: ddt_gen_lim(4) = (/ -1, 0, 16, -2 /)

  CALL init_mpi

  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  ! offset-free test:
  ! source index list
  CALL test_without_offsets
  CALL test_with_offsets
  CALL test_offset_extents

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)

  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi

CONTAINS

  SUBROUTINE test_without_offsets
    INTEGER, PARAMETER :: src_num_indices = 14, dst_num_indices = 13
    INTEGER(xt_int_kind), PARAMETER :: src_index_list(src_num_indices) &
         = (/  5_xi, 67_xi,  4_xi,  5_xi, 13_xi, &
         &     9_xi,  2_xi,  1_xi,  0_xi, 96_xi, &
         &    13_xi, 12_xi,  1_xi,  3_xi /), &
         dst_index_list(dst_num_indices) = &
         & (/  5_xi,  4_xi,  3_xi, 96_xi,  1_xi, &
         &     5_xi,  4_xi,  5_xi,  4_xi,  3_xi, &
         &    13_xi,  2_xi,  1_xi /)
    INTEGER :: i, ddt_gen_test
#ifndef __PGI
    DOUBLE PRECISION, PARAMETER :: src_data(src_num_indices) = &
         (/ (DBLE(i), i=0,src_num_indices-1) /)
#else
    ! for PGI Fortran DBLE must be evaluated at run-time
    DOUBLE PRECISION :: src_data(src_num_indices)
#endif
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(dst_num_indices) &
         = (/ 0.0d0,  2.0d0, 13.0d0,  9.0d0,  7.0d0, &
         &    0.0d0,  2.0d0,  0.0d0,  2.0d0, 13.0d0, &
         &    4.0d0,  6.0d0,  7.0d0 /)
    LOGICAL :: src_l(src_num_indices), &
         dst_l(dst_num_indices), ref_dst_l(dst_num_indices)
    DOUBLE PRECISION :: dst_data(dst_num_indices)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist_dp, redist_copy, redist_l

#ifdef __PGI
    DO i = 1, src_num_indices
      src_data(i) = DBLE(i - 1)
    END DO
#endif

    src_idxlist = xt_idxvec_new(src_index_list, src_num_indices)

    dst_idxlist = xt_idxvec_new(dst_index_list, dst_num_indices)

    ! xmap
    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist, mpi_comm_world)

    ! fill in data for logicals
    src_l = NINT(MOD(src_data, 2.0d0)) == 1
    ref_dst_l = NINT(MOD(ref_dst_data, 2.0d0)) == 1

    DO ddt_gen_test = 1, SIZE(ddt_gen_lim)
      CALL xt_config_set_ddt_cache_limit(config, ddt_gen_lim(ddt_gen_test))
      dst_l = .FALSE.
      ! redist_p2p
      redist_dp = xt_redist_p2p_new(xmap, mpi_double_precision, config)

      ! test communicator of redist
      IF (.NOT. communicators_are_congruent(xt_redist_get_mpi_comm(redist_dp), &
           mpi_comm_world)) &
           CALL test_abort("error in xt_redist_get_mpi_Comm", filename, __LINE__)

      ! test exchange
      CALL check_redist(redist_dp, src_data, dst_data, ref_dst_data)

      redist_l = xt_redist_p2p_new(xmap, mpi_logical, config)
      IF (.NOT. communicators_are_congruent(xt_redist_get_mpi_comm(redist_l), &
           mpi_comm_world)) &
           CALL test_abort("error in xt_redist_get_mpi_Comm", filename, __LINE__)
      CALL xt_redist_s_exchange(redist_l, src_l, dst_l)
      CALL xt_redist_delete(redist_l)
      IF (ANY(dst_l .NEQV. ref_dst_l)) &
           CALL test_abort("error in xt_redist_s_exchange for 1D logical array", &
           filename, __LINE__)
      redist_copy = xt_redist_copy(redist_dp)
      CALL xt_redist_delete(redist_dp)
      CALL check_redist(redist_copy, src_data, dst_data, ref_dst_data)
      CALL xt_redist_delete(redist_copy)
    END DO

    ! clean up
    CALL xt_xmap_delete(xmap)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)
  END SUBROUTINE test_without_offsets

  SUBROUTINE test_with_offsets
    ! source index list
    INTEGER, PARAMETER :: src_num = 14, dst_num = 13
    INTEGER(xt_int_kind), PARAMETER :: src_index_list(src_num) = &
         (/  5_xi, 67_xi,  4_xi,  5_xi, 13_xi, &
         &   9_xi,  2_xi,  1_xi,  0_xi, 96_xi, &
         &  13_xi, 12_xi,  1_xi,  3_xi /), &
         dst_index_list(dst_num) = &
         (/  5_xi,  4_xi,  3_xi, 96_xi,  1_xi, &
         &   5_xi,  4_xi,  5_xi,  4_xi,  3_xi, &
         &  13_xi,  2_xi,  1_xi /)
    INTEGER :: i, ddt_gen_test
    INTEGER, PARAMETER :: src_pos(src_num) = (/ (i, i = 0, src_num - 1) /), &
         dst_pos(dst_num) = (/ ( dst_num - i, i = 1, dst_num ) /)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_copy
#ifndef __PGI
    DOUBLE PRECISION, PARAMETER :: src_data(src_num) = &
         (/ (DBLE(i), i=0,src_num-1) /)
#else
    ! for PGI Fortran DBLE must be evaluated at run-time
    DOUBLE PRECISION :: src_data(src_num)
#endif
    DOUBLE PRECISION :: dst_data(dst_num)
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(dst_num) = &
         (/  0.0d0,  2.0d0, 13.0d0,  9.0d0,  7.0d0, &
         &   0.0d0,  2.0d0,  0.0d0,  2.0d0, 13.0d0, &
         &   4.0d0,  6.0d0,  7.0d0 /)

#ifdef __PGI
    DO i = 1, src_num
      src_data(i) = DBLE(i - 1)
    END DO
#endif

    src_idxlist = xt_idxvec_new(src_index_list)

    dst_idxlist = xt_idxvec_new(dst_index_list, dst_num)

    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist, mpi_comm_world)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    DO ddt_gen_test = 1, SIZE(ddt_gen_lim)
      CALL xt_config_set_ddt_cache_limit(config, ddt_gen_lim(ddt_gen_test))
      dst_data = -1.0d0
      ! redist_p2p with offsets
      redist = xt_redist_p2p_off_custom_new(xmap, src_pos, dst_pos, &
           mpi_double_precision, config)

      ! test communicator of redist
      IF (.NOT. communicators_are_congruent(xt_redist_get_mpi_comm(redist), &
           mpi_comm_world)) &
           CALL test_abort("error in xt_redist_get_MPI_Comm",filename,__LINE__)

      ! test exchange
      CALL check_redist(redist, src_data, dst_data, ref_dst_data(dst_num:1:-1))

      redist_copy = xt_redist_copy(redist)
      CALL xt_redist_delete(redist)
      CALL check_redist(redist_copy, src_data, dst_data, &
           ref_dst_data(dst_num:1:-1))
      CALL xt_redist_delete(redist_copy)
    END DO

    ! clean up
    CALL xt_xmap_delete(xmap)
  END SUBROUTINE test_with_offsets

  SUBROUTINE test_offset_extents
    ! source/destination index lists
    INTEGER, PARAMETER :: src_num = 14, dst_num = 13
    INTEGER(xt_int_kind), PARAMETER :: src_index_list(src_num) = &
         (/  5_xi, 67_xi,  4_xi,  5_xi, 13_xi, &
         &   9_xi,  2_xi,  1_xi,  0_xi, 96_xi, &
         &  13_xi, 12_xi,  1_xi,  3_xi /), &
         dst_index_list(dst_num) = &
         (/  5_xi,  4_xi,  3_xi, 96_xi,  1_xi, &
         &   5_xi,  4_xi,  5_xi,  4_xi,  3_xi, &
         &  13_xi, 2_xi, 1_xi /)
    INTEGER :: ddt_gen_test
#ifdef __G95__
    INTEGER :: i
    INTEGER(xt_int_kind), PARAMETER :: src_data(src_num) &
         = (/ (INT(i, xi), i = 0, 13) /)
#else
    INTEGER(xt_int_kind) :: i
    INTEGER(xt_int_kind), PARAMETER :: src_data(src_num) &
         = (/ (i, i = 0_xi, 13_xi) /)
#endif
    INTEGER(xt_int_kind) :: dst_data(dst_num)
    INTEGER(xt_int_kind), PARAMETER :: ref_dst_data(dst_num) = &
         (/  7_xi,  6_xi,  4_xi, 13_xi,  2_xi, &
         &   0_xi,  2_xi,  0_xi,  7_xi,  9_xi, &
         &  13_xi,  2_xi,  0_xi /)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_copy
    TYPE(xt_offset_ext), PARAMETER :: &
         src_pos(1) = (/ xt_offset_ext(0, src_num, 1) /), &
         dst_pos(1) = (/ xt_offset_ext(dst_num - 1, dst_num, -1) /)

    src_idxlist = xt_idxvec_new(src_index_list)
    dst_idxlist = xt_idxvec_new(dst_index_list)

    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist, mpi_comm_world)

    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    DO ddt_gen_test = 1, SIZE(ddt_gen_lim)
      CALL xt_config_set_ddt_cache_limit(config, ddt_gen_lim(ddt_gen_test))
      ! redist_p2p with extents of offsets
      redist = xt_redist_p2p_ext_new(xmap, src_pos, dst_pos, xt_int_mpidt, config)
      ! test communicator of redist
      IF (.NOT. communicators_are_congruent(xt_redist_get_MPI_Comm(redist), &
           mpi_comm_world)) &
           CALL test_abort("error in xt_redist_get_MPI_Comm", &
           filename, __LINE__)

      ! test exchange
      CALL check_redist(redist, src_data, dst_data, ref_dst_data)

      redist_copy = xt_redist_copy(redist)
      CALL xt_redist_delete(redist)
      CALL check_redist(redist_copy, src_data, dst_data, ref_dst_data)
      CALL xt_redist_delete(redist_copy)
    END DO
    ! clean up
    CALL xt_xmap_delete(xmap)
  END SUBROUTINE test_offset_extents

END PROGRAM test_redist_p2p_f
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_ut.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_ut
  USE mpi
  USE yaxt, ONLY: xt_finalize, xt_idxlist, xt_idxvec_new, xt_xmap, &
       xt_xmap_all2all_new, xt_redist, xt_redist_p2p_new, &
       xt_redist_p2p_off_new, xt_redist_s_exchange, xt_idxlist_delete, &
       xt_xmap_delete, xt_redist_delete, xt_int_kind, xt_initialize
  USE ftest_common, ONLY: icmp, id_map, factorize, regular_deco, &
       init_mpi, finish_mpi, test_abort
  USE test_redist_common, ONLY: xt_redist_s_exchange
#ifdef __PGI
  ! PGI up to at least 15.4 has a bug that prevents proper import of
  ! multiply extended generics. This is a separate bug from the one exhibited
  ! in 12.7 and older (see test_xmap_intersection_parallel_f.f90 for that)
  USE xt_redist_int_i2, ONLY: xt_redist_s_exchange
  USE xt_redist_int_i4, ONLY: xt_redist_s_exchange
  USE xt_redist_int_i8, ONLY: xt_redist_s_exchange
#endif
  IMPLICIT NONE

  ! global extents including halos
  INTEGER, PARAMETER :: g_ie = 8, g_je = 4
  LOGICAL, PARAMETER :: verbose = .FALSE.
  INTEGER, PARAMETER :: nlev = 3
  INTEGER, PARAMETER :: undef_int = g_ie * g_je * nlev + 1
  INTEGER(xt_int_kind), PARAMETER :: undef_index = -1_xt_int_kind
  INTEGER, PARAMETER :: nhalo = 1 ! 1dim. halo border size
  CHARACTER(len=*), PARAMETER :: filename = 'test_ut.f90'

  INTEGER :: ie, je ! local extents, including halos
  INTEGER :: p_ioff, p_joff ! offsets within global domain
  INTEGER :: nprocx, nprocy ! process space extents
  INTEGER :: nprocs ! == nprocx*nprocy
  ! process rank, process coords within (0:, 0:) process space
  INTEGER :: mype, mypx, mypy
  LOGICAL :: lroot ! true only for proc 0

  INTEGER(xt_int_kind) :: g_id(g_ie, g_je) ! global id

  ! global "tripolar-like" toy bounds exchange
  INTEGER(xt_int_kind) :: g_tpex(g_ie, g_je)

  INTEGER(xt_int_kind), ALLOCATABLE :: loc_id(:,:), loc_tpex(:,:)
  INTEGER, ALLOCATABLE :: fval(:,:), gval(:,:)
  INTEGER, ALLOCATABLE :: gval3d(:,:,:)
  INTEGER, ALLOCATABLE :: id_pos(:,:), pos3d_surf(:,:)
  INTEGER, ALLOCATABLE :: ref_m1(:,:)

  ! yaxt data:
  TYPE(xt_idxlist) :: start_idxlist, end_idxlist
  TYPE(xt_xmap) :: tpex_xmap
  TYPE(xt_redist) :: tpex_redist, surf_tpex_redist

  ! mpi & decomposition & allocate mem:
  CALL init_all

  ! full global index space:
  CALL id_map(g_id)

  ! local window of global index space:
  CALL get_window(g_id, loc_id)

  ! define bounds exchange for full global index space
  CALL def_exchange(g_id, g_tpex)

  ! local window of global bounds exchange:
  CALL get_window(g_tpex, loc_tpex)

  ! gen xmap: loc_id -> loc_tpex:
  start_idxlist = xt_idxvec_new(loc_id)
  end_idxlist = xt_idxvec_new(loc_tpex)
  tpex_xmap = xt_xmap_all2all_new(start_idxlist, end_idxlist, MPI_COMM_WORLD)

  ! gen transposition with default offsets:
  tpex_redist = xt_redist_p2p_new(tpex_xmap,  MPI_INTEGER)

  ! test 2d-to-2d bounds exchange:
  fval = INT(loc_id)
  gval = undef_int
  CALL xt_redist_s_exchange(tpex_redist, fval, gval)
  CALL icmp('2d to 2d check', gval, loc_tpex, mype)

  ! define positions of surface elements within (i,k,j) array
  CALL id_map(id_pos, 0)
  CALL id_map(pos3d_surf, 0)
  CALL gen_pos3d_surf(pos3d_surf)

  ! generate surface redist for (i,j)-source data and (i,k,j)-target data:
  surf_tpex_redist = xt_redist_p2p_off_new(tpex_xmap, id_pos, &
       pos3d_surf, MPI_INTEGER)

  ! test surface bounds exchange:
  gval3d = -1
  CALL xt_redist_s_exchange(surf_tpex_redist, fval, gval3d)
  CALL icmp('surface check', gval3d(:,1,:), loc_tpex, mype)

  ! check sub surface:
  ALLOCATE(ref_m1(SIZE(loc_tpex, 1), SIZE(loc_tpex, 2)))
  ref_m1 = -1
  CALL icmp('sub surface check', gval3d(:,2,:), ref_m1, mype)
  DEALLOCATE(ref_m1)

  ! cleanup:
  CALL xt_idxlist_delete(start_idxlist)
  CALL xt_idxlist_delete(end_idxlist)
  CALL xt_xmap_delete(tpex_xmap)
  CALL xt_redist_delete(surf_tpex_redist)
  CALL xt_redist_delete(tpex_redist)

  DEALLOCATE(fval, gval, loc_id, loc_tpex, id_pos, gval3d, pos3d_surf)

  ! finalize:
  CALL xt_finalize
  CALL finish_mpi

CONTAINS

  SUBROUTINE gen_pos3d_surf(pos)
    INTEGER, INTENT(inout) :: pos(:,:)
    ! positions for zero based arrays (ECHAM grid point dim order)
    ! old pos = i + j*ie
    ! new pos = i + k*ie + j*ie*nlev
    INTEGER :: ii,jj, i,j,k, p

    k = 0 ! surface
    DO jj=1,je
      DO ii=1,ie
        p = pos(ii,jj)
        j = p/ie
        i = MOD(p,ie)
        pos(ii,jj) = i + k*ie + j*ie*nlev
      ENDDO
    ENDDO

  END SUBROUTINE gen_pos3d_surf

  SUBROUTINE init_all
    CHARACTER(len=*), PARAMETER :: context = 'init_all: '
    INTEGER :: ierror

    CALL init_mpi

    CALL MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierror)
    IF (ierror /= MPI_SUCCESS) CALL test_abort(context//'MPI_COMM_SIZE failed', &
         filename, __LINE__)

    CALL MPI_COMM_RANK(MPI_COMM_WORLD, mype, ierror)
    IF (ierror /= MPI_SUCCESS) CALL test_abort(context//'MPI_COMM_RANK failed', &
         filename, __LINE__)
    IF (mype==0) THEN
      lroot = .true.
    ELSE
      lroot = .FALSE.
    ENDIF

    CALL factorize(nprocs, nprocx, nprocy)
    IF (verbose .AND. lroot) WRITE(0,*) 'nprocx, nprocy=',nprocx, nprocy
    mypy = mype / nprocx
    mypx = MOD(mype, nprocx)

    CALL xt_initialize(MPI_COMM_WORLD)

    CALL deco

    ALLOCATE(fval(ie,je), gval(ie,je))
    ALLOCATE(loc_id(ie,je), loc_tpex(ie,je))
    ALLOCATE(id_pos(ie,je), gval3d(ie,nlev,je), pos3d_surf(ie,je))

    fval = undef_int
    gval = undef_int
    loc_id = INT(undef_int, xt_int_kind)
    loc_tpex = INT(undef_int, xt_int_kind)
    id_pos = undef_int
    gval3d = undef_int
    pos3d_surf = undef_int

  END SUBROUTINE init_all

  SUBROUTINE get_window(gval, win)
    INTEGER(xt_int_kind), INTENT(in) :: gval(:,:)
    INTEGER(xt_int_kind), INTENT(out) :: win(:,:)

    INTEGER :: i, j, ig, jg

    DO j = 1, je
      jg = p_joff + j
      DO i = 1, ie
        ig = p_ioff + i
        win(i,j) =  gval(ig,jg)
      ENDDO
    ENDDO

  END SUBROUTINE get_window

  SUBROUTINE def_exchange(id_in, id_out)
    INTEGER(xt_int_kind), INTENT(in) :: id_in(:,:)
    INTEGER(xt_int_kind), INTENT(out) :: id_out(:,:)

    LOGICAL, PARAMETER :: increased_north_halo = .FALSE.
    LOGICAL, PARAMETER :: with_north_halo = .true.
    INTEGER :: i, j
    INTEGER :: g_core_is, g_core_ie, g_core_js, g_core_je
    INTEGER :: north_halo

    ! global core domain:
    g_core_is = nhalo + 1
    g_core_ie = g_ie-nhalo
    g_core_js = nhalo + 1
    g_core_je = g_je-nhalo

    ! global tripolar boundsexchange:
    id_out = undef_index
    id_out(g_core_is:g_core_ie, g_core_js:g_core_je) &
         = id_in(g_core_is:g_core_ie, g_core_js:g_core_je)

    IF (with_north_halo) THEN

      ! north inversion, (maybe with increased north halo)
      IF (increased_north_halo) THEN
        north_halo = nhalo+1
      ELSE
        north_halo = nhalo
      ENDIF

      IF (2*north_halo > g_core_je) &
           CALL test_abort('def_exchange: grid too small (or halo too large)&
           & for tripolar north exchange', &
           filename, __LINE__)
      DO j = 1, north_halo
        DO i = g_core_is, g_core_ie
          id_out(i,j) = id_out(g_core_ie + (g_core_is-i), 2*north_halo + (1-j))
        ENDDO
      ENDDO

    ELSE

      DO j = 1, nhalo
        DO i = nhalo+1, g_ie-nhalo
          id_out(i,j) = id_in(i,j)
        ENDDO
      ENDDO

    ENDIF

    ! south: no change
    DO j = g_core_je+1, g_je
      DO i = nhalo+1, g_ie-nhalo
        id_out(i,j) = id_in(i,j)
      ENDDO
    ENDDO

    ! PBC
    DO j = 1, g_je
      DO i = 1, nhalo
        id_out(g_core_is-i,j) = id_out(g_core_ie+(1-i),j)
      ENDDO
      DO i = 1, nhalo
        id_out(g_core_ie+i,j) = id_out(nhalo+i,j)
      ENDDO
    ENDDO

    CALL check_g_idx(id_out)

  END SUBROUTINE def_exchange

  SUBROUTINE check_g_idx(gidx)
    INTEGER(xt_int_kind), INTENT(in) :: gidx(:,:)

    IF (ANY(gidx == undef_index)) THEN
      CALL test_abort('check_g_idx: check failed', filename, __LINE__)
    ENDIF
  END SUBROUTINE check_g_idx

  SUBROUTINE deco
    INTEGER :: cx0(0:nprocx-1), cxn(0:nprocx-1)
    INTEGER :: cy0(0:nprocy-1), cyn(0:nprocy-1)

    CALL regular_deco(g_ie-2*nhalo, cx0, cxn)
    CALL regular_deco(g_je-2*nhalo, cy0, cyn)

    ! process local deco variables:
    ie = cxn(mypx) + 2*nhalo
    je = cyn(mypy) + 2*nhalo
    p_ioff = cx0(mypx)
    p_joff = cy0(mypy)

  END SUBROUTINE deco

END PROGRAM test_ut
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_xmap_common_parallel_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE test_xmap_common_parallel
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_int_kind, xt_stripe, &
       xi => xt_int_kind, xt_sort_int, &
       xt_idxlist, xt_idxlist_delete, xt_idxvec_new, &
       xt_idxstripes_new, xt_idxempty_new, &
       xt_xmap, xt_xmap_copy, xt_xmap_delete, &
       xt_xmap_get_num_destinations, xt_xmap_get_num_sources, &
       xt_xmap_get_destination_ranks, xt_xmap_get_source_ranks, &
       xt_xmap_get_max_dst_pos, xt_xmap_get_max_src_pos, &
       xt_xmap_update_positions, xt_xmap_spread
  IMPLICIT NONE
  PRIVATE
  PUBLIC :: xmap_parallel_test_main
  PUBLIC :: get_rank_range
  PUBLIC :: check_allgather_analog_xmap
  PUBLIC :: test_ring_1d
  PUBLIC :: test_ping_pong
  CHARACTER(len=*), PARAMETER :: filename = 'test_xmap_common_parallel_f.f90'
CONTAINS
  SUBROUTINE xmap_parallel_test_main(xmap_new)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER :: comm, comm_rank, comm_size
    INTEGER :: ierror
    CALL init_mpi
    comm = mpi_comm_world
    CALL xt_initialize(comm)
    CALL mpi_comm_rank(comm, comm_rank, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_rank", filename, __LINE__)
    CALL mpi_comm_size(comm, comm_size, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_size", filename, __LINE__)
    IF (comm_size > HUGE(1_xi)) &
         CALL test_abort("number of ranks exceeds test limit", &
         filename, __LINE__)

    CALL test_allgather_analog(xmap_new, 1, comm)
    ! repeat test for large index list that will cause stripifying
    CALL test_allgather_analog(xmap_new, 1024, comm)
    IF (comm_size > 2) CALL test_ring_1d(xmap_new, comm)
    IF (comm_size == 2) CALL test_pair(xmap_new, comm)
    IF (comm_size > 1) CALL test_ping_pong(xmap_new, comm, 0, comm_size - 1)

    ! test maxpos implementation for xt_xmap_intersection
    CALL test_maxpos(xmap_new, comm, 5)
    ! test maxpos implementation for xt_xmap_intersection_ext
    CALL test_maxpos(xmap_new, comm, 501)

    IF (test_err_count() /= 0) &
         CALL test_abort("non-zero error count!", filename, __LINE__)
    CALL xt_finalize
    CALL finish_mpi
  END SUBROUTINE xmap_parallel_test_main

  SUBROUTINE get_rank_range(comm, is_inter, comm_rank, comm_size)
    INTEGER, INTENT(inout) :: comm
    INTEGER, INTENT(out) :: comm_rank, comm_size
    LOGICAL, INTENT(out) :: is_inter
    INTEGER :: ierror

    CALL mpi_comm_rank(comm, comm_rank, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_rank", filename, __LINE__)
    CALL mpi_comm_test_inter(comm, is_inter, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_test_inter", &
         filename, __LINE__)
    IF (is_inter) THEN
      CALL mpi_comm_remote_size(comm, comm_size, ierror)
    ELSE
      CALL mpi_comm_size(comm, comm_size, ierror)
    END IF
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_(remote)_size", &
         filename, __LINE__)
  END SUBROUTINE get_rank_range

  SUBROUTINE check_allgather_analog_xmap(xmap, comm)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER, INTENT(inout) :: comm
    INTEGER, ALLOCATABLE :: ranks(:)
    INTEGER(xt_int_kind) :: i
    INTEGER :: comm_rank, comm_size
    LOGICAL :: is_inter

    CALL get_rank_range(comm, is_inter, comm_rank, comm_size)
    IF (xt_xmap_get_num_destinations(xmap) /= INT(comm_size, xi)) &
         CALL test_abort("error in xmap construction", filename, __LINE__)

    IF (xt_xmap_get_num_sources(xmap) /= INT(comm_size, xi)) &
         CALL test_abort("error in xt_xmap_get_num_sources", &
         filename, __LINE__)

    ALLOCATE(ranks(comm_size))

    CALL xt_xmap_get_destination_ranks(xmap, ranks)
    IF (ANY(ranks /= (/ (i, i=0_xi,INT(comm_size-1, xi)) /))) &
         CALL test_abort("error in xt_xmap_get_destination_ranks", &
         filename, __LINE__)

    CALL xt_xmap_get_source_ranks(xmap, ranks)
    IF (ANY(ranks /= (/ (i, i=0_xi,INT(comm_size-1, xi)) /))) &
         CALL test_abort("error in xt_xmap_get_source_ranks", &
         filename, __LINE__)
    DEALLOCATE(ranks)
  END SUBROUTINE check_allgather_analog_xmap

  SUBROUTINE test_allgather_analog(xmap_new, num_indices_per_rank, comm)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(inout) :: comm
    INTEGER, INTENT(in) :: num_indices_per_rank
    INTEGER(xi), ALLOCATABLE :: src_index_list(:)
    INTEGER(xi) :: i
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap, xmap_copy
    TYPE(xt_stripe) :: dst_index_stripe(1)
    INTEGER :: comm_size, comm_rank
    INTEGER(xi) :: comm_rank_xi, num_indices_per_rank_xi
    LOGICAL :: is_inter

    CALL get_rank_range(comm, is_inter, comm_rank, comm_size)
    comm_rank_xi = INT(comm_rank, xi)
    num_indices_per_rank_xi = INT(num_indices_per_rank, xi)
    ! setup
    ALLOCATE(src_index_list(num_indices_per_rank))
    DO i = 1_xi, num_indices_per_rank
      src_index_list(i) = comm_rank_xi * num_indices_per_rank_xi + i - 1_xi
    END DO
    src_idxlist = xt_idxvec_new(src_index_list)
    dst_index_stripe(1) = xt_stripe(0, 1, comm_size * num_indices_per_rank)
    dst_idxlist = xt_idxstripes_new(dst_index_stripe)
    xmap = xmap_new(src_idxlist, dst_idxlist, comm)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    ! verify expected results
    CALL check_allgather_analog_xmap(xmap, comm)
    xmap_copy = xt_xmap_copy(xmap)
    CALL check_allgather_analog_xmap(xmap, comm)

    ! clean up
    CALL xt_xmap_delete(xmap)
    CALL xt_xmap_delete(xmap_copy)
  END SUBROUTINE test_allgather_analog

  SUBROUTINE check_ring_xmap(xmap, dst_index_list, is_inter)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(xt_int_kind), INTENT(in) :: dst_index_list(2)
    LOGICAL, INTENT(in) :: is_inter
    INTEGER :: ranks(2), num_dst, num_src
    num_dst = xt_xmap_get_num_destinations(xmap)
    IF (.NOT. is_inter .AND. (num_dst > 2 .OR. num_dst < 1)) &
         CALL test_abort("error in xt_xmap_get_num_destinations", &
         filename, __LINE__)

    num_src = xt_xmap_get_num_sources(xmap)
    IF (num_src > 2 .OR. num_src < 1) &
         CALL test_abort("error in xt_xmap_get_num_sources", filename, __LINE__)

    IF (.NOT. is_inter) THEN
      CALL xt_xmap_get_destination_ranks(xmap, ranks)
      CALL xt_sort_int(ranks(1:num_dst))
      IF (ANY(ranks /= dst_index_list)) &
           CALL test_abort("error in xt_xmap_get_destination_ranks", &
           filename, __LINE__)
    END IF

    CALL xt_xmap_get_source_ranks(xmap, ranks)
    CALL xt_sort_int(ranks(1:num_src))
    IF (ANY(ranks /= dst_index_list)) &
         CALL test_abort("error in xt_xmap_get_source_ranks", &
         filename, __LINE__)
  END SUBROUTINE check_ring_xmap

  SUBROUTINE test_ring_1d(xmap_new, comm)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(inout) :: comm
    ! test in which each process talks WITH two other processes
    INTEGER(xt_int_kind) :: src_index_list(1), dst_index_list(2), temp
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap, xmap_copy
    INTEGER :: comm_size, comm_rank
    LOGICAL :: is_inter

    CALL get_rank_range(comm, is_inter, comm_rank, comm_size)
    src_index_list(1) = INT(comm_rank, xi)
    src_idxlist = xt_idxvec_new(src_index_list)

    ! destination index list
    dst_index_list(1) = INT(MOD(comm_rank + comm_size - 1, comm_size), xi)
    dst_index_list(2) = INT(MOD(comm_rank             + 1, comm_size), xi)
    IF (dst_index_list(1) > dst_index_list(2)) THEN
      temp = dst_index_list(1)
      dst_index_list(1) = dst_index_list(2)
      dst_index_list(2) = temp
    END IF
    dst_idxlist = xt_idxvec_new(dst_index_list, 2)

    ! test of exchange map
    xmap = xmap_new(src_idxlist, dst_idxlist, comm)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    ! test results
    CALL check_ring_xmap(xmap, dst_index_list, is_inter)
    xmap_copy = xt_xmap_copy(xmap)
    CALL check_ring_xmap(xmap_copy, dst_index_list, is_inter)

    ! clean up
    CALL xt_xmap_delete(xmap)
    CALL xt_xmap_delete(xmap_copy)

  END SUBROUTINE test_ring_1d

  SUBROUTINE test_maxpos(xmap_new, comm, indices_per_rank)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(in) :: comm
    INTEGER, INTENT(in) :: indices_per_rank
    ! first setup simple pattern of boundary exchange
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap, xmup, xmup2, xmsp
    INTEGER :: indices_for_exch
    INTEGER(xt_int_kind) :: src_index(indices_per_rank), &
         dst_index(indices_per_rank)
    INTEGER :: max_pos_src, max_pos_dst, max_pos_src_u, max_pos_dst_u, &
         max_pos_src_u2, max_pos_dst_u2, max_pos_src_s, max_pos_dst_s
    INTEGER :: comm_rank, comm_size, world_size
    INTEGER :: ierror
    INTEGER :: i, xmspread(2)
    INTEGER :: pos_update1(indices_per_rank), pos_update2(2*indices_per_rank)

    CALL mpi_comm_rank(comm, comm_rank, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_rank", filename, __LINE__)
    CALL mpi_comm_size(comm, comm_size, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_size", filename, __LINE__)

    world_size = comm_size * indices_per_rank

    ! setup
    indices_for_exch = indices_per_rank/2
    DO i = 1, indices_per_rank
      src_index(i) = INT(i-1 + comm_rank * indices_per_rank, xi)
    END DO
    DO i = 1, indices_for_exch
      dst_index(i) = INT(MOD(i - 1 - indices_for_exch &
           + (comm_rank+comm_size) * indices_per_rank, world_size), xi)
    END DO
    DO i = indices_for_exch+1, indices_per_rank-indices_for_exch
      dst_index(i) = INT(i-1 + comm_rank * indices_per_rank, xi)
    END DO
    DO i = 1, indices_for_exch
      dst_index(indices_per_rank-indices_for_exch+i) &
           = INT(MOD(i + (comm_rank+1) * indices_per_rank, world_size), xi)
    END DO
    src_idxlist = xt_idxvec_new(src_index)
    dst_idxlist = xt_idxvec_new(dst_index)

    xmap = xmap_new(src_idxlist, dst_idxlist, comm)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    ! test
    ! 1. test that initial max positions are in range
    max_pos_dst = xt_xmap_get_max_dst_pos(xmap)
    max_pos_src = xt_xmap_get_max_src_pos(xmap)
    IF (max_pos_src < indices_per_rank-1) &
         CALL test_abort("error in xt_xmap_get_max_src_pos", filename, __LINE__)
    IF (max_pos_dst < indices_per_rank-1) &
         CALL test_abort("error in xt_xmap_get_max_dst_pos", filename, __LINE__)

    ! 2. expand range and verify it is reflected in max pos
    DO i = 1,indices_per_rank
      pos_update1(i) = (i-1)*2
    END DO

    xmup = xt_xmap_update_positions(xmap, pos_update1, pos_update1)

    max_pos_dst_u = xt_xmap_get_max_dst_pos(xmup)
    max_pos_src_u = xt_xmap_get_max_src_pos(xmup)
    IF (max_pos_src_u < (indices_per_rank-1)*2) &
         CALL test_abort("error in xt_xmap_get_max_src_pos", filename, __LINE__)
    IF (max_pos_dst_u < (indices_per_rank-1)*2) &
         CALL test_abort("error in xt_xmap_get_max_dst_pos", filename, __LINE__)

    ! 3. contract range again and verify max pos is updated
    DO i = 1, indices_per_rank*2
      pos_update2(i) = (i-1)/2
    END DO
    xmup2 = xt_xmap_update_positions(xmap, pos_update2, pos_update2)

    max_pos_dst_u2 = xt_xmap_get_max_dst_pos(xmup2)
    max_pos_src_u2 = xt_xmap_get_max_src_pos(xmup2)
    IF (max_pos_src_u2 >= indices_per_rank) &
         CALL test_abort("error in xt_xmap_get_max_src_pos", filename, __LINE__)
    IF (max_pos_dst_u2 >= indices_per_rank) &
         CALL test_abort("error in xt_xmap_get_max_dst_pos", filename, __LINE__)

    ! 4. apply spread and check max pos range
    xmspread(1) = 0
    xmspread(2) = indices_per_rank*3
    xmsp = xt_xmap_spread(xmap, 2, xmspread, xmspread)
    max_pos_dst_s = xt_xmap_get_max_dst_pos(xmsp)
    max_pos_src_s = xt_xmap_get_max_src_pos(xmsp)
    IF (max_pos_dst_s < (indices_per_rank-1)*3) &
         CALL test_abort("error in xt_xmap_get_max_dst_pos", filename, __LINE__)
    IF (max_pos_src_s < (indices_per_rank-1)*3) &
         CALL test_abort("error in xt_xmap_get_max_src_pos", filename, __LINE__)

    ! cleanup
    CALL xt_xmap_delete(xmap)
    CALL xt_xmap_delete(xmup)
    CALL xt_xmap_delete(xmup2)
    CALL xt_xmap_delete(xmsp)
  END SUBROUTINE test_maxpos

  SUBROUTINE check_pair_xmap(xmap)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER :: ranks(2)
    ! test results
    IF (xt_xmap_get_num_destinations(xmap) /= 2) &
         CALL test_abort("error in xt_xmap_get_num_destinations", &
         filename, __LINE__)

    IF (xt_xmap_get_num_sources(xmap) /= 2) &
         CALL test_abort("error in xt_xmap_get_num_sources", filename, __LINE__)

    CALL xt_xmap_get_destination_ranks(xmap, ranks)
    IF (ranks(1) /= 0 .OR. ranks(2) /= 1) &
         CALL test_abort("error in xt_xmap_get_destination_ranks", &
         filename, __LINE__)

    CALL xt_xmap_get_source_ranks(xmap, ranks)
    IF (ranks(1) /= 0 .OR. ranks(2) /= 1) &
         CALL test_abort("error in xt_xmap_get_source_ranks", &
         filename, __LINE__)
  END SUBROUTINE check_pair_xmap

  SUBROUTINE test_pair(xmap_new, comm)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(in) :: comm
    !src_index_list(index, rank)
    INTEGER(xt_int_kind) :: i, j, k
#ifdef __xlC__
    INTEGER(xt_int_kind), PARAMETER :: src_index_list(20, 0:1) = RESHAPE((/ &
         &  1_xi,  2_xi,  3_xi,  4_xi,  5_xi, &
         &  9_xi, 10_xi, 11_xi, 12_xi, 13_xi, &
         & 17_xi, 18_xi, 19_xi, 20_xi, 21_xi, &
         & 25_xi, 26_xi, 27_xi, 28_xi, 29_xi, &
         &  4_xi,  5_xi,  6_xi,  7_xi,  8_xi, &
         & 12_xi, 13_xi, 14_xi, 15_xi, 16_xi, &
         & 20_xi, 21_xi, 22_xi, 23_xi, 24_xi, &
         & 28_xi, 29_xi, 30_xi, 31_xi, 32_xi /),  &
         (/ 20, 2 /))
#else
    INTEGER(xt_int_kind), PARAMETER :: src_index_list(20, 0:1) = RESHAPE((/ &
         (((i + j * 8_xi + k * 3_xi, i = 1_xi, 5_xi), j = 0_xi,3_xi), &
         k = 0_xi,1_xi) /), (/ 20, 2 /))
#endif
    ! dst_index_list(index,rank)
    INTEGER(xt_int_kind), PARAMETER :: dst_index_list(20, 0:1) = RESHAPE((/ &
         10_xi, 15_xi, 14_xi, 13_xi, 12_xi, &
         15_xi, 10_xi, 11_xi, 12_xi, 13_xi, &
         23_xi, 18_xi, 19_xi, 20_xi, 21_xi, &
         31_xi, 26_xi, 27_xi, 28_xi, 29_xi, &
         13_xi, 12_xi, 11_xi, 10_xi, 15_xi, &
         12_xi, 13_xi, 14_xi, 15_xi, 10_xi, &
         20_xi, 21_xi, 22_xi, 23_xi, 18_xi, &
         28_xi, 29_xi, 30_xi, 31_xi, 26_xi /),  &
         (/ 20, 2 /))
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap, xmap_copy
    INTEGER :: comm_rank, ierror

    CALL mpi_comm_rank(comm, comm_rank, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_rank", filename, __LINE__)

    src_idxlist = xt_idxvec_new(src_index_list(:, comm_rank))

    ! destination index list
    dst_idxlist = xt_idxvec_new(dst_index_list(:, comm_rank))

    ! test of exchange map
    xmap = xmap_new(src_idxlist, dst_idxlist, comm)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    CALL check_pair_xmap(xmap)
    xmap_copy = xt_xmap_copy(xmap)
    CALL check_pair_xmap(xmap_copy)

    ! clean up
    CALL xt_xmap_delete(xmap)
    CALL xt_xmap_delete(xmap_copy)
  END SUBROUTINE test_pair

  SUBROUTINE check_ping_pong_xmap(xmap, comm, ping_rank, pong_rank)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER, INTENT(in) :: comm, ping_rank, pong_rank
    INTEGER :: expect, dst_rank(1), src_rank(1), comm_rank, ierror
    CHARACTER(len=80) :: msg

    CALL mpi_comm_rank(comm, comm_rank, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort('error calling mpi_comm_rank', filename, __LINE__)
    WRITE (msg, '(a,i0,a)') "error in xt_xmap_get_num_destinations (rank == ", &
         comm_rank, ")"
    expect = MERGE(1, 0, comm_rank == ping_rank)
    IF (xt_xmap_get_num_destinations(xmap) /= expect) &
         CALL test_abort(msg, filename, __LINE__)

    expect = MERGE(1, 0, comm_rank == pong_rank)
    IF (xt_xmap_get_num_sources(xmap) /= expect) &
         CALL test_abort(msg, filename, __LINE__)

    IF (comm_rank == ping_rank) THEN
      CALL xt_xmap_get_destination_ranks(xmap, dst_rank)
      IF (dst_rank(1) /= pong_rank) &
           CALL test_abort("error in xt_xmap_get_destination_ranks", &
           filename, __LINE__)
    END IF
    IF (comm_rank == pong_rank) THEN
      CALL xt_xmap_get_source_ranks(xmap, src_rank)
      IF (src_rank(1) /= ping_rank) &
           CALL test_abort("error in xt_xmap_get_source_ranks", &
           filename, __LINE__)
    END IF
  END SUBROUTINE check_ping_pong_xmap

  SUBROUTINE test_ping_pong(xmap_new, comm, ping_rank, pong_rank)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(in) :: ping_rank, pong_rank
    INTEGER, INTENT(inout) :: comm
    INTEGER(xt_int_kind), PARAMETER :: &
         index_list(5) = (/ 0_xi, 1_xi, 2_xi, 3_xi, 4_xi /)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap, xmap_copy
    INTEGER :: comm_rank, comm_size
    LOGICAL :: is_inter
    CALL get_rank_range(comm, is_inter, comm_rank, comm_size)
    IF (comm_rank == ping_rank) THEN
      src_idxlist = xt_idxvec_new(index_list)
    ELSE
      src_idxlist = xt_idxempty_new()
    END IF


    IF (comm_rank == pong_rank) THEN
      dst_idxlist = xt_idxvec_new(index_list)
    ELSE
      dst_idxlist = xt_idxempty_new()
    END IF

    ! test of exchange map

    xmap = xmap_new(src_idxlist, dst_idxlist, comm)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    ! test results
    CALL check_ping_pong_xmap(xmap, comm, ping_rank, pong_rank)
    xmap_copy = xt_xmap_copy(xmap)
    CALL check_ping_pong_xmap(xmap_copy, comm, ping_rank, pong_rank)
    ! clean up
    CALL xt_xmap_delete(xmap)
    CALL xt_xmap_delete(xmap_copy)
  END SUBROUTINE test_ping_pong
END MODULE test_xmap_common_parallel
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file xt_idxstripes_f.f90
!! @brief Fortran interface to yaxt implementation
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"

!>
!! @example test_perf_stripes.f90
MODULE xt_idxstripes
  USE xt_core, ONLY: xt_stripe, i2, i4, i8, xt_abort
  USE xt_idxlist_abstract, ONLY: xt_idxlist, xt_idxlist_c2f, xt_idxlist_f2c
  USE iso_c_binding, ONLY: c_ptr, c_int
  IMPLICIT NONE
  PRIVATE
  PUBLIC :: xt_idxstripes_new
  INTERFACE xt_idxstripes_new
    MODULE PROCEDURE xt_idxstripes_new_s
    MODULE PROCEDURE xt_idxstripes_new_a1d
    MODULE PROCEDURE xt_idxstripes_new_a1d_i2
    MODULE PROCEDURE xt_idxstripes_new_a1d_i4
    MODULE PROCEDURE xt_idxstripes_new_a1d_i8
    MODULE PROCEDURE xt_idxstripes_new_a2d
    MODULE PROCEDURE xt_idxstripes_new_a2d_i2
    MODULE PROCEDURE xt_idxstripes_new_a2d_i4
    MODULE PROCEDURE xt_idxstripes_new_a2d_i8
    MODULE PROCEDURE xt_idxstripes_new_a3d
    MODULE PROCEDURE xt_idxstripes_new_a3d_i2
    MODULE PROCEDURE xt_idxstripes_new_a3d_i4
    MODULE PROCEDURE xt_idxstripes_new_a3d_i8
    MODULE PROCEDURE xt_idxstripes_new_a4d
    MODULE PROCEDURE xt_idxstripes_new_a4d_i2
    MODULE PROCEDURE xt_idxstripes_new_a4d_i4
    MODULE PROCEDURE xt_idxstripes_new_a4d_i8
    MODULE PROCEDURE xt_idxstripes_new_a5d
    MODULE PROCEDURE xt_idxstripes_new_a5d_i2
    MODULE PROCEDURE xt_idxstripes_new_a5d_i4
    MODULE PROCEDURE xt_idxstripes_new_a5d_i8
    MODULE PROCEDURE xt_idxstripes_new_a6d
    MODULE PROCEDURE xt_idxstripes_new_a6d_i2
    MODULE PROCEDURE xt_idxstripes_new_a6d_i4
    MODULE PROCEDURE xt_idxstripes_new_a6d_i8
    MODULE PROCEDURE xt_idxstripes_new_a7d
    MODULE PROCEDURE xt_idxstripes_new_a7d_i2
    MODULE PROCEDURE xt_idxstripes_new_a7d_i4
    MODULE PROCEDURE xt_idxstripes_new_a7d_i8
  END INTERFACE xt_idxstripes_new

  INTERFACE
    FUNCTION xt_idxstripes_new_c(stripes, num_stripes) &
         BIND(C, name='xt_idxstripes_new') RESULT(res_ptr)
      IMPORT:: xt_idxlist, xt_stripe, c_ptr, c_int
      IMPLICIT NONE
      TYPE(xt_stripe), INTENT(in) :: stripes(*)
      INTEGER(c_int), VALUE, INTENT(in) :: num_stripes
      TYPE(c_ptr) :: res_ptr
    END FUNCTION xt_idxstripes_new_c
  END INTERFACE

  PUBLIC :: xt_idxstripes_from_idxlist_new

  CHARACTER(len=*), PARAMETER :: filename = 'xt_idxstripes_f.f90'
CONTAINS

  FUNCTION xt_idxstripes_new_s(stripe) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripe
    TYPE(xt_idxlist) :: res

    res = xt_idxlist_c2f(xt_idxstripes_new_c((/ stripe /), 1_c_int))
  END FUNCTION xt_idxstripes_new_s

  FUNCTION xt_idxstripes_new_a1d(stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(:)
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (SIZE(stripes) > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(SIZE(stripes), c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a1d

  FUNCTION xt_idxstripes_new_a1d_i2(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(*)
    INTEGER(i2), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, &
         INT(num_stripes, c_int)))
  END FUNCTION xt_idxstripes_new_a1d_i2

  FUNCTION xt_idxstripes_new_a1d_i4(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(*)
    INTEGER(i4), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a1d_i4

  FUNCTION xt_idxstripes_new_a1d_i8(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(*)
    INTEGER(i8), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a1d_i8

  FUNCTION xt_idxstripes_new_a2d(stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(:,:)
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (SIZE(stripes) > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(SIZE(stripes), c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a2d

  FUNCTION xt_idxstripes_new_a2d_i2(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,*)
    INTEGER(i2), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, &
         INT(num_stripes, c_int)))
  END FUNCTION xt_idxstripes_new_a2d_i2

  FUNCTION xt_idxstripes_new_a2d_i4(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,*)
    INTEGER(i4), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res
    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a2d_i4

  FUNCTION xt_idxstripes_new_a2d_i8(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,*)
    INTEGER(i8), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a2d_i8

  FUNCTION xt_idxstripes_new_a3d(stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(:,:,:)
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (SIZE(stripes) > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(SIZE(stripes), c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a3d

  FUNCTION xt_idxstripes_new_a3d_i2(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,*)
    INTEGER(i2), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, &
         INT(num_stripes, c_int)))
  END FUNCTION xt_idxstripes_new_a3d_i2

  FUNCTION xt_idxstripes_new_a3d_i4(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,*)
    INTEGER(i4), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a3d_i4

  FUNCTION xt_idxstripes_new_a3d_i8(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,*)
    INTEGER(i8), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a3d_i8

  FUNCTION xt_idxstripes_new_a4d(stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(:,:,:,:)
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (SIZE(stripes) > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(SIZE(stripes), c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a4d

  FUNCTION xt_idxstripes_new_a4d_i2(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,1,*)
    INTEGER(i2), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, &
         INT(num_stripes, c_int)))
  END FUNCTION xt_idxstripes_new_a4d_i2

  FUNCTION xt_idxstripes_new_a4d_i4(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,1,*)
    INTEGER(i4), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a4d_i4

  FUNCTION xt_idxstripes_new_a4d_i8(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,1,*)
    INTEGER(i8), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a4d_i8

  FUNCTION xt_idxstripes_new_a5d(stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(:,:,:,:,:)
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (SIZE(stripes) > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(SIZE(stripes), c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a5d

  FUNCTION xt_idxstripes_new_a5d_i2(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,1,1,*)
    INTEGER(i2), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, &
         INT(num_stripes, c_int)))
  END FUNCTION xt_idxstripes_new_a5d_i2

  FUNCTION xt_idxstripes_new_a5d_i4(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,1,1,*)
    INTEGER(i4), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a5d_i4

  FUNCTION xt_idxstripes_new_a5d_i8(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,1,1,*)
    INTEGER(i8), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a5d_i8

  FUNCTION xt_idxstripes_new_a6d(stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(:,:,:,:,:,:)
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (SIZE(stripes) > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(SIZE(stripes), c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a6d

  FUNCTION xt_idxstripes_new_a6d_i2(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,1,1,1,*)
    INTEGER(i2), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, &
         INT(num_stripes, c_int)))
  END FUNCTION xt_idxstripes_new_a6d_i2

  FUNCTION xt_idxstripes_new_a6d_i4(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,1,1,1,*)
    INTEGER(i4), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a6d_i4

  FUNCTION xt_idxstripes_new_a6d_i8(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,1,1,1,*)
    INTEGER(i8), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a6d_i8

  FUNCTION xt_idxstripes_new_a7d(stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(:,:,:,:,:,:,:)
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (SIZE(stripes) > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(SIZE(stripes), c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a7d

  FUNCTION xt_idxstripes_new_a7d_i2(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,1,1,1,1,*)
    INTEGER(i2), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, &
         INT(num_stripes, c_int)))
  END FUNCTION xt_idxstripes_new_a7d_i2

  FUNCTION xt_idxstripes_new_a7d_i4(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,1,1,1,1,*)
    INTEGER(i4), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a7d_i4

  FUNCTION xt_idxstripes_new_a7d_i8(stripes, num_stripes) RESULT(res)
    TYPE(xt_stripe), INTENT(in) :: stripes(1,1,1,1,1,1,*)
    INTEGER(i8), VALUE, INTENT(in) :: num_stripes
    TYPE(xt_idxlist) :: res

    INTEGER(c_int) :: num_stripes_c

    IF (num_stripes > HUGE(num_stripes_c)) &
         CALL xt_abort("too many idxstripes elements", filename, __LINE__)
    num_stripes_c = INT(num_stripes, c_int)
    res = xt_idxlist_c2f(xt_idxstripes_new_c(stripes, num_stripes_c))
  END FUNCTION xt_idxstripes_new_a7d_i8

  FUNCTION xt_idxstripes_from_idxlist_new(idxlist_src) RESULT(idxstripes)
    TYPE(xt_idxlist), INTENT(in) :: idxlist_src
    TYPE(xt_idxlist) :: idxstripes
    INTERFACE
      FUNCTION xt_idxstripes_from_idxlist_new_c(idxlist_src) &
           BIND(c, name='xt_idxstripes_from_idxlist_new') RESULT(idxstripes)
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist_src
        TYPE(c_ptr) :: idxstripes
      END FUNCTION xt_idxstripes_from_idxlist_new_c
    END INTERFACE
    idxstripes = xt_idxlist_c2f(&
         xt_idxstripes_from_idxlist_new_c(xt_idxlist_f2c(idxlist_src)))
  END FUNCTION xt_idxstripes_from_idxlist_new

END MODULE xt_idxstripes
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_idxlist_utils_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE test_idxlist_utils
  USE yaxt, ONLY: xt_int_kind, xt_idxlist, xt_idxlist_c2f, xt_idxlist_f2c, &
       xt_stripe
  USE ftest_common, ONLY: test_abort
  USE iso_c_binding, ONLY: c_ptr, c_int, c_size_t
  IMPLICIT NONE
  PRIVATE
  INTERFACE
    FUNCTION test_err_count() BIND(c, name='test_err_count') RESULT(code)
      IMPORT :: c_int
      INTEGER(c_int) :: code
    END FUNCTION test_err_count
  END INTERFACE
  PUBLIC :: test_err_count
  PUBLIC :: check_idxlist, check_stripes, check_offsets, &
       idxlist_pack_unpack_copy, check_idxlist_copy

  CHARACTER(len=*), PARAMETER :: filename = 'test_idxlist_utils_f.f90'
CONTAINS
  SUBROUTINE check_idxlist(idxlist, ref_indices)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), INTENT(in) :: ref_indices(:)

    INTEGER :: num_ref_indices
    INTEGER(xt_int_kind) :: dummy(1)
    INTEGER(c_int) :: num_ref_indices_c

    INTERFACE
      SUBROUTINE check_idxlist_c(idxlist, ref_indices, ref_num_indices) &
           BIND(c, name='check_idxlist')
        IMPORT :: xt_int_kind, c_ptr, c_int
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
        INTEGER(xt_int_kind), INTENT(in) :: ref_indices(*)
        INTEGER(c_int), VALUE, INTENT(in) :: ref_num_indices
      END SUBROUTINE check_idxlist_c
    END INTERFACE

    num_ref_indices = SIZE(ref_indices)
    IF (num_ref_indices > 0) THEN
      num_ref_indices_c = INT(num_ref_indices, c_int)
      CALL check_idxlist_c(xt_idxlist_f2c(idxlist), ref_indices, &
           num_ref_indices_c)
    ELSE
      dummy(1) = 0_xt_int_kind
      CALL check_idxlist_c(xt_idxlist_f2c(idxlist), dummy, &
           0_c_int)
    END IF
  END SUBROUTINE check_idxlist

  SUBROUTINE check_stripes(stripes, ref_stripes)
    TYPE(xt_stripe), INTENT(in) :: stripes(:), ref_stripes(:)
    INTEGER(c_int) :: num_stripes_c, ref_num_stripes_c
    INTERFACE
      SUBROUTINE check_stripes_c(stripes, num_stripes, ref_stripes, &
           ref_num_stripes) BIND(c, name='check_stripes')
        IMPORT :: xt_stripe, c_int
        IMPLICIT NONE
        TYPE(xt_stripe), INTENT(in) :: stripes(*), ref_stripes(*)
        INTEGER(c_int), VALUE, INTENT(in) :: num_stripes, ref_num_stripes
      END SUBROUTINE check_stripes_c
    END INTERFACE

    num_stripes_c = INT(SIZE(stripes), c_int)
    ref_num_stripes_c = INT(SIZE(ref_stripes), c_int)
    CALL check_stripes_c(stripes, num_stripes_c, ref_stripes, ref_num_stripes_c)

  END SUBROUTINE check_stripes

  SUBROUTINE check_offsets(offsets_a, offsets_b)
    INTEGER(c_int), INTENT(in) :: offsets_a(:), offsets_b(:)
    INTEGER(c_size_t) :: num_offsets_c
    INTERFACE
      SUBROUTINE check_offsets_c(num_offsets, offsets_a, offsets_b) &
           BIND(c, name='check_offsets')
        IMPORT :: c_size_t, c_int
        IMPLICIT NONE
        INTEGER(c_size_t), VALUE, INTENT(in) :: num_offsets
        INTEGER(c_int), INTENT(IN) :: offsets_a(num_offsets), &
             offsets_b(num_offsets)
      END SUBROUTINE check_offsets_c
    END INTERFACE

    IF (SIZE(offsets_a) /= SIZE(offsets_b)) &
         CALL test_abort("inequal number of array elements in eq test", &
         filename, __LINE__)

    num_offsets_c = INT(SIZE(offsets_a), c_size_t)
    CALL check_offsets_c(num_offsets_c, offsets_a, offsets_b)

  END SUBROUTINE check_offsets

  FUNCTION idxlist_pack_unpack_copy(idxlist) RESULT(idxlist_copy)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    TYPE(xt_idxlist) :: idxlist_copy

    INTERFACE
      FUNCTION idxlist_pack_unpack_copy_c(idxlist) RESULT(idxlist_copy) &
           BIND(c, name='idxlist_pack_unpack_copy')
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
        TYPE(c_ptr) :: idxlist_copy
      END FUNCTION idxlist_pack_unpack_copy_c
    END INTERFACE

    idxlist_copy &
         = xt_idxlist_c2f(idxlist_pack_unpack_copy_c(xt_idxlist_f2c(idxlist)))

  END FUNCTION idxlist_pack_unpack_copy

  SUBROUTINE check_idxlist_copy(idxlist, idxlist_copy, ref_indices, ref_stripes)
    TYPE(xt_idxlist), INTENT(in) :: idxlist, idxlist_copy
    INTEGER(xt_int_kind), INTENT(in) :: ref_indices(:)
    TYPE(xt_stripe), INTENT(in) :: ref_stripes(:)
    INTEGER(c_size_t) :: num_ref_indices_c, num_ref_stripes_c
    INTERFACE
      SUBROUTINE check_idxlist_copy_c(idxlist, idxlist_copy, &
           num_ref_indices, ref_indices, &
           num_ref_stripes, ref_stripes) BIND(c, name='check_idxlist_copy')
        IMPORT :: c_size_t, c_ptr, xt_int_kind, xt_stripe
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist, idxlist_copy
        INTEGER(c_size_t), VALUE, INTENT(in) :: num_ref_indices, num_ref_stripes
        INTEGER(xt_int_kind), INTENT(in) :: ref_indices(*)
        TYPE(xt_stripe), INTENT(in) :: ref_stripes(*)
      END SUBROUTINE check_idxlist_copy_c
    END INTERFACE
    num_ref_indices_c = INT(SIZE(ref_indices), c_size_t)
    num_ref_stripes_c = INT(SIZE(ref_stripes), c_size_t)
    CALL check_idxlist_copy_c(xt_idxlist_f2c(idxlist), &
         xt_idxlist_f2c(idxlist_copy), num_ref_indices_c, ref_indices, &
         num_ref_stripes_c, ref_stripes)
  END SUBROUTINE check_idxlist_copy

END MODULE test_idxlist_utils
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file perf_xmap_create_f.f90
!!
!! Demonstrate performance impact of various choices in xmap creation.
!!
!! @copyright Copyright  (C)  2024 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Thomas Jahns <jahns@dkrz.de>
!!
!
! Keywords:
! Maintainer: Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
#define XT_UNUSED(x) IF (SIZE( (/(x)/) ) < 0) CONTINUE
MODULE perf_xmap_create_config
  USE iso_c_binding
  USE xt_xmap_intersection, ONLY: xt_com_list
  USE yaxt, ONLY: xi => xt_int_kind, xt_xmdd_bucket_gen, &
       xt_mpi_fint_kind, xt_idxlist, xt_config, xt_stripe, &
       xt_idxlist_get_max_index, xt_idxlist_get_min_index, &
       xt_idxlist_get_num_indices, xt_idxlist_delete, &
       xt_idxlist_is_stripe_conversion_profitable, &
       xt_idxsection_new, xt_idxstripes_new, xt_idxvec_new, &
       xt_is_null, xt_xmdd_bucket_gen_new, &
       xt_config_set_xmdd_bucket_gen, xt_config_set_sort_algorithm_by_id, &
       xt_config_set_mem_saving, xt_config_set_xmap_stripe_align, &
       xt_xmdd_bucket_gen_define_interface, &
       xt_xmdd_bucket_gen_comms
  ! older PGI compilers do not handle generic interface correctly
#if defined __PGI && (__PGIC__ < 12 || (__PGIC__ ==  12 && __PGIC_MINOR__ <= 10))
  USE xt_idxlist_abstract, ONLY: xt_is_null
#endif
  USE mpi
  IMPLICIT NONE
  PRIVATE
  INTEGER, PARAMETER :: pi8 =  14
  INTEGER, PUBLIC, PARAMETER :: i8 = SELECTED_INT_KIND(pi8)
  INTEGER, PUBLIC, PARAMETER :: &
       INDEX_GEN_COL_MAJOR = 0, &
       INDEX_GEN_ROW_MAJOR = 1, &
       INDEX_GEN_IDXVEC = 2, &
       INDEX_GEN_IDXSTRIPES = 3, &
       INDEX_GEN_IDXSECTION = 4
  TYPE config_settings
    TYPE(xt_xmdd_bucket_gen) :: bg
    INTEGER(xi) :: num_columns
    INTEGER(xi) :: nlev
    INTEGER :: comm_world_size, comm_world_rank, local_size
    INTEGER :: index_generation_sequence, &
         index_generation_method, &
         bucket_generation_sequence, &
         bucket_generation_method
    LOGICAL :: is_src
#ifdef HAVE_FC_ALLOCATABLE_CHARACTER
    CHARACTER(:), ALLOCATABLE :: fname_pat_src, fname_pat_dst
#else
    CHARACTER(len=1024) :: fname_pat_src, fname_pat_dst
#endif
  END TYPE config_settings
  TYPE(config_settings), SAVE :: run_config
  PUBLIC :: run_config, config_settings
  PUBLIC :: generate_3d_list
  PUBLIC :: set_custom_bucket_gen

  TYPE, BIND(c) :: custom_bucket_gen_state
    TYPE(xt_xmdd_bucket_gen_comms) :: comms
    INTEGER(xt_mpi_fint_kind) :: prev_rank_generated, &
         last_rank_generated, intra_comm_size
    TYPE(Xt_idxlist) :: prev_list
  END TYPE custom_bucket_gen_state

CONTAINS

  FUNCTION start_of_rank(rank, num_ranks, num_columns) RESULT(start_idx)
    INTEGER, INTENT(in) :: rank, num_ranks
    INTEGER(xi), INTENT(in) :: num_columns
    INTEGER(xi) :: start_idx
    start_idx = INT(INT(num_columns, i8) * INT(rank, i8) &
         &           / INT(num_ranks, i8), xi)
  END FUNCTION start_of_rank

  FUNCTION generate_3d_list(local_rank, local_size_, &
       index_generation_method, index_generation_sequence) &
       RESULT(idxlist_3d)
    INTEGER, INTENT(in) :: local_rank, local_size_, index_generation_method, &
         index_generation_sequence
    TYPE(xt_idxlist) :: idxlist_3d
    INTERFACE
      SUBROUTINE posix_abort() BIND(c, name='abort')
      END SUBROUTINE posix_abort
    END INTERFACE
    INTEGER(xi) :: start_idx, next_start_idx, local_num_columns, lev, idx
    INTEGER(xi) :: num_stripes, j
    INTEGER(xi), ALLOCATABLE :: idx3Dv(:)
    TYPE(xt_stripe), ALLOCATABLE :: idx3Ds(:)

    start_idx = start_of_rank(local_rank, local_size_, &
         INT(run_config%num_columns, xi))

    next_start_idx = start_of_rank(local_rank+1, local_size_, &
         INT(run_config%num_columns, xi))

    local_num_columns = next_start_idx - start_idx

    IF (index_generation_method == INDEX_GEN_IDXVEC) THEN
      ALLOCATE(idx3Dv(local_num_columns * run_config%nlev))

      IF (index_generation_sequence == INDEX_GEN_ROW_MAJOR) THEN
        j = 1_xi
        DO lev = 1_xi, run_config%nlev
          DO idx = 1_xi, local_num_columns
            idx3Dv(j) = start_idx + (idx-1_xi) + (lev-1_xi) * run_config%num_columns
            j = j + 1_xi
          END DO
        END DO
      ELSE IF (index_generation_sequence == INDEX_GEN_COL_MAJOR) THEN
        j = 1_xi
        DO idx = 1_xi, local_num_columns
          DO lev = 1_xi, run_config%nlev
            idx3Dv(j) = start_idx + (idx-1_xi) + (lev-1_xi) * run_config%num_columns
            j = j + 1_xi
          END DO
        END DO
      END IF
      idxlist_3d = xt_idxvec_new(idx3Dv)
    ELSE IF (index_generation_method == INDEX_GEN_IDXSTRIPES) THEN
      num_stripes = MERGE(run_config%nlev, local_num_columns, &
           index_generation_sequence == INDEX_GEN_ROW_MAJOR)
      ALLOCATE(idx3Ds(num_stripes))

      IF (index_generation_sequence == INDEX_GEN_ROW_MAJOR) THEN
        DO lev = 1_xi, run_config%nlev
          idx3Ds(lev) = xt_stripe(&
               start = start_idx + (lev-1_xi) * run_config%num_columns, &
               stride = 1_xi, &
               nstrides = INT(local_num_columns))
        END DO
      ELSE IF (index_generation_sequence == INDEX_GEN_COL_MAJOR) THEN
        DO idx = 1_xi, local_num_columns
          idx3Ds(idx) = xt_stripe(&
               start = start_idx + (idx-1_xi), &
               stride = run_config%num_columns, &
               nstrides = INT(run_config%nlev))
        END DO
      END IF
      idxlist_3d = xt_idxstripes_new(idx3Ds)
    ELSE ! IF (index_generation_method == INDEX_GEN_IDXSECTION)
      IF (index_generation_sequence == INDEX_GEN_ROW_MAJOR) THEN
        idxlist_3d = xt_idxsection_new(0_xi, &
             (/  run_config%nlev, run_config%num_columns /), &
             (/  INT(run_config%nlev), INT(local_num_columns) /), &
             (/  0_xi, start_idx /))
      ELSE
        ! currently unsupported
        CALL posix_abort()
      END IF
    END IF
  END FUNCTION generate_3d_list

  FUNCTION rank_of_column(column, num_ranks, num_columns)
    INTEGER, INTENT(in) :: num_ranks
    INTEGER(xi), INTENT(in) :: column, num_columns
    INTEGER :: rank_of_column
    rank_of_column = INT((INT(column, c_long_long) &
         &              * INT(num_ranks, c_long_long)) &
         &              / INT(num_columns, c_long_long))
  END FUNCTION rank_of_column

  FUNCTION custom_bucket_gen_init_state(gen_state_, src_idxlist, &
       dst_idxlist, config, comms, init_params) BIND(c) RESULT(stripify)

    INTEGER(c_int) :: stripify
    TYPE(c_ptr), VALUE :: gen_state_
    TYPE(xt_idxlist), VALUE, INTENT(in) :: src_idxlist, dst_idxlist
    TYPE(xt_config), VALUE, INTENT(in) :: config
    TYPE(xt_xmdd_bucket_gen_comms), INTENT(in) :: comms
    TYPE(c_ptr), VALUE, INTENT(in) :: init_params
    TYPE(xt_idxlist) :: init_prev_list

    TYPE(custom_bucket_gen_state), POINTER :: gen_state
    INTEGER :: ierror, start_rank, end_rank
    LOGICAL :: p
    INTEGER :: num_indices_src, num_indices_dst
    INTEGER(xi) :: first_column, last_column, start_src, end_src, &
         start_dst, end_dst

    XT_UNUSED(init_params)
    CALL C_F_POINTER(gen_state_, gen_state)
    gen_state%comms = comms
    CALL MPI_Comm_size(comms%intra_comm, gen_state%intra_comm_size, ierror)
    gen_state%prev_list = init_prev_list
    IF (run_config%index_generation_method == INDEX_GEN_IDXSTRIPES) THEN
      p = .TRUE.
    ELSE IF (xt_idxlist_is_stripe_conversion_profitable(&
         src_idxlist, config) > 0) THEN
      p = .TRUE.
    ELSE IF (xt_idxlist_is_stripe_conversion_profitable(&
         dst_idxlist, config) > 0) THEN
      p = .TRUE.
    ELSE
      p = .FALSE.
    END IF
    CALL mpi_allreduce(mpi_in_place, p, 1, mpi_logical, MPI_LOR, &
         comms%intra_comm, ierror)
    stripify = MERGE(1_c_int, 0_c_int, p)
    ! establish local ranges
    num_indices_src = xt_idxlist_get_num_indices(src_idxlist)
    num_indices_dst = xt_idxlist_get_num_indices(dst_idxlist)
    first_column = HUGE(first_column)
    last_column = -HUGE(last_column)
    IF (num_indices_src > 0) THEN
      start_src = xt_idxlist_get_min_index(src_idxlist)
      end_src = xt_idxlist_get_max_index(src_idxlist) &
           - (run_config%nlev - 1_xi) * INT(run_config%num_columns, xi)
      IF (start_src < first_column) first_column = start_src
      IF (end_src > last_column) last_column = end_src
    END IF
    IF (num_indices_dst > 0) THEN
      start_dst = xt_idxlist_get_min_index(dst_idxlist)
      end_dst = xt_idxlist_get_max_index(dst_idxlist) &
           - (run_config%nlev - 1_xi) * run_config%num_columns
      IF (start_dst < first_column) first_column = start_dst
      IF (end_dst > last_column) last_column = end_dst
    END IF
    start_rank = rank_of_column(first_column, gen_state%intra_comm_size, &
         INT(run_config%num_columns, xi))
    end_rank = rank_of_column(last_column, gen_state%intra_comm_size, &
         INT(run_config%num_columns, xi))
    gen_state%prev_rank_generated = start_rank-1
    gen_state%last_rank_generated = end_rank
  END FUNCTION custom_bucket_gen_init_state


  SUBROUTINE custom_bucket_gen_destroy_state(gen_state_) BIND(c)
    TYPE(c_ptr), VALUE, INTENT(in) :: gen_state_
    TYPE(custom_bucket_gen_state), POINTER :: gen_state

    CALL C_F_POINTER(gen_state_, gen_state)

    IF (.NOT. xt_is_null(gen_state%prev_list)) &
         CALL xt_idxlist_delete(gen_state%prev_list)
  END SUBROUTINE custom_bucket_gen_destroy_state

  FUNCTION custom_bucket_gen_get_intersect_max_num(&
       gen_state_, bucket_type) &
       RESULT(max_num) BIND(c)
    INTEGER(c_int) :: max_num
    TYPE(c_ptr), VALUE :: gen_state_
    INTEGER(c_int), VALUE :: bucket_type
    TYPE(custom_bucket_gen_state), POINTER :: gen_state

    XT_UNUSED(bucket_type)
    CALL C_F_POINTER(gen_state_, gen_state)
    max_num = gen_state%last_rank_generated - gen_state%prev_rank_generated
  END FUNCTION custom_bucket_gen_get_intersect_max_num

  FUNCTION custom_bucket_gen_next(gen_state_, bucket_type) &
       BIND(C) RESULT(bucket)
    TYPE(c_ptr), VALUE :: gen_state_
    INTEGER(c_int), VALUE :: bucket_type
    TYPE(xt_com_list) :: bucket
    TYPE(custom_bucket_gen_state), POINTER :: gen_state
    INTEGER :: next_rank

    XT_UNUSED(bucket_type)
    CALL C_F_POINTER(gen_state_, gen_state)
    IF (.NOT. xt_is_null(gen_state%prev_list)) &
         CALL xt_idxlist_delete(gen_state%prev_list)
    next_rank = gen_state%prev_rank_generated + 1
    gen_state%prev_rank_generated = next_rank
    bucket%rank = next_rank
    IF (next_rank <= gen_state%last_rank_generated) THEN
      bucket%list = generate_3d_list(next_rank, gen_state%intra_comm_size, &
           run_config%bucket_generation_method, &
           run_config%bucket_generation_sequence)
    END IF
    gen_state%prev_list = bucket%list
  END FUNCTION custom_bucket_gen_next

  SUBROUTINE set_custom_bucket_gen(config)
    TYPE(xt_config), INTENT(inout) :: config
    TYPE(custom_bucket_gen_state) :: dummy(2)
    INTEGER(mpi_address_kind) :: addr(2)
    INTEGER(c_size_t) :: sizeof_cbgs
    INTEGER :: ierror, i
    DO i = 1, 2
      CALL mpi_get_address(dummy(i), addr(i), ierror)
    END DO
    sizeof_cbgs = INT(addr(2) - addr(1), c_size_t)
    run_config%bg = xt_xmdd_bucket_gen_new()
    CALL xt_xmdd_bucket_gen_define_interface( &
         run_config%bg, &
         custom_bucket_gen_init_state, &
         custom_bucket_gen_destroy_state, &
         custom_bucket_gen_get_intersect_max_num, &
         custom_bucket_gen_next, &
         sizeof_cbgs, c_null_ptr)
    CALL xt_config_set_xmdd_bucket_gen(config, run_config%bg)
  END SUBROUTINE set_custom_bucket_gen

END MODULE perf_xmap_create_config

MODULE perf_xmap_create_init
  USE yaxt
  USE mpi
  USE iso_c_binding, ONLY: c_int, c_char, c_null_char
  USE perf_xmap_create_config, ONLY: config_settings, set_custom_bucket_gen, &
       index_gen_col_major, index_gen_row_major, index_gen_idxvec, &
       index_gen_idxstripes, index_gen_idxsection
  IMPLICIT NONE
  PRIVATE
  INTERFACE
    SUBROUTINE posix_exit(status) BIND(c, name='exit')
      IMPORT :: c_int
      INTEGER(c_int), VALUE, INTENT(in) :: status
    END SUBROUTINE posix_exit
  END INTERFACE
  PUBLIC :: parse_options
  PUBLIC :: read_idxlist
CONTAINS
  SUBROUTINE set_list_gen_methods(generation_sequence, generation_method, &
       arg)
    INTEGER, INTENT(inout) :: generation_sequence, generation_method
    CHARACTER(len=*), INTENT(in) :: arg

    INTEGER :: cur_parm_ofs, cur_parm_len, cur_parm_end

    cur_parm_ofs = 1
    ! split arg into comma-separated parts
    DO WHILE (cur_parm_ofs <= LEN(arg))
      cur_parm_len = SCAN(arg(cur_parm_ofs:), ",")
      IF (cur_parm_len /= 0) THEN
        cur_parm_end = cur_parm_ofs+cur_parm_len-2
      ELSE
        cur_parm_end = LEN(arg)
        cur_parm_len = cur_parm_end - cur_parm_ofs + 1
      END IF
      SELECT CASE (arg(cur_parm_ofs:cur_parm_end))
      CASE ("col-major")
        generation_sequence = INDEX_GEN_COL_MAJOR
      CASE ("row-major")
        generation_sequence = INDEX_GEN_ROW_MAJOR
      CASE ("idxvec")
        generation_method = INDEX_GEN_IDXVEC
      CASE ("idxstripes")
        generation_method = INDEX_GEN_IDXSTRIPES
      CASE ("idxsection")
        generation_method = INDEX_GEN_IDXSECTION
      CASE default
        WRITE (0, '(2a)') "error: unknown index generation method name: ", &
             arg(cur_parm_ofs:cur_parm_end)
        CALL posix_exit(1)
      END SELECT
      cur_parm_ofs = cur_parm_end &
           + MERGE(2, 1, cur_parm_end /= LEN(arg))
    END DO
  END SUBROUTINE set_list_gen_methods

  SUBROUTINE parse_options(run_config, config)
    TYPE(config_settings), INTENT(inout) :: run_config
    TYPE(xt_config), INTENT(inout) :: config

    INTERFACE
      FUNCTION xt_sort_algo_id_by_name(name) BIND(c) RESULT(rc)
        IMPORT :: c_int, c_char
        INTEGER(c_int) :: rc
        CHARACTER(kind=c_char, len=1), INTENT(in) :: name(*)
      END FUNCTION xt_sort_algo_id_by_name
    END INTERFACE
    INTEGER :: i, j, num_cmd_args, arg_len, eq_pos, opt_name_end, &
         algo, ialign, size_hamocc, ierror, optarg_len
    LOGICAL :: next_is_optarg, contradiction
    INTEGER, PARAMETER :: max_opt_arg_len = 256
    CHARACTER(max_opt_arg_len) :: opt, optarg
    CHARACTER(kind=c_char, len=1) :: optarg_c(max_opt_arg_len+1)

    num_cmd_args = COMMAND_ARGUMENT_COUNT()
    i = 1
    DO WHILE (i <= num_cmd_args)
      CALL GET_COMMAND_ARGUMENT(i, opt, arg_len, status=ierror)
      IF (ierror /= 0) THEN
        IF (arg_len > LEN(opt)) THEN
          WRITE (0, '(a,i0,a)') 'error: command-line argument (number ', &
               i, ') too long!'
        ELSE
          WRITE (0, '(2(a, i0))') 'error handling command-line argument ', i, &
               ', status=', ierror
        END IF
        CALL posix_exit(1)
      END IF
      IF (opt(1:2) == '--') THEN
        eq_pos = INDEX(opt, '=')
        IF (eq_pos /= 0) THEN
          opt_name_end = eq_pos-1
        ELSE
          opt_name_end = arg_len
        END IF
        IF (eq_pos /= 0) THEN
          optarg = opt(eq_pos+1:)
          optarg_len = arg_len-eq_pos
        ELSE IF (i < num_cmd_args) THEN
          CALL GET_COMMAND_ARGUMENT(i+1, optarg, optarg_len)
        ELSE
          optarg_len = 0
        END IF
        SELECT CASE (opt(3:opt_name_end))
        CASE ("index-generation")
          CALL set_list_gen_methods(run_config%index_generation_sequence, &
               run_config%index_generation_method, optarg(:optarg_len))
          next_is_optarg = eq_pos == 0
        CASE ("index-src-file-pat")
          IF (optarg_len == 0) THEN
            WRITE (0, '(a)') "error: invalid source list file pattern!"
            FLUSH(0)
            CALL posix_exit(1)
          END IF
#ifdef HAVE_FC_ALLOCATABLE_CHARACTER
          ALLOCATE(CHARACTER(optarg_len) :: run_config%fname_pat_src)
#endif
          run_config%fname_pat_src(1:optarg_len) = optarg(1:optarg_len)
#ifndef HAVE_FC_ALLOCATABLE_CHARACTER
          IF (optarg_len < LEN(run_config%fname_pat_src)) THEN
            run_config%fname_pat_src(optarg_len+1:) = ''
          END IF
#endif
          next_is_optarg = eq_pos == 0
        CASE ("index-dst-file-pat")
          IF (optarg_len == 0) THEN
            WRITE (0, '(a)') "error: invalid destination list file pattern!"
            FLUSH(0)
            CALL posix_exit(1)
          END IF
#ifdef HAVE_FC_ALLOCATABLE_CHARACTER
          ALLOCATE(CHARACTER(optarg_len) :: run_config%fname_pat_dst)
#endif
          run_config%fname_pat_dst(1:optarg_len) = optarg(1:optarg_len)
#ifndef HAVE_FC_ALLOCATABLE_CHARACTER
          IF (optarg_len < LEN(run_config%fname_pat_src)) THEN
            run_config%fname_pat_src(optarg_len+1:) = ''
          END IF
#endif
          next_is_optarg = eq_pos == 0
        CASE ("num-columns")
          READ (optarg, *) run_config%num_columns
          next_is_optarg = eq_pos == 0
        CASE ("nlev", "num-levels")
          READ (optarg, *) run_config%nlev
          next_is_optarg = eq_pos == 0
        CASE ("sort-algorithm")
          DO j = 1, optarg_len
            optarg_c(j) = optarg(j:j)
          END DO
          optarg_c(optarg_len+1) = c_null_char
          algo = xt_sort_algo_id_by_name(optarg_c)
          IF (algo == -1) THEN
            WRITE (0, '(2a)') "error: invalid sort algorithm name: ", &
                 optarg
            FLUSH(0)
            CALL posix_exit(1)
          END IF
          CALL xt_config_set_sort_algorithm_by_id(config, algo)
          next_is_optarg = eq_pos == 0
        CASE ("enable-mem-saving", "disable-mem-saving")
          IF (eq_pos /= 0) THEN
            WRITE (0, '(4a)') &
                 "error: invalid argument to ", TRIM(opt), ": ", &
                 optarg
            FLUSH(0)
            CALL posix_exit(1)
          END IF
          next_is_optarg = .FALSE.
          CALL xt_config_set_mem_saving(config, MERGE(1, 0, arg_len == 19))
        CASE ("enable-custom-bucket-generator")
          CALL set_custom_bucket_gen(config)
          IF (eq_pos /= 0) THEN
            CALL set_list_gen_methods(run_config%bucket_generation_sequence, &
                 run_config%bucket_generation_method, optarg)
          END IF
          next_is_optarg = .FALSE.
        CASE ("stripe-alignment-mode", &
             "disable-stripe-alignment", "enable-stripe-alignment")
          IF (opt(3:8) == 'stripe') THEN
            IF (eq_pos == 0 .AND. i == num_cmd_args) THEN
              WRITE (0, '(2a)') "error: option --stripe-alignment-mode ", &
                   "requires an argument"
              FLUSH(0)
              CALL posix_exit(1)
            END IF
            READ (optarg, *) ialign
            next_is_optarg = eq_pos == 0
          ELSE
            IF (eq_pos /= 0) THEN
              WRITE (0, '(4a)') &
                   "error: invalid argument to ", TRIM(opt),": ", &
                   optarg
              FLUSH(0)
              CALL posix_exit(1)
            END IF
            ialign = MERGE(1, 0, opt(3:4) == "en")
            next_is_optarg = .FALSE.
          END IF
          CALL xt_config_set_xmap_stripe_align(config, ialign)
        CASE DEFAULT
          WRITE (0, '(2a)') 'unrecognized command line argument: ', &
               optarg(1:arg_len)
          FLUSH(0)
          CALL posix_exit(1)
          STOP
        END SELECT
        i = i + MERGE(2, 1, next_is_optarg)
      ELSE
        EXIT
      END IF
    END DO
    IF (i <= num_cmd_args) THEN
      IF (i == num_cmd_args) THEN
        READ(opt, *, iostat=ierror) size_hamocc
        IF (ierror /= 0) THEN
          WRITE (0, '(3a, i0)') 'error reading group size ', TRIM(opt), &
               ', iostat=', ierror
          FLUSH(0)
          CALL posix_exit(1)
        END IF
      ELSE
        WRITE (0, '(a)') 'too many command line arguments:', opt(1:arg_len)
        DO i = i+1, num_cmd_args
          CALL GET_COMMAND_ARGUMENT(i, opt, arg_len)
          WRITE (0, '(a)') opt(1:arg_len)
        END DO
        CALL posix_exit(1)
      END IF
    ELSE
      size_hamocc = run_config%comm_world_size / 2
    END IF
    run_config%is_src = run_config%comm_world_rank &
         < (run_config%comm_world_size - size_hamocc)
    run_config%local_size = MERGE(run_config%comm_world_size - size_hamocc,  &
         size_hamocc, run_config%is_src)
    IF (run_config%bucket_generation_sequence == -1) &
         run_config%bucket_generation_sequence &
         = run_config%index_generation_sequence
    IF (run_config%bucket_generation_method == -1) &
         run_config%bucket_generation_method &
         = run_config%index_generation_sequence

#ifdef HAVE_FC_ALLOCATABLE_CHARACTER
    contradiction = ALLOCATED(run_config%fname_pat_src) &
         .NEQV. ALLOCATED(run_config%fname_pat_dst)
#else
    contradiction = run_config%fname_pat_src == '' &
         .NEQV. run_config%fname_pat_dst == ''
#endif
    IF (contradiction) THEN
      WRITE (0, '(3a)') "error: ", &
           "option --index-src-file-pat must be used together", &
           " with --index-dst-file-pat"
      CALL posix_exit(1)
    END IF
  END SUBROUTINE parse_options

  FUNCTION read_idxlist(idxgen_method, name_pat, subst_mpi_rank)
    INTEGER, INTENT(in) :: idxgen_method, subst_mpi_rank
    CHARACTER(len=*), INTENT(in) :: name_pat
    CHARACTER(len=LEN(name_pat)+5) :: fname
    TYPE(xt_idxlist) :: read_idxlist
    INTEGER :: ofs, num_indices, num_idx_per_line, i, last, &
         num_lines
    INTEGER :: ierror
    INTEGER, PARAMETER :: input_unit = 10
    INTEGER(xt_int_kind), ALLOCATABLE :: indices(:)
    IF (subst_mpi_rank < 0) THEN
      read_idxlist = xt_idxempty_new()
      RETURN
    END IF
    ofs = INDEX(name_pat, "%{rank}")
    IF (ofs == 0) THEN
      fname = name_pat
    ELSE
      WRITE (fname, "(a,i0,a)") name_pat(1:ofs-1), &
           subst_mpi_rank, name_pat(ofs+7:)
    END IF
    OPEN(unit=input_unit, file=fname, action="read", status="old")
    SELECT CASE (idxgen_method)
    CASE (index_gen_idxvec)
      READ(input_unit, *) num_indices, num_idx_per_line
      ALLOCATE(indices(num_indices))
      num_lines = (num_indices+num_idx_per_line-1)/num_idx_per_line
      DO i = 1, num_lines
        ofs = (i - 1) * num_idx_per_line
        last = MERGE(ofs + num_idx_per_line, num_indices, i < num_lines)
        READ(input_unit, *) indices(ofs + 1:last)
      END DO
      read_idxlist = xt_idxvec_new(indices)
    CASE default
      WRITE (0, '(a)') 'unsupported index list method selected for reading!'
      CALL mpi_abort(mpi_comm_world, 1, ierror)
    END SELECT
    CLOSE(input_unit)
  END FUNCTION read_idxlist

END MODULE perf_xmap_create_init

PROGRAM perf_xmap_create
  USE mpi
  USE yaxt, xi => xt_int_kind
  USE iso_c_binding
  USE perf_xmap_create_config
  USE perf_xmap_create_init
  IMPLICIT NONE
  TYPE(xt_config) :: conf
  TYPE(xt_idxlist) :: idxlist_3d, idxlist_empty, &
       idxlist_src, idxlist_dst
  TYPE(xt_xmap) :: xmap, reo
  DOUBLE PRECISION :: tic, dt, min, max, sum

  LOGICAL :: use_synthetic_indices
  INTEGER :: ierror

  IF (HUGE(1_xi) >= 1240000) THEN
    run_config%num_columns = INT(1240, xi)
    run_config%num_columns = run_config%num_columns * 1000_xi
  ELSE
    run_config%num_columns = 12400_xi
  END IF
  run_config%nlev = 50_xi
  run_config%index_generation_sequence = INDEX_GEN_COL_MAJOR
  run_config%index_generation_method = INDEX_GEN_IDXVEC
  run_config%bucket_generation_sequence = -1
  run_config%bucket_generation_method = -1
#ifndef HAVE_FC_ALLOCATABLE_CHARACTER
  run_config%fname_pat_src = ''
  run_config%fname_pat_dst = ''
#endif

  CALL mpi_init(ierror)
  CALL xt_initialize(mpi_comm_world)
  CALL mpi_comm_rank(mpi_comm_world, run_config%comm_world_rank, ierror)
  CALL mpi_comm_size(mpi_comm_world, run_config%comm_world_size, ierror)

  conf = xt_config_new()

  CALL parse_options(run_config, conf)

#ifdef HAVE_FC_ALLOCATABLE_CHARACTER
  use_synthetic_indices = .NOT. ALLOCATED(run_config%fname_pat_src)
#else
  use_synthetic_indices = run_config%fname_pat_src == ''
#endif
  IF (use_synthetic_indices) THEN
    idxlist_3d = generate_3d_list(&
         MOD(run_config%comm_world_rank, run_config%local_size), &
         run_config%local_size, run_config%index_generation_method, &
         run_config%index_generation_sequence)
    idxlist_empty = xt_idxempty_new()
    idxlist_src = MERGE(idxlist_3d, idxlist_empty, run_config%is_src)
    idxlist_dst = MERGE(idxlist_empty, idxlist_3d, run_config%is_src)
  ELSE
    idxlist_src = read_idxlist(run_config%index_generation_method, &
         run_config%fname_pat_src, run_config%comm_world_rank)
    idxlist_dst = read_idxlist(run_config%index_generation_method, &
         run_config%fname_pat_dst, run_config%comm_world_rank)
  END IF

  tic = mpi_wtime()

  xmap = xt_xmap_dist_dir_custom_new(&
       idxlist_src, idxlist_dst, mpi_comm_world, conf)

  dt = mpi_wtime() - tic

  reo = xt_xmap_reorder_custom(xmap, xt_reorder_recv_up, conf)

  CALL xt_xmap_delete(reo)
  CALL xt_xmap_delete(xmap)
  CALL xt_idxlist_delete(idxlist_src)
  CALL xt_idxlist_delete(idxlist_dst)

  CALL mpi_reduce(dt, min, 1, mpi_double_precision, &
       mpi_min, 0, mpi_comm_world, ierror)
  CALL mpi_reduce(dt, max, 1, mpi_double_precision, &
       mpi_max, 0, mpi_comm_world, ierror)
  CALL mpi_reduce(dt, sum, 1, mpi_double_precision, &
       mpi_sum, 0, mpi_comm_world, ierror)

  IF (run_config%comm_world_rank == 0) THEN
    WRITE (0, "(3(a,' ',es12.6,' '))") "min", min, "max", max, &
         "avg", sum / REAL(run_config%comm_world_size, KIND(1.0d0))
  END IF

  CALL xt_config_delete(conf);
  IF (.NOT. xt_is_null(run_config%bg)) &
    CALL xt_xmdd_bucket_gen_delete(run_config%bg)

  CALL xt_finalize()
  CALL MPI_Finalize(ierror)

END PROGRAM perf_xmap_create
!
! Local Variables:
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! license-project-url: "https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/"
! license-default: "bsd"
! End:
!

!>
!! @file unstruct_halo_exchange_f.f90
!! @brief Fortran example of unstructured halo exchange
!!
!! @copyright Copyright  (C)  2015 Moritz Hanke <hanke@dkrz.de>
!!
!! @author Moritz Hanke <hanke@dkrz.de>
!!

!
! Keywords:
! Maintainer: Moritz Hanke <hanke@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!

  ! This program demonstrates the halo exchange for unstructured data that is
  ! distributed among three processes. The "global" grid looks as follows
  ! (The numbers represent the indices of the corners of the grid.)
  !
  !      01------04------08------13
  !     /  \    /  \    /  \    /  \
  !    /    \  /    \  /    \  /    \
  !  00------03------07------12------17
  !    \    /  \    /  \    /  \    /
  !     \  /    \  /    \  /    \  /
  !      02------06------11------16
  !        \    /  \    /  \    /
  !         \  /    \  /    \  /
  !          05------10------15
  !            \    /  \    /
  !             \  /    \  /
  !              09------14
  !
  ! Each process has a part of this grid plus a halo around it (marked with '*').
  !
  ! Process 0 (halo points: 8, 12, 11 10, 5):
  !
  !      01------04******08
  !     /  \    /  \    *  *
  !    /    \  /    \  *    *
  !  00------03------07******12
  !    \    /  \    /  *    *
  !     \  /    \  /    *  *
  !      02------06******11
  !        *    *  *    *
  !         *  *    *  *
  !          05******10
  !
  ! Process 1 (halo points: 4, 3, 6, 10, 15):
  !
  !      04******08------13
  !     *  *    /  \    /  \
  !    *    *  /    \  /    \
  !  03******07------12------17
  !    *    *  \    /  \    /
  !     *  *    \  /    \  /
  !      06******11------16
  !        *    *  *    *
  !         *  *    *  *
  !          10******15
  !
  ! Process 2 (halo points: 3, 7, 12, 2, 16)
  !
  !      03******07******12
  !     *  *    *  *    *  *
  !    *    *  *    *  *    *
  !  02******06------11******16
  !    *    /  \    /  \    *
  !     *  /    \  /    \  *
  !      05------10------15
  !        \    /  \    /
  !         \  /    \  /
  !          09------14
#include "fc_feature_defs.inc"
PROGRAM unstruct_halo_exchang
  USE mpi
  USE yaxt, ONLY: xt_initialize, xt_finalize, &
       xt_idxlist, xt_idxvec_new, xt_idxlist_delete, &
       xt_xmap, xt_xmap_all2all_new, xt_xmap_delete, &
       xt_redist, xt_redist_p2p_off_new, xt_redist_delete, &
       xt_redist_s_exchange, xi => xt_int_kind
  ! PGI compilers do not handle generic interface correctly
#if defined __PGI && ( __PGIC__ == 15 || __PGIC__ == 14 )
  USE xt_redist_real_sp, ONLY: xt_redist_s_exchange
  USE xt_redist_real_dp, ONLY: xt_redist_s_exchange
#endif
  IMPLICIT NONE

  INTEGER :: comm_rank, comm_size
  INTEGER :: i, j, rank, ierror

  INTEGER(xi) :: local_indices(12, 0:2), idx
  INTEGER(xi) :: halo_indices(5, 0:2)
  INTEGER(xi) :: src_indices(12, 0:2), tgt_indices(5, 0:2)
  INTEGER :: src_offsets(12)
  INTEGER :: tgt_offsets(5)

  TYPE(xt_idxlist) :: src_idxlist, tgt_idxlist
  TYPE(xt_xmap) :: xmap
  TYPE(xt_redist) :: redist
  DOUBLE PRECISION :: src_data(12), tgt_data(12)

  CHARACTER(64) :: fmt

  CALL mpi_init(ierror)
  IF (ierror /= mpi_success) STOP 1
  CALL xt_initialize(mpi_comm_world)
  CALL mpi_comm_rank(mpi_comm_world, comm_rank, ierror)
  IF (ierror /= mpi_success) STOP 1
  CALL mpi_comm_size (mpi_comm_world, comm_size, ierror)
  IF (ierror /= mpi_success) STOP 1

  IF (comm_size /= 3) STOP 3

  ! create description of locally stored indices...
  local_indices(:,0) = (/    1_xi,  4_xi,  8_xi, &
       &                  0_xi,  3_xi,  7_xi, 12_xi, &
       &                     2_xi,  6_xi, 11_xi, &
       &                         5_xi, 10_xi                 /)
  local_indices(:,1) = (/    4_xi,  8_xi, 13_xi, &
       &                  3_xi,  7_xi, 12_xi, 17_xi, &
       &                     6_xi, 11_xi, 16_xi, &
       &                        10_xi, 15_xi                 /)
  local_indices(:,2) = (/    3_xi,  7_xi, 12_xi, &
       &                  2_xi,  6_xi, 11_xi, 16_xi, &
       &                     5_xi, 10_xi, 15_xi, &
       &                         9_xi, 14_xi                 /)

  ! ...and list of which of those are shadows of data "owned" by another rank
  halo_indices(:,0) = (/  8_xi, 12_xi, 11_xi, 10_xi,  5_xi /)
  halo_indices(:,1) = (/  4_xi,  3_xi,  6_xi, 10_xi, 15_xi /)
  halo_indices(:,2) = (/  3_xi,  7_xi, 12_xi,  2_xi, 16_xi /)

  DO rank = 0, comm_size - 1
    DO i = 1, SIZE(local_indices, 1)
      idx = local_indices(i, rank)
      src_indices(i, rank) = MERGE(-1_xi, idx, ANY(halo_indices(:, rank) == idx))
    END DO
    tgt_indices(:, rank) = halo_indices(:, rank)
  END DO

  ! create decomposition descriptors
  src_idxlist = xt_idxvec_new(src_indices(:,comm_rank), SIZE(src_indices, 1))
  tgt_idxlist = xt_idxvec_new(tgt_indices(:,comm_rank), SIZE(tgt_indices, 1))

  ! generate exchange map
  xmap = xt_xmap_all2all_new(src_idxlist, tgt_idxlist, mpi_comm_world)

  ! generate redistribution object
  src_offsets = (/(i, i = 0, SIZE(src_indices, 1) - 1)/)
  DO i = 1, SIZE(halo_indices, 1)
    DO j = 1, SIZE(local_indices, 1)
      IF (halo_indices(i, comm_rank) == local_indices(j, comm_rank)) &
        tgt_offsets(i) = j - 1
    END DO
  END DO
  redist = xt_redist_p2p_off_new(xmap, src_offsets, tgt_offsets, &
    &                            mpi_double_precision)

  ! prepare arrays
  src_data(:) = DBLE(src_indices(:,comm_rank))
  tgt_data(:) = DBLE(src_indices(:,comm_rank))

  fmt = '(I1, " ", A, " exchange: ", xx(I3))'
  WRITE(fmt(29:30), '(I2)') SIZE(src_data, 1)
  PRINT fmt, comm_rank, 'before', INT(src_data(:))

  ! do the exchange
  CALL xt_redist_s_exchange(redist, src_data, tgt_data)

  PRINT fmt, comm_rank, 'after ', INT(tgt_data(:))

  ! clean up
  CALL xt_redist_delete(redist)
  CALL xt_xmap_delete(xmap)
  CALL xt_idxlist_delete(tgt_idxlist)
  CALL xt_idxlist_delete(src_idxlist)

  ! finalise
  CALL xt_finalize()
  CALL mpi_finalize(ierror)
  IF (ierror /= mpi_success) STOP 1
END PROGRAM unstruct_halo_exchang
!
! Local Variables:
! coding: utf-8
! f90-continuation-indent: 5
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! license-project-url: "https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/"
! license-default: "bsd"
! End:
!

!>
!! @file perf_xmap_create_f.f90
!!
!! Demonstrate performance impact of various choices in xmap creation.
!!
!! @copyright Copyright  (C)  2024 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Thomas Jahns <jahns@dkrz.de>
!!
!
! Keywords:
! Maintainer: Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
#define XT_UNUSED(x) IF (SIZE( (/(x)/) ) < 0) CONTINUE
MODULE perf_xmap_create_config
  USE iso_c_binding
  USE xt_xmap_intersection, ONLY: xt_com_list
  USE yaxt, ONLY: xi => xt_int_kind, xt_xmdd_bucket_gen, &
       xt_mpi_fint_kind, xt_idxlist, xt_config, xt_stripe, &
       xt_idxlist_get_max_index, xt_idxlist_get_min_index, &
       xt_idxlist_get_num_indices, xt_idxlist_delete, &
       xt_idxlist_is_stripe_conversion_profitable, &
       xt_idxsection_new, xt_idxstripes_new, xt_idxvec_new, &
       xt_is_null, xt_xmdd_bucket_gen_new, &
       xt_config_set_xmdd_bucket_gen, xt_config_set_sort_algorithm_by_id, &
       xt_config_set_mem_saving, xt_config_set_xmap_stripe_align, &
       xt_xmdd_bucket_gen_define_interface, &
       xt_xmdd_bucket_gen_comms
  ! older PGI compilers do not handle generic interface correctly
#if defined __PGI && (__PGIC__ < 12 || (__PGIC__ ==  12 && __PGIC_MINOR__ <= 10))
  USE xt_idxlist_abstract, ONLY: xt_is_null
#endif
  USE mpi
  IMPLICIT NONE
  PRIVATE
  INTEGER, PARAMETER :: pi8 =  14
  INTEGER, PUBLIC, PARAMETER :: i8 = SELECTED_INT_KIND(pi8)
  INTEGER, PUBLIC, PARAMETER :: &
       INDEX_GEN_COL_MAJOR = 0, &
       INDEX_GEN_ROW_MAJOR = 1, &
       INDEX_GEN_IDXVEC = 2, &
       INDEX_GEN_IDXSTRIPES = 3, &
       INDEX_GEN_IDXSECTION = 4
  TYPE config_settings
    TYPE(xt_xmdd_bucket_gen) :: bg
    INTEGER(xi) :: num_columns
    INTEGER(xi) :: nlev
    INTEGER :: comm_world_size, comm_world_rank, local_size
    INTEGER :: index_generation_sequence, &
         index_generation_method, &
         bucket_generation_sequence, &
         bucket_generation_method
    LOGICAL :: is_src
#ifdef HAVE_FC_ALLOCATABLE_CHARACTER
    CHARACTER(:), ALLOCATABLE :: fname_pat_src, fname_pat_dst
#else
    CHARACTER(len=1024) :: fname_pat_src, fname_pat_dst
#endif
  END TYPE config_settings
  TYPE(config_settings), SAVE :: run_config
  PUBLIC :: run_config, config_settings
  PUBLIC :: generate_3d_list
  PUBLIC :: set_custom_bucket_gen

  TYPE, BIND(c) :: custom_bucket_gen_state
    TYPE(xt_xmdd_bucket_gen_comms) :: comms
    INTEGER(xt_mpi_fint_kind) :: prev_rank_generated, &
         last_rank_generated, intra_comm_size
    TYPE(Xt_idxlist) :: prev_list
  END TYPE custom_bucket_gen_state

CONTAINS

  FUNCTION start_of_rank(rank, num_ranks, num_columns) RESULT(start_idx)
    INTEGER, INTENT(in) :: rank, num_ranks
    INTEGER(xi), INTENT(in) :: num_columns
    INTEGER(xi) :: start_idx
    start_idx = INT(INT(num_columns, i8) * INT(rank, i8) &
         &           / INT(num_ranks, i8), xi)
  END FUNCTION start_of_rank

  FUNCTION generate_3d_list(local_rank, local_size_, &
       index_generation_method, index_generation_sequence) &
       RESULT(idxlist_3d)
    INTEGER, INTENT(in) :: local_rank, local_size_, index_generation_method, &
         index_generation_sequence
    TYPE(xt_idxlist) :: idxlist_3d
    INTERFACE
      SUBROUTINE posix_abort() BIND(c, name='abort')
      END SUBROUTINE posix_abort
    END INTERFACE
    INTEGER(xi) :: start_idx, next_start_idx, local_num_columns, lev, idx
    INTEGER(xi) :: num_stripes, j
    INTEGER(xi), ALLOCATABLE :: idx3Dv(:)
    TYPE(xt_stripe), ALLOCATABLE :: idx3Ds(:)

    start_idx = start_of_rank(local_rank, local_size_, &
         INT(run_config%num_columns, xi))

    next_start_idx = start_of_rank(local_rank+1, local_size_, &
         INT(run_config%num_columns, xi))

    local_num_columns = next_start_idx - start_idx

    IF (index_generation_method == INDEX_GEN_IDXVEC) THEN
      ALLOCATE(idx3Dv(local_num_columns * run_config%nlev))

      IF (index_generation_sequence == INDEX_GEN_ROW_MAJOR) THEN
        j = 1_xi
        DO lev = 1_xi, run_config%nlev
          DO idx = 1_xi, local_num_columns
            idx3Dv(j) = start_idx + (idx-1_xi) + (lev-1_xi) * run_config%num_columns
            j = j + 1_xi
          END DO
        END DO
      ELSE IF (index_generation_sequence == INDEX_GEN_COL_MAJOR) THEN
        j = 1_xi
        DO idx = 1_xi, local_num_columns
          DO lev = 1_xi, run_config%nlev
            idx3Dv(j) = start_idx + (idx-1_xi) + (lev-1_xi) * run_config%num_columns
            j = j + 1_xi
          END DO
        END DO
      END IF
      idxlist_3d = xt_idxvec_new(idx3Dv)
    ELSE IF (index_generation_method == INDEX_GEN_IDXSTRIPES) THEN
      num_stripes = MERGE(run_config%nlev, local_num_columns, &
           index_generation_sequence == INDEX_GEN_ROW_MAJOR)
      ALLOCATE(idx3Ds(num_stripes))

      IF (index_generation_sequence == INDEX_GEN_ROW_MAJOR) THEN
        DO lev = 1_xi, run_config%nlev
          idx3Ds(lev) = xt_stripe(&
               start = start_idx + (lev-1_xi) * run_config%num_columns, &
               stride = 1_xi, &
               nstrides = INT(local_num_columns))
        END DO
      ELSE IF (index_generation_sequence == INDEX_GEN_COL_MAJOR) THEN
        DO idx = 1_xi, local_num_columns
          idx3Ds(idx) = xt_stripe(&
               start = start_idx + (idx-1_xi), &
               stride = run_config%num_columns, &
               nstrides = INT(run_config%nlev))
        END DO
      END IF
      idxlist_3d = xt_idxstripes_new(idx3Ds)
    ELSE ! IF (index_generation_method == INDEX_GEN_IDXSECTION)
      IF (index_generation_sequence == INDEX_GEN_ROW_MAJOR) THEN
        idxlist_3d = xt_idxsection_new(0_xi, &
             (/  run_config%nlev, run_config%num_columns /), &
             (/  INT(run_config%nlev), INT(local_num_columns) /), &
             (/  0_xi, start_idx /))
      ELSE
        ! currently unsupported
        CALL posix_abort()
      END IF
    END IF
  END FUNCTION generate_3d_list

  FUNCTION rank_of_column(column, num_ranks, num_columns)
    INTEGER, INTENT(in) :: num_ranks
    INTEGER(xi), INTENT(in) :: column, num_columns
    INTEGER :: rank_of_column
    rank_of_column = INT((INT(column, c_long_long) &
         &              * INT(num_ranks, c_long_long)) &
         &              / INT(num_columns, c_long_long))
  END FUNCTION rank_of_column

  FUNCTION custom_bucket_gen_init_state(gen_state_, src_idxlist, &
       dst_idxlist, config, comms, init_params) BIND(c) RESULT(stripify)

    INTEGER(c_int) :: stripify
    TYPE(c_ptr), VALUE :: gen_state_
    TYPE(xt_idxlist), VALUE :: src_idxlist, dst_idxlist
    TYPE(xt_config), VALUE :: config
    TYPE(xt_xmdd_bucket_gen_comms), INTENT(in) :: comms
    TYPE(c_ptr), VALUE :: init_params
    TYPE(xt_idxlist) :: init_prev_list

    TYPE(custom_bucket_gen_state), POINTER :: gen_state
    INTEGER :: ierror, start_rank, end_rank
    LOGICAL :: p
    INTEGER :: num_indices_src, num_indices_dst
    INTEGER(xi) :: first_column, last_column, start_src, end_src, &
         start_dst, end_dst

    XT_UNUSED(init_params)
    CALL C_F_POINTER(gen_state_, gen_state)
    gen_state%comms = comms
    CALL MPI_Comm_size(comms%intra_comm, gen_state%intra_comm_size, ierror)
    gen_state%prev_list = init_prev_list
    IF (run_config%index_generation_method == INDEX_GEN_IDXSTRIPES) THEN
      p = .TRUE.
    ELSE IF (xt_idxlist_is_stripe_conversion_profitable(&
         src_idxlist, config) > 0) THEN
      p = .TRUE.
    ELSE IF (xt_idxlist_is_stripe_conversion_profitable(&
         dst_idxlist, config) > 0) THEN
      p = .TRUE.
    ELSE
      p = .FALSE.
    END IF
    CALL mpi_allreduce(mpi_in_place, p, 1, mpi_logical, MPI_LOR, &
         comms%intra_comm, ierror)
    stripify = MERGE(1_c_int, 0_c_int, p)
    ! establish local ranges
    num_indices_src = xt_idxlist_get_num_indices(src_idxlist)
    num_indices_dst = xt_idxlist_get_num_indices(dst_idxlist)
    first_column = HUGE(first_column)
    last_column = -HUGE(last_column)
    IF (num_indices_src > 0) THEN
      start_src = xt_idxlist_get_min_index(src_idxlist)
      end_src = xt_idxlist_get_max_index(src_idxlist) &
           - (run_config%nlev - 1_xi) * INT(run_config%num_columns, xi)
      IF (start_src < first_column) first_column = start_src
      IF (end_src > last_column) last_column = end_src
    END IF
    IF (num_indices_dst > 0) THEN
      start_dst = xt_idxlist_get_min_index(dst_idxlist)
      end_dst = xt_idxlist_get_max_index(dst_idxlist) &
           - (run_config%nlev - 1_xi) * run_config%num_columns
      IF (start_dst < first_column) first_column = start_dst
      IF (end_dst > last_column) last_column = end_dst
    END IF
    start_rank = rank_of_column(first_column, gen_state%intra_comm_size, &
         INT(run_config%num_columns, xi))
    end_rank = rank_of_column(last_column, gen_state%intra_comm_size, &
         INT(run_config%num_columns, xi))
    gen_state%prev_rank_generated = start_rank-1
    gen_state%last_rank_generated = end_rank
  END FUNCTION custom_bucket_gen_init_state


  SUBROUTINE custom_bucket_gen_destroy_state(gen_state_) BIND(c)
    TYPE(c_ptr), VALUE :: gen_state_
    TYPE(custom_bucket_gen_state), POINTER :: gen_state

    CALL C_F_POINTER(gen_state_, gen_state)

    IF (.NOT. xt_is_null(gen_state%prev_list)) &
         CALL xt_idxlist_delete(gen_state%prev_list)
  END SUBROUTINE custom_bucket_gen_destroy_state

  FUNCTION custom_bucket_gen_get_intersect_max_num(&
       gen_state_, bucket_type) &
       RESULT(max_num) BIND(c)
    INTEGER(c_int) :: max_num
    TYPE(c_ptr), VALUE :: gen_state_
    INTEGER(c_int), VALUE :: bucket_type
    TYPE(custom_bucket_gen_state), POINTER :: gen_state

    XT_UNUSED(bucket_type)
    CALL C_F_POINTER(gen_state_, gen_state)
    max_num = gen_state%last_rank_generated - gen_state%prev_rank_generated
  END FUNCTION custom_bucket_gen_get_intersect_max_num

  FUNCTION custom_bucket_gen_next(gen_state_, bucket_type) &
       BIND(C) RESULT(bucket)
    TYPE(c_ptr), VALUE :: gen_state_
    INTEGER(c_int), VALUE :: bucket_type
    TYPE(xt_com_list) :: bucket
    TYPE(custom_bucket_gen_state), POINTER :: gen_state
    INTEGER :: next_rank

    XT_UNUSED(bucket_type)
    CALL C_F_POINTER(gen_state_, gen_state)
    IF (.NOT. xt_is_null(gen_state%prev_list)) &
         CALL xt_idxlist_delete(gen_state%prev_list)
    next_rank = gen_state%prev_rank_generated + 1
    gen_state%prev_rank_generated = next_rank
    bucket%rank = next_rank
    IF (next_rank <= gen_state%last_rank_generated) THEN
      bucket%list = generate_3d_list(next_rank, gen_state%intra_comm_size, &
           run_config%bucket_generation_method, &
           run_config%bucket_generation_sequence)
    END IF
    gen_state%prev_list = bucket%list
  END FUNCTION custom_bucket_gen_next

  SUBROUTINE set_custom_bucket_gen(config)
    TYPE(xt_config), INTENT(inout) :: config
    TYPE(custom_bucket_gen_state) :: dummy(2)
    INTEGER(mpi_address_kind) :: addr(2)
    INTEGER(c_size_t) :: sizeof_cbgs
    INTEGER :: ierror, i
    DO i = 1, 2
      CALL mpi_get_address(dummy(i), addr(i), ierror)
    END DO
    sizeof_cbgs = INT(addr(2) - addr(1), c_size_t)
    run_config%bg = xt_xmdd_bucket_gen_new()
    CALL xt_xmdd_bucket_gen_define_interface( &
         run_config%bg, &
         custom_bucket_gen_init_state, &
         custom_bucket_gen_destroy_state, &
         custom_bucket_gen_get_intersect_max_num, &
         custom_bucket_gen_next, &
         sizeof_cbgs, c_null_ptr)
    CALL xt_config_set_xmdd_bucket_gen(config, run_config%bg)
  END SUBROUTINE set_custom_bucket_gen

END MODULE perf_xmap_create_config

MODULE perf_xmap_create_init
  USE yaxt
  USE mpi
  USE iso_c_binding, ONLY: c_int, c_char, c_null_char
  USE perf_xmap_create_config, ONLY: config_settings, set_custom_bucket_gen, &
       index_gen_col_major, index_gen_row_major, index_gen_idxvec, &
       index_gen_idxstripes, index_gen_idxsection
  IMPLICIT NONE
  PRIVATE
  INTERFACE
    SUBROUTINE posix_exit(status) BIND(c, name='exit')
      IMPORT :: c_int
      INTEGER(c_int), VALUE, INTENT(in) :: status
    END SUBROUTINE posix_exit
  END INTERFACE
  PUBLIC :: parse_options
  PUBLIC :: read_idxlist
CONTAINS
  SUBROUTINE set_list_gen_methods(generation_sequence, generation_method, &
       arg)
    INTEGER, INTENT(inout) :: generation_sequence, generation_method
    CHARACTER(len=*), INTENT(in) :: arg

    INTEGER :: cur_parm_ofs, cur_parm_len, cur_parm_end

    cur_parm_ofs = 1
    ! split arg into comma-separated parts
    DO WHILE (cur_parm_ofs <= LEN(arg))
      cur_parm_len = SCAN(arg(cur_parm_ofs:), ",")
      IF (cur_parm_len /= 0) THEN
        cur_parm_end = cur_parm_ofs+cur_parm_len-2
      ELSE
        cur_parm_end = LEN(arg)
        cur_parm_len = cur_parm_end - cur_parm_ofs + 1
      END IF
      SELECT CASE (arg(cur_parm_ofs:cur_parm_end))
      CASE ("col-major")
        generation_sequence = INDEX_GEN_COL_MAJOR
      CASE ("row-major")
        generation_sequence = INDEX_GEN_ROW_MAJOR
      CASE ("idxvec")
        generation_method = INDEX_GEN_IDXVEC
      CASE ("idxstripes")
        generation_method = INDEX_GEN_IDXSTRIPES
      CASE ("idxsection")
        generation_method = INDEX_GEN_IDXSECTION
      CASE default
        WRITE (0, '(2a)') "error: unknown index generation method name: ", &
             arg(cur_parm_ofs:cur_parm_end)
        CALL posix_exit(1)
      END SELECT
      cur_parm_ofs = cur_parm_end &
           + MERGE(2, 1, cur_parm_end /= LEN(arg))
    END DO
  END SUBROUTINE set_list_gen_methods

  SUBROUTINE parse_options(run_config, config)
    TYPE(config_settings), INTENT(inout) :: run_config
    TYPE(xt_config), INTENT(inout) :: config

    INTERFACE
      FUNCTION xt_sort_algo_id_by_name(name) BIND(c) RESULT(rc)
        IMPORT :: c_int, c_char
        INTEGER(c_int) :: rc
        CHARACTER(kind=c_char, len=1), INTENT(in) :: name(*)
      END FUNCTION xt_sort_algo_id_by_name
    END INTERFACE
    INTEGER :: i, j, num_cmd_args, arg_len, eq_pos, opt_name_end, &
         algo, ialign, size_hamocc, ierror, optarg_len
    LOGICAL :: next_is_optarg, contradiction
    INTEGER, PARAMETER :: max_opt_arg_len = 256
    CHARACTER(max_opt_arg_len) :: opt, optarg
    CHARACTER(kind=c_char, len=1) :: optarg_c(max_opt_arg_len+1)

    num_cmd_args = COMMAND_ARGUMENT_COUNT()
    i = 1
    DO WHILE (i <= num_cmd_args)
      CALL GET_COMMAND_ARGUMENT(i, opt, arg_len, status=ierror)
      IF (ierror /= 0) THEN
        IF (arg_len > LEN(opt)) THEN
          WRITE (0, '(a,i0,a)') 'error: command-line argument (number ', &
               i, ') too long!'
        ELSE
          WRITE (0, '(2(a, i0))') 'error handling command-line argument ', i, &
               ', status=', ierror
        END IF
        CALL posix_exit(1)
      END IF
      IF (opt(1:2) == '--') THEN
        eq_pos = INDEX(opt, '=')
        IF (eq_pos /= 0) THEN
          opt_name_end = eq_pos-1
        ELSE
          opt_name_end = arg_len
        END IF
        IF (eq_pos /= 0) THEN
          optarg = opt(eq_pos+1:)
          optarg_len = arg_len-eq_pos
        ELSE IF (i < num_cmd_args) THEN
          CALL GET_COMMAND_ARGUMENT(i+1, optarg, optarg_len)
        ELSE
          optarg_len = 0
        END IF
        SELECT CASE (opt(3:opt_name_end))
        CASE ("index-generation")
          CALL set_list_gen_methods(run_config%index_generation_sequence, &
               run_config%index_generation_method, optarg(:optarg_len))
          next_is_optarg = eq_pos == 0
        CASE ("index-src-file-pat")
          IF (optarg_len == 0) THEN
            WRITE (0, '(a)') "error: invalid source list file pattern!"
            FLUSH(0)
            CALL posix_exit(1)
          END IF
#ifdef HAVE_FC_ALLOCATABLE_CHARACTER
          ALLOCATE(CHARACTER(optarg_len) :: run_config%fname_pat_src)
#endif
          run_config%fname_pat_src(1:optarg_len) = optarg(1:optarg_len)
#ifndef HAVE_FC_ALLOCATABLE_CHARACTER
          IF (optarg_len < LEN(run_config%fname_pat_src)) THEN
            run_config%fname_pat_src(optarg_len+1:) = ''
          END IF
#endif
          next_is_optarg = eq_pos == 0
        CASE ("index-dst-file-pat")
          IF (optarg_len == 0) THEN
            WRITE (0, '(a)') "error: invalid destination list file pattern!"
            FLUSH(0)
            CALL posix_exit(1)
          END IF
#ifdef HAVE_FC_ALLOCATABLE_CHARACTER
          ALLOCATE(CHARACTER(optarg_len) :: run_config%fname_pat_dst)
#endif
          run_config%fname_pat_dst(1:optarg_len) = optarg(1:optarg_len)
#ifndef HAVE_FC_ALLOCATABLE_CHARACTER
          IF (optarg_len < LEN(run_config%fname_pat_src)) THEN
            run_config%fname_pat_src(optarg_len+1:) = ''
          END IF
#endif
          next_is_optarg = eq_pos == 0
        CASE ("num-columns")
          READ (optarg, *) run_config%num_columns
          next_is_optarg = eq_pos == 0
        CASE ("nlev", "num-levels")
          READ (optarg, *) run_config%nlev
          next_is_optarg = eq_pos == 0
        CASE ("sort-algorithm")
          DO j = 1, optarg_len
            optarg_c(j) = optarg(j:j)
          END DO
          optarg_c(optarg_len+1) = c_null_char
          algo = xt_sort_algo_id_by_name(optarg_c)
          IF (algo == -1) THEN
            WRITE (0, '(2a)') "error: invalid sort algorithm name: ", &
                 optarg
            FLUSH(0)
            CALL posix_exit(1)
          END IF
          CALL xt_config_set_sort_algorithm_by_id(config, algo)
          next_is_optarg = eq_pos == 0
        CASE ("enable-mem-saving", "disable-mem-saving")
          IF (eq_pos /= 0) THEN
            WRITE (0, '(4a)') &
                 "error: invalid argument to ", TRIM(opt), ": ", &
                 optarg
            FLUSH(0)
            CALL posix_exit(1)
          END IF
          next_is_optarg = .FALSE.
          CALL xt_config_set_mem_saving(config, MERGE(1, 0, arg_len == 19))
        CASE ("enable-custom-bucket-generator")
          CALL set_custom_bucket_gen(config)
          IF (eq_pos /= 0) THEN
            CALL set_list_gen_methods(run_config%bucket_generation_sequence, &
                 run_config%bucket_generation_method, optarg)
          END IF
          next_is_optarg = .FALSE.
        CASE ("stripe-alignment-mode", &
             "disable-stripe-alignment", "enable-stripe-alignment")
          IF (opt(3:8) == 'stripe') THEN
            IF (eq_pos == 0 .AND. i == num_cmd_args) THEN
              WRITE (0, '(2a)') "error: option --stripe-alignment-mode ", &
                   "requires an argument"
              FLUSH(0)
              CALL posix_exit(1)
            END IF
            READ (optarg, *) ialign
            next_is_optarg = eq_pos == 0
          ELSE
            IF (eq_pos /= 0) THEN
              WRITE (0, '(4a)') &
                   "error: invalid argument to ", TRIM(opt),": ", &
                   optarg
              FLUSH(0)
              CALL posix_exit(1)
            END IF
            ialign = MERGE(1, 0, opt(3:4) == "en")
            next_is_optarg = .FALSE.
          END IF
          CALL xt_config_set_xmap_stripe_align(config, ialign)
        CASE DEFAULT
          WRITE (0, '(2a)') 'unrecognized command line argument: ', &
               optarg(1:arg_len)
          FLUSH(0)
          CALL posix_exit(1)
          STOP
        END SELECT
        i = i + MERGE(2, 1, next_is_optarg)
      ELSE
        EXIT
      END IF
    END DO
    IF (i <= num_cmd_args) THEN
      IF (i == num_cmd_args) THEN
        READ(opt, *, iostat=ierror) size_hamocc
        IF (ierror /= 0) THEN
          WRITE (0, '(3a, i0)') 'error reading group size ', TRIM(opt), &
               ', iostat=', ierror
          FLUSH(0)
          CALL posix_exit(1)
        END IF
      ELSE
        WRITE (0, '(a)') 'too many command line arguments:', opt(1:arg_len)
        DO i = i+1, num_cmd_args
          CALL GET_COMMAND_ARGUMENT(i, opt, arg_len)
          WRITE (0, '(a)') opt(1:arg_len)
        END DO
        CALL posix_exit(1)
      END IF
    ELSE
      size_hamocc = run_config%comm_world_size / 2
    END IF
    run_config%is_src = run_config%comm_world_rank &
         < (run_config%comm_world_size - size_hamocc)
    run_config%local_size = MERGE(run_config%comm_world_size - size_hamocc,  &
         size_hamocc, run_config%is_src)
    IF (run_config%bucket_generation_sequence == -1) &
         run_config%bucket_generation_sequence &
         = run_config%index_generation_sequence
    IF (run_config%bucket_generation_method == -1) &
         run_config%bucket_generation_method &
         = run_config%index_generation_sequence

#ifdef HAVE_FC_ALLOCATABLE_CHARACTER
    contradiction = ALLOCATED(run_config%fname_pat_src) &
         .NEQV. ALLOCATED(run_config%fname_pat_dst)
#else
    contradiction = run_config%fname_pat_src == '' &
         .NEQV. run_config%fname_pat_dst == ''
#endif
    IF (contradiction) THEN
      WRITE (0, '(3a)') "error: ", &
           "option --index-src-file-pat must be used together", &
           " with --index-dst-file-pat"
      CALL posix_exit(1)
    END IF
  END SUBROUTINE parse_options

  FUNCTION read_idxlist(idxgen_method, name_pat, subst_mpi_rank)
    INTEGER, INTENT(in) :: idxgen_method, subst_mpi_rank
    CHARACTER(len=*), INTENT(in) :: name_pat
    CHARACTER(len=LEN(name_pat)+5) :: fname
    TYPE(xt_idxlist) :: read_idxlist
    INTEGER :: ofs, num_indices, num_idx_per_line, i, last, &
         num_lines
    INTEGER :: ierror
    INTEGER, PARAMETER :: input_unit = 10
    INTEGER(xt_int_kind), ALLOCATABLE :: indices(:)
    IF (subst_mpi_rank < 0) THEN
      read_idxlist = xt_idxempty_new()
      RETURN
    END IF
    ofs = INDEX(name_pat, "%{rank}")
    IF (ofs == 0) THEN
      fname = name_pat
    ELSE
      WRITE (fname, "(a,i0,a)") name_pat(1:ofs-1), &
           subst_mpi_rank, name_pat(ofs+7:)
    END IF
    OPEN(unit=input_unit, file=fname, action="read", status="old")
    SELECT CASE (idxgen_method)
    CASE (index_gen_idxvec)
      READ(input_unit, *) num_indices, num_idx_per_line
      ALLOCATE(indices(num_indices))
      num_lines = (num_indices+num_idx_per_line-1)/num_idx_per_line
      DO i = 1, num_lines
        ofs = (i - 1) * num_idx_per_line
        last = MERGE(ofs + num_idx_per_line, num_indices, i < num_lines)
        READ(input_unit, *) indices(ofs + 1:last)
      END DO
      read_idxlist = xt_idxvec_new(indices)
    CASE default
      WRITE (0, '(a)') 'unsupported index list method selected for reading!'
      CALL mpi_abort(mpi_comm_world, 1, ierror)
    END SELECT
    CLOSE(input_unit)
  END FUNCTION read_idxlist

END MODULE perf_xmap_create_init

PROGRAM perf_xmap_create
  USE mpi
  USE yaxt, xi => xt_int_kind
  USE iso_c_binding
  USE perf_xmap_create_config
  USE perf_xmap_create_init
  IMPLICIT NONE
  TYPE(xt_config) :: conf
  TYPE(xt_idxlist) :: idxlist_3d, idxlist_empty, &
       idxlist_src, idxlist_dst
  TYPE(xt_xmap) :: xmap, reo
  DOUBLE PRECISION :: tic, dt, min, max, sum

  LOGICAL :: use_synthetic_indices
  INTEGER :: ierror

  IF (HUGE(1_xi) >= 1240000) THEN
    run_config%num_columns = INT(1240, xi)
    run_config%num_columns = run_config%num_columns * 1000_xi
  ELSE
    run_config%num_columns = 12400_xi
  END IF
  run_config%nlev = 50_xi
  run_config%index_generation_sequence = INDEX_GEN_COL_MAJOR
  run_config%index_generation_method = INDEX_GEN_IDXVEC
  run_config%bucket_generation_sequence = -1
  run_config%bucket_generation_method = -1
#ifndef HAVE_FC_ALLOCATABLE_CHARACTER
  run_config%fname_pat_src = ''
  run_config%fname_pat_dst = ''
#endif

  CALL mpi_init(ierror)
  CALL xt_initialize(mpi_comm_world)
  CALL mpi_comm_rank(mpi_comm_world, run_config%comm_world_rank, ierror)
  CALL mpi_comm_size(mpi_comm_world, run_config%comm_world_size, ierror)

  conf = xt_config_new()

  CALL parse_options(run_config, conf)

#ifdef HAVE_FC_ALLOCATABLE_CHARACTER
  use_synthetic_indices = .NOT. ALLOCATED(run_config%fname_pat_src)
#else
  use_synthetic_indices = run_config%fname_pat_src == ''
#endif
  IF (use_synthetic_indices) THEN
    idxlist_3d = generate_3d_list(&
         MOD(run_config%comm_world_rank, run_config%local_size), &
         run_config%local_size, run_config%index_generation_method, &
         run_config%index_generation_sequence)
    idxlist_empty = xt_idxempty_new()
    idxlist_src = MERGE(idxlist_3d, idxlist_empty, run_config%is_src)
    idxlist_dst = MERGE(idxlist_empty, idxlist_3d, run_config%is_src)
  ELSE
    idxlist_src = read_idxlist(run_config%index_generation_method, &
         run_config%fname_pat_src, run_config%comm_world_rank)
    idxlist_dst = read_idxlist(run_config%index_generation_method, &
         run_config%fname_pat_dst, run_config%comm_world_rank)
  END IF

  tic = mpi_wtime()

  xmap = xt_xmap_dist_dir_custom_new(&
       idxlist_src, idxlist_dst, mpi_comm_world, conf)

  dt = mpi_wtime() - tic

  reo = xt_xmap_reorder_custom(xmap, xt_reorder_recv_up, conf)

  CALL xt_xmap_delete(reo)
  CALL xt_xmap_delete(xmap)
  CALL xt_idxlist_delete(idxlist_src)
  CALL xt_idxlist_delete(idxlist_dst)

  CALL mpi_reduce(dt, min, 1, mpi_double_precision, &
       mpi_min, 0, mpi_comm_world, ierror)
  CALL mpi_reduce(dt, max, 1, mpi_double_precision, &
       mpi_max, 0, mpi_comm_world, ierror)
  CALL mpi_reduce(dt, sum, 1, mpi_double_precision, &
       mpi_sum, 0, mpi_comm_world, ierror)

  IF (run_config%comm_world_rank == 0) THEN
    WRITE (0, "(3(a,' ',es12.6,' '))") "min", min, "max", max, &
         "avg", sum / REAL(run_config%comm_world_size, KIND(1.0d0))
  END IF

  CALL xt_config_delete(conf);
  IF (.NOT. xt_is_null(run_config%bg)) &
    CALL xt_xmdd_bucket_gen_delete(run_config%bg)

  CALL xt_finalize()
  CALL MPI_Finalize(ierror)

END PROGRAM perf_xmap_create
!
! Local Variables:
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! license-project-url: "https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/"
! license-default: "bsd"
! End:
!

!>
!! @file xt_config_f.f90
!! @brief Fortran interface to yaxt configuration object
!!
!! @copyright Copyright  (C)  2020 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE xt_config_f
  USE, INTRINSIC :: ISO_C_BINDING, ONLY: c_ptr, c_null_ptr, c_int, &
       c_char, c_null_char
  USE xt_core, ONLY: xt_abort
  USE xt_xmap_dist_dir_bucket_gen, ONLY: xt_xmdd_bucket_gen, &
       xt_xmdd_bucket_gen_c2f, xt_xmdd_bucket_gen_f2c
  IMPLICIT NONE
  PRIVATE
  ! note: this type must not be extended to contain any other
  ! components, its memory pattern has to match void * exactly, which
  ! it does because of C constraints
  TYPE, BIND(C), PUBLIC :: xt_config
#ifndef __G95__
    PRIVATE
#endif
    TYPE(c_ptr) :: cptr = c_null_ptr
  END TYPE xt_config

  INTERFACE
    ! this function must not be implemented in Fortran because
    ! PGI 11.x chokes on that
    FUNCTION xt_config_f2c(config) BIND(c, name='xt_config_f2c') RESULT(p)
      IMPORT :: c_ptr, xt_config
      IMPLICIT NONE
      TYPE(xt_config), INTENT(in) :: config
      TYPE(c_ptr) :: p
    END FUNCTION xt_config_f2c
  END INTERFACE

  PUBLIC :: xt_config_new, xt_config_delete
  PUBLIC :: xt_config_f2c
  PUBLIC :: xt_exchanger_id_by_name
  PUBLIC :: xt_config_get_exchange_method, xt_config_set_exchange_method
  INTEGER, PUBLIC, PARAMETER :: &
       xt_exchanger_irecv_send = 0, &
       xt_exchanger_irecv_isend = 1, &
       xt_exchanger_irecv_isend_packed = 2, &
       xt_exchanger_mix_isend_irecv = 3, &
       xt_exchanger_neigh_alltoall = 4, &
       xt_exchanger_irecv_isend_ddt_packed = 5
  PUBLIC :: xt_config_get_idxvec_autoconvert_size, &
       xt_config_set_idxvec_autoconvert_size
  PUBLIC :: xt_config_get_redist_mthread_mode, &
       xt_config_set_redist_mthread_mode
  PUBLIC :: xt_config_get_sort_algorithm_id, &
       xt_config_set_sort_algorithm_by_id
  PUBLIC :: xt_config_set_mem_saving, &
       xt_config_get_mem_saving
  INTEGER, PUBLIC, PARAMETER :: &
       xt_mt_none = 0, &
       xt_mt_openmp = 1
  INTEGER, PUBLIC, PARAMETER :: &
       xt_quicksort = 0, &
       xt_mergesort = 1

  INTEGER, PUBLIC, PARAMETER :: &
       xt_exch_send_standard = 0, &
       xt_exch_send_buffered = 1, &
       xt_exch_send_synchronous = 2
  PUBLIC :: xt_config_set_exchange_send_comm_mode, &
       xt_config_get_exchange_send_comm_mode
  PUBLIC :: xt_config_get_xmdd_bucket_gen, &
       xt_config_set_xmdd_bucket_gen

  PUBLIC :: xt_config_get_xmap_stripe_align, &
       xt_config_set_xmap_stripe_align

  PUBLIC :: xt_config_get_ddt_cache_limit, &
       xt_config_set_ddt_cache_limit
  INTEGER, PUBLIC, PARAMETER :: &
       xt_config_ddt_cache_none = 0, &
       xt_config_ddt_cache_unlimited = -1, &
       xt_config_ddt_cache_no_parse = -2, &
       xt_config_ddt_cache_no_match = -3, &
       xt_config_ddt_no_cache_no_parse = -4

  CHARACTER(len=*), PARAMETER :: filename = 'xt_config_f.f90'

CONTAINS

  FUNCTION xt_config_new() RESULT(config)
    TYPE(xt_config) :: config
    INTERFACE
      FUNCTION xt_config_new_c() RESULT(config) &
           BIND(c, name='xt_config_new')
        IMPORT :: c_ptr
        IMPLICIT NONE
        TYPE(c_ptr) :: config
      END FUNCTION xt_config_new_c
    END INTERFACE
    config%cptr = xt_config_new_c()
  END FUNCTION xt_config_new

  SUBROUTINE xt_config_delete(config)
    TYPE(xt_config), INTENT(in) :: config
    INTERFACE
      SUBROUTINE xt_config_delete_c(config) BIND(c, name='xt_config_delete')
        IMPORT :: c_ptr
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: config
      END SUBROUTINE xt_config_delete_c
    END INTERFACE
    CALL xt_config_delete_c(config%cptr)
  END SUBROUTINE xt_config_delete

  SUBROUTINE xt_config_set_exchange_method(config, method)
    TYPE(xt_config), INTENT(inout) :: config
    INTEGER, INTENT(in) :: method
    INTEGER(c_int) :: method_c
    INTERFACE
      SUBROUTINE xt_config_set_exchange_method_c(config, method) &
           BIND(c, name='xt_config_set_exchange_method')
        IMPORT :: c_int, c_ptr
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int), VALUE :: method
      END SUBROUTINE xt_config_set_exchange_method_c
    END INTERFACE
    method_c = INT(method, c_int)
    CALL xt_config_set_exchange_method_c(config%cptr, method_c)
  END SUBROUTINE xt_config_set_exchange_method

  FUNCTION xt_config_get_exchange_method(config) RESULT(method)
    TYPE(xt_config), INTENT(in) :: config
    INTEGER :: method
    INTERFACE
      FUNCTION xt_config_get_exchange_method_c(config) RESULT(method) &
           BIND(c, name='xt_config_get_exchange_method')
        IMPORT :: c_int, c_ptr
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int) :: method
      END FUNCTION xt_config_get_exchange_method_c
    END INTERFACE
    method = INT(xt_config_get_exchange_method_c(config%cptr))
  END FUNCTION xt_config_get_exchange_method

  FUNCTION xt_exchanger_id_by_name(name) RESULT(exchanger_id)
    CHARACTER(len=*), INTENT(in) :: name
    INTEGER :: exchanger_id
    INTERFACE
      FUNCTION xt_exchanger_id_by_name_c(name) RESULT(exchanger_id) &
           BIND(c, name='xt_exchanger_id_by_name')
        IMPORT :: c_char, c_int
        CHARACTER(len=1, kind=c_char), INTENT(in) :: name(*)
        INTEGER(c_int) :: exchanger_id
      END FUNCTION xt_exchanger_id_by_name_c
    END INTERFACE
    INTEGER(c_int) :: c_id
    CHARACTER(len=1) :: name_c(LEN(name)+1)
    INTEGER :: i, nlen
    nlen = LEN(name)
    DO i = 1, nlen
      name_c(i) = name(i:i)
    END DO
    name_c(nlen+1) = c_null_char
    c_id = xt_exchanger_id_by_name_c(name_c)
    exchanger_id = INT(c_id)
  END FUNCTION xt_exchanger_id_by_name

  FUNCTION xt_config_get_idxvec_autoconvert_size(config) RESULT(cnvsize)
    TYPE(xt_config), INTENT(in) :: config
    INTEGER :: cnvsize
    INTERFACE
      FUNCTION xt_config_get_idxvec_autoconvert_size_c(config) RESULT(cnvsize) &
           BIND(c, name='xt_config_get_idxvec_autoconvert_size')
        IMPORT :: c_int, c_ptr
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int) :: cnvsize
      END FUNCTION xt_config_get_idxvec_autoconvert_size_c
    END INTERFACE
    cnvsize = INT(xt_config_get_idxvec_autoconvert_size_c(config%cptr))
  END FUNCTION xt_config_get_idxvec_autoconvert_size

  SUBROUTINE xt_config_set_idxvec_autoconvert_size(config, cnvsize)
    TYPE(xt_config), INTENT(inout) :: config
    INTEGER, INTENT(in) :: cnvsize
    INTEGER(c_int) :: cnvsize_c
    INTERFACE
      SUBROUTINE xt_config_set_idxvec_autoconvert_size_c(config, cnvsize) &
           BIND(c, name='xt_config_set_idxvec_autoconvert_size')
        IMPORT :: c_int, c_ptr
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int), VALUE :: cnvsize
      END SUBROUTINE xt_config_set_idxvec_autoconvert_size_c
    END INTERFACE
    IF (cnvsize > HUGE(1_c_int) .OR. cnvsize < 1) &
      CALL xt_abort("invalid conversion size", filename, __LINE__)

    cnvsize_c = INT(cnvsize, c_int)
    CALL xt_config_set_idxvec_autoconvert_size_c(config%cptr, cnvsize_c)
  END SUBROUTINE xt_config_set_idxvec_autoconvert_size

  FUNCTION xt_config_get_redist_mthread_mode(config) RESULT(mt_mode)
    TYPE(xt_config), INTENT(in) :: config
    INTEGER :: mt_mode
    INTERFACE
      FUNCTION xt_config_get_redist_mthread_mode_c(config) RESULT(mt_mode) &
           BIND(c, name='xt_config_get_redist_mthread_mode')
        IMPORT :: c_int, c_ptr
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int) :: mt_mode
      END FUNCTION xt_config_get_redist_mthread_mode_c
    END INTERFACE
    mt_mode = INT(xt_config_get_redist_mthread_mode_c(config%cptr))
  END FUNCTION xt_config_get_redist_mthread_mode

  SUBROUTINE xt_config_set_redist_mthread_mode(config, mt_mode)
    TYPE(xt_config), INTENT(inout) :: config
    INTEGER, INTENT(in) :: mt_mode
    INTEGER(c_int) :: mt_mode_c
    INTERFACE
      SUBROUTINE xt_config_set_redist_mthread_mode_c(config, mt_mode) &
           BIND(c, name='xt_config_set_redist_mthread_mode')
        IMPORT :: c_int, c_ptr
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int), VALUE :: mt_mode
      END SUBROUTINE xt_config_set_redist_mthread_mode_c
    END INTERFACE
    IF (mt_mode > HUGE(1_c_int) .OR. mt_mode < 0) &
      CALL xt_abort("invalid multi-threading mode", filename, __LINE__)

    mt_mode_c = INT(mt_mode, c_int)
    CALL xt_config_set_redist_mthread_mode_c(config%cptr, mt_mode_c)
  END SUBROUTINE xt_config_set_redist_mthread_mode

  FUNCTION xt_config_get_sort_algorithm_id(config) RESULT(sort_algo)
    TYPE(xt_config), INTENT(in) :: config
    INTEGER :: sort_algo
    INTERFACE
      FUNCTION xt_config_get_sort_algorithm_id_c(config) RESULT(sort_algo) &
           BIND(c, name='xt_config_get_sort_algorithm_id')
        IMPORT :: c_int, c_ptr
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int) :: sort_algo
      END FUNCTION xt_config_get_sort_algorithm_id_c
    END INTERFACE
    sort_algo = INT(xt_config_get_sort_algorithm_id_c(config%cptr))
  END FUNCTION xt_config_get_sort_algorithm_id

  SUBROUTINE xt_config_set_sort_algorithm_by_id(config, sort_algo)
    TYPE(xt_config), INTENT(inout) :: config
    INTEGER, INTENT(in) :: sort_algo
    INTEGER(c_int) :: sort_algo_c
    INTERFACE
      SUBROUTINE xt_config_set_sort_algorithm_by_id_c(config, sort_algo) &
           BIND(c, name='xt_config_set_sort_algorithm_by_id')
        IMPORT :: c_int, c_ptr
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int), VALUE :: sort_algo
      END SUBROUTINE xt_config_set_sort_algorithm_by_id_c
    END INTERFACE
    IF (sort_algo > HUGE(1_c_int) .OR. sort_algo < 0) &
      CALL xt_abort("invalid algorithm selection", filename, __LINE__)

    sort_algo_c = INT(sort_algo, c_int)
    CALL xt_config_set_sort_algorithm_by_id_c(config%cptr, sort_algo_c)
  END SUBROUTINE xt_config_set_sort_algorithm_by_id

  !>
  !! Set memory conservation PARAMETER.
  !!
  !! @param[in]   config configuration object to modify
  !! @param       memconserve switch on methods of memory saving
  !!              currently supported values: 0 and 1
  !!
  !! When set to 1, operations parameterized by config will
  !! aggressively try to trade memory savings for higher computational
  !! cost.
  !!
  !! Currently, by not sorting index lists used in xmap construction.
  !!
  !! When set to 0, use default trade-offs for space vs. time complexity.
  !!
  SUBROUTINE xt_config_set_mem_saving(config, memconserve)
    TYPE(xt_config), INTENT(inout) :: config
    INTEGER, INTENT(in) :: memconserve
    INTERFACE
      SUBROUTINE xt_config_set_mem_saving_c(config, memconserve) &
           BIND(c, name="xt_config_set_mem_saving")
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int), VALUE :: memconserve
      END SUBROUTINE xt_config_set_mem_saving_c
    END INTERFACE
    INTEGER(c_int) :: memconserve_c
    memconserve_c = INT(memconserve, c_int)
    CALL xt_config_set_mem_saving_c(config%cptr, memconserve_c)
  END SUBROUTINE xt_config_set_mem_saving

  !> Get memory conservation parameter.
  !! @param[in]   config configuration object to query
  !! @return memory conservation parameter as described
  !! at \a xt_config_set_mem_saving
  FUNCTION xt_config_get_mem_saving(config) RESULT(memconserve)
    TYPE(xt_config), INTENT(in) :: config
    INTEGER :: memconserve
    INTERFACE
      FUNCTION xt_config_get_mem_saving_c(config) &
           BIND(c, name="xt_config_get_mem_saving") RESULT(memconserve)
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int) :: memconserve
      END FUNCTION xt_config_get_mem_saving_c
    END INTERFACE
    INTEGER(c_int) :: memconserve_c
    memconserve_c = xt_config_get_mem_saving_c(config%cptr)
    memconserve = INT(memconserve_c)
  END FUNCTION xt_config_get_mem_saving

  !>
  !! Query configured bucket generator
  FUNCTION xt_config_get_xmdd_bucket_gen(config) RESULT(gen)
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_xmdd_bucket_gen) :: gen
    INTERFACE
      FUNCTION xt_config_get_xmdd_bucket_gen_c(config) &
           BIND(c, name='xt_config_get_xmdd_bucket_gen') RESULT(gen)
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE :: config
        TYPE(c_ptr) :: gen
      END FUNCTION xt_config_get_xmdd_bucket_gen_c
    END INTERFACE
    TYPE(c_ptr) :: gen_c
    gen_c = xt_config_get_xmdd_bucket_gen_c(config%cptr)
    gen = xt_xmdd_bucket_gen_c2f(gen_c)
  END FUNCTION xt_config_get_xmdd_bucket_gen

  !> Change generator for buckets in distributed directory
  !! The default is a generator that tiles the range of indices of all
  !! index lists involved in xmap creation in 1D fashion with stripes.
  SUBROUTINE xt_config_set_xmdd_bucket_gen(config, gen)
    TYPE(xt_config), INTENT(inout) :: config
    TYPE(xt_xmdd_bucket_gen), INTENT(in) :: gen
    INTERFACE
      SUBROUTINE xt_config_set_xmdd_bucket_gen_c(config, gen) &
           BIND(c, name='xt_config_set_xmdd_bucket_gen')
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE :: config, gen
      END SUBROUTINE xt_config_set_xmdd_bucket_gen_c
    END INTERFACE
    CALL xt_config_set_xmdd_bucket_gen_c(config%cptr, &
         xt_xmdd_bucket_gen_f2c(gen))
  END SUBROUTINE xt_config_set_xmdd_bucket_gen

  SUBROUTINE xt_config_set_xmap_stripe_align(config, preference)
    TYPE(xt_config), INTENT(inout) :: config
    INTEGER, INTENT(in) :: preference
    INTEGER(c_int) :: preference_c
    INTERFACE
      SUBROUTINE xt_config_set_xmap_stripe_align_c(config, preference) &
           BIND(c, name='xt_config_set_xmap_stripe_align')
        IMPORT :: c_int, c_ptr
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int), VALUE :: preference
      END SUBROUTINE xt_config_set_xmap_stripe_align_c
    END INTERFACE
    preference_c = INT(preference, c_int)
    CALL xt_config_set_xmap_stripe_align_c(config%cptr, preference_c)
  END SUBROUTINE xt_config_set_xmap_stripe_align

  FUNCTION xt_config_get_xmap_stripe_align(config) RESULT(preference)
    TYPE(xt_config), INTENT(in) :: config
    INTEGER :: preference
    INTERFACE
      FUNCTION xt_config_get_xmap_stripe_align_c(config) RESULT(preference) &
           BIND(c, name='xt_config_get_xmap_stripe_align')
        IMPORT :: c_int, c_ptr
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int) :: preference
      END FUNCTION xt_config_get_xmap_stripe_align_c
    END INTERFACE
    preference = INT(xt_config_get_xmap_stripe_align_c(config%cptr))
  END FUNCTION xt_config_get_xmap_stripe_align

  SUBROUTINE xt_config_set_exchange_send_comm_mode(config, &
       exch_send_comm_mode)
    TYPE(xt_config), INTENT(inout) :: config
    INTEGER, INTENT(in) :: exch_send_comm_mode
    INTEGER(c_int) :: exch_send_comm_mode_c
    INTERFACE
      SUBROUTINE xt_config_set_exchange_send_comm_mode_c(config, &
           exch_send_comm_mode) &
           BIND(c, name='xt_config_set_exchange_send_comm_mode')
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int), VALUE :: exch_send_comm_mode
      END SUBROUTINE xt_config_set_exchange_send_comm_mode_c
    END INTERFACE
    exch_send_comm_mode_c = INT(exch_send_comm_mode, c_int)
    CALL xt_config_set_exchange_send_comm_mode_c(config%cptr, &
         exch_send_comm_mode_c)
  END SUBROUTINE xt_config_set_exchange_send_comm_mode

  FUNCTION xt_config_get_exchange_send_comm_mode(config) RESULT(send_mode)
    TYPE(xt_config), INTENT(in) :: config
    INTEGER :: send_mode
    INTERFACE
      FUNCTION xt_config_get_exchange_send_comm_mode_c(config) &
           RESULT(send_mode) &
           BIND(c, name='xt_config_get_exchange_send_comm_mode')
        IMPORT :: c_int, c_ptr
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int) :: send_mode
      END FUNCTION xt_config_get_exchange_send_comm_mode_c
    END INTERFACE
    send_mode = INT(xt_config_get_exchange_send_comm_mode_c(config%cptr))
  END FUNCTION xt_config_get_exchange_send_comm_mode

  SUBROUTINE xt_config_set_ddt_cache_limit(config, limit)
    TYPE(xt_config), INTENT(in) :: config
    INTEGER, INTENT(in) :: limit
    INTEGER(c_int) :: limit_c
    INTERFACE
      SUBROUTINE xt_config_set_ddt_cache_limit_c(config, limit) &
           BIND(c, name='xt_config_set_ddt_cache_limit')
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int), VALUE :: limit
      END SUBROUTINE xt_config_set_ddt_cache_limit_c
    END INTERFACE

    limit_c = INT(limit, c_int)
    CALL xt_config_set_ddt_cache_limit_c(config%cptr, limit_c)
  END SUBROUTINE xt_config_set_ddt_cache_limit

  FUNCTION xt_config_get_ddt_cache_limit(config) RESULT(limit)
    TYPE(xt_config), INTENT(in) :: config
    INTEGER :: limit
    INTEGER(c_int) :: limit_c
    INTERFACE
      FUNCTION xt_config_get_ddt_cache_limit_c(config) &
           BIND(c, name='xt_config_get_ddt_cache_limit') RESULT(limit)
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE :: config
        INTEGER(c_int) :: limit
      END FUNCTION xt_config_get_ddt_cache_limit_c
    END INTERFACE

    limit_c = xt_config_get_ddt_cache_limit_c(config%cptr)
    limit = INT(limit_c)
  END FUNCTION xt_config_get_ddt_cache_limit

END MODULE xt_config_f
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_idxsection_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_idxsection
  USE mpi
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_idxlist, &
       xt_int_kind, xt_bounds, xt_stripe, &
       xt_idxlist_copy, xt_idxlist_get_index_stripes, xt_idxlist_delete, &
       xt_idxlist_get_intersection, xt_idxlist_get_positions_of_indices, &
       xt_idxlist_get_position_of_index, xt_idxlist_get_indices_const, &
       xt_idxlist_get_bounding_box, xt_idxfsection_new, xt_idxstripes_new, &
       xt_idxsection_new, xt_idxvec_new, OPERATOR(/=), OPERATOR(==)
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_idxlist_utils, ONLY: check_idxlist, test_err_count, check_stripes, &
       idxlist_pack_unpack_copy
  IMPLICIT NONE
  INTEGER, PARAMETER :: xi = xt_int_kind
  CHARACTER(len=*), PARAMETER :: filename = 'test_idxsection_f.f90'

  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)

  CALL test_1d_section
  CALL test_2d_section
  CALL test_3d_section
  CALL test_4d_section
  CALL test_2d_simple
  CALL test_1d_intersection1
  CALL test_1d_intersection2
  CALL test_2d_intersection1
  CALL test_2d_1
  CALL test_2d_2
  CALL test_get_positions1
  CALL test_get_positions2
  CALL test_other_intersection
  CALL test_stripe_intersection
  CALL test_signed_sizes1
  CALL test_signed_sizes2
  CALL test_signed_size_positions
  CALL test_signed_size_intersections
  CALL test_section_with_stride1
  CALL test_section_with_stride2
  CALL test_bb1
  CALL test_bb2
  CALL test_bb3

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_finalize
  CALL finish_mpi

CONTAINS
  SUBROUTINE test_1d_section
    INTEGER(xt_int_kind), PARAMETER :: start = 0_xi
    INTEGER, PARAMETER :: num_dimensions = 1
    INTEGER(xt_int_kind), PARAMETER :: global_size(num_dimensions) = 10_xi, &
         local_start(num_dimensions) = 3_xi, &
         ref_indices(5) = (/ 3_xi, 4_xi, 5_xi, 6_xi, 7_xi /)
    INTEGER, PARAMETER :: local_size(num_dimensions) = 5
    TYPE(xt_stripe), PARAMETER :: ref_stripes(1) = xt_stripe(3, 1, 5)
    TYPE(xt_idxlist) :: idxsection

    ! create index section
    idxsection = xt_idxsection_new(start, global_size, local_size, local_start)

    ! testing
    CALL do_tests(idxsection, ref_indices, ref_stripes)

    ! clean up
    CALL xt_idxlist_delete(idxsection)
  END SUBROUTINE test_1d_section

  SUBROUTINE test_2d_section
    INTEGER(xt_int_kind), PARAMETER :: start = 0_xi
    INTEGER, PARAMETER :: num_dimensions = 2
    INTEGER(xt_int_kind), PARAMETER :: global_size(num_dimensions) &
         = (/ 5_xi, 6_xi /), &
         local_start(num_dimensions) = (/ 1_xi, 2_xi /), &
         ref_indices(6) = (/ 8_xi, 9_xi, 14_xi, 15_xi, 20_xi, 21_xi /)
    INTEGER, PARAMETER :: local_size(num_dimensions) = (/ 3, 2 /)
    TYPE(xt_stripe), PARAMETER :: ref_stripes(3) = (/ xt_stripe(8, 1, 2), &
         xt_stripe(14, 1, 2), xt_stripe(20, 1, 2) /)
    TYPE(xt_idxlist) :: idxsection

    ! create index section
    idxsection = xt_idxsection_new(start, global_size, local_size, local_start)

    ! testing
    CALL do_tests(idxsection, ref_indices, ref_stripes)

    ! clean up
    CALL xt_idxlist_delete(idxsection)
  END SUBROUTINE test_2d_section

  SUBROUTINE test_3d_section
    INTEGER(xt_int_kind), PARAMETER :: start = 0_xi
    INTEGER, PARAMETER :: num_dimensions = 3
    INTEGER(xt_int_kind), PARAMETER :: global_size(num_dimensions) = 4_xi, &
         local_start(num_dimensions) = (/ 0_xi, 1_xi, 1_xi /), &
         ref_indices(16) = (/ 5_xi, 6_xi, 9_xi, 10_xi, 21_xi, 22_xi, 25_xi, &
         26_xi, 37_xi, 38_xi, 41_xi, 42_xi, 53_xi, 54_xi, 57_xi, 58_xi /)
    INTEGER, PARAMETER :: local_size(num_dimensions) = (/ 4, 2, 2 /)
    TYPE(xt_stripe), PARAMETER :: ref_stripes(8) = (/ xt_stripe(5, 1, 2), &
         xt_stripe(9, 1, 2), xt_stripe(21, 1, 2), xt_stripe(25, 1, 2), &
         xt_stripe(37, 1, 2), xt_stripe(41, 1, 2), xt_stripe(53, 1, 2), &
         xt_stripe(57, 1, 2) /)
    TYPE(xt_idxlist) :: idxsection

    ! create index section
    idxsection = xt_idxsection_new(start, global_size, local_size, local_start)

    ! testing
    CALL do_tests(idxsection, ref_indices, ref_stripes)

    ! clean up
    CALL xt_idxlist_delete(idxsection)
  END SUBROUTINE test_3d_section

  SUBROUTINE test_4d_section
    INTEGER(xt_int_kind), PARAMETER :: start = 0_xi
    INTEGER, PARAMETER :: num_dimensions = 4
    INTEGER(xt_int_kind) :: i, j, k, l
    INTEGER(xt_int_kind), PARAMETER :: global_size(num_dimensions) &
         = (/ 3_xi, 4_xi, 4_xi, 3_xi /), &
         local_start(num_dimensions) &
         = (/ 0_xi, 1_xi, 1_xi, 1_xi /), &
#ifdef __xlC__
         ref_indices(36) = &
              (/ 16_xi,17_xi,19_xi,20_xi,22_xi,23_xi, &
              28_xi,29_xi,31_xi,32_xi,34_xi,35_xi, &
              40_xi,41_xi,43_xi,44_xi,46_xi,47_xi, &
              64_xi,65_xi,67_xi,68_xi,70_xi,71_xi, &
              76_xi,77_xi,79_xi,80_xi,82_xi,83_xi, &
              88_xi,89_xi,91_xi,92_xi,94_xi,95_xi /)
#else
         ref_indices(36) &
         = (/ ((((16_xi + i + j*3_xi + k*12_xi + l*48_xi, &
         &        i=0_xi,1_xi), j=0_xi,2_xi), k=0_xi,2_xi), l=0_xi,1_xi) /)
#endif
    INTEGER, PARAMETER :: local_size(num_dimensions) = (/ 2, 3, 3, 2 /)
    TYPE(xt_stripe), PARAMETER :: ref_stripes(18) &
         = (/ (((xt_stripe(16_xi + j*3_xi + k*12_xi + l*48_xi, 1_xi, 2), &
         &       j = 0_xi,2_xi), k=0_xi,2_xi), l=0_xi,1_xi) /)
    TYPE(xt_idxlist) :: idxsection

    ! create index section
    idxsection = xt_idxsection_new(start, global_size, local_size, local_start)

    ! testing
    CALL do_tests(idxsection, ref_indices, ref_stripes)

    ! clean up
    CALL xt_idxlist_delete(idxsection)
  END SUBROUTINE test_4d_section

  SUBROUTINE test_2d_simple
    INTEGER(xt_int_kind), PARAMETER :: start = 0_xi
    INTEGER, PARAMETER :: num_dimensions = 2
    INTEGER(xt_int_kind) :: i, j
    INTEGER(xt_int_kind), PARAMETER :: global_size(num_dimensions) &
         = (/ 5_xi, 10_xi /), &
         local_start(num_dimensions) = (/ 1_xi, 2_xi /), &
         ref_indices(12) &
         = (/ ((12_xi + i + j*10_xi, i=0_xi,3_xi), j=0_xi,2_xi) /)
    INTEGER, PARAMETER :: local_size(num_dimensions) = (/ 3, 4 /)
    TYPE(xt_idxlist) :: idxsection

    ! create index section
    idxsection = xt_idxsection_new(start, global_size, local_size, local_start)

    ! testing
    CALL check_idxlist(idxsection, ref_indices)

    CALL xt_idxlist_delete(idxsection)
  END SUBROUTINE test_2d_simple

  SUBROUTINE test_intersection(&
       start_a, global_size_a, local_size_a, local_start_a, &
       start_b, global_size_b, local_size_b, local_start_b, &
       ref_indices, ref_stripes)
    INTEGER(xt_int_kind), INTENT(in) :: start_a, start_b, global_size_a(:), &
         global_size_b(:), local_start_a(:), local_start_b(:), ref_indices(:)
    INTEGER, INTENT(in) :: local_size_a(:), local_size_b(:)
    TYPE(xt_stripe), INTENT(in) :: ref_stripes(:)
    TYPE(xt_idxlist) :: idxsection(2), intersection
    idxsection(1) = xt_idxsection_new(start_a, global_size_a, local_size_a, &
         local_start_a)
    idxsection(2) = xt_idxsection_new(start_b, global_size_b, local_size_b, &
         local_start_b)
    intersection = xt_idxlist_get_intersection(idxsection(1), idxsection(2))
    CALL xt_idxlist_delete(idxsection(2))
    CALL xt_idxlist_delete(idxsection(1))
    CALL do_tests(intersection, ref_indices, ref_stripes)
    CALL xt_idxlist_delete(intersection)
  END SUBROUTINE test_intersection

  SUBROUTINE test_1d_intersection1
    INTEGER(xt_int_kind), PARAMETER :: start=0_xi, &
         global_size_a(1) = 10_xi, global_size_b(1) = 15_xi, &
         local_start_a(1) = 4_xi, local_start_b(1) = 7_xi, &
         ref_indices(2) = (/ 7_xi, 8_xi /)
    INTEGER, PARAMETER :: local_size_a(1) = 5, local_size_b(1) = 6
    TYPE(xt_stripe), PARAMETER :: ref_stripes(1) = (/ xt_stripe(7, 1, 2) /)
    CALL test_intersection(&
         start, global_size_a, local_size_a, local_start_a, &
         start, global_size_b, local_size_b, local_start_b, &
         ref_indices, ref_stripes)
  END SUBROUTINE test_1d_intersection1

  SUBROUTINE test_1d_intersection2
    INTEGER(xt_int_kind), PARAMETER :: start=0_xi, global_size_a(1) = 10_xi, &
         global_size_b(1) = 10_xi, local_start_a(1) = 3_xi, &
         local_start_b(1) = 4_xi, ref_indices(1) = (/ -1_xi /)
    INTEGER, PARAMETER :: local_size_a(1) = 1, local_size_b(1) = 5
    TYPE(xt_stripe), PARAMETER :: ref_stripes(1) = (/ xt_stripe(-1, -1, -1) /)
    CALL test_intersection(&
         start, global_size_a, local_size_a, local_start_a, &
         start, global_size_b, local_size_b, local_start_b, &
         ref_indices(1:0), ref_stripes(1:0))
  END SUBROUTINE test_1d_intersection2

  SUBROUTINE test_2d_intersection1
    INTEGER, PARAMETER :: n = 2
    INTEGER(xt_int_kind), PARAMETER :: start=0_xi, &
         global_size_a(n) = 6_xi, global_size_b(n) = 6_xi, &
         local_start_a(n) = 1_xi, local_start_b(n) = (/ 3_xi, 2_xi /), &
         ref_indices(2) = (/ 20_xi, 26_xi /)
    INTEGER, PARAMETER :: local_size_a(n) = (/ 4, 2 /), local_size_b(n) = 3
    TYPE(xt_stripe), PARAMETER :: ref_stripes(1) = (/ xt_stripe(20, 6, 2) /)
    CALL test_intersection(&
         start, global_size_a, local_size_a, local_start_a, &
         start, global_size_b, local_size_b, local_start_b, &
         ref_indices, ref_stripes)
  END SUBROUTINE test_2d_intersection1

  SUBROUTINE test_2d_1
    INTEGER, PARAMETER :: n = 2
    INTEGER(xt_int_kind), PARAMETER :: start=0_xi, &
         global_size(n) = 4, local_start(n) = (/ 0_xi, 2_xi /), &
         ref_indices(4) = (/ 2_xi, 3_xi, 6_xi, 7_xi /)
    INTEGER, PARAMETER :: local_size(n) = 2
    TYPE(xt_idxlist) :: idxsection
    idxsection = xt_idxsection_new(start, n, global_size, local_size, &
         local_start)
    CALL check_idxlist(idxsection, ref_indices)
    CALL xt_idxlist_delete(idxsection)
  END SUBROUTINE test_2d_1

  SUBROUTINE test_2d_2
    INTEGER, PARAMETER :: n = 2
    INTEGER(xt_int_kind), PARAMETER :: start=1_xi, &
         global_size(n) = 4_xi, local_start(n) = (/ 0_xi, 2_xi /), &
         ref_indices(4) = (/ 3_xi, 4_xi, 7_xi, 8_xi /)
    INTEGER, PARAMETER :: local_size(n) = 2
    TYPE(xt_idxlist) :: idxsection
    idxsection = xt_idxsection_new(start, n, global_size, local_size, &
         local_start)
    CALL check_idxlist(idxsection, ref_indices)
    CALL xt_idxlist_delete(idxsection)
  END SUBROUTINE test_2d_2

  SUBROUTINE test_get_positions1
    INTEGER, PARAMETER :: n = 2, num_selection = 6
    INTEGER(xt_int_kind), PARAMETER :: start=0_xi, &
         global_size(n) = 4_xi, local_start(n) = (/ 0_xi, 2_xi /)
    INTEGER, PARAMETER :: local_size(n) = 2
    INTEGER(xt_int_kind), PARAMETER :: selection(num_selection) &
         = (/ 1_xi, 2_xi, 5_xi, 6_xi, 7_xi, 8_xi /)
    INTEGER, PARAMETER :: ref_positions(num_selection) &
         = (/ 1*0 - 1, 2*0 + 0, 5*0 - 1, 6*0 + 2, 7*0 + 3, 8*0 - 1 /)
    INTEGER :: positions(num_selection), num_found
    TYPE(xt_idxlist) :: idxsection
    idxsection = xt_idxsection_new(start, n, global_size, local_size, &
         local_start)
    num_found = xt_idxlist_get_positions_of_indices(idxsection, selection, &
         positions, .FALSE.)
    IF (num_found /= 3) &
         CALL test_abort("xt_idxlist_get_positions_of_indices &
         &returned incorrect num_unmatched", &
         filename, __LINE__)
    IF (ANY(positions /= ref_positions)) &
         CALL test_abort("xt_idxlist_get_positions_of_indices &
         &returned incorrect position", &
         filename, __LINE__)
    CALL xt_idxlist_delete(idxsection)
  END SUBROUTINE test_get_positions1

  SUBROUTINE test_get_positions2
    INTEGER, PARAMETER :: n = 2, num_selection = 9
    INTEGER(xt_int_kind), PARAMETER :: start=0_xi, &
         global_size(n) = 4_xi, local_start(n) = (/ 0_xi, 2_xi /)
    INTEGER, PARAMETER :: local_size(n) = 2
    INTEGER(xt_int_kind), PARAMETER :: selection(num_selection) &
         = (/ 2_xi, 1_xi, 5_xi, 7_xi, 6_xi, 7_xi, 7_xi, 6_xi, 8_xi /)
    INTEGER, PARAMETER :: ref_positions(num_selection) &
         = (/ 2*0 + 0, 1*0 - 1, 5*0 - 1, 7*0 + 3, 6*0 + 2, 7*0 + 3, 7*0 + 3, &
         &    6*0 + 2, 8*0 - 1 /)
    INTEGER :: positions(num_selection), num_found, i, p
    LOGICAL :: notfound
    TYPE(xt_idxlist) :: idxsection
    idxsection = xt_idxsection_new(start, n, global_size, local_size, &
         local_start)
    num_found = xt_idxlist_get_positions_of_indices(idxsection, selection, &
         positions, .FALSE.)
    IF (num_found /= 3) &
         CALL test_abort("xt_idxlist_get_position_of_indices &
         &returned incorrect num_unmatched", &
         filename, __LINE__)
    IF (ANY(positions /= ref_positions)) &
         CALL test_abort("xt_idxlist_get_position_of_indices &
         &returned incorrect position", &
         filename, __LINE__)
    DO i = 1, num_selection
      notfound = xt_idxlist_get_position_of_index(idxsection, selection(i), p)
      IF (p /= ref_positions(i) &
           .OR. (notfound .AND. ref_positions(i) /= -1)) &
           CALL test_abort("xt_idxlist_get_position_of_index &
           &returned incorrect position", &
           filename, __LINE__)
    END DO
    CALL xt_idxlist_delete(idxsection)
  END SUBROUTINE test_get_positions2

  SUBROUTINE test_other_intersection
    INTEGER, PARAMETER :: n = 2, num_sel_idx = 9
    INTEGER(xt_int_kind), PARAMETER :: start=0_xi, &
         global_size(n) = 4_xi, local_start(n) = (/ 0_xi, 2_xi /), &
         sel_idx(num_sel_idx) &
         = (/ 2_xi, 1_xi, 5_xi, 7_xi, 6_xi, 7_xi, 7_xi, 6_xi, 8_xi /), &
         ref_inter_idx(6) = (/ 2_xi, 6_xi, 6_xi, 7_xi, 7_xi, 7_xi /)
    INTEGER, PARAMETER :: local_size(n) = 2
    TYPE(xt_idxlist) :: idxsection, sel_idxlist, inter_idxlist

    idxsection = xt_idxsection_new(start, n, global_size, local_size, &
         local_start)
    sel_idxlist = xt_idxvec_new(sel_idx)
    inter_idxlist = xt_idxlist_get_intersection(idxsection, sel_idxlist)
    CALL xt_idxlist_delete(sel_idxlist)
    CALL xt_idxlist_delete(idxsection)
    CALL check_idxlist(inter_idxlist, ref_inter_idx)
    CALL xt_idxlist_delete(inter_idxlist)
  END SUBROUTINE test_other_intersection

  SUBROUTINE test_stripe_intersection
    INTEGER, PARAMETER :: irank = 4
    INTEGER(xt_int_kind), PARAMETER :: gsz(irank) &
         = (/ 19_xi, 16_xi, 1_xi, 1_xi /)
    INTEGER, PARAMETER :: lsz(irank) &
         = (/ 10, 16, 1, 1 /)
    INTEGER(xt_int_kind) :: i, j
    INTEGER(xt_int_kind), PARAMETER :: lst(irank) &
         = (/  1_xi,  1_xi, 1_xi, 1_xi /), &
         ref_inter_idx(160) = &
         (/ ((i + j*19_xi, &
         &        i=1_xi,10_xi), j=0_xi,15_xi) /)
    TYPE(xt_stripe), PARAMETER :: ref_stripes(lsz(2)) &
         = (/ (xt_stripe((j*19_xi)+1, 1, lsz(1)), j=0_xi,15_xi) /)
    TYPE(xt_idxlist) :: section, stripes
    TYPE(xt_idxlist) :: intersect
    TYPE(xt_stripe), ALLOCATABLE :: sec_stripes(:)

    section = xt_idxfsection_new(1_xi, gsz, lsz, lst)
    CALL xt_idxlist_get_index_stripes(section, sec_stripes)
    CALL check_stripes(sec_stripes, ref_stripes)
    stripes = xt_idxstripes_new((/ xt_stripe(0_xi, 1_xi, 304) /))
    intersect = xt_idxlist_get_intersection(section, stripes)
    CALL xt_idxlist_delete(stripes)
    CALL xt_idxlist_delete(section)
    CALL check_idxlist(intersect, ref_inter_idx)
    CALL xt_idxlist_delete(intersect)

  END SUBROUTINE test_stripe_intersection

  ! test 2D section with arbitrary size signs
  SUBROUTINE test_signed_sizes1
    INTEGER :: i
    TYPE(xt_idxlist) :: idxsection
    INTEGER, PARAMETER :: n = 2
    INTEGER(xt_int_kind), PARAMETER :: start = 0, &
         global_size(n, 4) = RESHAPE( &
         (/ 5_xi, 10_xi, 5_xi,-10_xi, -5_xi, 10_xi, -5_xi, -10_xi /), &
         (/ n, 4 /) ), &
         local_start(2) = (/ 1_xi, 2_xi /), &
         ref_indices(12, 16) = RESHAPE( &
         (/ 12_xi, 13_xi, 14_xi, 15_xi, 22_xi, 23_xi, 24_xi, 25_xi, 32_xi, &
         &  33_xi, 34_xi, 35_xi, &
         &  15_xi, 14_xi, 13_xi, 12_xi, 25_xi, 24_xi, 23_xi, 22_xi, 35_xi, &
         &  34_xi, 33_xi, 32_xi, &
         &  32_xi, 33_xi, 34_xi, 35_xi, 22_xi, 23_xi, 24_xi, 25_xi, 12_xi, &
         &  13_xi, 14_xi, 15_xi, &
         &  35_xi, 34_xi, 33_xi, 32_xi, 25_xi, 24_xi, 23_xi, 22_xi, 15_xi, &
         &  14_xi, 13_xi, 12_xi, &
         &  17_xi, 16_xi, 15_xi, 14_xi, 27_xi, 26_xi, 25_xi, 24_xi, 37_xi, &
         &  36_xi, 35_xi, 34_xi, &
         &  14_xi, 15_xi, 16_xi, 17_xi, 24_xi, 25_xi, 26_xi, 27_xi, 34_xi, &
         &  35_xi, 36_xi, 37_xi, &
         &  37_xi, 36_xi, 35_xi, 34_xi, 27_xi, 26_xi, 25_xi, 24_xi, 17_xi, &
         &  16_xi, 15_xi, 14_xi, &
         &  34_xi, 35_xi, 36_xi, 37_xi, 24_xi, 25_xi, 26_xi, 27_xi, 14_xi, &
         &  15_xi, 16_xi, 17_xi, &
         &  32_xi, 33_xi, 34_xi, 35_xi, 22_xi, 23_xi, 24_xi, 25_xi, 12_xi, &
         &  13_xi, 14_xi, 15_xi, &
         &  35_xi, 34_xi, 33_xi, 32_xi, 25_xi, 24_xi, 23_xi, 22_xi, 15_xi, &
         &  14_xi, 13_xi, 12_xi, &
         &  12_xi, 13_xi, 14_xi, 15_xi, 22_xi, 23_xi, 24_xi, 25_xi, 32_xi, &
         &  33_xi, 34_xi, 35_xi, &
         &  15_xi, 14_xi, 13_xi, 12_xi, 25_xi, 24_xi, 23_xi, 22_xi, 35_xi, &
         &  34_xi, 33_xi, 32_xi, &
         &  37_xi, 36_xi, 35_xi, 34_xi, 27_xi, 26_xi, 25_xi, 24_xi, 17_xi, &
         &  16_xi, 15_xi, 14_xi, &
         &  34_xi, 35_xi, 36_xi, 37_xi, 24_xi, 25_xi, 26_xi, 27_xi, 14_xi, &
         &  15_xi, 16_xi, 17_xi, &
         &  17_xi, 16_xi, 15_xi, 14_xi, 27_xi, 26_xi, 25_xi, 24_xi, 37_xi, &
         &  36_xi, 35_xi, 34_xi, &
         &  14_xi, 15_xi, 16_xi, 17_xi, 24_xi, 25_xi, 26_xi, 27_xi, 34_xi, &
         &  35_xi, 36_xi, 37_xi /), (/ 12, 16 /) )
    INTEGER, PARAMETER :: local_size(n, 4) = RESHAPE( &
         (/ 3, 4, 3, -4, -3, 4, -3, -4 /), (/ n, 4 /) )
    ! iterate through all sign combinations of -/+ for local and global
    ! and for x and y, giving 2^2^2 combinations
    DO i = 0, 15
      ! create index section

      idxsection = xt_idxsection_new(start, n, global_size(:, i/4 + 1), &
           local_size(:, MOD(i, 4) + 1), local_start)

      ! testing
      CALL check_idxlist(idxsection, ref_indices(:, i + 1))

      ! clean up
      CALL xt_idxlist_delete(idxsection)
    END DO
  END SUBROUTINE test_signed_sizes1

  ! test 2D section with arbitrary size signs
  SUBROUTINE test_signed_sizes2
    INTEGER :: i
    TYPE(xt_idxlist) :: idxsection
    INTEGER, PARAMETER :: n = 2
    INTEGER(xt_int_kind), PARAMETER :: start = 0, &
         global_size(n, 4) = RESHAPE( &
         (/ 5_xi, 6_xi, 5_xi,-6_xi, -5_xi, 6_xi, -5_xi, -6_xi /), &
         (/ n, 4 /) ), &
         local_start(2) = (/ 1_xi, 2_xi /), &
         ref_indices(6, 16) = RESHAPE( &
         (/  8_xi,  9_xi, 10_xi, 14_xi, 15_xi, 16_xi, &
         &  10_xi,  9_xi,  8_xi, 16_xi, 15_xi, 14_xi, &
         &  14_xi, 15_xi, 16_xi,  8_xi,  9_xi, 10_xi, &
         &  16_xi, 15_xi, 14_xi, 10_xi,  9_xi,  8_xi, &
         &   9_xi,  8_xi,  7_xi, 15_xi, 14_xi, 13_xi, &
         &   7_xi,  8_xi,  9_xi, 13_xi, 14_xi, 15_xi, &
         &  15_xi, 14_xi, 13_xi,  9_xi,  8_xi,  7_xi, &
         &  13_xi, 14_xi, 15_xi,  7_xi,  8_xi,  9_xi, &
         &  20_xi, 21_xi, 22_xi, 14_xi, 15_xi, 16_xi, &
         &  22_xi, 21_xi, 20_xi, 16_xi, 15_xi, 14_xi, &
         &  14_xi, 15_xi, 16_xi, 20_xi, 21_xi, 22_xi, &
         &  16_xi, 15_xi, 14_xi, 22_xi, 21_xi, 20_xi, &
         &  21_xi, 20_xi, 19_xi, 15_xi, 14_xi, 13_xi, &
         &  19_xi, 20_xi, 21_xi, 13_xi, 14_xi, 15_xi, &
         &  15_xi, 14_xi, 13_xi, 21_xi, 20_xi, 19_xi, &
         &  13_xi, 14_xi, 15_xi, 19_xi, 20_xi, 21_xi /), (/ 6, 16 /) )
    ! iterate through all sign combinations of -/+ for local and global
    INTEGER, PARAMETER :: local_size(n, 4) = RESHAPE( &
         (/ 2, 3, 2, -3, -2, 3, -2, -3 /), (/ n, 4 /) )
    ! iterate through all sign combinations of -/+ for local and global
    ! and for x and y, giving 2^2^2 combinations
    DO i = 0, 15
      ! create index section

      idxsection = xt_idxsection_new(start, n, global_size(:, i/4 + 1), &
           local_size(:, MOD(i, 4) + 1), local_start)

      ! testing
      CALL check_idxlist(idxsection, ref_indices(:, i + 1))

      ! clean up
      CALL xt_idxlist_delete(idxsection)
    END DO
  END SUBROUTINE test_signed_sizes2

  SUBROUTINE test_signed_size_intersections
    INTEGER, PARAMETER :: n = 2
    INTEGER(xt_int_kind), PARAMETER :: start = 0, &
         global_size(n, 4) = RESHAPE( &
         (/ 5_xi, 10_xi, 5_xi,-10_xi, -5_xi, 10_xi, -5_xi, -10_xi /), &
         (/ n, 4 /) ), &
         local_start(2) = (/ 1_xi, 2_xi /), &
         indices(12, 16) = RESHAPE( &
         (/ 12_xi, 13_xi, 14_xi, 15_xi, 22_xi, 23_xi, 24_xi, 25_xi, 32_xi, &
         &  33_xi, 34_xi, 35_xi, &
         &  15_xi, 14_xi, 13_xi, 12_xi, 25_xi, 24_xi, 23_xi, 22_xi, 35_xi, &
         &  34_xi, 33_xi, 32_xi, &
         &  32_xi, 33_xi, 34_xi, 35_xi, 22_xi, 23_xi, 24_xi, 25_xi, 12_xi, &
         &  13_xi, 14_xi, 15_xi, &
         &  35_xi, 34_xi, 33_xi, 32_xi, 25_xi, 24_xi, 23_xi, 22_xi, 15_xi, &
         &  14_xi, 13_xi, 12_xi, &
         &  17_xi, 16_xi, 15_xi, 14_xi, 27_xi, 26_xi, 25_xi, 24_xi, 37_xi, &
         &  36_xi, 35_xi, 34_xi, &
         &  14_xi, 15_xi, 16_xi, 17_xi, 24_xi, 25_xi, 26_xi, 27_xi, 34_xi, &
         &  35_xi, 36_xi, 37_xi, &
         &  37_xi, 36_xi, 35_xi, 34_xi, 27_xi, 26_xi, 25_xi, 24_xi, 17_xi, &
         &  16_xi, 15_xi, 14_xi, &
         &  34_xi, 35_xi, 36_xi, 37_xi, 24_xi, 25_xi, 26_xi, 27_xi, 14_xi, &
         &  15_xi, 16_xi, 17_xi, &
         &  32_xi, 33_xi, 34_xi, 35_xi, 22_xi, 23_xi, 24_xi, 25_xi, 12_xi, &
         &  13_xi, 14_xi, 15_xi, &
         &  35_xi, 34_xi, 33_xi, 32_xi, 25_xi, 24_xi, 23_xi, 22_xi, 15_xi, &
         &  14_xi, 13_xi, 12_xi, &
         &  12_xi, 13_xi, 14_xi, 15_xi, 22_xi, 23_xi, 24_xi, 25_xi, 32_xi, &
         &  33_xi, 34_xi, 35_xi, &
         &  15_xi, 14_xi, 13_xi, 12_xi, 25_xi, 24_xi, 23_xi, 22_xi, 35_xi, &
         &  34_xi, 33_xi, 32_xi, &
         &  37_xi, 36_xi, 35_xi, 34_xi, 27_xi, 26_xi, 25_xi, 24_xi, 17_xi, &
         &  16_xi, 15_xi, 14_xi, &
         &  34_xi, 35_xi, 36_xi, 37_xi, 24_xi, 25_xi, 26_xi, 27_xi, 14_xi, &
         &  15_xi, 16_xi, 17_xi, &
         &  17_xi, 16_xi, 15_xi, 14_xi, 27_xi, 26_xi, 25_xi, 24_xi, 37_xi, &
         &  36_xi, 35_xi, 34_xi, &
         &  14_xi, 15_xi, 16_xi, 17_xi, 24_xi, 25_xi, 26_xi, 27_xi, 34_xi, &
         &  35_xi, 36_xi, 37_xi /), (/ 12, 16 /) )
    INTEGER, PARAMETER :: local_size(n, 4) = RESHAPE( &
         (/ 3, 4, 3, -4, -3, 4, -3, -4 /), (/ n, 4 /) )
    INTEGER :: i, j
    TYPE(xt_idxlist) :: idxsection_a, idxsection_b, &
         idxvec_a, idxvec_b, idxsection_intersection, &
         idxsection_intersection_other, idxvec_intersection

    DO i = 0, 15
      DO j = 0, 15
        ! create index section
        idxsection_a = xt_idxsection_new(start, n, global_size(:, i/4 + 1), &
             local_size(:, MOD(i, 4) + 1), local_start)
        idxsection_b = xt_idxsection_new(start, n, global_size(:, j/4 + 1), &
             local_size(:, MOD(j, 4) + 1), local_start)
        ! create reference index vectors
        idxvec_a = xt_idxvec_new(indices(:, i+1))
        idxvec_b = xt_idxvec_new(indices(:, j+1))

        ! testing
        idxsection_intersection = xt_idxlist_get_intersection(idxsection_a, &
             idxsection_b)
        idxsection_intersection_other &
             = xt_idxlist_get_intersection(idxsection_a, idxvec_b)
        idxvec_intersection = xt_idxlist_get_intersection(idxvec_a, idxvec_b)

        CALL check_idxlist(idxsection_intersection, &
             xt_idxlist_get_indices_const(idxvec_intersection))
        CALL check_idxlist(idxsection_intersection_other, &
             xt_idxlist_get_indices_const(idxvec_intersection))

        ! clean up

        CALL xt_idxlist_delete(idxsection_a)
        CALL xt_idxlist_delete(idxsection_b)
        CALL xt_idxlist_delete(idxvec_a)
        CALL xt_idxlist_delete(idxvec_b)
        CALL xt_idxlist_delete(idxsection_intersection)
        CALL xt_idxlist_delete(idxsection_intersection_other)
        CALL xt_idxlist_delete(idxvec_intersection)
      END DO
    END DO
  END SUBROUTINE test_signed_size_intersections

  SUBROUTINE test_signed_size_positions
    TYPE(xt_idxlist) :: idxsection
    INTEGER, PARAMETER :: n = 2, num_pos = 34
    INTEGER :: positions(num_pos)

    INTEGER(xt_int_kind), PARAMETER :: start = 0, &
         global_size(n) = (/ -5_xi, 6_xi /), &
         local_start(n) = (/ 1_xi, 2_xi /), &
         ref_indices(6) = (/ 16_xi, 15_xi, 14_xi, 22_xi, 21_xi, 20_xi /), &
         indices(num_pos) = &
         (/ -1_xi,  0_xi,  1_xi,  2_xi,  3_xi, &
         &   4_xi,  5_xi,  6_xi,  7_xi,  8_xi, &
         &   9_xi, 10_xi, 11_xi, 12_xi, 13_xi, &
         &  14_xi, 15_xi, 14_xi, 16_xi, 17_xi, &
         &  18_xi, 19_xi, 20_xi, 20_xi, 21_xi, &
         &  22_xi, 23_xi, 24_xi, 25_xi, 26_xi, &
         &  27_xi, 28_xi, 29_xi, 30_xi /)
    INTEGER, PARAMETER :: local_size(n) = (/ -2, -3 /)
    INTEGER, PARAMETER :: ref_positions(num_pos) = &
         (/ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, &
         &  -1, -1, -1, -1, -1,  2,  1, -1,  0, -1, &
         &  -1, -1,  5, -1,  4,  3, -1, -1, -1, -1, &
         &  -1, -1, -1, -1 /)

    ! create index section
    idxsection = xt_idxsection_new(start, n, global_size, &
         local_size, local_start)

    ! testing
    CALL check_idxlist(idxsection, ref_indices)

    ! check get_positions_of_indices
    if (xt_idxlist_get_positions_of_indices(idxsection, indices, positions, &
         .TRUE.) /= 28) &
         CALL test_abort("error in xt_idxlist_get_positions_of_indices &
         &(wrong number of unmatched indices)", &
         filename, __LINE__)

    IF (ANY(ref_positions /= positions)) &
         call test_abort("error in xt_idxlist_get_positions_of_indices &
         &(wrong position)", &
         filename, __LINE__)

    ! clean up
    CALL xt_idxlist_delete(idxsection)
  END SUBROUTINE test_signed_size_positions

  SUBROUTINE test_section_with_stride(start, global_size, local_size, &
       local_start, ref_indices)
    INTEGER(xt_int_kind), INTENT(in) :: start, global_size(:), &
         local_start(:), ref_indices(:)
    INTEGER, INTENT(in) :: local_size(:)
    TYPE(xt_idxlist) :: idxsection
    idxsection = xt_idxsection_new(start, SIZE(global_size), global_size, &
         local_size, local_start)
    CALL check_idxlist(idxsection, ref_indices)
    CALL xt_idxlist_delete(idxsection)
  END SUBROUTINE test_section_with_stride

  SUBROUTINE test_section_with_stride1
    INTEGER, PARAMETER :: num_dimensions = 3
    INTEGER(xt_int_kind), PARAMETER :: start = 0_xi, &
         global_size(num_dimensions) = (/ 5_xi, 5_xi, 2_xi /), &
         local_start(num_dimensions) = (/ 2_xi, 0_xi, 1_xi /), &
         ref_indices(12) = &
         (/ 21_xi, 23_xi, 25_xi, 27_xi, &
         &  31_xi, 33_xi, 35_xi, 37_xi, &
         &  41_xi, 43_xi, 45_xi, 47_xi /)
    INTEGER, PARAMETER :: local_size(num_dimensions) = (/ 3, 4, 1 /)
    CALL test_section_with_stride(start, global_size, local_size, local_start, &
         ref_indices)
  END SUBROUTINE test_section_with_stride1

  SUBROUTINE test_section_with_stride2
    INTEGER, PARAMETER :: num_dimensions = 4
    INTEGER(xt_int_kind), PARAMETER :: start = 0_xi, &
         global_size(num_dimensions) = (/ 3_xi, 2_xi, 5_xi, 2_xi /), &
         local_start(num_dimensions) = (/ 0_xi, 1_xi, 1_xi, 0_xi /), &
         ref_indices(12) = &
         (/ 12_xi, 14_xi, 16_xi, 18_xi, &
         &  32_xi, 34_xi, 36_xi, 38_xi, &
         &  52_xi, 54_xi, 56_xi, 58_xi /)
    INTEGER, PARAMETER :: local_size(num_dimensions) = (/ 3, 1, 4, 1 /)
    CALL test_section_with_stride(start, global_size, local_size, local_start, &
         ref_indices)
  END SUBROUTINE test_section_with_stride2

  SUBROUTINE check_bb(start, global_size, local_size, &
       local_start, bb_start, global_bb_size, ref_bb)
    INTEGER(xt_int_kind), INTENT(in) :: start, global_size(:), local_start(:), &
         bb_start, global_bb_size(:)
    INTEGER, INTENT(in) :: local_size(:)
    TYPE(xt_bounds), INTENT(in) :: ref_bb(:)
    TYPE(xt_idxlist) :: idxsection
    TYPE(xt_bounds) :: bounds(SIZE(global_bb_size))
    idxsection = xt_idxsection_new(start, SIZE(global_size), global_size, &
         local_size, local_start)
    bounds = xt_idxlist_get_bounding_box(idxsection, global_bb_size, bb_start)
    IF (ANY(bounds /= ref_bb)) &
         CALL test_abort("bounding box mismatch", filename, __LINE__)
    CALL xt_idxlist_delete(idxsection)
  END SUBROUTINE check_bb

  SUBROUTINE test_bb1
    INTEGER, PARAMETER :: num_dimensions = 3
    INTEGER(xt_int_kind), PARAMETER :: start = 0_xi, &
         global_size(num_dimensions) = 4_xi, &
         local_start(num_dimensions) = (/ 2_xi, 0_xi, 1_xi /)
    INTEGER, PARAMETER :: local_size(num_dimensions) = 0
    TYPE(xt_bounds), PARAMETER :: ref_bb(num_dimensions) = xt_bounds(0, 0)
    CALL check_bb(start, global_size, local_size, local_start, start, &
         INT(global_size, xt_int_kind), ref_bb)
  END SUBROUTINE test_bb1

  SUBROUTINE test_bb2
    INTEGER, PARAMETER :: num_dimensions = 3
    INTEGER(xt_int_kind), PARAMETER :: start = 1_xi, &
         global_size(num_dimensions) = (/ 5_xi, 4_xi, 3_xi /), &
         local_start(num_dimensions) = (/ 2_xi, 2_xi, 1_xi /)
    INTEGER, PARAMETER :: local_size(num_dimensions) = 2
    TYPE(xt_bounds), PARAMETER :: ref_bb(num_dimensions) = &
         (/ xt_bounds(2, 2), xt_bounds(2, 2), xt_bounds(1, 2) /)
    CALL check_bb(start, global_size, local_size, local_start, start, &
         INT(global_size, xt_int_kind), ref_bb)
  END SUBROUTINE test_bb2

  SUBROUTINE test_bb3
    INTEGER, PARAMETER :: num_dimensions = 4, bb_ndim = 3
    INTEGER(xt_int_kind), PARAMETER :: start = 1_xi, &
         global_size(num_dimensions) = (/ 5_xi, 2_xi, 2_xi, 3_xi /), &
         local_start(num_dimensions) = (/ 2_xi, 0_xi, 1_xi, 1_xi /), &
         global_bb_size(bb_ndim) = (/ 5_xi, 4_xi, 3_xi /)
    INTEGER, PARAMETER :: local_size(num_dimensions) = (/ 2, 2, 1, 2 /)
    TYPE(xt_bounds), PARAMETER :: ref_bb(bb_ndim) = &
         (/ xt_bounds(2, 2), xt_bounds(1, 3), xt_bounds(1, 2) /)
    CALL check_bb(start, global_size, local_size, local_start, start, &
         global_bb_size, ref_bb)
  END SUBROUTINE test_bb3

  SUBROUTINE do_tests(idxlist, ref_indices, ref_stripes)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), INTENT(in) :: ref_indices(:)
    TYPE(xt_stripe), OPTIONAL, INTENT(in) :: ref_stripes(:)

    TYPE(xt_stripe), ALLOCATABLE :: stripes(:)
    TYPE(xt_idxlist) :: idxlist_copy

    CALL check_idxlist(idxlist, ref_indices)
    IF (PRESENT(ref_stripes)) THEN
      CALL xt_idxlist_get_index_stripes(idxlist, stripes)
      IF (ALLOCATED(stripes)) THEN
        CALL check_stripes(stripes, ref_stripes)
        DEALLOCATE(stripes)
      ELSE
        IF (SIZE(ref_stripes) /= 0) &
             CALL test_abort("failed to reproduce stripes", filename, __LINE__)
      END IF
    END IF

    ! test packing and unpacking
    idxlist_copy = idxlist_pack_unpack_copy(idxlist)
    ! check copy
    CALL check_idxlist(idxlist_copy, ref_indices)

    CALL xt_idxlist_delete(idxlist_copy)

    ! test copying
    idxlist_copy = xt_idxlist_copy(idxlist)

    ! check copy
    CALL check_idxlist(idxlist_copy, ref_indices)

    ! clean up
    CALL xt_idxlist_delete(idxlist_copy)
  END SUBROUTINE do_tests

END PROGRAM test_idxsection
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file ftest_common.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE ftest_common
#include "xt_slice_c_loc.inc"
  USE mpi
  USE xt_core, ONLY: i2, i4, i8
  USE iso_c_binding, ONLY: c_int, c_double, &
       c_int16_t, c_int32_t, c_int64_t, c_size_t, c_loc, c_ptr
  IMPLICIT NONE
  PRIVATE
  INTEGER, PUBLIC, PARAMETER :: dp = SELECTED_REAL_KIND(12, 307)

  TYPE timer
    CHARACTER(len=20) :: label = 'undef'
    INTEGER  :: istate  = -1
    REAL(dp) :: t0      = 0.0_dp
    REAL(dp) :: dt_work = 0.0_dp
  END TYPE timer

  INTERFACE test_abort
    MODULE PROCEDURE test_abort_cmsl_f
    MODULE PROCEDURE test_abort_msl_f
  END INTERFACE test_abort

  INTERFACE icmp
    MODULE PROCEDURE icmp_2d
    MODULE PROCEDURE icmp_2d_i2
    MODULE PROCEDURE icmp_2d_i8
    MODULE PROCEDURE icmp_3d
    MODULE PROCEDURE icmp_3d_i2
    MODULE PROCEDURE icmp_3d_i8
  END INTERFACE icmp

  INTERFACE
    SUBROUTINE posix_exit(code) BIND(c, name="exit")
      IMPORT :: c_int
      INTEGER(c_int), VALUE, INTENT(in) :: code
    END SUBROUTINE posix_exit
  END INTERFACE
  PUBLIC :: posix_exit

  INTERFACE
    ! this function is meant as an escape hatch to prevent warnings
    ! about elision of non-pure calls
    PURE FUNCTION pure_print(s) RESULT(is_true)
      INTEGER :: is_true ! returns non-zero value to prevent
      ! optimizing out of the call
      CHARACTER(len=*), INTENT(in) :: s
    END FUNCTION pure_print
  END INTERFACE

  INTERFACE cmp_arrays

    PURE FUNCTION cmp_dbl_arrays(asize, a, b)
      IMPORT :: c_double
      INTEGER :: cmp_dbl_arrays
      INTEGER, INTENT(in) :: asize
      REAL(c_double), INTENT(in) :: a(asize), b(asize)
    END FUNCTION cmp_dbl_arrays
#define cmp_dbl_arrays(asize,a,b) (Cmp_dbl_arrays(asize,a,b) /= 0)

    PURE FUNCTION cmp_int16_arrays(asize, a, b)
      IMPORT :: c_int16_t
      INTEGER :: cmp_int16_arrays
      INTEGER, INTENT(in) :: asize
      INTEGER(c_int16_t), INTENT(in) :: a(asize), b(asize)
    END FUNCTION cmp_int16_arrays
#define cmp_int16_arrays(asize,a,b) (Cmp_int16_arrays(asize,a,b) /= 0)

    PURE FUNCTION cmp_int32_arrays(asize, a, b)
      IMPORT :: c_int32_t
      INTEGER :: cmp_int32_arrays
      INTEGER, INTENT(in) :: asize
      INTEGER(c_int32_t), INTENT(in) :: a(asize), b(asize)
    END FUNCTION cmp_int32_arrays
#define cmp_int32_arrays(asize,a,b) (Cmp_int32_arrays(asize,a,b) /= 0)

    PURE FUNCTION cmp_int64_arrays(asize, a, b)
      IMPORT :: c_int64_t
      INTEGER :: cmp_int64_arrays
      INTEGER, INTENT(in) :: asize
      INTEGER(c_int64_t), INTENT(in) :: a(asize), b(asize)
    END FUNCTION cmp_int64_arrays
#define cmp_int64_arrays(asize,a,b) (Cmp_int64_arrays(asize,a,b) /= 0)

    MODULE PROCEDURE cmp_dbl_arrays_a1d_a1d
    MODULE PROCEDURE cmp_dbl_arrays_a2d_a2d
    MODULE PROCEDURE cmp_dbl_arrays_a3d_a3d
    MODULE PROCEDURE cmp_i2_arrays_a1d_a1d
    MODULE PROCEDURE cmp_i4_arrays_a1d_a1d
    MODULE PROCEDURE cmp_i8_arrays_a1d_a1d
    MODULE PROCEDURE cmp_i2_arrays_a2d_a2d
    MODULE PROCEDURE cmp_i4_i2_arrays_a2d_a2d
    MODULE PROCEDURE cmp_i4_arrays_a2d_a2d
    MODULE PROCEDURE cmp_i4_i8_arrays_a2d_a2d
    MODULE PROCEDURE cmp_i8_arrays_a2d_a2d
    MODULE PROCEDURE cmp_i2_arrays_a3d_a3d
    MODULE PROCEDURE cmp_i4_i2_arrays_a3d_a3d
    MODULE PROCEDURE cmp_i4_arrays_a3d_a3d
    MODULE PROCEDURE cmp_i4_i8_arrays_a3d_a3d
    MODULE PROCEDURE cmp_i8_arrays_a3d_a3d
  END INTERFACE cmp_arrays

  INTERFACE id_map
    MODULE PROCEDURE id_map_i2, id_map_i4, id_map_i8
  END INTERFACE id_map

  INTERFACE icbrt
    MODULE PROCEDURE icbrt_i2, icbrt_i4, icbrt_i8
  END INTERFACE icbrt

  INTERFACE random_fill
    MODULE PROCEDURE random_fill_i2, random_fill_i4, random_fill_i8
  END INTERFACE random_fill

  INTERFACE crc32
    FUNCTION memcrc(a, n) BIND(c, name="Xt_memcrc") RESULT(crcval)
      IMPORT :: c_ptr, c_size_t, c_int32_t
      TYPE(c_ptr), VALUE, INTENT(in) :: a
      INTEGER(c_size_t), VALUE, INTENT(in) :: n
      INTEGER(c_int32_t) :: crcval
    END function memcrc
    MODULE PROCEDURE memcrc_i2, memcrc_i4, memcrc_i8
  END INTERFACE crc32

  INTERFACE permute
    MODULE PROCEDURE permute_i2
    MODULE PROCEDURE permute_i4
    MODULE PROCEDURE permute_i8
  END INTERFACE permute

  REAL(dp) :: sync_dt_sum = 0.0_dp
  LOGICAL, PARAMETER :: debug = .FALSE.
  LOGICAL :: verbose = .FALSE.

  PUBLIC :: init_mpi, finish_mpi
  PUBLIC :: timer, treset, tstart, tstop, treport, mysync
  PUBLIC :: id_map, icbrt, icmp, factorize, regular_deco
  PUBLIC :: test_abort, set_verbose, get_verbose
  PUBLIC :: cmp_arrays, crc32
  PUBLIC :: random_fill, permute
  PUBLIC :: run_randomized_tests, init_fortran_random
  CHARACTER(len=*), PARAMETER :: filename = 'ftest_common.f90'
CONTAINS

  SUBROUTINE init_mpi
    CHARACTER(len=*), PARAMETER :: context = 'init_mpi: '
    INTEGER :: ierror
#ifndef _OPENMP
    CALL mpi_init(ierror)
#else
    INTEGER :: th_provided
    th_provided = mpi_thread_single
    CALL mpi_init_thread(mpi_thread_multiple, th_provided, ierror)
#endif
    IF (ierror /= MPI_SUCCESS) CALL test_abort(context//'MPI_INIT failed', &
         filename, __LINE__)
  END SUBROUTINE init_mpi

  SUBROUTINE finish_mpi
    CHARACTER(len=*), PARAMETER :: context = 'finish_mpi: '
    INTEGER :: ierror
    CALL MPI_FINALIZE(ierror)
    IF (ierror /= MPI_SUCCESS) CALL test_abort(context//'MPI_FINALIZE failed', &
         filename, &
         __LINE__)
  END SUBROUTINE finish_mpi

  SUBROUTINE set_verbose(verb)
    LOGICAL, INTENT(in) :: verb
    verbose = verb
  END SUBROUTINE set_verbose

  SUBROUTINE get_verbose(verb)
    LOGICAL, INTENT(out) :: verb
    verb = verbose
  END SUBROUTINE get_verbose

  PURE SUBROUTINE treset(t, label)
    TYPE(timer), INTENT(inout) :: t
    CHARACTER(len=*), INTENT(in) :: label
    t%label   = label
    t%istate  = 0
    t%t0      = 0.0_dp
    t%dt_work = 0.0_dp
  END SUBROUTINE treset

  SUBROUTINE tstart(t)
    TYPE(timer), INTENT(inout) :: t
    IF (debug) WRITE(0,*) 'tstart: ',t%label
    CALL mysync
    t%istate = 1
    t%t0 = work_time()
  END SUBROUTINE tstart

  SUBROUTINE tstop(t)
    TYPE(timer), INTENT(inout) :: t
    REAL(dp) :: t1
    IF (debug) WRITE(0,*) 'tstop: ',t%label
    t1 = work_time()
    t%dt_work = t%dt_work + (t1 - t%t0)
    t%istate = 0
    CALL mysync

  END SUBROUTINE tstop

  SUBROUTINE treport(t,extra_label,comm)
    TYPE(timer), INTENT(in) :: t
    CHARACTER(len=*), INTENT(in) :: extra_label
    INTEGER, INTENT(in) :: comm

    CHARACTER(len=*), PARAMETER :: context = 'treport: '
    REAL(dp) :: work_sum, work_max, work_avg, e
    REAL(dp) :: sbuf(1)
    REAL(dp), ALLOCATABLE :: rbuf(:)
    INTEGER :: nprocs, rank, ierror

    sbuf(1) = t%dt_work
    CALL mpi_comm_rank(comm, rank, ierror)
    IF (ierror /= MPI_SUCCESS) &
         CALL test_abort(context//'mpi_comm_rank failed', filename, __LINE__)
    CALL mpi_comm_size(comm, nprocs, ierror)
    IF (ierror /= MPI_SUCCESS) &
         CALL test_abort(context//'mpi_comm_size failed', filename, __LINE__)
    ALLOCATE(rbuf(0:nprocs-1))
    rbuf = -1.0_dp
    CALL mpi_gather(sbuf, 1, MPI_DOUBLE_PRECISION, &
         &  rbuf, 1, MPI_DOUBLE_PRECISION, &
         &  0, comm, ierror)
    IF (ierror /= MPI_SUCCESS) CALL test_abort(context//'MPI_GATHER failed', &
         filename, __LINE__)

    IF (rank == 0) THEN
      IF (cmp_dbl_arrays(1, rbuf, sbuf)) &
           CALL test_abort(context//'internal error (1)', &
           filename, __LINE__)
      IF (ANY(rbuf < 0.0_dp)) CALL test_abort(context//'internal error (2)', &
           filename, __LINE__)
      work_sum = SUM(rbuf)
      work_max = MAXVAL(rbuf)
      work_avg = work_sum / REAL(nprocs, dp)
      e = work_avg / (work_max + 1.e-20_dp)

      IF (verbose) WRITE(0,'(A,I4,2X,A16,3F18.8)') &
           'nprocs, label, wmax, wavg, e =', &
           nprocs, extra_label//':'//t%label, &
           work_max, work_avg, e
    ENDIF

  END SUBROUTINE treport

  SUBROUTINE mysync
    CHARACTER(len=*), PARAMETER :: context = 'mysync: '
    INTEGER :: ierror
    REAL(dp) :: t0, dt

    t0 = mpi_wtime()

    CALL mpi_barrier(MPI_COMM_WORLD, IERROR)
    IF (ierror /= MPI_SUCCESS) CALL test_abort(context//'MPI_BARRIER failed', &
         filename, __LINE__)

    dt = (MPI_WTIME() - t0)
    sync_dt_sum = sync_dt_sum + dt

  END SUBROUTINE mysync

  REAL(dp) FUNCTION work_time()
    work_time = MPI_WTIME() - sync_dt_sum
    RETURN
  END FUNCTION work_time

  PURE SUBROUTINE id_map_i2(map, ofs)
    INTEGER(i2), INTENT(out) :: map(:,:)
    INTEGER(i2), OPTIONAL, INTENT(in) :: ofs

    INTEGER :: i, j, m, n
    INTEGER :: ofs_

    m = SIZE(map, 1)
    n = SIZE(map, 2)
    IF (PRESENT(ofs)) THEN
      ofs_ = INT(ofs) - 1
    ELSE
      ofs_ = 0
    END IF
    DO j = 1, n
      DO i = 1, m
        map(i,j) = INT((j - 1) * m + i + ofs_, i2)
      ENDDO
    ENDDO

  END SUBROUTINE id_map_i2

  PURE SUBROUTINE id_map_i4(map, ofs)
    INTEGER(i4), INTENT(out) :: map(:,:)
    INTEGER(i4), OPTIONAL, INTENT(in) :: ofs

    INTEGER :: i, j, m, n
    INTEGER(i4) :: ofs_

    m = SIZE(map, 1)
    n = SIZE(map, 2)
    IF (PRESENT(ofs)) THEN
      ofs_ = ofs - 1_i4
    ELSE
      ofs_ = 0_i4
    END IF
    DO j = 1, n
      DO i = 1, m
        map(i,j) = INT((j - 1) * m + i, i4) + ofs_
      ENDDO
    ENDDO

  END SUBROUTINE id_map_i4

  PURE SUBROUTINE id_map_i8(map, ofs)
    INTEGER(i8), INTENT(out) :: map(:,:)
    INTEGER(i8), OPTIONAL, INTENT(in) :: ofs

    INTEGER :: i, j, m, n
    INTEGER(i8) :: ofs_

    m = SIZE(map, 1)
    n = SIZE(map, 2)
    IF (PRESENT(ofs)) THEN
      ofs_ = ofs - 1_i8
    ELSE
      ofs_ = 0_i8
    END IF
    DO j = 1, n
      DO i = 1, m
        map(i,j) = INT((j - 1) * m + i, i8) + ofs_
      ENDDO
    ENDDO

  END SUBROUTINE id_map_i8

  SUBROUTINE test_abort_msl_f(msg, source, line)
    CHARACTER(*), INTENT(in) :: msg
    CHARACTER(*), INTENT(in) :: source
    INTEGER, INTENT(in) :: line
    CALL test_abort_cmsl_f(mpi_comm_world, msg, source, line)
  END SUBROUTINE test_abort_msl_f

  SUBROUTINE test_abort_cmsl_f(comm, msg, source, line)
    INTEGER, INTENT(in):: comm
    CHARACTER(*), INTENT(in) :: msg
    CHARACTER(*), INTENT(in) :: source
    INTEGER, INTENT(in) :: line

    INTERFACE
      SUBROUTINE c_abort() BIND(c, name='abort')
      END SUBROUTINE c_abort
    END INTERFACE

    INTEGER :: ierror
    LOGICAL :: flag

    WRITE (0, '(3a,i0,2a)') 'Fatal error in ', source, ', line ', line, &
         ': ', TRIM(msg)
    FLUSH(0)
    CALL mpi_initialized(flag, ierror)
    IF (ierror == mpi_success .AND. flag) &
         CALL mpi_abort(comm, 1, ierror)
    CALL c_abort
  END SUBROUTINE test_abort_cmsl_f

  SUBROUTINE icmp_2d_i2(label, f,g, rank)
    CHARACTER(len=*), PARAMETER :: context = 'ftest_common::icmp_2d_i8: '
    CHARACTER(len=*), INTENT(in) :: label
    INTEGER, INTENT(in) :: f(:,:)
    INTEGER(i2), INTENT(in) :: g(:,:)
    INTEGER, INTENT(in) :: rank

    INTEGER :: i, j, n1, n2
    LOGICAL :: mismatch_found

    n1 = SIZE(f,1)
    n2 = SIZE(f,2)
    IF (SIZE(g,1) /= n1 .OR. SIZE(g,2) /= n2) &
         CALL test_abort(context//'shape mismatch error', filename, __LINE__)

    mismatch_found = .FALSE.
    DO j = 1, n2
      DO i = 1, n1
        mismatch_found = mismatch_found .OR. f(i,j) /= INT(g(i,j))
      END DO
    END DO
    IF (mismatch_found) THEN
      DO j = 1, n2
        DO i = 1, n1
          IF (f(i,j) /= INT(g(i,j))) THEN
            WRITE(0,'(2a,4(a,i0))') context, label, ' test failed: i=', &
                 i, ', j=', j, ', f(i,j)=', f(i,j), ', g(i,j)=', g(i,j)
            CALL test_abort(context//label//' test failed', filename, __LINE__)
          ENDIF
        ENDDO
      ENDDO
    END IF
    IF (verbose) WRITE(0,*) rank,':',context//label//' passed'
  END SUBROUTINE icmp_2d_i2

  SUBROUTINE icmp_2d(label, f,g, rank)
    CHARACTER(len=*), PARAMETER :: context = 'ftest_common::icmp_2d: '
    CHARACTER(len=*), INTENT(in) :: label
    INTEGER, INTENT(in) :: f(:,:), g(:,:)
    INTEGER, INTENT(in) :: rank

    INTEGER :: i, j, n1, n2
    LOGICAL :: mismatch_found

    n1 = SIZE(f,1)
    n2 = SIZE(f,2)
    IF (SIZE(g,1) /= n1 .OR. SIZE(g,2) /= n2) &
         CALL test_abort(context//'shape mismatch error', filename, __LINE__)

    mismatch_found = .FALSE.
    DO j = 1, n2
      DO i = 1, n1
        mismatch_found = mismatch_found .OR. f(i,j) /= g(i,j)
      END DO
    END DO
    IF (mismatch_found) THEN
      DO j = 1, n2
        DO i = 1, n1
          IF (f(i,j) /= g(i,j)) THEN
            WRITE(0,'(2a,4(a,i0))') context, label, ' test failed: i=', &
                 i, ', j=', j, ', f(i,j)=', f(i,j), ', g(i,j)=', g(i,j)
            CALL test_abort(context//label//' test failed', filename, __LINE__)
          ENDIF
        ENDDO
      ENDDO
    END IF
    IF (verbose) WRITE(0,*) rank,':',context//label//' passed'
  END SUBROUTINE icmp_2d

  SUBROUTINE icmp_2d_i8(label, f,g, rank)
    CHARACTER(len=*), PARAMETER :: context = 'ftest_common::icmp_2d_i8: '
    CHARACTER(len=*), INTENT(in) :: label
    INTEGER, INTENT(in) :: f(:,:)
    INTEGER(i8), INTENT(in) :: g(:,:)
    INTEGER, INTENT(in) :: rank

    INTEGER :: i, j, n1, n2
    LOGICAL :: mismatch_found

    n1 = SIZE(f,1)
    n2 = SIZE(f,2)
    IF (SIZE(g,1) /= n1 .OR. SIZE(g,2) /= n2) &
         CALL test_abort(context//'shape mismatch error', filename, __LINE__)

    mismatch_found = .FALSE.
    DO j = 1, n2
      DO i = 1, n1
        mismatch_found = mismatch_found .OR. INT(f(i,j),i8) /= g(i,j)
      END DO
    END DO
    IF (mismatch_found) THEN
      DO j = 1, n2
        DO i = 1, n1
          IF (INT(f(i,j), i8) /= g(i,j)) THEN
            WRITE(0,'(2a,4(a,i0))') context, label, ' test failed: i=', &
                 i, ', j=', j, ', f(i,j)=', f(i,j), ', g(i,j)=', g(i,j)
            CALL test_abort(context//label//' test failed', filename, __LINE__)
          ENDIF
        ENDDO
      ENDDO
    END IF
    IF (verbose) WRITE(0,*) rank,':',context//label//' passed'
  END SUBROUTINE icmp_2d_i8

  SUBROUTINE icmp_3d_i2(label, f,g, rank)
    CHARACTER(len=*), PARAMETER :: context = 'ftest_common::icmp_3d_i8: '
    CHARACTER(len=*), INTENT(in)  :: label
    INTEGER, INTENT(in)  :: f(:,:,:)
    INTEGER(i2), INTENT(in)  :: g(:,:,:)
    INTEGER, INTENT(in) :: rank

    INTEGER :: i, j, k, n1, n2, n3
    LOGICAL :: mismatch_found

    n1 = SIZE(f,1)
    n2 = SIZE(f,2)
    n3 = SIZE(f,3)
    IF (SIZE(g,1) /= n1 .OR. SIZE(g,2) /= n2 .OR. SIZE(g,3) /= n3) &
      CALL test_abort(context//label//' shape mismatch', filename, __LINE__)

    mismatch_found = .FALSE.
    DO k = 1, n3
      DO j = 1, n2
        DO i = 1, n1
          mismatch_found = mismatch_found &
               .OR. f(i,j,k) /= INT(g(i,j,k))
        END DO
      END DO
    END DO
    IF (mismatch_found) THEN
      DO k = 1, n3
        DO j = 1, n2
          DO i = 1, n1
            IF (f(i,j,k) /= INT(g(i,j,k))) THEN
              WRITE(0,*) context,label,&
                   ' test failed: i, j, k, f(i,j,k), g(i,j,k) =', &
                   i, j, k, f(i,j,k), g(i,j,k)
              CALL test_abort(context//label//' test failed', &
                   filename, __LINE__)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
    END IF
    IF (verbose) WRITE(0,*) rank,':',context//label//' passed'
  END SUBROUTINE icmp_3d_i2


  SUBROUTINE icmp_3d(label, f,g, rank)
    CHARACTER(len=*), PARAMETER :: context = 'ftest_common::icmp_3d: '
    CHARACTER(len=*), INTENT(in)  :: label
    INTEGER, INTENT(in)  :: f(:,:,:), g(:,:,:)
    INTEGER, INTENT(in) :: rank

    INTEGER :: i1, i2, i3, n1, n2, n3
    LOGICAL :: mismatch_found

    n1 = SIZE(f,1)
    n2 = SIZE(f,2)
    n3 = SIZE(f,3)
    IF (SIZE(g,1) /= n1 .OR. SIZE(g,2) /= n2 .OR. SIZE(g,3) /= n3) &
      CALL test_abort(context//label//' shape mismatch', filename, __LINE__)

    mismatch_found = .FALSE.
    DO i3 = 1, n3
      DO i2 = 1, n2
        DO i1 = 1, n1
          mismatch_found = mismatch_found .OR. f(i1,i2,i3) /= g(i1,i2,i3)
        END DO
      END DO
    END DO
    IF (mismatch_found) THEN
      DO i3 = 1, n3
        DO i2 = 1, n2
          DO i1 = 1, n1
            IF (f(i1,i2,i3) /= g(i1,i2,i3)) THEN
              WRITE(0,*) context,label,&
                   ' test failed: i1, i2, i3, f(i1,i2,i3), g(i1,i2,i3) =', &
                   i1, i2, i3, f(i1,i2,i3), g(i1,i2,i3)
              CALL test_abort(context//label//' test failed', &
                   filename, __LINE__)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
    END IF
    IF (verbose) WRITE(0,*) rank,':',context//label//' passed'
  END SUBROUTINE icmp_3d

  SUBROUTINE icmp_3d_i8(label, f,g, rank)
    CHARACTER(len=*), PARAMETER :: context = 'ftest_common::icmp_3d_i8: '
    CHARACTER(len=*), INTENT(in)  :: label
    INTEGER, INTENT(in)  :: f(:,:,:)
    INTEGER(i8), INTENT(in)  :: g(:,:,:)
    INTEGER, INTENT(in) :: rank

    INTEGER :: i1, i2, i3, n1, n2, n3
    LOGICAL :: mismatch_found

    n1 = SIZE(f,1)
    n2 = SIZE(f,2)
    n3 = SIZE(f,3)
    IF (SIZE(g,1) /= n1 .OR. SIZE(g,2) /= n2 .OR. SIZE(g,3) /= n3) &
      CALL test_abort(context//label//' shape mismatch', filename, __LINE__)

    mismatch_found = .FALSE.
    DO i3 = 1, n3
      DO i2 = 1, n2
        DO i1 = 1, n1
          mismatch_found = mismatch_found &
               .OR. INT(f(i1,i2,i3), i8) /= g(i1,i2,i3)
        END DO
      END DO
    END DO
    IF (mismatch_found) THEN
      DO i3 = 1, n3
        DO i2 = 1, n2
          DO i1 = 1, n1
            IF (INT(f(i1,i2,i3), i8) /= g(i1,i2,i3)) THEN
              WRITE(0,*) context,label,&
                   ' test failed: i1, i2, i3, f(i1,i2,i3), g(i1,i2,i3) =', &
                   i1, i2, i3, f(i1,i2,i3), g(i1,i2,i3)
              CALL test_abort(context//label//' test failed', &
                   filename, __LINE__)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
    END IF
    IF (verbose) WRITE(0,*) rank,':',context//label//' passed'
  END SUBROUTINE icmp_3d_i8


  PURE FUNCTION cmp_dbl_arrays_a1d_a1d(a, b) RESULT(differ)
    DOUBLE PRECISION, INTENT(in) :: a(:), b(:)
    LOGICAL :: differ
    INTEGER :: asize, bsize
    INTEGER(c_int) :: asize_c

    asize = SIZE(a)
    bsize = SIZE(b)
    IF (asize /= bsize) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (asize > 0) THEN
      asize_c = INT(asize, c_int)
      differ = cmp_dbl_arrays(asize_c, a, b)
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_dbl_arrays_a1d_a1d

  PURE FUNCTION cmp_dbl_arrays_a2d_a2d(a, b) RESULT(differ)
    DOUBLE PRECISION, INTENT(in) :: a(:,:), b(:,:)
    LOGICAL :: differ
    INTEGER :: asize, bsize
    INTEGER(c_int) :: asize_c

    asize = SIZE(a)
    bsize = SIZE(b)
    IF (asize /= bsize) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (asize > 0) THEN
      asize_c = INT(asize, c_int)
      differ = cmp_dbl_arrays(asize_c, a, b)
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_dbl_arrays_a2d_a2d

  PURE FUNCTION cmp_dbl_arrays_a3d_a3d(a, b) RESULT(differ)
    DOUBLE PRECISION, INTENT(in) :: a(:,:,:), b(:,:,:)
    LOGICAL :: differ
    INTEGER :: asize, bsize
    INTEGER(c_int) :: asize_c

    asize = SIZE(a)
    bsize = SIZE(b)
    IF (asize /= bsize) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (asize > 0) THEN
      asize_c = INT(asize, c_int)
      differ = cmp_dbl_arrays(asize_c, a, b)
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_dbl_arrays_a3d_a3d

  PURE FUNCTION cmp_i2_arrays_a1d_a1d(a, b) RESULT(differ)
    INTEGER(i2), INTENT(in) :: a(:), b(:)
    LOGICAL :: differ
    INTEGER :: asize, bsize
    INTEGER(c_int) :: asize_c

    asize = SIZE(a)
    bsize = SIZE(b)
    IF (asize /= bsize) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (asize > 0) THEN
      asize_c = INT(asize, c_int)
      differ = cmp_int16_arrays(asize_c, a, b)
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i2_arrays_a1d_a1d

  PURE FUNCTION cmp_i4_arrays_a1d_a1d(a, b) RESULT(differ)
    INTEGER(i4), INTENT(in) :: a(:), b(:)
    LOGICAL :: differ
    INTEGER :: asize, bsize
    INTEGER(c_int) :: asize_c

    asize = SIZE(a)
    bsize = SIZE(b)
    IF (asize /= bsize) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (asize > 0) THEN
      asize_c = INT(asize, c_int)
      differ = cmp_int32_arrays(asize_c, a, b)
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i4_arrays_a1d_a1d

  PURE FUNCTION cmp_i8_arrays_a1d_a1d(a, b) RESULT(differ)
    INTEGER(i8), INTENT(in) :: a(:), b(:)
    LOGICAL :: differ
    INTEGER :: asize, bsize
    INTEGER(c_int) :: asize_c

    asize = SIZE(a)
    bsize = SIZE(b)
    IF (asize /= bsize) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (asize > 0) THEN
      asize_c = INT(asize, c_int)
      differ = cmp_int64_arrays(asize_c, a, b)
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i8_arrays_a1d_a1d

  PURE FUNCTION cmp_i2_arrays_a2d_a2d(a, b) RESULT(differ)
    INTEGER(i2), INTENT(in) :: a(:,:), b(:,:)
    LOGICAL :: differ
    INTEGER :: asize, bsize
    INTEGER(c_int) :: asize_c

    asize = SIZE(a)
    bsize = SIZE(b)
    IF (asize /= bsize) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (asize > 0) THEN
      asize_c = INT(asize, c_int)
      differ = cmp_int16_arrays(asize_c, a, b)
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i2_arrays_a2d_a2d

  PURE FUNCTION cmp_i4_arrays_a2d_a2d(a, b) RESULT(differ)
    INTEGER(i4), INTENT(in) :: a(:,:), b(:,:)
    LOGICAL :: differ
    INTEGER :: asize, bsize
    INTEGER(c_int) :: asize_c

    asize = SIZE(a)
    bsize = SIZE(b)
    IF (asize /= bsize) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (asize > 0) THEN
      asize_c = INT(asize, c_int)
      differ = cmp_int32_arrays(asize_c, a, b)
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i4_arrays_a2d_a2d

  PURE FUNCTION cmp_i8_arrays_a2d_a2d(a, b) RESULT(differ)
    INTEGER(i8), INTENT(in) :: a(:,:), b(:,:)
    LOGICAL :: differ
    INTEGER :: asize, bsize
    INTEGER(c_int) :: asize_c

    asize = SIZE(a)
    bsize = SIZE(b)
    IF (asize /= bsize) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (asize > 0) THEN
      asize_c = INT(asize, c_int)
      differ = cmp_int64_arrays(asize_c, a, b)
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i8_arrays_a2d_a2d

  PURE FUNCTION cmp_i2_arrays_a3d_a3d(a, b) RESULT(differ)
    INTEGER(i2), INTENT(in) :: a(:,:,:), b(:,:,:)
    LOGICAL :: differ
    INTEGER :: asize, bsize
    INTEGER(c_int) :: asize_c

    asize = SIZE(a)
    bsize = SIZE(b)
    IF (asize /= bsize) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (asize > 0) THEN
      asize_c = INT(asize, c_int)
      differ = cmp_int16_arrays(asize_c, a, b)
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i2_arrays_a3d_a3d

  PURE FUNCTION cmp_i4_arrays_a3d_a3d(a, b) RESULT(differ)
    INTEGER(i4), INTENT(in) :: a(:,:,:), b(:,:,:)
    LOGICAL :: differ
    INTEGER :: asize, bsize
    INTEGER(c_int) :: asize_c

    asize = SIZE(a)
    bsize = SIZE(b)
    IF (asize /= bsize) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (asize > 0) THEN
      asize_c = INT(asize, c_int)
      differ = cmp_int32_arrays(asize_c, a, b)
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i4_arrays_a3d_a3d

  PURE FUNCTION cmp_i4_i2_arrays_a2d_a2d(a, b) RESULT(differ)
    INTEGER(i4), INTENT(in) :: a(:,:)
    INTEGER(i2), INTENT(in) :: b(:,:)
    LOGICAL :: differ
    INTEGER :: i, j, m, n

    m = SIZE(a, 1)
    n = SIZE(a, 2)
    IF (m /= SIZE(b, 1) .OR. n /= SIZE(b, 2)) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (SIZE(a) > 0) THEN
      differ = .FALSE.
      DO j = 1, n
        DO i = 1, m
          differ = differ .OR. a(i, j) /= INT(b(i, j), i4)
        END DO
      END DO
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i4_i2_arrays_a2d_a2d

  PURE FUNCTION cmp_i4_i8_arrays_a2d_a2d(a, b) RESULT(differ)
    INTEGER(i4), INTENT(in) :: a(:,:)
    INTEGER(i8), INTENT(in) :: b(:,:)
    LOGICAL :: differ
    INTEGER :: i, j, m, n

    m = SIZE(a, 1)
    n = SIZE(a, 2)
    IF (m /= SIZE(b, 1) .OR. n /= SIZE(b, 2)) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (SIZE(a) > 0) THEN
      differ = .FALSE.
      DO j = 1, n
        DO i = 1, m
          differ = differ .OR. INT(a(i, j), i8) /= b(i, j)
        END DO
      END DO
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i4_i8_arrays_a2d_a2d

  PURE FUNCTION cmp_i4_i2_arrays_a3d_a3d(a, b) RESULT(differ)
    INTEGER(i4), INTENT(in) :: a(:,:,:)
    INTEGER(i2), INTENT(in) :: b(:,:,:)
    LOGICAL :: differ
    INTEGER :: i, j, k, m, n, o

    m = SIZE(a, 1)
    n = SIZE(a, 2)
    o = SIZE(a, 3)
    IF (m /= SIZE(b, 1) .OR. n /= SIZE(b, 2) .OR. o /= SIZE(b, 3)) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (SIZE(a) > 0) THEN
      differ = .FALSE.
      DO k = 1, o
        DO j = 1, n
          DO i = 1, m
            differ = differ .OR. a(i, j, k) /= INT(b(i, j, k), i4)
          END DO
        END DO
      END DO
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i4_i2_arrays_a3d_a3d

  PURE FUNCTION cmp_i4_i8_arrays_a3d_a3d(a, b) RESULT(differ)
    INTEGER(i4), INTENT(in) :: a(:,:,:)
    INTEGER(i8), INTENT(in) :: b(:,:,:)
    LOGICAL :: differ
    INTEGER :: i, j, k, m, n, o

    m = SIZE(a, 1)
    n = SIZE(a, 2)
    o = SIZE(a, 3)
    IF (m /= SIZE(b, 1) .OR. n /= SIZE(b, 2) .OR. o /= SIZE(b, 3)) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (SIZE(a) > 0) THEN
      differ = .FALSE.
      DO k = 1, o
        DO j = 1, n
          DO i = 1, m
            differ = differ .OR. INT(a(i, j, k), i8) /= b(i, j, k)
          END DO
        END DO
      END DO
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i4_i8_arrays_a3d_a3d

  PURE FUNCTION cmp_i8_arrays_a3d_a3d(a, b) RESULT(differ)
    INTEGER(i8), INTENT(in) :: a(:,:,:), b(:,:,:)
    LOGICAL :: differ
    INTEGER :: asize, bsize
    INTEGER(c_int) :: asize_c

    asize = SIZE(a)
    bsize = SIZE(b)
    IF (asize /= bsize) THEN
      differ = 0 /= pure_print('warning: comparing arrays of different size')
    ELSE IF (asize > 0) THEN
      asize_c = INT(asize, c_int)
      differ = cmp_int64_arrays(asize_c, a, b)
    ELSE
      differ = .FALSE.
    END IF
  END FUNCTION cmp_i8_arrays_a3d_a3d

  SUBROUTINE factorize(c, a, b)
    INTEGER, INTENT(in) :: c
    INTEGER, INTENT(out) :: a, b ! c = a*b

    INTEGER :: x0, i

    IF (c<1) CALL test_abort('factorize: invalid process space', &
         filename, __LINE__)
    IF (c <= 3 .OR. c == 5 .OR. c == 7) THEN
      a = c
      b = 1
      RETURN
    ENDIF

    ! simple approach, we try to be near c = (2*x) * x
    x0 = INT(SQRT(0.5 * REAL(c)) + 0.5)
    a = 2*x0
    f_loop: DO i = a, 1, -1
      IF (MOD(c,i) == 0) THEN
        a = i
        b = c/i
        EXIT f_loop
      ENDIF
    ENDDO f_loop

  END SUBROUTINE factorize

  !> computes n**(1/3)
  FUNCTION icbrt_i2(n) RESULT(icbrt)
    INTEGER(i2), INTENT(in) :: n
    INTEGER(i2) :: icbrt
    INTEGER(i2), PARAMETER :: nbits = BIT_SIZE(n)-1_i2
    INTEGER(i2) :: s
    INTEGER(i2) :: b, x

    x = ABS(n)
    icbrt = 0_i2
    DO s = nbits, 0_i2, -3_i2
      icbrt = icbrt + icbrt
      b = 3_i2 * icbrt * (icbrt + 1_i2) + 1_i2
      IF (ISHFT(x, -s) >= b) THEN
        x = x - ISHFT(b, s)
        icbrt = icbrt + 1_i2
      END IF
    END DO
    icbrt = SIGN(icbrt, n)
  END FUNCTION icbrt_i2

  !> computes n**(1/3)
  FUNCTION icbrt_i4(n) RESULT(icbrt)
    INTEGER(i4), INTENT(in) :: n
    INTEGER(i4) :: icbrt
    INTEGER(i4), PARAMETER :: nbits = BIT_SIZE(n)-1_i4
    INTEGER(i4) :: s
    INTEGER(i4) :: b, x

    x = ABS(n)
    icbrt = 0_i4
    DO s = nbits-1, 0_i4, -3_i4
      icbrt = icbrt + icbrt
      b = 3_i4 * icbrt * (icbrt + 1_i4) + 1_i4
      IF (ISHFT(x, -s) >= b) THEN
        x = x - ISHFT(b, s)
        icbrt = icbrt + 1_i4
      END IF
    END DO
    icbrt = SIGN(icbrt, n)
  END FUNCTION icbrt_i4

  !> computes n**(1/3)
  FUNCTION icbrt_i8(n) RESULT(icbrt)
    INTEGER(i8), INTENT(in) :: n
    INTEGER(i8) :: icbrt
    INTEGER(i8), PARAMETER :: nbits = BIT_SIZE(n)-1_i8
    INTEGER(i8) :: s
    INTEGER(i8) :: b, x

    x = ABS(n)
    icbrt = 0_i8
    DO s = nbits, 0_i8, -3_i8
      icbrt = icbrt + icbrt
      b = 3_i8 * icbrt * (icbrt + 1_i8) + 1_i8
      IF (ISHFT(x, -s) >= b) THEN
        x = x - ISHFT(b, s)
        icbrt = icbrt + 1_i8
      END IF
    END DO
    icbrt = SIGN(icbrt, n)
  END FUNCTION icbrt_i8


  SUBROUTINE regular_deco(g_cn, c0, cn)
    INTEGER, INTENT(in) :: g_cn
    INTEGER, INTENT(out) :: c0(0:), cn(0:)

    ! convention: process space coords start at 0, grid point coords start at 1

    integer :: tn
    INTEGER :: d, m
    INTEGER :: it

    tn = SIZE(c0)
    IF (tn<0) CALL test_abort('(tn<0)', filename, __LINE__)
    IF (tn>g_cn) CALL test_abort('regular_deco: too many task for such a core&
         & region', &
         filename, __LINE__)

    d = g_cn/tn
    m = MOD(g_cn, tn)

    DO it = 0, m-1
      cn(it) = d + 1
    ENDDO
    DO it = m, tn-1
      cn(it) = d
    ENDDO

    c0(0)=0
    DO it = 1, tn-1
      c0(it) = c0(it-1) + cn(it-1)
    ENDDO
    IF (c0(tn-1)+cn(tn-1) /= g_cn) &
         CALL test_abort('regular_deco: internal error 1', filename, __LINE__)
  END SUBROUTINE regular_deco

  FUNCTION run_randomized_tests() RESULT(fully_random_tests)
    LOGICAL :: fully_random_tests
    CHARACTER(len=32) :: envval
    INTEGER :: envlen, envstat
    CALL get_environment_variable("YAXT_FULLY_RANDOM_TESTS", envval, envlen, &
         status=envstat)
    IF (envstat == 0 .AND. (envlen == 1 .OR. envlen == 3)) THEN
      IF (envlen == 1 .AND. (envval(1:1) == 'y' .OR. envval(1:1) == 'Y' &
           &                 .OR. envval(1:1) == '1')) THEN
        fully_random_tests = .TRUE.
      ELSE IF (str2lower(envval(1:3)) == 'yes') THEN
        fully_random_tests = .TRUE.
      ELSE
        fully_random_tests = .FALSE.
      END IF
    ELSE
      fully_random_tests = .FALSE.
    END IF
  END FUNCTION run_randomized_tests

  FUNCTION str2lower(s) RESULT(t)
    CHARACTER(len=*), INTENT(in) :: s
    CHARACTER(len=LEN(s)) :: t
    INTEGER, PARAMETER :: idel = ICHAR('a')-ICHAR('A')
    INTEGER :: i
    DO i = 1, LEN_TRIM(s)
      t(i:i) = CHAR( ICHAR(s(i:i)) &
           + MERGE(idel, 0,       ICHAR(s(i:i)) >= ICHAR('A') &
           &                .AND. ICHAR(s(i:i)) <= ICHAR('Z')))
    ENDDO
  END FUNCTION str2lower

  SUBROUTINE init_fortran_random(full_random)
    LOGICAL, INTENT(in) :: full_random
    INTEGER, ALLOCATABLE :: rseed(:)

    INTEGER :: rseed_size, i
    CHARACTER(len=32) :: fmt
    INTEGER :: tparts(8), timeseed
    INTEGER :: days_per_month(12), days_prefix
    INTEGER, PARAMETER :: tparts_mult(7) = (/ &
         365 * 24 * 60 * 60, & ! year
         0,                  & ! sum over days_per_month added to day
         24 * 60 * 60,       & ! day
         0,                  & ! ignore timezone offset
         60 * 60,            & ! hour of day
         60,                 & ! minute of hour
         1 /)                  ! seconnd
    CHARACTER(len=32) :: envval
    INTEGER :: envlen, envstat

    CALL random_seed(size=rseed_size)
    ALLOCATE(rseed(rseed_size))
    DO i = 1, rseed_size
      rseed(i) = 4711
    END DO
    IF (full_random) THEN

      CALL date_and_TIME(values=tparts)
      days_per_month( 1) = 31
      days_per_month( 2) = MERGE(28, 29, &
           MOD(tparts(1), 4) == 0 .AND. (     MOD(tparts(1), 100) /= 0 &
           &                             .OR. MOD(tparts(1), 400) == 0))
      days_per_month( 3) = 31
      days_per_month( 4) = 30
      days_per_month( 5) = 31
      days_per_month( 6) = 30
      days_per_month( 7) = 31
      days_per_month( 8) = 31
      days_per_month( 9) = 30
      days_per_month(10) = 31
      days_per_month(11) = 30
      days_per_month(12) = 31
      tparts(1) = tparts(1) - 1970
      days_prefix = SUM(days_per_month(1:tparts(2)-1))
      tparts(3) = tparts(3) + days_prefix - 1
      tparts(2) = 0
      timeseed = SUM(tparts(1:7) * tparts_mult)
      timeseed = IEOR(tparts(8), timeseed) ! mix in microseconds
      rseed(1) = timeseed
      CALL get_environment_VARIABLE("YAXT_RANDOM_SEED", envval, envlen, &
           status=envstat)
      IF (envstat == 0) THEN
        WRITE (fmt, '(a,i0,a)') '(i', DIGITS(rseed), ')'
        READ(envval(1:envlen), fmt) rseed(1)
      END IF
      WRITE(0, '(a,i0)') 'used extra seed=', rseed(1)
      FLUSH(0)
    END IF
    CALL random_seed(put=rseed)
  END SUBROUTINE init_fortran_random

  SUBROUTINE random_fill_i2(a)
    INTEGER(i2), ALLOCATABLE :: a(:)
    INTEGER :: n, nb, i, j
    INTEGER, PARAMETER :: block_len=8
    REAL(c_double) :: rand_nums(block_len)
    REAL(c_double) :: sc
    n = SIZE(a)
    nb = n/block_len
    sc = REAL(HUGE(a), c_double)
    DO j = 1, nb
      CALL RANDOM_NUMBER(rand_nums)
      DO i = 1, block_len
        a(i+(j-1)*block_len) = NINT(rand_nums(i) * sc, i2)
      END DO
    END DO
    CALL RANDOM_NUMBER(rand_nums)
    DO i = 1, MOD(n, block_len)
      a(i+nb*block_len) = NINT(rand_nums(i) * sc, i2)
    END DO
  END SUBROUTINE random_fill_i2

  SUBROUTINE random_fill_i4(a)
    INTEGER(i4), ALLOCATABLE :: a(:)
    INTEGER :: n, nb, i, j
    INTEGER, PARAMETER :: block_len=8
    REAL(c_double) :: rand_nums(block_len)
    REAL(c_double) :: sc
    n = SIZE(a)
    nb = n/block_len
    sc = REAL(HUGE(a), c_double)
    DO j = 1, nb
      CALL RANDOM_NUMBER(rand_nums)
      DO i = 1, block_len
        a(i+(j-1)*block_len) = NINT(rand_nums(i) * sc, i4)
      END DO
    END DO
    CALL RANDOM_NUMBER(rand_nums)
    DO i = 1, MOD(n, block_len)
      a(i+nb*block_len) = NINT(rand_nums(i) * sc, i4)
    END DO
  END SUBROUTINE random_fill_i4

  SUBROUTINE random_fill_i8(a)
    INTEGER(i8), ALLOCATABLE :: a(:)
    INTEGER :: n, nb, i, j
    INTEGER, PARAMETER :: block_len=8
    REAL(c_double) :: rand_nums(block_len)
    ! the least signifant digits of huge(a) do not fit into an ieee754
    ! double precision real and gfortran warns about that. For that
    ! reason the below expression limits scale_val to those 1-bits
    ! which can be represented in a double precision constant
#ifdef HAVE_FC_MIL_STD_1753_INIT
    INTEGER(i8), PARAMETER :: scale_val &
         = IAND(HUGE(a), NOT(ISHFT(1_i8, BIT_SIZE(1_i8) &
         &                               - DIGITS(0.0_c_double))  - 1_i8 ) )
    REAL(c_double) :: sc
    sc = REAL(scale_val, c_double)
#else
    REAL(c_double), PARAMETER :: sc &
         = REAL(RADIX(sc), c_double) ** (BIT_SIZE(1_i8) - 1) - 1.0_c_double
#endif
    n = SIZE(a)
    nb = n/block_len

    DO j = 1, nb
      CALL RANDOM_NUMBER(rand_nums)
      DO i = 1, block_len
        a(i+(j-1)*block_len) = NINT(rand_nums(i) * sc, i8)
      END DO
    END DO
    CALL RANDOM_NUMBER(rand_nums)
    DO i = 1, MOD(n, block_len)
      a(i+nb*block_len) = NINT(rand_nums(i) * sc, i8)
    END DO
  END SUBROUTINE random_fill_i8

  FUNCTION memcrc_i2(a) RESULT(crcval)
    INTEGER(i2), TARGET, INTENT(in) :: a(:)
    INTEGER(c_int32_t) :: crcval
    TYPE(c_ptr) :: p
    INTEGER(c_size_t) :: n
    XT_SLICE_C_LOC(a, p)
    n = SIZE(a) * 2_c_size_t
    crcval = memcrc(p, n)
  END FUNCTION memcrc_i2

  FUNCTION memcrc_i4(a) RESULT(crcval)
    INTEGER(i4), TARGET, INTENT(in) :: a(:)
    INTEGER(c_int32_t) :: crcval
    TYPE(c_ptr) :: p
    INTEGER(c_size_t) :: n
    XT_SLICE_C_LOC(a, p)
    n = SIZE(a) * 4_c_size_t
    crcval = memcrc(p, n)
  END FUNCTION memcrc_i4

  FUNCTION memcrc_i8(a) RESULT(crcval)
    INTEGER(i8), TARGET, INTENT(in) :: a(:)
    INTEGER(c_int32_t) :: crcval
    TYPE(c_ptr) :: p
    INTEGER(c_size_t) :: n
    XT_SLICE_C_LOC(a, p)
    n = SIZE(a) * 8_c_size_t
    crcval = memcrc(p, n)
  END FUNCTION memcrc_i8

  SUBROUTINE permute_i2(a, p)
    INTEGER(i2), INTENT(inout) :: a(:)
    INTEGER, INTENT(inout) :: p(:)

    INTEGER :: i, n, next, temp
    INTEGER(i2) :: t

    n = SIZE(a)
    DO i = 1, n
      next = i
      ! Check if it is already
      ! considered in cycle
      DO WHILE (p(next) >= 0)
        ! Swap the current element according
        ! to the permutation in P
        t = a(i)
        temp = p(next)
        a(i) = a(temp)
        a(temp) = t
        p(next) = -temp
        next = temp
      END DO
    END DO
  END SUBROUTINE permute_i2

  SUBROUTINE permute_i4(a, p)
    INTEGER(i4), INTENT(inout) :: a(:)
    INTEGER, INTENT(inout) :: p(:)

    INTEGER :: i, n, next, temp
    INTEGER(i4) :: t

    n = SIZE(a)
    DO i = 1, n
      next = i
      ! Check if it is already
      ! considered in cycle
      DO WHILE (p(next) >= 0)
        ! Swap the current element according
        ! to the permutation in P
        t = a(i)
        temp = p(next)
        a(i) = a(temp)
        a(temp) = t
        p(next) = -temp
        next = temp
      END DO
    END DO
  END SUBROUTINE permute_i4

  SUBROUTINE permute_i8(a, p)
    INTEGER(i8), INTENT(inout) :: a(:)
    INTEGER, INTENT(inout) :: p(:)

    INTEGER :: i, n, next, temp
    INTEGER(i8) :: t

    n = SIZE(a)
    DO i = 1, n
      next = i
      ! Check if it is already
      ! considered in cycle
      DO WHILE (p(next) >= 0)
        ! Swap the current element according
        ! to the permutation in P
        t = a(i)
        temp = p(next)
        a(i) = a(temp)
        a(temp) = t
        p(next) = -temp
        next = temp
      END DO
    END DO
  END SUBROUTINE permute_i8

END MODULE ftest_common
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file xt_idxlist_collection_f.f90
!! @brief Fortran interface to xt_idxlist_collection constructors
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE xt_idxlist_collection
  USE xt_core, ONLY: xt_abort, xt_get_default_comm
  USE xt_idxlist_abstract, ONLY: xt_idxlist, xt_idxlist_c2f
  USE iso_c_binding, ONLY: c_int, c_ptr
  IMPLICIT NONE
  PRIVATE
  INTERFACE
    FUNCTION xt_idxlist_collection_new_c(idxlists, num_lists) &
         BIND(C, name='xt_idxlist_collection_new') RESULT(res_ptr)
      IMPORT:: c_ptr, c_int, xt_idxlist
      IMPLICIT NONE
      TYPE(xt_idxlist), INTENT(in) :: idxlists(*)
      INTEGER(c_int), VALUE, INTENT(in) :: num_lists
      TYPE(c_ptr) :: res_ptr
    END FUNCTION xt_idxlist_collection_new_c
  END INTERFACE

  INTERFACE xt_idxlist_collection_new
    MODULE PROCEDURE xt_idxlist_collection_new_a1d
    MODULE PROCEDURE xt_idxlist_collection_new_a2d
  END INTERFACE xt_idxlist_collection_new

  PUBLIC :: xt_idxlist_collection_new
  CHARACTER(len=*), PARAMETER :: filename = 'xt_idxlist_collection_f.f90'
CONTAINS

  FUNCTION xt_idxlist_collection_new_a1d(idxlists) RESULT(res)
    TYPE(xt_idxlist), INTENT(in) :: idxlists(:)
    TYPE(xt_idxlist) :: res
    INTEGER(c_int) :: num_idxlists_c

    IF (SIZE(idxlists) > HUGE(1_c_int)) &
         CALL xt_abort(xt_get_default_comm(), "idxlists array too large", &
         filename, __LINE__)
    num_idxlists_c = INT(SIZE(idxlists), c_int)
    res = xt_idxlist_c2f(xt_idxlist_collection_new_c(idxlists, num_idxlists_c))
  END FUNCTION xt_idxlist_collection_new_a1d

  FUNCTION xt_idxlist_collection_new_a2d(idxlists) RESULT(res)
    TYPE(xt_idxlist), INTENT(in) :: idxlists(:,:)
    TYPE(xt_idxlist) :: res
    INTEGER(c_int) :: num_idxlists_c

    IF (SIZE(idxlists) > HUGE(1_c_int)) &
         CALL xt_abort(xt_get_default_comm(), "idxlists array too large", &
         filename, __LINE__)
    num_idxlists_c = INT(SIZE(idxlists), c_int)
    res = xt_idxlist_c2f(xt_idxlist_collection_new_c(idxlists, num_idxlists_c))
  END FUNCTION xt_idxlist_collection_new_a2d

END MODULE xt_idxlist_collection
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file mpi_fortran_startup.f90
!! @brief Test startup of MPI-parallel Fortran programs
!!
!! @copyright Copyright  (C)  2023 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
! acx_mpirun_num_tasks=2
PROGRAM mpi_hello
!  INCLUDE "mpif.h"
  USE mpi
  USE iso_c_binding

  INTERFACE
    SUBROUTINE posix_exit(code) BIND(c, name="exit")
      IMPORT :: c_int
      INTEGER(c_int), VALUE, INTENT(in) :: code
    END SUBROUTINE posix_exit
  END INTERFACE

  INTEGER :: ierror, comm_size, comm_rank
  INTEGER :: procnum, acx_mpirun_num_tasks
  CALL mpi_init(ierror)
  CALL handle_mpi_error(ierror)
  CALL mpi_comm_rank(mpi_comm_world, comm_rank, ierror)
  CALL handle_mpi_error(ierror)
  CALL mpi_comm_size(mpi_comm_world, comm_size, ierror)
  CALL handle_mpi_error(ierror)
  acx_mpirun_num_tasks = 2
  procnum = 1
  CALL mpi_allreduce(mpi_in_place, procnum, 1, mpi_integer, &
       mpi_sum, mpi_comm_world, ierror)
  IF (procnum /= acx_mpirun_num_tasks) THEN
    CALL mpi_abort(mpi_comm_world, 1, ierror)
  END IF
  CALL mpi_finalize(ierror)
  CALL handle_mpi_error(ierror)
CONTAINS
  SUBROUTINE handle_mpi_error(ierror)
    INTEGER, INTENT(in) :: ierror

    INTEGER :: msg_len, msg_ierror
    CHARACTER(len=MPI_MAX_ERROR_STRING) :: msg

    IF (ierror /= MPI_SUCCESS) THEN
      CALL mpi_error_string(ierror, msg, msg_len, msg_ierror)
      WRITE (0, *) msg(1:msg_len)
      FLUSH(0)
      CALL posix_exit(1_c_int)
    END IF
  END SUBROUTINE handle_mpi_error

END PROGRAM mpi_hello
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_xmap_intersection_parallel_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#include "fc_feature_defs.inc"
PROGRAM test_xmap_intersection_parallel
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort, posix_exit
  USE mpi
  USE iso_c_binding, ONLY: c_int
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_int_kind, &
       xt_idxlist, xt_idxvec_new, xt_idxlist_delete, xt_xmap, &
       xt_idxempty_new, xi => xt_int_kind, &
       xt_xmap_intersection_new, xt_xmap_intersection_ext_new, xt_com_list, &
       xt_xmap_intersection_pos_new, xt_com_pos, &
       xt_xmap_copy, xt_xmap_delete, xt_xmap_iter, &
       xt_xmap_get_in_iterator, xt_xmap_get_out_iterator, &
       xt_xmap_get_num_destinations, xt_xmap_get_num_sources, &
       xt_xmap_iterator_get_rank, xt_xmap_iterator_get_num_transfer_pos, &
       xt_xmap_iterator_get_transfer_pos, xt_xmap_iterator_next, &
       xt_pos_ext, xt_xmap_iterator_get_num_transfer_pos_ext, &
       xt_xmap_iterator_get_transfer_pos_ext, &
       xt_xmap_iterator_delete, xt_xmap_reorder, xt_reorder_type_kind, &
       xt_reorder_none, xt_reorder_send_up, xt_reorder_recv_up, &
       xt_sort_permutation, xt_xmap_update_positions, xt_xmap_spread
#if defined __PGI && ( __PGIC__ < 12 || (__PGIC__ ==  12 && __PGIC_MINOR__ <= 7))
  ! PGI Fortran 12.7 and older has a bug that prevents proper passing of
  ! generic interfaces through multiple modules, direct USE instead
  USE xt_xmap_abstract, ONLY: xt_is_null
#else
  USE yaxt, ONLY: xt_is_null
#endif
  IMPLICIT NONE

  TYPE test_message
    INTEGER :: rank       ! rank of communication partner
    INTEGER, POINTER :: pos(:)   ! positions to be sent/received
  END TYPE test_message

  INTEGER, PARAMETER :: xmi_type_base = 0, xmi_type_ext = 1
  INTEGER :: xmi_type

  INTEGER :: ierror
  INTEGER :: my_rank, comm_size
  CHARACTER(len=*), PARAMETER :: &
       filename = 'test_xmap_intersection_parallel_f.f90'

  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  xmi_type = xmi_type_base
  CALL parse_options

  CALL mpi_comm_rank(mpi_comm_world, my_rank, ierror)
  IF (ierror /= mpi_success) &
       CALL test_abort("MPI error!", filename, __LINE__)

  CALL mpi_comm_size(mpi_comm_world, comm_size, ierror)
  IF (ierror /= mpi_success) &
       CALL test_abort("MPI error!", filename, __LINE__)

  IF (comm_size /= 3) THEN
    CALL xt_finalize
    CALL finish_mpi
    CALL posix_exit(77_c_int)
  END IF

  ! parse_options(&argc, &argv);
  CALL simple_rr_test
  CALL elimination_test
  CALL one_to_one_comm_test
  CALL full_comm_matrix_test
  CALL dedup_test
  CALL reorder_test
  CALL update_positions_and_spread_test
  CALL alltoall_pos_test

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_finalize
  CALL finish_mpi

CONTAINS
  ! simple test (round robin)
  SUBROUTINE simple_rr_test
    ! setup
    INTEGER(xi) :: src_index(1), dst_index(1)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    INTEGER, PARAMETER :: num_src_intersections = 1, &
         num_dst_intersections = 1, num_sends = 1, num_recvs = 1
    INTEGER, SAVE, TARGET :: send_pos(num_sends) = (/ 0 /), &
         recv_pos(num_recvs) = (/ 0 /)
    TYPE(xt_com_list) :: src_com(num_src_intersections), &
         dst_com(num_dst_intersections)
    TYPE(xt_xmap) :: xmap
    TYPE(test_message) :: send_messages(1), recv_messages(1)

    src_index(1) = INT(my_rank, xi)
    dst_index(1) = INT(MOD(my_rank + 1, comm_size), xi)
    src_idxlist = xt_idxvec_new(src_index)
    dst_idxlist = xt_idxvec_new(dst_index)
    src_com(1) = xt_com_list(src_idxlist, MOD(my_rank+1, comm_size))
    dst_com(1) = xt_com_list(dst_idxlist, MOD(my_rank+comm_size-1, comm_size))

    xmap = xmi_new(src_com(1:num_src_intersections), &
         dst_com(1:num_dst_intersections), &
         src_idxlist, dst_idxlist, mpi_comm_world)

    ! test
    send_messages(1)%rank = MOD(my_rank+1, comm_size)
    send_messages(1)%pos => send_pos
    recv_messages(1)%rank = MOD(my_rank+comm_size-1, comm_size)
    recv_messages(1)%pos => recv_pos

    CALL test_xmap(xmap, send_messages, recv_messages)

    ! cleanup
    CALL xt_xmap_delete(xmap)
    CALL xt_idxlist_delete(dst_idxlist)
    CALL xt_idxlist_delete(src_idxlist)
  END SUBROUTINE simple_rr_test

  ! rank 0 receives the same point from rank 1 and 2
  SUBROUTINE elimination_test
    INTEGER(xi), PARAMETER :: src_index(1) = (/ 0_xi /), &
         dst_index(1) = (/ 0_xi /)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    INTEGER :: num_src_intersections,  num_dst_intersections, num_sends, &
         num_recvs
    INTEGER, TARGET :: send_pos(1), recv_pos(1)
    TYPE(xt_com_list) :: src_com(1), dst_com(2)
    TYPE(xt_xmap) :: xmap
    TYPE(test_message) :: send_messages(1), recv_messages(1)
    ! setup
    IF (my_rank == 0) THEN
      src_idxlist = xt_idxempty_new()
      dst_idxlist = xt_idxvec_new(dst_index)
    ELSE
      src_idxlist = xt_idxvec_new(src_index)
      dst_idxlist = xt_idxempty_new()
    END IF
    num_src_intersections = MERGE(1, 0, my_rank /= 0)
    src_com = xt_com_list(src_idxlist, 0)
    num_dst_intersections = MERGE(0, 2, my_rank /= 0)
    dst_com(1) = xt_com_list(dst_idxlist, 1)
    dst_com(2) = xt_com_list(dst_idxlist, 2)

    xmap = xmi_new(src_com(1:num_src_intersections), &
         dst_com(1:num_dst_intersections), &
         src_idxlist, dst_idxlist, mpi_comm_world)

    ! test
    send_pos(1) = 0
    num_sends = MERGE(1, 0, my_rank == 1)
    send_messages(1)%rank = 0
    send_messages(1)%pos => send_pos
    recv_pos(1) = 0;
    num_recvs = MERGE(1, 0, my_rank == 0)
    recv_messages(1)%rank = 1
    recv_messages(1)%pos => recv_pos

    CALL test_xmap(xmap, send_messages(1:num_sends), recv_messages(1:num_recvs))

    ! cleanup

    CALL xt_xmap_delete(xmap)
    CALL xt_idxlist_delete(dst_idxlist)
    CALL xt_idxlist_delete(src_idxlist)
  END SUBROUTINE elimination_test

  ! all ranks can receive data from one of the others
  SUBROUTINE one_to_one_comm_test
    ! rank               |  0  |  1  |  2  |
    ! source indices     | 1,2 | 2,0 | 0,1 |
    ! destination indice |  0  |  1  |  2  |

    INTEGER(xi) :: src_indices(2), dst_index(1)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist, src_intersection_idxlist(2)
    INTEGER, PARAMETER :: num_src_intersections(3) = (/ 2, 1, 0 /)
    INTEGER :: num_sends, num_recvs, s_s, s_e, i
    INTEGER, TARGET :: send_pos(2), recv_pos(1)
    TYPE(xt_com_list) :: src_com(2), dst_com(1)
    TYPE(xt_xmap) :: xmap
    TYPE(test_message) :: send_messages(2), recv_messages(1)
    ! setup
    dst_index(1) = INT(my_rank, xi)
    DO i = 1, 2
      src_indices(i) = INT(MOD(my_rank+i, comm_size), xi)
      src_intersection_idxlist(i) = xt_idxvec_new(src_indices(i:i), 1)
    END DO
    src_idxlist = xt_idxvec_new(src_indices, 2)
    dst_idxlist = xt_idxvec_new(dst_index, 1)
    src_com(1) = xt_com_list(src_intersection_idxlist(1), 1)
    src_com(2) = xt_com_list(src_intersection_idxlist(2), &
         MERGE(2, 0, my_rank == 0))
    dst_com = xt_com_list(dst_idxlist, MERGE(1, 0, my_rank == 0))
    s_s = MERGE(my_rank + 1, 1, my_rank /= 2)
    s_e = s_s + num_src_intersections(my_rank + 1) - 1
    xmap = xmi_new(src_com(s_s:s_e), dst_com(:), src_idxlist, dst_idxlist, &
         mpi_comm_world)

    ! test
    recv_pos(1) = 0
    num_recvs = 1
    SELECT CASE (my_rank)
    CASE (0)
      send_pos(1) = 0
      send_pos(2) = 1
      num_sends = 2
      send_messages(1)%rank = 1
      send_messages(1)%pos => send_pos(1:1)
      send_messages(2)%rank = 2
      send_messages(2)%pos => send_pos(2:2)
      recv_messages(1)%rank = 1
    CASE (1)
      send_pos = 1
      num_sends = 1
      send_messages(1)%rank = 0
      send_messages(1)%pos => send_pos(1:1)
      recv_messages(1)%rank = 0
    CASE default
      num_sends = 0
      recv_messages(1)%rank = 0
    END SELECT
    recv_messages(1)%pos => recv_pos(1:1)
    CALL test_xmap(xmap, send_messages(1:num_sends), recv_messages(1:num_recvs))

    ! cleanup
    CALL xt_xmap_delete(xmap)
    CALL xt_idxlist_delete(src_intersection_idxlist(2))
    CALL xt_idxlist_delete(src_intersection_idxlist(1))
    CALL xt_idxlist_delete(dst_idxlist)
    CALL xt_idxlist_delete(src_idxlist)
  END SUBROUTINE one_to_one_comm_test

  ! all ranks receive data from each of the others
  SUBROUTINE full_comm_matrix_test
    !rank               |        0        |        1        |        2
    !source indices     |    0,1,2,3,4    |    3,4,5,6,7    |    6,7,8,0,1
    !destination indices|0,1,2,3,4,5,6,7,8|0,1,2,3,4,5,6,7,8|0,1,2,3,4,5,6,7,8


    INTEGER(xi), PARAMETER :: src_indices(5,0:2) &
         = RESHAPE((/ 0_xi, 1_xi, 2_xi, 3_xi, 4_xi, &
         &            3_xi, 4_xi ,5_xi, 6_xi, 7_xi, &
         &            6_xi, 7_xi, 8_xi, 0_xi, 1_xi /), (/ 5, 3 /)), &
         dst_indices(9) &
         = (/ 0_xi, 1_xi, 2_xi, 3_xi, 4_xi, 5_xi, 6_xi, 7_xi, 8_xi /)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_com_list) :: src_com(0:2), dst_com(0:2)
    TYPE(xt_xmap) :: xmap
    INTEGER, SAVE, TARGET :: send_pos(5, 0:2) &
         = RESHAPE((/ 0,1,2,3,4, 2,3,4,-1,-1, 2,-1,-1,-1,-1 /), (/ 5, 3 /)), &
         num_send_pos(0:2) = (/ 5, 3, 1 /), &
         recv_pos(5, 0:2) &
         = RESHAPE((/ 0,1,2,3,4, 5,6,7,-1,-1, 8,-1,-1,-1,-1 /), (/ 5, 3 /)), &
         num_recv_pos(0:2) = (/ 5, 3, 1 /)
    TYPE(test_message) :: send_messages(0:2), recv_messages(0:2)
    INTEGER :: i

    ! setup
    src_idxlist = xt_idxvec_new(src_indices(:, my_rank))
    dst_idxlist = xt_idxvec_new(dst_indices, 9)
    DO i = 0, 2
      src_com(i) = xt_com_list(src_idxlist, i)
      dst_com(i) = xt_com_list(xt_idxvec_new(src_indices(:, i)), i)
    END DO
    xmap = xmi_new(src_com, dst_com, src_idxlist, dst_idxlist, &
         mpi_comm_world)

    ! test
    DO i = 0, 2
      send_messages(i)%rank = i
      send_messages(i)%pos => send_pos(1:num_send_pos(my_rank), my_rank)
      recv_messages(i)%rank = i
      recv_messages(i)%pos => recv_pos(1:num_recv_pos(i), i)
    END DO
    CALL test_xmap(xmap, send_messages, recv_messages)

    ! cleanup
    CALL xt_xmap_delete(xmap)
    DO i = 2, 0, -1
      CALL xt_idxlist_delete(dst_com(i)%list)
    END DO
    CALL xt_idxlist_delete(dst_idxlist)
    CALL xt_idxlist_delete(src_idxlist)
  END SUBROUTINE full_comm_matrix_test

  ! one rank receives data from the other two, that have duplicated indices
  ! (this provokes a bug found by Joerg Behrens)
  SUBROUTINE dedup_test
    ! rank                |  0  |  1  |   2   |
    ! source indices      | 0,2 | 1,2 |       |
    ! destination indices |     |     | 0,1,2 |

    INTEGER(xt_int_kind), PARAMETER :: src_indices(2, 0:1) &
         = RESHAPE((/ 0_xi,2_xi, 1_xi,2_xi /), (/ 2, 2 /))
    TYPE(xt_com_list) ::  src_com(1), dst_com(2)
    INTEGER :: num_src_intersections, num_dst_intersections
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    INTEGER(xt_int_kind), PARAMETER :: dst_indices(3) = (/ 0_xi, 1_xi, 2_xi /)
    TYPE(xt_xmap) :: xmap
    INTEGER :: i, num_recv_messages, num_send_messages
    INTEGER, PARAMETER :: num_recv_pos(2) = (/ 2, 1 /), &
         num_send_pos(2) = (/ 2, 1 /)
    INTEGER, SAVE, TARGET :: &
         recv_pos(2, 2) = RESHAPE((/ 0, 2, 1, -1 /), (/ 2, 2 /)), &
         send_pos(2, 2) = RESHAPE((/ 0, 1, 0, -1 /), (/ 2, 2 /))
    TYPE(test_message) :: recv_messages(2), send_messages(1)
    ! setup
    IF (my_rank == 2) THEN
      num_src_intersections = 0
      num_dst_intersections = 2
      DO i = 0, 1
        dst_com(i+1)%list = xt_idxvec_new(src_indices(:, i))
        dst_com(i+1)%rank = i
      END DO
      src_idxlist = xt_idxempty_new()
      dst_idxlist = xt_idxvec_new(dst_indices(:))
    ELSE
      num_src_intersections = 1
      src_com(1)%list = xt_idxvec_new(src_indices(:, my_rank))
      src_com(1)%rank = 2
      num_dst_intersections = 0;
      src_idxlist = xt_idxvec_new(src_indices(:, my_rank))
      dst_idxlist = xt_idxempty_new()
    END IF
    xmap = xmi_new(src_com(1:num_src_intersections), &
         dst_com(1:num_dst_intersections), &
         src_idxlist, dst_idxlist, mpi_comm_world)

    ! test
    IF (my_rank == 2) THEN
      num_recv_messages = 2
      num_send_messages = 0
      DO i = 1, 2
        recv_messages(i)%rank = i - 1
        recv_messages(i)%pos => recv_pos(1:num_recv_pos(i), i)
      END DO
    ELSE
      num_recv_messages = 0
      num_send_messages = 1
      send_messages(1)%rank = 2
      send_messages(1)%pos => send_pos(1:num_send_pos(my_rank + 1), my_rank + 1)
    END IF
    CALL test_xmap(xmap, send_messages(1:num_send_messages), &
         recv_messages(1:num_recv_messages))

    ! cleanup
    CALL xt_xmap_delete(xmap)
    CALL xt_idxlist_delete(dst_idxlist)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_com(1:num_dst_intersections)%list)
    CALL xt_idxlist_delete(src_com(1:num_src_intersections)%list)
  END SUBROUTINE dedup_test

  ! checks the reorder functionality of exchange maps
  SUBROUTINE reorder_test

    INTEGER(xt_int_kind), PARAMETER :: src_indices(6) &
         = (/ 0_xi, 5_xi, 1_xi, 4_xi, 2_xi, 3_xi /)
    INTEGER(xt_int_kind), PARAMETER :: dst_indices(6) &
         = (/ 5_xi, 4_xi, 3_xi, 2_xi, 1_xi, 0_xi /)
    INTEGER(xt_int_kind), PARAMETER :: intersection_indices(6) &
         = (/ 0_xi, 1_xi, 2_xi, 3_xi, 4_xi, 5_xi /)
    TYPE(xt_com_list) ::  src_com(1), dst_com(1)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap, xmap_reorder
    INTEGER(xt_reorder_type_kind), PARAMETER :: reorder_types(3) &
         = (/ xt_reorder_none, xt_reorder_send_up, xt_reorder_recv_up/)
    INTEGER :: i
    INTEGER, SAVE, TARGET :: send_pos(6), recv_pos(6)
    TYPE(test_message) :: recv_messages(1), send_messages(1)

    ! setup
    src_idxlist = xt_idxvec_new(src_indices(:))
    dst_idxlist = xt_idxvec_new(dst_indices(:))
    src_com(1)%list = xt_idxvec_new(intersection_indices)
    src_com(1)%rank = MOD(my_rank + 1, comm_size)
    dst_com(1)%list = xt_idxvec_new(intersection_indices)
    dst_com(1)%rank = MOD(comm_size + my_rank - 1, comm_size)
    xmap = xmi_new(src_com, dst_com, src_idxlist, dst_idxlist, mpi_comm_world)

    send_messages(1)%rank = MOD(my_rank + 1, comm_size)
    send_messages(1)%pos => send_pos
    recv_messages(1)%rank = MOD(comm_size + my_rank - 1, comm_size)
    recv_messages(1)%pos => recv_pos

    ! test
    DO i = 1, 3
      xmap_reorder = xt_xmap_reorder(xmap, reorder_types(i))
      send_pos = (/ 0, 2, 4, 5, 3, 1 /)
      recv_pos = (/ 5, 4, 3, 2, 1, 0 /)
      SELECT CASE(reorder_types(i))
        CASE(xt_reorder_send_up)
          CALL xt_sort_permutation(send_pos, recv_pos)
        CASE(xt_reorder_recv_up)
          CALL xt_sort_permutation(recv_pos, send_pos)
      END SELECT
      CALL test_xmap(xmap_reorder, send_messages, recv_messages)
      CALL xt_xmap_delete(xmap_reorder)
    END DO

    ! cleanup
    CALL xt_xmap_delete(xmap)
    CALL xt_idxlist_delete(dst_idxlist)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_com(1)%list)
    CALL xt_idxlist_delete(src_com(1)%list)
  END SUBROUTINE reorder_test

  ! checks the update positions functionality of exchange maps
  SUBROUTINE update_positions_and_spread_test

    INTEGER(xt_int_kind), PARAMETER :: indices(12) &
         = (/ 0_xi, 1_xi, 2_xi, 3_xi, 4_xi, 5_xi, 6_xi, 7_xi, 8_xi, 9_xi, 10_xi, 11_xi /)
    TYPE(xt_com_list) ::  src_com(1), dst_com(1)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap, xmap_single_level_blocked, xmap_multi_level_blocked
    INTEGER :: i, idx, blk, lev
    INTEGER, PARAMETER :: nproma = 4, nblk = 3, nlev = 6
    INTEGER, SAVE, TARGET :: blocked_positions(72)
    INTEGER :: displacements(6)
    TYPE(test_message) :: recv_messages(1), send_messages(1)

    ! setup
    src_idxlist = xt_idxvec_new(indices)
    dst_idxlist = xt_idxvec_new(indices)
    src_com(1)%list = xt_idxvec_new(indices)
    src_com(1)%rank = MOD(my_rank + 1, comm_size)
    dst_com(1)%list = xt_idxvec_new(indices)
    dst_com(1)%rank = MOD(comm_size + my_rank - 1, comm_size)
    xmap = xmi_new(src_com, dst_com, src_idxlist, dst_idxlist, mpi_comm_world)

    i = 1
    DO lev = 0, nlev - 1
      DO blk = 0, nblk - 1
        DO idx = 0, nproma - 1
          blocked_positions(i) = idx + (blk * nlev + lev) * nproma
          i = i + 1
        END DO
      END DO
    END DO
    DO i = 1, nlev
      displacements(i) = (i - 1) * nproma
    END DO

    xmap_single_level_blocked = &
      xt_xmap_update_positions(xmap, blocked_positions, blocked_positions);
    xmap_multi_level_blocked = &
      xt_xmap_spread( &
        xmap_single_level_blocked, nlev, displacements, displacements);

    send_messages(1)%rank = MOD(my_rank + 1, comm_size)
    send_messages(1)%pos => blocked_positions
    recv_messages(1)%rank = MOD(comm_size + my_rank - 1, comm_size)
    recv_messages(1)%pos => blocked_positions

    ! test
    CALL test_xmap(xmap_multi_level_blocked, send_messages, recv_messages)

    ! cleanup
    CALL xt_xmap_delete(xmap_multi_level_blocked)
    CALL xt_xmap_delete(xmap_single_level_blocked)
    CALL xt_xmap_delete(xmap)
    CALL xt_idxlist_delete(dst_idxlist)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_com(1)%list)
    CALL xt_idxlist_delete(src_com(1)%list)
  END SUBROUTINE update_positions_and_spread_test

  ! checks xt_xmap_intersection_pos_new constructor
  SUBROUTINE alltoall_pos_test

    TYPE(xt_xmap) :: xmap
    TYPE(xt_com_pos), TARGET :: src_com(comm_size), dst_com(comm_size)
    INTEGER, TARGET :: transfer_pos(comm_size)
    TYPE(test_message) :: recv_messages(comm_size), send_messages(comm_size)
    INTEGER :: i

    DO i = 1, comm_size
      transfer_pos(i) = i
      src_com(i)%transfer_pos => transfer_pos(i:i)
      src_com(i)%rank = i - 1
      dst_com(i)%transfer_pos => transfer_pos(i:i)
      dst_com(i)%rank = i - 1
      send_messages(i)%rank = i - 1
      send_messages(i)%pos => transfer_pos(i:i)
      recv_messages(i)%rank = i - 1
      recv_messages(i)%pos => transfer_pos(i:i)
    END DO

    xmap = xt_xmap_intersection_pos_new(src_com, dst_com, mpi_comm_world)

    ! test
    CALL test_xmap(xmap, send_messages, recv_messages)

    ! cleanup
    CALL xt_xmap_delete(xmap)
  END SUBROUTINE alltoall_pos_test

  SUBROUTINE test_xmap_iter(iter, msgs)
    TYPE(xt_xmap_iter), INTENT(inout) :: iter
    TYPE(test_message), INTENT(in) :: msgs(:)

    INTEGER :: num_msgs, num_pos, num_pos_ext, i, j, ofs, pe, pos_ext_size
    INTEGER, POINTER :: pos(:)
    TYPE(xt_pos_ext), POINTER :: pos_ext(:)
    LOGICAL :: iter_is_null, mismatch

    num_msgs = SIZE(msgs)
    iter_is_null = xt_is_null(iter)
    IF (num_msgs == 0) THEN
      IF (.NOT. iter_is_null) &
           CALL test_abort('ERROR: xt_xmap_get_*_iterator (non-null when &
           &iter should be null)', &
           filename, __LINE__)
    ELSE IF (iter_is_null) THEN
      CALL test_abort('ERROR: xt_xmap_get_*_iterator &
           &(iter should not be NULL)', &
           filename, __LINE__)
    ELSE
      i = 1
      DO WHILE(.TRUE.)
        IF (xt_xmap_iterator_get_rank(iter) /= msgs(i)%rank) &
             CALL test_abort('ERROR: xt_xmap_iterator_get_rank', &
             filename, __LINE__)
        num_pos = SIZE(msgs(i)%pos)
        IF (xt_xmap_iterator_get_num_transfer_pos(iter) /= num_pos) THEN
          CALL test_abort("ERROR: xt_xmap_iterator_get_num_transfer_pos", &
               filename, __LINE__)
        END IF
        pos => xt_xmap_iterator_get_transfer_pos(iter)
        mismatch = .FALSE.
        DO j = 1, num_pos
          mismatch = mismatch .OR. pos(j) /= msgs(i)%pos(j)
        END DO
        IF (mismatch) &
             CALL test_abort('ERROR: xt_xmap_iterator_get_transfer_pos', &
             filename, __LINE__)

        num_pos_ext = xt_xmap_iterator_get_num_transfer_pos_ext(iter)
        pos_ext => xt_xmap_iterator_get_transfer_pos_ext(iter)
        ofs = 0
        mismatch = .FALSE.
        DO pe = 1, num_pos_ext
          pos_ext_size = ABS(pos_ext(pe)%size)
          IF (pos_ext(pe)%size > 0) THEN
            DO j = 1, pos_ext_size
              mismatch = mismatch .OR. pos(ofs+j) /= pos_ext(pe)%start + j - 1
            END DO
          ELSE
            DO j = 1, pos_ext_size
              mismatch = mismatch .OR. pos(ofs+j) /= pos_ext(pe)%start - j + 1
            END DO
          END IF
          ofs = ofs + pos_ext_size
        END DO
        IF (mismatch .OR. ofs /= num_pos) &
             CALL test_abort('ERROR: xt_xmap_iterator_get_transfer_pos_ext', &
             filename, __LINE__)

        IF (.NOT. xt_xmap_iterator_next(iter)) EXIT
        i = i + 1
      END DO
      IF (i /= num_msgs) &
           CALL test_abort('ERROR: xt_xmap_iterator_next &
           &(wrong number of messages)', &
           filename, __LINE__)
    END IF
  END SUBROUTINE test_xmap_iter

  SUBROUTINE test_xmap(xmap, send_messages, recv_messages)
    TYPE(xt_xmap), INTENT(in) :: xmap
    TYPE(test_message), INTENT(in) :: send_messages(:), recv_messages(:)

    INTEGER :: num_sends, num_recvs
    TYPE(xt_xmap_iter) :: send_iter, recv_iter
    INTEGER, PARAMETER :: num_xmaps_2_test = 2
    INTEGER :: i
    TYPE(xt_xmap) :: maps(num_xmaps_2_test)

    maps(1) = xmap
    maps(2) = xt_xmap_copy(xmap)
    DO i = 1, num_xmaps_2_test
      num_sends = SIZE(send_messages)
      num_recvs = SIZE(recv_messages)
      IF (xt_xmap_get_num_destinations(maps(i)) /= num_sends) &
           CALL test_abort('ERROR: xt_xmap_get_num_destinations', filename, &
           __LINE__)
      IF (xt_xmap_get_num_sources(maps(i)) /= num_recvs) &
           CALL test_abort('ERROR: xt_xmap_get_num_sources', filename, __LINE__)
      send_iter = xt_xmap_get_out_iterator(maps(i))
      recv_iter = xt_xmap_get_in_iterator(maps(i))

      CALL test_xmap_iter(send_iter, send_messages)
      CALL test_xmap_iter(recv_iter, recv_messages)

      IF (.NOT. xt_is_null(recv_iter)) CALL xt_xmap_iterator_delete(recv_iter)
      IF (.NOT. xt_is_null(send_iter)) CALL xt_xmap_iterator_delete(send_iter)
    END DO
    CALL xt_xmap_delete(maps(2))
  END SUBROUTINE test_xmap

  SUBROUTINE parse_options
    INTEGER :: i, num_cmd_args, arg_len
    INTEGER, PARAMETER :: max_opt_arg_len = 80
    CHARACTER(max_opt_arg_len) :: optarg
    num_cmd_args = COMMAND_ARGUMENT_COUNT()
    i = 1
    DO WHILE (i < num_cmd_args)
      CALL GET_COMMAND_ARGUMENT(i, optarg, arg_len)
      IF (optarg(1:2) == '-m' .AND. i < num_cmd_args .AND. arg_len == 2) THEN
        CALL GET_COMMAND_ARGUMENT(i + 1, optarg, arg_len)
        IF (arg_len > max_opt_arg_len) &
             CALL test_abort('incorrect argument to command-line option -m', &
             filename, __LINE__)
        IF (optarg(1:arg_len) == "xt_xmap_intersection_new") THEN
          xmi_type = xmi_type_base
        ELSE IF (optarg(1:arg_len) == "xt_xmap_intersection_ext_new") THEN
          xmi_type = xmi_type_ext
        ELSE
          WRITE (0, *) 'arg to -m: ', optarg(1:arg_len)
          CALL test_abort('incorrect argument to command-line option -m', &
               filename, __LINE__)
        END IF
        i = i + 2
      ELSE
        WRITE (0, *) 'unexpected command-line argument parsing error: ', &
             TRIM(optarg)
        FLUSH(0)
        CALL test_abort('unexpected command-line argument -m', filename, &
             __LINE__)
      END IF
    END DO
  END SUBROUTINE parse_options

  FUNCTION xmi_new(src_com, dst_com, src_idxlist, dst_idxlist, comm) &
       RESULT(xmap)
    TYPE(xt_com_list), INTENT(in) :: src_com(:), dst_com(:)
    TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_xmap) :: xmap
    SELECT CASE(xmi_type)
    CASE(xmi_type_base)
      xmap = xt_xmap_intersection_new(src_com, dst_com, &
           src_idxlist, dst_idxlist, comm)
    CASE(xmi_type_ext)
      xmap = xt_xmap_intersection_ext_new(src_com, dst_com, &
           src_idxlist, dst_idxlist, comm)
    END SELECT
  END FUNCTION xmi_new

END PROGRAM test_xmap_intersection_parallel
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_single_array_base_parallel_f.f90
!!
!! @copyright Copyright  (C)  2017 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_redist_single_array_base_parallel_f
  USE mpi
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_redist_msg, &
       xt_config, xt_config_delete

  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_redist_common, ONLY: &
       test_redist_single_array_base, redist_exchanger_option
  USE test_idxlist_utils, ONLY: test_err_count
  IMPLICIT NONE

  CHARACTER(len=*), PARAMETER :: &
       filename = 'test_redist_single_array_base_parallel_f.f90'
  TYPE(xt_config) :: config

  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  CALL test_round_robin(mpi_comm_world, config)
  CALL test_allgather(mpi_comm_world, config)
  CALL test_scatter(mpi_comm_world, config)

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)

  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi


CONTAINS

  SUBROUTINE test_round_robin(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config

    TYPE(xt_redist_msg) :: send_msgs(1), recv_msgs(1)

    INTEGER, PARAMETER :: num_elem = 1
    DOUBLE PRECISION :: src_data(num_elem)
    DOUBLE PRECISION :: ref_dst_data(num_elem)
    INTEGER :: comm_rank, comm_size, ierror

    CALL mpi_comm_rank(mpi_comm_world, comm_rank, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)
    CALL mpi_comm_size(comm, comm_size, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)

    send_msgs(1)%rank = MOD(comm_rank + 1, comm_size)
    send_msgs(1)%datatype = MPI_DOUBLE_PRECISION
    recv_msgs(1)%rank = MOD(comm_rank + comm_size - 1, comm_size)
    recv_msgs(1)%datatype = MPI_DOUBLE_PRECISION

    src_data(1) = DBLE(comm_rank)
    ref_dst_data(1) = DBLE(MOD(comm_rank + comm_size - 1, comm_size))

    CALL test_redist_single_array_base(send_msgs, recv_msgs, src_data, &
         ref_dst_data, comm, config)

  END SUBROUTINE test_round_robin

  SUBROUTINE test_allgather(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config

    TYPE(xt_redist_msg), ALLOCATABLE :: send_msgs(:), recv_msgs(:)

    DOUBLE PRECISION :: src_data(1)
    DOUBLE PRECISION, ALLOCATABLE :: ref_dst_data(:)

    INTEGER :: comm_rank, comm_size, i, ierror

    CALL mpi_comm_rank(mpi_comm_world, comm_rank, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)

    CALL mpi_comm_size(mpi_comm_world, comm_size, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)

    ALLOCATE(send_msgs(comm_size), recv_msgs(comm_size), &
         ref_dst_data(comm_size))
    DO i = 1, comm_size
      send_msgs(i)%rank = i - 1
      send_msgs(i)%datatype = MPI_DOUBLE_PRECISION
      recv_msgs(i)%rank = i - 1
      CALL MPI_Type_create_indexed_block( &
           1, 1, (/i - 1/), MPI_DOUBLE_PRECISION, recv_msgs(i)%datatype, ierror)
      IF (ierror /= mpi_success) &
           CALL test_abort("error calling mpi_type_create_indexed_block", &
           filename, __LINE__)
      CALL MPI_Type_commit(recv_msgs(i)%datatype, ierror)
      IF (ierror /= mpi_success) &
           CALL test_abort("error calling mpi_type_commit", filename, __LINE__)
    END DO

    src_data(1) = DBLE(comm_rank)
    DO i = 1, comm_size
      ref_dst_data(i) = DBLE(i-1)
    END DO

    CALL test_redist_single_array_base(send_msgs, recv_msgs, src_data, &
         ref_dst_data, comm, config)

    DO i = 1, comm_size
      CALL MPI_Type_free(recv_msgs(i)%datatype, ierror)
      IF (ierror /= mpi_success) &
           CALL test_abort("error calling mpi_type_free", filename, __LINE__)
    END DO

  END SUBROUTINE test_allgather

  SUBROUTINE test_scatter(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config

    TYPE(xt_redist_msg), ALLOCATABLE :: send_msgs(:)
    TYPE(xt_redist_msg) :: recv_msgs(1)

    DOUBLE PRECISION, ALLOCATABLE :: src_data(:)
    DOUBLE PRECISION :: ref_dst_data(1)

    INTEGER :: comm_size, comm_rank, i, ierror, nsend, rank, displ(1)

    CALL mpi_comm_rank(mpi_comm_world, comm_rank, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)
    ref_dst_data(1) = DBLE(comm_rank)

    CALL mpi_comm_size(mpi_comm_world, comm_size, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)

    nsend = MERGE(comm_size, 0, comm_rank == 0)
    ALLOCATE(send_msgs(nsend))
    DO i = 1, nsend
      rank = i - 1
      send_msgs(i)%rank = rank
      displ(1) = rank
      CALL MPI_Type_create_indexed_block( &
           1, 1, displ, MPI_DOUBLE_PRECISION, send_msgs(i)%datatype, ierror)
      IF (ierror /= mpi_success) &
           CALL test_abort("error calling mpi_type_create_indexed_block", &
           filename, __LINE__)
      CALL MPI_Type_commit(send_msgs(i)%datatype, ierror)
      IF (ierror /= mpi_success) &
           CALL test_abort("error calling mpi_type_commit", filename, __LINE__)
    END DO
    recv_msgs(1)%rank = 0
    recv_msgs(1)%datatype = MPI_DOUBLE_PRECISION

    ALLOCATE(src_data(nsend))
    DO i = 1, nsend
      src_data(i) = DBLE(i-1)
    END DO

    CALL test_redist_single_array_base(send_msgs, recv_msgs, src_data, &
         ref_dst_data, comm, config)

    DO i = 1, nsend
      CALL MPI_Type_free(send_msgs(i)%datatype, ierror)
      IF (ierror /= mpi_success) &
           CALL test_abort("error calling mpi_type_free", filename, __LINE__)
    END DO

  END SUBROUTINE test_scatter

END PROGRAM test_redist_single_array_base_parallel_f
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_xmap_dist_dir_f.f90
!! @brief Fortran test of distributed directory
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_xmap_dist_dir
  USE xt_xmap_abstract, ONLY: xt_xmap_dist_dir_new
  USE test_xmap_common, ONLY: xmap_self_test_main
  IMPLICIT NONE
  CALL xmap_self_test_main(xt_xmap_dist_dir_new)
END PROGRAM test_xmap_dist_dir
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_repeat_parallel_f.f90
!! @brief Parallelized Fortran test of redist_repeat class
!!
!! @copyright Copyright  (C)  2013 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_redist_repeat_parallel
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_int_kind, xi => xt_int_kind, &
       xt_idxlist, xt_idxlist_delete, xt_stripe, &
       xt_idxfsection_new, xt_idxlist_collection_new, xt_idxstripes_new, &
       xt_xmap, xt_xmap_all2all_new, xt_xmap_delete, &
       xt_redist, xt_redist_p2p_new, xt_redist_repeat_new, &
       xt_redist_delete, xt_redist_s_exchange, &
       xt_idxlist_get_indices, xt_int_mpidt, &
       xt_request, xt_redist_a_exchange, xt_config, xt_config_delete, &
       xt_config_set_ddt_cache_limit
    ! older PGI compilers do not handle generic interface correctly
#if defined __PGI
  USE xt_redist_int_i2, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
  USE xt_redist_int_i4, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
  USE xt_redist_int_i8, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
#endif
  USE test_redist_common, ONLY: check_wait_request, redist_exchanger_option
  USE iso_c_binding, ONLY: c_int
  IMPLICIT NONE
  CHARACTER(len=*), PARAMETER :: filename = 'test_redist_repeat_parallel_f.f90'
  CHARACTER(len=*), PARAMETER :: err_msg(2) = &
       (/ "error on xt_redist_s_exchange", "error on xt_redist_a_exchange" /)
  INTEGER, PARAMETER :: ddt_gen_lim(4) = (/ -1, 0, 16, -2 /)
  TYPE(xt_config) :: config
  INTEGER :: comm_size, ierror
  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  CALL mpi_comm_size(mpi_comm_world, comm_size, ierror)
  IF (ierror /= MPI_SUCCESS) &
       CALL test_abort('mpi_comm_size failed', filename, __LINE__)

  IF (comm_size > 1) THEN
    CALL test_4redist(mpi_comm_world, config, 2*comm_size**2)
  END IF

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi
CONTAINS
  ! create index lists to exchange data sections from a global 4D
  ! array.
  !
  ! For the source side, the global array is of size W x X x Y x Z,
  ! where W=X=Y=comm_size and Z=2. The source data is decomposed
  ! into two shards of size comm_size*comm_size per process, where one
  ! shard is positioned at (1, comm_rank, 1, 1), the other at (1,
  ! comm_size-comm_rank, 1, 2), i.e. the decomposition of the last
  ! dimension is decomposed anti-symmetrically.
  !
  ! The destination decomposition is a contiguous subset of the
  ! interval [0,W*X*Y*Z-1], the stripe [S, S+2*comm_size^2] with S =
  ! comm_rank * 2 * comm_size**2. This corresponds to a section of a
  ! 4D array reshaped to [W,X,Z,Y], decomposed along the Y-axis
  ! according to comm_rank (but enumerated differently from source
  ! array).
  SUBROUTINE build_idxlists(indices_a, indices_b, comm_size, comm_rank)
    TYPE(xt_idxlist), INTENT(out) :: indices_a, indices_b
    INTEGER, INTENT(in) :: comm_size, comm_rank

    INTEGER, PARAMETER :: glob_rank = 4
    TYPE(xt_idxlist) :: indices_a_(2)
    INTEGER :: i
    INTEGER(xt_int_kind), PARAMETER :: start = 0
    INTEGER(xt_int_kind) :: global_size(glob_rank), local_start(glob_rank, 2)
    INTEGER :: local_size(glob_rank)

    TYPE(xt_stripe) :: stripe

    global_size(1) = INT(comm_size, xi)
    global_size(2) = INT(comm_size, xi)
    global_size(3) = INT(comm_size, xi)
    global_size(4) = 2_xi
    local_size(1) = comm_size
    local_size(2) = 1
    local_size(3) = comm_size
    local_size(4) = 1
    local_start(1, 1) = 1_xi
    local_start(2, 1) = INT(comm_rank + 1, xi)
    local_start(3, 1) = 1_xi
    local_start(4, 1) = 1_xi
    !
    local_start(1, 2) = 1_xi
    local_start(2, 2) = INT(comm_size-comm_rank, xi)
    local_start(3, 2) = 1_xi
    local_start(4, 2) = 2_xi

    DO i = 1, 2
      indices_a_(i) = xt_idxfsection_new(start, global_size, local_size, &
           local_start(:, i))
    END DO
    indices_a = xt_idxlist_collection_new(indices_a_)

    CALL xt_idxlist_delete(indices_a_(1))
    CALL xt_idxlist_delete(indices_a_(2))

    stripe = xt_stripe(start = INT(comm_rank * 2 * comm_size**2, xi), &
         &             stride = 1_xi, &
         &             nstrides = INT(2*comm_size**2, c_int))
    indices_b = xt_idxstripes_new(stripe)
  END SUBROUTINE build_idxlists

  ! redist test for 4 level repetition of redist (i.e. 3D extension of 2D
  ! redist)
  SUBROUTINE test_4redist(comm, config, dim1)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    INTEGER, INTENT(in) :: dim1
    TYPE(xt_idxlist) :: indices_a, indices_b
    INTEGER(xt_int_kind) :: index_vector_a(dim1), &
                            index_vector_b(dim1)
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist_repeat(2), redist_p2p
    INTEGER, PARAMETER :: dim2a = 9, rpt_cnt = 4
    INTEGER(xt_int_kind) :: results_1(dim1,rpt_cnt), &
                            results_2(dim1,dim2a), dim1_xi
    INTEGER(xt_int_kind) :: input_data(dim1,dim2a)
    INTEGER(xt_int_kind) :: ref_results_1(dim1,rpt_cnt), &
                            ref_results_2(dim1,dim2a)
    INTEGER(mpi_address_kind) :: extent
    INTEGER(mpi_address_kind) :: base_address, temp_address
    INTEGER(c_int), PARAMETER :: &
         displacements(rpt_cnt, 2) &
         = RESHAPE((/ 0_c_int, 1_c_int, 2_c_int, 3_c_int, &
         &            1_c_int, 2_c_int, 4_c_int, 8_c_int /), (/ rpt_cnt, 2 /))
    ! skip_lev_2 must correspond to the levels skipped via displacements_2
    LOGICAL, PARAMETER :: skip_lev_2(9) &
         = (/  .TRUE., .FALSE., .FALSE., &
         &     .TRUE., .FALSE.,  .TRUE., &
         &     .TRUE.,  .TRUE., .FALSE. /)
    INTEGER :: i, j, ierror
    TYPE(xt_request) :: request1, request2
    INTEGER :: iexch, ddt_gen_test
    INTEGER :: comm_rank, comm_size

    CALL mpi_comm_rank(comm, comm_rank, ierror)
    IF (ierror /= MPI_SUCCESS) &
         CALL test_abort('mpi_comm_rank failed', filename, __LINE__)
    CALL mpi_comm_size(comm, comm_size, ierror)
    IF (ierror /= MPI_SUCCESS) &
         CALL test_abort('mpi_comm_size failed', filename, __LINE__)

    CALL build_idxlists(indices_a, indices_b, comm_size, comm_rank)

    CALL xt_idxlist_get_indices(indices_a, index_vector_a)
    CALL xt_idxlist_get_indices(indices_b, index_vector_b)

    xmap = xt_xmap_all2all_new(indices_a, indices_b, comm)

    CALL xt_idxlist_delete(indices_a)
    CALL xt_idxlist_delete(indices_b)

    CALL mpi_get_address(input_data(1,1), base_address, ierror)
    CALL mpi_get_address(input_data(1,2), temp_address, ierror)
    extent = temp_address - base_address

    dim1_xi = INT(dim1, xi)
    DO j = 1, dim2a
      DO i = 1, dim1
        input_data(i, j) = index_vector_a(i) + INT(j-1, xi) * 2_xi * dim1_xi
      END DO
    END DO

    DO j = 1, rpt_cnt
      DO i = 1, dim1
        ref_results_1(i, j) = index_vector_b(i) + INT(j-1, xi) * 2_xi * dim1_xi
      END DO
    END DO
    DO j = 1, dim2a
      IF (skip_lev_2(j)) THEN
        ref_results_2(:, j) = -1_xi
      ELSE
        DO i = 1, dim1
          ref_results_2(i, j) &
               = index_vector_b(i) + INT(j-1, xi) * 2_xi * dim1_xi
        END DO
      END IF
    END DO

    DO ddt_gen_test = 1, SIZE(ddt_gen_lim)
      CALL xt_config_set_ddt_cache_limit(config, ddt_gen_lim(ddt_gen_test))

      redist_p2p = xt_redist_p2p_new(xmap, xt_int_mpidt)

      DO i = 1, 2
        redist_repeat(i) = xt_redist_repeat_new(redist_p2p, extent, extent, &
             rpt_cnt, displacements(:, i), config)
      END DO
      CALL xt_redist_delete(redist_p2p)

      DO iexch = 1, 2
        results_1 = -1
        results_2 = -1

        IF (iexch == 1) THEN
          CALL xt_redist_s_exchange(redist_repeat(1), input_data, results_1)
          CALL xt_redist_s_exchange(redist_repeat(2), input_data, results_2)
        ELSE
          CALL xt_redist_a_exchange(redist_repeat(1), input_data, results_1, &
               request1)
          CALL xt_redist_a_exchange(redist_repeat(2), input_data, results_2, &
               request2)
          CALL check_wait_request(request1, filename, __LINE__)
          CALL check_wait_request(request2, filename, __LINE__)
        ENDIF

        ! check results
        IF (ANY(results_1 /= ref_results_1)) &
             CALL test_abort(err_msg(iexch), filename, __LINE__)
        IF (ANY(results_2 /= ref_results_2)) &
             CALL test_abort(err_msg(iexch), filename, __LINE__)
      ENDDO

      ! clean up
      CALL xt_redist_delete(redist_repeat)
    END DO
    CALL xt_xmap_delete(xmap)
  END SUBROUTINE test_4redist

END PROGRAM test_redist_repeat_parallel
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file yaxt.f90
!! @brief Fortran interface to yaxt implementation
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"

MODULE yaxt
  !
  ! Fortran interface to yaxt implementation
  !
  USE xt_core, ONLY: i4, xt_int_kind, xt_int_mpidt, &
       xt_abort, xt_initialize, xt_get_default_comm, xt_stripe, xt_bounds, &
       char, xt_finalize, xt_initialized, xt_finalized, xt_slice_c_loc, &
       xt_pos_ext, OPERATOR(/=), OPERATOR(==), &
       xt_direction_send, xt_direction_recv, &
       xt_set_abort_handler => set_abort_handler, xt_restore_default_abort_hndl
  USE xt_config_f, ONLY: xt_config, xt_config_new, xt_config_delete, &
       xt_exchanger_id_by_name, &
       xt_config_get_exchange_method, xt_config_set_exchange_method, &
       xt_exchanger_irecv_send, xt_exchanger_irecv_isend, &
       xt_exchanger_irecv_isend_packed, xt_exchanger_mix_isend_irecv, &
       xt_exchanger_neigh_alltoall, &
       xt_config_get_idxvec_autoconvert_size, &
       xt_config_set_idxvec_autoconvert_size, &
       xt_config_get_redist_mthread_mode, &
       xt_config_set_redist_mthread_mode, &
       xt_mt_none, xt_mt_openmp, &
       xt_config_get_sort_algorithm_id, &
       xt_config_set_sort_algorithm_by_id, &
       xt_config_set_mem_saving, &
       xt_config_get_mem_saving, &
       xt_config_set_xmdd_bucket_gen, &
       xt_config_get_xmdd_bucket_gen, &
       xt_config_get_xmap_stripe_align, &
       xt_config_set_xmap_stripe_align, &
       xt_exch_send_standard, &
       xt_exch_send_buffered, &
       xt_exch_send_synchronous, &
       xt_config_set_exchange_send_comm_mode, &
       xt_config_get_exchange_send_comm_mode, &
       xt_exchanger_irecv_isend_ddt_packed, &
       xt_config_get_ddt_cache_limit, xt_config_set_ddt_cache_limit, &
       xt_config_ddt_cache_none, xt_config_ddt_cache_unlimited, &
       xt_config_ddt_cache_no_parse, xt_config_ddt_cache_no_match, &
       xt_config_ddt_no_cache_no_parse
  USE xt_sort, ONLY: xt_sort_int, xt_sort_index, xt_sort_idxpos, &
       xt_sort_permutation, xt_assign_id_map
  USE xt_idxlist_abstract, ONLY: &
       xt_idxlist_f2c, xt_idxlist_c2f, xt_idxlist, &
       xt_idxlist_delete, xt_idxlist_get_pack_size, &
       xt_idxlist_pack => xt_idxlist_pack_f, &
       xt_idxlist_unpack => xt_idxlist_unpack_f, xt_idxlist_copy, &
       xt_idxlist_get_sorting, &
       xt_idxlist_sorted_copy, xt_idxlist_sorted_copy_custom, &
       xt_idxlist_get_index_at_position, xt_idxlist_get_indices_at_positions, &
       xt_idxlist_get_position_of_index, xt_idxlist_get_position_of_index_off, &
       xt_idxlist_get_positions_of_indices, &
       xt_idxlist_get_num_index_stripes, xt_idxlist_get_index_stripes, &
       xt_idxlist_get_bounding_box, xt_idxlist_get_intersection, &
       xt_idxlist_get_num_indices, xt_is_null, &
       xt_idxlist_get_min_index, xt_idxlist_get_max_index, &
       xt_idxlist_get_indices, xt_idxlist_get_indices_const, &
       xt_idxlist_get_pos_exts_of_index_stripes, &
       xt_idxlist_is_stripe_conversion_profitable
  USE xt_idxvec, ONLY: xt_idxvec_from_stripes_new, xt_idxvec_new
  USE xt_idxstripes, ONLY: xt_idxstripes_new, xt_idxstripes_from_idxlist_new
  USE xt_idxsection, ONLY: xt_idxsection_new, xt_idxfsection_new
  USE xt_idxlist_collection, ONLY: xt_idxlist_collection_new
  USE xt_xmap_abstract, ONLY: xt_xmap, xt_xmap_c2f, xt_xmap_f2c, &
       xt_xmap_delete, xt_xmap_get_num_destinations, xt_xmap_get_num_sources, &
       xt_xmap_copy, xt_xmap_get_destination_ranks, xt_xmap_get_source_ranks, &
       xt_xmap_get_max_src_pos, xt_xmap_get_max_dst_pos, &
       xt_xmap_all2all_custom_new, xt_xmap_dist_dir_custom_new, xt_is_null, &
       xt_xmap_dist_dir_intercomm_custom_new, &
       xt_xmap_iter, xt_xmap_get_in_iterator, xt_xmap_get_out_iterator, &
       xt_xmap_iterator_next, xt_xmap_iterator_get_rank, &
       xt_xmap_iterator_get_transfer_pos, &
       xt_xmap_iterator_get_num_transfer_pos, xt_xmap_iterator_delete, &
       xt_xmap_iterator_get_transfer_pos_ext, &
       xt_xmap_iterator_get_num_transfer_pos_ext, &
       xt_xmap_reorder, xt_xmap_reorder_custom, &
       xt_reorder_type_kind, XT_REORDER_NONE, XT_REORDER_SEND_UP, &
       XT_REORDER_RECV_UP, xt_xmap_update_positions, xt_xmap_spread
  USE xt_xmap_rename, ONLY: xt_xmap_all2all_new, xt_xmap_dist_dir_new, &
       xt_xmap_dist_dir_intercomm_new
  USE xt_xmap_dist_dir_bucket_gen, ONLY: xt_xmdd_bucket_gen, &
       xt_xmdd_bucket_gen_new, xt_xmdd_bucket_gen_delete, &
       xt_xmdd_bucket_gen_c2f, xt_xmdd_bucket_gen_f2c, &
       xt_is_null
#ifdef XT_HAVE_FC_HLF_STRUCT_RETURN
  USE xt_xmap_dist_dir_bucket_gen2, ONLY: &
       xt_xmdd_bucket_gen_define_interface, &
       xt_xmdd_bucket_gen_define_interface_f, &
       xt_xmdd_bucket_gen_comms, &
       xt_dist_dir_bucket_gen_type_send, &
       xt_dist_dir_bucket_gen_type_recv, &
       xt_dist_dir_bucket_gen_type_sendrecv, &
       xt_xmdd_bucket_gen_get_init_params, &
       xt_xmdd_bucket_gen_set_init_params, &
       xt_xmdd_bucket_gen_set_init, &
       xt_xmdd_bucket_gen_set_extended_init_params
#  if defined HAVE_FC_C_FUNLOC && defined HAVE_FC_ABSTRACT_INTERFACE
  USE xt_xmap_dist_dir_bucket_gen2, ONLY: xt_xmdd_bucket_gen_get_init
#  endif
#  ifdef HAVE_FC_C_FUNLOC
  USE xt_xmap_dist_dir_bucket_gen2, ONLY: xt_xmdd_bucket_gen_def_if_f2c
#  endif
#  ifdef HAVE_FC_ABSTRACT_INTERFACE
  USE xt_xmap_dist_dir_bucket_gen2, ONLY: xt_xmdd_bucket_gen_init_state
#  endif
#endif
  USE xt_xmap_intersection, ONLY: xt_xmap_intersection_new, &
       xt_xmap_intersection_ext_new, xt_com_list, &
       xt_xmap_intersection_pos_new, xt_com_pos
  USE xt_redist_base, ONLY: xt_redist, xt_redist_c2f, xt_redist_f2c, &
       xt_redist_copy, xt_redist_p2p_custom_new, &
       xt_redist_delete, xt_redist_s_exchange1, xt_redist_s_exchange, &
       xt_redist_p2p_off_new, xt_redist_p2p_off_custom_new, &
       xt_redist_p2p_blocks_new, xt_redist_p2p_blocks_custom_new, &
       xt_redist_p2p_blocks_off_new, xt_redist_p2p_blocks_off_custom_new, &
       xt_redist_collection_static_new, xt_redist_collection_new, &
       xt_redist_repeat_new, xt_is_null, xt_redist_get_mpi_comm, &
       xt_offset_ext, xt_redist_p2p_ext_new, xt_redist_msg, &
       xt_aoffset_ext, xt_redist_p2p_aext_new, &
       xt_redist_a_exchange1, xt_redist_a_exchange, &
       xt_redist_single_array_base_new, &
       xt_redist_single_array_base_custom_new, &
       xt_redist_get_recv_mpi_datatype, xt_redist_get_send_mpi_datatype, &
       xt_redist_get_num_send_msg, xt_redist_get_num_recv_msg
  USE xt_redist_rename, ONLY: xt_redist_p2p_new
  USE xt_redist_int_i2, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
  USE xt_redist_int_i4, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
  USE xt_redist_int_i8, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
  USE xt_redist_logical, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
  USE xt_redist_real_sp, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
  USE xt_redist_real_dp, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
  USE xt_requests, ONLY: xt_request, xt_request_wait, xt_request_test, &
       xt_is_null, xt_request_null
  USE xt_mpi, ONLY: xt_mpi_comm_mark_exclusive, xt_mpi_fint_kind

  USE iso_c_binding, ONLY: c_int, c_ptr, c_null_ptr, c_loc
  IMPLICIT NONE

  PRIVATE

  PUBLIC :: xt_initialize, xt_finalize, xt_abort, xt_get_default_comm, &
       xt_initialized, xt_finalized, &
       xt_direction_send, xt_direction_recv, &
       xt_set_abort_handler, xt_restore_default_abort_hndl, &
       xt_int_kind, xt_int_mpidt, xt_stripe, xt_bounds, xt_pos_ext
  PUBLIC :: xt_idxlist, xt_idxlist_delete,  &
       xt_idxlist_c2f, xt_idxlist_f2c, xt_idxlist_copy, &
       xt_idxlist_get_sorting, &
       xt_idxlist_sorted_copy, xt_idxlist_sorted_copy_custom, &
       xt_idxlist_get_pack_size, xt_idxlist_pack, xt_idxlist_unpack, &
       xt_idxlist_get_intersection, xt_idxlist_get_positions_of_indices, &
       xt_idxlist_get_index_at_position, xt_idxlist_get_indices_at_positions, &
       xt_idxlist_get_position_of_index, xt_idxlist_get_position_of_index_off, &
       xt_idxlist_get_num_indices, &
       xt_idxlist_get_min_index, xt_idxlist_get_max_index, &
       xt_idxlist_get_indices, xt_idxlist_get_indices_const, &
       xt_idxlist_get_num_index_stripes, xt_idxlist_get_index_stripes, &
       xt_idxlist_get_bounding_box, &
       xt_idxlist_get_pos_exts_of_index_stripes, &
       xt_idxlist_is_stripe_conversion_profitable
  PUBLIC :: xt_idxvec_new, xt_idxvec_from_stripes_new, &
       xt_idxstripes_new, xt_idxstripes_from_idxlist_new, &
       xt_idxlist_collection_new, xt_idxsection_new, xt_idxfsection_new, &
       xt_idxmod_new, xt_xmap, xt_xmap_c2f, xt_xmap_f2c, xt_xmap_copy, &
       xt_xmap_delete, xt_xmap_get_num_destinations, &
       xt_xmap_get_num_sources, xt_xmap_get_destination_ranks, &
       xt_xmap_get_source_ranks, &
       xt_xmap_get_max_src_pos, xt_xmap_get_max_dst_pos, &
       xt_xmap_intersection_new, xt_xmap_intersection_ext_new, &
       xt_xmap_intersection_pos_new, &
       xt_xmap_reorder, xt_xmap_reorder_custom, &
       xt_reorder_type_kind, &
       XT_REORDER_NONE, XT_REORDER_SEND_UP, XT_REORDER_RECV_UP, &
       xt_xmap_update_positions, xt_xmap_spread, &
       xt_com_list, xt_com_pos, &
       xt_xmap_iter, xt_xmap_get_in_iterator, xt_xmap_get_out_iterator, &
       xt_xmap_iterator_next, xt_xmap_iterator_get_rank, &
       xt_xmap_iterator_get_transfer_pos, &
       xt_xmap_iterator_get_num_transfer_pos, xt_xmap_iterator_delete, &
       xt_xmap_iterator_get_transfer_pos_ext, &
       xt_xmap_iterator_get_num_transfer_pos_ext, &
       xt_redist, xt_redist_f2c, xt_redist_c2f, &
       xt_redist_msg, &
       xt_offset_ext, xt_redist_p2p_ext_new, &
       xt_aoffset_ext, xt_redist_p2p_aext_new, &
       xt_redist_repeat_new, xt_redist_copy, xt_redist_delete, &
       xt_redist_s_exchange1, xt_redist_s_exchange, &
       xt_redist_get_mpi_comm, &
       xt_redist_get_recv_mpi_datatype, xt_redist_get_send_mpi_datatype, &
       xt_redist_get_num_send_msg, xt_redist_get_num_recv_msg, &
       xt_idxempty_new, xt_redist_collection_static_new, &
       xt_redist_collection_new, xt_slice_c_loc, &
       xt_is_null, &
       OPERATOR(==), OPERATOR(/=), char, &
       xt_request, xt_request_null, &
       xt_request_wait, xt_request_test, xt_redist_a_exchange1, &
       xt_redist_a_exchange
  PUBLIC :: xt_mpi_fint_kind, &
       xt_mpi_comm_mark_exclusive

  PUBLIC :: xt_xmdd_bucket_gen
  PUBLIC :: xt_xmdd_bucket_gen_new, xt_xmdd_bucket_gen_delete
  PUBLIC :: xt_xmdd_bucket_gen_c2f, xt_xmdd_bucket_gen_f2c
#ifdef XT_HAVE_FC_HLF_STRUCT_RETURN
  PUBLIC :: xt_xmdd_bucket_gen_define_interface, &
       xt_xmdd_bucket_gen_comms, &
       xt_dist_dir_bucket_gen_type_send, &
       xt_dist_dir_bucket_gen_type_recv, &
       xt_dist_dir_bucket_gen_type_sendrecv, &
       xt_xmdd_bucket_gen_get_init_params, &
       xt_xmdd_bucket_gen_set_init_params, &
       xt_xmdd_bucket_gen_set_init, &
       xt_xmdd_bucket_gen_set_extended_init_params
  PUBLIC :: xt_xmdd_bucket_gen_define_interface_f
#  if defined HAVE_FC_C_FUNLOC && defined HAVE_FC_ABSTRACT_INTERFACE
  PUBLIC :: xt_xmdd_bucket_gen_get_init
#  endif
#  ifdef HAVE_FC_C_FUNLOC
  PUBLIC :: xt_xmdd_bucket_gen_def_if_f2c
#  endif
#  ifdef HAVE_FC_ABSTRACT_INTERFACE
  PUBLIC :: xt_xmdd_bucket_gen_init_state
#  endif
#endif

  PUBLIC :: xt_sort_int, xt_sort_index, xt_sort_idxpos, xt_sort_permutation, &
       xt_assign_id_map
  PUBLIC :: xt_xmap_all2all_new, xt_xmap_all2all_custom_new
  PUBLIC :: xt_xmap_dist_dir_new, xt_xmap_dist_dir_custom_new
  PUBLIC :: xt_xmap_dist_dir_intercomm_new, &
       xt_xmap_dist_dir_intercomm_custom_new

  PUBLIC :: xt_config, xt_config_new, xt_config_delete, &
       xt_exchanger_id_by_name, &
       xt_config_get_exchange_method, xt_config_set_exchange_method, &
       xt_exchanger_irecv_send, xt_exchanger_irecv_isend, &
       xt_exchanger_irecv_isend_packed, xt_exchanger_mix_isend_irecv, &
       xt_exchanger_neigh_alltoall, &
       xt_config_get_idxvec_autoconvert_size, &
       xt_config_set_idxvec_autoconvert_size, &
       xt_config_get_redist_mthread_mode, &
       xt_config_set_redist_mthread_mode, &
       xt_mt_none, xt_mt_openmp, &
       xt_config_get_sort_algorithm_id, &
       xt_config_set_sort_algorithm_by_id, &
       xt_config_set_mem_saving, &
       xt_config_get_mem_saving, &
       xt_config_set_xmdd_bucket_gen, &
       xt_config_get_xmdd_bucket_gen, &
       xt_config_get_xmap_stripe_align, &
       xt_config_set_xmap_stripe_align, &
       xt_exch_send_standard, &
       xt_exch_send_buffered, &
       xt_exch_send_synchronous, &
       xt_config_set_exchange_send_comm_mode, &
       xt_config_get_exchange_send_comm_mode, &
       xt_exchanger_irecv_isend_ddt_packed, &
       xt_config_get_ddt_cache_limit, xt_config_set_ddt_cache_limit, &
       xt_config_ddt_cache_none, xt_config_ddt_cache_unlimited, &
       xt_config_ddt_cache_no_parse, xt_config_ddt_cache_no_match, &
       xt_config_ddt_no_cache_no_parse


  PUBLIC :: xt_redist_p2p_new, xt_redist_p2p_custom_new
  PUBLIC :: xt_redist_p2p_off_new, xt_redist_p2p_off_custom_new
  PUBLIC :: xt_redist_p2p_blocks_new, xt_redist_p2p_blocks_custom_new
  PUBLIC :: xt_redist_p2p_blocks_off_new, xt_redist_p2p_blocks_off_custom_new
  PUBLIC :: xt_redist_single_array_base_new, &
       xt_redist_single_array_base_custom_new

  INTERFACE OPERATOR(==)
    MODULE PROCEDURE xt_bounds_eq
  END INTERFACE OPERATOR(==)

  INTERFACE OPERATOR(/=)
    MODULE PROCEDURE xt_bounds_ne
  END INTERFACE OPERATOR(/=)

  TYPE, BIND(C), PUBLIC :: xt_modifier
    TYPE(xt_idxlist) :: extract
    TYPE(xt_idxlist) :: subst
    INTEGER(c_int) :: mask
  END TYPE xt_modifier

  INTERFACE
    FUNCTION xt_idxmod_new_c(patch, modifier, modifier_num, mstate_ptr) &
         BIND(C, name='xt_idxmod_new') RESULT(res)
      IMPORT :: xt_int_kind, xt_modifier, c_ptr, c_int
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in) :: patch
      INTEGER(c_int), VALUE, INTENT(in) :: modifier_num
      TYPE(xt_modifier), INTENT(in) :: modifier(modifier_num)
      TYPE(c_ptr), VALUE, INTENT(in) :: mstate_ptr
      TYPE(c_ptr) :: res
    END FUNCTION xt_idxmod_new_c
  END INTERFACE

  INTERFACE xt_idxmod_new
    MODULE PROCEDURE xt_idxmod_new_a1d
    MODULE PROCEDURE xt_idxmod_new_a1d_a1d
    MODULE PROCEDURE xt_idxmod_new_a1d_i4
    MODULE PROCEDURE xt_idxmod_new_a1d_i4_a1d
    MODULE PROCEDURE xt_idxmod_new_a1d_i4_a2d
  END INTERFACE xt_idxmod_new
  CHARACTER(len=*), PARAMETER :: filename = 'yaxt.f90'
CONTAINS

  FUNCTION xt_idxempty_new() RESULT(res)
    IMPLICIT NONE
    TYPE(Xt_idxlist) :: res

    INTERFACE
      FUNCTION xt_idxempty_new_c() &
           BIND(C, name='xt_idxempty_new') RESULT(res_ptr)
        IMPORT :: c_ptr
        IMPLICIT NONE
        TYPE(c_ptr) :: res_ptr
      END FUNCTION xt_idxempty_new_c
    END INTERFACE

    res = xt_idxlist_c2f(xt_idxempty_new_c())

  END FUNCTION xt_idxempty_new

  ELEMENTAL FUNCTION xt_bounds_eq(a, b) RESULT(a_equals_b)
    TYPE(xt_bounds), INTENT(in) :: a, b
    LOGICAL :: a_equals_b
    a_equals_b = a%size == b%size .AND. a%start == b%start
  END FUNCTION xt_bounds_eq

  ELEMENTAL FUNCTION xt_bounds_ne(a, b) RESULT(a_equals_b)
    TYPE(xt_bounds), INTENT(in) :: a, b
    LOGICAL :: a_equals_b
    a_equals_b = a%size /= b%size .OR. a%start /= b%start
  END FUNCTION xt_bounds_ne

  FUNCTION xt_idxmod_new_a1d(patch, modifier) RESULT(res)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: patch
    TYPE(xt_modifier), INTENT(in) :: modifier(:)
    TYPE(Xt_idxlist) :: res

    INTEGER :: num_modifier
    INTEGER(c_int) :: num_modifier_c
    num_modifier = SIZE(modifier)
    IF (num_modifier > HUGE(1_c_int)) &
         CALL xt_abort("number of modifiers too high", filename, __LINE__)
    num_modifier_c = INT(num_modifier, c_int)
    res = xt_idxlist_c2f(xt_idxmod_new_c(xt_idxlist_f2c(patch), modifier, &
         num_modifier_c, c_null_ptr))
  END FUNCTION xt_idxmod_new_a1d

  FUNCTION xt_idxmod_new_a1d_a1d(patch, modifier, mstate) RESULT(res)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: patch
    TYPE(xt_modifier), INTENT(in) :: modifier(:)
    INTEGER(c_int), TARGET, INTENT(inout) :: mstate(*)
    TYPE(Xt_idxlist) :: res

    INTEGER :: num_modifier
    INTEGER(c_int) :: num_modifier_c
    num_modifier = SIZE(modifier)
    IF (num_modifier > HUGE(1_c_int)) &
         CALL xt_abort("number of modifiers too high", filename, __LINE__)
    num_modifier_c = INT(num_modifier, c_int)
    res = xt_idxlist_c2f(xt_idxmod_new_c(xt_idxlist_f2c(patch), modifier, &
         num_modifier_c, C_LOC(mstate)))
  END FUNCTION xt_idxmod_new_a1d_a1d

  FUNCTION xt_idxmod_new_a1d_i4(patch, modifier, num_modifier) RESULT(res)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: patch
    TYPE(xt_modifier), INTENT(in) :: modifier(*)
    INTEGER(i4), INTENT(in) :: num_modifier
    TYPE(Xt_idxlist) :: res
    INTEGER(c_int) :: num_modifier_c

    num_modifier_c = INT(num_modifier, c_int)
    res = xt_idxlist_c2f(xt_idxmod_new_c(xt_idxlist_f2c(patch), modifier, &
         num_modifier_c, c_null_ptr))
  END FUNCTION xt_idxmod_new_a1d_i4

  FUNCTION xt_idxmod_new_a1d_i4_a1d(patch, modifier, num_modifier, mstate) &
       RESULT(res)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: patch
    TYPE(xt_modifier), INTENT(in) :: modifier(*)
    INTEGER(i4), INTENT(in) :: num_modifier
    INTEGER(c_int), TARGET, INTENT(inout) :: mstate(*)
    TYPE(Xt_idxlist) :: res
    INTEGER(c_int) :: num_modifier_c

    num_modifier_c = INT(num_modifier, c_int)
    res = xt_idxlist_c2f(xt_idxmod_new_c(xt_idxlist_f2c(patch), modifier, &
         num_modifier_c, C_LOC(mstate)))
  END FUNCTION xt_idxmod_new_a1d_i4_a1d

  FUNCTION xt_idxmod_new_a1d_i4_a2d(patch, modifier, num_modifier, mstate) &
       RESULT(res)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: patch
    TYPE(xt_modifier), INTENT(in) :: modifier(*)
    INTEGER(i4), INTENT(in) :: num_modifier
    INTEGER(c_int), TARGET, INTENT(inout) :: mstate(1,*)
    TYPE(Xt_idxlist) :: res
    INTEGER(c_int) :: num_modifier_c

    num_modifier_c = INT(num_modifier, c_int)
    res = xt_idxlist_c2f(xt_idxmod_new_c(xt_idxlist_f2c(patch), modifier, &
         num_modifier_c, C_LOC(mstate)))
  END FUNCTION xt_idxmod_new_a1d_i4_a2d

END MODULE yaxt
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file xt_xmap_dist_dir_bucket_gen_f.f90
!! @brief Fortran interface to yaxt bucket generator declarations
!!
!! @copyright Copyright  (C)  2024 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE xt_xmap_dist_dir_bucket_gen
  USE iso_c_binding, ONLY: c_ptr, c_null_ptr, c_associated
  IMPLICIT NONE
  PRIVATE

  TYPE, PUBLIC, BIND(c) :: xt_xmdd_bucket_gen
#ifndef __G95__
    PRIVATE
#endif
    TYPE(c_ptr) :: cptr = c_null_ptr
  END TYPE xt_xmdd_bucket_gen

  INTERFACE
    ! this function must not be implemented in Fortran because
    ! PGI 11.x chokes on that
    FUNCTION xt_xmdd_bucket_gen_f2c(gen) &
         BIND(c, name='xt_xmdd_bucket_gen_f2c') RESULT(p)
      IMPORT :: c_ptr, xt_xmdd_bucket_gen
      IMPLICIT NONE
      TYPE(xt_xmdd_bucket_gen), INTENT(in) :: gen
      TYPE(c_ptr) :: p
    END FUNCTION xt_xmdd_bucket_gen_f2c
  END INTERFACE

  PUBLIC :: xt_xmdd_bucket_gen_new, xt_xmdd_bucket_gen_delete
  PUBLIC :: xt_xmdd_bucket_gen_c2f, xt_xmdd_bucket_gen_f2c

  INTERFACE xt_is_null
    MODULE PROCEDURE xt_xmdd_bucket_gen_is_null
  END INTERFACE xt_is_null
  PUBLIC :: xt_is_null

CONTAINS

  FUNCTION xt_xmdd_bucket_gen_new() RESULT(gen)
    TYPE(xt_xmdd_bucket_gen) :: gen
    INTERFACE
      FUNCTION xt_xmdd_bucket_gen_new_c() RESULT(gen) &
           BIND(c, name='xt_xmdd_bucket_gen_new')
        IMPORT :: c_ptr
        IMPLICIT NONE
        TYPE(c_ptr) :: gen
      END FUNCTION xt_xmdd_bucket_gen_new_c
    END INTERFACE
    gen%cptr = xt_xmdd_bucket_gen_new_c()
  END FUNCTION xt_xmdd_bucket_gen_new

  SUBROUTINE xt_xmdd_bucket_gen_delete(gen)
    TYPE(xt_xmdd_bucket_gen), INTENT(in) :: gen
    INTERFACE
      SUBROUTINE xt_xmdd_bucket_gen_delete_c(gen) &
           BIND(c, name='xt_xmdd_bucket_gen_delete')
        IMPORT :: c_ptr
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: gen
      END SUBROUTINE xt_xmdd_bucket_gen_delete_c
    END INTERFACE
    CALL xt_xmdd_bucket_gen_delete_c(gen%cptr)
  END SUBROUTINE xt_xmdd_bucket_gen_delete

  FUNCTION xt_xmdd_bucket_gen_c2f(gen) RESULT(p)
    TYPE(c_ptr), INTENT(in) :: gen
    TYPE(xt_xmdd_bucket_gen) :: p
    p%cptr = gen
  END FUNCTION xt_xmdd_bucket_gen_c2f

  FUNCTION xt_xmdd_bucket_gen_is_null(bucket_gen) RESULT(p)
    TYPE(xt_xmdd_bucket_gen), INTENT(in) :: bucket_gen
    LOGICAL :: p
    p = .NOT. C_ASSOCIATED(bucket_gen%cptr)
  END FUNCTION xt_xmdd_bucket_gen_is_null

END MODULE xt_xmap_dist_dir_bucket_gen
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_xmap_all2all_fail_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_xmap_all2all_fail
  USE iso_c_binding, ONLY: c_int
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_int_kind, &
       xt_stripe, xt_idxlist, xt_xmap
  USE test_xmap_common, ONLY : test_self_xmap_construct
  IMPLICIT NONE
  INTERFACE
    FUNCTION xmap_new_fail3(src_idxlist, dst_idxlist, comm) RESULT(xmap)
#if __INTEL_COMPILER == 1500
      USE yaxt, ONLY: xt_xmap, xt_idxlist
#else
      IMPORT :: xt_xmap, xt_idxlist
#endif
      TYPE(xt_xmap) :: xmap
      TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
      INTEGER, INTENT(in) :: comm
    END FUNCTION xmap_new_fail3
  END INTERFACE
  INTEGER, PARAMETER :: xi = xt_int_kind
  CHARACTER(len=*), PARAMETER :: filename = 'test_xmap_all2all_fail_f.f90'
  INTEGER :: my_rank, ierror, list_size
  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  CALL mpi_comm_rank(mpi_comm_world, my_rank, ierror)
  CALL parse_options
  CALL test_xmap1(list_size, mpi_comm_world)

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_finalize
  CALL finish_mpi
CONTAINS
  SUBROUTINE test_xmap1(num_idx, comm)
    INTEGER, INTENT(in) :: num_idx, comm
    TYPE(xt_stripe) :: src_stripe(1), dst_stripe(1)

    ! soruce index list
    src_stripe(1)%nstrides = INT(num_idx, c_int)
    src_stripe(1)%start = 1_xi + INT(my_rank, xi) * INT(num_idx, xi)
    src_stripe(1)%stride = 1_xi

    ! destination index list
    dst_stripe(1)%nstrides = INT(num_idx, c_int)
    dst_stripe(1)%start = src_stripe(1)%start + src_stripe(1)%nstrides
    dst_stripe(1)%stride = -1_xi
    ! note: this should fail because dst/src indices don't match
    CALL test_self_xmap_construct(src_stripe, dst_stripe,&
         & xmap_new_fail3, comm)
  END SUBROUTINE test_xmap1

  SUBROUTINE parse_options
    INTEGER :: i, num_cmd_args, arg_len
    INTEGER, PARAMETER :: max_opt_arg_len = 80
    CHARACTER(max_opt_arg_len) :: optarg
    num_cmd_args = COMMAND_ARGUMENT_COUNT()
    i = 1
    DO WHILE (i < num_cmd_args)
      CALL GET_COMMAND_ARGUMENT(i, optarg, arg_len)
      IF (optarg(1:2) == '-s' .AND. i < num_cmd_args .AND. arg_len == 2) THEN
        CALL GET_COMMAND_ARGUMENT(i + 1, optarg, arg_len)
        IF (arg_len > max_opt_arg_len) &
             CALL test_abort('incorrect argument to command-line option -s', &
             filename, __LINE__)
        IF (optarg(1:arg_len) == "big") THEN
          list_size = 1023
        ELSE IF (optarg(1:arg_len) == "small") THEN
          list_size = 7
        ELSE
          WRITE (0, *) 'arg to -s: ', optarg(1:arg_len)
          CALL test_abort('incorrect argument to command-line option -s', &
               filename, __LINE__)
        END IF
        i = i + 2
      ELSE
        WRITE (0, *) 'unexpected command-line argument parsing error: ', &
             optarg(1:arg_len)
        FLUSH(0)
        CALL test_abort('unexpected command-line argument', &
             filename, __LINE__)
      END IF
    END DO
  END SUBROUTINE parse_options

END PROGRAM test_xmap_all2all_fail

SUBROUTINE xfail_abort(comm, msg, source, line)
  USE iso_c_binding, ONLY: c_int
  USE mpi
  USE ftest_common, ONLY: posix_exit
  INTEGER, INTENT(in) :: comm, line
  CHARACTER(len=*), INTENT(in) :: msg, source
  INTEGER :: ierror
#ifdef XT_NEED_MPI_ABORT_WORK_AROUND
  INTEGER :: abort_msg_lun
#endif
  WRITE (0, '(4a,i0)') msg, ' at ', source, ', line ', line

#ifdef XT_NEED_MPI_ABORT_WORK_AROUND
#  if XT_NEED_MPI_ABORT_WORK_AROUND == 1
  abort_msg_lun = 0
#  elif XT_NEED_MPI_ABORT_WORK_AROUND == 2
  FLUSH(0)
  abort_msg_lun = 10
  OPEN(unit=abort_msg_lun, status='replace', &
       file='test_xmap_all2all_fail.result.txt', &
       action='write', iostat=ierror)
#  endif
  WRITE (abort_msg_lun, '(a)') 'MPI_Abort(0xdeadbeef, 3)'
  FLUSH(abort_msg_lun)
#endif

  CALL mpi_abort(comm, 3, ierror)
  CALL posix_exit(3_c_int)
END SUBROUTINE xfail_abort

FUNCTION xmap_new_fail3(src_idxlist, dst_idxlist, comm) RESULT(xmap)
  USE yaxt, ONLY: xt_xmap, xt_idxlist, xt_xmap_all2all_new, &
       xt_set_abort_handler, xt_restore_default_abort_hndl
  TYPE(xt_xmap) :: xmap
  TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
  INTEGER, INTENT(in) :: comm
  INTERFACE
    SUBROUTINE xfail_abort(comm, msg, source, line)
      INTEGER, INTENT(in) :: comm, line
      CHARACTER(len=*), INTENT(in) :: msg, source
    END SUBROUTINE xfail_abort
  END INTERFACE
  CALL xt_set_abort_handler(xfail_abort)
  xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist, comm)
  CALL xt_restore_default_abort_hndl
END FUNCTION xmap_new_fail3

!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_collection_parallel_f.f90
!! @brief parallel Fortran test of redist_collection class
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_redist_collection_parallel
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort, icbrt
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_int_kind, xi => xt_int_kind, &
       xt_idxlist, xt_idxlist_delete, xt_stripe, xt_idxvec_new, &
       xt_idxsection_new, xt_idxlist_collection_new, xt_idxstripes_new, &
       xt_xmap, xt_xmap_all2all_new, xt_xmap_delete, &
       xt_redist, xt_redist_p2p_new, xt_redist_collection_new, &
       xt_redist_copy, xt_redist_delete, xt_redist_s_exchange, &
       xt_idxlist_get_indices, xt_int_mpidt, &
       xt_request, xt_redist_a_exchange, xt_config, xt_config_delete
  ! older PGI compilers do not handle generic interface correctly
#if defined __PGI && (__PGIC__ < 12 || (__PGIC__ ==  12 && __PGIC_MINOR__ <= 10))
  USE xt_redist_base, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
#endif
  USE test_redist_common, ONLY: check_wait_request, redist_exchanger_option
  USE iso_c_binding, ONLY: c_loc, c_ptr
#include "xt_slice_c_loc.inc"
  IMPLICIT NONE
  INTEGER :: rank, world_size, ierror
  CHARACTER(len=*), PARAMETER :: &
       filename = 'test_redist_collection_parallel_f.f90'
  CHARACTER(len=*), PARAMETER :: err_msg(2) = &
       (/ "error in xt_redist_s_exchange", "error in xt_redist_a_exchange" /)
  TYPE(xt_config) :: config

  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  CALL mpi_comm_rank(mpi_comm_world, rank, ierror)
  IF (ierror /= MPI_SUCCESS) &
       CALL test_abort('mpi_comm_rank failed', filename, __LINE__)
  CALL mpi_comm_size(mpi_comm_world, world_size, ierror)
  IF (ierror /= MPI_SUCCESS) &
       CALL test_abort('mpi_comm_size failed', filename, __LINE__)

  IF (world_size > 1) THEN
    CALL test_4redist(mpi_comm_world, config)
    CALL test_rr_exchange(mpi_comm_world, config)
  END IF

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi
CONTAINS
  SUBROUTINE build_idxlists(indices_a, indices_b, indices_all)
    TYPE(xt_idxlist), INTENT(out) :: indices_a, indices_b, indices_all

    TYPE(xt_idxlist) :: indices_a_(2)
    INTEGER :: i
    INTEGER(xt_int_kind), PARAMETER :: start = 0
    INTEGER(xt_int_kind) :: global_size(2), local_start(2, 2)
    INTEGER :: local_size(2)

    TYPE(xt_stripe) :: stripe

    global_size(1) = INT(2 * world_size, xi)
    global_size(2) = INT(world_size**2, xi)
    local_size = world_size
    local_start = RESHAPE((/ 0_xi, INT(rank*world_size, xi), &
         INT(world_size, xi), &
         INT((world_size-(rank+1))*world_size, xi) /), (/ 2, 2 /))

    DO i = 1, 2
      indices_a_(i) = xt_idxsection_new(start, global_size, local_size, &
           local_start(:, i))
    END DO
    indices_a = xt_idxlist_collection_new(indices_a_)

    CALL xt_idxlist_delete(indices_a_(1))
    CALL xt_idxlist_delete(indices_a_(2))

    stripe = xt_stripe(INT(rank * 2 * world_size**2, xi), 1_xi, 2*world_size**2)
    indices_b = xt_idxstripes_new(stripe)

    stripe = xt_stripe(0_xi, 1_xi, 2*world_size**3)
    indices_all = xt_idxstripes_new(stripe)
  END SUBROUTINE build_idxlists

  SUBROUTINE test_4redist(comm, config)
    ! redist test with four different redists
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    INTEGER, PARAMETER :: num_tx = 4
    TYPE(xt_idxlist) :: indices_a, indices_b, indices_all
    INTEGER(xt_int_kind), ALLOCATABLE :: index_vector_a(:), &
         index_vector_b(:)
    TYPE(xt_xmap) :: xmaps(num_tx)
    TYPE(xt_redist) :: redists(num_tx), redist, redist_copy
    INTEGER :: i, vec_size

    IF (world_size &
         > icbrt((HUGE(1_xi)-MOD(HUGE(1_xi),2_xi))/2_xi)) &
         CALL test_abort('communicator too large for test', filename, __LINE__)

    vec_size = 2*world_size**2
    ALLOCATE(index_vector_a(vec_size), index_vector_b(vec_size))
    CALL build_idxlists(indices_a, indices_b, indices_all)

    xmaps(1) = xt_xmap_all2all_new(indices_a, indices_b, comm)
    xmaps(2) = xt_xmap_all2all_new(indices_b, indices_a, comm)
    xmaps(3) = xt_xmap_all2all_new(indices_a, indices_all, comm)
    xmaps(4) = xt_xmap_all2all_new(indices_b, indices_all, comm)

    CALL xt_idxlist_get_indices(indices_a, index_vector_a)
    CALL xt_idxlist_get_indices(indices_b, index_vector_b)

    CALL xt_idxlist_delete(indices_a)
    CALL xt_idxlist_delete(indices_b)
    CALL xt_idxlist_delete(indices_all)

    DO i = 1, num_tx
      redists(i) = xt_redist_p2p_new(xmaps(i), xt_int_mpidt)
      CALL xt_xmap_delete(xmaps(i))
    END DO

    redist = xt_redist_collection_new(redists, num_tx, -1, comm, config)

    ! test communicator of redist
    ! if (!test_communicator(xt_redist_get_MPI_Comm(redist), COMM))
    !   PUT_ERR("error in xt_redist_get_MPI_Comm\n");

    CALL xt_redist_delete(redists)

    CALL exchange_4redist(redist, index_vector_a, index_vector_b)
    redist_copy = xt_redist_copy(redist)
    CALL xt_redist_delete(redist)
    CALL exchange_4redist(redist_copy, index_vector_a, index_vector_b)

    ! clean up
    CALL xt_redist_delete(redist_copy)
  END SUBROUTINE test_4redist

  SUBROUTINE exchange_4redist(redist, index_vector_a, index_vector_b)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(xt_int_kind), INTENT(in) :: index_vector_a(2*world_size**2), &
         index_vector_b(2*world_size**2)
    INTEGER(xt_int_kind), TARGET, ALLOCATABLE :: buf(:)
    INTEGER(xt_int_kind), POINTER :: results_1(:), &
         results_2(:), results_3(:), results_4(:)
    INTEGER :: result_sizes(4), buf_size, ofs
    INTEGER, PARAMETER :: result_spacing(4) = (/ 2, 14, 5, 8 /)
    INTEGER :: iexch

    result_sizes(1) = 2*world_size**2
    result_sizes(2) = 2*world_size**2
    result_sizes(3) = 2*world_size**3
    result_sizes(4) = 2*world_size**3

    buf_size = SUM(result_spacing) + SUM(result_sizes)
    ALLOCATE(buf(buf_size))
    DO iexch = 1, 2
      buf(:) = -1_xt_int_kind
      ofs = result_spacing(1)
      results_1 => buf(ofs+1:ofs+result_sizes(1))
      ofs = ofs + result_sizes(1) + result_spacing(2)
      results_2 => buf(ofs+1:ofs+result_sizes(2))
      ofs = ofs + result_sizes(2) + result_spacing(3)
      results_3 => buf(ofs+1:ofs+result_sizes(3))
      ofs = ofs + result_sizes(3) + result_spacing(4)
      results_4 => buf(ofs+1:ofs+result_sizes(4))

      CALL do_4redist(redist, index_vector_a, index_vector_b, &
           results_1, results_2, results_3, results_4, iexch)

      CALL check_4redist_results(results_1, results_2, results_3, results_4, &
           index_vector_a, index_vector_b, iexch)
      buf(:) = -1_xt_int_kind
      ! shift addresses around
      IF (rank == 0) THEN
        ofs = SUM(result_spacing(1:2)) + SUM(result_sizes(1:2))
        results_3 => buf(ofs+1:ofs+result_sizes(3))
      END IF

      CALL do_4redist(redist, index_vector_a, index_vector_b, &
           results_1, results_2, results_3, results_4, iexch)

      CALL check_4redist_results(results_1, results_2, results_3, results_4, &
           index_vector_a, index_vector_b, iexch)
    ENDDO
    ! clean up
    DEALLOCATE(buf)
  END SUBROUTINE exchange_4redist

  SUBROUTINE do_4redist(redist, index_vector_a, index_vector_b, &
       results_1, results_2, results_3, results_4, iexch)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(xt_int_kind), INTENT(in), TARGET :: &
         index_vector_a(*), index_vector_b(*)
    INTEGER(xt_int_kind), INTENT(inout), TARGET :: &
         results_1(*), results_2(*), results_3(*), results_4(*)
    INTEGER, INTENT(in) :: iexch

    TYPE(c_ptr) :: results(4), input(4)
    TYPE(xt_request) :: request

    results(1) = C_LOC(results_1)
    results(2) = C_LOC(results_2)
    results(3) = C_LOC(results_3)
    results(4) = C_LOC(results_4)

    input(1) = C_LOC(index_vector_a)
    input(2) = C_LOC(index_vector_b)
    input(3) = C_LOC(index_vector_a)
    input(4) = C_LOC(index_vector_b)
    IF (iexch == 1) THEN
      CALL xt_redist_s_exchange(redist, 4, input, results)
    ELSE
      CALL xt_redist_a_exchange(redist, 4, input, results, request)
      CALL check_wait_request(request, filename, __LINE__)
    ENDIF
  END SUBROUTINE do_4redist

  SUBROUTINE check_4redist_results(results_1, results_2, results_3, results_4, &
       index_vector_a, index_vector_b, iexch)
    INTEGER(xt_int_kind), INTENT(in) :: index_vector_a(:), index_vector_b(:), &
         results_1(:), results_2(:), results_3(0:), results_4(0:)
    INTEGER, INTENT(in) :: iexch
    INTEGER(xt_int_kind) :: i, n
    LOGICAL :: p_3, p_4

    IF (ANY(results_1 /= index_vector_b)) &
         CALL test_abort(err_msg(iexch), filename, __LINE__)

    IF (ANY(results_2 /= index_vector_a)) &
         CALL test_abort(err_msg(iexch), filename, __LINE__)

    n = INT(SIZE(results_3), xt_int_kind)
    p_3 = .FALSE.
    p_4 = .FALSE.
    DO i = 0_xi, n - 1_xi
      p_3 = p_3 .OR. results_3(i) /= i
      p_4 = p_4 .OR. results_4(i) /= i
    END DO
    IF (p_3 .OR. p_4) CALL test_abort(err_msg(iexch), filename, __LINE__)
  END SUBROUTINE check_4redist_results


  ! redist test with two redists that do a round robin exchange in
  ! different directions
  SUBROUTINE test_rr_exchange(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config

    TYPE(xt_idxlist) :: src_indices, dst_indices(2)
    INTEGER(xt_int_kind) :: src_indices_(5)
    INTEGER(xt_int_kind) :: i, temp, dst_indices_(5, 2)
    TYPE(xt_xmap) :: xmaps(2)
    TYPE(xt_redist) :: redists(2), redist, redist_copy

    IF (world_size > (HUGE(1_xi)-MOD(HUGE(1_xi),5_xi))/5_xi) &
      CALL test_abort('communicator too large for test', filename, __LINE__)

    DO i = 1_xi, 5_xi
      src_indices_(i) = INT(rank, xi) * 5_xi + (i - 1_xi)
      dst_indices_(i, 1) = MOD(src_indices_(i) + 1_xi, &
           &                   INT(world_size, xi) * 5_xi)
      temp = src_indices_(i) - 1_xi
      dst_indices_(i, 2) = MERGE(INT(world_size, xi) * 5_xi - 1_xi, &
           &                     temp, temp < 0_xi)
    END DO

    src_indices = xt_idxvec_new(src_indices_, 5)
    dst_indices(1) = xt_idxvec_new(dst_indices_(:, 1))
    dst_indices(2) = xt_idxvec_new(dst_indices_(:, 2))

    xmaps(1) = xt_xmap_all2all_new(src_indices, dst_indices(1), comm)
    xmaps(2) = xt_xmap_all2all_new(src_indices, dst_indices(2), comm)

    CALL xt_idxlist_delete(src_indices)
    CALL xt_idxlist_delete(dst_indices)

    redists(1) = xt_redist_p2p_new(xmaps(1), xt_int_mpidt)
    redists(2) = xt_redist_p2p_new(xmaps(2), xt_int_mpidt)

    CALL xt_xmap_delete(xmaps)

    redist = xt_redist_collection_new(redists, 2, -1, comm, config)

    ! test communicator of redist
    ! IF (!test_communicator(xt_redist_get_MPI_Comm(redist), comm))
    !     PUT_ERR("error in xt_redist_get_MPI_Comm\n");

    CALL xt_redist_delete(redists)

    CALL rr_exchange(redist, src_indices_, dst_indices_)
    redist_copy = xt_redist_copy(redist)
    CALL xt_redist_delete(redist)
    CALL rr_exchange(redist_copy, src_indices_, dst_indices_)

    ! clean up
    CALL xt_redist_delete(redist_copy)
  END SUBROUTINE test_rr_exchange

  SUBROUTINE rr_exchange(redist, src_indices_, ref_dst_indices_)
#if defined __GNUC__ && __GNUC__ >= 5 && ( __GNUC__ <= 7 \
    || __GNUC__ == 8 && __GNUC_MINOR__ < 4 )
    ! gcc versions 5.x to 8.x have a bug that lets them evaluate the
    ! ANY test too early if results never gets passed to some external
    ! routine directly, 9.x is not only fixed again, but requires to
    ! have the explicit escaping of a pointer to results via C_LOC
    USE yaxt, ONLY: xt_slice_c_loc
#undef XT_SLICE_C_LOC
#define XT_SLICE_C_LOC(slice, cptr) CALL xt_slice_c_loc(slice, cptr)
#endif
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER, PARAMETER :: nredist = 2
    INTEGER(xt_int_kind), TARGET, INTENT(in) :: src_indices_(5)
    INTEGER(xt_int_kind), INTENT(in) :: ref_dst_indices_(5, nredist)

    INTEGER(xt_int_kind), TARGET :: results(5,nredist)
    TYPE(c_ptr) :: results_p(nredist), input(nredist)
    INTEGER :: iexch, i
    TYPE(xt_request) :: request

    DO i = 1, nredist
      XT_SLICE_C_LOC(results(:,i), results_p(i))
      input(i) = C_LOC(src_indices_)
    END DO

    DO iexch = 1, 2
      results = -1

      IF (iexch == 1) THEN
        CALL xt_redist_s_exchange(redist, input, results_p)
      ELSE
        CALL xt_redist_a_exchange(redist, input, results_p, request)
        CALL check_wait_request(request, filename, __LINE__)
      ENDIF

      ! check results
      IF (ANY(results /= ref_dst_indices_)) &
           CALL test_abort(err_msg(iexch), filename, __LINE__)
    ENDDO
  END SUBROUTINE rr_exchange

END PROGRAM test_redist_collection_parallel
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_idxmod_f.f90
!!
!! @copyright Copyright  (C)  2012 Jörg Behrens <behrens@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_idxmod_f
  USE mpi
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_idxlist, &
       xi => xt_int_kind, xt_stripe, &
       xt_modifier, xt_idxvec_new, xt_idxstripes_new, &
       xt_idxlist_delete, xt_idxmod_new
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_idxlist_utils, ONLY: check_idxlist, test_err_count
  IMPLICIT NONE
  CHARACTER(len=*), PARAMETER :: filename = 'test_idxmod_f.f90'
  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)

  CALL test_idxvec_modifier
  CALL test_idxstripes_modifier
  CALL test_multimod

  CALL xt_finalize

  IF (test_err_count() /= 0) CALL test_abort("non-zero error count", &
       filename, __LINE__)

  CALL finish_mpi

CONTAINS
  SUBROUTINE test_idxvec_modifier
    INTEGER, PARAMETER :: g_src_num = 9, g_dst_num=9, patch_num=7
#ifndef __G95__
    INTEGER(xi) :: i
    INTEGER(xi), PARAMETER :: &
         g_src_idx(g_src_num) = (/ (i, i=1,g_src_num) /), &
         g_dst_idx(g_dst_num) = (/ (i, i=g_dst_num,1,-1) /), &
#else
    INTEGER :: i
    INTEGER(xi), PARAMETER :: &
         g_src_idx(g_src_num) = (/ (INT(i, xi), i=1,g_src_num) /), &
         g_dst_idx(g_dst_num) = (/ (INT(i, xi), i=g_dst_num,1,-1) /), &
#endif
         patch_idx(patch_num) = (/ 3_xi, 4_xi, 4_xi, 4_xi, 7_xi, 7_xi, 8_xi /)
    ! idx:{3,4,4,4,7,7,8} -> pos:{2,3,3,3,6,6,7} => idx:{7,6,6,6,3,3,2}
    INTEGER(xi), PARAMETER :: &
         ref_mpatch_idx(patch_num) = (/ 7_xi, 6_xi, 6_xi, 6_xi, 3_xi, 3_xi, &
         2_xi /)

    TYPE(xt_idxlist) :: g_src_idxlist,  g_dst_idxlist, patch_idxlist, &
         mpatch_idxlist
    TYPE(xt_modifier) :: modifier(1)

    g_src_idxlist = xt_idxvec_new(g_src_idx, g_src_num)

    g_dst_idxlist = xt_idxvec_new(g_dst_idx, g_dst_num)

    modifier(1) = xt_modifier(g_src_idxlist, g_dst_idxlist, 0)

    patch_idxlist = xt_idxvec_new(patch_idx, patch_num)

    mpatch_idxlist = xt_idxmod_new(patch_idxlist, modifier)

    CALL check_idxlist(mpatch_idxlist, ref_mpatch_idx)

    CALL xt_idxlist_delete(mpatch_idxlist)
    CALL xt_idxlist_delete(patch_idxlist)
    CALL xt_idxlist_delete(g_dst_idxlist)
    CALL xt_idxlist_delete(g_src_idxlist)
  END SUBROUTINE test_idxvec_modifier

  SUBROUTINE test_idxstripes_modifier
    INTEGER :: i
    INTEGER, PARAMETER :: patch_num = 8
    TYPE(xt_stripe), PARAMETER :: &
         g_src_stripe = xt_stripe(1, 1, 20), &
         g_dst_stripe = xt_stripe(100, -1, 20)
    TYPE(xt_idxlist) :: g_src_idxlist, g_dst_idxlist, patch_idxlist, &
         mpatch_idxlist
    TYPE(xt_modifier) :: modifier(1)
    INTEGER :: mstate(patch_num)
    INTEGER, PARAMETER :: ref_mstate(patch_num) &
         = (/ 1, IOR(2, 32), IOR(3, 32), IOR(4, 32), IOR(5, 32), 6, 7, 8 /)
    ! inter:{1,3,3,5} => extract_pos:{0,2,2,4} => subst_idx:{100,98,98,96},
    ! patch_pos:{1,2,3,4} = > mpatch:{0,100,98,98,96,50,100,150}
    INTEGER(xi), PARAMETER :: &
         patch_idx(patch_num) = (/   0_xi,   1_xi,   3_xi,   3_xi, &
         &                           5_xi,  50_xi, 100_xi, 150_xi /), &
         ref_mpatch_idx(patch_num) = (/   0_xi, 100_xi,  98_xi,  98_xi, &
         &                               96_xi,  50_xi, 100_xi, 150_xi /)

    g_src_idxlist = xt_idxstripes_new(g_src_stripe)
    g_dst_idxlist = xt_idxstripes_new(g_dst_stripe)

    modifier(1) = xt_modifier(g_src_idxlist, g_dst_idxlist, 32)

    patch_idxlist = xt_idxvec_new(patch_idx)

    DO i = 1, patch_num
      mstate(i) = i
    END DO

    mpatch_idxlist = xt_idxmod_new(patch_idxlist, modifier, mstate)

    CALL check_idxlist(mpatch_idxlist, ref_mpatch_idx)

    ! check mstate
    IF (ANY(mstate(:) /= ref_mstate(:))) &
         CALL test_abort("mstate(:) /= ref_mstate(:)", filename, __LINE__)
    CALL xt_idxlist_delete(mpatch_idxlist)
    CALL xt_idxlist_delete(patch_idxlist)
    CALL xt_idxlist_delete(g_dst_idxlist)
    CALL xt_idxlist_delete(g_src_idxlist)
  END SUBROUTINE test_idxstripes_modifier

  ! track modifier usage
  SUBROUTINE test_multimod
    INTEGER, PARAMETER :: g1_src_num = 9, g1_dst_num = 9, &
         g2_src_num = 5, g2_dst_num = 5, patch_num = 6, num_mod = 2
#ifndef __G95__
    INTEGER(xi) :: i
    INTEGER(xi), PARAMETER :: &
         g1_src_idx(g1_src_num) = (/ (i, i = 1,g1_src_num) /), &
         g1_dst_idx(g1_dst_num) = (/ (i, i = g1_dst_num,1,-1) /), &
#else
    INTEGER :: i
    INTEGER(xi), PARAMETER :: &
         g1_src_idx(g1_src_num) = (/ (INT(i, xi), i = 1,g1_src_num) /), &
         g1_dst_idx(g1_dst_num) = (/ (INT(i, xi), i = g1_dst_num,1,-1) /), &
#endif
         g2_src_idx(g2_src_num) = (/ 1_xi, 2_xi, 8_xi, 9_xi, 10_xi /), &
         g2_dst_idx(g2_dst_num) = (/ 8_xi, 2_xi, 8_xi, 2_xi, 5_xi /), &
         patch_idx(patch_num) = (/ 6_xi, 7_xi, 25_xi, 8_xi, 9_xi, 10_xi /), &
         ! mod1: idx:{6,7,25,8,9,10} -> pos:{5,6,nil,7,8,nil} => idx:{4,3,25,2,1,10}
         ! mod2: idx:{4,3,25,2,1,10} -> pos:{nil,nil,nil,1,0,4}
         !                           => idx:{4,3,25,2,8,5}
         ref_mpatch_idx(patch_num) = (/ 4_xi, 3_xi, 25_xi, 2_xi, 8_xi, 5_xi /)

    TYPE(xt_idxlist) :: mod_idxlist(2,2), patch_idxlist, mpatch_idxlist
    TYPE(xt_modifier) ::  modifier(num_mod)
    INTEGER :: mstate(patch_num), k
    INTEGER, PARAMETER :: ref_mstate(patch_num) &
         = (/ IOR(1, 0), IOR(1, 0), IOR(0, 0), &
         &    IOR(1, 2), IOR(1, 2), IOR(0, 2) /), &
         src = 1, dst = 2

    mod_idxlist(1, src) = xt_idxvec_new(g1_src_idx, g1_src_num)
    mod_idxlist(1, dst) = xt_idxvec_new(g1_dst_idx)
    mod_idxlist(2, src) = xt_idxvec_new(g2_src_idx)
    mod_idxlist(2, dst) = xt_idxvec_new(g2_dst_idx, g2_dst_num)

    patch_idxlist = xt_idxvec_new(patch_idx)
    ! reset mstate
    mstate(:) = 0

    DO k = 1, num_mod
      modifier(k) = xt_modifier(mod_idxlist(k, src), mod_idxlist(k, dst), &
           ISHFT(1, k - 1))
    END DO
    mpatch_idxlist = xt_idxmod_new(patch_idxlist, modifier, 2, mstate)
    CALL check_idxlist(mpatch_idxlist, ref_mpatch_idx)

    ! check mstate
    IF (ANY(mstate(:) /= ref_mstate(:))) &
         CALL test_abort("mstate(:) /= ref_mstate(:)", filename, __LINE__)
    CALL xt_idxlist_delete(mpatch_idxlist)
    CALL xt_idxlist_delete(patch_idxlist)
    CALL xt_idxlist_delete(mod_idxlist)
  END SUBROUTINE test_multimod

END PROGRAM test_idxmod_f
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file xt_xmap_f.f90
!! @brief Fortran interface to yaxt xmap declarations
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE xt_xmap_abstract
  USE iso_c_binding, ONLY: c_int, c_ptr, c_null_ptr, &
       c_associated, c_f_pointer, c_loc
  USE xt_core, ONLY: xt_abort, xt_mpi_fint_kind, xt_pos_ext, i2, i4, i8
  USE xt_config_f, ONLY: xt_config, xt_config_f2c
  USE xt_idxlist_abstract, ONLY: xt_idxlist
  IMPLICIT NONE
  PRIVATE
  PUBLIC :: xt_xmap_c2f, xt_xmap_f2c, xt_is_null
  PUBLIC :: xt_xmap_copy, xt_xmap_delete, xt_xmap_get_num_destinations, &
       xt_xmap_get_num_sources, xt_xmap_get_destination_ranks, &
       xt_xmap_get_max_src_pos, xt_xmap_get_max_dst_pos, &
       xt_xmap_get_source_ranks, xt_xmap_reorder, xt_xmap_reorder_custom, &
       xt_reorder_type_kind, &
       xt_reorder_none, xt_reorder_send_up, xt_reorder_recv_up, &
       xt_xmap_update_positions, xt_xmap_spread
  PUBLIC :: xt_xmap_all2all_new, xt_xmap_all2all_custom_new
  PUBLIC :: xt_xmap_dist_dir_new,  xt_xmap_dist_dir_custom_new
  PUBLIC ::  xt_xmap_dist_dir_intercomm_new,  &
       xt_xmap_dist_dir_intercomm_custom_new
  PUBLIC :: xt_xmap_get_in_iterator, xt_xmap_get_out_iterator, &
       xt_xmap_iterator_next, xt_xmap_iterator_get_rank, &
       xt_xmap_iterator_get_transfer_pos, &
       xt_xmap_iterator_get_transfer_pos_ext, &
       xt_xmap_iterator_get_num_transfer_pos, &
       xt_xmap_iterator_get_num_transfer_pos_ext, &
       xt_xmap_iterator_delete


  ! note: this type must not be extended to contain any other
  ! components, its memory pattern has to match void * exactly, which
  ! it does because of C constraints
  TYPE, BIND(C), PUBLIC :: xt_xmap
#ifndef __G95__
    PRIVATE
#endif
    TYPE(c_ptr) :: cptr = c_null_ptr
  END TYPE xt_xmap

  TYPE, BIND(c), PUBLIC :: xt_xmap_iter
#ifndef __G95__
    PRIVATE
#endif
    TYPE(c_ptr) :: cptr = c_null_ptr
  END TYPE xt_xmap_iter

  ENUM, BIND( C )
    ENUMERATOR :: xt_reorder_none, xt_reorder_send_up, xt_reorder_recv_up
  END ENUM
  INTEGER, PARAMETER :: xt_reorder_type_kind = KIND(xt_reorder_none)

  INTERFACE
    ! this function must not be implemented in Fortran because
    ! PGI 11.x chokes on that
    FUNCTION xt_xmap_f2c(xmap) BIND(c, name='xt_xmap_f2c') RESULT(p)
      IMPORT :: c_ptr, xt_xmap
      IMPLICIT NONE
      TYPE(xt_xmap), INTENT(in) :: xmap
      TYPE(c_ptr) :: p
    END FUNCTION xt_xmap_f2c

    SUBROUTINE xt_xmap_delete_c(xmap) BIND(C, name='xt_xmap_delete')
      IMPORT :: c_ptr
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in) :: xmap
    END SUBROUTINE xt_xmap_delete_c

  END INTERFACE

  INTERFACE xt_xmap_delete
    MODULE PROCEDURE xt_xmap_delete_1
    MODULE PROCEDURE xt_xmap_delete_a1d
  END INTERFACE xt_xmap_delete

  INTERFACE xt_is_null
    MODULE PROCEDURE xt_xmap_is_null
    MODULE PROCEDURE xt_xmap_iterator_is_null
  END INTERFACE xt_is_null

  INTERFACE
    FUNCTION xt_xmap_iterator_get_num_transfer_pos_c(iter) RESULT(num) &
         BIND(c, name='xt_xmap_iterator_get_num_transfer_pos')
      IMPORT :: c_int, c_ptr
      TYPE(c_ptr), VALUE, INTENT(in) :: iter
      INTEGER(c_int) :: num
    END FUNCTION xt_xmap_iterator_get_num_transfer_pos_c

    FUNCTION xt_xmap_iterator_get_num_transfer_pos_ext_c(iter) RESULT(num) &
         BIND(c, name='xt_xmap_iterator_get_num_transfer_pos_ext')
      IMPORT :: c_int, c_ptr
      TYPE(c_ptr), VALUE, INTENT(in) :: iter
      INTEGER(c_int) :: num
    END FUNCTION xt_xmap_iterator_get_num_transfer_pos_ext_c
  END INTERFACE

  INTERFACE xt_xmap_spread
    MODULE PROCEDURE xt_xmap_spread_a1d
    MODULE PROCEDURE xt_xmap_spread_i2_a1d
    MODULE PROCEDURE xt_xmap_spread_i4_a1d
    MODULE PROCEDURE xt_xmap_spread_i8_a1d
  END INTERFACE xt_xmap_spread

  CHARACTER(len=*), PARAMETER :: filename = 'xt_xmap_f.f90'
CONTAINS

  FUNCTION xt_xmap_is_null(xmap) RESULT(p)
    TYPE(xt_xmap), INTENT(in) :: xmap
    LOGICAL :: p
    p = .NOT. C_ASSOCIATED(xmap%cptr)
  END FUNCTION xt_xmap_is_null


  FUNCTION xt_xmap_c2f(xmap) RESULT(p)
    TYPE(c_ptr), INTENT(in) :: xmap
    TYPE(xt_xmap) :: p
    p%cptr = xmap
  END FUNCTION xt_xmap_c2f

  FUNCTION xt_xmap_copy(xmap) RESULT(xmap_copy)
    TYPE(xt_xmap), INTENT(in) :: xmap
    TYPE(xt_xmap) :: xmap_copy
    INTERFACE
      FUNCTION xt_xmap_copy_c(xmap) BIND(C, name='xt_xmap_copy') RESULT(res_ptr)
        IMPORT :: xt_xmap, c_ptr
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: xmap
        TYPE(c_ptr) :: res_ptr
      END FUNCTION xt_xmap_copy_c
    END INTERFACE
    xmap_copy%cptr = xt_xmap_copy_c(xmap%cptr)
  END FUNCTION xt_xmap_copy
  SUBROUTINE xt_xmap_delete_1(xmap)
    TYPE(xt_xmap), INTENT(inout) :: xmap
    CALL xt_xmap_delete_c(xmap%cptr)
    xmap%cptr = c_null_ptr
  END SUBROUTINE xt_xmap_delete_1

  SUBROUTINE xt_xmap_delete_a1d(xmaps)
    TYPE(xt_xmap), INTENT(inout) :: xmaps(:)
    INTEGER :: i, n
    n = SIZE(xmaps)
    DO i = 1, n
      CALL xt_xmap_delete_c(xmaps(i)%cptr)
      xmaps(i)%cptr = c_null_ptr
    END DO
  END SUBROUTINE xt_xmap_delete_a1d

  FUNCTION xt_xmap_all2all_new(src_idxlist, dst_idxlist, comm) RESULT(xmap)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: src_idxlist
    TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_xmap) :: xmap

    INTERFACE
      FUNCTION xt_xmap_all2all_new_f(src_idxlist, dst_idxlist, comm) &
           BIND(C, name='xt_xmap_all2all_new_f') RESULT(xmap_ptr)
        IMPORT :: xt_idxlist, xt_xmap, xt_mpi_fint_kind, c_ptr
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: comm
        TYPE(c_ptr) :: xmap_ptr
      END FUNCTION xt_xmap_all2all_new_f
    END INTERFACE

    xmap%cptr = xt_xmap_all2all_new_f(src_idxlist, dst_idxlist, comm)
  END FUNCTION xt_xmap_all2all_new

  FUNCTION xt_xmap_all2all_custom_new(src_idxlist, dst_idxlist, comm, config) &
       RESULT(xmap)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: src_idxlist
    TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_xmap) :: xmap

    INTERFACE
      FUNCTION xt_xmap_all2all_custom_new_f(src_idxlist, dst_idxlist, comm, &
           config) BIND(C, name='xt_xmap_all2all_custom_new_f') RESULT(xmap_ptr)
        IMPORT :: xt_idxlist, xt_xmap, xt_mpi_fint_kind, xt_config, c_ptr
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: comm
        TYPE(xt_config), INTENT(in) :: config
        TYPE(c_ptr) :: xmap_ptr
      END FUNCTION xt_xmap_all2all_custom_new_f
    END INTERFACE

    xmap%cptr = xt_xmap_all2all_custom_new_f(src_idxlist, dst_idxlist, &
         comm, config)
  END FUNCTION xt_xmap_all2all_custom_new

  FUNCTION xt_xmap_dist_dir_new(src_idxlist, dst_idxlist, comm) RESULT(xmap)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: src_idxlist
    TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_xmap) :: xmap

    INTERFACE
      FUNCTION xt_xmap_dist_dir_new_f(src_idxlist, dst_idxlist, comm) &
           BIND(C, name='xt_xmap_dist_dir_new_f') RESULT(xmap_ptr)
        IMPORT :: xt_idxlist, xt_xmap, xt_mpi_fint_kind, c_ptr
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: comm
        TYPE(c_ptr) :: xmap_ptr
      END FUNCTION xt_xmap_dist_dir_new_f
    END INTERFACE

    xmap%cptr = xt_xmap_dist_dir_new_f(src_idxlist, dst_idxlist, comm)
  END FUNCTION xt_xmap_dist_dir_new

  FUNCTION xt_xmap_dist_dir_custom_new(src_idxlist, dst_idxlist, comm, config) &
       RESULT(xmap)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: src_idxlist
    TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
    TYPE(xt_config), INTENT(in) :: config
    INTEGER, INTENT(in) :: comm
    TYPE(xt_xmap) :: xmap
    INTERFACE
      FUNCTION xt_xmap_dist_dir_custom_new_f(src_idxlist, dst_idxlist, comm, &
           config) BIND(C, name='xt_xmap_dist_dir_custom_new_f') &
           RESULT(xmap_ptr)
        IMPORT :: xt_idxlist, xt_xmap, xt_mpi_fint_kind, xt_config, c_ptr
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: comm
        TYPE(xt_config), INTENT(in) :: config
        TYPE(c_ptr) :: xmap_ptr
      END FUNCTION xt_xmap_dist_dir_custom_new_f
    END INTERFACE
    xmap%cptr = xt_xmap_dist_dir_custom_new_f(src_idxlist, dst_idxlist, &
         comm, config)
  END FUNCTION xt_xmap_dist_dir_custom_new

  FUNCTION xt_xmap_dist_dir_intercomm_new(src_idxlist, dst_idxlist, &
       inter_comm, intra_comm) RESULT(xmap)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: src_idxlist
    TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
    INTEGER, INTENT(in) :: inter_comm, intra_comm
    TYPE(xt_xmap) :: xmap

    INTERFACE
      FUNCTION xt_xmap_dist_dir_intercomm_new_f(src_idxlist, dst_idxlist, &
           inter_comm, intra_comm) &
           BIND(C, name='xt_xmap_dist_dir_intercomm_new_f') RESULT(xmap_ptr)
        IMPORT :: xt_idxlist, xt_xmap, xt_mpi_fint_kind, c_ptr
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: inter_comm, intra_comm
        TYPE(c_ptr) :: xmap_ptr
      END FUNCTION xt_xmap_dist_dir_intercomm_new_f
    END INTERFACE

    xmap%cptr = xt_xmap_dist_dir_intercomm_new_f(src_idxlist, &
         dst_idxlist, inter_comm, intra_comm)
  END FUNCTION xt_xmap_dist_dir_intercomm_new

  FUNCTION xt_xmap_dist_dir_intercomm_custom_new(src_idxlist, dst_idxlist, &
       inter_comm, intra_comm, config) RESULT(xmap)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: src_idxlist
    TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
    INTEGER, INTENT(in) :: inter_comm, intra_comm
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_xmap) :: xmap

    INTERFACE
      FUNCTION xt_xmap_dist_dir_intercomm_custom_new_f(src_idxlist, &
           dst_idxlist, inter_comm, intra_comm, config) &
           BIND(C, name='xt_xmap_dist_dir_intercomm_custom_new_f') &
           RESULT(xmap_ptr)
        IMPORT :: xt_idxlist, xt_xmap, xt_mpi_fint_kind, xt_config, c_ptr
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: inter_comm, intra_comm
        TYPE(xt_config), INTENT(in) :: config
        TYPE(c_ptr) :: xmap_ptr
      END FUNCTION xt_xmap_dist_dir_intercomm_custom_new_f
    END INTERFACE

    xmap%cptr = xt_xmap_dist_dir_intercomm_custom_new_f(src_idxlist, &
         dst_idxlist, inter_comm, intra_comm, config)
  END FUNCTION xt_xmap_dist_dir_intercomm_custom_new

  FUNCTION xt_xmap_get_num_destinations(xmap) RESULT(num)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER :: num
    INTERFACE
      FUNCTION xt_xmap_get_num_destinations_c(xmap) RESULT(num) &
           BIND(c, name='xt_xmap_get_num_destinations')
        IMPORT :: c_ptr, c_int
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: xmap
        INTEGER(c_int) :: num
      END FUNCTION xt_xmap_get_num_destinations_c
    END INTERFACE
    num = INT(xt_xmap_get_num_destinations_c(xmap%cptr))
  END FUNCTION xt_xmap_get_num_destinations

  FUNCTION xt_xmap_get_num_sources(xmap) RESULT(num)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER :: num
    INTERFACE
      FUNCTION xt_xmap_get_num_sources_c(xmap) RESULT(num) &
           BIND(c, name='xt_xmap_get_num_sources')
        IMPORT :: c_ptr, c_int
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: xmap
        INTEGER(c_int) :: num
      END FUNCTION xt_xmap_get_num_sources_c
    END INTERFACE
    num = INT(xt_xmap_get_num_sources_c(xmap%cptr))
  END FUNCTION xt_xmap_get_num_sources

  SUBROUTINE xt_xmap_get_destination_ranks(xmap, ranks)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(c_int), INTENT(out) :: ranks(*)
    INTERFACE
      SUBROUTINE xt_xmap_get_destination_ranks_c(xmap, ranks) &
           BIND(c, name='xt_xmap_get_destination_ranks')
        IMPORT :: c_ptr, c_int
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: xmap
        INTEGER(c_int), INTENT(out) :: ranks(*)
      END SUBROUTINE xt_xmap_get_destination_ranks_c
    END INTERFACE
    CALL xt_xmap_get_destination_ranks_c(xmap%cptr, ranks)
  END SUBROUTINE xt_xmap_get_destination_ranks

  SUBROUTINE xt_xmap_get_source_ranks(xmap, ranks)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(c_int), INTENT(out) :: ranks(*)
    INTERFACE
      SUBROUTINE xt_xmap_get_source_ranks_c(xmap, ranks) &
           BIND(c, name='xt_xmap_get_source_ranks')
        IMPORT :: c_ptr, c_int
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: xmap
        INTEGER(c_int), INTENT(out) :: ranks(*)
      END SUBROUTINE xt_xmap_get_source_ranks_c
    END INTERFACE
    CALL xt_xmap_get_source_ranks_c(xmap%cptr, ranks)
  END SUBROUTINE xt_xmap_get_source_ranks

  FUNCTION xt_xmap_get_max_src_pos(xmap) RESULT(num)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER :: num
    INTERFACE
      FUNCTION xt_xmap_get_max_src_pos_c(xmap) RESULT(num) &
           BIND(c, name='xt_xmap_get_max_src_pos')
        IMPORT :: c_ptr, c_int
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: xmap
        INTEGER(c_int) :: num
      END FUNCTION xt_xmap_get_max_src_pos_c
    END INTERFACE
    num = INT(xt_xmap_get_max_src_pos_c(xmap%cptr))
  END FUNCTION xt_xmap_get_max_src_pos

  FUNCTION xt_xmap_get_max_dst_pos(xmap) RESULT(num)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER :: num
    INTERFACE
      FUNCTION xt_xmap_get_max_dst_pos_c(xmap) RESULT(num) &
           BIND(c, name='xt_xmap_get_max_dst_pos')
        IMPORT :: c_ptr, c_int
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: xmap
        INTEGER(c_int) :: num
      END FUNCTION xt_xmap_get_max_dst_pos_c
    END INTERFACE
    num = INT(xt_xmap_get_max_dst_pos_c(xmap%cptr))
  END FUNCTION xt_xmap_get_max_dst_pos

  FUNCTION xt_xmap_reorder(xmap, reorder_type) RESULT(xmap_reorder)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(xt_reorder_type_kind), INTENT(in) :: reorder_type
    TYPE(xt_xmap) :: xmap_reorder
    ! fixme: evil hack because gfortran with all warnings enabled throws a
    ! hissy fit for dummy arguments of type integer(xt_reorder_kind)
    ! of bind(c) routines, but the value of xt_reorder_kind always
    ! matches c_int for that compiler anyway
#ifdef __GNUC__
    LOGICAL, PARAMETER :: static_assert_xt_reorder_type_kind &
         = xt_reorder_type_kind == c_int
    INTEGER, PARAMETER :: assert_check &
         = 1 / MERGE(1, 0, static_assert_xt_reorder_type_kind)
#  define xt_reorder_type_kind c_int
#endif
    INTERFACE
      FUNCTION xt_xmap_reorder_c(xmap, reorder_type) &
           BIND(C, name='xt_xmap_reorder') RESULT(xmap_reorder_ptr)
        IMPORT:: xt_reorder_type_kind, c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: xmap
        INTEGER(xt_reorder_type_kind), VALUE, INTENT(in) :: reorder_type
        TYPE(c_ptr) :: xmap_reorder_ptr
      END FUNCTION xt_xmap_reorder_c
    END INTERFACE
#ifdef __GNUC__
#  define UNUSED(x) IF (SIZE( (/(x)/) ) < 0) CONTINUE
    UNUSED(assert_check)
#endif

    IF (reorder_type < 0_xt_reorder_type_kind .OR. &
         reorder_type > HUGE(1_c_int)) &
         CALL xt_abort("invalid reorder type", filename, __LINE__)
    xmap_reorder%cptr = xt_xmap_reorder_c(xmap%cptr, reorder_type)
  ! fixme: undo effect of above hack
#ifdef __GNUC__
#  undef xt_reorder_type_kind
#endif
  END FUNCTION xt_xmap_reorder

  FUNCTION xt_xmap_reorder_custom(xmap, reorder_type, config) &
       RESULT(xmap_reorder)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(xt_reorder_type_kind), INTENT(in) :: reorder_type
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_xmap) :: xmap_reorder
    ! fixme: evil hack because gfortran with all warnings enabled throws a
    ! hissy fit for dummy arguments of type integer(xt_reorder_kind)
    ! of bind(c) routines, but the value of xt_reorder_kind always
    ! matches c_int for that compiler anyway
#ifdef __GNUC__
    LOGICAL, PARAMETER :: static_assert_xt_reorder_type_kind &
         = xt_reorder_type_kind == c_int
    INTEGER, PARAMETER :: assert_check &
         = 1 / MERGE(1, 0, static_assert_xt_reorder_type_kind)
#  define xt_reorder_type_kind c_int
#endif
    INTERFACE
      FUNCTION xt_xmap_reorder_custom_c(xmap, reorder_type, config) &
           BIND(C, name='xt_xmap_reorder_custom') RESULT(xmap_reorder_ptr)
        IMPORT:: xt_reorder_type_kind, c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: xmap, config
        INTEGER(xt_reorder_type_kind), VALUE, INTENT(in) :: reorder_type
        TYPE(c_ptr) :: xmap_reorder_ptr
      END FUNCTION xt_xmap_reorder_custom_c
    END INTERFACE
#ifdef __GNUC__
#  define UNUSED(x) IF (SIZE( (/(x)/) ) < 0) CONTINUE
    UNUSED(assert_check)
#endif

    IF (reorder_type < 0_xt_reorder_type_kind .OR. &
         reorder_type > HUGE(1_c_int)) &
         CALL xt_abort("invalid reorder type", filename, __LINE__)
    xmap_reorder%cptr = xt_xmap_reorder_custom_c(xmap%cptr, reorder_type, &
         xt_config_f2c(config))
  ! fixme: undo effect of above hack
#ifdef __GNUC__
#  undef xt_reorder_type_kind
#endif
  END FUNCTION xt_xmap_reorder_custom

  FUNCTION xt_xmap_update_positions(xmap, src_positions, dst_positions) &
      RESULT(xmap_updated)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER, TARGET, INTENT(in) :: src_positions(*)
    INTEGER, TARGET, INTENT(in) :: dst_positions(*)
    TYPE(xt_xmap) :: xmap_updated
    INTEGER(c_int), TARGET, ALLOCATABLE :: src_positions_c(:), dst_positions_c(:)
    TYPE(c_ptr) :: src_positions_p, dst_positions_p
    INTERFACE
      FUNCTION xt_xmap_update_positions_c(xmap, src_positions, dst_positions) &
           BIND(C, name='xt_xmap_update_positions') RESULT(xmap_updated_ptr)
        IMPORT:: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: xmap, src_positions, dst_positions
        TYPE(c_ptr) :: xmap_updated_ptr
      END FUNCTION xt_xmap_update_positions_c
    END INTERFACE

    IF (c_int == KIND(1)) THEN
      src_positions_p = C_LOC(src_positions)
      dst_positions_p = C_LOC(dst_positions)
    ELSE
      CALL arg2ci(xt_xmap_get_max_src_pos(xmap), src_positions, src_positions_c)
      src_positions_p = C_LOC(src_positions_c)
      CALL arg2ci(xt_xmap_get_max_dst_pos(xmap), dst_positions, dst_positions_c)
      dst_positions_p = C_LOC(dst_positions_c)
    END IF
    xmap_updated%cptr = &
      xt_xmap_update_positions_c(xmap%cptr, src_positions_p, dst_positions_p)
    CONTAINS
      SUBROUTINE arg2ci(n, arg, argc)
        INTEGER, INTENT(in) :: n, arg(*)
        INTEGER(c_int), ALLOCATABLE, INTENT(inout) :: argc(:)
        INTEGER :: i
        ALLOCATE(argc(n))
        DO i = 1, n
          argc(i) = INT(arg(i), c_int)
        END DO
      END SUBROUTINE arg2ci
  END FUNCTION xt_xmap_update_positions

  FUNCTION xt_xmap_spread_a1d(xmap, src_displacements, dst_displacements) &
      RESULT(xmap_spread)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER, INTENT(in) :: src_displacements(:)
    INTEGER, INTENT(in) :: dst_displacements(:)
    TYPE(xt_xmap) :: xmap_spread
    INTEGER :: num_repetitions
    INTEGER(i8) :: num_repetitions_i8
    num_repetitions = SIZE(src_displacements)
    IF (num_repetitions /= SIZE(dst_displacements)) &
         CALL xt_abort("invalid number of repetitions", filename, __LINE__)
    num_repetitions_i8 = INT(num_repetitions, i8)
    xmap_spread = &
      xt_xmap_spread( &
        xmap, num_repetitions_i8, src_displacements, dst_displacements);
  END FUNCTION xt_xmap_spread_a1d

  FUNCTION xt_xmap_spread_i2_a1d(xmap, num_repetitions, src_displacements, &
                                 dst_displacements) &
      RESULT(xmap_spread)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i2), INTENT(in) :: num_repetitions
    INTEGER, INTENT(in) :: src_displacements(num_repetitions)
    INTEGER, INTENT(in) :: dst_displacements(num_repetitions)
    TYPE(xt_xmap) :: xmap_spread
    INTEGER(i8) :: num_repetitions_i8
    num_repetitions_i8 = INT(num_repetitions, i8)
    xmap_spread = &
      xt_xmap_spread( &
        xmap, num_repetitions_i8, src_displacements, dst_displacements);
  END FUNCTION xt_xmap_spread_i2_a1d

  FUNCTION xt_xmap_spread_i4_a1d(xmap, num_repetitions, src_displacements, &
                                 dst_displacements) &
      RESULT(xmap_spread)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i4), INTENT(in) :: num_repetitions
    INTEGER, INTENT(in) :: src_displacements(num_repetitions)
    INTEGER, INTENT(in) :: dst_displacements(num_repetitions)
    TYPE(xt_xmap) :: xmap_spread
    INTEGER(i8) :: num_repetitions_i8
    num_repetitions_i8 = INT(num_repetitions, i8)
    xmap_spread = &
      xt_xmap_spread( &
        xmap, num_repetitions_i8, src_displacements, dst_displacements);
  END FUNCTION xt_xmap_spread_i4_a1d

  FUNCTION xt_xmap_spread_i8_a1d(xmap, num_repetitions, src_displacements, &
                                 dst_displacements) &
      RESULT(xmap_spread)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i8), INTENT(in) :: num_repetitions
    INTEGER, TARGET, INTENT(in) :: src_displacements(num_repetitions)
    INTEGER, TARGET, INTENT(in) :: dst_displacements(num_repetitions)
    INTEGER(c_int) :: num_repetitions_c
    TYPE(xt_xmap) :: xmap_spread
    INTEGER(c_int), TARGET, ALLOCATABLE :: &
      src_displacements_c(:), dst_displacements_c(:)
    TYPE(c_ptr) :: src_displacements_p, dst_displacements_p
    INTERFACE
      FUNCTION xt_xmap_spread_c(xmap, num_repetitions, src_displacements, &
                                dst_displacements) &
           BIND(C, name='xt_xmap_spread') RESULT(xmap_spread_ptr)
        IMPORT:: c_ptr, c_int
        TYPE(c_ptr), VALUE, INTENT(in) :: &
          xmap, src_displacements, dst_displacements
        INTEGER(c_int), VALUE, INTENT(in) :: num_repetitions
        TYPE(c_ptr) :: xmap_spread_ptr
      END FUNCTION xt_xmap_spread_c
    END INTERFACE
    IF (num_repetitions < 0_c_int .OR. &
        num_repetitions > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_repetitions_c = INT(num_repetitions, c_int)
    IF (c_int == KIND(1)) THEN
      src_displacements_p = C_LOC(src_displacements)
      dst_displacements_p = C_LOC(dst_displacements)
    ELSE
      CALL arg2ci(src_displacements, src_displacements_c)
      src_displacements_p = C_LOC(src_displacements_c)
      CALL arg2ci(dst_displacements, dst_displacements_c)
      dst_displacements_p = C_LOC(dst_displacements_c)
    END IF
    xmap_spread%cptr = &
      xt_xmap_spread_c( &
        xmap%cptr, num_repetitions_c, src_displacements_p, dst_displacements_p)
  CONTAINS
    SUBROUTINE arg2ci(arg, argc)
      INTEGER, INTENT(in) :: arg(*)
      INTEGER(c_int), ALLOCATABLE, INTENT(inout) :: argc(:)
      INTEGER :: i, n
      n = INT(num_repetitions)
      ALLOCATE(argc(n))
      DO i = 1, n
        argc(i) = INT(arg(i), c_int)
      END DO
    END SUBROUTINE arg2ci
  END FUNCTION xt_xmap_spread_i8_a1d

  FUNCTION xt_xmap_get_out_iterator(xmap) RESULT(iter)
    TYPE(xt_xmap), INTENT(in) :: xmap
    TYPE(xt_xmap_iter) :: iter
    INTERFACE
      FUNCTION xt_xmap_get_out_iterator_c(xmap) RESULT(cptr) &
           BIND(c, name='xt_xmap_get_out_iterator')
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: xmap
        TYPE(c_ptr) :: cptr
      END FUNCTION xt_xmap_get_out_iterator_c
    END INTERFACE
    iter%cptr = xt_xmap_get_out_iterator_c(xmap%cptr)
  END FUNCTION xt_xmap_get_out_iterator

  FUNCTION xt_xmap_get_in_iterator(xmap) RESULT(iter)
    TYPE(xt_xmap), INTENT(in) :: xmap
    TYPE(xt_xmap_iter) :: iter
    INTERFACE
      FUNCTION xt_xmap_get_in_iterator_c(xmap) RESULT(cptr) &
           BIND(c, name='xt_xmap_get_in_iterator')
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: xmap
        TYPE(c_ptr) :: cptr
      END FUNCTION xt_xmap_get_in_iterator_c
    END INTERFACE
    iter%cptr = xt_xmap_get_in_iterator_c(xmap%cptr)
  END FUNCTION xt_xmap_get_in_iterator

  FUNCTION xt_xmap_iterator_is_null(iter) RESULT(p)
    TYPE(xt_xmap_iter), INTENT(in) :: iter
    LOGICAL :: p
    p = .NOT. C_ASSOCIATED(iter%cptr)
  END FUNCTION xt_xmap_iterator_is_null

  FUNCTION xt_xmap_iterator_next(iter) RESULT(avail)
    TYPE(xt_xmap_iter), INTENT(inout) :: iter
    LOGICAL :: avail
    INTERFACE
      FUNCTION xt_xmap_iterator_next_c(iter) RESULT(avail) &
           BIND(c, name='xt_xmap_iterator_next')
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE, INTENT(in) :: iter
        INTEGER(c_int) :: avail
      END FUNCTION xt_xmap_iterator_next_c
    END INTERFACE
    avail = xt_xmap_iterator_next_c(iter%cptr) /= 0
  END FUNCTION xt_xmap_iterator_next

  FUNCTION xt_xmap_iterator_get_rank(iter) RESULT(rank)
    TYPE(xt_xmap_iter), INTENT(in) :: iter
    INTEGER :: rank
    INTERFACE
      FUNCTION xt_xmap_iterator_get_rank_c(iter) RESULT(rank) &
           BIND(c, name='xt_xmap_iterator_get_rank')
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE, INTENT(in) :: iter
        INTEGER(c_int) :: rank
      END FUNCTION xt_xmap_iterator_get_rank_c
    END INTERFACE
    rank = INT(xt_xmap_iterator_get_rank_c(iter%cptr))
  END FUNCTION xt_xmap_iterator_get_rank

  !> note: result is read-only
  FUNCTION xt_xmap_iterator_get_transfer_pos(iter) RESULT(transfer_pos)
    TYPE(xt_xmap_iter), INTENT(in) :: iter
    INTEGER(c_int), POINTER :: transfer_pos(:)

    INTERFACE
      FUNCTION xt_xmap_iterator_get_transfer_pos_c(iter) RESULT(transfer_pos) &
           BIND(c, name='xt_xmap_iterator_get_transfer_pos')
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: iter
        TYPE(c_ptr) :: transfer_pos
      END FUNCTION xt_xmap_iterator_get_transfer_pos_c
    END INTERFACE
    INTEGER :: n(1)
    TYPE(c_ptr) :: transfer_pos_cptr
    NULLIFY(transfer_pos)
    n(1) = INT(xt_xmap_iterator_get_num_transfer_pos_c(iter%cptr))
    transfer_pos_cptr = xt_xmap_iterator_get_transfer_pos_c(iter%cptr)
    CALL C_F_POINTER(transfer_pos_cptr, transfer_pos, n)
  END FUNCTION xt_xmap_iterator_get_transfer_pos

  FUNCTION xt_xmap_iterator_get_num_transfer_pos(iter) RESULT(num)
    TYPE(xt_xmap_iter), INTENT(in) :: iter
    INTEGER :: num
    num = INT(xt_xmap_iterator_get_num_transfer_pos_c(iter%cptr))
  END FUNCTION xt_xmap_iterator_get_num_transfer_pos

  !> note: result is read-only
  FUNCTION xt_xmap_iterator_get_transfer_pos_ext(iter) RESULT(transfer_pos_ext)
    TYPE(xt_xmap_iter), INTENT(in) :: iter
    TYPE(xt_pos_ext), POINTER :: transfer_pos_ext(:)

    INTERFACE
      FUNCTION xt_xmap_iterator_get_transfer_pos_ext_c(iter) &
           RESULT(transfer_pos_ext) &
           BIND(c, name='xt_xmap_iterator_get_transfer_pos_ext')
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: iter
        TYPE(c_ptr) :: transfer_pos_ext
      END FUNCTION xt_xmap_iterator_get_transfer_pos_ext_c
    END INTERFACE
    INTEGER :: n(1)
    TYPE(c_ptr) :: transfer_pos_ext_cptr
    NULLIFY(transfer_pos_ext)
    n(1) = INT(xt_xmap_iterator_get_num_transfer_pos_ext_c(iter%cptr))
    transfer_pos_ext_cptr = xt_xmap_iterator_get_transfer_pos_ext_c(iter%cptr)
    CALL C_F_POINTER(transfer_pos_ext_cptr, transfer_pos_ext, n)
  END FUNCTION xt_xmap_iterator_get_transfer_pos_ext

  FUNCTION xt_xmap_iterator_get_num_transfer_pos_ext(iter) RESULT(num)
    TYPE(xt_xmap_iter), INTENT(in) :: iter
    INTEGER :: num
    num = INT(xt_xmap_iterator_get_num_transfer_pos_ext_c(iter%cptr))
  END FUNCTION xt_xmap_iterator_get_num_transfer_pos_ext

  SUBROUTINE xt_xmap_iterator_delete(iter)
    TYPE(xt_xmap_iter), INTENT(inout) :: iter
    INTERFACE
      SUBROUTINE xt_xmap_iterator_delete_c(iter) &
           BIND(c, name='xt_xmap_iterator_delete')
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: iter
      END SUBROUTINE xt_xmap_iterator_delete_c
    END INTERFACE
    CALL xt_xmap_iterator_delete_c(iter%cptr)
    iter%cptr = c_null_ptr
  END SUBROUTINE xt_xmap_iterator_delete
END MODULE xt_xmap_abstract

MODULE xt_xmap_rename
  USE xt_xmap_abstract, ONLY: xt_xmap_all2all_orig_new => xt_xmap_all2all_new, &
       xt_xmap_all2all_custom_new, &
       xt_xmap_dist_dir_orig_new => xt_xmap_dist_dir_new, &
       xt_xmap_dist_dir_custom_new, &
       xt_xmap_dist_dir_intercomm_orig_new => xt_xmap_dist_dir_intercomm_new, &
       xt_xmap_dist_dir_intercomm_custom_new
  IMPLICIT NONE
  PRIVATE
  INTERFACE xt_xmap_all2all_new
    MODULE PROCEDURE xt_xmap_all2all_orig_new
    MODULE PROCEDURE xt_xmap_all2all_custom_new
  END INTERFACE xt_xmap_all2all_new
  PUBLIC :: xt_xmap_all2all_new
  INTERFACE xt_xmap_dist_dir_new
    MODULE PROCEDURE xt_xmap_dist_dir_orig_new
    MODULE PROCEDURE xt_xmap_dist_dir_custom_new
  END INTERFACE xt_xmap_dist_dir_new
  PUBLIC :: xt_xmap_dist_dir_new
  INTERFACE xt_xmap_dist_dir_intercomm_new
    MODULE PROCEDURE xt_xmap_dist_dir_intercomm_orig_new
    MODULE PROCEDURE xt_xmap_dist_dir_intercomm_custom_new
  END INTERFACE xt_xmap_dist_dir_intercomm_new
  PUBLIC :: xt_xmap_dist_dir_intercomm_new
END MODULE xt_xmap_rename
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file xt_idxlist_f.f90
!! @brief Fortran interface to yaxt idxlist methods
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE xt_idxlist_abstract
  USE xt_core, ONLY: xt_int_kind, xt_mpi_fint_kind, xt_stripe, &
       xt_bounds, xt_abort, i2, i4, i8, &
       xt_pos_ext, OPERATOR(==)
  USE xt_config_f, ONLY: xt_config, xt_config_f2c
  USE iso_c_binding, ONLY: c_ptr, c_int, c_f_pointer, c_null_ptr, &
       c_associated, c_loc
  IMPLICIT NONE
  PRIVATE

  ! note: this type must not be extended to contain any other
  ! components, its memory pattern has to match void * exactly, which
  ! it does because of C constraints
  TYPE, BIND(C), PUBLIC :: xt_idxlist
#ifndef __G95__
    PRIVATE
#endif
    TYPE(c_ptr) :: cptr = c_null_ptr
  END TYPE xt_idxlist

  INTERFACE

    ! this function must not be implemented in Fortran because
    ! PGI 11.x chokes on that
    FUNCTION xt_idxlist_f2c(idxlist) BIND(c, name='xt_idxlist_f2c') RESULT(p)
      IMPORT :: c_ptr, xt_idxlist
      IMPLICIT NONE
      TYPE(xt_idxlist), INTENT(in) :: idxlist
      TYPE(c_ptr) :: p
    END FUNCTION xt_idxlist_f2c

    FUNCTION xt_idxlist_get_pack_size(idxlist, comm) &
         BIND(c, name='xt_idxlist_get_pack_size_f2c') RESULT(pack_size)
      IMPORT :: xt_idxlist, xt_mpi_fint_kind
      IMPLICIT NONE
      TYPE(xt_idxlist), INTENT(in) :: idxlist
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: comm
      INTEGER(xt_mpi_fint_kind) :: pack_size
    END FUNCTION xt_idxlist_get_pack_size

  END INTERFACE
  ! xt_idxlist_pack_f(type(xt_idxlist), intent(out) :: idxlist,
  !                  type<*>, intent(inout) :: buffer, integer,
  !                  intent(in) :: buffer_size,
  !                  integer, intent(inout) :: position, integer,
  !                  intent(in) :: comm)
  EXTERNAL :: xt_idxlist_pack_f

  ! xt_idxlist_unpack_f(type(xt_idxlist), intent(out) :: idxlist,
  !                     type<*>, intent(in) :: buffer,
  !                     integer, intent(in) :: buffer_size,
  !                     integer, intent(inout) :: position, integer,
  !                     intent(in) :: comm)
  EXTERNAL :: xt_idxlist_unpack_f

  PUBLIC :: xt_idxlist_delete, xt_idxlist_get_pack_size, &
       xt_idxlist_f2c, xt_idxlist_c2f, xt_is_null, &
       xt_idxlist_pack_f, xt_idxlist_unpack_f, xt_idxlist_copy, &
       xt_idxlist_get_sorting, &
       xt_idxlist_sorted_copy, xt_idxlist_sorted_copy_custom, &
       xt_idxlist_get_index_at_position, xt_idxlist_get_indices_at_positions, &
       xt_idxlist_get_position_of_index, xt_idxlist_get_position_of_index_off, &
       xt_idxlist_get_positions_of_indices, &
       xt_idxlist_get_min_index, xt_idxlist_get_max_index, &
       xt_idxlist_get_num_index_stripes, &
       xt_idxlist_get_index_stripes, &
       xt_idxlist_get_num_indices, &
       xt_idxlist_get_indices, xt_idxlist_get_indices_const, &
       xt_idxlist_get_bounding_box, xt_idxlist_get_intersection, &
       xt_idxlist_get_pos_exts_of_index_stripes, &
       xt_idxlist_is_stripe_conversion_profitable
  INTERFACE

    FUNCTION xt_idxlist_get_num_indices_c(idxlist) RESULT(num_indices) &
         BIND(c, name='xt_idxlist_get_num_indices')
      IMPORT :: c_int, c_ptr
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
      INTEGER(c_int) :: num_indices
    END FUNCTION xt_idxlist_get_num_indices_c

    SUBROUTINE xt_idxlist_get_indices_c(idxlist, indices) &
         BIND(c, name='xt_idxlist_get_indices')
      IMPORT :: c_ptr, xt_int_kind
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
      INTEGER(xt_int_kind), INTENT(out) :: indices(*)
    END SUBROUTINE xt_idxlist_get_indices_c

    SUBROUTINE xt_idxlist_delete_c(idxlist) BIND(C, name='xt_idxlist_delete')
      IMPORT :: c_ptr
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
    END SUBROUTINE xt_idxlist_delete_c

    FUNCTION xt_idxlist_get_indices_at_positions_c(idxlist, positions, &
         num_pos, indices, undef_idx) &
         BIND(c, name='xt_idxlist_get_indices_at_positions') RESULT(num_subst)
      IMPORT :: c_ptr, c_int, xt_int_kind
      TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
      INTEGER(c_int), INTENT(in) :: positions(*)
      INTEGER(c_int), VALUE, INTENT(in) :: num_pos
      INTEGER(xt_int_kind), VALUE, INTENT(in) :: undef_idx
      INTEGER(xt_int_kind), INTENT(out) :: indices(*)
      INTEGER(c_int) :: num_subst
    END FUNCTION xt_idxlist_get_indices_at_positions_c

  END INTERFACE

  INTERFACE xt_idxlist_delete
    MODULE PROCEDURE xt_idxlist_delete_1
    MODULE PROCEDURE xt_idxlist_delete_a1d
    MODULE PROCEDURE xt_idxlist_delete_a2d
  END INTERFACE xt_idxlist_delete

  INTERFACE xt_idxlist_get_indices
    MODULE PROCEDURE xt_idxlist_get_indices_1d
    MODULE PROCEDURE xt_idxlist_get_indices_2d
    MODULE PROCEDURE xt_idxlist_get_indices_3d
    MODULE PROCEDURE xt_idxlist_get_indices_4d
    MODULE PROCEDURE xt_idxlist_get_indices_5d
    MODULE PROCEDURE xt_idxlist_get_indices_6d
    MODULE PROCEDURE xt_idxlist_get_indices_7d
  END INTERFACE xt_idxlist_get_indices

  INTERFACE xt_is_null
    MODULE PROCEDURE xt_idxlist_is_null
  END INTERFACE xt_is_null

  INTERFACE xt_idxlist_get_indices_at_positions
    MODULE PROCEDURE xt_idxlist_get_indices_at_positions_a1d
    MODULE PROCEDURE xt_idxlist_get_indices_at_positions_a1d_i2
    MODULE PROCEDURE xt_idxlist_get_indices_at_positions_a1d_i4
    MODULE PROCEDURE xt_idxlist_get_indices_at_positions_a1d_i8
  END INTERFACE xt_idxlist_get_indices_at_positions

  INTERFACE
    FUNCTION xt_idxlist_get_pos_exts_of_index_stripes_c(idxlist, &
       num_stripes, stripes, num_ext, pos_ext, single_match_only) &
       BIND(c, name='xt_idxlist_get_pos_exts_of_index_stripes') &
       RESULT(num_unmatched)
      IMPORT :: c_ptr, c_int
      TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
      INTEGER(c_int), VALUE, INTENT(in) ::  num_stripes
      TYPE(c_ptr), VALUE, INTENT(in) :: stripes
      INTEGER(c_int), INTENT(out) :: num_ext
      TYPE(c_ptr), INTENT(out) :: pos_ext
      INTEGER(c_int), VALUE, INTENT(in) :: single_match_only
      INTEGER(c_int) :: num_unmatched
    END FUNCTION xt_idxlist_get_pos_exts_of_index_stripes_c

    SUBROUTINE free_c(p) BIND(c, name='free')
      IMPORT :: c_ptr
      TYPE(c_ptr), VALUE, INTENT(in) :: p
    END SUBROUTINE free_c
  END INTERFACE

  INTERFACE xt_idxlist_get_pos_exts_of_index_stripes
    MODULE PROCEDURE gpe_is_i4_a_i4_p1d_l
    MODULE PROCEDURE gpe_is_a_p1d_l
  END INTERFACE xt_idxlist_get_pos_exts_of_index_stripes

  INTERFACE xt_idxlist_sorted_copy
    MODULE PROCEDURE xt_idxlist_sorted_copy
    MODULE PROCEDURE xt_idxlist_sorted_copy_custom
  END INTERFACE xt_idxlist_sorted_copy

  CHARACTER(len=*), PARAMETER :: filename = 'xt_idxlist_f.f90'
CONTAINS

  FUNCTION xt_idxlist_is_null(idxlist) RESULT(p)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    LOGICAL :: p
    p = .NOT. C_ASSOCIATED(idxlist%cptr)
  END FUNCTION xt_idxlist_is_null

  SUBROUTINE xt_idxlist_delete_1(idxlist)
    TYPE(xt_idxlist), INTENT(inout) :: idxlist
    CALL xt_idxlist_delete_c(idxlist%cptr)
    idxlist%cptr = c_null_ptr
  END SUBROUTINE xt_idxlist_delete_1

  SUBROUTINE xt_idxlist_delete_a1d(idxlists)
    TYPE(xt_idxlist), INTENT(inout) :: idxlists(:)
    INTEGER :: i, n
    n = SIZE(idxlists)
    DO i = 1, n
      CALL xt_idxlist_delete_c(idxlists(i)%cptr)
      idxlists(i)%cptr = c_null_ptr
    END DO
  END SUBROUTINE xt_idxlist_delete_a1d

  SUBROUTINE xt_idxlist_delete_a2d(idxlists)
    TYPE(xt_idxlist), INTENT(inout) :: idxlists(:, :)
    INTEGER :: i, j, m, n
    m = SIZE(idxlists, 1)
    n = SIZE(idxlists, 2)
    DO j = 1, n
      DO i = 1, m
        CALL xt_idxlist_delete_c(idxlists(i, j)%cptr)
        idxlists(i, j)%cptr = c_null_ptr
      END DO
    END DO
  END SUBROUTINE xt_idxlist_delete_a2d

  FUNCTION xt_idxlist_get_index_at_position(idxlist, position, idx) RESULT(res)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER, VALUE, INTENT(in) :: position
    INTEGER(xt_int_kind), INTENT(out) :: idx
    LOGICAL :: res
    INTEGER(c_int) :: position_c

    INTERFACE
      FUNCTION xt_idxlist_get_index_at_position_c(idxlist, position, idx) &
           BIND(c, name='xt_idxlist_get_index_at_position') RESULT(res)
        IMPORT :: c_ptr, c_int, xt_int_kind
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
        INTEGER(c_int), VALUE, INTENT(in) :: position
        INTEGER(xt_int_kind), INTENT(out) :: idx
        INTEGER(c_int) :: res
      END FUNCTION xt_idxlist_get_index_at_position_c
    END INTERFACE

    position_c = INT(position, c_int)
    res = xt_idxlist_get_index_at_position_c(idxlist%cptr, &
         position_c, idx) /= 0
  END FUNCTION xt_idxlist_get_index_at_position

  FUNCTION xt_idxlist_get_indices_at_positions_a1d(idxlist, positions, &
    indices, undef_idx) RESULT(num_subst)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER, INTENT(in) :: positions(:)
    INTEGER(xt_int_kind), INTENT(out) :: indices(:)
    INTEGER(xt_int_kind), INTENT(in) :: undef_idx
    INTEGER :: num_subst, n
    INTEGER(c_int) :: num_positions_c

    n = SIZE(positions)
    IF (n > HUGE(1_c_int)) n = HUGE(1_c_int)

    num_positions_c = INT(n, c_int)
    num_subst = xt_idxlist_get_indices_at_positions_c(idxlist%cptr, &
         INT(positions, c_int), num_positions_c, &
         indices, undef_idx)
  END FUNCTION xt_idxlist_get_indices_at_positions_a1d

  FUNCTION xt_idxlist_get_indices_at_positions_a1d_i2(idxlist, positions, &
       num_pos, indices, undef_idx) RESULT(num_subst)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER, INTENT(in) :: positions(*)
    INTEGER(xt_int_kind), INTENT(out) :: indices(*)
    INTEGER(xt_int_kind), INTENT(in) :: undef_idx
    INTEGER(i2), INTENT(in) :: num_pos
    INTEGER :: num_subst
    INTEGER(c_int) :: num_pos_c

    num_pos_c = INT(num_pos, c_int)
    num_subst = xt_idxlist_get_indices_at_positions_c(idxlist%cptr, &
         INT(positions(1:num_pos), c_int), num_pos_c, &
         indices, undef_idx)
  END FUNCTION xt_idxlist_get_indices_at_positions_a1d_i2

  FUNCTION xt_idxlist_get_indices_at_positions_a1d_i4(idxlist, positions, &
       num_pos, indices, undef_idx) RESULT(num_subst)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER, INTENT(in) :: positions(*)
    INTEGER(xt_int_kind), INTENT(out) :: indices(*)
    INTEGER(xt_int_kind), INTENT(in) :: undef_idx
    INTEGER(i4), INTENT(in) :: num_pos
    INTEGER :: num_subst
    INTEGER(c_int) :: num_pos_c

    IF (num_pos > HUGE(1_c_int) .OR. num_pos < 0) &
         CALL xt_abort("invalid number of positions", filename, __LINE__)

    num_pos_c = INT(num_pos, c_int)
    num_subst = xt_idxlist_get_indices_at_positions_c(idxlist%cptr, &
         INT(positions(1:num_pos), c_int), num_pos_c, indices, undef_idx)
  END FUNCTION xt_idxlist_get_indices_at_positions_a1d_i4

  FUNCTION xt_idxlist_get_indices_at_positions_a1d_i8(idxlist, positions, &
       num_pos, indices, undef_idx) RESULT(num_subst)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER, INTENT(in) :: positions(*)
    INTEGER(xt_int_kind), INTENT(out) :: indices(*)
    INTEGER(xt_int_kind), INTENT(in) :: undef_idx
    INTEGER(i8), INTENT(in) :: num_pos
    INTEGER :: num_subst
    INTEGER(c_int) :: num_pos_c

    IF (num_pos > HUGE(1_c_int) .OR. num_pos < 0) &
         CALL xt_abort("invalid number of positions", filename, __LINE__)

    num_pos_c = INT(num_pos, c_int)
    num_subst = xt_idxlist_get_indices_at_positions_c(idxlist%cptr, &
         INT(positions(1:num_pos), c_int), num_pos_c, indices, undef_idx)
  END FUNCTION xt_idxlist_get_indices_at_positions_a1d_i8

  FUNCTION xt_idxlist_get_position_of_index(idxlist, idx, position) &
       RESULT(notfound)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), VALUE, INTENT(in) :: idx
    INTEGER, INTENT(out) :: position
    LOGICAL :: notfound
    INTEGER(c_int) :: position_c

    INTERFACE
      FUNCTION xt_idxlist_get_position_of_index_c(idxlist, idx, position) &
           BIND(c, name='xt_idxlist_get_position_of_index') RESULT(res)
        IMPORT :: Xt_idxlist, xt_int_kind, c_int, c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
        INTEGER(xt_int_kind), VALUE, INTENT(in) :: idx
        INTEGER(c_int), INTENT(out) :: position
        INTEGER(c_int) :: res
      END FUNCTION xt_idxlist_get_position_of_index_c
    END INTERFACE

    notfound = xt_idxlist_get_position_of_index_c(idxlist%cptr, &
         idx, position_c) /= 0
    position = INT(position_c)
  END FUNCTION xt_idxlist_get_position_of_index

  FUNCTION xt_idxlist_get_position_of_index_off(idxlist, idx, position, &
       offset) RESULT(notfound)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), VALUE, INTENT(in) :: idx
    INTEGER, INTENT(out) :: position
    INTEGER, INTENT(in) :: offset
    LOGICAL :: notfound
    INTEGER(c_int) :: position_c, offset_c

    INTERFACE
      FUNCTION xt_idxlist_get_position_of_index_off_c(idxlist, idx, position, &
           offset) BIND(c, name='xt_idxlist_get_position_of_index_off') &
           RESULT(res)
        IMPORT :: Xt_idxlist, xt_int_kind, c_int, c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
        INTEGER(xt_int_kind), VALUE, INTENT(in) :: idx
        INTEGER(c_int), INTENT(out) :: position
        INTEGER(c_int), VALUE, INTENT(in) :: offset
        INTEGER(c_int) :: res
      END FUNCTION xt_idxlist_get_position_of_index_off_c
    END INTERFACE

    offset_c = INT(offset, c_int)
    notfound = xt_idxlist_get_position_of_index_off_c(idxlist%cptr, &
         idx, position_c, offset_c) /= 0
    position = INT(position_c)
  END FUNCTION xt_idxlist_get_position_of_index_off

  FUNCTION xt_idxlist_get_positions_of_indices(idxlist, indices, positions, &
       single_match_only) RESULT(num_missing)
    IMPLICIT NONE
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), INTENT(in) :: indices(:)
    INTEGER, INTENT(out) :: positions(:)
    LOGICAL, INTENT(in) :: single_match_only
    INTEGER :: num_missing, n, ofs
    INTEGER(c_int) :: single_match_only_, num_pos_c

    INTERFACE
      FUNCTION xt_idxlist_get_positions_of_indices_c(idxlist, indices, &
           num_indices, positions, single_match_only) &
           BIND(c, name='xt_idxlist_get_positions_of_indices') &
           RESULT(num_missing)
        IMPORT :: Xt_idxlist, xt_int_kind, c_int, c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
        INTEGER(xt_int_kind), INTENT(in) :: indices(*)
        INTEGER(c_int), VALUE, INTENT(in) :: num_indices
        INTEGER(c_int), INTENT(out) :: positions(*)
        INTEGER(c_int), VALUE, INTENT(in) :: single_match_only
        INTEGER(c_int) :: num_missing
      END FUNCTION xt_idxlist_get_positions_of_indices_c
    END INTERFACE

    n = SIZE(indices)
    IF (SIZE(positions) < n) THEN
      CALL xt_abort("positions array too small", filename, __LINE__)
    END IF
    num_missing = 0
    ofs = 1
    single_match_only_ = MERGE(1_c_int, 0_c_int, single_match_only)
    DO WHILE (n > 0)
      IF (n > HUGE(1_c_int)) THEN
        num_missing = num_missing &
             + INT(xt_idxlist_get_positions_of_indices_c(&
             idxlist%cptr, indices(ofs:), HUGE(1_c_int), &
             positions(ofs:), single_match_only_))
        ofs = ofs + HUGE(1_c_int)
        n = n - HUGE(1_c_int)
      ELSE
        num_pos_c = INT(n, c_int)
        num_missing = num_missing &
             + INT(xt_idxlist_get_positions_of_indices_c(&
             idxlist%cptr, indices(ofs:), &
             num_pos_c, positions(ofs:), single_match_only_))
        n = 0
      END IF
    END DO
  END FUNCTION xt_idxlist_get_positions_of_indices

  FUNCTION xt_idxlist_get_num_index_stripes(idxlist) &
       RESULT(num_stripes)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER :: num_stripes

    INTERFACE
      FUNCTION xt_idxlist_get_num_index_stripes_c(idxlist) &
           BIND(c, name='xt_idxlist_get_num_index_stripes') RESULT(num_stripes)
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
        INTEGER(c_int) :: num_stripes
      END FUNCTION xt_idxlist_get_num_index_stripes_c
    END INTERFACE

    INTEGER(c_int) :: num_stripes_c

    num_stripes_c = xt_idxlist_get_num_index_stripes_c(idxlist%cptr)
    IF (num_stripes_c > HUGE(num_stripes)) &
         CALL xt_abort("number of stripes too large", filename, __LINE__)
    num_stripes = INT(num_stripes_c)
  END FUNCTION xt_idxlist_get_num_index_stripes

  FUNCTION xt_idxlist_get_min_index(idxlist) &
       RESULT(min_index)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind) :: min_index

    INTERFACE
      FUNCTION xt_idxlist_get_min_index_c(idxlist) &
           BIND(c, name='xt_idxlist_get_min_index') RESULT(min_index)
        IMPORT :: c_ptr, xt_int_kind
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
        INTEGER(xt_int_kind) :: min_index
      END FUNCTION xt_idxlist_get_min_index_c
    END INTERFACE

    min_index = xt_idxlist_get_min_index_c(idxlist%cptr)
  END FUNCTION xt_idxlist_get_min_index

  FUNCTION xt_idxlist_get_max_index(idxlist) &
       RESULT(max_index)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind) :: max_index

    INTERFACE
      FUNCTION xt_idxlist_get_max_index_c(idxlist) &
           BIND(c, name='xt_idxlist_get_max_index') RESULT(max_index)
        IMPORT :: c_ptr, xt_int_kind
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
        INTEGER(xt_int_kind) :: max_index
      END FUNCTION xt_idxlist_get_max_index_c
    END INTERFACE

    max_index = xt_idxlist_get_max_index_c(idxlist%cptr)
  END FUNCTION xt_idxlist_get_max_index

  SUBROUTINE xt_idxlist_get_index_stripes(idxlist, stripes)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    TYPE(xt_stripe), ALLOCATABLE, INTENT(out) :: stripes(:)

    INTERFACE
      SUBROUTINE xt_idxlist_get_index_stripes_c(idxlist, stripes,&
           num_stripes) BIND(c, name='xt_idxlist_get_index_stripes')
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
        TYPE(c_ptr), INTENT(out) :: stripes
        INTEGER(c_int), INTENT(out) :: num_stripes
      END SUBROUTINE xt_idxlist_get_index_stripes_c
    END INTERFACE
    TYPE(c_ptr) :: stripes_c_ptr
    INTEGER(c_int) :: num_stripes
    TYPE(xt_stripe), POINTER :: stripes_f_ptr(:)
    INTEGER :: stripes_shape(1)
    CALL xt_idxlist_get_index_stripes_c(idxlist%cptr, &
         stripes_c_ptr, num_stripes)
    IF (num_stripes > HUGE(stripes_shape)) &
         CALL xt_abort("number of stripes too large", filename, __LINE__)
    stripes_shape(1) = INT(num_stripes)
    IF (num_stripes > 0) THEN
      ALLOCATE(stripes(INT(num_stripes)))
      CALL C_F_POINTER(stripes_c_ptr, stripes_f_ptr, stripes_shape)
      stripes = stripes_f_ptr
    END IF
    CALL free_c(stripes_c_ptr)
  END SUBROUTINE xt_idxlist_get_index_stripes

  FUNCTION xt_idxlist_get_bounding_box(idxlist, global_size, &
       global_start_index) RESULT(bounds)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), INTENT(in) :: global_size(:)
    INTEGER(xt_int_kind), INTENT(in) :: global_start_index
    TYPE(xt_bounds) :: bounds(SIZE(global_size))
    INTEGER(c_int) :: ndim

    INTERFACE
      SUBROUTINE xt_idxlist_get_bounding_box_c(idxlist, ndim, global_size, &
           global_start_index, bounds) &
           BIND(c, name='xt_idxlist_get_bounding_box')
        IMPORT :: c_int, c_ptr, xt_int_kind, xt_bounds
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
        INTEGER(c_int), VALUE :: ndim
        INTEGER(xt_int_kind), INTENT(in) :: global_size(ndim)
        INTEGER(xt_int_kind), VALUE, INTENT(in) :: global_start_index
        TYPE(xt_bounds), INTENT(out) :: bounds(ndim)
      END SUBROUTINE xt_idxlist_get_bounding_box_c
    END INTERFACE

    ndim = INT(SIZE(global_size), c_int)
    CALL xt_idxlist_get_bounding_box_c(idxlist%cptr, &
         ndim, global_size, global_start_index, bounds)
  END FUNCTION xt_idxlist_get_bounding_box

  FUNCTION xt_idxlist_get_intersection(idxlist_src, idxlist_dst) &
       RESULT(intersection)
    TYPE(xt_idxlist), INTENT(in) :: idxlist_src, idxlist_dst
    TYPE(xt_idxlist) :: intersection

    INTERFACE
      FUNCTION xt_idxlist_get_intersection_c(idxlist_src, idxlist_dst) &
           BIND(c, name='xt_idxlist_get_intersection') RESULT(intersection)
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist_src, idxlist_dst
        TYPE(c_ptr) :: intersection
      END FUNCTION xt_idxlist_get_intersection_c
    END INTERFACE

    intersection = xt_idxlist_c2f(xt_idxlist_get_intersection_c(&
         idxlist_src%cptr, idxlist_dst%cptr))
  END FUNCTION xt_idxlist_get_intersection

  FUNCTION xt_idxlist_copy(idxlist) RESULT(copy)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    TYPE(xt_idxlist) :: copy

    INTERFACE
      FUNCTION xt_idxlist_copy_c(idxlist) BIND(c, name='xt_idxlist_copy') &
           RESULT(copy)
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(IN) :: idxlist
        TYPE(c_ptr) :: copy
      END FUNCTION xt_idxlist_copy_c
    END INTERFACE

    copy = xt_idxlist_c2f(xt_idxlist_copy_c(idxlist%cptr))

  END FUNCTION xt_idxlist_copy

  FUNCTION xt_idxlist_get_sorting(idxlist) RESULT(sorting)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER :: sorting

    INTERFACE
      FUNCTION xt_idxlist_get_sorting_c(idxlist) &
           BIND(c, name='xt_idxlist_get_sorting') RESULT(sorting)
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE, INTENT(IN) :: idxlist
        INTEGER(c_int) :: sorting
      END FUNCTION xt_idxlist_get_sorting_c
    END INTERFACE

    sorting = INT(xt_idxlist_get_sorting_c(idxlist%cptr))

  END FUNCTION xt_idxlist_get_sorting

  FUNCTION xt_idxlist_sorted_copy(idxlist) RESULT(copy)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    TYPE(xt_idxlist) :: copy

    INTERFACE
      FUNCTION xt_idxlist_sorted_copy_c(idxlist) &
           BIND(c, name='xt_idxlist_sorted_copy') &
           RESULT(copy)
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(IN) :: idxlist
        TYPE(c_ptr) :: copy
      END FUNCTION xt_idxlist_sorted_copy_c
    END INTERFACE

    copy = xt_idxlist_c2f(xt_idxlist_sorted_copy_c(idxlist%cptr))

  END FUNCTION xt_idxlist_sorted_copy

  FUNCTION xt_idxlist_sorted_copy_custom(idxlist, config) RESULT(copy)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_idxlist) :: copy

    INTERFACE
      FUNCTION xt_idxlist_sorted_copy_custom_c(idxlist, config) &
           BIND(c, name='xt_idxlist_sorted_copy_custom') &
           RESULT(copy)
        IMPORT :: c_ptr
        TYPE(c_ptr), VALUE, INTENT(IN) :: idxlist, config
        TYPE(c_ptr) :: copy
      END FUNCTION xt_idxlist_sorted_copy_custom_c
    END INTERFACE

    copy = xt_idxlist_c2f(xt_idxlist_sorted_copy_custom_c(idxlist%cptr, &
         xt_config_f2c(config)))

  END FUNCTION xt_idxlist_sorted_copy_custom

  FUNCTION xt_idxlist_c2f(idxlist) RESULT(p)
    TYPE(c_ptr), INTENT(in) :: idxlist
    TYPE(xt_idxlist) :: p
    p%cptr = idxlist
  END FUNCTION xt_idxlist_c2f

  FUNCTION xt_idxlist_get_num_indices(idxlist) RESULT(num_indices)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER :: num_indices
    INTEGER(c_int) :: n
    n = xt_idxlist_get_num_indices_c(idxlist%cptr)
    IF (n > HUGE(num_indices) .OR. n < -HUGE(num_indices)) &
         CALL xt_abort("num_indices out of bounds", filename, __LINE__)
    num_indices = INT(n)
  END FUNCTION xt_idxlist_get_num_indices

  SUBROUTINE xt_idxlist_get_indices_1d(idxlist, indices)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), INTENT(out) :: indices(:)
    INTEGER(c_int) :: num_indices
    num_indices = xt_idxlist_get_num_indices_c(idxlist%cptr)
    IF (num_indices > SIZE(indices)) THEN
      CALL xt_abort("indices array too small", filename, __LINE__)
    END IF
    CALL xt_idxlist_get_indices_c(idxlist%cptr, indices)
  END SUBROUTINE xt_idxlist_get_indices_1d

  SUBROUTINE xt_idxlist_get_indices_2d(idxlist, indices)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), INTENT(out) :: indices(:,:)
    INTEGER(c_int) :: num_indices
    num_indices = xt_idxlist_get_num_indices_c(idxlist%cptr)
    IF (num_indices > SIZE(indices)) THEN
      CALL xt_abort("indices array too small", filename, __LINE__)
    END IF
    CALL xt_idxlist_get_indices_c(idxlist%cptr, indices)
  END SUBROUTINE xt_idxlist_get_indices_2d

  SUBROUTINE xt_idxlist_get_indices_3d(idxlist, indices)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), INTENT(out) :: indices(:,:,:)
    INTEGER(c_int) :: num_indices
    num_indices = xt_idxlist_get_num_indices_c(idxlist%cptr)
    IF (num_indices > SIZE(indices)) THEN
      CALL xt_abort("indices array too small", filename, __LINE__)
    END IF
    CALL xt_idxlist_get_indices_c(idxlist%cptr, indices)
  END SUBROUTINE xt_idxlist_get_indices_3d

  SUBROUTINE xt_idxlist_get_indices_4d(idxlist, indices)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), INTENT(out) :: indices(:,:,:,:)
    INTEGER(c_int) :: num_indices
    num_indices = xt_idxlist_get_num_indices_c(idxlist%cptr)
    IF (num_indices > SIZE(indices)) THEN
      CALL xt_abort("indices array too small", filename, __LINE__)
    END IF
    CALL xt_idxlist_get_indices_c(idxlist%cptr, indices)
  END SUBROUTINE xt_idxlist_get_indices_4d

  SUBROUTINE xt_idxlist_get_indices_5d(idxlist, indices)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), INTENT(out) :: indices(:,:,:,:,:)
    INTEGER(c_int) :: num_indices
    num_indices = xt_idxlist_get_num_indices_c(idxlist%cptr)
    IF (num_indices > SIZE(indices)) THEN
      CALL xt_abort("indices array too small", filename, __LINE__)
    END IF
    CALL xt_idxlist_get_indices_c(idxlist%cptr, indices)
  END SUBROUTINE xt_idxlist_get_indices_5d

  SUBROUTINE xt_idxlist_get_indices_6d(idxlist, indices)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), INTENT(out) :: indices(:,:,:,:,:,:)
    INTEGER(c_int) :: num_indices
    num_indices = xt_idxlist_get_num_indices_c(idxlist%cptr)
    IF (num_indices > SIZE(indices)) THEN
      CALL xt_abort("indices array too small", filename, __LINE__)
    END IF
    CALL xt_idxlist_get_indices_c(idxlist%cptr, indices)
  END SUBROUTINE xt_idxlist_get_indices_6d

  SUBROUTINE xt_idxlist_get_indices_7d(idxlist, indices)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), INTENT(out) :: indices(:,:,:,:,:,:,:)
    INTEGER(c_int) :: num_indices
    num_indices = xt_idxlist_get_num_indices_c(idxlist%cptr)
    IF (num_indices > SIZE(indices)) THEN
      CALL xt_abort("indices array too small", filename, __LINE__)
    END IF
    CALL xt_idxlist_get_indices_c(idxlist%cptr, indices)
  END SUBROUTINE xt_idxlist_get_indices_7d

  FUNCTION xt_idxlist_get_indices_const(idxlist) RESULT(indices)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), POINTER :: indices(:)
    INTEGER(c_int) :: num_indices
    TYPE(c_ptr) :: c_indices
    INTEGER(xt_int_kind), SAVE, TARGET :: dummy(1) = -HUGE(indices)
    INTEGER :: indices_shape(1)
    INTERFACE
      FUNCTION xt_idxlist_get_indices_const_c(idxlist) &
           BIND(c, name='xt_idxlist_get_indices_const') RESULT(indices)
        IMPORT :: c_ptr
        IMPLICIT NONE
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist
        TYPE(c_ptr) :: indices
      END FUNCTION xt_idxlist_get_indices_const_c
    END INTERFACE
    num_indices = xt_idxlist_get_num_indices_c(idxlist%cptr)
    IF (num_indices > 0_xt_int_kind) THEN
      IF (num_indices > HUGE(indices_shape)) &
           CALL xt_abort("too many indices for default integer kind", &
           filename, __LINE__)
      indices_shape(1) = INT(num_indices)
      c_indices = xt_idxlist_get_indices_const_c(idxlist%cptr)
      CALL C_F_POINTER(c_indices, indices, indices_shape)
    ELSE
      indices => dummy(1:0)
    END IF
  END FUNCTION xt_idxlist_get_indices_const

  FUNCTION xt_idxlist_is_stripe_conversion_profitable(idxlist, config) &
       RESULT(profit)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    TYPE(xt_config), INTENT(in) :: config
    INTEGER :: profit
    INTERFACE
      FUNCTION is_stripe_conversion_profitable_c(idxlist, config) &
           RESULT(profit) &
           BIND(c, name="xt_idxlist_is_stripe_conversion_profitable")
        IMPORT :: c_ptr, c_int
        TYPE(c_ptr), VALUE, INTENT(in) :: idxlist, config
        INTEGER(c_int) :: profit
      END FUNCTION is_stripe_conversion_profitable_c
    END INTERFACE
    profit = INT(is_stripe_conversion_profitable_c(idxlist%cptr, &
         xt_config_f2c(config)))
  END FUNCTION xt_idxlist_is_stripe_conversion_profitable

  FUNCTION gpe_is_i4_a_i4_p1d_l(idxlist, &
       num_stripes, stripes, num_ext, pos_ext, single_match_only) &
       RESULT(num_unmatched)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(i4), INTENT(in) ::  num_stripes
    TYPE(xt_stripe), INTENT(in), TARGET :: stripes(num_stripes)
    INTEGER, INTENT(out) :: num_ext
    TYPE(xt_pos_ext), ALLOCATABLE, INTENT(out) :: pos_ext(:)
    LOGICAL, INTENT(in) :: single_match_only
    INTEGER :: num_unmatched

    INTEGER(c_int) :: num_unmatched_c, num_ext_c, num_stripes_c
    TYPE(c_ptr) :: pos_ext_c, stripes_c
    TYPE(xt_pos_ext), POINTER :: pos_ext_fptr(:)
    INTEGER :: pos_ext_shape(1)
    TYPE(xt_pos_ext), TARGET :: dummy_stripe(1)

    IF (num_stripes > HUGE(1_c_int) .OR. num_stripes < 0) &
         CALL xt_abort("interface violation detected", filename, __LINE__)

    IF (num_stripes > 0_i4) THEN
      stripes_c = C_LOC(stripes)
    ELSE
      stripes_c = C_LOC(dummy_stripe)
    END IF
    num_stripes_c = INT(num_stripes, c_int)
    num_unmatched_c = xt_idxlist_get_pos_exts_of_index_stripes_c(&
         idxlist%cptr, num_stripes_c, stripes_c, &
         num_ext_c, pos_ext_c, MERGE(1_c_int, 0_c_int, single_match_only))

    IF (num_ext_c > HUGE(1) .OR. num_ext_c < 0 &
         .OR. num_unmatched_c > HUGE(1) .OR. num_unmatched_c < 0) &
         CALL xt_abort("data representation problem", filename, __LINE__)
    num_unmatched = INT(num_unmatched_c)
    num_ext = INT(num_ext_c)
    IF (num_ext > 0) THEN
      ALLOCATE(pos_ext(num_ext))
      pos_ext_shape(1) = num_ext
      CALL C_F_POINTER(pos_ext_c, pos_ext_fptr, pos_ext_shape)
      pos_ext = pos_ext_fptr
      CALL free_c(pos_ext_c)
    END IF
  END FUNCTION gpe_is_i4_a_i4_p1d_l

  FUNCTION gpe_is_a_p1d_l(idxlist, stripes, pos_ext, single_match_only) &
       RESULT(num_unmatched)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    TYPE(xt_stripe), INTENT(in) :: stripes(:)
    TYPE(xt_pos_ext), ALLOCATABLE, INTENT(out) :: pos_ext(:)
    LOGICAL, INTENT(in) :: single_match_only
    INTEGER :: num_unmatched

    INTEGER :: num_ext
    INTEGER(i4) :: num_stripes

    num_stripes = SIZE(stripes)
    IF (num_stripes > 0) THEN
      num_unmatched = gpe_is_i4_a_i4_p1d_l(idxlist, num_stripes, stripes, &
           num_ext, pos_ext, single_match_only)
    ELSE
      num_unmatched = 0
    END IF
  END FUNCTION gpe_is_a_p1d_l

END MODULE xt_idxlist_abstract
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file xt_redist_int_i8.f90
!! @brief convenience wrappers of xt_redist exchanges for Fortran data
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#include "fc_feature_defs.inc"
MODULE xt_redist_int_i8
  USE xt_redist_base, ONLY: xt_redist, xt_redist_s_exchange1, &
       xt_redist_a_exchange1
  USE xt_requests, ONLY: xt_request
#ifdef HAVE_FC_IS_CONTIGUOUS
  USE xt_core, ONLY: xt_abort
#endif
  USE iso_c_binding, ONLY: c_ptr, c_loc
  IMPLICIT NONE
  PRIVATE
  CHARACTER(len=*), PARAMETER :: filename = 'xt_redist_int_i8.f90'
  INTEGER, PARAMETER :: pi8 =  14
  INTEGER, PARAMETER :: i8 = SELECTED_INT_KIND(pi8)
  PUBLIC :: i8
  INTERFACE xt_redist_s_exchange
    MODULE PROCEDURE xt_redist_s_exchange_i8_1d
    MODULE PROCEDURE xt_redist_s_exchange_i8_2d
    MODULE PROCEDURE xt_redist_s_exchange_i8_3d
    MODULE PROCEDURE xt_redist_s_exchange_i8_4d
    MODULE PROCEDURE xt_redist_s_exchange_i8_5d
    MODULE PROCEDURE xt_redist_s_exchange_i8_6d
    MODULE PROCEDURE xt_redist_s_exchange_i8_7d
  END INTERFACE xt_redist_s_exchange
  PUBLIC :: xt_redist_s_exchange
  INTERFACE xt_redist_a_exchange
    MODULE PROCEDURE xt_redist_a_exchange_i8_1d
    MODULE PROCEDURE xt_redist_a_exchange_i8_2d
    MODULE PROCEDURE xt_redist_a_exchange_i8_3d
    MODULE PROCEDURE xt_redist_a_exchange_i8_4d
    MODULE PROCEDURE xt_redist_a_exchange_i8_5d
    MODULE PROCEDURE xt_redist_a_exchange_i8_6d
    MODULE PROCEDURE xt_redist_a_exchange_i8_7d
  END INTERFACE xt_redist_a_exchange
  PUBLIC :: xt_redist_a_exchange
CONTAINS

  ! see @ref xt_redist_s_exchange
  SUBROUTINE xt_redist_s_exchange_i8_1d_as(redist, src_size, src_data, &
       dst_size, dst_data)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER, INTENT(in) :: src_size, dst_size
    INTEGER(i8), TARGET, INTENT(in) :: src_data(src_size)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(dst_size)
    TYPE(c_ptr) :: src_data_cptr, dst_data_cptr
    src_data_cptr = C_LOC(src_data)
    dst_data_cptr = C_LOC(dst_data)
    CALL xt_redist_s_exchange1(redist, src_data_cptr, dst_data_cptr)
  END SUBROUTINE xt_redist_s_exchange_i8_1d_as

  ! see @ref xt_redist_s_exchange
  SUBROUTINE xt_redist_s_exchange_i8_1d(redist, src_data, dst_data)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:)

    INTEGER(i8), POINTER :: src_p(:), dst_p(:)
    INTEGER(i8), TARGET :: dummy(1)
    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
    IF (src_size > 0) THEN
      src_p => src_data
    ELSE
      src_p => dummy
      src_size = 1
    END IF
    IF (dst_size > 0) THEN
      dst_p => dst_data
    ELSE
      dst_p => dummy
      dst_size = 1
    END IF
    CALL xt_redist_s_exchange_i8_1d_as(redist, src_size, src_p, dst_size, dst_p)
  END SUBROUTINE xt_redist_s_exchange_i8_1d

  ! see @ref xt_redist_s_exchange
  SUBROUTINE xt_redist_s_exchange_i8_2d(redist, src_data, dst_data)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:,:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:,:)

    INTEGER(i8), POINTER :: src_p(:,:), dst_p(:,:)
    INTEGER(i8), TARGET :: dummy(1,1)
    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
    IF (src_size > 0) THEN
      src_p => src_data
    ELSE
      src_p => dummy
      src_size = 1
    END IF
    IF (dst_size > 0) THEN
      dst_p => dst_data
    ELSE
      dst_p => dummy
      dst_size = 1
    END IF
    CALL xt_redist_s_exchange_i8_1d_as(redist, src_size, src_p, dst_size, dst_p)
  END SUBROUTINE xt_redist_s_exchange_i8_2d

  ! see @ref xt_redist_s_exchange
  SUBROUTINE xt_redist_s_exchange_i8_3d(redist, src_data, dst_data)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:,:,:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:,:,:)

    INTEGER(i8), POINTER :: src_p(:,:,:), dst_p(:,:,:)
    INTEGER(i8), TARGET :: dummy(1,1,1)
    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
    IF (src_size > 0) THEN
      src_p => src_data
    ELSE
      src_p => dummy
      src_size = 1
    END IF
    IF (dst_size > 0) THEN
      dst_p => dst_data
    ELSE
      dst_p => dummy
      dst_size = 1
    END IF
    CALL xt_redist_s_exchange_i8_1d_as(redist, src_size, src_p, dst_size, dst_p)
  END SUBROUTINE xt_redist_s_exchange_i8_3d

  ! see @ref xt_redist_s_exchange
  SUBROUTINE xt_redist_s_exchange_i8_4d(redist, src_data, dst_data)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:,:,:,:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:,:,:,:)

    INTEGER(i8), POINTER :: src_p(:,:,:,:), dst_p(:,:,:,:)
    INTEGER(i8), TARGET :: dummy(1,1,1,1)
    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
    IF (src_size > 0) THEN
      src_p => src_data
    ELSE
      src_p => dummy
      src_size = 1
    END IF
    IF (dst_size > 0) THEN
      dst_p => dst_data
    ELSE
      dst_p => dummy
      dst_size = 1
    END IF
    CALL xt_redist_s_exchange_i8_1d_as(redist, src_size, src_p, dst_size, dst_p)
  END SUBROUTINE xt_redist_s_exchange_i8_4d

  ! see @ref xt_redist_s_exchange
  SUBROUTINE xt_redist_s_exchange_i8_5d(redist, src_data, dst_data)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:,:,:,:,:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:,:,:,:,:)

    INTEGER(i8), POINTER :: src_p(:,:,:,:,:), dst_p(:,:,:,:,:)
    INTEGER(i8), TARGET :: dummy(1,1,1,1,1)
    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
    IF (src_size > 0) THEN
      src_p => src_data
    ELSE
      src_p => dummy
      src_size = 1
    END IF
    IF (dst_size > 0) THEN
      dst_p => dst_data
    ELSE
      dst_p => dummy
      dst_size = 1
    END IF
    CALL xt_redist_s_exchange_i8_1d_as(redist, src_size, src_p, dst_size, dst_p)
  END SUBROUTINE xt_redist_s_exchange_i8_5d

  ! see @ref xt_redist_s_exchange
  SUBROUTINE xt_redist_s_exchange_i8_6d(redist, src_data, dst_data)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:,:,:,:,:,:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:,:,:,:,:,:)

    INTEGER(i8), POINTER :: src_p(:,:,:,:,:,:), dst_p(:,:,:,:,:,:)
    INTEGER(i8), TARGET :: dummy(1,1,1,1,1,1)
    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
    IF (src_size > 0) THEN
      src_p => src_data
    ELSE
      src_p => dummy
      src_size = 1
    END IF
    IF (dst_size > 0) THEN
      dst_p => dst_data
    ELSE
      dst_p => dummy
      dst_size = 1
    END IF
    CALL xt_redist_s_exchange_i8_1d_as(redist, src_size, src_p, dst_size, dst_p)
  END SUBROUTINE xt_redist_s_exchange_i8_6d

  ! see @ref xt_redist_s_exchange
  SUBROUTINE xt_redist_s_exchange_i8_7d(redist, src_data, dst_data)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:,:,:,:,:,:,:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:,:,:,:,:,:,:)

    INTEGER(i8), POINTER :: src_p(:,:,:,:,:,:,:), dst_p(:,:,:,:,:,:,:)
    INTEGER(i8), TARGET :: dummy(1,1,1,1,1,1,1)
    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
    IF (src_size > 0) THEN
      src_p => src_data
    ELSE
      src_p => dummy
      src_size = 1
    END IF
    IF (dst_size > 0) THEN
      dst_p => dst_data
    ELSE
      dst_p => dummy
      dst_size = 1
    END IF
    CALL xt_redist_s_exchange_i8_1d_as(redist, src_size, src_p, dst_size, dst_p)
  END SUBROUTINE xt_redist_s_exchange_i8_7d

  ! see @ref xt_redist_a_exchange
  SUBROUTINE xt_redist_a_exchange_i8_1d_as(redist, src_size, src_data, &
       dst_size, dst_data, request)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER, INTENT(in) :: src_size, dst_size
    INTEGER(i8), TARGET, INTENT(in) :: src_data(src_size)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(dst_size)
    TYPE(xt_request), INTENT(out) :: request

    INTEGER(i8), TARGET :: dummy(1)
    TYPE(c_ptr) :: src_data_cptr, dst_data_cptr
    IF (src_size > 0) THEN
      src_data_cptr = C_LOC(src_data)
    ELSE
      src_data_cptr = C_LOC(dummy)
    END IF
    IF (dst_size > 0) THEN
      dst_data_cptr = C_LOC(dst_data)
    ELSE
      dst_data_cptr = C_LOC(dummy)
    END IF
    CALL xt_redist_a_exchange1(redist, src_data_cptr, dst_data_cptr, request)
  END SUBROUTINE xt_redist_a_exchange_i8_1d_as

  ! see @ref xt_redist_a_exchange
  SUBROUTINE xt_redist_a_exchange_i8_1d(redist, src_data, dst_data, &
       request)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:)
    TYPE(xt_request), INTENT(out) :: request

    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
#ifdef HAVE_FC_IS_CONTIGUOUS
    IF (.NOT. (IS_CONTIGUOUS(src_data) .AND. IS_CONTIGUOUS(dst_data))) &
      CALL xt_abort('arguments to xt_redist_a_exchange must be contiguous!',&
      filename, __LINE__)
#endif
    CALL xt_redist_a_exchange_i8_1d_as(redist, src_size, src_data, dst_size, &
         dst_data, request)
  END SUBROUTINE xt_redist_a_exchange_i8_1d

  ! see @ref xt_redist_a_exchange
  SUBROUTINE xt_redist_a_exchange_i8_2d(redist, src_data, dst_data, &
       request)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:,:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:,:)
    TYPE(xt_request), INTENT(out) :: request

    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
#ifdef HAVE_FC_IS_CONTIGUOUS
    IF (.NOT. (IS_CONTIGUOUS(src_data) .AND. IS_CONTIGUOUS(dst_data))) &
      CALL xt_abort('arguments to xt_redist_a_exchange must be contiguous!',&
      filename, __LINE__)
#endif
    CALL xt_redist_a_exchange_i8_1d_as(redist, src_size, src_data, dst_size, &
         dst_data, request)
  END SUBROUTINE xt_redist_a_exchange_i8_2d

  ! see @ref xt_redist_a_exchange
  SUBROUTINE xt_redist_a_exchange_i8_3d(redist, src_data, dst_data, &
       request)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:,:,:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:,:,:)
    TYPE(xt_request), INTENT(out) :: request

    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
#ifdef HAVE_FC_IS_CONTIGUOUS
    IF (.NOT. (IS_CONTIGUOUS(src_data) .AND. IS_CONTIGUOUS(dst_data))) &
      CALL xt_abort('arguments to xt_redist_a_exchange must be contiguous!',&
      filename, __LINE__)
#endif
    CALL xt_redist_a_exchange_i8_1d_as(redist, src_size, src_data, dst_size, &
         dst_data, request)
  END SUBROUTINE xt_redist_a_exchange_i8_3d

  ! see @ref xt_redist_a_exchange
  SUBROUTINE xt_redist_a_exchange_i8_4d(redist, src_data, dst_data, &
       request)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:,:,:,:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:,:,:,:)
    TYPE(xt_request), INTENT(out) :: request

    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
#ifdef HAVE_FC_IS_CONTIGUOUS
    IF (.NOT. (IS_CONTIGUOUS(src_data) .AND. IS_CONTIGUOUS(dst_data))) &
      CALL xt_abort('arguments to xt_redist_a_exchange must be contiguous!',&
      filename, __LINE__)
#endif
    CALL xt_redist_a_exchange_i8_1d_as(redist, src_size, src_data, dst_size, &
         dst_data, request)
  END SUBROUTINE xt_redist_a_exchange_i8_4d

  ! see @ref xt_redist_a_exchange
  SUBROUTINE xt_redist_a_exchange_i8_5d(redist, src_data, dst_data, &
       request)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:,:,:,:,:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:,:,:,:,:)
    TYPE(xt_request), INTENT(out) :: request

    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
#ifdef HAVE_FC_IS_CONTIGUOUS
    IF (.NOT. (IS_CONTIGUOUS(src_data) .AND. IS_CONTIGUOUS(dst_data))) &
      CALL xt_abort('arguments to xt_redist_a_exchange must be contiguous!',&
      filename, __LINE__)
#endif
    CALL xt_redist_a_exchange_i8_1d_as(redist, src_size, src_data, dst_size, &
         dst_data, request)
  END SUBROUTINE xt_redist_a_exchange_i8_5d

  ! see @ref xt_redist_a_exchange
  SUBROUTINE xt_redist_a_exchange_i8_6d(redist, src_data, dst_data, &
       request)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:,:,:,:,:,:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:,:,:,:,:,:)
    TYPE(xt_request), INTENT(out) :: request

    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
#ifdef HAVE_FC_IS_CONTIGUOUS
    IF (.NOT. (IS_CONTIGUOUS(src_data) .AND. IS_CONTIGUOUS(dst_data))) &
      CALL xt_abort('arguments to xt_redist_a_exchange must be contiguous!',&
      filename, __LINE__)
#endif
    CALL xt_redist_a_exchange_i8_1d_as(redist, src_size, src_data, dst_size, &
         dst_data, request)
  END SUBROUTINE xt_redist_a_exchange_i8_6d

  ! see @ref xt_redist_a_exchange
  SUBROUTINE xt_redist_a_exchange_i8_7d(redist, src_data, dst_data, &
       request)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), TARGET, INTENT(in) :: src_data(:,:,:,:,:,:,:)
    INTEGER(i8), TARGET, INTENT(inout) :: dst_data(:,:,:,:,:,:,:)
    TYPE(xt_request), INTENT(out) :: request

    INTEGER :: src_size, dst_size
    src_size = SIZE(src_data)
    dst_size = SIZE(dst_data)
#ifdef HAVE_FC_IS_CONTIGUOUS
    IF (.NOT. (IS_CONTIGUOUS(src_data) .AND. IS_CONTIGUOUS(dst_data))) &
      CALL xt_abort('arguments to xt_redist_a_exchange must be contiguous!',&
      filename, __LINE__)
#endif
    CALL xt_redist_a_exchange_i8_1d_as(redist, src_size, src_data, dst_size, &
         dst_data, request)
  END SUBROUTINE xt_redist_a_exchange_i8_7d
END MODULE xt_redist_int_i8
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! mode: f90
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_idxempty_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_idxempty
  USE mpi
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_idxlist, xt_idxempty_new, &
       xt_int_kind, xt_stripe, xt_idxlist_get_intersection, &
       xt_idxlist_get_index_stripes, xt_idxlist_delete, &
       xt_bounds, xt_idxlist_get_bounding_box
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_idxlist_utils, ONLY: check_idxlist, test_err_count, &
       idxlist_pack_unpack_copy
  IMPLICIT NONE

  TYPE(xt_idxlist) :: idxempty, idxempty_copy
  INTEGER(xt_int_kind) :: no_idx(1)
  TYPE(xt_stripe), ALLOCATABLE :: stripes(:)
  CHARACTER(len=*), PARAMETER :: filename = 'test_idxempty_f.f90'


  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)

  idxempty = xt_idxempty_new()

  CALL check_idxlist(idxempty, no_idx(1:0))

  idxempty_copy = idxlist_pack_unpack_copy(idxempty)

  ! check the computed intersection, must be identical to original list
  CALL check_idxlist(idxempty_copy, no_idx(1:0))

  CALL check_intersection

  CALL xt_idxlist_get_index_stripes(idxempty, stripes)

  IF (ALLOCATED(stripes)) &
       CALL test_abort("unexpected non-zero amount of stripes for &
       &empty index set", &
       filename, __LINE__)

  CALL check_bounding_box

  CALL xt_idxlist_delete(idxempty)
  CALL xt_idxlist_delete(idxempty_copy)

  CALL xt_finalize
  CALL finish_mpi

  IF (test_err_count() /= 0) CALL test_abort("non-zero error count", &
       filename, __LINE__)

CONTAINS

  SUBROUTINE check_intersection
    TYPE(xt_idxlist) :: intersection

    intersection = xt_idxlist_get_intersection(idxempty, idxempty_copy)
    CALL check_idxlist(intersection, no_idx(1:0))
    CALL xt_idxlist_delete(intersection)

  END SUBROUTINE check_intersection

  SUBROUTINE check_bounding_box
    INTEGER, PARAMETER :: ndims = 3
    INTEGER(xt_int_kind), PARAMETER :: global_start_index = 0
    INTEGER(xt_int_kind) :: global_size(ndims)
    TYPE(xt_bounds) :: bounds(ndims)

    global_size = 10
    bounds = xt_idxlist_get_bounding_box(idxempty, global_size, &
         global_start_index)
    IF (ANY(bounds%size /= 0)) &
         CALL test_abort("ERROR: non-zero boundings box for xt_idxempty in &
         &xt_idxlist_get_bounding_box", &
         filename, __LINE__)
  END SUBROUTINE check_bounding_box

END PROGRAM test_idxempty
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file perf_sparse_array_gather.f90
!! @brief recreates whole array from variously displaced chunks
!!
!! @copyright Copyright  (C)  2021 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM perf_sparse_array_gather
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_abort, &
       xt_int_kind, xt_stripe, xt_idxlist_collection_new, &
       xt_idxlist, xt_idxfsection_new, xt_idxstripes_new, xt_idxlist_delete, &
       xt_redist, xt_redist_p2p_ext_new, xt_offset_ext, &
       xt_xmap, xt_xmap_all2all_new, xt_xmap_delete, &
       xt_redist_delete, xt_redist_s_exchange, &
       xt_idxstripes_from_idxlist_new
  USE iso_c_binding, ONLY: c_int
  USE mpi
  ! older PGI compilers do not handle generic interface correctly
#if defined __PGI && ( __PGIC__ == 15 || __PGIC__ == 14 )
  USE xt_redist_real_sp, ONLY: xt_redist_s_exchange
  USE xt_redist_real_dp, ONLY: xt_redist_s_exchange
#endif
  IMPLICIT NONE

  INTEGER :: gshape(3), nparts(2), num_parts, sshape(3), gsize, &
       section_shape(3), section_start(3), section_size, ofs, ierror
  DOUBLE PRECISION, ALLOCATABLE :: gathered_data(:, :, :), &
       scattered_data(:, :, :)
  TYPE(xt_offset_ext) :: gather_ext(1)
  TYPE(xt_offset_ext), ALLOCATABLE :: scatter_exts(:,:)
  TYPE(xt_idxlist) :: gather_list
  TYPE(xt_idxlist), ALLOCATABLE :: scatter_lists(:,:)
  TYPE(xt_idxlist) :: scatter_list, scatter_list_stripes
  TYPE(xt_xmap) :: gather_xmap
  TYPE(xt_redist) :: gather_redist
  REAL :: r
  INTEGER :: i, j, k, t
  CHARACTER(len=132) :: msg
  CHARACTER(len=*), PARAMETER :: filename = 'perf_sparse_array_gather.f90'
  LOGICAL :: check_correctness_of_exchange
  INTERFACE
    SUBROUTINE posix_exit(code) BIND(c, name="exit")
      IMPORT :: c_int
      INTEGER(c_int), VALUE, INTENT(in) :: code
    END SUBROUTINE posix_exit
  END INTERFACE

  CALL mpi_init(ierror)
  IF (ierror /= mpi_success) THEN
    WRITE (0, *) "MPI initialization failed"
    CALL POSIX_EXIT(1_c_int)
  END IF
  CALL xt_initialize(mpi_comm_world)

  check_correctness_of_exchange = .FALSE.
  CALL parse_options

  gshape(1) = 192
  gshape(2) = 96
  gshape(3) = 49
  gsize = PRODUCT(gshape)

  nparts(1) = 8
  nparts(2) = 8
  num_parts = PRODUCT(nparts)
  sshape(1) = (gsize + num_parts - 1) / num_parts * 20
  sshape(2) = nparts(1)
  sshape(3) = nparts(2)

  ALLOCATE(gathered_data(gshape(1), gshape(2), gshape(3)), &
       scattered_data(sshape(1), sshape(2), sshape(3)), &
       scatter_exts(nparts(1), nparts(2)), scatter_lists(nparts(1), nparts(2)))

  gather_ext(1) = xt_offset_ext(0, gsize, 1)

  gathered_data = -HUGE(1.0d0)

  ! perform 2d deco of cube
  ! divide gshape(1:2) by nparts(1:2)
  section_start(3) = 1
  section_shape(3) = gshape(3)
  DO t = 1, 100
    gather_list = xt_idxstripes_new(xt_stripe(0, 1, gsize))
    CALL RANDOM_NUMBER(r)
    DO j = 1, nparts(2)
      section_start(2) = (gshape(2) * (j - 1))/nparts(2) + 1
      section_shape(2) = (gshape(2) * j)/nparts(2) - section_start(2) + 1
      DO i = 1, nparts(1)
        section_start(1) = (gshape(1) * (i - 1))/nparts(1) + 1
        section_shape(1) = (gshape(1) * i)/nparts(1) - section_start(1) + 1
        section_size = PRODUCT(section_shape(:))
        ofs = INT(r * REAL(sshape(1) - 1 - section_size))
        scatter_exts(i, j) &
             = xt_offset_ext(ofs + ((i-1) + (j-1) * sshape(2)) * sshape(1), &
             section_size, 1)
        scatter_lists(i, j) = xt_idxfsection_new(0_xt_int_kind, &
             INT(gshape, xt_int_kind), &
             section_shape, INT(section_start, xt_int_kind))
        scattered_data(1:ofs, i, j) = -9.0d99
        scattered_data(ofs+1:ofs + section_size, i, j) &
             = DBLE(i + (j - 1) * nparts(1))
        scattered_data(ofs + section_size + 1:, i, j) = -9.0d99
      END DO
    END DO
    scatter_list = xt_idxlist_collection_new(scatter_lists)
    CALL xt_idxlist_delete(scatter_lists)
    scatter_list_stripes = xt_idxstripes_from_idxlist_new(scatter_list)
    CALL xt_idxlist_delete(scatter_list)
    gather_xmap = xt_xmap_all2all_new(scatter_list_stripes, gather_list, &
         mpi_comm_self)
    CALL xt_idxlist_delete(gather_list)
    gather_redist = xt_redist_p2p_ext_new(gather_xmap, &
         RESHAPE(scatter_exts, (/ num_parts /)), gather_ext, &
         mpi_double_precision)
    CALL xt_xmap_delete(gather_xmap)
    CALL xt_redist_s_exchange(gather_redist, scattered_data, gathered_data)
    IF (check_correctness_of_exchange) THEN
      DO k = 1, gshape(3)
        DO j = 1, gshape(2)
          DO i = 1, gshape(1)
            IF (gathered_data(i, j, k) < 1.0d0 &
                 .OR. gathered_data(i, j, k) > DBLE(num_parts)) THEN
              WRITE (0, "(a,3(i0,a),g28.16)") "gathered_data(", &
                   i, ", ", j, ", ", k, ") = ", gathered_data(i, j, k)
              WRITE (msg, "(a,3(', ',i0))") "error in data", i, j, k
              CALL xt_abort(msg, filename, __LINE__)
            END IF
          END DO
        END DO
      END DO
    END IF
    CALL xt_redist_delete(gather_redist)
  END DO
  CALL xt_finalize
  CALL mpi_finalize(ierror)
  IF (ierror /= mpi_success) THEN
    WRITE (0, *) "MPI finalization failed"
    CALL posix_exit(1)
  END IF

CONTAINS
  SUBROUTINE parse_options
    INTEGER :: i, num_cmd_args, arg_len
    INTEGER, PARAMETER :: max_opt_arg_len = 80
    CHARACTER(max_opt_arg_len) :: optarg
    CHARACTER(len=18), PARAMETER :: &
         check_correctness_argstr = '-check-correctness'
    num_cmd_args = COMMAND_ARGUMENT_COUNT()
    i = 1
    DO WHILE (i < num_cmd_args)
      CALL GET_COMMAND_ARGUMENT(i, optarg, arg_len)
      IF (optarg(1:arg_len) == check_correctness_argstr &
           .AND. arg_len == LEN(check_correctness_argstr)) THEN
        check_correctness_of_exchange = .TRUE.
      ELSE
        WRITE (0, *) 'unexpected command-line argument parsing error: ', &
             optarg(1:arg_len)
        FLUSH(0)
        CALL xt_abort('unexpected command-line argument "' &
             // optarg(1:arg_len) // '"', filename, __LINE__)
      END IF
      i = i + 1
    END DO

  END SUBROUTINE parse_options

END PROGRAM perf_sparse_array_gather
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! license-project-url: "https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/"
! license-default: "bsd"
! End:
!

!>
!! @file xt_sort_f.f90
!! @brief Fortran interface to yaxt sort declarations
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE xt_sort
  USE, INTRINSIC :: ISO_C_BINDING, ONLY: c_int, c_size_t
  USE xt_core, ONLY: xt_abort, xt_int_kind
  IMPLICIT NONE
  PRIVATE

  INTERFACE xt_sort_int
    SUBROUTINE xt_sort_int_f2c(a, n) BIND(c, name='xt_sort_int_f2c')
      IMPORT :: c_int, c_size_t
      INTEGER(c_size_t), VALUE, INTENT(in) :: n
      INTEGER(c_int), INTENT(inout) :: a(n)
    END SUBROUTINE xt_sort_int_f2c
    MODULE PROCEDURE xt_sort_int_a
  END INTERFACE xt_sort_int
  PUBLIC :: xt_sort_int

  INTERFACE xt_sort_xt_int
    SUBROUTINE xt_sort_xt_int_f2c(a, n) BIND(c, name='xt_sort_xt_int_f2c')
      IMPORT :: xt_int_kind, c_size_t
      INTEGER(c_size_t), VALUE, INTENT(in) :: n
      INTEGER(xt_int_kind), INTENT(inout) :: a(n)
    END SUBROUTINE xt_sort_xt_int_f2c
    MODULE PROCEDURE xt_sort_xt_int_a
  END INTERFACE xt_sort_xt_int
  PUBLIC :: xt_sort_xt_int

  INTERFACE xt_sort_index
    SUBROUTINE xt_sort_index_f2c(a, n, positions, reset_positions) &
          BIND(c, name='xt_sort_index_f2c')
      IMPORT :: c_int, xt_int_kind
      INTEGER(c_int), VALUE, INTENT(in) :: n, reset_positions
      INTEGER(xt_int_kind), INTENT(inout) :: a(n)
      INTEGER(c_int), INTENT(inout) :: positions(n)
    END SUBROUTINE xt_sort_index_f2c
    MODULE PROCEDURE xt_sort_index_a_a_l
  END INTERFACE xt_sort_index
  PUBLIC :: xt_sort_index

  INTERFACE xt_sort_permutation
#if XT_FC_XT_INT_FC_NUMERIC_KIND != XT_FC_C_INT_FC_NUMERIC_KIND
    SUBROUTINE xt_sort_xt_int_permutation_f2c(a, n, permutation) &
          BIND(c, name='xt_sort_xt_int_permutation_f2c')
      IMPORT :: c_int, c_size_t, xt_int_kind
      INTEGER(c_size_t), VALUE, INTENT(in) :: n
      INTEGER(xt_int_kind), INTENT(inout) :: a(n)
      INTEGER(c_int), INTENT(inout) :: permutation(n)
    END SUBROUTINE xt_sort_xt_int_permutation_f2c
    MODULE PROCEDURE xt_sort_xt_int_permutation
#endif
    SUBROUTINE xt_sort_int_permutation_f2c(a, n, permutation) &
          BIND(c, name='xt_sort_int_permutation_f2c')
      IMPORT :: c_int, c_size_t
      INTEGER(c_size_t), VALUE, INTENT(in) :: n
      INTEGER(c_int), INTENT(inout) :: a(n), permutation(n)
    END SUBROUTINE xt_sort_int_permutation_f2c
    MODULE PROCEDURE xt_sort_int_permutation
  END INTERFACE xt_sort_permutation
  PUBLIC :: xt_sort_permutation

  INTERFACE xt_sort_xt_int_permutation
    SUBROUTINE xt_sort_xt_int_permutation_f2c(a, n, permutation) &
          BIND(c, name='xt_sort_xt_int_permutation_f2c')
      IMPORT :: c_int, c_size_t, xt_int_kind
      INTEGER(c_size_t), VALUE, INTENT(in) :: n
      INTEGER(xt_int_kind), INTENT(inout) :: a(n)
      INTEGER(c_int), INTENT(inout) :: permutation(n)
    END SUBROUTINE xt_sort_xt_int_permutation_f2c
    MODULE PROCEDURE xt_sort_xt_int_permutation
  END INTERFACE xt_sort_xt_int_permutation
  PUBLIC :: xt_sort_xt_int_permutation

  TYPE, BIND(c), PUBLIC :: xt_idxpos
    INTEGER(xt_int_kind) :: idx
    INTEGER(c_int) :: pos
  END TYPE xt_idxpos

  INTERFACE xt_sort_idxpos
    SUBROUTINE xt_sort_idxpos_f2c(a, n) BIND(c, name='xt_sort_idxpos_f2c')
      IMPORT :: c_size_t, xt_idxpos
      INTEGER(c_size_t), VALUE, INTENT(in) :: n
      TYPE(xt_idxpos), INTENT(inout) :: a(n)
    END SUBROUTINE xt_sort_idxpos_f2c
    MODULE PROCEDURE xt_sort_idxpos_a
  END INTERFACE xt_sort_idxpos
  PUBLIC :: xt_sort_idxpos

  INTERFACE xt_assign_id_map
    SUBROUTINE xt_assign_id_map_int(n, a, ofs) &
         BIND(c, name='xt_assign_id_map_int')
      IMPORT :: c_int, c_size_t
      INTEGER(c_size_t), VALUE, INTENT(in) :: n
      INTEGER(c_int), INTENT(out) :: a(n)
      INTEGER(c_int), VALUE, INTENT(in) :: ofs
    END SUBROUTINE xt_assign_id_map_int
    MODULE PROCEDURE xt_assign_id_map_a
    MODULE PROCEDURE xt_assign_id_map_ai
  END INTERFACE xt_assign_id_map
  PUBLIC :: xt_assign_id_map

  CHARACTER(len=*), PARAMETER :: filename = 'xt_sort_f.f90'
CONTAINS
  SUBROUTINE xt_sort_int_a(a)
    INTEGER(c_int), INTENT(inout) :: a(:)
    INTEGER :: a_size
    a_size = SIZE(a)
    IF (a_size > 1) CALL xt_sort_int_f2c(a, INT(a_size, c_size_t))
  END SUBROUTINE xt_sort_int_a

  SUBROUTINE xt_sort_xt_int_a(a)
    INTEGER(xt_int_kind), INTENT(inout) :: a(:)
    INTEGER :: a_size
    a_size = SIZE(a)
    IF (a_size > 1) CALL xt_sort_xt_int_f2c(a, INT(a_size, c_size_t))
  END SUBROUTINE xt_sort_xt_int_a

  SUBROUTINE xt_sort_index_a_a_l(a, positions, reset_positions)
    INTEGER(xt_int_kind), INTENT(inout) :: a(:)
    INTEGER(c_int), INTENT(inout) :: positions(:)
    LOGICAL, INTENT(in) :: reset_positions
    INTEGER(c_int) :: a_size, reset_positions_c
    a_size = INT(SIZE(a), c_int)
    reset_positions_c = MERGE(1_c_int, 0_c_int, reset_positions)
    IF (a_size > SIZE(positions)) &
         CALL xt_abort("positions array too small", filename, __LINE__)
    IF (a_size > 1) CALL xt_sort_index_f2c(a, a_size, positions, &
         reset_positions_c)
  END SUBROUTINE xt_sort_index_a_a_l

  SUBROUTINE xt_sort_idxpos_a(a)
    TYPE(xt_idxpos), INTENT(inout) :: a(:)
    INTEGER :: a_size
    a_size = SIZE(a)
    IF (a_size > 1) CALL xt_sort_idxpos_f2c(a, INT(a_size, c_size_t))
  END SUBROUTINE xt_sort_idxpos_a

  SUBROUTINE xt_sort_xt_int_permutation(a, permutation)
    INTEGER(c_int), INTENT(inout) :: a(:), permutation(:)
    INTEGER(c_size_t) :: a_size
#ifdef HAVE_SIZE_KIND_ARGUMENT
    a_size = SIZE(a, kind=c_size_t)
#else
    a_size = INT(SIZE(a), kind=c_size_t)
#endif
    IF (a_size > 1) CALL xt_sort_int_permutation_f2c(a, a_size, permutation)
  END SUBROUTINE xt_sort_xt_int_permutation

  SUBROUTINE xt_sort_int_permutation(a, permutation)
    INTEGER(c_int), INTENT(inout) :: a(:), permutation(:)
    INTEGER(c_size_t) :: a_size
#ifdef HAVE_SIZE_KIND_ARGUMENT
    a_size = SIZE(a, kind=c_size_t)
#else
    a_size = INT(SIZE(a), kind=c_size_t)
#endif
    IF (a_size > 1) CALL xt_sort_int_permutation_f2c(a, a_size, permutation)
  END SUBROUTINE xt_sort_int_permutation

  SUBROUTINE xt_assign_id_map_a(a)
    INTEGER(c_int), INTENT(out) :: a(:)
    INTEGER(c_size_t) :: n
    INTEGER(c_int) :: ofs
#ifdef HAVE_SIZE_KIND_ARGUMENT
    n = SIZE(a, kind=c_size_t)
#else
    n = INT(SIZE(a), kind=c_size_t)
#endif
    IF (n >= 1) THEN
      ofs = 0_c_int
      CALL xt_assign_id_map_int(n, a, ofs)
    END IF
  END SUBROUTINE xt_assign_id_map_a

  SUBROUTINE xt_assign_id_map_ai(a, ofs)
    INTEGER(c_int), INTENT(out) :: a(:)
    INTEGER(c_int), INTENT(in) :: ofs
    INTEGER(c_size_t) :: n
#ifdef HAVE_SIZE_KIND_ARGUMENT
    n = SIZE(a, kind=c_size_t)
#else
    n = INT(SIZE(a), kind=c_size_t)
#endif
    IF (n >= 1) THEN
      CALL xt_assign_id_map_int(n, a, ofs)
    END IF
  END SUBROUTINE xt_assign_id_map_ai

END MODULE xt_sort
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_yaxt.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_yaxt
  USE iso_c_binding, ONLY: c_int
  USE mpi
  USE yaxt, ONLY: xt_idxlist, xt_idxlist_delete, xt_idxvec_new, &
       &          xt_xmap, xt_xmap_all2all_new, xt_xmap_delete, &
       &          xt_redist, xt_redist_p2p_new, xt_redist_delete, &
       &          xt_initialize, xt_finalize, xt_idxlist_get_num_indices, &
       &          xt_idxlist_get_indices, xt_modifier, xt_idxmod_new, &
       xt_redist_p2p_off_new, xt_redist_s_exchange, xt_int_kind, &
       xt_idxfsection_new, xt_redist_collection_static_new
  USE ftest_common, ONLY: test_abort, id_map, factorize, regular_deco, &
       init_mpi, finish_mpi, cmp_arrays

  ! PGI compilers up to at least version 15 do not handle generic
  ! interfaces correctly
#if defined __PGI
  USE xt_redist_int_i2, ONLY: xt_redist_s_exchange
  USE xt_redist_int_i4, ONLY: xt_redist_s_exchange
  USE xt_redist_int_i8, ONLY: xt_redist_s_exchange
#endif
  IMPLICIT NONE

  INTEGER, PARAMETER :: g_ie = 8, g_je = 4! global extents including halos
  LOGICAL, PARAMETER :: verbose = .FALSE.
  INTEGER, PARAMETER :: nlev = 3
  INTEGER, PARAMETER :: undef_int = -1
  INTEGER(xt_int_kind), PARAMETER :: undef_index = -1
  INTEGER, PARAMETER :: nhalo = 1 ! 1dim. halo border size
  LOGICAL, PARAMETER :: increased_north_halo = .FALSE.
  LOGICAL, PARAMETER :: with_north_halo = .TRUE.

  INTEGER :: ie, je ! local extents, including halos
  INTEGER :: p_ioff, p_joff ! offsets within global domain
  INTEGER :: nprocx, nprocy ! process space extents
  INTEGER :: nprocs ! == nprocx*nprocy
  INTEGER :: mype, mypx, mypy ! process rank, process coords within (0:, 0:) process space
  LOGICAL :: lroot ! true only for proc 0

  INTEGER(xt_int_kind) :: g_id(g_ie, g_je) ! global id
  CHARACTER(len=*), PARAMETER :: filename = 'test_yaxt.f90'
  ! global "tripolar-like" toy bounds exchange
  INTEGER(xt_int_kind) :: g_tpex(g_ie, g_je)
  TYPE(xt_xmap) :: xmap_tpex
  TYPE(xt_redist) :: redist_tpex
  TYPE(xt_redist) :: redist_surf_tpex

  INTEGER(xt_int_kind), ALLOCATABLE :: loc_id(:,:), loc_tpex(:,:)
  INTEGER, ALLOCATABLE :: fval(:,:), gval(:,:)
  INTEGER, ALLOCATABLE :: gval3d(:,:,:)
  INTEGER, ALLOCATABLE :: id_pos(:,:), pos3d_surf(:,:)

  ! mpi & decomposition & allocate mem:
  CALL init_all

  ! full global index space:
  CALL id_map(g_id)

  ! local window of global index space:
  CALL get_window(g_id, loc_id)

  ! define bounds exchange for full global index space
  CALL def_exchange(g_id, g_tpex)

  ! local window of global bounds exchange:
  CALL get_window(g_tpex, loc_tpex)

  ! check interface to idxsection:
  CALL general_fsection_test

  ! compare current index construction with modifier results
  CALL check_modifiers

  ! template: loc_id -> loc_tpex
  CALL gen_template(loc_id, loc_tpex, xmap_tpex) ! todo rename template to xmap

  ! transposition: loc_id:data -> loc_tpex:data
  CALL gen_trans(xmap_tpex, MPI_INTEGER, MPI_INTEGER, redist_tpex)

  ! test 2d-to-2d transposition:
  fval = INT(loc_id)
  CALL xt_redist_s_exchange(redist_tpex, fval, gval)

  IF (cmp_arrays(gval, loc_tpex)) &
       CALL test_abort('array eqivalence test failed', filename, __LINE__)
  DEALLOCATE(gval)
  CALL check_redist_collection_static
  DEALLOCATE(loc_id)

  ! define positions of surface elements within (i,k,j) array
  CALL gen_id_pos(id_pos)
  CALL gen_id_pos(pos3d_surf)
  CALL gen_pos3d_surf(pos3d_surf)

  ! generate surface transposition:
  CALL gen_off_trans(xmap_tpex, MPI_INTEGER, id_pos(:,:) - 1, &
       MPI_INTEGER, pos3d_surf, redist_surf_tpex)
  DEALLOCATE(pos3d_surf, id_pos)

  ! 2d to surface boundsexchange:
  gval3d = -1
  CALL xt_redist_s_exchange(redist_surf_tpex, &
       RESHAPE(fval, (/ ie, 1, je /)), gval3d)
  DEALLOCATE(fval)

  IF (cmp_arrays(gval3d(:, 1, :), loc_tpex)) &
       CALL test_abort('surface check failed', filename, __LINE__)
  ! check sub surface:
  IF (ANY(gval3d(:, 2, :) /= -1)) &
       CALL test_abort('surface check failed', filename, __LINE__)

  ! cleanup:
  DEALLOCATE(loc_tpex, gval3d)
  CALL xt_xmap_delete(xmap_tpex)

  CALL xt_redist_delete(redist_tpex)

  CALL xt_redist_delete(redist_surf_tpex)

  CALL xt_finalize()
  CALL finish_mpi

CONTAINS

#define abort(msg, line) test_abort(msg, filename, line)

  SUBROUTINE check_redist_collection_static
    INTEGER, PARAMETER :: nr = 2
    TYPE(xt_redist) :: rvec(nr), rcol
    INTEGER :: f(ie,je,nr), g(ie,je,nr), ref_g(ie,je,nr)
    INTEGER(mpi_address_kind) :: f_addr(nr), g_addr(nr)
    INTEGER(mpi_address_kind) :: f_disp(nr), g_disp(nr)

    INTEGER :: ir, ierror
    rvec(:) = redist_tpex
    DO ir = 1, nr
      CALL MPI_GET_ADDRESS(f(1,1,ir), f_addr(ir), ierror)
      IF (ierror /= MPI_SUCCESS) &
           CALL abort('MPI_GET_ADDRESS failed', __LINE__)
      CALL MPI_GET_ADDRESS(g(1,1,ir), g_addr(ir), ierror)
      IF (ierror /= MPI_SUCCESS) &
           CALL abort('MPI_GET_ADDRESS failed', __LINE__)
      f_disp(ir) = f_addr(ir) - f_addr(1)
      g_disp(ir) = g_addr(ir) - g_addr(1)
    ENDDO

    rcol = xt_redist_collection_static_new(rvec, nr, f_disp, g_disp, MPI_COMM_WORLD)
    DO ir = 1, nr
      f(:,:,ir) = INT(loc_id) + (ir-1) * ie*je
    ENDDO

    ref_g = 0
    DO ir = 1, nr
      CALL xt_redist_s_exchange(rvec(ir), f(:,:,ir), ref_g(:,:,ir))
    ENDDO

    g = 0
    CALL xt_redist_s_exchange(rcol, f, g)
    IF (ANY(g /= ref_g)) CALL abort('(g /= ref_g)', __LINE__)
    CALL xt_redist_delete(rcol)

  END SUBROUTINE check_redist_collection_static

  SUBROUTINE check_modifiers()
    TYPE(xt_modifier) :: m_tpex(5)
    INTEGER :: m_tpex_num
    TYPE(xt_idxlist) :: loc_id_idxlist
    INTEGER(xt_int_kind) :: loc_tpex2(ie,je)
    TYPE(xt_idxlist) :: loc_tpex2_idxlist
    INTEGER(c_int), ALLOCATABLE :: mstate(:,:)

    loc_id_idxlist = xt_idxvec_new(loc_id, SIZE(loc_id))
    ALLOCATE(mstate(ie,je))

    ! use one simple modifier to define index transfer:
    CALL def_tpex_mod_via_idxvec(m_tpex, m_tpex_num)

    loc_tpex2_idxlist = xt_idxmod_new(loc_id_idxlist, m_tpex, m_tpex_num, mstate)
    loc_tpex2 = -1
    CALL xt_idxlist_get_indices(loc_tpex2_idxlist, loc_tpex2)
    IF (ANY(loc_tpex2 /= loc_tpex)) &
         CALL abort('idx copy does not match', __LINE__)
    CALL xt_idxlist_delete(loc_tpex2_idxlist)

    ! test call without mstate
    loc_tpex2_idxlist = xt_idxmod_new(loc_id_idxlist, m_tpex, m_tpex_num)
    loc_tpex2 = -1
    CALL xt_idxlist_get_indices(loc_tpex2_idxlist, loc_tpex2)
    IF (ANY(loc_tpex2 /= loc_tpex)) &
         CALL abort('idx copy does not match', __LINE__)
    CALL xt_idxlist_delete(loc_tpex2_idxlist)
    CALL delete_modifiers(m_tpex(1:m_tpex_num))

    ! use compact modifiers to define index transfer:
    CALL def_tpex_mod_via_sections(m_tpex, m_tpex_num)
    loc_tpex2_idxlist = xt_idxmod_new(loc_id_idxlist, m_tpex, m_tpex_num, mstate)
    loc_tpex2 = -1
    CALL xt_idxlist_get_indices(loc_tpex2_idxlist, loc_tpex2)

    IF (ANY(loc_tpex2 /= loc_tpex)) &
         CALL abort('idx copy does not match', __LINE__)
    CALL xt_idxlist_delete(loc_tpex2_idxlist)
    CALL delete_modifiers(m_tpex(1:m_tpex_num))

    ! cleanup:
    CALL xt_idxlist_delete(loc_id_idxlist)
  END SUBROUTINE check_modifiers

  SUBROUTINE delete_modifiers(m)
    TYPE(xt_modifier), INTENT(inout) :: m(:)

    INTEGER :: i

    DO i = 1, SIZE(m)
      CALL xt_idxlist_delete(m(i)%extract)
      CALL xt_idxlist_delete(m(i)%subst)
    ENDDO

  END SUBROUTINE delete_modifiers

  SUBROUTINE general_fsection_test
    INTEGER(xt_int_kind), PARAMETER :: gdx = 10_xt_int_kind, gdy=5_xt_int_kind
    INTEGER, PARAMETER :: ldx = 4,  ldy=2
    INTEGER(xt_int_kind), PARAMETER :: gstart = 1
    INTEGER(xt_int_kind), PARAMETER :: gsize(2) = (/ gdx, gdy /)
    TYPE(xt_idxlist) :: global_section, local_section
    INTEGER(xt_int_kind) :: indices(gdx*gdy), lstart(2)
    INTEGER :: egis(gdx, gdy)
    INTEGER :: i, j, idx, p

    ! prepare explicit global index space
    idx = gstart - 1
    DO j = 1, gdy
      DO i = 1, gdx
        idx = idx + 1
        egis(i,j) = idx
      ENDDO
    ENDDO

    lstart = (/ 1_xt_int_kind, 1_xt_int_kind /)

    ! check case: local section == global section
    global_section = xt_idxfsection_new(gstart, gsize, INT(gsize), lstart)
    indices = -1
    CALL xt_idxlist_get_indices(global_section, indices)
    p = 0
    DO j = 1, gdy
      DO i = 1, gdx
        p = p + 1
        IF (egis(i,j) /= indices(p)) CALL abort('(1) bad indices', __LINE__)
      ENDDO
    ENDDO
    CALL xt_idxlist_delete(global_section)

    ! check case: simple subsection
    local_section = xt_idxfsection_new(gstart, gsize, (/ ldx, ldy /), lstart)
    indices = -1
    CALL xt_idxlist_get_indices(local_section, indices)
    p = 0
    DO j = 1, ldy
      DO i = 1, ldx
        p = p + 1
        IF (egis(i,j) /= indices(p)) CALL abort('(2) bad indices', __LINE__)
      ENDDO
    ENDDO
    CALL xt_idxlist_delete(local_section)

    ! check case: i-reverse subsection
    local_section = xt_idxfsection_new(gstart, gsize, &
         (/ -ldx, ldy /), lstart)
    indices = -1
    CALL xt_idxlist_get_indices(local_section, indices)
    p = 0
    DO j = 1, ldy
      DO i = ldx, 1, -1
        p = p + 1
        IF (egis(i,j) /= indices(p)) CALL abort('(3) bad indices', __LINE__)
      ENDDO
    ENDDO
    CALL xt_idxlist_delete(local_section)

    ! check case: j-reverse subsection
    local_section = xt_idxfsection_new(gstart, gsize, (/ ldx, -ldy /), lstart)
    indices = -1
    CALL xt_idxlist_get_indices(local_section, indices)
    p = 0
    DO j = ldy, 1, -1
      DO i = 1, ldx
        p = p + 1
        IF (egis(i,j) /= indices(p)) CALL abort('(4) bad indices', __LINE__)
      ENDDO
    ENDDO
    CALL xt_idxlist_delete(local_section)

    ! check case: ij-reverse subsection
    local_section = xt_idxfsection_new(gstart, gsize, &
         (/ -ldx, -ldy /), lstart)
    indices = -1
    CALL xt_idxlist_get_indices(local_section, indices)
    p = 0
    DO j = ldy, 1, -1
      DO i = ldx, 1, -1
        p = p + 1
        IF (egis(i,j) /= indices(p)) CALL abort('(5) bad indices', __LINE__)
      ENDDO
    ENDDO
    CALL xt_idxlist_delete(local_section)
  END SUBROUTINE general_fsection_test

  SUBROUTINE gen_pos3d_surf(pos)
    INTEGER, INTENT(inout) :: pos(:,:)
    ! positions for zero based arrays (ECHAM grid point dim order)
    ! old pos = i + j*ie
    ! new pos = i + k*ie + j*ie*nlev
    INTEGER :: ii,jj, i,j,k, p

    k = 0 ! surface
    DO jj=1,je
      DO ii=1,ie
        p = pos(ii,jj) - 1 ! shift to 0-based index
        j = p/ie
        i = MOD(p,ie)
        pos(ii,jj) = i + k*ie + j*ie*nlev
      ENDDO
    ENDDO

  END SUBROUTINE gen_pos3d_surf

  SUBROUTINE init_all
    CHARACTER(len=*), PARAMETER :: context = 'init_all: '
    INTEGER :: ierror

    CALL init_mpi

    CALL xt_initialize(MPI_COMM_WORLD)

    CALL MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierror)
    IF (ierror /= MPI_SUCCESS) &
         CALL abort(context//'MPI_COMM_SIZE failed', __LINE__)

    CALL MPI_COMM_RANK(MPI_COMM_WORLD, mype, ierror)
    IF (ierror /= MPI_SUCCESS) &
         CALL abort(context//'MPI_COMM_RANK failed', __LINE__)
    IF (mype==0) THEN
      lroot = .true.
    ELSE
      lroot = .FALSE.
    ENDIF

    CALL factorize(nprocs, nprocx, nprocy)
    IF (verbose .AND. lroot) WRITE(0,*) 'nprocx, nprocy=',nprocx, nprocy
    mypy = mype / nprocx
    mypx = MOD(mype, nprocx)

    CALL deco

    ALLOCATE(fval(ie,je), gval(ie,je))
    ALLOCATE(loc_id(ie,je), loc_tpex(ie,je))
    ALLOCATE(id_pos(ie,je), gval3d(ie,nlev,je), pos3d_surf(ie,je))

    fval = undef_int
    gval = undef_int
    loc_id = INT(undef_int, xt_int_kind)
    loc_tpex = INT(undef_int, xt_int_kind)
    id_pos = undef_int
    gval3d = undef_int
    pos3d_surf = undef_int

  END SUBROUTINE init_all

  SUBROUTINE gen_id_pos(pos)
    INTEGER, INTENT(out) :: pos(:,:)

    INTEGER :: i,j,p

    p = 0
    DO j = 1, SIZE(pos,2)
      DO i = 1, SIZE(pos,1)
        p = p + 1
        pos(i,j) = p
      ENDDO
    ENDDO

  END SUBROUTINE gen_id_pos

  SUBROUTINE gen_trans(xmap, send_dt, recv_dt, redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER,INTENT(in) :: send_dt, recv_dt
    TYPE(xt_redist),INTENT(out) :: redist

    INTEGER :: dt

    IF (send_dt /= recv_dt) &
         CALL abort('gen_trans: (send_dt /= recv_dt) unsupported', __LINE__)
    dt = send_dt
    redist = xt_redist_p2p_new(xmap, dt)

  END SUBROUTINE gen_trans

  SUBROUTINE gen_off_trans(xmap, send_dt, send_off, recv_dt, recv_off, redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER,INTENT(in) :: send_dt, recv_dt
    INTEGER(c_int),INTENT(in) :: send_off(:,:), recv_off(:,:)
    TYPE(xt_redist),INTENT(out) :: redist

    !INTEGER :: send_offsets(SIZE(send_off)), recv_offsets(SIZE(recv_off))

    !send_offsets = RESHAPE(send_off, (/SIZE(send_off)/) )
    !recv_offsets = RESHAPE(recv_off, (/SIZE(recv_off)/) )
    IF (recv_dt /= send_dt) &
         CALL abort('(datatype_in /= datatype_out) not supported', __LINE__)

    redist = xt_redist_p2p_off_new(xmap, send_off, recv_off, send_dt);

  END SUBROUTINE gen_off_trans

  SUBROUTINE get_window(gval, win)
    INTEGER(xt_int_kind), INTENT(in) :: gval(:,:)
    INTEGER(xt_int_kind), INTENT(out) :: win(:,:)

    INTEGER :: i, j, ig, jg

    DO j = 1, je
      jg = p_joff + j
      DO i = 1, ie
        ig = p_ioff + i
        win(i,j) =  gval(ig,jg)
      ENDDO
    ENDDO

  END SUBROUTINE get_window

  SUBROUTINE gen_template(local_src_idx, local_dst_idx, xmap)
    INTEGER(xt_int_kind), INTENT(in) :: local_src_idx(:,:)
    INTEGER(xt_int_kind), INTENT(in) :: local_dst_idx(:,:)
    TYPE(xt_xmap), INTENT(out) :: xmap

    TYPE(Xt_idxlist) :: src_idxlist, dst_idxlist
    INTEGER :: src_num, dst_num
    INTEGER(xt_int_kind) :: cp_src_idx(g_ie, g_je)
    INTEGER(xt_int_kind) :: cp_dst_idx(g_ie, g_je)

    src_idxlist = xt_idxvec_new(local_src_idx, g_ie * g_je)
    src_num = INT(xt_idxlist_get_num_indices(src_idxlist))
    IF (src_num /= g_ie*g_je) CALL abort('unexpected src_num', __LINE__)
    CALL xt_idxlist_get_indices(src_idxlist, cp_src_idx)
    IF (ANY(cp_src_idx /= local_src_idx)) &
         CALL abort('idx copy does not match', __LINE__)

    dst_idxlist = xt_idxvec_new(local_dst_idx, g_ie * g_je)
    dst_num = INT(xt_idxlist_get_num_indices(dst_idxlist))
    IF (dst_num /= g_ie*g_je) CALL abort('unexpected dst_num', __LINE__)
    CALL xt_idxlist_get_indices(dst_idxlist, cp_dst_idx)
    IF (ANY(cp_dst_idx /= local_dst_idx)) &
         CALL abort('idx copy does not match', __LINE__)

    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist,  MPI_COMM_WORLD)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

  END SUBROUTINE gen_template

  SUBROUTINE def_tpex_mod_via_idxvec(mvec, mvec_num)
    TYPE(xt_modifier), INTENT(out) :: mvec(:)
    INTEGER, INTENT(out) :: mvec_num

    INTEGER(xt_int_kind) :: g_start_indices(g_ie, g_je)
    INTEGER(xt_int_kind) :: g_end_indices(g_ie, g_je)
    TYPE(xt_idxlist) :: g_start_idxlist
    TYPE(xt_idxlist) :: g_end_idxlist

    IF (SIZE(mvec)<1) &
         CALL abort('def_tpex_mod_via_idxvec mvec too small', __LINE__)

    CALL id_map(g_start_indices)
    g_start_idxlist = xt_idxvec_new(g_start_indices, SIZE(g_start_indices))

    CALL def_exchange(g_start_indices, g_end_indices)
    g_end_idxlist = xt_idxvec_new(g_end_indices, SIZE(g_end_indices))

    mvec(1)%extract = g_start_idxlist
    mvec(1)%subst = g_end_idxlist
    mvec(1)%mask = 1
    mvec_num = 1

  END SUBROUTINE def_tpex_mod_via_idxvec

  SUBROUTINE def_tpex_mod_via_sections(mvec, mvec_num)
    TYPE(xt_modifier), INTENT(out) :: mvec(:)
    INTEGER, INTENT(out) :: mvec_num

    INTEGER(xt_int_kind), PARAMETER :: gstart_idx = 1_xt_int_kind
    INTEGER(xt_int_kind), PARAMETER :: gsize(2) &
         = (/ INT(g_ie, xt_int_kind), INT(g_je, xt_int_kind) /)
    INTEGER :: ldx, ldy

    INTEGER(xt_int_kind) :: g_core_is, g_core_ie, g_core_je
    INTEGER(xt_int_kind) :: north_halo, im

    ! global core domain:
    g_core_is = nhalo + 1
    g_core_ie = g_ie-nhalo
    g_core_je = g_je-nhalo

    im = 0

    ! global tripolar boundsexchange:
    IF (with_north_halo) THEN

      ! north inversion, (maybe with increased north halo)
      IF (increased_north_halo) THEN
        north_halo = nhalo+1
      ELSE
        north_halo = nhalo
      ENDIF

      IF (2*north_halo > g_core_je) &
           CALL test_abort('def_tpex_mod_via_sections: grid too small '//&
           '(or halo too large) for tripolar north exchange',filename, __LINE__)

      im = im + 1_xt_int_kind
      IF (SIZE(mvec)<im) CALL abort('(SIZE(mvec)<im)', __LINE__)
      ! north border exchange without ew-halos
      ldx = INT(g_core_ie - g_core_is + 1)
      ldy = INT(north_halo)
      mvec(im)%extract = xt_idxfsection_new(gstart_idx, gsize, &
           (/ ldx, ldy /),   (/g_core_is, 1_xt_int_kind/))
      mvec(im)%subst   = xt_idxfsection_new(gstart_idx, gsize, &
           (/ -ldx, -ldy /), (/g_core_is, north_halo+1_xt_int_kind/))
      mvec(im)%mask    = 1

      ! 1. north edge:
      im = im + 1_xt_int_kind
      IF (SIZE(mvec)<im) CALL abort('(SIZE(mvec)<im)', __LINE__)
      ldx = 1
      ldy = INT(north_halo)
      mvec(im)%extract = xt_idxfsection_new(gstart_idx, gsize, &
           (/ ldx, ldy /),   (/1_xt_int_kind, 1_xt_int_kind/))
      mvec(im)%subst   = xt_idxfsection_new(gstart_idx, gsize, &
           (/ -ldx, -ldy /), (/2_xt_int_kind, north_halo+1_xt_int_kind/))
      mvec(im)%mask    = 1
      ! 2. north edge:
      im = im + 1_xt_int_kind
      IF (SIZE(mvec)<im) CALL abort('(SIZE(mvec)<im)', __LINE__)
      ldx = 1
      ldy = INT(north_halo)
      mvec(im)%extract = xt_idxfsection_new(gstart_idx, gsize, &
           (/ ldx, ldy /),   (/INT(g_ie, xt_int_kind), 1_xt_int_kind/))
      mvec(im)%subst   = xt_idxfsection_new(gstart_idx, gsize, &
           (/ -ldx, -ldy /), &
           (/INT(g_ie - 1, xt_int_kind), north_halo+1_xt_int_kind/))
      mvec(im)%mask    = 1

    ELSE

      ! nothing to do at the north border

    ENDIF

    ! PBC below north border
    ldx = nhalo
    ldy = INT(INT(g_je, xt_int_kind) - north_halo)
    im = im + 1_xt_int_kind
    IF (SIZE(mvec)<im) CALL abort('(SIZE(mvec)<im)', __LINE__)
    mvec(im)%extract = xt_idxfsection_new(gstart_idx, gsize, &
         (/ ldx, ldy /), (/1_xt_int_kind, north_halo+1_xt_int_kind/))
    mvec(im)%subst   = xt_idxfsection_new(gstart_idx, gsize, &
         (/ ldx, ldy /), &
         (/ g_core_ie - INT(ldx, xt_int_kind) + 1_xt_int_kind, &
           north_halo + 1_xt_int_kind/))
    mvec(im)%mask    = 1

    im = im + 1_xt_int_kind
    IF (SIZE(mvec)<im) CALL abort('(SIZE(mvec)<im)', __LINE__)
    mvec(im)%extract = xt_idxfsection_new(gstart_idx, gsize, &
         (/ ldx, ldy /), (/g_core_ie+1_xt_int_kind, north_halo+1_xt_int_kind/))
    mvec(im)%subst   = xt_idxfsection_new(gstart_idx, gsize, &
         (/ ldx, ldy /), (/ INT(ldx, xt_int_kind) + 1_xt_int_kind, &
         &                  north_halo+1_xt_int_kind/))
    mvec(im)%mask    = 1

    mvec_num = INT(im)

  END SUBROUTINE def_tpex_mod_via_sections

  SUBROUTINE def_exchange(id_in, id_out)
    INTEGER(xt_int_kind), INTENT(in) :: id_in(:,:)
    INTEGER(xt_int_kind), INTENT(out) :: id_out(:,:)

    INTEGER :: i, j
    INTEGER :: g_core_is, g_core_ie, g_core_js, g_core_je
    INTEGER :: north_halo

    ! global core domain:
    g_core_is = nhalo + 1
    g_core_ie = g_ie-nhalo
    g_core_js = nhalo + 1
    g_core_je = g_je-nhalo

    ! global tripolar boundsexchange:
    id_out = undef_index
    id_out(g_core_is:g_core_ie, g_core_js:g_core_je) &
         = id_in(g_core_is:g_core_ie, g_core_js:g_core_je)

    IF (with_north_halo) THEN

      ! north inversion, (maybe with increased north halo)
      IF (increased_north_halo) THEN
        north_halo = nhalo+1
      ELSE
        north_halo = nhalo
      ENDIF

      IF (2*north_halo > g_core_je) &
           CALL test_abort('def_exchange: grid too small (or halo too large)'//&
           'for tripolar north exchange', filename, __LINE__)
      DO j = 1, north_halo
        DO i = g_core_is, g_core_ie
          id_out(i,j) = id_out(g_core_ie + (g_core_is-i), 2*north_halo + (1-j))
        ENDDO
      ENDDO

    ELSE

      DO j = 1, nhalo
        DO i = nhalo+1, g_ie-nhalo
          id_out(i,j) = id_in(i,j)
        ENDDO
      ENDDO

    ENDIF

    ! south: no change
    DO j = g_core_je+1, g_je
      DO i = nhalo+1, g_ie-nhalo
        id_out(i,j) = id_in(i,j)
      ENDDO
    ENDDO

    ! PBC
    DO j = 1, g_je
      DO i = 1, nhalo
        id_out(g_core_is-i,j) = id_out(g_core_ie+(1-i),j)
      ENDDO
      DO i = 1, nhalo
        id_out(g_core_ie+i,j) = id_out(nhalo+i,j)
      ENDDO
    ENDDO

    IF (ANY(id_out == undef_index)) &
         CALL abort('found undefined indices', __LINE__)

  END SUBROUTINE def_exchange

  SUBROUTINE deco
    INTEGER :: cx0(0:nprocx-1), cxn(0:nprocx-1)
    INTEGER :: cy0(0:nprocy-1), cyn(0:nprocy-1)

    CALL regular_deco(g_ie-2*nhalo, cx0, cxn)
    CALL regular_deco(g_je-2*nhalo, cy0, cyn)

    ! process local deco variables:
    ie = cxn(mypx) + 2*nhalo
    je = cyn(mypy) + 2*nhalo
    p_ioff = cx0(mypx)
    p_joff = cy0(mypy)

  END SUBROUTINE deco

END PROGRAM test_yaxt
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_single_array_base_f.f90
!!
!! @copyright Copyright  (C)  2017 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
!  Keywords:
!  Maintainer: Jörg Behrens <behrens@dkrz.de>
!              Moritz Hanke <hanke@dkrz.de>
!              Thomas Jahns <jahns@dkrz.de>
!  URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
!  Redistribution and use in source and binary forms, with or without
!  modification, are  permitted provided that the following conditions are
!  met:
!
!  Redistributions of source code must retain the above copyright notice,
!  this list of conditions and the following disclaimer.
!
!  Redistributions in binary form must reproduce the above copyright
!  notice, this list of conditions and the following disclaimer in the
!  documentation and/or other materials provided with the distribution.
!
!  Neither the name of the DKRZ GmbH nor the names of its contributors
!  may be used to endorse or promote products derived from this software
!  without specific prior written permission.
!
!  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
!  IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
!  TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
!  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
!  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
!  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
!  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
!  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
!  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
!  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
!  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_redist_single_array_base_f
  USE mpi
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_redist_msg, &
       xt_config, xt_config_delete

  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_redist_common, ONLY: &
       test_redist_single_array_base, redist_exchanger_option
  USE test_idxlist_utils, ONLY: test_err_count
  IMPLICIT NONE
  CHARACTER(len=*), PARAMETER :: &
       filename = 'test_redist_single_array_base_f.f90'
  TYPE(xt_config) :: config

  ! init mpi
  CALL init_mpi

  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  ! single double
  CALL test_single_double(mpi_comm_world, config)
  ! reverse order of some doubles
  CALL test_reverse_doubles(mpi_comm_world, config)

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)

  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi

CONTAINS

  SUBROUTINE test_single_double(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config


    TYPE(xt_redist_msg) :: send_msgs(1)
    TYPE(xt_redist_msg) :: recv_msgs(1)

    INTEGER, PARAMETER :: num_elem = 1
    DOUBLE PRECISION, PARAMETER :: src_data(num_elem) &
         = (/ 0.0d0 /)
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(num_elem) &
         = (/ 0.0d0 /)

    send_msgs(1)%rank = 0
    send_msgs(1)%datatype = MPI_DOUBLE_PRECISION
    recv_msgs(1)%rank = 0
    recv_msgs(1)%datatype = MPI_DOUBLE_PRECISION

    CALL test_redist_single_array_base(send_msgs, recv_msgs, src_data, &
         ref_dst_data, comm, config)

  END SUBROUTINE test_single_double

  SUBROUTINE test_reverse_doubles(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config


    TYPE(xt_redist_msg) :: send_msgs(1)
    TYPE(xt_redist_msg) :: recv_msgs(1)

    INTEGER :: i, ierror
    INTEGER, PARAMETER :: num_elem = 10
    INTEGER, PARAMETER :: displ(num_elem) &
         = (/ (i, i = num_elem - 1, 0, -1) /)
#ifndef __PGI
    DOUBLE PRECISION, PARAMETER :: src_data(num_elem) &
         = (/ (DBLE(i), i = 1, num_elem) /)
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(num_elem) &
         = (/ (DBLE(i), i = num_elem, 1, -1) /)
#else
    DOUBLE PRECISION :: src_data(num_elem), ref_dst_data(num_elem)
#endif

#ifdef __PGI
    DO i = 1, num_elem
      src_data(i) = DBLE(i)
      ref_dst_data(i) = DBLE(num_elem - i + 1)
    END DO
#endif
    send_msgs(1)%rank = 0
    CALL MPI_Type_contiguous( &
      num_elem, MPI_DOUBLE_PRECISION, send_msgs(1)%datatype, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_type_contiguous", &
         filename, __LINE__)
    CALL MPI_Type_commit(send_msgs(1)%datatype, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_type_commit", &
         filename, __LINE__)
    recv_msgs(1)%rank = 0
    CALL MPI_Type_create_indexed_block(num_elem, 1, displ, &
         MPI_DOUBLE_PRECISION, recv_msgs(1)%datatype, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_type_create_indexed_block", &
         filename, __LINE__)
    CALL MPI_Type_commit(recv_msgs(1)%datatype, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_type_commit", &
         filename, __LINE__)

    CALL test_redist_single_array_base(send_msgs, recv_msgs, src_data, &
         ref_dst_data, comm, config)

    CALL MPI_Type_free(recv_msgs(1)%datatype, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_type_free", filename, __LINE__)
    CALL MPI_Type_free(send_msgs(1)%datatype, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_type_free", filename, __LINE__)

  END SUBROUTINE test_reverse_doubles

END PROGRAM test_redist_single_array_base_f
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file row2col_f.f90
!! @brief Fortran example of row to column redistribution
!!
!! @copyright Copyright  (C)  2013 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_redist_collection
  USE mpi
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_int_kind, &
       xt_idxlist, xt_idxfsection_new, xt_idxlist_delete, &
       xt_xmap, xt_xmap_all2all_new, xt_xmap_delete, &
       xt_redist, xt_redist_p2p_new, xt_redist_delete, xt_redist_s_exchange
  USE iso_c_binding, ONLY: c_int
  ! older PGI compilers do not handle generic interface correctly
#if defined __PGI && ( __PGIC__ == 15 || __PGIC__ == 14 )
  USE xt_redist_real_sp, ONLY: xt_redist_s_exchange
  USE xt_redist_real_dp, ONLY: xt_redist_s_exchange
#endif
  IMPLICIT NONE
  INTEGER, PARAMETER :: i4 = SELECTED_INT_KIND(9)
  INTEGER, PARAMETER :: i8 = SELECTED_INT_KIND(14)

  INTEGER :: rank, comm_size
  INTEGER(i4), PARAMETER :: global_shape(2) = (/ 1024, 512 /), &
       global_range(2, 2) = RESHAPE((/ 1_i4, global_shape(1), &
       &                               1_i4, global_shape(2) /), (/ 2, 2 /))
  INTEGER :: row_part_range(2, 2), col_part_range(2, 2)
  INTEGER :: i, j
  INTEGER(i4) :: row_part_shape(2), col_part_shape(2)
  INTEGER :: ierror
  TYPE(xt_idxlist) :: src_idxlist, tgt_idxlist
  TYPE(xt_xmap) :: xmap
  TYPE(xt_redist) :: redist
  DOUBLE PRECISION, ALLOCATABLE :: src_array(:, :), tgt_array(:, :)

  CALL mpi_init(ierror)
  IF (ierror /= mpi_success) STOP 1
  CALL xt_initialize(mpi_comm_world)
  CALL mpi_comm_rank(mpi_comm_world, rank, ierror)
  IF (ierror /= mpi_success) STOP 1
  CALL mpi_comm_size (mpi_comm_world, comm_size, ierror)
  IF (ierror /= mpi_success) STOP 1

  ! row-wise partitioning
  row_part_range(1, 1) = &
       INT(uniform_partition_start(global_range(:, 1), comm_size, rank + 1))
  row_part_range(2, 1) = &
       INT(uniform_partition_start(global_range(:, 1), comm_size, rank + 2)) - 1
  row_part_range(:, 2) = INT(global_range(:, 2))
  row_part_shape(:) = row_part_range(2, :) - row_part_range(1, :) + 1

  ! column-wise partitioning
  col_part_range(:, 1) = INT(global_range(:, 1))
  col_part_range(1, 2) = &
       INT(uniform_partition_start(global_range(:, 2), comm_size, rank + 1))
  col_part_range(2, 2) = &
       INT(uniform_partition_start(global_range(:, 2), comm_size, rank + 2)) - 1
  col_part_shape(:) = col_part_range(2, :) - col_part_range(1, :) + 1

  ! create decomposition descriptors
  src_idxlist = xt_idxfsection_new(0_xt_int_kind, &
       INT(global_shape, xt_int_kind), INT(row_part_shape, c_int), &
       INT(row_part_range(1, :), xt_int_kind))
  tgt_idxlist = xt_idxfsection_new(0_xt_int_kind, &
       INT(global_shape, xt_int_kind), INT(col_part_shape, c_int), &
       INT(col_part_range(1, :), xt_int_kind))

  ! generate exchange map
  xmap = xt_xmap_all2all_new(src_idxlist, tgt_idxlist, mpi_comm_world)

  ! generate redistribution object
  redist = xt_redist_p2p_new(xmap, mpi_double_precision)

  ! prepare arrays
  ALLOCATE(src_array(row_part_range(1, 1):row_part_range(2, 1), &
       &             row_part_range(1, 2):row_part_range(2, 2)), &
       &   tgt_array(col_part_range(1, 1):col_part_range(2, 1), &
       &             col_part_range(1, 2):col_part_range(2, 2)))

  DO j = row_part_range(1, 2), row_part_range(2, 2)
    DO i = row_part_range(1, 1), row_part_range(2, 1)
      src_array(i, j) = DBLE(i * j)
    END DO
  END DO

  ! do the exchange
  CALL xt_redist_s_exchange(redist, src_array, tgt_array)

  ! clean up
  DEALLOCATE(tgt_array, src_array)
  CALL xt_redist_delete(redist)
  CALL xt_xmap_delete(xmap)
  CALL xt_idxlist_delete(tgt_idxlist)
  CALL xt_idxlist_delete(src_idxlist)

  ! finalise
  CALL xt_finalize()
  CALL mpi_finalize(ierror)
  IF (ierror /= mpi_success) STOP 1
CONTAINS
  FUNCTION uniform_partition_start(set_interval, nparts, part_idx) &
       RESULT(start)
    INTEGER(i4), INTENT(in) :: nparts
    INTEGER(i4), INTENT(in) :: set_interval(2)
    INTEGER(i4), INTENT(in) :: part_idx

    INTEGER(i4) :: start, part_offset

    part_offset = INT((INT(set_interval(2) - set_interval(1) + 1, i8) &
         &             * INT(part_idx - 1, i8)) / INT(nparts, i8))
    start = set_interval(1) + part_offset
  END FUNCTION uniform_partition_start

END PROGRAM test_redist_collection
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file xt_redist_f.f90
!! @brief xt_redist-related procedures of Fortran interface
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!

!>
!! @example test_redist_collection_displace_f.f90
!! @example test_redist_common_f.f90
!! @example test_redist_p2p_f.f90
!! @example test_redist_p2p_parallel_f.f90

#include "fc_feature_defs.inc"
MODULE xt_redist_base
  USE xt_core, ONLY: xt_abort, xt_mpi_fint_kind, i2, i4, i8
  USE xt_config_f, ONLY: xt_config, xt_config_f2c
  USE xt_xmap_abstract, ONLY: xt_xmap
  USE iso_c_binding, ONLY: c_int, c_null_ptr, c_ptr, c_loc, c_associated
  USE xt_mpi, ONLY: mpi_address_kind
  USE xt_requests, ONLY: xt_request
#include "xt_slice_c_loc.inc"
  IMPLICIT NONE
  PRIVATE
  ! note: this type must not be extended to contain any other
  ! components, its memory pattern has to match void * exactly, which
  ! it does because of C constraints
  TYPE, BIND(C), PUBLIC :: xt_redist
#ifndef __G95__
    PRIVATE
#endif
    TYPE(c_ptr) :: cptr = c_null_ptr
  END TYPE xt_redist

  TYPE, BIND(c), PUBLIC :: xt_offset_ext
    INTEGER(c_int) :: start, size, stride
  END TYPE xt_offset_ext

  TYPE, BIND(c), PUBLIC :: xt_aoffset_ext
    INTEGER(mpi_address_kind) :: start
    INTEGER(c_int) :: size
    INTEGER(mpi_address_kind) :: stride
  END TYPE xt_aoffset_ext

  TYPE, BIND(c), PUBLIC :: xt_redist_msg
    INTEGER(xt_mpi_fint_kind) :: rank, datatype
  END TYPE xt_redist_msg

  INTERFACE
    ! this function must not be implemented in Fortran because
    ! PGI 11.x chokes on that
    FUNCTION xt_redist_f2c(redist) BIND(c, name='xt_redist_f2c') RESULT(p)
      IMPORT :: c_ptr, xt_redist
      IMPLICIT NONE
      TYPE(xt_redist), INTENT(in) :: redist
      TYPE(c_ptr) :: p
    END FUNCTION xt_redist_f2c
  END INTERFACE

  INTERFACE xt_redist_delete
    MODULE PROCEDURE xt_redist_delete_1
    MODULE PROCEDURE xt_redist_delete_a1d
  END INTERFACE xt_redist_delete

  INTERFACE
    SUBROUTINE xt_redist_delete_c(redist) &
         BIND(C, name='xt_redist_delete')
      IMPORT :: c_ptr
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in) :: redist
    END SUBROUTINE xt_redist_delete_c
  END INTERFACE

  INTERFACE xt_is_null
    MODULE PROCEDURE xt_redist_is_null
  END INTERFACE xt_is_null

  INTERFACE xt_redist_s_exchange
    MODULE PROCEDURE xt_redist_s_exchange1
    MODULE PROCEDURE xt_redist_s_exchange_a1d
    MODULE PROCEDURE xt_redist_s_exchange_i2_a1d
    MODULE PROCEDURE xt_redist_s_exchange_i4_a1d
    MODULE PROCEDURE xt_redist_s_exchange_i8_a1d
  END INTERFACE xt_redist_s_exchange

  INTERFACE xt_redist_a_exchange
    MODULE PROCEDURE xt_redist_a_exchange1
    MODULE PROCEDURE xt_redist_a_exchange_a1d
    MODULE PROCEDURE xt_redist_a_exchange_i2_a1d
    MODULE PROCEDURE xt_redist_a_exchange_i4_a1d
    MODULE PROCEDURE xt_redist_a_exchange_i8_a1d
  END INTERFACE xt_redist_a_exchange


  INTERFACE
    SUBROUTINE xt_redist_s_exchange_c(redist, num_ptr, src_data_cptr, &
         dst_data_cptr) BIND(C, name='xt_redist_s_exchange')
      IMPORT:: c_ptr, c_int
      TYPE(c_ptr), VALUE, INTENT(in) :: redist
      INTEGER(c_int), VALUE, INTENT(in) :: num_ptr
      TYPE(c_ptr), INTENT(in) :: src_data_cptr(num_ptr), dst_data_cptr(num_ptr)
    END SUBROUTINE xt_redist_s_exchange_c

    SUBROUTINE xt_redist_a_exchange_c(redist, num_ptr, src_data_cptr, &
         dst_data_cptr, request) BIND(C, name='xt_redist_a_exchange')
      IMPORT:: c_ptr, c_int, xt_request
      TYPE(c_ptr), VALUE, INTENT(in) :: redist
      INTEGER(c_int), VALUE, INTENT(in) :: num_ptr
      TYPE(c_ptr), INTENT(in) :: src_data_cptr(num_ptr), dst_data_cptr(num_ptr)
      TYPE(xt_request), INTENT(out) :: request
    END SUBROUTINE  xt_redist_a_exchange_c

    FUNCTION xt_redist_get_mpi_comm(redist) &
         BIND(c, name='xt_redist_get_mpi_comm_c2f') RESULT(comm)
      IMPORT :: xt_redist, xt_mpi_fint_kind
      TYPE(xt_redist), INTENT(in) :: redist
      INTEGER(xt_mpi_fint_kind) :: comm
    END FUNCTION xt_redist_get_mpi_comm

    FUNCTION xt_redist_get_num_send_msg_c(redist) RESULT(num_send_msg) &
         BIND(c, name='xt_redist_get_num_send_msg')
      IMPORT :: c_ptr, c_int
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in) :: redist
      INTEGER(c_int) :: num_send_msg
    END FUNCTION xt_redist_get_num_send_msg_c

    FUNCTION xt_redist_get_num_recv_msg_c(redist) RESULT(num_recv_msg) &
         BIND(c, name='xt_redist_get_num_recv_msg')
      IMPORT :: c_ptr, c_int
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in) :: redist
      INTEGER(c_int) :: num_recv_msg
    END FUNCTION xt_redist_get_num_recv_msg_c

    FUNCTION xt_redist_get_recv_mpi_datatype(redist, rank) &
         BIND(c, name='xt_redist_get_recv_MPI_Datatype_c2f') RESULT(dt)
      IMPORT :: xt_redist, xt_mpi_fint_kind
      TYPE(xt_redist), INTENT(in) :: redist
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: rank
      INTEGER(xt_mpi_fint_kind) :: dt
    END FUNCTION xt_redist_get_recv_mpi_datatype

    FUNCTION xt_redist_get_send_mpi_datatype(redist, rank) &
         BIND(c, name='xt_redist_get_send_MPI_Datatype_c2f') RESULT(dt)
      IMPORT :: xt_redist, xt_mpi_fint_kind
      TYPE(xt_redist), INTENT(in) :: redist
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: rank
      INTEGER(xt_mpi_fint_kind) :: dt
    END FUNCTION xt_redist_get_send_mpi_datatype

    FUNCTION xt_redist_collection_static_new_f(redists_f, num_redists, &
         src_displacements, dst_displacements, comm_f) &
         BIND(C, name='xt_redist_collection_static_new_f') RESULT(res)
      IMPORT :: xt_redist, mpi_address_kind, c_ptr, xt_mpi_fint_kind
      IMPLICIT NONE
      TYPE(xt_redist), INTENT(in) :: redists_f(*)
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: num_redists
      INTEGER(mpi_address_kind), INTENT(in) :: src_displacements(*), &
           dst_displacements(*)
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: comm_f
      TYPE(c_ptr) :: res
    END FUNCTION xt_redist_collection_static_new_f

    FUNCTION xt_redist_collection_static_custom_new_f(redists_f, num_redists, &
         src_displacements, dst_displacements, comm_f, config) &
         BIND(C, name='xt_redist_collection_static_custom_new_f') RESULT(res)
      IMPORT :: xt_redist, mpi_address_kind, c_ptr, xt_mpi_fint_kind, xt_config
      IMPLICIT NONE
      TYPE(xt_redist), INTENT(in) :: redists_f(*)
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: num_redists
      INTEGER(mpi_address_kind), INTENT(in) :: src_displacements(*), &
           dst_displacements(*)
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: comm_f
      TYPE(xt_config), INTENT(in) :: config
      TYPE(c_ptr) :: res
    END FUNCTION xt_redist_collection_static_custom_new_f

    FUNCTION xt_redist_collection_new_f(redists_f, num_redists, cache_size, &
         comm_f) BIND(C, name='xt_redist_collection_new_f') RESULT(res)
      IMPORT :: xt_redist, mpi_address_kind, c_ptr, xt_mpi_fint_kind
      IMPLICIT NONE
      TYPE(xt_redist), INTENT(in) :: redists_f(*)
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: &
           num_redists, cache_size, comm_f
      TYPE(c_ptr) :: res
    END FUNCTION xt_redist_collection_new_f

    FUNCTION xt_redist_collection_custom_new_f(redists_f, num_redists, &
         cache_size, comm_f, config) &
         BIND(C, name='xt_redist_collection_custom_new_f') RESULT(res)
      IMPORT :: xt_redist, mpi_address_kind, c_ptr, xt_mpi_fint_kind, xt_config
      IMPLICIT NONE
      TYPE(xt_redist), INTENT(in) :: redists_f(*)
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: &
           num_redists, cache_size, comm_f
      TYPE(xt_config), INTENT(in) :: config
      TYPE(c_ptr) :: res
    END FUNCTION xt_redist_collection_custom_new_f

    FUNCTION xt_redist_p2p_ext_new_c2f(xmap, num_src_ext, src_extents, &
         num_dst_ext, dst_extents, datatype) &
         BIND(c, name='xt_redist_p2p_ext_new_c2f') RESULT(redist)
      IMPORT :: c_int, c_ptr, xt_offset_ext, xt_mpi_fint_kind, xt_xmap
      TYPE(xt_xmap), INTENT(in) :: xmap
      INTEGER(c_int), VALUE, INTENT(in) :: num_src_ext, num_dst_ext
      TYPE(xt_offset_ext), INTENT(in) :: src_extents(num_src_ext), &
           dst_extents(num_dst_ext)
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: datatype
      TYPE(c_ptr) :: redist
    END FUNCTION xt_redist_p2p_ext_new_c2f

    FUNCTION xt_redist_p2p_ext_custom_new_c2f(xmap, num_src_ext, src_extents, &
         num_dst_ext, dst_extents, datatype, config) &
         BIND(c, name='xt_redist_p2p_ext_custom_new_c2f') RESULT(redist)
      IMPORT :: c_int, c_ptr, xt_offset_ext, xt_mpi_fint_kind, xt_xmap, &
           xt_config
      TYPE(xt_xmap), INTENT(in) :: xmap
      INTEGER(c_int), VALUE, INTENT(in) :: num_src_ext, num_dst_ext
      TYPE(xt_offset_ext), INTENT(in) :: src_extents(num_src_ext), &
           dst_extents(num_dst_ext)
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: datatype
      TYPE(xt_config), INTENT(in) :: config
      TYPE(c_ptr) :: redist
    END FUNCTION xt_redist_p2p_ext_custom_new_c2f

    FUNCTION xt_redist_p2p_aext_new_c2f(xmap, num_src_ext, src_extents, &
         num_dst_ext, dst_extents, datatype) &
         BIND(c, name='xt_redist_p2p_aext_new_c2f') RESULT(redist)
      IMPORT :: c_int, c_ptr, xt_aoffset_ext, xt_mpi_fint_kind, xt_xmap
      TYPE(xt_xmap), INTENT(in) :: xmap
      INTEGER(c_int), VALUE, INTENT(in) :: num_src_ext, num_dst_ext
      TYPE(xt_aoffset_ext), INTENT(in) :: src_extents(num_src_ext), &
           dst_extents(num_dst_ext)
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: datatype
      TYPE(c_ptr) :: redist
    END FUNCTION xt_redist_p2p_aext_new_c2f

    FUNCTION xt_redist_p2p_aext_custom_new_c2f(xmap, num_src_ext, src_extents, &
         num_dst_ext, dst_extents, datatype, config) &
         BIND(c, name='xt_redist_p2p_aext_custom_new_c2f') RESULT(redist)
      IMPORT :: c_int, c_ptr, xt_aoffset_ext, xt_mpi_fint_kind, xt_xmap, &
           xt_config
      TYPE(xt_xmap), INTENT(in) :: xmap
      INTEGER(c_int), VALUE, INTENT(in) :: num_src_ext, num_dst_ext
      TYPE(xt_aoffset_ext), INTENT(in) :: src_extents(num_src_ext), &
           dst_extents(num_dst_ext)
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: datatype
      TYPE(xt_config), INTENT(in) :: config
      TYPE(c_ptr) :: redist
    END FUNCTION xt_redist_p2p_aext_custom_new_c2f

    FUNCTION xt_redist_repeat_new_c(redist_f, src_extent, dst_extent, &
         num_repetitions, displacements) &
         BIND(C, name='xt_redist_repeat_new') RESULT(res)
      IMPORT :: xt_redist, mpi_address_kind, c_ptr, xt_mpi_fint_kind, c_int
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in)  :: redist_f
      INTEGER(mpi_address_kind), VALUE, INTENT(in) :: src_extent, dst_extent
      INTEGER(c_int), VALUE, INTENT(in) :: num_repetitions
      INTEGER(c_int), INTENT(in) :: displacements(*)
      TYPE(c_ptr) :: res
    END FUNCTION xt_redist_repeat_new_c

    FUNCTION xt_redist_repeat_custom_new_c(redist_f, src_extent, dst_extent, &
         num_repetitions, displacements, config) &
         BIND(C, name='xt_redist_repeat_custom_new') RESULT(res)
      IMPORT :: xt_redist, mpi_address_kind, c_ptr, xt_mpi_fint_kind, c_int
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in)  :: redist_f
      INTEGER(mpi_address_kind), VALUE, INTENT(in) :: src_extent, dst_extent
      INTEGER(c_int), VALUE, INTENT(in) :: num_repetitions
      INTEGER(c_int), INTENT(in) :: displacements(*)
      TYPE(c_ptr), VALUE, INTENT(in) :: config
      TYPE(c_ptr) :: res
    END FUNCTION xt_redist_repeat_custom_new_c

    FUNCTION xt_redist_repeat_asym_new_c(redist_f, src_extent, dst_extent, &
         num_repetitions, src_displacements, dst_displacements) &
         BIND(C, name='xt_redist_repeat_asym_new') RESULT(res)
      IMPORT :: xt_redist, mpi_address_kind, c_ptr, xt_mpi_fint_kind, c_int
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in)  :: redist_f
      INTEGER(mpi_address_kind), VALUE, INTENT(in) :: src_extent, dst_extent
      INTEGER(c_int), VALUE, INTENT(in) :: num_repetitions
      INTEGER(c_int), INTENT(in) :: src_displacements(*), dst_displacements(*)
      TYPE(c_ptr) :: res
    END FUNCTION xt_redist_repeat_asym_new_c

    FUNCTION xt_redist_repeat_asym_custom_new_c(redist_f, src_extent, &
         dst_extent, num_repetitions, src_displacements, dst_displacements, &
         config) &
         BIND(C, name='xt_redist_repeat_asym_custom_new') RESULT(res)
      IMPORT :: xt_redist, mpi_address_kind, c_ptr, xt_mpi_fint_kind, c_int
      IMPLICIT NONE
      TYPE(c_ptr), VALUE, INTENT(in)  :: redist_f
      INTEGER(mpi_address_kind), VALUE, INTENT(in) :: src_extent, dst_extent
      INTEGER(c_int), VALUE, INTENT(in) :: num_repetitions
      INTEGER(c_int), INTENT(in) :: src_displacements(*), dst_displacements(*)
      TYPE(c_ptr), VALUE, INTENT(in) :: config
      TYPE(c_ptr) :: res
    END FUNCTION xt_redist_repeat_asym_custom_new_c

    FUNCTION xt_redist_single_array_base_new_c2f(nsend, nrecv, send_msgs_f, &
         recv_msgs_f, comm_f) &
         BIND(C, name='xt_redist_single_array_base_new_c2f') RESULT(res)
      IMPORT :: c_ptr, c_int, xt_mpi_fint_kind
      IMPLICIT NONE
      INTEGER(c_int), VALUE :: nsend, nrecv
      TYPE(c_ptr), VALUE, INTENT(in) :: send_msgs_f, recv_msgs_f
      INTEGER(xt_mpi_fint_kind), VALUE :: comm_f
      TYPE(c_ptr) :: res
    END FUNCTION xt_redist_single_array_base_new_c2f

    FUNCTION xt_redist_single_array_base_custom_new_c2f(nsend, nrecv, &
         send_msgs_f, recv_msgs_f, comm_f, config) &
         BIND(C, name='xt_redist_single_array_base_custom_new_c2f') RESULT(res)
      IMPORT :: c_ptr, c_int, xt_mpi_fint_kind, xt_config
      IMPLICIT NONE
      INTEGER(c_int), VALUE :: nsend, nrecv
      TYPE(c_ptr), VALUE, INTENT(in) :: send_msgs_f, recv_msgs_f
      INTEGER(xt_mpi_fint_kind), VALUE :: comm_f
      TYPE(xt_config), INTENT(in) :: config
      TYPE(c_ptr) :: res
    END FUNCTION xt_redist_single_array_base_custom_new_c2f

  END INTERFACE

  INTERFACE xt_redist_collection_static_new
    MODULE PROCEDURE xt_redist_collection_static_new_a_i_2ak_i
    MODULE PROCEDURE xt_redist_collection_static_new_a_i_2ak_i_cfg
    MODULE PROCEDURE xt_redist_collection_static_new_a_2ak_i
    MODULE PROCEDURE xt_redist_collection_static_new_a_2ak_i_cfg
  END INTERFACE xt_redist_collection_static_new

  INTERFACE xt_redist_collection_static_custom_new
    MODULE PROCEDURE xt_redist_collection_static_new_a_i_2ak_i_cfg
    MODULE PROCEDURE xt_redist_collection_static_new_a_2ak_i_cfg
  END INTERFACE xt_redist_collection_static_custom_new

  INTERFACE xt_redist_collection_new
    MODULE PROCEDURE xt_redist_collection_new_a_3i
    MODULE PROCEDURE xt_redist_collection_new_a_3i_cfg
    MODULE PROCEDURE xt_redist_collection_new_a_2i
    MODULE PROCEDURE xt_redist_collection_new_a_2i_cfg
    MODULE PROCEDURE xt_redist_collection_new_a_i
    MODULE PROCEDURE xt_redist_collection_new_a_i_cfg
  END INTERFACE xt_redist_collection_new

  INTERFACE xt_redist_collection_custom_new
    MODULE PROCEDURE xt_redist_collection_new_a_3i_cfg
    MODULE PROCEDURE xt_redist_collection_new_a_2i_cfg
    MODULE PROCEDURE xt_redist_collection_new_a_i_cfg
  END INTERFACE xt_redist_collection_custom_new

  INTERFACE xt_redist_p2p_ext_new
    MODULE PROCEDURE xt_redist_p2p_ext_new_i2_a1d_i2_a1d
    MODULE PROCEDURE xt_redist_p2p_ext_new_i2_a1d_i2_a1d_cfg
    MODULE PROCEDURE xt_redist_p2p_ext_new_i4_a1d_i4_a1d
    MODULE PROCEDURE xt_redist_p2p_ext_new_i4_a1d_i4_a1d_cfg
    MODULE PROCEDURE xt_redist_p2p_ext_new_i8_a1d_i8_a1d
    MODULE PROCEDURE xt_redist_p2p_ext_new_i8_a1d_i8_a1d_cfg
    MODULE PROCEDURE xt_redist_p2p_ext_new_a1d_a1d
    MODULE PROCEDURE xt_redist_p2p_ext_new_a1d_a1d_cfg
  END INTERFACE xt_redist_p2p_ext_new

  INTERFACE xt_redist_p2p_ext_custom_new
    MODULE PROCEDURE xt_redist_p2p_ext_new_i2_a1d_i2_a1d_cfg
    MODULE PROCEDURE xt_redist_p2p_ext_new_i4_a1d_i4_a1d_cfg
    MODULE PROCEDURE xt_redist_p2p_ext_new_i8_a1d_i8_a1d_cfg
    MODULE PROCEDURE xt_redist_p2p_ext_new_a1d_a1d_cfg
  END INTERFACE xt_redist_p2p_ext_custom_new

  INTERFACE xt_redist_p2p_aext_new
    MODULE PROCEDURE xt_redist_p2p_aext_new_i2_a1d_i2_a1d
    MODULE PROCEDURE xt_redist_p2p_aext_new_i2_a1d_i2_a1d_cfg
    MODULE PROCEDURE xt_redist_p2p_aext_new_i4_a1d_i4_a1d
    MODULE PROCEDURE xt_redist_p2p_aext_new_i4_a1d_i4_a1d_cfg
    MODULE PROCEDURE xt_redist_p2p_aext_new_i8_a1d_i8_a1d
    MODULE PROCEDURE xt_redist_p2p_aext_new_i8_a1d_i8_a1d_cfg
    MODULE PROCEDURE xt_redist_p2p_aext_new_a1d_a1d
    MODULE PROCEDURE xt_redist_p2p_aext_new_a1d_a1d_cfg
  END INTERFACE xt_redist_p2p_aext_new

  INTERFACE xt_redist_p2p_aext_custom_new
    MODULE PROCEDURE xt_redist_p2p_aext_new_i2_a1d_i2_a1d_cfg
    MODULE PROCEDURE xt_redist_p2p_aext_new_i4_a1d_i4_a1d_cfg
    MODULE PROCEDURE xt_redist_p2p_aext_new_i8_a1d_i8_a1d_cfg
    MODULE PROCEDURE xt_redist_p2p_aext_new_a1d_a1d_cfg
  END INTERFACE xt_redist_p2p_aext_custom_new

  INTERFACE xt_redist_repeat_new
    MODULE PROCEDURE xt_redist_repeat_new_i4_a1d
    MODULE PROCEDURE xt_redist_repeat_new_i4_a1d_cfg
    MODULE PROCEDURE xt_redist_repeat_new_a1d
    MODULE PROCEDURE xt_redist_repeat_new_a1d_cfg
    MODULE PROCEDURE xt_redist_repeat_asym_new_i4_a1d
    MODULE PROCEDURE xt_redist_repeat_asym_new_i4_a1d_cfg
    MODULE PROCEDURE xt_redist_repeat_asym_new_a1d
    MODULE PROCEDURE xt_redist_repeat_asym_new_a1d_cfg
  END INTERFACE xt_redist_repeat_new

  INTERFACE xt_redist_repeat_custom_new
    MODULE PROCEDURE xt_redist_repeat_new_i4_a1d_cfg
    MODULE PROCEDURE xt_redist_repeat_new_a1d_cfg
    MODULE PROCEDURE xt_redist_repeat_asym_new_i4_a1d_cfg
    MODULE PROCEDURE xt_redist_repeat_asym_new_a1d_cfg
  END INTERFACE xt_redist_repeat_custom_new

  INTERFACE xt_redist_single_array_base_new
    MODULE PROCEDURE xt_redist_single_array_base_new_i2_a1d_i2_a1d
    MODULE PROCEDURE xt_redist_single_array_base_new_i2_a1d_i2_a1d_cfg
    MODULE PROCEDURE xt_redist_single_array_base_new_i4_a1d_i4_a1d
    MODULE PROCEDURE xt_redist_single_array_base_new_i4_a1d_i4_a1d_cfg
    MODULE PROCEDURE xt_redist_single_array_base_new_i8_a1d_i8_a1d
    MODULE PROCEDURE xt_redist_single_array_base_new_i8_a1d_i8_a1d_cfg
    MODULE PROCEDURE xt_redist_single_array_base_new_a1d_a1d
    MODULE PROCEDURE xt_redist_single_array_base_new_a1d_a1d_cfg
  END INTERFACE xt_redist_single_array_base_new

  INTERFACE xt_redist_single_array_base_custom_new
    MODULE PROCEDURE xt_redist_single_array_base_new_i2_a1d_i2_a1d_cfg
    MODULE PROCEDURE xt_redist_single_array_base_new_i4_a1d_i4_a1d_cfg
    MODULE PROCEDURE xt_redist_single_array_base_new_i8_a1d_i8_a1d_cfg
    MODULE PROCEDURE xt_redist_single_array_base_new_a1d_a1d_cfg
  END INTERFACE xt_redist_single_array_base_custom_new

  PUBLIC :: xt_redist_c2f, xt_redist_f2c, xt_is_null, xt_redist_copy, &
       xt_redist_delete, xt_redist_s_exchange1, xt_redist_s_exchange, &
       xt_redist_collection_static_new, xt_redist_collection_static_custom_new,&
       xt_redist_collection_new, xt_redist_collection_custom_new, &
       xt_redist_repeat_new, xt_redist_repeat_custom_new, &
       xt_redist_get_mpi_comm, xt_redist_p2p_ext_new, xt_redist_p2p_aext_new, &
       xt_redist_a_exchange1, xt_redist_a_exchange, &
       xt_redist_single_array_base_new, xt_redist_single_array_base_custom_new,&
       xt_redist_get_send_mpi_datatype, xt_redist_get_recv_mpi_datatype, &
       xt_redist_get_num_send_msg, xt_redist_get_num_recv_msg
  PUBLIC :: xt_redist_p2p_new, xt_redist_p2p_custom_new
  PUBLIC :: xt_redist_p2p_off_new, xt_redist_p2p_off_custom_new
  PUBLIC :: xt_redist_p2p_blocks_new, xt_redist_p2p_blocks_custom_new
  PUBLIC :: xt_redist_p2p_blocks_off_new, xt_redist_p2p_blocks_off_custom_new
  CHARACTER(len=*), PARAMETER :: filename = 'xt_redist_f.f90'
CONTAINS

  FUNCTION xt_redist_is_null(redist) RESULT(p)
    TYPE(xt_redist), INTENT(in) :: redist
    LOGICAL :: p
    p = .NOT. C_ASSOCIATED(redist%cptr)
  END FUNCTION xt_redist_is_null

  FUNCTION xt_redist_c2f(redist) RESULT(p)
    TYPE(c_ptr), INTENT(in) :: redist
    TYPE(xt_redist) :: p
    p%cptr = redist
  END FUNCTION xt_redist_c2f

  FUNCTION xt_redist_copy(redist) RESULT(redist_copy)
    TYPE(xt_redist), INTENT(in) :: redist
    TYPE(xt_redist) :: redist_copy
    INTERFACE
      FUNCTION xt_redist_copy_c(redist) BIND(C, name='xt_redist_copy')
        IMPORT:: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: redist
        TYPE(c_ptr) :: xt_redist_copy_c
      END FUNCTION xt_redist_copy_c
    END INTERFACE
    redist_copy%cptr = xt_redist_copy_c(redist%cptr)
  END FUNCTION xt_redist_copy

  SUBROUTINE xt_redist_delete_1(redist)
    TYPE(xt_redist), INTENT(inout) :: redist
    CALL xt_redist_delete_c(redist%cptr)
    redist%cptr = c_null_ptr
  END SUBROUTINE xt_redist_delete_1

  SUBROUTINE xt_redist_delete_a1d(redists)
    TYPE(xt_redist), INTENT(inout) :: redists(:)
    INTEGER :: i, n
    n = SIZE(redists)
    DO i = 1, n
      CALL xt_redist_delete_c(redists(i)%cptr)
      redists(i)%cptr = c_null_ptr
    END DO
  END SUBROUTINE xt_redist_delete_a1d

  FUNCTION xt_redist_get_num_send_msg(redist) RESULT(num_send_msg)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER :: num_send_msg
    INTEGER(c_int) :: n
    n = xt_redist_get_num_send_msg_c(redist%cptr)
    IF (n > HUGE(num_send_msg) .OR. n < -HUGE(num_send_msg)) &
         CALL xt_abort("num_send_msg out of bounds", filename, __LINE__)
    num_send_msg = INT(n)
  END FUNCTION xt_redist_get_num_send_msg

  FUNCTION xt_redist_get_num_recv_msg(redist) RESULT(num_recv_msg)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER :: num_recv_msg
    INTEGER(c_int) :: n
    n = xt_redist_get_num_recv_msg_c(redist%cptr)
    IF (n > HUGE(num_recv_msg) .OR. n < -HUGE(num_recv_msg)) &
         CALL xt_abort("num_recv_msg out of bounds", filename, __LINE__)
    num_recv_msg = INT(n)
  END FUNCTION xt_redist_get_num_recv_msg

  SUBROUTINE xt_redist_s_exchange1(redist, src_data_cptr, dst_data_cptr)
    TYPE(xt_redist), INTENT(in) :: redist
    TYPE(c_ptr), INTENT(in) :: src_data_cptr, dst_data_cptr
    INTERFACE
      SUBROUTINE xt_redist_s_exchange1_c(redist, src_data_cptr, dst_data_cptr) &
           BIND(C, name='xt_redist_s_exchange1')
        IMPORT:: c_ptr
        TYPE(c_ptr), VALUE, INTENT(in) :: redist
        TYPE(c_ptr), VALUE :: src_data_cptr, dst_data_cptr
      END SUBROUTINE xt_redist_s_exchange1_c
    END INTERFACE
    CALL xt_redist_s_exchange1_c(redist%cptr, src_data_cptr, dst_data_cptr)
  END SUBROUTINE xt_redist_s_exchange1

  SUBROUTINE xt_redist_a_exchange1(redist, src_data_cptr, dst_data_cptr, &
       request)
    TYPE(xt_redist), INTENT(in) :: redist
    TYPE(c_ptr) :: src_data_cptr, dst_data_cptr
    TYPE(xt_request), INTENT(out) :: request
    INTERFACE
      SUBROUTINE xt_redist_a_exchange1_c(redist, src_data_cptr, &
           dst_data_cptr, request_c) BIND(C, name='xt_redist_a_exchange1')
        IMPORT:: c_ptr, xt_request
        TYPE(c_ptr), VALUE, INTENT(in) :: redist
        TYPE(c_ptr), VALUE :: src_data_cptr, dst_data_cptr
        TYPE(xt_request), INTENT(out) :: request_c
      END SUBROUTINE xt_redist_a_exchange1_c
    END INTERFACE
    CALL xt_redist_a_exchange1_c(redist%cptr, src_data_cptr, &
         & dst_data_cptr, request)
  END SUBROUTINE xt_redist_a_exchange1

  SUBROUTINE xt_redist_s_exchange_a1d(redist, src_data_cptr, dst_data_cptr)
    TYPE(xt_redist), INTENT(in) :: redist
    TYPE(c_ptr), INTENT(in) :: src_data_cptr(:), dst_data_cptr(:)
    INTEGER :: n
    INTEGER(c_int) :: num_ptr_c
#if __INTEL_COMPILER == 1910 && __INTEL_COMPILER_UPDATE == 2
    TYPE(c_ptr) :: contig_src_data_cptr(SIZE(src_data_cptr)), &
         contig_dst_data_cptr(SIZE(dst_data_cptr))
    contig_src_data_cptr = src_data_cptr
    contig_dst_data_cptr = dst_data_cptr
#endif
    n = SIZE(src_data_cptr)
    IF (n /= SIZE(dst_data_cptr) .OR. n > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of pointers", filename, __LINE__)
    num_ptr_c = INT(n, c_int)
#if __INTEL_COMPILER == 1910 && __INTEL_COMPILER_UPDATE == 2
    CALL xt_redist_s_exchange_c(redist%cptr, num_ptr_c, &
         contig_src_data_cptr, contig_dst_data_cptr)
#else
    CALL xt_redist_s_exchange_c(redist%cptr, num_ptr_c, &
         src_data_cptr, dst_data_cptr)
#endif
  END SUBROUTINE xt_redist_s_exchange_a1d

  SUBROUTINE xt_redist_a_exchange_a1d(redist, src_data_cptr, dst_data_cptr, &
       request)
    TYPE(xt_redist), INTENT(in) :: redist
    TYPE(c_ptr), INTENT(in) :: src_data_cptr(:), dst_data_cptr(:)
    TYPE(xt_request), INTENT(out) :: request
    INTEGER :: num_ptr
    INTEGER(c_int) :: num_ptr_c
#if __INTEL_COMPILER == 1910 && __INTEL_COMPILER_UPDATE == 2
    TYPE(c_ptr) :: contig_src_data_cptr(SIZE(src_data_cptr)), &
         contig_dst_data_cptr(SIZE(dst_data_cptr))
    contig_src_data_cptr = src_data_cptr
    contig_dst_data_cptr = dst_data_cptr
#endif
    num_ptr = SIZE(src_data_cptr)
    IF (num_ptr /= SIZE(dst_data_cptr) .OR. num_ptr > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of pointers", filename, __LINE__)
    num_ptr_c = INT(num_ptr, c_int)
#if __INTEL_COMPILER == 1910 && __INTEL_COMPILER_UPDATE == 2
    CALL xt_redist_a_exchange_c(redist%cptr, num_ptr_c, &
         contig_src_data_cptr, contig_dst_data_cptr, request)
#else
    CALL xt_redist_a_exchange_c(redist%cptr, num_ptr_c, &
         src_data_cptr, dst_data_cptr, request)
#endif
  END SUBROUTINE xt_redist_a_exchange_a1d

  SUBROUTINE xt_redist_s_exchange_i2_a1d(redist, num_ptr, &
       src_data_cptr, dst_data_cptr)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i2), INTENT(in) :: num_ptr
    TYPE(c_ptr), INTENT(in) :: src_data_cptr(num_ptr), dst_data_cptr(num_ptr)
    INTEGER(c_int) :: num_ptr_c
    IF (num_ptr < 0_i2) &
         CALL xt_abort("invalid number of pointers", filename, __LINE__)
    num_ptr_c = INT(num_ptr, c_int)
    CALL xt_redist_s_exchange_c(redist%cptr, num_ptr_c, &
         src_data_cptr, dst_data_cptr)
  END SUBROUTINE xt_redist_s_exchange_i2_a1d

  SUBROUTINE xt_redist_a_exchange_i2_a1d(redist, num_ptr, &
       src_data_cptr, dst_data_cptr, request)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i2), INTENT(in) :: num_ptr
    TYPE(xt_request), INTENT(out) :: request
    TYPE(c_ptr), INTENT(in) :: src_data_cptr(num_ptr), dst_data_cptr(num_ptr)
    INTEGER(c_int) :: num_ptr_c
    IF (num_ptr < 0_i2) &
         CALL xt_abort("invalid number of pointers", filename, __LINE__)
    num_ptr_c = INT(num_ptr, c_int)
    CALL xt_redist_a_exchange_c(redist%cptr, num_ptr_c, &
         src_data_cptr, dst_data_cptr, request)
  END SUBROUTINE xt_redist_a_exchange_i2_a1d

  SUBROUTINE xt_redist_s_exchange_i4_a1d(redist, num_ptr, &
       src_data_cptr, dst_data_cptr)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i4), INTENT(in) :: num_ptr
    TYPE(c_ptr), INTENT(in) :: src_data_cptr(num_ptr), dst_data_cptr(num_ptr)
    INTEGER(c_int) :: num_ptr_c
    IF (num_ptr < 0_i4 .OR. num_ptr > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of pointers", filename, __LINE__)
    num_ptr_c = INT(num_ptr, c_int)
    CALL xt_redist_s_exchange_c(redist%cptr, num_ptr_c, &
         src_data_cptr, dst_data_cptr)
  END SUBROUTINE xt_redist_s_exchange_i4_a1d

  SUBROUTINE xt_redist_a_exchange_i4_a1d(redist, num_ptr, &
       src_data_cptr, dst_data_cptr, request)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i4), INTENT(in) :: num_ptr
    TYPE(xt_request), INTENT(out) :: request
    TYPE(c_ptr), INTENT(in) :: src_data_cptr(num_ptr), dst_data_cptr(num_ptr)
    INTEGER(c_int) :: num_ptr_c
    IF (num_ptr < 0_i4 .OR. num_ptr > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of pointers", filename, __LINE__)
    num_ptr_c = INT(num_ptr, c_int)
    CALL xt_redist_a_exchange_c(redist%cptr, num_ptr_c, &
         src_data_cptr, dst_data_cptr, request)
  END SUBROUTINE  xt_redist_a_exchange_i4_a1d

  SUBROUTINE xt_redist_s_exchange_i8_a1d(redist, num_ptr, &
       src_data_cptr, dst_data_cptr)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), INTENT(in) :: num_ptr
    TYPE(c_ptr), INTENT(in) :: src_data_cptr(num_ptr), dst_data_cptr(num_ptr)
    INTEGER(c_int) :: num_ptr_c
    IF (num_ptr < 0_i8 .OR. num_ptr > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of pointers", filename, __LINE__)
    num_ptr_c = INT(num_ptr, c_int)
    CALL xt_redist_s_exchange_c(redist%cptr, num_ptr_c, &
         src_data_cptr, dst_data_cptr)
  END SUBROUTINE xt_redist_s_exchange_i8_a1d

  SUBROUTINE xt_redist_a_exchange_i8_a1d(redist, num_ptr, &
       src_data_cptr, dst_data_cptr, request)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(i8), INTENT(in) :: num_ptr
    TYPE(xt_request), INTENT(out) :: request
    TYPE(c_ptr), INTENT(in) :: src_data_cptr(num_ptr), dst_data_cptr(num_ptr)
    INTEGER(c_int) :: num_ptr_c
    IF (num_ptr < 0_i8 .OR. num_ptr > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of pointers", filename, __LINE__)
    num_ptr_c = INT(num_ptr, c_int)
    CALL xt_redist_a_exchange_c(redist%cptr, num_ptr_c, &
         src_data_cptr, dst_data_cptr, request)
  END SUBROUTINE xt_redist_a_exchange_i8_a1d

  FUNCTION xt_redist_p2p_new(xmap, datatype) RESULT(res)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_redist) :: res
    INTERFACE
      FUNCTION xt_redist_p2p_new_f(xmap, datatype) &
           BIND(C, name='xt_redist_p2p_new_f') RESULT(res_ptr)
        IMPORT:: xt_xmap, xt_redist, c_int, c_ptr, xt_mpi_fint_kind
        IMPLICIT NONE
        TYPE(xt_xmap), INTENT(in) :: xmap
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: datatype
        TYPE(c_ptr) :: res_ptr
      END FUNCTION xt_redist_p2p_new_f
    END INTERFACE
    res%cptr = xt_redist_p2p_new_f(xmap, datatype)
  END FUNCTION xt_redist_p2p_new

  FUNCTION xt_redist_p2p_custom_new(xmap, datatype, config) RESULT(res)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res
    INTERFACE
      FUNCTION xt_redist_p2p_custom_new_f(xmap, datatype, config) &
           BIND(C, name='xt_redist_p2p_custom_new_f') RESULT(res_ptr)
        IMPORT:: xt_xmap, xt_redist, c_ptr, xt_mpi_fint_kind, xt_config
        IMPLICIT NONE
        TYPE(xt_xmap), INTENT(in) :: xmap
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: datatype
        TYPE(xt_config), INTENT(in) :: config
        TYPE(c_ptr) :: res_ptr
      END FUNCTION xt_redist_p2p_custom_new_f
    END INTERFACE
    res%cptr = xt_redist_p2p_custom_new_f(xmap, datatype, config)
  END FUNCTION xt_redist_p2p_custom_new

  FUNCTION xt_redist_p2p_off_new(xmap, src_offsets, dst_offsets, datatype) &
       RESULT(res)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER, INTENT(in) :: src_offsets(*), dst_offsets(*)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_redist) :: res
    INTERFACE
      FUNCTION xt_redist_p2p_off_new_f(xmap, src_offsets, dst_offsets, &
           datatype) BIND(C, name='xt_redist_p2p_off_new_f') RESULT(res_ptr)
        IMPORT :: xt_xmap, xt_redist, c_ptr, xt_mpi_fint_kind
        IMPLICIT NONE
        TYPE(xt_xmap), INTENT(in) :: xmap
        INTEGER(xt_mpi_fint_kind), INTENT(in) :: src_offsets(*), dst_offsets(*)
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: datatype
        TYPE(c_ptr) :: res_ptr
      END FUNCTION xt_redist_p2p_off_new_f
    END INTERFACE
    res%cptr = xt_redist_p2p_off_new_f(xmap, src_offsets, dst_offsets, datatype)
  END FUNCTION xt_redist_p2p_off_new

  FUNCTION xt_redist_p2p_off_custom_new(xmap, src_offsets, dst_offsets, &
       datatype, config) RESULT(res)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER, INTENT(in) :: src_offsets(*), dst_offsets(*)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res
    INTERFACE
      FUNCTION xt_redist_p2p_off_custom_new_f(xmap, src_offsets, dst_offsets, &
           datatype, config) BIND(C, name='xt_redist_p2p_off_custom_new_f') &
           RESULT(res_ptr)
        IMPORT :: xt_xmap, xt_redist, c_ptr, xt_mpi_fint_kind, xt_config
        IMPLICIT NONE
        TYPE(xt_xmap), INTENT(in) :: xmap
        INTEGER(xt_mpi_fint_kind), INTENT(in) :: src_offsets(*), dst_offsets(*)
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: datatype
        TYPE(xt_config), INTENT(in) :: config
        TYPE(c_ptr) :: res_ptr
      END FUNCTION xt_redist_p2p_off_custom_new_f
    END INTERFACE
    res%cptr = xt_redist_p2p_off_custom_new_f(xmap, src_offsets, dst_offsets, &
         datatype, config)
  END FUNCTION xt_redist_p2p_off_custom_new

  FUNCTION xt_redist_p2p_blocks_new(xmap, src_block_sizes, src_block_num, &
       &                                  dst_block_sizes, dst_block_num, &
       &                                  datatype) &
       RESULT(res)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(c_int), INTENT(in) :: src_block_sizes(*), src_block_num, &
         dst_block_sizes(*), dst_block_num
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_redist) :: res
    INTERFACE
      FUNCTION xt_redist_p2p_blocks_new_f(xmap, &
           &                              src_block_sizes, src_block_num, &
           &                              dst_block_sizes, dst_block_num, &
           &                              datatype) &
           BIND(C, name='xt_redist_p2p_blocks_new_f') RESULT(res_ptr)
        IMPORT :: xt_xmap, xt_mpi_fint_kind, xt_redist, c_int, c_ptr
        IMPLICIT NONE
        TYPE(xt_xmap), INTENT(in) :: xmap
        INTEGER(c_int), VALUE, INTENT(in) :: src_block_num, dst_block_num
        INTEGER(c_int), INTENT(in) :: src_block_sizes(*), dst_block_sizes(*)
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: datatype
        TYPE(c_ptr) :: res_ptr
      END FUNCTION xt_redist_p2p_blocks_new_f
    END INTERFACE
    res%cptr = xt_redist_p2p_blocks_new_f(xmap, &
         &                                src_block_sizes, src_block_num, &
         &                                dst_block_sizes, dst_block_num, &
         &                                datatype)
  END FUNCTION xt_redist_p2p_blocks_new

  FUNCTION xt_redist_p2p_blocks_custom_new(xmap, src_block_sizes, &
       &                                   src_block_num, &
       &                                   dst_block_sizes, dst_block_num, &
       &                                   datatype, config) &
       RESULT(res)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(c_int), INTENT(in) :: src_block_sizes(*), src_block_num, &
         dst_block_sizes(*), dst_block_num
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res
    INTERFACE
      FUNCTION xt_redist_p2p_blocks_custom_new_f(xmap, &
           &                              src_block_sizes, src_block_num, &
           &                              dst_block_sizes, dst_block_num, &
           &                              datatype, config) &
           BIND(C, name='xt_redist_p2p_blocks_custom_new_f') RESULT(res_ptr)
        IMPORT :: xt_xmap, xt_mpi_fint_kind, xt_redist, c_int, c_ptr, xt_config
        IMPLICIT NONE
        TYPE(xt_xmap), INTENT(in) :: xmap
        INTEGER(c_int), VALUE, INTENT(in) :: src_block_num, dst_block_num
        INTEGER(c_int), INTENT(in) :: src_block_sizes(*), dst_block_sizes(*)
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: datatype
        TYPE(xt_config), INTENT(in) :: config
        TYPE(c_ptr) :: res_ptr
      END FUNCTION xt_redist_p2p_blocks_custom_new_f
    END INTERFACE
    res%cptr = xt_redist_p2p_blocks_custom_new_f(xmap, &
         &  src_block_sizes, src_block_num, &
         &  dst_block_sizes, dst_block_num, datatype, config)
  END FUNCTION xt_redist_p2p_blocks_custom_new

  FUNCTION xt_redist_p2p_blocks_off_new(xmap, src_block_offsets, &
       src_block_sizes, src_block_num, &
       dst_block_offsets, dst_block_sizes, dst_block_num, &
       datatype) RESULT(res)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(c_int), INTENT(in) :: src_block_offsets(*)
    INTEGER(c_int), INTENT(in) :: src_block_sizes(*)
    INTEGER(c_int), VALUE, INTENT(in) :: src_block_num
    INTEGER(c_int), INTENT(in) :: dst_block_offsets(*)
    INTEGER(c_int), INTENT(in) :: dst_block_sizes(*)
    INTEGER(c_int), VALUE, INTENT(in) :: dst_block_num
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_redist) :: res
    INTERFACE
      FUNCTION xt_redist_p2p_blocks_off_new_f(xmap, src_block_offsets, &
           src_block_sizes, src_block_num, &
           dst_block_offsets, dst_block_sizes, dst_block_num, &
           datatype) BIND(C, name='xt_redist_p2p_blocks_off_new_f') &
           RESULT(res_ptr)
        IMPORT :: xt_xmap, xt_redist, xt_mpi_fint_kind, c_int, c_ptr
        IMPLICIT NONE
        TYPE(xt_xmap), INTENT(in) :: xmap
        INTEGER(c_int), INTENT(in) :: src_block_offsets(*), src_block_sizes(*),&
             dst_block_offsets(*), dst_block_sizes(*)
        INTEGER(c_int), VALUE, INTENT(in) :: src_block_num, dst_block_num
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: datatype
        TYPE(c_ptr) :: res_ptr
      END FUNCTION xt_redist_p2p_blocks_off_new_f
    END INTERFACE
    res%cptr = xt_redist_p2p_blocks_off_new_f(xmap, src_block_offsets, &
         src_block_sizes, src_block_num, &
         dst_block_offsets, dst_block_sizes, dst_block_num, datatype)
  END FUNCTION xt_redist_p2p_blocks_off_new

  FUNCTION xt_redist_p2p_blocks_off_custom_new(xmap, src_block_offsets, &
       src_block_sizes, src_block_num, &
       dst_block_offsets, dst_block_sizes, dst_block_num, &
       datatype, config) RESULT(res)
    IMPLICIT NONE
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(c_int), INTENT(in) :: src_block_offsets(*), src_block_sizes(*), &
         dst_block_offsets(*), dst_block_sizes(*)
    INTEGER(c_int), INTENT(in) :: src_block_num, dst_block_num
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res
    INTERFACE
      FUNCTION xt_redist_p2p_blocks_off_custom_new_f(xmap, src_block_offsets, &
           src_block_sizes, src_block_num, &
           dst_block_offsets, dst_block_sizes, dst_block_num, &
           datatype, config) &
           BIND(C, name='xt_redist_p2p_blocks_off_custom_new_f') RESULT(res_ptr)
        IMPORT :: xt_xmap, xt_redist, xt_mpi_fint_kind, c_int, c_ptr, xt_config
        IMPLICIT NONE
        TYPE(xt_xmap), INTENT(in) :: xmap
        INTEGER(c_int), INTENT(in) :: src_block_offsets(*), src_block_sizes(*),&
             dst_block_offsets(*), dst_block_sizes(*)
        INTEGER(c_int), VALUE, INTENT(in) :: src_block_num
        INTEGER(c_int), VALUE, INTENT(in) :: dst_block_num
        INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: datatype
        TYPE(xt_config), INTENT(in) :: config
        TYPE(c_ptr) :: res_ptr
      END FUNCTION xt_redist_p2p_blocks_off_custom_new_f
    END INTERFACE

    res%cptr = xt_redist_p2p_blocks_off_custom_new_f(xmap, &
         src_block_offsets, src_block_sizes, src_block_num, &
         dst_block_offsets, dst_block_sizes, dst_block_num, &
         datatype, config)
  END FUNCTION xt_redist_p2p_blocks_off_custom_new

  FUNCTION xt_redist_collection_static_new_a_i_2ak_i(redists, num_redists, &
       src_displacements, dst_displacements, comm) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redists(*)
    INTEGER, INTENT(in) :: num_redists, comm
    INTEGER(mpi_address_kind), INTENT(in) :: src_displacements(*), &
         dst_displacements(*)
    TYPE(xt_redist) :: res
    INTEGER(c_int) :: num_redists_c
    num_redists_c = INT(num_redists, c_int)
    res%cptr = xt_redist_collection_static_new_f(redists, &
         num_redists_c, src_displacements, dst_displacements, comm)
  END FUNCTION xt_redist_collection_static_new_a_i_2ak_i

  FUNCTION xt_redist_collection_static_new_a_i_2ak_i_cfg(redists, num_redists, &
       src_displacements, dst_displacements, comm, config) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redists(*)
    INTEGER, INTENT(in) :: num_redists, comm
    INTEGER(mpi_address_kind), INTENT(in) :: src_displacements(*), &
         dst_displacements(*)
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res
    INTEGER(c_int) :: num_redists_c
    num_redists_c = INT(num_redists, c_int)
    res%cptr = xt_redist_collection_static_custom_new_f(redists, &
         num_redists_c, src_displacements, dst_displacements, comm, config)
  END FUNCTION xt_redist_collection_static_new_a_i_2ak_i_cfg

  FUNCTION xt_redist_collection_static_new_a_2ak_i(redists, &
       src_displacements, dst_displacements, comm) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redists(:)
    INTEGER, INTENT(in) :: comm
    INTEGER(mpi_address_kind), INTENT(in) :: src_displacements(:), &
         dst_displacements(:)
    TYPE(xt_redist) :: res
    INTEGER :: num_redists
    num_redists = SIZE(redists)
    IF (num_redists /= SIZE(src_displacements) &
         .OR. num_redists /= SIZE(dst_displacements)) &
         CALL xt_abort("invalid number of redists", filename, __LINE__)
    res%cptr = xt_redist_collection_static_new_f(redists, &
         num_redists, src_displacements, dst_displacements, comm)
  END FUNCTION xt_redist_collection_static_new_a_2ak_i

  FUNCTION xt_redist_collection_static_new_a_2ak_i_cfg(redists, &
       src_displacements, dst_displacements, comm, config) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redists(:)
    INTEGER, INTENT(in) :: comm
    INTEGER(mpi_address_kind), INTENT(in) :: src_displacements(:), &
         dst_displacements(:)
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res
    INTEGER :: num_redists
    num_redists = SIZE(redists)
    IF (num_redists /= SIZE(src_displacements) &
         .OR. num_redists /= SIZE(dst_displacements)) &
         CALL xt_abort("invalid number of redists", filename, __LINE__)
    res%cptr = xt_redist_collection_static_custom_new_f(redists, &
         num_redists, src_displacements, dst_displacements, comm, config)
  END FUNCTION xt_redist_collection_static_new_a_2ak_i_cfg

  FUNCTION xt_redist_collection_new_a_3i(redists, num_redists, cache_size, &
       comm) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redists(*)
    INTEGER, INTENT(in) :: num_redists, cache_size, comm
    TYPE(xt_redist) :: res
    res%cptr = xt_redist_collection_new_f(redists, num_redists, &
         cache_size, comm)
  END FUNCTION xt_redist_collection_new_a_3i

  FUNCTION xt_redist_collection_new_a_3i_cfg(redists, num_redists, cache_size, &
       comm, config) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redists(*)
    INTEGER, INTENT(in) :: num_redists, cache_size, comm
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res
    res%cptr = xt_redist_collection_custom_new_f(redists, num_redists,&
         cache_size, comm, config)
  END FUNCTION xt_redist_collection_new_a_3i_cfg

  FUNCTION xt_redist_collection_new_a_2i(redists, cache_size, comm) &
       RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redists(:)
    INTEGER, INTENT(in) :: cache_size, comm
    TYPE(xt_redist) :: res
    INTEGER :: num_redists
    num_redists = SIZE(redists)
    res%cptr = xt_redist_collection_new_f(redists, &
         num_redists, cache_size, comm)
  END FUNCTION xt_redist_collection_new_a_2i

  FUNCTION xt_redist_collection_new_a_2i_cfg(redists, cache_size, comm, &
       config) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redists(:)
    INTEGER, INTENT(in) :: cache_size, comm
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res
    INTEGER :: num_redists
    num_redists = SIZE(redists)
    res%cptr = xt_redist_collection_custom_new_f(redists, &
         num_redists, cache_size, comm, config)
  END FUNCTION xt_redist_collection_new_a_2i_cfg

  FUNCTION xt_redist_collection_new_a_i(redists, comm) &
       RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redists(:)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_redist) :: res

    res = xt_redist_collection_new_a_3i(redists, SIZE(redists), -1, comm)
  END FUNCTION xt_redist_collection_new_a_i

  FUNCTION xt_redist_collection_new_a_i_cfg(redists, comm, config) &
       RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redists(:)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res

    res = xt_redist_collection_new_a_3i_cfg(redists, SIZE(redists), &
         &-1, comm, config)
  END FUNCTION xt_redist_collection_new_a_i_cfg


  FUNCTION xt_redist_repeat_new_i4_a1d(redist, src_extent, dst_extent, &
       num_repetitions, displacements) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(mpi_address_kind), INTENT(in) :: src_extent, dst_extent
    INTEGER(i4), INTENT(in) :: num_repetitions
    INTEGER(c_int), INTENT(in) :: displacements(num_repetitions)
    TYPE(xt_redist) :: res
    INTEGER(c_int) :: num_repetitions_c
    num_repetitions_c = INT(num_repetitions, c_int)
    res%cptr = xt_redist_repeat_new_c(redist%cptr, &
         src_extent, dst_extent, num_repetitions_c, displacements)
  END FUNCTION xt_redist_repeat_new_i4_a1d

  FUNCTION xt_redist_repeat_new_i4_a1d_cfg(redist, src_extent, dst_extent, &
       num_repetitions, displacements, config) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(mpi_address_kind), INTENT(in) :: src_extent, dst_extent
    INTEGER(i4), INTENT(in) :: num_repetitions
    INTEGER(c_int), INTENT(in) :: displacements(num_repetitions)
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res
    INTEGER(c_int) :: num_repetitions_c
    num_repetitions_c = INT(num_repetitions, c_int)
    res%cptr = xt_redist_repeat_custom_new_c(redist%cptr, &
         src_extent, dst_extent, num_repetitions_c, displacements, &
         xt_config_f2c(config))
  END FUNCTION xt_redist_repeat_new_i4_a1d_cfg

  FUNCTION xt_redist_repeat_new_a1d(redist, src_extent, dst_extent, &
       displacements) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(mpi_address_kind), INTENT(in) :: src_extent, dst_extent
    INTEGER(c_int), INTENT(in) :: displacements(:)
    TYPE(xt_redist) :: res
    INTEGER(c_int) :: num_repetitions_c
    num_repetitions_c = INT(SIZE(displacements), c_int)
    res%cptr = xt_redist_repeat_new_c(redist%cptr, &
         src_extent, dst_extent, num_repetitions_c, displacements)
  END FUNCTION xt_redist_repeat_new_a1d

  FUNCTION xt_redist_repeat_new_a1d_cfg(redist, src_extent, dst_extent, &
       displacements, config) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(mpi_address_kind), INTENT(in) :: src_extent, dst_extent
    INTEGER(c_int), INTENT(in) :: displacements(:)
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res
    INTEGER(c_int) :: num_repetitions_c
    num_repetitions_c = INT(SIZE(displacements), c_int)
    res%cptr = xt_redist_repeat_custom_new_c(redist%cptr, &
         src_extent, dst_extent, num_repetitions_c, displacements, &
         xt_config_f2c(config))
  END FUNCTION xt_redist_repeat_new_a1d_cfg

  FUNCTION xt_redist_repeat_asym_new_i4_a1d(redist, src_extent, dst_extent, &
       num_repetitions, src_displacements, dst_displacements) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(mpi_address_kind), INTENT(in) :: src_extent, dst_extent
    INTEGER(i4), INTENT(in) :: num_repetitions
    INTEGER(c_int), INTENT(in) :: src_displacements(num_repetitions), &
         & dst_displacements(num_repetitions)
    TYPE(xt_redist) :: res
    INTEGER(c_int) :: num_repetitions_c
    num_repetitions_c = INT(num_repetitions, c_int)
    res%cptr = xt_redist_repeat_asym_new_c(redist%cptr, &
         src_extent, dst_extent, num_repetitions_c, src_displacements, &
         dst_displacements)
  END FUNCTION xt_redist_repeat_asym_new_i4_a1d

  FUNCTION xt_redist_repeat_asym_new_i4_a1d_cfg(redist, src_extent, dst_extent,&
       num_repetitions, src_displacements, dst_displacements, config) &
       RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(mpi_address_kind), INTENT(in) :: src_extent, dst_extent
    INTEGER(i4), INTENT(in) :: num_repetitions
    INTEGER(c_int), INTENT(in) :: src_displacements(num_repetitions), &
         & dst_displacements(num_repetitions)
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res
    INTEGER(c_int) :: num_repetitions_c
    num_repetitions_c = INT(num_repetitions, c_int)
    res%cptr = xt_redist_repeat_asym_custom_new_c(redist%cptr, &
         src_extent, dst_extent, num_repetitions_c, src_displacements, &
         dst_displacements, xt_config_f2c(config))
  END FUNCTION xt_redist_repeat_asym_new_i4_a1d_cfg

  FUNCTION xt_redist_repeat_asym_new_a1d(redist, src_extent, dst_extent, &
       src_displacements, dst_displacements) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(mpi_address_kind), INTENT(in) :: src_extent, dst_extent
    INTEGER(c_int), INTENT(in) :: src_displacements(:), dst_displacements(:)
    TYPE(xt_redist) :: res
    INTEGER(i4) :: num_repetitions
    num_repetitions = SIZE(src_displacements)
    IF (num_repetitions /= SIZE(dst_displacements)) &
         CALL xt_abort("inequal size for src and dst displacements", &
         filename, __LINE__)
    res%cptr = xt_redist_repeat_asym_new_c(redist%cptr, &
         src_extent, dst_extent, num_repetitions, src_displacements, &
         dst_displacements)
  END FUNCTION xt_redist_repeat_asym_new_a1d

  FUNCTION xt_redist_repeat_asym_new_a1d_cfg(redist, src_extent, dst_extent, &
       src_displacements, dst_displacements, config) RESULT(res)
    TYPE(xt_redist), INTENT(in) :: redist
    INTEGER(mpi_address_kind), INTENT(in) :: src_extent, dst_extent
    INTEGER(c_int), INTENT(in) :: src_displacements(:), dst_displacements(:)
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: res
    INTEGER(i4) :: num_repetitions
    num_repetitions = SIZE(src_displacements)
    IF (num_repetitions /= SIZE(dst_displacements)) &
         CALL xt_abort("inequal size for src and dst displacements", &
         filename, __LINE__)
    res%cptr = xt_redist_repeat_asym_custom_new_c(redist%cptr, &
         src_extent, dst_extent, num_repetitions, src_displacements, &
         dst_displacements, xt_config_f2c(config))
  END FUNCTION xt_redist_repeat_asym_new_a1d_cfg

  FUNCTION xt_redist_p2p_ext_new_i2_a1d_i2_a1d(xmap, num_src_ext, src_extents, &
       num_dst_ext, dst_extents, datatype) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i2), INTENT(in) :: num_src_ext, num_dst_ext
    TYPE(xt_offset_ext), INTENT(in) :: src_extents(num_src_ext), &
         dst_extents(num_dst_ext)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_redist) :: redist
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    IF (num_src_ext < 0_i2 .OR. num_src_ext > HUGE(1_c_int) &
         .OR. num_dst_ext < 0_i2 .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_ext_new_c2f(xmap, &
         num_src_ext_c, src_extents, num_dst_ext_c, dst_extents, datatype)
  END FUNCTION xt_redist_p2p_ext_new_i2_a1d_i2_a1d

  FUNCTION xt_redist_p2p_ext_new_i2_a1d_i2_a1d_cfg(xmap, num_src_ext, &
       src_extents, num_dst_ext, dst_extents, datatype, config) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i2), INTENT(in) :: num_src_ext, num_dst_ext
    TYPE(xt_offset_ext), INTENT(in) :: src_extents(num_src_ext), &
         dst_extents(num_dst_ext)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: redist
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    IF (num_src_ext < 0_i2 .OR. num_src_ext > HUGE(1_c_int) &
         .OR. num_dst_ext < 0_i2 .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_ext_custom_new_c2f(xmap, num_src_ext_c, &
         src_extents, num_dst_ext_c, dst_extents, datatype, config)
  END FUNCTION xt_redist_p2p_ext_new_i2_a1d_i2_a1d_cfg

  FUNCTION xt_redist_p2p_ext_new_i4_a1d_i4_a1d(xmap, num_src_ext, src_extents, &
       num_dst_ext, dst_extents, datatype) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i4), INTENT(in) :: num_src_ext, num_dst_ext
    TYPE(xt_offset_ext), INTENT(in) :: src_extents(num_src_ext), &
         dst_extents(num_dst_ext)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_redist) :: redist
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    IF (num_src_ext < 0_i4 .OR. num_src_ext > HUGE(1_c_int) &
         .OR. num_dst_ext < 0_i4 .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_ext_new_c2f(xmap, num_src_ext_c, &
         src_extents, num_dst_ext_c, dst_extents, datatype)
  END FUNCTION xt_redist_p2p_ext_new_i4_a1d_i4_a1d

  FUNCTION xt_redist_p2p_ext_new_i4_a1d_i4_a1d_cfg(xmap, num_src_ext, &
       src_extents, num_dst_ext, dst_extents, datatype, config) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i4), INTENT(in) :: num_src_ext, num_dst_ext
    TYPE(xt_offset_ext), INTENT(in) :: src_extents(num_src_ext), &
         dst_extents(num_dst_ext)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: redist
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    IF (num_src_ext < 0_i4 .OR. num_src_ext > HUGE(1_c_int) &
         .OR. num_dst_ext < 0_i4 .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_ext_custom_new_c2f(xmap, &
         num_src_ext_c, src_extents, num_dst_ext_c, dst_extents, datatype, &
         config)
  END FUNCTION xt_redist_p2p_ext_new_i4_a1d_i4_a1d_cfg

  FUNCTION xt_redist_p2p_ext_new_i8_a1d_i8_a1d(xmap, num_src_ext, src_extents, &
       num_dst_ext, dst_extents, datatype) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i8), INTENT(in) :: num_src_ext, num_dst_ext
    TYPE(xt_offset_ext), INTENT(in) :: src_extents(num_src_ext), &
         dst_extents(num_dst_ext)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_redist) :: redist
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    IF (num_src_ext < 0_i8 .OR. num_src_ext > HUGE(1_c_int) &
         .OR. num_dst_ext < 0_i8 .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_ext_new_c2f(xmap, num_src_ext_c, &
         src_extents, num_dst_ext_c, dst_extents, datatype)
  END FUNCTION xt_redist_p2p_ext_new_i8_a1d_i8_a1d

  FUNCTION xt_redist_p2p_ext_new_i8_a1d_i8_a1d_cfg(xmap, num_src_ext, &
       src_extents, num_dst_ext, dst_extents, datatype, config) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i8), INTENT(in) :: num_src_ext, num_dst_ext
    TYPE(xt_offset_ext), INTENT(in) :: src_extents(num_src_ext), &
         dst_extents(num_dst_ext)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: redist
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    IF (num_src_ext < 0_i8 .OR. num_src_ext > HUGE(1_c_int) &
         .OR. num_dst_ext < 0_i8 .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_ext_custom_new_c2f(xmap, num_src_ext_c, &
         src_extents, num_dst_ext_c, dst_extents, datatype, config)
  END FUNCTION xt_redist_p2p_ext_new_i8_a1d_i8_a1d_cfg

  FUNCTION xt_redist_p2p_ext_new_a1d_a1d(xmap, src_extents, dst_extents, &
       datatype) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    TYPE(xt_offset_ext), INTENT(in) :: src_extents(:), dst_extents(:)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_redist) :: redist
    INTEGER :: num_src_ext, num_dst_ext
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    num_src_ext = SIZE(src_extents)
    num_dst_ext = SIZE(dst_extents)
    IF (num_src_ext > HUGE(1_c_int) .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_ext_new_c2f(xmap, num_src_ext_c, &
         src_extents, num_dst_ext_c, dst_extents, datatype)
  END FUNCTION xt_redist_p2p_ext_new_a1d_a1d

  FUNCTION xt_redist_p2p_ext_new_a1d_a1d_cfg(xmap, src_extents, dst_extents, &
       datatype, config) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    TYPE(xt_offset_ext), INTENT(in) :: src_extents(:), dst_extents(:)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: redist
    INTEGER :: num_src_ext, num_dst_ext
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    num_src_ext = SIZE(src_extents)
    num_dst_ext = SIZE(dst_extents)
    IF (num_src_ext > HUGE(1_c_int) .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_ext_custom_new_c2f(xmap, num_src_ext_c, &
         src_extents, num_dst_ext_c, dst_extents, datatype, config)
  END FUNCTION xt_redist_p2p_ext_new_a1d_a1d_cfg

  FUNCTION xt_redist_p2p_aext_new_i2_a1d_i2_a1d(xmap, num_src_ext, src_extents,&
       num_dst_ext, dst_extents, datatype) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i2), INTENT(in) :: num_src_ext, num_dst_ext
    TYPE(xt_aoffset_ext), INTENT(in) :: src_extents(num_src_ext), &
         dst_extents(num_dst_ext)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_redist) :: redist
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    IF (num_src_ext < 0_i2 .OR. num_src_ext > HUGE(1_c_int) &
         .OR. num_dst_ext < 0_i2 .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_aext_new_c2f(xmap, &
         num_src_ext_c, src_extents, num_dst_ext_c, dst_extents, datatype)
  END FUNCTION xt_redist_p2p_aext_new_i2_a1d_i2_a1d

  FUNCTION xt_redist_p2p_aext_new_i2_a1d_i2_a1d_cfg(xmap, num_src_ext, &
       src_extents, num_dst_ext, dst_extents, datatype, config) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i2), INTENT(in) :: num_src_ext, num_dst_ext
    TYPE(xt_aoffset_ext), INTENT(in) :: src_extents(num_src_ext), &
         dst_extents(num_dst_ext)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: redist
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    IF (num_src_ext < 0_i2 .OR. num_src_ext > HUGE(1_c_int) &
         .OR. num_dst_ext < 0_i2 .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_aext_custom_new_c2f(xmap, num_src_ext_c, &
         src_extents, num_dst_ext_c, dst_extents, datatype, config)
  END FUNCTION xt_redist_p2p_aext_new_i2_a1d_i2_a1d_cfg

  FUNCTION xt_redist_p2p_aext_new_i4_a1d_i4_a1d(xmap, num_src_ext, src_extents,&
       num_dst_ext, dst_extents, datatype) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i4), INTENT(in) :: num_src_ext, num_dst_ext
    TYPE(xt_aoffset_ext), INTENT(in) :: src_extents(num_src_ext), &
         dst_extents(num_dst_ext)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_redist) :: redist
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    IF (num_src_ext < 0_i4 .OR. num_src_ext > HUGE(1_c_int) &
         .OR. num_dst_ext < 0_i4 .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_aext_new_c2f(xmap, num_src_ext_c, &
         src_extents, num_dst_ext_c, dst_extents, datatype)
  END FUNCTION xt_redist_p2p_aext_new_i4_a1d_i4_a1d

  FUNCTION xt_redist_p2p_aext_new_i4_a1d_i4_a1d_cfg(xmap, num_src_ext, &
       src_extents, num_dst_ext, dst_extents, datatype, config) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i4), INTENT(in) :: num_src_ext, num_dst_ext
    TYPE(xt_aoffset_ext), INTENT(in) :: src_extents(num_src_ext), &
         dst_extents(num_dst_ext)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: redist
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    IF (num_src_ext < 0_i4 .OR. num_src_ext > HUGE(1_c_int) &
         .OR. num_dst_ext < 0_i4 .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_aext_custom_new_c2f(xmap, &
         num_src_ext_c, src_extents, num_dst_ext_c, dst_extents, datatype, &
         config)
  END FUNCTION xt_redist_p2p_aext_new_i4_a1d_i4_a1d_cfg

  FUNCTION xt_redist_p2p_aext_new_i8_a1d_i8_a1d(xmap, num_src_ext, src_extents,&
       num_dst_ext, dst_extents, datatype) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i8), INTENT(in) :: num_src_ext, num_dst_ext
    TYPE(xt_aoffset_ext), INTENT(in) :: src_extents(num_src_ext), &
         dst_extents(num_dst_ext)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_redist) :: redist
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    IF (num_src_ext < 0_i8 .OR. num_src_ext > HUGE(1_c_int) &
         .OR. num_dst_ext < 0_i8 .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_aext_new_c2f(xmap, num_src_ext_c, &
         src_extents, num_dst_ext_c, dst_extents, datatype)
  END FUNCTION xt_redist_p2p_aext_new_i8_a1d_i8_a1d

  FUNCTION xt_redist_p2p_aext_new_i8_a1d_i8_a1d_cfg(xmap, num_src_ext, &
       src_extents, num_dst_ext, dst_extents, datatype, config) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER(i8), INTENT(in) :: num_src_ext, num_dst_ext
    TYPE(xt_aoffset_ext), INTENT(in) :: src_extents(num_src_ext), &
         dst_extents(num_dst_ext)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: redist
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    IF (num_src_ext < 0_i8 .OR. num_src_ext > HUGE(1_c_int) &
         .OR. num_dst_ext < 0_i8 .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_aext_custom_new_c2f(xmap, num_src_ext_c, &
         src_extents, num_dst_ext_c, dst_extents, datatype, config)
  END FUNCTION xt_redist_p2p_aext_new_i8_a1d_i8_a1d_cfg

  FUNCTION xt_redist_p2p_aext_new_a1d_a1d(xmap, src_extents, dst_extents, &
       datatype) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    TYPE(xt_aoffset_ext), INTENT(in) :: src_extents(:), dst_extents(:)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_redist) :: redist
    INTEGER :: num_src_ext, num_dst_ext
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    num_src_ext = SIZE(src_extents)
    num_dst_ext = SIZE(dst_extents)
    IF (num_src_ext > HUGE(1_c_int) .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_aext_new_c2f(xmap, num_src_ext_c, &
         src_extents, num_dst_ext_c, dst_extents, datatype)
  END FUNCTION xt_redist_p2p_aext_new_a1d_a1d

  FUNCTION xt_redist_p2p_aext_new_a1d_a1d_cfg(xmap, src_extents, dst_extents, &
       datatype, config) RESULT(redist)
    TYPE(xt_xmap), INTENT(in) :: xmap
    TYPE(xt_aoffset_ext), INTENT(in) :: src_extents(:), dst_extents(:)
    INTEGER, INTENT(in) :: datatype
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: redist
    INTEGER :: num_src_ext, num_dst_ext
    INTEGER(c_int) :: num_src_ext_c, num_dst_ext_c
    num_src_ext = SIZE(src_extents)
    num_dst_ext = SIZE(dst_extents)
    IF (num_src_ext > HUGE(1_c_int) .OR. num_dst_ext > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of extents", filename, __LINE__)
    num_src_ext_c = INT(num_src_ext, c_int)
    num_dst_ext_c = INT(num_dst_ext, c_int)
    redist%cptr = xt_redist_p2p_aext_custom_new_c2f(xmap, num_src_ext_c, &
         src_extents, num_dst_ext_c, dst_extents, datatype, config)
  END FUNCTION xt_redist_p2p_aext_new_a1d_a1d_cfg

  FUNCTION xt_redist_single_array_base_new_i2_a1d_i2_a1d( &
       nsend, nrecv, send_msgs, recv_msgs, comm) RESULT(redist)
    INTEGER(i2), INTENT(in) :: nsend, nrecv
    TYPE(xt_redist_msg), TARGET, INTENT(in) :: &
         send_msgs(nsend), recv_msgs(nrecv)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_redist) :: redist

    INTEGER(c_int) :: nsend_c, nrecv_c
    TYPE(c_ptr) :: send_msgs_p, recv_msgs_p

    IF (nsend < 0_i2 .OR. nsend > HUGE(1_c_int) &
         .OR. nrecv < 0_i2 .OR. nrecv > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of send messages", filename, __LINE__)
    IF (nsend > 0_i2) THEN
      send_msgs_p = C_LOC(send_msgs)
    ELSE
      send_msgs_p = c_null_ptr
    END IF
    IF (nrecv > 0_i2) THEN
      recv_msgs_p = C_LOC(recv_msgs)
    ELSE
      recv_msgs_p = c_null_ptr
    END IF
    nsend_c = INT(nsend, c_int)
    nrecv_c = INT(nrecv, c_int)
    redist%cptr = xt_redist_single_array_base_new_c2f(&
         nsend_c, nrecv_c, send_msgs_p, recv_msgs_p, comm)
  END FUNCTION xt_redist_single_array_base_new_i2_a1d_i2_a1d

  FUNCTION xt_redist_single_array_base_new_i2_a1d_i2_a1d_cfg( &
       nsend, nrecv, send_msgs, recv_msgs, comm, config) RESULT(redist)
    INTEGER(i2), INTENT(in) :: nsend, nrecv
    TYPE(xt_redist_msg), TARGET, INTENT(in) :: &
         send_msgs(nsend), recv_msgs(nrecv)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: redist

    INTEGER(c_int) :: nsend_c, nrecv_c
    TYPE(c_ptr) :: send_msgs_p, recv_msgs_p

    IF (nsend < 0_i2 .OR. nsend > HUGE(1_c_int) &
         .OR. nrecv < 0_i2 .OR. nrecv > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of send messages", filename, __LINE__)
    IF (nsend > 0_i2) THEN
      send_msgs_p = C_LOC(send_msgs)
    ELSE
      send_msgs_p = c_null_ptr
    END IF
    IF (nrecv > 0_i2) THEN
      recv_msgs_p = C_LOC(recv_msgs)
    ELSE
      recv_msgs_p = c_null_ptr
    END IF
    nsend_c = INT(nsend, c_int)
    nrecv_c = INT(nrecv, c_int)
    redist%cptr = xt_redist_single_array_base_custom_new_c2f(&
         nsend_c, nrecv_c, send_msgs_p, recv_msgs_p, comm, config)
  END FUNCTION xt_redist_single_array_base_new_i2_a1d_i2_a1d_cfg

  FUNCTION xt_redist_single_array_base_new_i4_a1d_i4_a1d( &
       nsend, nrecv, send_msgs, recv_msgs, comm) RESULT(redist)
    INTEGER(i4), INTENT(in) :: nsend, nrecv
    TYPE(xt_redist_msg), TARGET, INTENT(in) :: &
         send_msgs(nsend), recv_msgs(nrecv)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_redist) :: redist

    INTEGER(c_int) :: nsend_c, nrecv_c
    TYPE(c_ptr) :: send_msgs_p, recv_msgs_p

    IF (nsend < 0_i4 .OR. nsend > HUGE(1_c_int) &
         .OR. nrecv < 0_i4 .OR. nrecv > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of send messages", filename, __LINE__)
    IF (nsend > 0_i4) THEN
      send_msgs_p = C_LOC(send_msgs)
    ELSE
      send_msgs_p = c_null_ptr
    END IF
    IF (nrecv > 0_i4) THEN
      recv_msgs_p = C_LOC(recv_msgs)
    ELSE
      recv_msgs_p = c_null_ptr
    END IF
    nsend_c = INT(nsend, c_int)
    nrecv_c = INT(nrecv, c_int)
    redist = xt_redist_c2f(xt_redist_single_array_base_new_c2f(&
         nsend_c, nrecv_c, send_msgs_p, recv_msgs_p, comm))
  END FUNCTION xt_redist_single_array_base_new_i4_a1d_i4_a1d

  FUNCTION xt_redist_single_array_base_new_i4_a1d_i4_a1d_cfg( &
       nsend, nrecv, send_msgs, recv_msgs, comm, config) RESULT(redist)
    INTEGER(i4), INTENT(in) :: nsend, nrecv
    TYPE(xt_redist_msg), TARGET, INTENT(in) :: &
         send_msgs(nsend), recv_msgs(nrecv)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: redist

    INTEGER(c_int) :: nsend_c, nrecv_c
    TYPE(c_ptr) :: send_msgs_p, recv_msgs_p

    IF (nsend < 0_i4 .OR. nsend > HUGE(1_c_int) &
         .OR. nrecv < 0_i4 .OR. nrecv > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of send messages", filename, __LINE__)
    IF (nsend > 0_i4) THEN
      send_msgs_p = C_LOC(send_msgs)
    ELSE
      send_msgs_p = c_null_ptr
    END IF
    IF (nrecv > 0_i4) THEN
      recv_msgs_p = C_LOC(recv_msgs)
    ELSE
      recv_msgs_p = c_null_ptr
    END IF
    nsend_c = INT(nsend, c_int)
    nrecv_c = INT(nrecv, c_int)
    redist%cptr = xt_redist_single_array_base_custom_new_c2f(&
         nsend_c, nrecv_c, send_msgs_p, recv_msgs_p, comm, config)
  END FUNCTION xt_redist_single_array_base_new_i4_a1d_i4_a1d_cfg

  FUNCTION xt_redist_single_array_base_new_i8_a1d_i8_a1d( &
       nsend, nrecv, send_msgs, recv_msgs, comm) RESULT(redist)
    INTEGER(i8), INTENT(in) :: nsend, nrecv
    TYPE(xt_redist_msg), TARGET, INTENT(in) :: &
         send_msgs(nsend), recv_msgs(nrecv)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_redist) :: redist

    INTEGER(c_int) :: nsend_c, nrecv_c
    TYPE(c_ptr) :: send_msgs_p, recv_msgs_p

    IF (nsend < 0_i8 .OR. nsend > HUGE(1_c_int) &
         .OR. nrecv < 0_i8 .OR. nrecv > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of send messages", filename, __LINE__)
    IF (nsend > 0_i8) THEN
      send_msgs_p = C_LOC(send_msgs)
    ELSE
      send_msgs_p = c_null_ptr
    END IF
    IF (nrecv > 0_i8) THEN
      recv_msgs_p = C_LOC(recv_msgs)
    ELSE
      recv_msgs_p = c_null_ptr
    END IF
    nsend_c = INT(nsend, c_int)
    nrecv_c = INT(nrecv, c_int)
    redist%cptr = xt_redist_single_array_base_new_c2f(&
         nsend_c, nrecv_c, send_msgs_p, recv_msgs_p, comm)
  END FUNCTION xt_redist_single_array_base_new_i8_a1d_i8_a1d

  FUNCTION xt_redist_single_array_base_new_i8_a1d_i8_a1d_cfg( &
       nsend, nrecv, send_msgs, recv_msgs, comm, config) RESULT(redist)
    INTEGER(i8), INTENT(in) :: nsend, nrecv
    TYPE(xt_redist_msg), TARGET, INTENT(in) :: &
         send_msgs(nsend), recv_msgs(nrecv)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: redist

    INTEGER(c_int) :: nsend_c, nrecv_c
    TYPE(c_ptr) :: send_msgs_p, recv_msgs_p

    IF (nsend < 0_i8 .OR. nsend > HUGE(1_c_int) &
         .OR. nrecv < 0_i8 .OR. nrecv > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of send messages", filename, __LINE__)
    IF (nsend > 0_i8) THEN
      send_msgs_p = C_LOC(send_msgs)
    ELSE
      send_msgs_p = c_null_ptr
    END IF
    IF (nrecv > 0_i8) THEN
      recv_msgs_p = C_LOC(recv_msgs)
    ELSE
      recv_msgs_p = c_null_ptr
    END IF
    nsend_c = INT(nsend, c_int)
    nrecv_c = INT(nrecv, c_int)
    redist%cptr = xt_redist_single_array_base_custom_new_c2f(&
         nsend_c, nrecv_c, send_msgs_p, recv_msgs_p, comm, config)
  END FUNCTION xt_redist_single_array_base_new_i8_a1d_i8_a1d_cfg

  FUNCTION xt_redist_single_array_base_new_a1d_a1d(send_msgs, recv_msgs, comm) &
       RESULT(redist)
    TYPE(xt_redist_msg), TARGET, INTENT(in) :: send_msgs(:), recv_msgs(:)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_redist) :: redist

    INTEGER :: nsend, nrecv
    INTEGER(c_int) :: nsend_c, nrecv_c
    TYPE(c_ptr) :: send_msgs_p, recv_msgs_p
    TYPE(xt_redist_msg), ALLOCATABLE, TARGET :: send_msgs_a(:), recv_msgs_a(:)

    nsend = SIZE(send_msgs)
    nrecv = SIZE(recv_msgs)

    CALL msgs_p_arg(send_msgs, send_msgs_a, send_msgs_p)
    CALL msgs_p_arg(recv_msgs, recv_msgs_a, recv_msgs_p)

    IF (nsend < 0 .OR. nsend > HUGE(1_c_int) &
         .OR. nrecv < 0 .OR. nrecv > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of send messages", filename, __LINE__)
    nsend_c = INT(nsend, c_int)
    nrecv_c = INT(nrecv, c_int)
    redist%cptr = xt_redist_single_array_base_new_c2f(&
         nsend_c, nrecv_c, send_msgs_p, recv_msgs_p, comm)
  END FUNCTION xt_redist_single_array_base_new_a1d_a1d

  FUNCTION xt_redist_single_array_base_new_a1d_a1d_cfg(send_msgs, recv_msgs, &
       comm, config) RESULT(redist)
    TYPE(xt_redist_msg), TARGET, INTENT(in) :: send_msgs(:), recv_msgs(:)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    TYPE(xt_redist) :: redist

    INTEGER :: nsend, nrecv
    INTEGER(c_int) :: nsend_c, nrecv_c
    TYPE(c_ptr) :: send_msgs_p, recv_msgs_p
    TYPE(xt_redist_msg), ALLOCATABLE, TARGET :: send_msgs_a(:), recv_msgs_a(:)

    nsend = SIZE(send_msgs)
    nrecv = SIZE(recv_msgs)

    CALL msgs_p_arg(send_msgs, send_msgs_a, send_msgs_p)
    CALL msgs_p_arg(recv_msgs, recv_msgs_a, recv_msgs_p)

    IF (nsend < 0 .OR. nsend > HUGE(1_c_int) &
         .OR. nrecv < 0 .OR. nrecv > HUGE(1_c_int)) &
         CALL xt_abort("invalid number of send messages", filename, __LINE__)
    nsend_c = INT(nsend, c_int)
    nrecv_c = INT(nrecv, c_int)
    redist%cptr = xt_redist_single_array_base_custom_new_c2f(&
         nsend_c, nrecv_c, send_msgs_p, recv_msgs_p, comm, config)
  END FUNCTION xt_redist_single_array_base_new_a1d_a1d_cfg

  SUBROUTINE msgs_p_arg(msgs, msgs_a, msgs_p)
    TYPE(xt_redist_msg), TARGET, INTENT(in) :: msgs(:)
    TYPE(xt_redist_msg), TARGET, ALLOCATABLE, INTENT(inout) :: msgs_a(:)
    TYPE(c_ptr), INTENT(out) :: msgs_p

    INTEGER :: msgs_size
    LOGICAL :: msgs_is_contiguous
#ifndef HAVE_FC_IS_CONTIGUOUS
    INTERFACE
      FUNCTION xt_redist_msg_contiguous(msgs_a, msgs_b) RESULT(p) &
            BIND(c, name='xt_redist_msg_contiguous')
        IMPORT :: c_int, xt_redist_msg
        TYPE(xt_redist_msg), INTENT(in) :: msgs_a, msgs_b
        INTEGER(c_int) :: p
      END FUNCTION xt_redist_msg_contiguous
    END INTERFACE
#endif

    msgs_size = SIZE(msgs)
    IF (msgs_size > HUGE(1_c_int)) &
         CALL xt_abort('invalid size', filename, __LINE__)
    IF (msgs_size > 0) THEN
      IF (msgs_size > 1) THEN
#ifdef HAVE_FC_IS_CONTIGUOUS
        msgs_is_contiguous = IS_CONTIGUOUS(msgs)
#else
        msgs_is_contiguous = xt_redist_msg_contiguous(msgs(1), msgs(2)) /= 0
#endif
        IF (msgs_is_contiguous) THEN
          XT_SLICE_C_LOC(msgs(1), msgs_p)
        ELSE
          ALLOCATE(msgs_a(msgs_size))
          msgs_a = msgs
          msgs_p = C_LOC(msgs_a)
        END IF
      ELSE
        XT_SLICE_C_LOC(msgs(1), msgs_p)
      END IF
    ELSE
      msgs_p = c_null_ptr
    END IF
  END SUBROUTINE msgs_p_arg

END MODULE xt_redist_base

MODULE xt_redist_rename
  USE xt_redist_base, ONLY: xt_redist_p2p_orig_new => xt_redist_p2p_new, &
       xt_redist_p2p_custom_new
  IMPLICIT NONE
  PRIVATE
  INTERFACE xt_redist_p2p_new
    MODULE PROCEDURE xt_redist_p2p_orig_new
    MODULE PROCEDURE xt_redist_p2p_custom_new
  END INTERFACE xt_redist_p2p_new
  PUBLIC :: xt_redist_p2p_new
END MODULE xt_redist_rename
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_p2p_parallel_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_redist_p2p_parallel
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE mpi
  USE yaxt, ONLY: xt_initialize, xt_finalize, &
       xt_int_kind, xi => xt_int_kind, &
       xt_idxlist, xt_idxvec_new, xt_idxlist_delete, &
       xt_xmap, xt_xmap_all2all_new, xt_xmap_delete, &
       xt_redist, xt_redist_p2p_new, xt_redist_get_mpi_comm, &
       xt_redist_delete, &
       xt_redist_p2p_blocks_off_custom_new, xt_redist_p2p_blocks_custom_new, &
       xt_config, xt_config_delete, xt_config_set_ddt_cache_limit
  USE test_idxlist_utils, ONLY: test_err_count
  USE test_redist_common, ONLY: communicators_are_congruent, &
       check_redist, redist_exchanger_option
  IMPLICIT NONE

  CHARACTER(len=*), PARAMETER :: filename = 'test_redist_p2p_parallel_f.f90'
  TYPE(xt_config) :: config
  INTEGER, PARAMETER :: ddt_gen_lim(4) = (/ -1, 0, 16, -2 /)
  INTEGER :: comm_rank, comm_size, ierror

  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  CALL mpi_comm_rank(mpi_comm_world, comm_rank, ierror)
  IF (ierror /= mpi_success) &
       CALL test_abort("MPI error!", filename, __LINE__)

  CALL mpi_comm_size(mpi_comm_world, comm_size, ierror)
  IF (ierror /= mpi_success) &
       CALL test_abort("MPI error!", filename, __LINE__)

  CALL simple_test
  CALL nonuniform_test
  CALL block_redist_test

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi

CONTAINS
  SUBROUTINE simple_test
    INTEGER, PARAMETER :: data_size = 10
    INTEGER, PARAMETER :: src_num_indices = data_size, &
         dst_num_indices = data_size
    INTEGER(xt_int_kind) :: src_index_list(data_size), &
         dst_index_list(data_size)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist
    DOUBLE PRECISION :: src_data(data_size), dst_data(data_size)
    INTEGER :: i, ddt_gen_test

    ! source index list
    DO i = 1, src_num_indices
      src_index_list(i) = INT(comm_rank * data_size + (i - 1), xi)
    END DO

    src_idxlist = xt_idxvec_new(src_index_list)
    ! destination index list
    DO i = 1, dst_num_indices
      dst_index_list(i) &
           = INT(MOD(comm_rank * data_size + i + 1, comm_size * data_size), xi)
    END DO
    dst_idxlist = xt_idxvec_new(dst_index_list)
    ! xmap
    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist, mpi_comm_world)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    DO i = 1, src_num_indices
      src_data(i) = DBLE(comm_rank * data_size + i - 1)
    END DO

    DO ddt_gen_test = 1, SIZE(ddt_gen_lim)
      CALL xt_config_set_ddt_cache_limit(config, ddt_gen_lim(ddt_gen_test))

      ! redist_p2p
      redist = xt_redist_p2p_new(xmap, mpi_double_precision, config)

      ! test communicator of redist
      IF (.NOT. communicators_are_congruent(xt_redist_get_mpi_comm(redist), &
           mpi_comm_world)) &
           CALL test_abort("error in xt_redist_get_mpi_comm", filename, __LINE__)


      CALL check_redist(redist, src_data, dst_data, dst_index_list)
      CALL xt_redist_delete(redist)
    END DO

    ! clean up
    CALL xt_xmap_delete(xmap)
  END SUBROUTINE simple_test

  ! test nonuniform numbers of send and receive partners
  SUBROUTINE nonuniform_test
    ! source index list
    INTEGER(xt_int_kind), ALLOCATABLE :: src_index_list(:), dst_index_list(:)
    DOUBLE PRECISION, ALLOCATABLE :: src_data(:), dst_data(:), ref_dst_data(:)
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap
    TYPE(Xt_redist) :: redist
    INTEGER :: i, src_num_indices, dst_num_indices, ddt_gen_test

    ALLOCATE(src_index_list(comm_size), dst_index_list(comm_size), &
         src_data(comm_size), dst_data(comm_size), ref_dst_data(comm_size))
    src_num_indices = MERGE(comm_size, 0, comm_rank == 0)
    DO i = 1, src_num_indices
      src_index_list(i) = INT(i - 1, xi)
    END DO

    src_idxlist = xt_idxvec_new(src_index_list, src_num_indices)

    ! destination index list
    dst_num_indices = comm_size
    DO i = 1, dst_num_indices
      dst_index_list(i) = INT(i - 1, xi)
    END DO

    dst_idxlist = xt_idxvec_new(dst_index_list, dst_num_indices)

    ! xmap
    xmap = xt_xmap_all2all_new(src_idxlist, dst_idxlist, mpi_comm_world)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    ! prepare invariant test-data
    IF (comm_rank == 0) THEN
      DO i = 1, comm_size
        src_data(i) = DBLE(i - 1)
      END DO
    ELSE
      src_data(:) = -2.0d0
    END IF
    DO i = 1, comm_size
      ref_dst_data(i) = DBLE(i-1)
    END DO

    DO ddt_gen_test = 1, SIZE(ddt_gen_lim)
      CALL xt_config_set_ddt_cache_limit(config, ddt_gen_lim(ddt_gen_test))
      ! redist_p2p
      redist = xt_redist_p2p_new(xmap, mpi_double_precision, config)

      ! test communicator of redist
      IF (.NOT. communicators_are_congruent(xt_redist_get_mpi_comm(redist), &
           mpi_comm_world)) &
           CALL test_abort("error in xt_redist_get_mpi_comm", filename, __LINE__)

      ! test exchange
      CALL check_redist(redist, src_data, dst_data, ref_dst_data)
      CALL xt_redist_delete(redist)
    END DO

    ! clean up
    CALL xt_xmap_delete(xmap)
  END SUBROUTINE nonuniform_test

  ! test redist with blocks
  SUBROUTINE block_redist_test
    ! gvol_size: volume of deep ocean
    INTEGER :: ngdom, gvol_size, i, nwin, ig0, j, p, ddt_gen_test
    ! gdepth: ocean depth of an one dim. ocean
    INTEGER, ALLOCATABLE :: gdoma(:), gdomb(:), gsurfdata(:), &
         gdepth(:), ig2col_off(:), b_surfdata_ref(:), gvoldata(:), &
         src_block_offsets(:), src_block_sizes(:), dst_block_offsets(:), &
         dst_block_sizes(:), b_voldata_ref(:)
    INTEGER, ALLOCATABLE :: a_surfdata(:), b_surfdata(:), &
         a_voldata(:), b_voldata(:)
    INTEGER(xi), ALLOCATABLE :: iveca(:), ivecb(:)
    TYPE(Xt_idxlist) :: idxlist_a, idxlist_b
    TYPE(xt_xmap) :: xmap
    TYPE(Xt_redist) :: redist, block_redist, block_redist2

    IF (2 * comm_size > HUGE(1_xt_int_kind)) &
         CALL test_abort('too large number of tasks', filename, __LINE__)
    ! the global index domain (1dim problem):
    ngdom = 2 * comm_size
    ! start state (index distribution) of global domain
    ALLOCATE(gdoma(ngdom), gdomb(ngdom))
    ! end state ""
    ALLOCATE(gsurfdata(ngdom), gdepth(ngdom))
    ALLOCATE(ig2col_off(ngdom)) ! offset of surface DATA within vol
    gvol_size = 0
    DO i = 1, ngdom
      gdoma(i) = i - 1
      gdomb(i) = ngdom - i
      gsurfdata(i) = 99 + i
      gdepth(i) = i
      ig2col_off(i) = gvol_size
      gvol_size = gvol_size + gdepth(i)
    END DO

    nwin = ngdom / comm_size ! my local window size of the global surface domain
    ! start of my window within global index domain (== global offset)
    ig0 = comm_rank * nwin
    IF (nwin * comm_size /= ngdom) &
         CALL test_abort("internal error", filename, __LINE__)

    ! local index
    ALLOCATE(iveca(nwin), ivecb(nwin))
    DO i = 1, nwin
      iveca(i) = INT(gdoma(ig0+i), xi)
      ivecb(i) = INT(gdomb(ig0+i), xi)
    END DO

    idxlist_a = xt_idxvec_new(iveca, nwin)
    idxlist_b = xt_idxvec_new(ivecb, nwin)

    xmap = xt_xmap_all2all_new(idxlist_a, idxlist_b, mpi_comm_world)
    CALL xt_idxlist_delete(idxlist_a)
    CALL xt_idxlist_delete(idxlist_b)

    ALLOCATE(a_surfdata(nwin), b_surfdata(nwin), b_surfdata_ref(nwin))
    DO i = 1, nwin
      a_surfdata(i) = gsurfdata(iveca(i) + 1)
      b_surfdata_ref(i) = gsurfdata(ivecb(i) + 1)
    END DO
    ! generate global volume data
    ALLOCATE(gvoldata(gvol_size))
    DO i = 1, ngdom
      DO j = 1, gdepth(i)
        p = ig2col_off(i) + j
        gvoldata(p) = (i - 1) * 100 + j - 1
      END DO
    END DO

    ! generate blocks
    ALLOCATE(src_block_offsets(nwin), src_block_sizes(nwin), &
         dst_block_offsets(nwin), dst_block_sizes(nwin))
    ! we only need local size but simply oversize here
    ALLOCATE(a_voldata(gvol_size), b_voldata(gvol_size), &
         b_voldata_ref(gvol_size))
    b_voldata_ref(:) = -1

    CALL generate_block(a_voldata, src_block_sizes, src_block_offsets, &
         gvoldata, ig2col_off, gdepth, iveca, nwin)
    CALL generate_block(b_voldata_ref, dst_block_sizes, dst_block_offsets, &
         gvoldata, ig2col_off, gdepth, ivecb, nwin)

    DO ddt_gen_test = 1, SIZE(ddt_gen_lim)
      CALL xt_config_set_ddt_cache_limit(config, ddt_gen_lim(ddt_gen_test))
      ! simple redist
      redist = xt_redist_p2p_new(xmap, mpi_integer, config)

      ! test communicator of redist
      IF (.NOT. communicators_are_congruent(xt_redist_get_mpi_comm(redist), &
           mpi_comm_world)) &
           CALL test_abort("error in xt_redist_get_mpi_comm", filename, __LINE__)

      CALL check_redist(redist, a_surfdata, b_surfdata, b_surfdata_ref)
      CALL xt_redist_delete(redist)


      ! redist with blocks
      block_redist = xt_redist_p2p_blocks_off_custom_new(xmap, &
           src_block_offsets, src_block_sizes, nwin, &
           dst_block_offsets, dst_block_sizes, nwin, mpi_integer, config)
      ! test communicator of redist
      IF (.NOT. communicators_are_congruent(xt_redist_get_mpi_comm(block_redist), &
           mpi_comm_world)) &
           CALL test_abort("error in xt_redist_get_mpi_comm", filename, __LINE__)

      CALL check_redist(block_redist, a_voldata, b_voldata, b_voldata_ref)
      CALL xt_redist_delete(block_redist)

      ! redist with blocks but without explicit offsets:
      block_redist2 = xt_redist_p2p_blocks_custom_new(xmap, &
           src_block_sizes, nwin, dst_block_sizes, nwin, mpi_integer, config)
      ! test communicator of redist
      IF (.NOT. communicators_are_congruent(xt_redist_get_mpi_comm(block_redist2),&
           mpi_comm_world)) &
           CALL test_abort("error in xt_redist_get_mpi_comm", filename, __LINE__)

      CALL check_redist(block_redist2, a_voldata, b_voldata, b_voldata_ref)
      CALL xt_redist_delete(block_redist2)
    END DO

    ! cleanup
    CALL xt_xmap_delete(xmap)
  END SUBROUTINE block_redist_test

  SUBROUTINE generate_block(voldata, block_sizes, block_offsets, &
    gvoldata, ig2col_off, gdepth, ivec, nwin)
    INTEGER, INTENT(out) :: voldata(*), block_sizes(*), block_offsets(*)
    INTEGER, INTENT(in) :: gvoldata(*), ig2col_off(*), gdepth(*), nwin
    INTEGER(xi), INTENT(in) :: ivec(*)

    INTEGER :: p, q, ia, bsize, ofs_accum, i, j
    q = 0
    ofs_accum = 0
    DO i = 1, nwin
      ia = INT(ivec(i)) + 1
      bsize = gdepth(ia)
      block_offsets(i) = ofs_accum
      ofs_accum = ofs_accum + bsize
      block_sizes(i) = bsize
      p = ig2col_off(ia)
      DO j = 1, bsize
        voldata(q + j) = gvoldata(p + j)
      END DO
      q = q + bsize
    END DO
  END SUBROUTINE generate_block

END PROGRAM test_redist_p2p_parallel
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file xt_core_f.f90
!! @brief Fortran interface to yaxt core declarations
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE xt_core
  USE, INTRINSIC :: ISO_C_BINDING, ONLY: c_char, c_null_char, c_int
#ifdef XT_INT_FC_KIND_IN_ISO_C_BINDING
  USE, INTRINSIC :: iso_c_binding, ONLY: XT_INT_FC_KIND
#endif
  USE xt_mpi, ONLY: xt_mpi_fint_kind
  USE mpi
  IMPLICIT NONE
  PRIVATE
  INTEGER, PUBLIC, PARAMETER :: xt_int_kind   = XT_INT_FC_KIND
  INTEGER, PUBLIC, PARAMETER :: pi2 = 4
  INTEGER, PUBLIC, PARAMETER :: pi4 = 9
  INTEGER, PUBLIC, PARAMETER :: pi8 = 14
  INTEGER, PUBLIC, PARAMETER :: i2 = SELECTED_INT_KIND(pi2)
  INTEGER, PUBLIC, PARAMETER :: i4 = SELECTED_INT_KIND(pi4)
  INTEGER, PUBLIC, PARAMETER :: i8 = SELECTED_INT_KIND(pi8)
  PUBLIC :: xt_initialize, xt_finalize, xt_abort, xt_get_default_comm, char
  PUBLIC :: xt_initialized, xt_finalized
  PUBLIC :: xt_slice_c_loc
  PUBLIC :: OPERATOR(==), OPERATOR(/=)

  PUBLIC :: xt_mpi_fint_kind
  INTEGER, PUBLIC, PARAMETER :: xt_int_mpidt = XT_INT_FC_MPIDT
  INTEGER(xt_int_kind), PARAMETER :: dummy = 0_xt_int_kind
  !> number of decimal places needed to print any variable of type
  !! INTEGER(xt_int_kind)
  INTEGER, PUBLIC, PARAMETER :: xt_int_dec_len &
       = CEILING(1.0 + REAL(DIGITS(dummy)) * LOG10(REAL(RADIX(dummy))))
  CHARACTER(9), PARAMETER :: xt_stripe_tag = 'xt_stripe'
  !> maximal length of string xt_stripe(a, b, c)
  INTEGER, PUBLIC, PARAMETER :: xt_stripe2s_len &
       = LEN(xt_stripe_tag) + 2 + 4 + 3 * xt_int_dec_len

  INTEGER, PUBLIC, PARAMETER :: xt_direction_send = 0, xt_direction_recv = 1

  TYPE, BIND(C), PUBLIC :: xt_stripe
    INTEGER(xt_int_kind) :: start
    INTEGER(xt_int_kind) :: stride
    INTEGER(c_int) :: nstrides
  END TYPE xt_stripe

  TYPE, BIND(C), PUBLIC :: xt_bounds
    INTEGER(xt_int_kind) :: start, size
  END TYPE xt_bounds

  !> describes range of positions starting with start up to start + size - 1
  !! i.e. [start,start+size) if size is positive and down to start + size + 1
  !! i.e. (start+size,start] if size is negative
  TYPE, BIND(c), PUBLIC :: xt_pos_ext
    INTEGER(c_int) :: start, size
  END TYPE xt_pos_ext

  INTERFACE

    FUNCTION xt_get_default_comm() RESULT(comm) &
         BIND(c, name='xt_get_default_comm_f')
      IMPORT :: xt_mpi_fint_kind
      IMPLICIT NONE
      INTEGER(xt_mpi_fint_kind) :: comm
    END FUNCTION xt_get_default_comm

    SUBROUTINE xt_initialize(default_comm) BIND(C, name='xt_initialize_f')
      IMPORT:: xt_mpi_fint_kind
      IMPLICIT NONE
      INTEGER(xt_mpi_fint_kind), INTENT(in) :: default_comm
    END SUBROUTINE xt_initialize

    SUBROUTINE xt_finalize() BIND(C, name='xt_finalize')
    END SUBROUTINE xt_finalize

    SUBROUTINE xt_restore_default_abort_hndl
    END SUBROUTINE xt_restore_default_abort_hndl

  END INTERFACE

  INTERFACE xt_abort
    MODULE PROCEDURE xt_abort4
    MODULE PROCEDURE xt_abort3
  END INTERFACE xt_abort

  INTERFACE
    SUBROUTINE xt_abort_c(comm, msg, source, line) BIND(c, name='xt_abort_f')
      IMPORT :: c_char, xt_mpi_fint_kind
      IMPLICIT NONE
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in):: comm
      CHARACTER(kind=c_char), DIMENSION(*), INTENT(in) :: msg
      CHARACTER(kind=c_char), DIMENSION(*), INTENT(in) :: source
      INTEGER(xt_mpi_fint_kind), VALUE, INTENT(in) :: line
    END SUBROUTINE xt_abort_c
  END INTERFACE

  INTERFACE char
    MODULE PROCEDURE xt_stripe2char
  END INTERFACE char

  INTERFACE OPERATOR(==)
    MODULE PROCEDURE xt_pos_ext_eq
  END INTERFACE OPERATOR(==)

  INTERFACE OPERATOR(/=)
    MODULE PROCEDURE xt_pos_ext_ne
  END INTERFACE OPERATOR(/=)

  EXTERNAL :: xt_slice_c_loc

  PUBLIC :: set_abort_handler, xt_restore_default_abort_hndl

  ENUM, BIND( C )
    ENUMERATOR :: xt_lib_pre_init, &
         xt_lib_initialized, &
         xt_lib_finalized
  END ENUM
  INTEGER(c_int), PUBLIC, BIND(c, name='xt_lib_state') :: xt_lib_state

CONTAINS

  SUBROUTINE xt_abort4(comm, msg, source, line)
    INTEGER, INTENT(in) :: comm
    CHARACTER(len=*), INTENT(in) :: msg
    CHARACTER(len=*), INTENT(in) :: source
    INTEGER, INTENT(in) :: line
    CALL xt_abort_c(comm, TRIM(msg)//c_null_char, &
         TRIM(source)//c_null_char, line)
  END SUBROUTINE xt_abort4

  SUBROUTINE xt_abort3(msg, source, line)
    CHARACTER(len=*), INTENT(in) :: msg
    CHARACTER(len=*), INTENT(in) :: source
    INTEGER, INTENT(in) :: line
    CALL xt_abort_c(xt_get_default_comm(), TRIM(msg)//c_null_char, &
         TRIM(source)//c_null_char, line)
  END SUBROUTINE xt_abort3

  ELEMENTAL FUNCTION xt_stripe2char(stripe) RESULT(str)
    CHARACTER(len=xt_stripe2s_len) :: str
    TYPE(xt_stripe), INTENT(in) :: stripe
    WRITE (str, '(2a,3(i0,a))') xt_stripe_tag, '(', stripe%start, ', ', &
         stripe%stride, ', ', stripe%nstrides, ')'
  END FUNCTION xt_stripe2char

  PURE FUNCTION xt_initialized() RESULT(is_initialized)
    LOGICAL :: is_initialized
    is_initialized = xt_lib_state > xt_lib_pre_init
  END FUNCTION xt_initialized

  PURE FUNCTION xt_finalized() RESULT(is_finalized)
    LOGICAL :: is_finalized
    is_finalized = xt_lib_state == xt_lib_finalized
  END FUNCTION xt_finalized

  ELEMENTAL FUNCTION xt_pos_ext_eq(a, b) RESULT(p)
    TYPE(xt_pos_ext), INTENT(in) :: a, b
    LOGICAL :: p
    p = a%start == b%start .AND. (a%size == b%size &
         .OR. (ABS(a%size) == 1 .AND. ABS(a%size) == ABS(b%size)))
  END FUNCTION xt_pos_ext_eq

  ELEMENTAL FUNCTION xt_pos_ext_ne(a, b) RESULT(p)
    TYPE(xt_pos_ext), INTENT(in) :: a, b
    LOGICAL :: p
    p = a%start /= b%start .OR. (a%size /= b%size &
         .AND. .NOT. (ABS(a%size) == 1 .AND. ABS(a%size) == ABS(b%size)))
  END FUNCTION xt_pos_ext_ne

  !> set routine f to use as abort function which is called on xt_abort
  SUBROUTINE set_abort_handler(f)
    INTERFACE
      SUBROUTINE f(comm, msg, source, line)
        INTEGER, INTENT(in) :: comm, line
        CHARACTER(len=*), INTENT(in) :: msg, source
      END SUBROUTINE f
      SUBROUTINE xt_set_abort_handler(f)
        INTERFACE
          SUBROUTINE f(comm, msg, source, line)
            INTEGER, INTENT(in) :: comm, line
            CHARACTER(len=*), INTENT(in) :: msg, source
          END SUBROUTINE f
        END INTERFACE
      END SUBROUTINE xt_set_abort_handler
    END INTERFACE
    CALL xt_set_abort_handler(f)
  END SUBROUTINE set_abort_handler

END MODULE xt_core
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! license-project-url: "https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/"
! license-default: "bsd"
! End:
!

!>
!! @file test_misc_f.f90
!! @brief Test minor functionality needed for higher level parts of YAXT.
!!
!! @copyright Copyright  (C)  2021 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_misc
  USE xt_core, ONLY: i2, i4, i8
  USE ftest_common, ONLY: icbrt, test_abort, run_randomized_tests, &
       init_fortran_random
  IMPLICIT NONE
  LOGICAL :: fully_random_tests
  CHARACTER(len=*), PARAMETER :: filename = 'test_misc_f.f90'

  fully_random_tests = run_randomized_tests()
  CALL init_fortran_random(fully_random_tests)
  CALL test_icbrt
CONTAINS
  SUBROUTINE test_icbrt
    CALL test_icbrt_i2
    CALL test_icbrt_i4
    CALL test_icbrt_i8
  END SUBROUTINE test_icbrt

  SUBROUTINE test_icbrt_i2
    INTEGER(i2), PARAMETER :: ulim = 31_i2
    INTEGER(i2) :: i, cubed, cbrt
    CHARACTER(len=132) :: msg
    DO i = -ulim, ulim, 1_i2
      cubed = i**3_i2
      cbrt = icbrt(cubed)
      IF (cbrt /= i) THEN
        WRITE (msg, '(4(a,i0))') &
             "integer cube root computation failed for ", i, &
             "**3 = ", cubed, ", but icbrt(", cubed, ") = ", cbrt
        CALL test_abort(msg, filename, __LINE__)
      END IF
    END DO
  END SUBROUTINE test_icbrt_i2

  SUBROUTINE test_icbrt_i4
    INTEGER(i4), PARAMETER :: ulim = 1290
    INTEGER(i4) :: i, cubed, cbrt, prev_cubed, other_cubed
    CHARACTER(len=132) :: msg
    DOUBLE PRECISION :: rnd
    i = icbrt(-8)
    prev_cubed = -HUGE(1_i4)
    DO i = -ulim, -1_i4, 1_i4
      cubed = i**3_i4
      cbrt = icbrt(cubed)
      IF (cbrt /= i) THEN
        WRITE (msg, '(4(a,i0))') &
             "integer cube root computation failed for ", i, &
             "**3 = ", cubed, ", but icbrt(", cubed, ") = ", cbrt
        CALL test_abort(msg, filename, __LINE__)
      END IF
      CALL random_number(rnd)
      other_cubed = prev_cubed + MAX(1_i4, INT(rnd * DBLE(cubed - prev_cubed), i4))
      cbrt = icbrt(other_cubed)
      IF (cbrt /= i) THEN
        WRITE (msg, '(4(a,i0))') &
             "integer cube root computation failed for ", other_cubed, &
             ", expected ", i, &
             ", but icbrt(", other_cubed, ") = ", cbrt
        CALL test_abort(msg, filename, __LINE__)
      END IF
      prev_cubed = cubed
    END DO
    prev_cubed = HUGE(1_i4)
    DO i = ulim, 0_i4, -1_i4
      cubed = i**3_i4
      cbrt = icbrt(cubed)
      IF (cbrt /= i) THEN
        WRITE (msg, '(4(a,i0))') &
             "integer cube root computation failed for ", i, &
             "**3 = ", cubed, ", but icbrt(", cubed, ") = ", cbrt
        CALL test_abort(msg, filename, __LINE__)
      END IF
      CALL random_number(rnd)
      other_cubed = cubed + MIN(INT(rnd * DBLE(prev_cubed - cubed), i4), -1_i4)
      cbrt = icbrt(cubed)
      IF (cbrt /= i) THEN
        WRITE (msg, '(4(a,i0))') &
             "integer cube root computation failed for ", other_cubed, &
             ", expected ", i, &
             ", but icbrt(", other_cubed, ") = ", cbrt
        CALL test_abort(msg, filename, __LINE__)
      END IF
      prev_cubed = cubed
    END DO
  END SUBROUTINE test_icbrt_i4

  SUBROUTINE test_icbrt_i8
    INTEGER(i8), PARAMETER :: ulim = 2097151_i8
    INTEGER(i8) :: i, cubed, cbrt
    CHARACTER(len=132) :: msg
    DO i = -ulim, ulim, 1_i8
      ! need to spell that out explcitely for crayftn 8.5.5 at least
#ifndef HAVE_FC_PRECISE_INTEGER_EXPONENTIATION
      cubed = i * i * i
#else
      cubed = i**3
#endif
      cbrt = icbrt(cubed)
      IF (cbrt /= i) THEN
        WRITE (msg, '(4(a,i0))') &
             "integer cube root computation failed for ", i, &
             "**3 = ", cubed, ", but icbrt(", cubed, ") = ", cbrt
        CALL test_abort(msg, filename, __LINE__)
      END IF
    END DO
  END SUBROUTINE test_icbrt_i8
END PROGRAM test_misc
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! license-project-url: "https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/"
! license-default: "bsd"
! End:
!

!>
!! @file xt_mpi_f.f90
!! @brief Fortran wrapper for MPI
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE xt_mpi
  USE mpi, orig_mpi_address_kind => mpi_address_kind
  USE, INTRINSIC :: ISO_C_BINDING, ONLY: c_int, c_long, c_short, c_long_long
  IMPLICIT NONE
  PRIVATE
  INTEGER, PUBLIC, PARAMETER :: xt_mpi_fint_kind = XT_MPI_FINT_FC_KIND
  INTEGER, PUBLIC, PARAMETER :: mpi_address_kind = XT_MPI_AINT_KIND
  INTERFACE
    SUBROUTINE xt_mpi_comm_mark_exclusive(comm) &
         BIND(c, name='xt_mpi_comm_mark_exclusive_f2c')
      IMPORT :: xt_mpi_fint_kind
      INTEGER(xt_mpi_fint_kind), INTENT(inout) :: comm
    END SUBROUTINE xt_mpi_comm_mark_exclusive
  END INTERFACE
  PUBLIC :: xt_mpi_comm_mark_exclusive
END MODULE xt_mpi
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_idxlist_collection_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_idxlist_collection_f
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE mpi
  USE test_idxlist_utils, ONLY: check_idxlist, test_err_count, &
       idxlist_pack_unpack_copy, check_idxlist_copy
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_int_kind, &
       xt_idxlist, xt_idxvec_new, xt_idxfsection_new, &
       xt_idxlist_collection_new, xt_idxlist_delete, xt_stripe, &
       xt_idxlist_get_intersection, xt_idxsection_new, xt_idxstripes_new, &
       xt_bounds, xt_idxempty_new, xt_idxlist_get_bounding_box, OPERATOR(/=)
  USE xt_sort, ONLY: xt_sort_xt_int
  USE iso_c_binding, ONLY: c_size_t
  IMPLICIT NONE
  CHARACTER(len=*), PARAMETER :: filename = 'test_idxlist_collection_f.f90'
  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)

  CALL test_idxlist_collection_pack_unpack
  CALL test_idxlist_collection_copy
  CALL test_idxlist_collection_intersection
  CALL test_idxlist_collection_heterogeneous
  CALL test_bounding_box1
  CALL test_bounding_box2
  call test_idxfsections

  CALL xt_finalize
  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL finish_mpi

CONTAINS
  SUBROUTINE test_idxlist_collection_pack_unpack
    INTEGER, PARAMETER :: num_indices = 7, num_vec = 2
    INTEGER(xt_int_kind) :: i, j
    INTEGER(xt_int_kind), PARAMETER :: index_list(num_indices, num_vec) = &
         RESHAPE((/ ((INT(i, xt_int_kind), i = 1, num_indices), &
         &                                 j = 1, num_vec) /), &
         &       shape = (/ num_indices, num_vec /))
    TYPE(xt_idxlist) :: idxlists(num_vec), collectionlist, collectionlist_copy
    TYPE(xt_stripe), PARAMETER :: ref_stripes(num_vec) = xt_stripe(1, 1, 7)
    INTEGER :: k
    DO k = 1, num_vec
      idxlists(k) = xt_idxvec_new(index_list(:, k), num_indices)
    END DO
    collectionlist = xt_idxlist_collection_new(idxlists)
    CALL xt_idxlist_delete(idxlists)
    CALL check_idxlist(collectionlist, &
         RESHAPE(index_list, (/ SIZE(index_list) /)))
    collectionlist_copy = idxlist_pack_unpack_copy(collectionlist)
    CALL check_idxlist_copy(collectionlist, collectionlist_copy, &
         RESHAPE(index_list, (/ SIZE(index_list) /)), ref_stripes)
    CALL xt_idxlist_delete(collectionlist_copy)
    CALL xt_idxlist_delete(collectionlist)
  END SUBROUTINE test_idxlist_collection_pack_unpack

  SUBROUTINE test_idxlist_collection_copy
    INTEGER, PARAMETER :: num_indices = 7, num_vec = 2
    INTEGER(xt_int_kind) :: i, j
    INTEGER(xt_int_kind), PARAMETER :: index_list(num_indices, num_vec) = &
         RESHAPE((/ ((INT(num_indices - (j * num_indices + 1 - j - i) &
         &                * (2*j - 1), xt_int_kind), &
         &           i=1, num_indices), j=1,0,-1) /), &
         &       (/ num_indices, num_vec /))
    TYPE(xt_idxlist) :: idxlists(num_vec), collectionlist, collectionlist_copy
    TYPE(xt_stripe), PARAMETER :: ref_stripes(num_vec) &
         = (/ xt_stripe(1, 1, 7), xt_stripe(7, -1, 7) /)
    INTEGER :: k
    DO k = 1, num_vec
      idxlists(k) = xt_idxvec_new(index_list(:, k), num_indices)
    END DO
    collectionlist = xt_idxlist_collection_new(idxlists)
    CALL xt_idxlist_delete(idxlists)
    CALL check_idxlist(collectionlist, &
         RESHAPE(index_list, (/ SIZE(index_list) /)))
    collectionlist_copy = idxlist_pack_unpack_copy(collectionlist)
    CALL check_idxlist_copy(collectionlist, collectionlist_copy, &
         RESHAPE(index_list, (/ SIZE(index_list) /)), ref_stripes)
    CALL xt_idxlist_delete(collectionlist_copy)
    CALL xt_idxlist_delete(collectionlist)
  END SUBROUTINE test_idxlist_collection_copy

  SUBROUTINE test_idxlist_collection_intersection
    INTEGER, PARAMETER :: num_indices = 7, num_lists = 3
    INTEGER, PARAMETER :: xi = xt_int_kind
    INTEGER(xt_int_kind), PARAMETER :: index_list(num_indices, num_lists) &
         = RESHAPE((/ 1_xi, 2_xi, 3_xi, 4_xi, 5_xi, 6_xi, 7_xi, &
         &            7_xi, 6_xi, 5_xi, 4_xi, 3_xi, 2_xi, 1_xi, &
         &            2_xi, 6_xi, 1_xi, 4_xi, 7_xi, 3_xi, 0_xi /),  &
         &         (/ num_indices,  num_lists /)), &
         sorted_index_list(SIZE(index_list)) &
         = (/ 0_xi, 1_xi, 1_xi, 1_xi, 2_xi, 2_xi, 2_xi, &
         &    3_xi, 3_xi, 3_xi, 4_xi, 4_xi, 4_xi, 5_xi, &
         &    5_xi, 6_xi, 6_xi, 6_xi, 7_xi, 7_xi, 7_xi /)
    TYPE(xt_idxlist) :: idxlists(num_lists), collectionlist, intersection, &
         ref_idxvec
    INTEGER :: i

    DO i = 1, 3
      idxlists(i) = xt_idxvec_new(index_list(:, i), num_indices)
    END DO
    collectionlist = xt_idxlist_collection_new(idxlists)
    DO i = 1, 3
      CALL xt_idxlist_delete(idxlists(i))
    END DO
    CALL check_idxlist(collectionlist, &
         RESHAPE(index_list, (/ SIZE(index_list) /)))
    ref_idxvec = xt_idxvec_new(RESHAPE(index_list, (/ SIZE(index_list) /)), &
         SIZE(index_list))
    intersection = xt_idxlist_get_intersection(ref_idxvec, collectionlist)
    CALL check_idxlist(intersection, sorted_index_list)
    CALL xt_idxlist_delete(intersection)
    intersection = xt_idxlist_get_intersection(collectionlist, ref_idxvec)
    CALL check_idxlist(intersection, sorted_index_list)
    CALL xt_idxlist_delete(intersection)
    CALL xt_idxlist_delete(ref_idxvec)
    CALL xt_idxlist_delete(collectionlist)

  END SUBROUTINE test_idxlist_collection_intersection

  SUBROUTINE test_idxlist_collection_heterogeneous
    INTEGER, PARAMETER :: num_indices = 6, num_lists = 3
    INTEGER, PARAMETER :: xi = xt_int_kind
    INTEGER(xt_int_kind), PARAMETER :: &
         index_list(num_indices) = (/ 1_xi, 3_xi, 5_xi, 7_xi, 9_xi, 11_xi /)
    TYPE(xt_stripe), PARAMETER :: stripes(2) = (/ xt_stripe(0, 2, 5), &
         xt_stripe(1, 2, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: local_start(2) = 2
    INTEGER(xt_int_kind), PARAMETER :: global_size(2) = (/ 10_xi, 10_xi /)
    INTEGER, PARAMETER :: local_size(2) = 5
    INTEGER, PARAMETER :: ref_size = num_indices + stripes(1)%nstrides &
         + stripes(2)%nstrides + local_size(1) * local_size(2)
    INTEGER(xt_int_kind), PARAMETER :: ref_index_list(ref_size) &
         = (/ 1_xi, 3_xi, 5_xi, 7_xi, 9_xi, 11_xi, &
         &    0_xi, 2_xi, 4_xi, 6_xi, 8_xi, 1_xi, 3_xi, 5_xi, 7_xi, 9_xi, &
         &    22_xi, 23_xi, 24_xi, 25_xi, 26_xi, &
         &    32_xi, 33_xi, 34_xi, 35_xi, 36_xi, &
         &    42_xi, 43_xi, 44_xi, 45_xi, 46_xi, &
         &    52_xi, 53_xi, 54_xi, 55_xi, 56_xi, &
         &    62_xi, 63_xi, 64_xi, 65_xi, 66_xi /)
    TYPE(xt_idxlist) :: idxlists(num_lists), collectionlist

    idxlists(1) = xt_idxvec_new(index_list, SIZE(index_list))
    idxlists(2) = xt_idxstripes_new(stripes, SIZE(stripes))
    idxlists(3) = xt_idxsection_new(0_xt_int_kind, global_size, local_size, &
         local_start)

    ! generate a collection index list
    collectionlist = xt_idxlist_collection_new(idxlists)

    CALL xt_idxlist_delete(idxlists)

    ! test generated collection list
    CALL check_idxlist(collectionlist, ref_index_list)

    CALL xt_idxlist_delete(collectionlist)

  END SUBROUTINE test_idxlist_collection_heterogeneous

  SUBROUTINE test_bounding_box1
    INTEGER, PARAMETER :: ndim=3, num_lists = 2
    INTEGER(xt_int_kind), PARAMETER :: global_size_bb(ndim) = 4, &
         global_start_index = 0
    TYPE(xt_idxlist) :: idxlists(num_lists), collectionlist
    TYPE(xt_bounds) :: bounds(ndim)
    INTEGER :: i

    DO i = 1, num_lists
      idxlists(i) = xt_idxempty_new()
    END DO
    collectionlist = xt_idxlist_collection_new(idxlists)
    CALL xt_idxlist_delete(idxlists)
    bounds = xt_idxlist_get_bounding_box(collectionlist, global_size_bb, &
         global_start_index)
    IF (ANY(bounds%size /= 0)) &
         CALL test_abort("ERROR: non-zero bounding box size", &
         filename, __LINE__)
    CALL xt_idxlist_delete(collectionlist)
  END SUBROUTINE test_bounding_box1

  SUBROUTINE test_bounding_box2
    INTEGER, PARAMETER :: ndim = 3, num_lists = 2, num_indices = 3
    INTEGER, PARAMETER :: xi = xt_int_kind
    INTEGER(xt_int_kind), PARAMETER :: indices(num_indices, num_lists) &
         = RESHAPE( (/ 45_xi, 35_xi, 32_xi, 32_xi, 48_xi, 33_xi /), &
         &          (/ num_indices, num_lists /)), &
         global_size(ndim) = (/ 5_xi, 4_xi, 3_xi /), &
         global_start_index = 1
    TYPE(xt_idxlist) :: idxlists(num_lists), collectionlist
    TYPE(xt_bounds) :: bounds(ndim)
    TYPE(xt_bounds), PARAMETER :: bounds_ref(ndim) = (/ xt_bounds(2, 2), &
         xt_bounds(2, 2), xt_bounds(1, 2) /)
    INTEGER :: i

    DO i = 1, num_lists
      idxlists(i) = xt_idxvec_new(indices(:, i), SIZE(indices, 1))
    END DO
    collectionlist = xt_idxlist_collection_new(idxlists)
    CALL xt_idxlist_delete(idxlists)

    bounds = xt_idxlist_get_bounding_box(collectionlist, global_size, &
         global_start_index)
    CALL xt_idxlist_delete(collectionlist)
    IF (ANY(bounds /= bounds_ref)) &
         CALL test_abort("ERROR: unexpected boundaries", filename, __LINE__)
  END SUBROUTINE test_bounding_box2

  SUBROUTINE test_idxfsections()

    INTEGER, PARAMETER :: irank = 4, &
         num_regions=5
    INTEGER, PARAMETER :: xi = xt_int_kind
    !
    INTEGER :: iseg
    !
    INTEGER(xt_int_kind), PARAMETER :: gsz(irank) &
         =  (/ 132_xi, 122_xi, 1_xi, 1_xi /),     &
         global_index_start = 1_xi
    INTEGER, PARAMETER :: lsz(irank, num_regions) &
         = RESHAPE((/  8, 15, 1, 1, &  ! core region
         &            14,  3, 1, 1, &  ! 1st halo
         &            14,  3, 1, 1, &  ! 2nd halo
         &             3, 15, 1, 1, &  ! 3rd halo
         &             3, 15, 1, 1 /), &  ! 4th halo
         &          (/ irank, num_regions /))
    INTEGER(xt_int_kind) :: lst(irank, num_regions) &
         = RESHAPE((/ 43_xi, 47_xi, 1_xi, 1_xi, &
         &            40_xi, 44_xi, 1_xi, 1_xi, &
         &            40_xi, 62_xi, 1_xi, 1_xi, &
         &            51_xi, 47_xi, 1_xi, 1_xi, &
         &            40_xi, 47_xi, 1_xi, 1_xi /), &
         &         (/ irank, num_regions /))
    !
    TYPE(xt_idxlist) :: component_idxlists(num_regions)
    !
    TYPE(xt_idxlist) :: collection_idxlist, global_section, intersection
    !
    INTEGER(kind=xi), DIMENSION(:), ALLOCATABLE :: indices
    INTEGER :: i1, i2, i3, i4, num_indices, idx_ofs
    INTEGER(kind=xi) :: dim_ofs2, dim_ofs3, dim_ofs4, &
         idx_stride2, idx_stride3, idx_stride4

    num_indices = SUM(PRODUCT(lsz, dim=1))
    ALLOCATE(indices(num_indices))
    idx_ofs = 0
    segments: DO iseg = 1, num_regions
      component_idxlists(iseg) = xt_idxfsection_new( &
           global_index_start     &    ! start index
           , gsz(:) &    ! global size
           , lsz(:, iseg) &    ! local size
           , lst(:, iseg) &    ! local start
           )
      idx_stride4 = gsz(1) * gsz(2) * gsz(3)
      idx_stride3 = gsz(1) * gsz(2)
      idx_stride2 = gsz(1)
      DO i4 = 1, lsz(4, iseg)
        dim_ofs4 = (lst(4, iseg)+i4-2) * idx_stride4
        DO i3 = 1, lsz(3, iseg)
          dim_ofs3 = (lst(3, iseg)+i3-2) * idx_stride3 + dim_ofs4
          DO i2 = 1, lsz(2, iseg)
            dim_ofs2 = (lst(2, iseg)+i2-2) * idx_stride2 + dim_ofs3
            DO i1 = 1, lsz(1, iseg)
              indices(idx_ofs+i1) = lst(1, iseg) + i1 - 2 &
                   + global_index_start + dim_ofs2
            END DO
            idx_ofs = idx_ofs + lsz(1, iseg)
          END DO
        END DO
      END DO
    END DO segments

    ! COLLECTION
    collection_idxlist = xt_idxlist_collection_new(component_idxlists(:))

    CALL check_idxlist(collection_idxlist, indices)

    ! GLOBAL FIELD
    global_section = xt_idxfsection_new( &
         1_xi     &    ! start index
         , gsz(:) &    ! global size
         , INT(gsz(:)) &    ! local size
         , (/ 1_xi, 1_xi, 1_xi, 1_xi /) &    ! local start
         )

    intersection &
         = xt_idxlist_get_intersection(global_section, collection_idxlist)
#ifdef HAVE_SIZE_KIND_ARGUMEN
    CALL xt_sort_xt_int(indices, SIZE(indices, kind=c_size_t))
#else
    CALL xt_sort_xt_int(indices, INT(SIZE(indices), c_size_t))
#endif
    CALL check_idxlist(intersection, indices)
    CALL xt_idxlist_delete(intersection)
    CALL xt_idxlist_delete(global_section)
    CALL xt_idxlist_delete(collection_idxlist)
    CALL xt_idxlist_delete(component_idxlists)

  END SUBROUTINE test_idxfsections

END PROGRAM test_idxlist_collection_f
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_xmap_dist_dir_intercomm_parallel_f.f90
!!
!! @copyright Copyright  (C)  2013 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_xmap_dist_dir_intercomm_parallel
  USE xt_xmap_abstract, ONLY: xt_xmap_dist_dir_new
  USE test_xmap_common_intercomm_parallel, ONLY: &
       xmap_intercomm_parallel_test_main
  IMPLICIT NONE
  INTERFACE
    FUNCTION xmap_dist_dir_intercomm_wrap(src_idxlist, dst_idxlist, &
         inter_comm) RESULT(xmap)
      USE yaxt, ONLY: xt_xmap, xt_idxlist
      TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
      INTEGER, INTENT(in) :: inter_comm
      TYPE(xt_xmap) :: xmap
    END FUNCTION  xmap_dist_dir_intercomm_wrap
  END INTERFACE
  CALL xmap_intercomm_parallel_test_main(xt_xmap_dist_dir_new, &
       call_finalize=.FALSE.)
  CALL xmap_intercomm_parallel_test_main(xmap_dist_dir_intercomm_wrap, &
       call_initialize=.FALSE.)
END PROGRAM test_xmap_dist_dir_intercomm_parallel

FUNCTION xmap_dist_dir_intercomm_wrap(src_idxlist, dst_idxlist, inter_comm) &
     RESULT(xmap)
  USE yaxt, ONLY: xt_xmap_dist_dir_intercomm_new, xt_xmap, xt_idxlist
  USE test_xmap_common_intercomm_parallel, ONLY: intra_group_comm
  TYPE(xt_idxlist), INTENT(in) :: src_idxlist, dst_idxlist
  INTEGER, INTENT(in) :: inter_comm
  TYPE(xt_xmap) :: xmap
  xmap = xt_xmap_dist_dir_intercomm_new(src_idxlist, dst_idxlist, &
       inter_comm, intra_group_comm)
END FUNCTION  xmap_dist_dir_intercomm_wrap

!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_exchanger_parallel_f.f90
!!
!! @copyright Copyright  (C)  2024 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
#define FP_EQ(a, b) (ABS((a)-(b)) < EPSILON((a)))
PROGRAM test_exchanger_parallel
  USE iso_c_binding, ONLY: c_ptr, c_loc, c_int, c_null_ptr
  USE mpi
  USE yaxt
  USE xt_exchanger_abstract
  USE ftest_common
  IMPLICIT NONE
  CHARACTER(len=*), PARAMETER :: filename = 'test_exchanger_parallel_f.f90'
  TYPE test_message
    INTEGER :: rank       !< rank of communication partner
    INTEGER, ALLOCATABLE :: pos(:)   !< positions to be sent/received
  END TYPE test_message

  TYPE(xt_config) :: config
  INTEGER :: test_freq = 3
  INTEGER, PARAMETER :: num_mt_modes = 1 &
#ifdef _OPENMP
       + 1 &
#endif
       + 0

  INTEGER, PARAMETER :: mt_configs_2_test(num_mt_modes) = (/ XT_MT_NONE &
#ifdef _OPENMP
    , XT_MT_OPENMP &
#endif
    /)
#if XT_ENABLE_ALTERNATIVE_EXCHANGER_SEND_MODES
  INTEGER, PARAMETER :: num_send_modes = 3
#else
  INTEGER, PARAMETER :: num_send_modes = 1
#endif
  INTEGER, PARAMETER :: send_comm_modes_2_test(num_send_modes) = (/ &
       xt_exch_send_standard &
#if XT_ENABLE_ALTERNATIVE_EXCHANGER_SEND_MODES
       , xt_exch_send_buffered, &
       xt_exch_send_synchronous &
#endif
       /)
  INTEGER :: comm
  INTEGER :: m, i, sm, split_rank, world_size_2
#ifdef _OPENMP
  INTEGER :: thread_support_provided
#endif
  INTEGER, ALLOCATABLE :: exchanger_code(:)
  INTEGER, ALLOCATABLE :: split_comm(:)
  INTEGER :: world_size, world_rank, buf_size, buf_size_, ierror
  INTEGER(c_int), ALLOCATABLE :: buf(:)
  TYPE(c_ptr) :: bufp

  comm = mpi_comm_world

  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)

  CALL parse_options(exchanger_code, test_freq)
  config = xt_config_new()
  ! todo: replace computation with query of exchanger
  CALL mpi_comm_size(comm, world_size, ierror)
  CALL mpi_comm_rank(comm, world_rank, ierror)
  buf_size = (4 + mpi_bsend_overhead) * world_size
  ALLOCATE(buf((buf_size+3)/4))
  CALL mpi_buffer_attach(buf, buf_size, ierror)
  world_size_2 = world_size/2
  ALLOCATE(split_comm(0:world_size_2))
  split_comm(0) = mpi_comm_world
  DO split_rank = 1, world_size_2
    CALL mpi_comm_split(mpi_comm_world, &
         MERGE(1, 0, world_rank < split_rank), world_rank, &
         split_comm(split_rank), ierror)
  END DO
  DO m = 1, num_mt_modes
#ifdef _OPENMP
    CALL mpi_query_thread(thread_support_provided, ierror)
    IF (mt_configs_2_test(m) == XT_MT_OPENMP &
         .AND. thread_support_provided /= MPI_THREAD_MULTIPLE) CYCLE
#endif
    DO split_rank = 0, world_size_2
      comm = split_comm(split_rank)
      CALL xt_config_set_redist_mthread_mode(config, mt_configs_2_test(m))
      DO sm = 1, num_send_modes
        CALL xt_config_set_exchange_send_comm_mode(config, &
             send_comm_modes_2_test(sm))
        DO i = 1, SIZE(exchanger_code)
          CALL xt_config_set_exchange_method(config, exchanger_code(i))

          CALL test_bcast(comm, config)

          CALL test_gather(comm, config)

          CALL test_all2all(comm, config)

          CALL test_rr(comm, config)

          CALL test_intercomm_all2all(comm, config)
        END DO
      END DO
    END DO
  END DO
  DO split_rank = 1, world_size_2
    CALL mpi_comm_free(split_comm(split_rank), ierror)
  END DO

  CALL mpi_buffer_detach(bufp, buf_size_, ierror)
  CALL xt_config_delete(config)
  DEALLOCATE(exchanger_code, buf, split_comm)

  CALL xt_finalize
  CALL finish_mpi

CONTAINS

  SUBROUTINE parse_options(exchanger_codes, test_freq)
    INTEGER, ALLOCATABLE, INTENT(out) :: exchanger_codes(:)
    INTEGER, INTENT(inout) :: test_freq
    INTEGER, PARAMETER :: num_exchanger = 3 &
#ifdef XT_ENABLE_DDT_EXCHANGER
         + 1 &
#endif
#ifdef XT_CAN_USE_MPI_NEIGHBOR_ALLTOALL
         + 1 &
#endif
         + 1
    INTEGER, PARAMETER :: exchanger_table(num_exchanger) = (/ &
         xt_exchanger_irecv_send, &
         xt_exchanger_irecv_isend, &
         xt_exchanger_irecv_isend_packed, &
#ifdef XT_ENABLE_DDT_EXCHANGER
         xt_exchanger_irecv_isend_ddt_packed, &
#endif
#ifdef XT_CAN_USE_MPI_NEIGHBOR_ALLTOALL
         xt_exchanger_neigh_alltoall, &
#endif
         xt_exchanger_mix_isend_irecv /)
    LOGICAL :: selected_exchanger(num_exchanger)
    INTEGER :: j, i, num_cmd_args, arg_len, opt_len, &
         exchanger_new_id, freq, ierror, num_sel_exch
#ifndef XT_ENABLE_DDT_EXCHANGER
    INTEGER :: my_world_rank
#endif
    INTEGER, PARAMETER :: max_opt_arg_len = 80
    CHARACTER(max_opt_arg_len) :: optarg, opt

    selected_exchanger = .FALSE.
    selected_exchanger(xt_exchanger_mix_isend_irecv) = .TRUE.
    num_cmd_args = COMMAND_ARGUMENT_COUNT()
    i = 1
    DO WHILE (i < num_cmd_args)
      CALL GET_COMMAND_ARGUMENT(i, opt, opt_len)
      IF (opt_len == 2 .AND. opt(1:1) == '-') THEN
        IF (i < num_cmd_args) THEN
          CALL GET_COMMAND_ARGUMENT(i + 1, optarg, arg_len)
        ELSE
          WRITE (0, '(4a)') &
               'unexpected command-line argument parsing error: ', &
               opt(1:opt_len), ' ', optarg(1:arg_len)
          FLUSH(0)
          CALL test_abort('unexpected command-line argument', &
               filename, __LINE__)
        END IF
        SELECT CASE (opt(2:2))
        CASE('m')
          IF (arg_len > max_opt_arg_len) &
               CALL test_abort('incorrect argument to command-line option -m', &
               filename, __LINE__)
          exchanger_new_id &
               = xt_exchanger_id_by_name(optarg(1:LEN_TRIM(optarg)))
          IF (exchanger_new_id == -1) THEN
            WRITE (0, '(2a)') &
                 'unexpected command-line argument parsing error: ', &
                 optarg(1:arg_len)
            FLUSH(0)
            CALL test_abort('unexpected command-line argument', &
                 filename, __LINE__)
#ifndef XT_CAN_USE_MPI_NEIGHBOR_ALLTOALL
          ELSE IF (exchanger_new_id == xt_exchanger_neigh_alltoall) THEN
            WRITE (0, '(a)') &
                 "xt_exchanger_neigh_alltoall_new requires MPI version 3.0 or &
                 &higher"
            i = i + 2
            CYCLE
#endif
#ifndef XT_ENABLE_DDT_EXCHANGER
          ELSE IF (exchanger_new_id == xt_exchanger_irecv_isend_ddt_packed) THEN
            CALL mpi_comm_rank(mpi_comm_world, my_world_rank, ierror)
            IF (my_world_rank == 0) THEN
              WRITE (0, '(a)') &
                   "notice: xt_exchanger_irecv_isend_ddt_packed disabled."
            END IF
            i = i + 2
            CYCLE
#endif
          ELSE
            DO j = 1, num_exchanger
              IF (exchanger_table(j) == exchanger_new_id) THEN
                selected_exchanger(j) = .TRUE.
                EXIT
              END IF
            END DO
          END IF
        CASE('-s')
          READ (optarg(1:arg_len), fmt=*, iostat=ierror) freq
          IF (ierror /= 0) THEN
            WRITE (0, '(3a,i0)') &
                 'unexpected command-line argument parsing error: ', &
                 optarg(1:arg_len), ' ', ierror
            FLUSH(0)
            CALL test_abort('unexpected command-line argument', &
                 filename, __LINE__)
          END IF
          test_freq = freq
        END SELECT
      ELSE
        WRITE (0, '(2a)') 'unknown argument: ', opt
        CALL test_abort('unexpected command-line argument', &
             filename, __LINE__)
      END IF
      i = i + 2
    END DO
    num_sel_exch = COUNT(selected_exchanger)
    ALLOCATE(exchanger_codes(num_sel_exch))
    exchanger_codes = PACK(exchanger_table, selected_exchanger)
  END SUBROUTINE parse_options

  SUBROUTINE data_exchange(exchanger, src_data_p, dst_data_p, async)
    TYPE(xt_exchanger), INTENT(inout) :: exchanger
    TYPE(c_ptr), INTENT(in) :: src_data_p, dst_data_p
    LOGICAL, INTENT(in) :: async

    TYPE(xt_request) :: request
    LOGICAL :: request_finished

    IF (async) THEN
      CALL xt_exchanger_a_exchange(exchanger, src_data_p, &
           dst_data_p, request)
      CALL xt_request_test(request, request_finished)
      CALL xt_request_wait(request)
      CALL xt_request_test(request, request_finished)
      IF (.NOT. request_finished) &
           CALL test_abort("invalid flag result", filename, __LINE__)
    ELSE
      CALL xt_exchanger_s_exchange(exchanger, src_data_p, dst_data_p)
    END IF
  END SUBROUTINE data_exchange

  SUBROUTINE test_bcast(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config

    TYPE(xt_msg_param), ALLOCATABLE :: send_msgs(:)
    TYPE(xt_msg_param) :: recv_msgs(1)
    TYPE(xt_exchanger) :: exchanger
    TYPE(c_ptr) :: src_data_p, dst_data_p
    INTEGER, TARGET :: src_data(1), dst_data(1)
    INTEGER :: my_rank, comm_size, ierror
    INTEGER :: incr, i, j, nsend, nrecv, exchange_method, &
         test_async, test_async_ubound

    CALL mpi_comm_rank(comm, my_rank, ierror)
    CALL mpi_comm_size(comm, comm_size, ierror)
    exchange_method = xt_config_get_exchange_method(config)
    src_data_p = C_LOC(src_data)
#if defined __GNUC__ && ( __GNUC__ >= 5 && ( __GNUC__ <= 7 \
    || __GNUC__ == 8 && __GNUC_MINOR__ < 4 ) \
    || __GNUC__ == 4 && __GNUC_MINOR__ == 6 )
    CALL xt_slice_c_loc(dst_data, dst_data_p)
#else
    dst_data_p = C_LOC(dst_data)
#endif

    ! bcast pattern
    incr = comm_size/test_freq + MERGE(1, 0, comm_size < test_freq)
    DO i = 0, comm_size-1, incr
      ! setup
      nsend = 0
      nrecv = MERGE(1, 0, my_rank /= i)

      IF (my_rank == i) THEN
        nsend = comm_size - 1
        ALLOCATE(send_msgs(nsend))
        DO j = 0, i-1
          send_msgs(j+1) = xt_msg_param(rank=j, &
               datatype=mpi_integer, displacement=0_mpi_address_kind, count=1)
        END DO
        DO j = i, nsend-1
          send_msgs(j+1) = xt_msg_param(rank=MOD(1+j, comm_size), &
               datatype=mpi_integer, displacement=0_mpi_address_kind, count=1)
        END DO
        recv_msgs(1) = xt_msg_param(rank=-1, datatype=mpi_datatype_null, &
             displacement=0_mpi_address_kind, count=1)
      ELSE
        ALLOCATE(send_msgs(0))
        recv_msgs(1) = xt_msg_param(rank=i, datatype=mpi_integer, &
           displacement=0_mpi_address_kind, count=1)
      END IF

      exchanger = xt_exchanger_new(nsend, nrecv, send_msgs, &
           recv_msgs, comm, 0, config)

      ! run the test
      test_async_ubound &
           = MERGE(1, 2, exchange_method == xt_exchanger_irecv_send)
      DO test_async = 1, test_async_ubound
        src_data(1) = MERGE(4711, -1, my_rank == i)
        dst_data(1) = MERGE(4711, -1, my_rank == i)
        CALL data_exchange(exchanger, src_data_p, &
               dst_data_p, test_async > 1)
        IF (dst_data(1) /= 4711) &
             CALL test_abort("invalid data", filename, __LINE__)
      END DO

      ! cleanup
      DEALLOCATE(send_msgs)
      CALL xt_exchanger_delete(exchanger)
    END DO
  END SUBROUTINE test_bcast

  SUBROUTINE test_gather(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config

    INTEGER, PARAMETER :: num_exchanges=2
    TYPE(xt_exchanger) :: exchanger(2)
    TYPE(xt_msg_param) :: send_msgs(1)
    TYPE(xt_msg_param), ALLOCATABLE :: recv_msgs(:,:)
    TYPE(c_ptr) :: src_data_p, dst_data_p
    INTEGER, ALLOCATABLE :: dt_by_ofs(:)
    REAL, ALLOCATABLE, TARGET :: dst_data(:, :)

    INTEGER :: my_rank, comm_size, ierror
    INTEGER :: incr, i, j, nsend, nrecv, exchange_method, &
         test_async, test_async_ubound
    LOGICAL :: no_mismatch
    REAL, TARGET :: src_data(1)

    CALL mpi_comm_rank(comm, my_rank, ierror)
    CALL mpi_comm_size(comm, comm_size, ierror)
    exchange_method = xt_config_get_exchange_method(config)
    src_data_p = C_LOC(src_data)

    ! gather pattern
    ! prepare datatypes outside of loop for load-balance
    ALLOCATE(dt_by_ofs(comm_size))
    dt_by_ofs(1) = MPI_REAL
    DO j = 2, comm_size
      CALL mpi_type_indexed(1, (/ 1 /), (/ j-1 /), MPI_REAL, dt_by_ofs(j), &
           ierror)
      CALL mpi_type_commit(dt_by_ofs(j), ierror)
    END DO
    ALLOCATE(dst_data(comm_size-1, 2))
    incr = comm_size/test_freq + MERGE(1, 0, comm_size < test_freq)
    DO i = 0, comm_size-1, incr
      ! setup
      nsend = MERGE(1, 0, i /= my_rank)
      nrecv = 0


      send_msgs(1) = xt_msg_param(rank=i, datatype=MPI_REAL, &
           displacement=0_mpi_address_kind, count=1)
      ALLOCATE(recv_msgs(MERGE(comm_size-1, 1, my_rank == i), 2))
      IF (my_rank == i) THEN
        nrecv = comm_size - 1
        DO j = 1, nrecv
          recv_msgs(j, 1)%rank = MOD(i + j, comm_size)
          recv_msgs(j, 1)%datatype = dt_by_ofs(j)
          recv_msgs(j, 1)%displacement = 0_mpi_address_kind
          recv_msgs(j, 1)%count=1
          recv_msgs(j, 2)%rank &
               = MOD(comm_size - j + i, comm_size)
          recv_msgs(j, 2)%datatype = dt_by_ofs(j)
          recv_msgs(j, 2)%displacement = 0
          recv_msgs(j, 2)%count=1
        END DO
      END IF

      DO j = 1, num_exchanges
        exchanger(j) = xt_exchanger_new(nsend, nrecv, send_msgs, &
             recv_msgs(1:nrecv, j), comm, 0, config)
      END DO

      ! run test
      test_async_ubound &
           = MERGE(1, 2, exchange_method == xt_exchanger_irecv_send)
      dst_data_p = c_null_ptr
      DO test_async = 1, test_async_ubound
        src_data(1) = REAL(MOD(my_rank+comm_size-i, comm_size))
        dst_data = -1.0
        DO j = 1, num_exchanges
          IF (nrecv > 0) dst_data_p = C_LOC(dst_data(1, j))
          CALL data_exchange(exchanger(j), src_data_p, &
               dst_data_p, test_async > 1)
        END DO
      END DO

      no_mismatch = .TRUE.
      DO j = 1, nrecv
        no_mismatch = no_mismatch .AND. FP_EQ(dst_data(j, 1), REAL(j)) &
             .AND. FP_EQ(dst_data(j, 2), REAL(comm_size - j))
      END DO
      IF (no_mismatch) THEN
        CONTINUE
      ELSE
        CALL test_abort("invalid data", filename, __LINE__)
      END IF
      ! cleanup
      DEALLOCATE(recv_msgs)
      CALL xt_exchanger_delete(exchanger)
    END DO

    DEALLOCATE(dst_data)
    DO j = 2, comm_size
      CALL mpi_type_free(dt_by_ofs(j), ierror)
    END DO
    DEALLOCATE(dt_by_ofs)
  END SUBROUTINE test_gather

  SUBROUTINE test_all2all(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config

    TYPE(xt_msg_param), ALLOCATABLE :: send_msgs(:), recv_msgs(:)
    TYPE(xt_exchanger) :: exchanger
    INTEGER, ALLOCATABLE :: dt_by_ofs(:)
    DOUBLE PRECISION, ALLOCATABLE, TARGET :: dst_data(:)
    DOUBLE PRECISION, TARGET :: src_data
    TYPE(c_ptr) :: src_data_p, dst_data_p
    INTEGER :: my_rank, comm_size, ierror
    INTEGER :: incr, i, j, k, nsend, nrecv, exchange_method, &
         test_async, test_async_ubound, ofs
    LOGICAL :: no_mismatch

    CALL mpi_comm_rank(comm, my_rank, ierror)
    CALL mpi_comm_size(comm, comm_size, ierror)
    exchange_method = xt_config_get_exchange_method(config)
    src_data_p = C_LOC(src_data)
    ALLOCATE(dst_data(comm_size))
    dst_data_p = C_LOC(dst_data)
    src_data = DBLE(my_rank)

    ! all-to-all pattern
    ! setup
    nsend = comm_size - 1
    nrecv = comm_size - 1

    ALLOCATE(send_msgs(nsend), recv_msgs(nrecv))
    DO j = 1, nsend
      send_msgs(j)%datatype = mpi_double_precision
      send_msgs(j)%displacement = 0_mpi_address_kind
      send_msgs(j)%count = 1
    END DO
    ALLOCATE(dt_by_ofs(0:comm_size-1))
    dt_by_ofs(0) = MERGE(mpi_double_precision, mpi_datatype_null, my_rank /= 0)
    DO i = 1, comm_size-1
      IF (i /= my_rank) THEN
        CALL mpi_type_indexed(1, (/ 1 /), (/ i /), mpi_double_precision, &
             dt_by_ofs(i), ierror)
        CALL MPI_Type_commit(dt_by_ofs(i), ierror)
      ELSE
        dt_by_ofs(i) = MPI_DATATYPE_NULL
      END IF
    END DO
    incr = comm_size/test_freq + MERGE(1, 0, comm_size < test_freq)
    DO i = 0, comm_size - 2, incr
      DO j = 1, nsend
        ofs = my_rank + i + j
        send_msgs(j)%rank = MOD(ofs + MERGE(1, 0, ofs >= comm_size + my_rank),&
             comm_size)
      END DO
      DO j = 0, comm_size - 2, incr
        DO k = 1, nrecv
          ofs = MOD(i + j + k-1, comm_size - 1)
          ofs = ofs + MERGE(1, 0, ofs >= my_rank)
          recv_msgs(k)%rank = ofs
          recv_msgs(k)%datatype = dt_by_ofs(ofs) ! replace by mpi_double_precision
          recv_msgs(k)%displacement = 0 ! replace by sizeof (double precision) * ofs
          recv_msgs(k)%count = 1
        END DO
        exchanger = xt_exchanger_new(nsend, nrecv, send_msgs, &
             recv_msgs, comm, 0, config)
        ! test
        test_async_ubound &
           = MERGE(1, 2, exchange_method == xt_exchanger_irecv_send)
        DO test_async = 1, test_async_ubound
          dst_data(:) = DBLE(my_rank)

          CALL data_exchange(exchanger, src_data_p, &
               dst_data_p, test_async > 1)
          no_mismatch = .TRUE.
          DO k = 1, comm_size
            no_mismatch = no_mismatch .AND. FP_EQ(dst_data(k), DBLE(k-1))
          END DO
          IF (no_mismatch) THEN
            CONTINUE
          ELSE
            CALL test_abort("invalid data", filename, __LINE__)
          END IF
        END DO
        ! cleanup
        CALL xt_exchanger_delete(exchanger)
      END DO
    END DO
    DO i = 1, comm_size-1
      IF (i /= my_rank) &
           CALL mpi_type_free(dt_by_ofs(i), ierror)
    END DO
    DEALLOCATE(dt_by_ofs, dst_data, recv_msgs, send_msgs)
  END SUBROUTINE test_all2all

  SUBROUTINE test_rr(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config

    INTEGER, PARAMETER :: nrecv = 1, nsend = 1
    TYPE(xt_msg_param) :: send_msgs(nsend), recv_msgs(nrecv)
    TYPE(xt_exchanger) :: exchanger
    DOUBLE PRECISION, TARGET :: src_data(1), dst_data(1)
    TYPE(c_ptr) :: src_data_p, dst_data_p
    INTEGER :: my_rank, comm_size, ierror
    INTEGER :: incr, i, exchange_method, &
         test_async, test_async_ubound
#if defined __INTEL_COMPILER && (__INTEL_COMPILER_BUILD_DATE == 20110811 \
        || __INTEL_COMPILER < 1400)
    INTEGER(mpi_address_kind) :: addr_dummy
#endif

    CALL mpi_comm_rank(comm, my_rank, ierror)
    CALL mpi_comm_size(comm, comm_size, ierror)
    exchange_method = xt_config_get_exchange_method(config)

    src_data(1) = DBLE(my_rank)
    src_data_p = C_LOC(src_data)
#if defined __GNUC__ && ( __GNUC__ >= 5 && ( __GNUC__ <= 7 \
    || __GNUC__ == 8 && __GNUC_MINOR__ < 4 ) \
    || __GNUC__ == 4 && __GNUC_MINOR__ == 6 )
    CALL xt_slice_c_loc(dst_data, dst_data_p)
#else
    dst_data_p = C_LOC(dst_data)
#endif

    ! round robin pattern
    incr = comm_size/test_freq + MERGE(1, 0, comm_size < test_freq)
    DO i = 1, comm_size, incr
      ! setup
      send_msgs(1) = xt_msg_param(rank=MOD(my_rank+i, comm_size), &
           datatype=mpi_double_precision, displacement = 0_mpi_address_kind, &
           count=1)
      recv_msgs(1) = xt_msg_param(rank=MOD(my_rank+comm_size-i, comm_size), &
           datatype=mpi_double_precision, displacement=0_mpi_address_kind, &
           count=1)

      exchanger = xt_exchanger_new(nsend, nrecv, send_msgs, recv_msgs, &
           comm, 0, config)

      ! test
      test_async_ubound &
           = MERGE(1, 2, exchange_method == xt_exchanger_irecv_send)
      DO test_async = 1, test_async_ubound
        dst_data(1) = DBLE(-1)

        CALL data_exchange(exchanger, src_data_p, &
             dst_data_p, test_async > 1)
#if defined __INTEL_COMPILER && (__INTEL_COMPILER_BUILD_DATE == 20110811 \
        || __INTEL_COMPILER < 1400)
        ! the following call is only needed to make the optimizer
        ! in old Intel compilers less optimistic in their (mistaken)
        ! ability to predict changes to dst_data
        CALL mpi_get_address(dst_data, addr_dummy, ierror)
#endif
        IF (FP_EQ(dst_data(1), DBLE(MOD(my_rank + comm_size - i, comm_size)))) THEN
          CONTINUE
        ELSE
          CALL test_abort("invalid data", filename, __LINE__)
        END IF
      END DO
      ! cleanup
      CALL xt_exchanger_delete(exchanger)
    END DO
  END SUBROUTINE test_rr

  SUBROUTINE test_intercomm_all2all(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config

    TYPE(xt_msg_param), ALLOCATABLE :: send_msgs(:), recv_msgs(:)
    TYPE(xt_exchanger) :: exchanger
    DOUBLE PRECISION, TARGET, ALLOCATABLE :: dst_data(:)
    DOUBLE PRECISION, TARGET :: src_data(1)
    DOUBLE PRECISION :: dummy(2)
    INTEGER(mpi_address_kind) :: base, next, ofs
    INTEGER :: dst_data_offset
    TYPE(c_ptr) :: src_data_p, dst_data_p
    INTEGER :: my_rank, comm_size, ierror, &
         intra_group_comm, intra_rank, inter_comm, &
         local_size, remote_size
    INTEGER :: i, nsend, nrecv, exchange_method, &
         test_async, test_async_ubound, split_rank, group
    LOGICAL :: no_mismatch

    exchange_method = xt_config_get_exchange_method(config)
#ifdef XT_CAN_USE_MPI_NEIGHBOR_ALLTOALL
    ! inter-communicators are not defined for virtual topologies, which are
    ! used by xt_exchanger_neigh_alltoall_new
    IF (exchange_method == xt_exchanger_neigh_alltoall) RETURN
#endif
    CALL mpi_comm_rank(comm, my_rank, ierror)
    CALL mpi_comm_size(comm, comm_size, ierror)

    IF (comm_size == 1) RETURN

    ! generate intercomm
    split_rank = (comm_size * 2) / 3
    group = MERGE(1, 0, my_rank >= split_rank)
    ! split communicator with 2 to 1 ratio
    CALL mpi_comm_split(comm, group, 0, intra_group_comm, ierror)
    CALL mpi_intercomm_create(intra_group_comm, 0, comm, &
         MERGE(0, split_rank, group > 0), 0, inter_comm, ierror)

    CALL mpi_comm_rank(inter_comm, intra_rank, ierror)
    CALL mpi_comm_size(inter_comm, local_size, ierror)
    CALL mpi_comm_remote_size(inter_comm, remote_size, ierror)

    ! all-to-all pattern
    ! setup
    nsend = remote_size
    nrecv = remote_size
    src_data(1) = DBLE(my_rank)
    CALL mpi_get_address(dummy(1), base, ierror)
    CALL mpi_get_address(dummy(2), next, ierror)
    ofs = next - base

    ALLOCATE(send_msgs(nsend), recv_msgs(nrecv))
    DO i = 1, nsend
      send_msgs(i)%rank = i-1
      send_msgs(i)%datatype = mpi_double_precision
      send_msgs(i)%displacement = 0
      send_msgs(i)%count = 1
    END DO

    ALLOCATE(dst_data(nrecv))
    DO i = 1, nrecv
      recv_msgs(i)%rank = i-1
      recv_msgs(i)%datatype = mpi_double_precision
      recv_msgs(i)%displacement = ofs * (i-1)
      recv_msgs(i)%count = 1
    END DO

    dst_data_p = C_LOC(dst_data)
    src_data_p = C_LOC(src_data)

    exchanger = xt_exchanger_new(nsend, nrecv, send_msgs, recv_msgs, &
         inter_comm, 0, config)
    ! test
    test_async_ubound &
         = MERGE(1, 2, exchange_method == xt_exchanger_irecv_send)
    DO test_async = 1, test_async_ubound
      dst_data(:) = -1.0d0
      CALL data_exchange(exchanger, src_data_p, &
           dst_data_p, test_async > 1)
      dst_data_offset = MERGE(-1, split_rank-1, my_rank >= split_rank)
      no_mismatch = .TRUE.
      DO i = 1, nrecv
        no_mismatch = no_mismatch &
             .AND. FP_EQ(dst_data(i), DBLE(i+dst_data_offset))
      END DO
      IF (no_mismatch) THEN
        CONTINUE
      ELSE
        CALL test_abort("invalid data", filename, __LINE__)
      END IF
    END DO

    ! cleanup
    CALL xt_exchanger_delete(exchanger)

    DEALLOCATE(dst_data, recv_msgs, send_msgs)
    CALL mpi_comm_free(inter_comm, ierror)
    CALL mpi_comm_free(intra_group_comm, ierror)
  END SUBROUTINE test_intercomm_all2all

END PROGRAM test_exchanger_parallel

!
! Local Variables:
! c-basic-offset: 2
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_xmap_bucket_tiler_f.f90
!! @brief Fortran test of distributed directory
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
#define XT_UNUSED(x) IF (SIZE( (/(x)/) ) < 0) CONTINUE
MODULE test_xmap_bucket_tiler
  USE yaxt, ONLY: xt_is_null, xt_idxlist, xt_idxlist_c2f, xt_idxlist_delete, &
       xt_idxlist_is_stripe_conversion_profitable, &
       xt_config, xt_config_new, xt_config_get_xmdd_bucket_gen, &
       xt_config_set_xmdd_bucket_gen, &
       xt_idxfsection_new, &
       xt_xmdd_bucket_gen, xt_xmdd_bucket_gen_define_interface, &
       xt_xmdd_bucket_gen_new, xt_xmdd_bucket_gen_delete, &
       xt_xmdd_bucket_gen_comms, &
       xt_xmdd_bucket_gen_get_init_params, &
       xt_xmdd_bucket_gen_set_extended_init_params, &
       xt_com_list, xi => xt_int_kind
#if defined HAVE_FC_C_FUNLOC && defined HAVE_FC_ABSTRACT_INTERFACE && !defined NDEBUG
  USE yaxt, ONLY: xt_xmdd_bucket_gen_init_state, &
       xt_xmdd_bucket_gen_get_init, xt_abort
#endif
  USE iso_c_binding, ONLY: c_ptr, c_long_long, c_f_pointer, c_int, &
       c_null_ptr, c_size_t, c_char, c_null_char
#ifdef HAVE_FC_C_SIZEOF
  USE iso_c_binding, ONLY: c_sizeof
#endif
#if defined __PGI && ( __PGIC__ <= 11 )
  USE xt_idxlist_abstract, ONLY: xt_is_null
#endif
#if defined __PGI && __PGIC__ >= 22 && __PGIC__ <= 24
  USE iso_c_binding, ONLY: c_funloc, c_funptr
  USE yaxt, ONLY: xt_xmdd_bucket_gen_f2c, xt_config_c2f
#endif

#if ! defined HAVE_GFORTRAN_SIZEOF
  USE mpi
#endif
  IMPLICIT NONE
  INTEGER, PARAMETER :: max_arank = 1
  TYPE, BIND(c) :: bucket_gen_1d_tile_param
    INTEGER(xi) :: global_sizes(max_arank)
  END TYPE bucket_gen_1d_tile_param

  TYPE bucket_gen_1d_tile_state
    INTEGER(xi) :: global_sizes(max_arank)
    INTEGER :: deco(max_arank)
    INTEGER :: intra_comm_size, last_rank_generated, prev_rank_generated
    TYPE(xt_idxlist) :: prev_tile
  END TYPE bucket_gen_1d_tile_state
  CHARACTER(*), PARAMETER :: filename = "test_xmap_bucket_tiler_f.f90"
CONTAINS
    ! determine which MPI rank owns sub-section a particular coordinate falls into
  ! note: assumes row-major distribution of ranks
  FUNCTION rank_of_coord(gsz, deco, coord)
    INTEGER(xi), INTENT(in) :: gsz(max_arank), coord(max_arank)
    INTEGER, INTENT(in) :: deco(max_arank)
    INTEGER :: rank_of_coord, i, prod

    prod = 1
    rank_of_coord = 0
    DO i = 1, max_arank
      rank_of_coord = rank_of_coord + &
           INT((INT(coord(i)-1, c_long_long) &
           &              * INT(deco(i), c_long_long) + deco(i)-1) &
           &              / INT(gsz(i), c_long_long)) * prod
      prod = prod * deco(i)
    END DO
    rank_of_coord = rank_of_coord
  END FUNCTION rank_of_coord

  ! nvfortran 22 to 24 exhibit incorrect handling of directly passed
  ! TYPE(x), VALUE arguments where x contains default initialized
  ! members, i.e. the value passed in from the caller is overwritten
  ! on function entry
  FUNCTION bucket_gen_1d_tile_init(gen_state_, &
       src_idxlist, dst_idxlist, config, comms, init_params_) &
       BIND(c) RESULT(convert_to_stripes)
    TYPE(c_ptr), VALUE :: gen_state_
#if defined __PGI && __PGIC__ >= 22 && __PGIC__ <= 24
    TYPE(c_ptr), VALUE :: src_idxlist, dst_idxlist, config
#else
    TYPE(xt_idxlist), VALUE :: src_idxlist, dst_idxlist
    TYPE(xt_config), VALUE :: config
#endif
    TYPE(xt_xmdd_bucket_gen_comms), INTENT(in) :: comms
    TYPE(c_ptr), VALUE :: init_params_
    TYPE(xt_idxlist) :: init_prev_tile

    TYPE(bucket_gen_1d_tile_state), POINTER :: gen_state
    TYPE(bucket_gen_1d_tile_param), POINTER :: init_params
    INTEGER :: ierror, start_rank, end_rank
    INTEGER(c_int) :: convert_to_stripes
    INTEGER :: num_indices_src, num_indices_dst, deco3, deco4

#if defined __PGI && __PGIC__ >= 22 && __PGIC__ <= 24
    TYPE(xt_idxlist) :: src_idxlist_, dst_idxlist_
    TYPE(xt_config) :: config_
    src_idxlist_ = xt_idxlist_c2f(src_idxlist)
    dst_idxlist_ = xt_idxlist_c2f(dst_idxlist)
    config_ = xt_config(config)
#define src_idxlist src_idxlist_
#define dst_idxlist dst_idxlist_
#define config config_
#endif
    CALL C_F_POINTER(gen_state_, gen_state)
    CALL MPI_Comm_size(comms%intra_comm, gen_state%intra_comm_size, ierror)
    gen_state%prev_tile = init_prev_tile
    IF (xt_idxlist_is_stripe_conversion_profitable(&
         src_idxlist, config) > 0) THEN
      convert_to_stripes = 1_c_int
    ELSE IF (xt_idxlist_is_stripe_conversion_profitable(&
         dst_idxlist, config) > 0) THEN
      convert_to_stripes = 1_c_int
    ELSE
      convert_to_stripes = 0_c_int
    END IF
    ! todo: query idxlists for minimum and maximum to assess
    !  range of intersecting bucket ranks */
    ! establish local ranges
    CALL C_F_POINTER(init_params_, init_params)
    gen_state%global_sizes = init_params%global_sizes
    gen_state%last_rank_generated = gen_state%intra_comm_size-1
    gen_state%prev_rank_generated = -1
    ! todo: distribute ranks to more than one dimension
    gen_state%deco(1) = gen_state%intra_comm_size
#if defined __PGI && __PGIC__ >= 22 && __PGIC__ <= 24
#undef src_idxlist
#undef dst_idxlist
#undef config
#endif
  END FUNCTION bucket_gen_1d_tile_init

  SUBROUTINE bucket_gen_1d_tile_destroy(gen_state_) BIND(c)
    TYPE(c_ptr), VALUE :: gen_state_
    TYPE(bucket_gen_1d_tile_state), POINTER :: gen_state

    CALL C_F_POINTER(gen_state_, gen_state)

    IF (.NOT. xt_is_null(gen_state%prev_tile)) &
         CALL xt_idxlist_delete(gen_state%prev_tile)
  END SUBROUTINE bucket_gen_1d_tile_destroy

  FUNCTION bucket_gen_1d_tile_get_intersect_max_num(&
       gen_state_, bucket_type) BIND(c) RESULT(max_num)
    TYPE(c_ptr), VALUE :: gen_state_
    INTEGER(c_int), VALUE :: bucket_type
    INTEGER(c_int) :: max_num
    TYPE(bucket_gen_1d_tile_state), POINTER :: gen_state

    XT_UNUSED(bucket_type)
    CALL C_F_POINTER(gen_state_, gen_state)
    max_num = INT(gen_state%last_rank_generated &
         &        - gen_state%prev_rank_generated, c_int)
  END FUNCTION bucket_gen_1d_tile_get_intersect_max_num

  FUNCTION bucket_gen_1d_tile_next(gen_state_, bucket_type) &
       BIND(C) RESULT(bucket)
    TYPE(c_ptr), VALUE :: gen_state_
    INTEGER(c_int), VALUE :: bucket_type

    TYPE(xt_com_list) :: bucket

    TYPE(bucket_gen_1d_tile_state), POINTER :: gen_state
    INTEGER :: next_rank, lsz(max_arank), rank_mod, rank_idx, i
    INTEGER(xi) :: lst(max_arank)
    LOGICAL :: all_lsz_non_zero

    ! todo: properly handle bucket_type
    XT_UNUSED(bucket_type)

    CALL C_F_POINTER(gen_state_, gen_state)
    IF (.NOT. xt_is_null(gen_state%prev_tile)) &
         CALL xt_idxlist_delete(gen_state%prev_tile)
    next_rank = gen_state%prev_rank_generated
    DO next_rank = next_rank+1, gen_state%last_rank_generated
      gen_state%prev_rank_generated = next_rank
      rank_idx = next_rank
      all_lsz_non_zero = .TRUE.
      DO i = 1, max_arank
        rank_mod = MOD(rank_idx, gen_state%deco(i))
        rank_idx = rank_idx / gen_state%deco(i)
        lst(i) &
             = INT((INT(gen_state%global_sizes(i), c_long_long) &
             &         * rank_mod)/gen_state%deco(i)+1, &
             &     xi)
        lsz(i) &
             = INT(INT((INT(gen_state%global_sizes(i), c_long_long) &
             &         * (rank_mod+1))/gen_state%deco(i), &
             &         xi) - (lst(i)-1))
        all_lsz_non_zero = all_lsz_non_zero .AND. lsz(i) > 0
      END DO
      IF (all_lsz_non_zero) THEN
        bucket%list = xt_idxfsection_new(0_xi, &
             gen_state%global_sizes, &
             lsz, lst)
        bucket%rank = next_rank
        gen_state%prev_tile = bucket%list
        RETURN
      END IF
    END DO
    bucket%list = xt_idxlist_c2f(c_null_ptr)
    bucket%rank = -1
  END FUNCTION bucket_gen_1d_tile_next

  FUNCTION tile_bucket_config_new(ndims, global_dims, num_part) &
       RESULT(custom_bucket_config)
    INTEGER, INTENT(in) :: ndims
    INTEGER(xi), INTENT(in) :: global_dims(ndims)
    INTEGER, INTENT(in) :: num_part(ndims)
    TYPE(Xt_config) :: custom_bucket_config

    TYPE(Xt_xmdd_bucket_gen) :: bucket_gen
    TYPE(bucket_gen_1d_tile_param), POINTER :: bucket_params
    TYPE(bucket_gen_1d_tile_state) :: state_dummy(2)
#ifdef FC_C_SIZEOF
    TYPE(bucket_gen_1d_tile_param) :: bucket_params_dummy
#else
    TYPE(bucket_gen_1d_tile_param) :: bucket_params_dummy(2)
#endif
    TYPE(c_ptr) :: bucket_params_c
    INTEGER(c_size_t) :: bucket_params_c_size, state_c_size
#if ! defined HAVE_GFORTRAN_SIZEOF
    INTEGER(mpi_address_kind) :: dummy_addr(2)
    INTEGER :: ierror
#endif
#if defined __PGI && __PGIC__ >= 22 && __PGIC__ <= 24
    TYPE(c_funptr) :: bucket_gen_1d_tile_init_, bucket_gen_1d_tile_destroy_, &
         bucket_gen_1d_tile_get_intersect_max_num_, bucket_gen_1d_tile_next_
#endif
    INTEGER :: i
    CHARACTER(len=1, kind=c_char) :: filename_c(LEN(filename)+1)
    INTERFACE
      FUNCTION xt_xmalloc(char_size, source, line) BIND(c, name='Xt_xmalloc') &
           RESULT(ptr)
        IMPORT :: c_size_t, c_ptr, c_char, c_int
        INTEGER(c_size_t), VALUE, INTENT(in) :: char_size
        CHARACTER(kind=c_char, len=1), INTENT(in) :: source(*)
        INTEGER(c_int), VALUE, INTENT(in) :: line
        TYPE(c_ptr) :: ptr
      END FUNCTION xt_xmalloc
    END INTERFACE
    XT_UNUSED(num_part)
    custom_bucket_config = xt_config_new()
    bucket_gen = xt_xmdd_bucket_gen_new()
    ! todo: generalize for arbitrary number of dimensions
    IF (ndims /= 1) STOP

#ifdef FC_C_SIZEOF
    bucket_params_c_size = FC_C_SIZEOF(bucket_params_dummy)
#else
    DO i = 1, 2
      CALL mpi_get_address(bucket_params_dummy(i), dummy_addr(i), ierror)
    END DO
    bucket_params_c_size = INT(dummy_addr(2) - dummy_addr(1), c_size_t)
#endif
    DO i = 1, LEN(filename)
      filename_c(i) = filename(i:i)
    END DO
    filename_c(LEN(filename)+1) = c_null_char
    bucket_params_c = xt_xmalloc(bucket_params_c_size, filename_c, __LINE__)
    CALL C_F_POINTER(bucket_params_c, bucket_params)
    bucket_params%global_sizes(1:ndims) = global_dims
#if defined HAVE_GFORTRAN_SIZEOF
    state_c_size = SIZEOF(state_dummy(1))
#else
    DO i = 1, 2
      CALL mpi_get_address(state_dummy(i), dummy_addr(i), ierror)
    END DO
    state_c_size = INT(dummy_addr(2) - dummy_addr(1), c_size_t)
#endif
    ! unfortunately, for the above
    ! work-around, additional ISO C binding sauce is needed here
#if defined __PGI && __PGIC__ >= 22 && __PGIC__ <= 24
    bucket_gen_1d_tile_init_ = C_FUNLOC(bucket_gen_1d_tile_init)
    bucket_gen_1d_tile_destroy_ = C_FUNLOC(bucket_gen_1d_tile_destroy)
    bucket_gen_1d_tile_get_intersect_max_num_ &
         = C_FUNLOC(bucket_gen_1d_tile_get_intersect_max_num)
    bucket_gen_1d_tile_next_ = C_FUNLOC(bucket_gen_1d_tile_next)
    CALL xt_xmdd_bucket_gen_define_interface(&
         xt_xmdd_bucket_gen_f2c(bucket_gen), &
         bucket_gen_1d_tile_init_, bucket_gen_1d_tile_destroy_, &
         bucket_gen_1d_tile_get_intersect_max_num_, &
         bucket_gen_1d_tile_next_, state_c_size, bucket_params_c)
#else
    CALL xt_xmdd_bucket_gen_define_interface(bucket_gen, &
         bucket_gen_1d_tile_init, bucket_gen_1d_tile_destroy, &
         bucket_gen_1d_tile_get_intersect_max_num, &
         bucket_gen_1d_tile_next, state_c_size, bucket_params_c)
#endif
    CALL xt_xmdd_bucket_gen_set_extended_init_params(&
         bucket_gen, bucket_params_c_size)

    CALL xt_config_set_xmdd_bucket_gen(custom_bucket_config, bucket_gen)
    CALL xt_xmdd_bucket_gen_delete(bucket_gen)
  END FUNCTION tile_bucket_config_new

  SUBROUTINE tile_bucket_config_set_global_dims(custom_bucket_config, &
       global_dims)
    TYPE(xt_config) :: custom_bucket_config
    INTEGER(xi), INTENT(in) :: global_dims(*)
#if defined HAVE_FC_C_FUNLOC && defined HAVE_FC_ABSTRACT_INTERFACE \
    && !defined NDEBUG
    PROCEDURE(xt_xmdd_bucket_gen_init_state), POINTER :: ini
#endif

    TYPE(xt_xmdd_bucket_gen) ::  bucket_gen
    TYPE(c_ptr) :: init_params_c
    TYPE(bucket_gen_1d_tile_param), POINTER :: init_params

    bucket_gen = xt_config_get_xmdd_bucket_gen(custom_bucket_config)
#if defined HAVE_FC_C_FUNLOC && defined HAVE_FC_ABSTRACT_INTERFACE \
    && !defined NDEBUG
    ini => xt_xmdd_bucket_gen_get_init(bucket_gen)
    IF (.NOT. ASSOCIATED(ini, bucket_gen_1d_tile_init)) &
         CALL xt_abort("unexpected function pointer query result", &
         filename, __LINE__)
#endif
    init_params_c = xt_xmdd_bucket_gen_get_init_params(bucket_gen)
    CALL C_F_POINTER(init_params_c, init_params)
    init_params%global_sizes = global_dims(1:1)
  END SUBROUTINE tile_bucket_config_set_global_dims

END MODULE test_xmap_bucket_tiler
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_xmap_common_intercomm_parallel_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!
!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE test_xmap_common_intercomm_parallel
  USE iso_c_binding, ONLY: c_int
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort, posix_exit
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_int_kind, xt_stripe, &
       xi => xt_int_kind, &
       xt_idxlist, xt_idxlist_delete, xt_idxstripes_new, &
       xt_xmap, xt_xmap_copy, xt_xmap_delete, &
       xt_xmap_get_num_destinations, xt_xmap_get_num_sources, &
       xt_xmap_get_destination_ranks, xt_xmap_get_source_ranks, &
       xt_sort_int
  USE xt_core, ONLY: i8
  USE test_xmap_common_parallel, ONLY: get_rank_range, &
       check_allgather_analog_xmap, test_ping_pong, test_ring_1d
  IMPLICIT NONE
  PRIVATE
  INTEGER :: intra_group_comm
  PUBLIC :: xmap_intercomm_parallel_test_main, intra_group_comm
  CHARACTER(len=*), PARAMETER :: &
       filename = 'test_xmap_common_intercomm_parallel_f.f90'
CONTAINS
  SUBROUTINE xmap_intercomm_parallel_test_main(xmap_new, call_initialize, &
       call_finalize)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    LOGICAL, OPTIONAL, INTENT(in) :: call_initialize, call_finalize
    INTEGER :: comm, comm_rank, comm_size, ierror, inter_comm, split_rank, &
         retval
    LOGICAL :: in_second_group, call_finalize_, call_initialize_

    IF (PRESENT(call_initialize)) THEN
      call_initialize_ = call_initialize
    ELSE
      call_initialize_ = .TRUE.
    END IF
    IF (PRESENT(call_finalize)) THEN
      call_finalize_ = call_finalize
    ELSE
      call_finalize_ = .TRUE.
    END IF
    IF (call_initialize_) THEN
      CALL init_mpi
      CALL xt_initialize(mpi_comm_world)
    END IF
    comm = mpi_comm_world
    CALL mpi_comm_rank(comm, comm_rank, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_rank", filename, __LINE__)
    CALL mpi_comm_size(comm, comm_size, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_size", filename, __LINE__)
    IF (comm_size > HUGE(1_xi)) &
         CALL test_abort("number of ranks exceeds test limit", &
         filename, __LINE__)

    IF (comm_size > 1) THEN
      retval = 0
      split_rank = comm_size/2 - MERGE(1, 0, comm_size > 5)
      in_second_group = comm_rank >= split_rank
      CALL mpi_comm_split(comm, MERGE(1, 0, in_second_group), 0, &
           intra_group_comm, ierror)
      IF (ierror /= mpi_success) &
           CALL test_abort("error calling mpi_comm_split", filename, __LINE__)
      CALL mpi_intercomm_create(intra_group_comm, 0, comm, &
           MERGE(0, split_rank, in_second_group), 0, inter_comm, ierror)
      IF (ierror /= mpi_success) &
           CALL test_abort("error calling mpi_intercomm_create", &
           filename, __LINE__)
      CALL test_allgather_analog(xmap_new, 1_xi, inter_comm)
      ! repeat test for large index list that will cause stripifying
      CALL test_allgather_analog(xmap_new, 1024_xi, inter_comm)

      CALL test_peer(xmap_new, inter_comm)

      CALL test_ping_pong(xmap_new, inter_comm, 0, 0)

      IF (split_rank > 2) CALL test_ring_1d(xmap_new, inter_comm)

      CALL mpi_comm_free(inter_comm, ierror)
      IF (ierror /= mpi_success) &
           CALL test_abort("error calling mpi_comm_free", filename, __LINE__)
      CALL mpi_comm_free(intra_group_comm, ierror)
      IF (ierror /= mpi_success) &
           CALL test_abort("error calling mpi_comm_free", filename, __LINE__)
    ELSE
      retval = 77
    END IF
    IF (test_err_count() /= 0) &
         CALL test_abort("non-zero error count!", filename, __LINE__)
    IF (call_finalize_) THEN
      CALL xt_finalize
      CALL finish_mpi
    END IF
    IF (retval /= 0) CALL posix_exit(retval)
  END SUBROUTINE xmap_intercomm_parallel_test_main

  SUBROUTINE test_allgather_analog(xmap_new, num_indices_per_rank, comm)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER(xt_int_kind), INTENT(in) :: num_indices_per_rank
    INTEGER, INTENT(inout) :: comm
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    TYPE(xt_xmap) :: xmap, xmap_copy
    TYPE(xt_stripe) :: src_index_stripe(1), dst_index_stripe(1)
    INTEGER :: comm_rank, remote_size
    LOGICAL :: is_inter
    CALL get_rank_range(comm, is_inter, comm_rank, remote_size)
    ! setup
    src_index_stripe(1) = xt_stripe(INT(comm_rank, xi) * num_indices_per_rank, &
         1_xi, INT(num_indices_per_rank, c_int))
    src_idxlist = xt_idxstripes_new(src_index_stripe)
    dst_index_stripe(1) = xt_stripe(0, 1, &
         INT(INT(remote_size, xi) * num_indices_per_rank, c_int))
    dst_idxlist = xt_idxstripes_new(dst_index_stripe)
    xmap = xmap_new(src_idxlist, dst_idxlist, comm)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    ! verify expected results
    CALL check_allgather_analog_xmap(xmap, comm)
    xmap_copy = xt_xmap_copy(xmap)
    CALL check_allgather_analog_xmap(xmap_copy, comm)

    ! clean up
    CALL xt_xmap_delete(xmap)
    CALL xt_xmap_delete(xmap_copy)
  END SUBROUTINE test_allgather_analog


  SUBROUTINE check_peers(xmap, num_ref_ranks, ref_ranks, peer_rank_buf, &
       get_num_peers, get_peer_ranks, get_num_peers_name, get_peer_ranks_name)
    TYPE(xt_xmap), INTENT(in) :: xmap
    INTEGER, INTENT(in) :: num_ref_ranks
    INTEGER(c_int), INTENT(in) :: ref_ranks(num_ref_ranks)
    INTEGER(c_int), INTENT(out) :: peer_rank_buf(num_ref_ranks)
    INTERFACE
      FUNCTION get_num_peers(xmap) RESULT(num)
        IMPORT :: xt_xmap
        TYPE(xt_xmap), INTENT(in) :: xmap
        INTEGER :: num
      END FUNCTION get_num_peers
      SUBROUTINE get_peer_ranks(xmap, ranks)
        IMPORT :: xt_xmap, c_int
        TYPE(xt_xmap), INTENT(in) :: xmap
        INTEGER(c_int), INTENT(out) :: ranks(*)
      END SUBROUTINE get_peer_ranks
    END INTERFACE
    CHARACTER(len=*), INTENT(in) :: get_num_peers_name, get_peer_ranks_name
    CHARACTER(len=80) :: msg
    IF (get_num_peers(xmap) /= num_ref_ranks) THEN
      WRITE (msg, '(2a)') "error in ", get_num_peers_name
      CALL test_abort(msg, filename, __LINE__)
    END IF
    CALL get_peer_ranks(xmap, peer_rank_buf)
    CALL xt_sort_int(peer_rank_buf)
    IF (ANY(peer_rank_buf /= ref_ranks)) THEN
      WRITE (msg, '(2a)') "error in ", get_peer_ranks_name
      CALL test_abort(msg, filename, __LINE__)
    END IF
  END SUBROUTINE check_peers

  SUBROUTINE check_peer_xmap(xmap, stripe_in_local_group, remote_size, &
       global_num_idx)
    TYPE(xt_xmap), INTENT(in) :: xmap
    TYPE(xt_stripe), INTENT(in) :: stripe_in_local_group
    INTEGER, INTENT(in) :: remote_size
    INTEGER(i8), INTENT(in) :: global_num_idx
    INTEGER :: num_indices, idx_per_remote_rank, num_remote_peers, &
         last_seen_rank, i, remote_rank_i
    INTEGER(c_int), ALLOCATABLE :: ref_ranks(:), rank_buf(:)
    num_indices = INT(stripe_in_local_group%nstrides)
    idx_per_remote_rank = INT(global_num_idx / INT(remote_size, i8))
    ALLOCATE(ref_ranks(num_indices))
    num_remote_peers = 0
    last_seen_rank = -1
    DO i = 1, num_indices
      remote_rank_i = INT((stripe_in_local_group%start + INT(i-1, xi)) &
           &              / idx_per_remote_rank)
      IF (remote_rank_i /= last_seen_rank) THEN
        num_remote_peers = num_remote_peers + 1
        ref_ranks(num_remote_peers) = INT(remote_rank_i, c_int)
        last_seen_rank = remote_rank_i
      END IF
    END DO
    ALLOCATE(rank_buf(num_remote_peers))
    CALL check_peers(xmap, num_remote_peers, ref_ranks, rank_buf, &
         xt_xmap_get_num_destinations, xt_xmap_get_destination_ranks, &
         "xt_xmap_get_num_destinations", "xt_xmap_get_destination_ranks")
    CALL check_peers(xmap, num_remote_peers, ref_ranks, rank_buf, &
         xt_xmap_get_num_sources, xt_xmap_get_source_ranks, &
         "xt_xmap_get_num_sources", "xt_xmap_get_source_ranks")
  END SUBROUTINE check_peer_xmap

  FUNCTION gcd(a, b)
    INTEGER, INTENT(in) :: a, b
    INTEGER :: a_, b_, t_, gcd
    a_ = a ; b_ = b
    DO WHILE (b_ /= 0)
      t_ = b_
      b_ = MOD(a_, b_)
      a_ = t_
    END DO
    gcd = a_
  END FUNCTION gcd

  FUNCTION lcm(a, b)
    INTEGER(i8) :: lcm
    INTEGER, INTENT(in) :: a, b
    INTEGER :: t
    t = gcd(a, b)
    lcm = INT(a / t, i8) * INT(b, i8)
  END FUNCTION lcm

  SUBROUTINE test_peer(xmap_new, comm)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(inout) :: comm
    INTEGER :: comm_rank, comm_size, remote_size, ierror
    INTEGER(i8) :: global_num_idx
    TYPE(xt_stripe) :: stripe_in_local_group(1)
    TYPE(xt_idxlist) :: idxlist
    TYPE(xt_xmap) :: xmap, xmap_copy
    CALL mpi_comm_rank(comm, comm_rank, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_rank", filename, __LINE__)
    CALL mpi_comm_size(comm, comm_size, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_size", filename, __LINE__)
    CALL mpi_comm_remote_size(comm, remote_size, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("error calling mpi_comm_remote_size", &
         filename, __LINE__)
    global_num_idx = lcm(comm_size, remote_size)
    stripe_in_local_group(1) &
         = xt_stripe(INT(global_num_idx / INT(comm_size, i8) &
         &               * INT(comm_rank, i8), xi), &
         &           1, INT(global_num_idx / INT(comm_size, i8), c_int))
    idxlist = xt_idxstripes_new(stripe_in_local_group)
    xmap = xmap_new(idxlist, idxlist, comm)
    CALL xt_idxlist_delete(idxlist)
    CALL check_peer_xmap(xmap, stripe_in_local_group(1), remote_size, &
         global_num_idx)
    xmap_copy = xt_xmap_copy(xmap)
    CALL check_peer_xmap(xmap_copy, stripe_in_local_group(1), remote_size, &
         global_num_idx)
    CALL xt_xmap_delete(xmap)
    CALL xt_xmap_delete(xmap_copy)
  END SUBROUTINE test_peer

END MODULE test_xmap_common_intercomm_parallel
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_redist_repeat_f.f90
!! @brief Fortran test of redist_repeatection_static class
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_redist_repeat
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort, cmp_arrays
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_xmap, xt_xmap_delete, &
       xt_redist, xt_redist_p2p_new, xt_redist_p2p_off_new, &
       xt_redist_p2p_off_custom_new, &
       xt_redist_repeat_new, xt_redist_delete, &
       xt_redist_s_exchange, xt_redist_a_exchange, &
       xt_request, xt_config, xt_config_delete, &
       xt_config_set_ddt_cache_limit
#if defined __PGI && ( __PGIC__ == 15 || __PGIC__ == 14 )
  USE xt_redist_real_sp, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
  USE xt_redist_real_dp, ONLY: xt_redist_s_exchange, xt_redist_a_exchange
#endif
  USE test_redist_common, ONLY: build_odd_selection_xmap, check_redist, &
       check_wait_request, redist_exchanger_option
  USE iso_c_binding, ONLY: c_int
  IMPLICIT NONE
  CHARACTER(len=*), PARAMETER :: filename = 'test_redist_repeat_f.f90'
  CHARACTER(len=*), PARAMETER :: exch1name(2) = &
       (/ "xt_redist_s_exchange1", "xt_redist_a_exchange1" /)
  INTEGER, PARAMETER :: ddt_gen_lim(4) = (/ -1, 0, 16, -2 /)
  TYPE(xt_config) :: config

  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  config = redist_exchanger_option()

  CALL simple_test(mpi_comm_world, config)
  CALL test_repeated_redist(mpi_comm_world, config)
  CALL test_repeated_redist_with_gap(mpi_comm_world, config)
  CALL test_repeated_overlapping_redist(mpi_comm_world, config)
  CALL test_repeated_redist_asym(mpi_comm_world, config)

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_config_delete(config)
  CALL xt_finalize
  CALL finish_mpi
CONTAINS
  SUBROUTINE simple_test(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    ! general test with one redist
    ! set up data
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_repeat
    INTEGER, PARAMETER :: src_slice_len = 5, dst_slice_len = 3
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(dst_slice_len) &
         = (/ 1.0d0, 3.0d0, 5.0d0 /), &
         src_data(src_slice_len) = (/ 1.0d0, 2.0d0, 3.0d0, 4.0d0, 5.0d0 /)
    DOUBLE PRECISION :: dst_data(dst_slice_len)
    INTEGER(mpi_address_kind) :: src_extent, dst_extent
    INTEGER(mpi_address_kind) :: base_address, temp_address
    INTEGER(c_int) :: displacements(1) = 0
    INTEGER :: ierror, ddt_gen_test

    xmap = build_odd_selection_xmap(src_slice_len, comm)

    CALL mpi_get_address(src_data(1), base_address, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort('mpi_get_address failed', filename, __LINE__)
    CALL mpi_get_address(src_data(2), temp_address, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort('mpi_get_address failed', filename, __LINE__)
    src_extent = (temp_address - base_address) * src_slice_len
    CALL mpi_get_address(dst_data(1), base_address, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort('mpi_get_address failed', filename, __LINE__)
    CALL mpi_get_address(dst_data(2), temp_address, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort('mpi_get_address failed', filename, __LINE__)
    dst_extent = (temp_address - base_address) * dst_slice_len

    DO ddt_gen_test = 1, SIZE(ddt_gen_lim)
      CALL xt_config_set_ddt_cache_limit(config, ddt_gen_lim(ddt_gen_test))

      redist = xt_redist_p2p_new(xmap, mpi_double_precision)


      ! generate redist_repeat
      redist_repeat = xt_redist_repeat_new(redist, src_extent, dst_extent, 1, &
                                         displacements, config)

      CALL xt_redist_delete(redist)

      ! test exchange
      CALL check_redist(redist_repeat, src_data, dst_data, ref_dst_data)

      ! clean up
      CALL xt_redist_delete(redist_repeat)
    END DO
    CALL xt_xmap_delete(xmap)
  END SUBROUTINE simple_test

  SUBROUTINE test_repeated_redist_ds1(redist_repeat)
    TYPE(xt_redist), INTENT(in) :: redist_repeat
    INTEGER :: i, j
    DOUBLE PRECISION, PARAMETER :: src_data(5, 3) = RESHAPE((/&
         (DBLE(i), i = 1, 15)/), (/ 5, 3 /))
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(3, 3) &
         = RESHAPE((/ ((DBLE(i + j), i = 1,5,2), j = 0,10,5) /), (/ 3, 3 /))
    DOUBLE PRECISION :: dst_data(3, 3)

    CALL check_redist(redist_repeat, src_data, dst_data, ref_dst_data)
  END SUBROUTINE test_repeated_redist_ds1

#ifdef __PGI
#  define NO_2D_PARAM
#elif defined(_CRAYFTN)
#  if _RELEASE_MAJOR < 8 || (_RELEASE_MAJOR == 8 && _RELEASE_MINOR < 7)
#    define NO_2D_PARAM
#  endif
#endif

  SUBROUTINE test_repeated_redist_ds1_with_gap(redist_repeat)
    TYPE(xt_redist), INTENT(in) :: redist_repeat
    INTEGER :: i, j
    DOUBLE PRECISION, PARAMETER :: src_data(5, 5) = RESHAPE((/&
         (DBLE(i), i = 1, 25)/), (/ 5, 5 /))
    DOUBLE PRECISION :: dst_data(3, 5)
#ifdef NO_2D_PARAM
    DOUBLE PRECISION :: ref_dst_data(3, 5)
    ref_dst_data &
         = RESHAPE((/ ((DBLE((i + j)*MOD(j+1,2)-MOD(j,2)), i = 1,5,2), &
         j = 0,20,5) /), (/ 3, 5 /))
#else
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(3, 5) &
         = RESHAPE((/ ((DBLE((i + j)*MOD(j+1,2)-MOD(j,2)), i = 1,5,2), j = 0,20,5) /), (/ 3, 5 /))
#endif
    CALL check_redist(redist_repeat, src_data, dst_data, ref_dst_data)
  END SUBROUTINE test_repeated_redist_ds1_with_gap

  SUBROUTINE test_repeated_redist_ds2(redist_repeat)
    TYPE(xt_redist), INTENT(in) :: redist_repeat
    INTEGER :: i, j
    DOUBLE PRECISION, PARAMETER :: src_data(5, 3) = RESHAPE((/&
         (DBLE(i), i = 20, 34)/), (/ 5, 3 /))
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(3, 3) &
         = RESHAPE((/ ((DBLE(i + j), i = 1,5,2), j = 19,33,5) /), (/ 3, 3 /))
    DOUBLE PRECISION :: dst_data(3, 3)

    CALL check_redist(redist_repeat, src_data, dst_data, ref_dst_data)
  END SUBROUTINE test_repeated_redist_ds2

  SUBROUTINE test_repeated_redist(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    ! test with one redist used three times (with two different input data
    ! displacements -> test of cache) (with default cache size)
    ! set up data
    INTEGER, PARAMETER :: num_slice = 3
    INTEGER, PARAMETER :: src_slice_len = 5
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_repeat
    INTEGER(mpi_address_kind) :: src_extent, dst_extent
    INTEGER(mpi_address_kind) :: base_address, temp_address
    INTEGER(c_int), PARAMETER :: &
         displacements(3)= (/ 0_c_int, 1_c_int, 2_c_int /)
    DOUBLE PRECISION, TARGET :: src_template(5, 3), dst_template(3, 3)
    INTEGER :: ierror, ddt_gen_test

    ! generate redist_repeat
    CALL mpi_get_address(src_template(1,1), base_address, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort('mpi_get_address failed', filename, __LINE__)
    CALL mpi_get_address(src_template(1,2), temp_address, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort('mpi_get_address failed', filename, __LINE__)
    src_extent = temp_address - base_address
    CALL mpi_get_address(dst_template(1,1), base_address, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort('mpi_get_address failed', filename, __LINE__)
    CALL mpi_get_address(dst_template(1,2), temp_address, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort('mpi_get_address failed', filename, __LINE__)
    dst_extent = temp_address - base_address
    xmap = build_odd_selection_xmap(src_slice_len, comm)
    DO ddt_gen_test = 1, SIZE(ddt_gen_lim)
      CALL xt_config_set_ddt_cache_limit(config, ddt_gen_lim(ddt_gen_test))

      redist = xt_redist_p2p_new(xmap, mpi_double_precision, config)

      redist_repeat = xt_redist_repeat_new(redist, src_extent, dst_extent, &
           num_slice, displacements, config)
      CALL xt_redist_delete(redist)

      ! test exchange
      CALL test_repeated_redist_ds1(redist_repeat)
      ! test exchange
      CALL test_repeated_redist_ds2(redist_repeat)
      ! clean up
      CALL xt_redist_delete(redist_repeat)
    END DO
    CALL xt_xmap_delete(xmap)
  END SUBROUTINE test_repeated_redist

  SUBROUTINE test_repeated_redist_asym(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config
    ! test asymmetric variant of redist_repeat

    INTEGER, PARAMETER :: num_slice = 3
    INTEGER, PARAMETER :: src_slice_len = 5
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_repeat
    INTEGER(mpi_address_kind) :: src_extent, dst_extent
    INTEGER(mpi_address_kind) :: base_address, temp_address
    INTEGER(c_int) :: src_displacements(3), dst_displacements(3)
    INTEGER :: i, ierror, ddt_gen_test
    DOUBLE PRECISION, PARAMETER :: &
         ref_dst_data(3, 3) = RESHAPE([ 6.0d0, 8.0d0, 10.0d0, 11.0d0, 13.0d0, &
         &                             15.0d0, 1.0d0,  3.0d0,  5.0d0 ], [3,3] )
    DOUBLE PRECISION, TARGET :: dst_data(3, 3)
    DOUBLE PRECISION, TARGET, SAVE :: &
         src_data(5, 3) = RESHAPE([(DBLE(i), i = 1, 15)], [5,3])
    INTEGER, PARAMETER :: dp = KIND(src_data)

    ! xmap: [1,2,3,4,5] -> [1,3,5]
    xmap = build_odd_selection_xmap(src_slice_len, comm)

    ! generate redist_repeat:
    CALL mpi_get_address(src_data(1,1), base_address, ierror)
    CALL mpi_get_address(src_data(1,2), temp_address, ierror)
    src_extent = temp_address - base_address
    CALL mpi_get_address(dst_data(1,1), base_address, ierror)
    CALL mpi_get_address(dst_data(1,2), temp_address, ierror)
    dst_extent = temp_address - base_address

    ! repeated redist parameters:
    src_displacements = [0,1,2]
    dst_displacements = [2,0,1]

    DO ddt_gen_test = 1, SIZE(ddt_gen_lim)
      CALL xt_config_set_ddt_cache_limit(config, ddt_gen_lim(ddt_gen_test))

      redist = xt_redist_p2p_new(xmap, mpi_double_precision)

      ! connect to explicit shape interface:
      redist_repeat = xt_redist_repeat_new(redist, src_extent, dst_extent, &
           num_slice, src_displacements, dst_displacements, config)
      dst_data = -1.0_dp
      CALL check_redist(redist_repeat, src_data, dst_data, ref_dst_data)
      CALL xt_redist_delete(redist_repeat)

      ! connect to assumed shape interface:
      redist_repeat = xt_redist_repeat_new(redist, src_extent, dst_extent, &
           src_displacements, dst_displacements, config)
      dst_data = -1.0_dp
      CALL check_redist(redist_repeat, src_data, dst_data, ref_dst_data)
      CALL xt_redist_delete(redist_repeat)

      CALL xt_redist_delete(redist)
    END DO
    CALL xt_xmap_delete(xmap)
  END SUBROUTINE test_repeated_redist_asym

  SUBROUTINE test_repeated_redist_with_gap(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config

    ! test with one redist used three times (with two different input data
    ! displacements -> test of cache) (with default cache size)
    ! set up data
    INTEGER, PARAMETER :: num_slice = 3
    INTEGER, PARAMETER :: src_slice_len = 5
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_repeat
    INTEGER(mpi_address_kind) :: src_extent, dst_extent
    INTEGER(mpi_address_kind) :: base_address, temp_address
    INTEGER(c_int), PARAMETER :: displacements(3) = (/0_c_int,2_c_int,4_c_int/)
    DOUBLE PRECISION, TARGET :: src_template(5, 3), dst_template(3, 3)
    INTEGER :: ierror, ddt_gen_test

    xmap = build_odd_selection_xmap(src_slice_len, comm)
    ! generate redist_repeat
    CALL mpi_get_address(src_template(1,1), base_address, ierror)
    CALL mpi_get_address(src_template(1,2), temp_address, ierror)
    src_extent = temp_address - base_address
    CALL mpi_get_address(dst_template(1,1), base_address, ierror)
    CALL mpi_get_address(dst_template(1,2), temp_address, ierror)
    dst_extent = temp_address - base_address

    DO ddt_gen_test = 1, SIZE(ddt_gen_lim)
      CALL xt_config_set_ddt_cache_limit(config, ddt_gen_lim(ddt_gen_test))
      redist = xt_redist_p2p_new(xmap, mpi_double_precision, config)

      redist_repeat = xt_redist_repeat_new(redist, src_extent, dst_extent, &
           num_slice, displacements, config)
      CALL xt_redist_delete(redist)

      ! test exchange
      CALL test_repeated_redist_ds1_with_gap(redist_repeat)
      ! clean up
      CALL xt_redist_delete(redist_repeat)
    END DO
    CALL xt_xmap_delete(xmap)
  END SUBROUTINE test_repeated_redist_with_gap

  SUBROUTINE test_repeated_overlapping_redist(comm, config)
    INTEGER, INTENT(in) :: comm
    TYPE(xt_config), INTENT(in) :: config

    ! test with one redist used three times (with two different input data
    ! displacements -> test of cache) (with default cache size)
    ! set up data
    INTEGER, PARAMETER :: npt = 9, selection_len = 6
    TYPE(xt_xmap) :: xmap
    TYPE(xt_redist) :: redist, redist_repeat
    INTEGER(mpi_address_kind) :: src_extent, dst_extent
    INTEGER(mpi_address_kind) :: base_address, temp_address
    INTEGER(c_int), PARAMETER :: displacements(2) = (/ 0_c_int, 1_c_int /)
    INTEGER :: i, j, ierror
    INTEGER, PARAMETER :: src_pos(npt) = (/ (i, i=1,npt) /), &
         dst_pos(npt) = (/ (2*i, i = 0, npt-1) /)
    DOUBLE PRECISION :: src_data(npt), dst_data(npt)
#if __INTEL_COMPILER >= 1600 && __INTEL_COMPILER <= 1602 || defined __PGI
    DOUBLE PRECISION :: ref_dst_data(npt)
#else
    DOUBLE PRECISION, PARAMETER :: ref_dst_data(npt) &
         = (/ ((DBLE(((2-j)*3+i+101)*((ABS(j)+j)/ABS(j+MAX(1,j))) &
         &           +(j-1-ABS(j-1))/2), &
         &     i=1,3 ),j=2,0,-1) /)
#endif
    DOUBLE PRECISION, TARGET :: src_template(2), dst_template(2)
    INTEGER :: iexch, ddt_gen_test
    TYPE(xt_request) :: request(2)

    ! init data
#if __INTEL_COMPILER >= 1600 && __INTEL_COMPILER <= 1602 || defined __PGI
    DO j = 2, 0, -1
      DO i = 1, 3
        ref_dst_data(i + (2-j)*3) = DBLE(((2-j)*3+i+101)*((ABS(j)+j)/ABS(j+1)) &
             &                           +(j-1-ABS(j-1))/2)
      END DO
    END DO
#endif
    DO i = 1, npt
      src_data(i) = 1.0d2 + DBLE(i)
    END DO
    ! generate redist_repeat
    CALL mpi_get_address(src_template(1), base_address, ierror)
    CALL mpi_get_address(src_template(2), temp_address, ierror)
    src_extent = temp_address - base_address
    CALL mpi_get_address(dst_template(1), base_address, ierror)
    CALL mpi_get_address(dst_template(2), temp_address, ierror)
    dst_extent = temp_address - base_address


    xmap = build_odd_selection_xmap(selection_len, comm)

    DO ddt_gen_test = 1, SIZE(ddt_gen_lim)
      CALL xt_config_set_ddt_cache_limit(config, ddt_gen_lim(ddt_gen_test))
      redist = xt_redist_p2p_off_custom_new(xmap, src_pos, dst_pos, &
           mpi_double_precision, config)

      DO iexch = 1, 2

        dst_data = -1.0d0

        ! test individual redists
        IF (iexch == 1) THEN
          CALL xt_redist_s_exchange(redist, src_data, dst_data)
          CALL xt_redist_s_exchange(redist, src_data(2:), dst_data(2:))
        ELSE
          CALL xt_redist_a_exchange(redist, src_data, dst_data, request(1))
          CALL xt_redist_a_exchange(redist, src_data(2:), dst_data(2:), request(2))
          CALL check_wait_request(request(1), filename, __LINE__)
          CALL check_wait_request(request(2), filename, __LINE__)
        ENDIF
        ! check individual redists to have desired effect
        IF (cmp_arrays(dst_data, ref_dst_data)) &
             CALL test_abort("error in "//exch1name(iexch), filename,__LINE__)
      ENDDO
      dst_data = -1.0d0
      redist_repeat = xt_redist_repeat_new(redist, src_extent, dst_extent, &
           displacements, config)
      CALL xt_redist_delete(redist)

      ! test exchange
      CALL check_redist(redist_repeat, src_data, dst_data, ref_dst_data)
      ! clean up
      CALL xt_redist_delete(redist_repeat)
    END DO
    CALL xt_xmap_delete(xmap)
  END SUBROUTINE test_repeated_overlapping_redist

END PROGRAM test_redist_repeat
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_idxvec_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_idxvec
  USE mpi
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_idxlist, xt_idxvec_new, &
       xt_idxvec_from_stripes_new, &
       xt_int_kind, xt_stripe, xt_idxlist_get_intersection, &
       xt_idxlist_get_index_stripes, xt_idxlist_delete, &
       xt_idxlist_get_positions_of_indices, &
       xt_idxlist_get_index_at_position, xt_idxlist_get_indices_at_positions, &
       xt_idxlist_get_position_of_index, xt_idxlist_get_position_of_index_off, &
       xt_bounds, xt_idxlist_get_bounding_box, xt_idxlist_copy
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_idxlist_utils, ONLY: check_idxlist, test_err_count, check_stripes, &
       check_offsets, idxlist_pack_unpack_copy
  IMPLICIT NONE
  INTEGER, PARAMETER :: xi = xt_int_kind
  INTEGER(xt_int_kind), PARAMETER :: index_vector(7) &
       = (/ 1_xi, 2_xi, 3_xi, 4_xi, 5_xi, 6_xi, 7_xi /)
  CHARACTER(len=*), PARAMETER :: filename = 'test_idxvec_f.f90'

  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)

  CALL test_idxvec_pack_unpack
  CALL test_copying
  CALL test_repeated_equal_indices
  CALL test_positions
  CALL test_intersection_surjective
  CALL test_intersection_partial
  CALL test_intersection_inverse_partial
  CALL test_intersection_unsort_partial
  CALL test_intersection_unsort_inverse_partial
  CALL test_stripes1
  CALL test_stripes2
  CALL test_stripes3
  CALL test_stripes4
  CALL test_stripes5
  CALL test_stripes6
  CALL test_stripes7
  CALL test_get_indices_at_positions1
  CALL test_get_indices_at_positions2
  CALL test_get_indices_at_positions3
  CALL test_get_positions_of_indices
  CALL test_bounding_box1
  CALL test_bounding_box2
  CALL test_bounding_box3

  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_finalize
  CALL finish_mpi
CONTAINS
  SUBROUTINE test_idxvec_pack_unpack
    TYPE(xt_idxlist) :: idxvector, idxvector_copy, intersection
    TYPE(xt_stripe), PARAMETER :: ref_stripes(1) = (/ xt_stripe(1, 1, 7) /)
    CALL setup_idxvec(idxvector, index_vector)

    idxvector_copy = idxlist_pack_unpack_copy(idxvector)

    CALL check_idxlist(idxvector_copy, index_vector)

    intersection = xt_idxlist_get_intersection(idxvector, idxvector_copy)

    CALL check_idxlist(intersection, index_vector)

    CALL compare_stripes(idxvector, ref_stripes)

    CALL xt_idxlist_delete(idxvector)
    CALL xt_idxlist_delete(idxvector_copy)
    CALL xt_idxlist_delete(intersection)

  END SUBROUTINE test_idxvec_pack_unpack

  SUBROUTINE test_copying
    TYPE(xt_idxlist) :: idxvector, idxvector_copy
    CALL setup_idxvec(idxvector, index_vector)
    idxvector_copy = xt_idxlist_copy(idxvector)
    CALL check_idxlist(idxvector_copy, index_vector)
    CALL xt_idxlist_delete(idxvector)
    CALL xt_idxlist_delete(idxvector_copy)
  END SUBROUTINE test_copying

  SUBROUTINE test_repeated_equal_indices
    INTEGER(xt_int_kind), PARAMETER :: index_vector(8) &
         = (/ 1_xi, 2_xi, 3_xi, 7_xi, 5_xi, 6_xi, 7_xi, 7_xi /)
    TYPE(xt_idxlist) :: idxvector
    CALL setup_idxvec(idxvector, index_vector)
    CALL xt_idxlist_delete(idxvector)
  END SUBROUTINE test_repeated_equal_indices

  SUBROUTINE test_positions
    LOGICAL, PARAMETER :: single_match_only = .TRUE.
    INTEGER(xt_int_kind), PARAMETER :: index_vector(20) &
         = (/ 10_xi, 15_xi, 14_xi, 13_xi, 12_xi, &
         &    15_xi, 10_xi, 11_xi, 12_xi, 13_xi, &
         &    23_xi, 18_xi, 19_xi, 20_xi, 21_xi, &
         &    31_xi, 26_xi, 27_xi, 28_xi, 29_xi /), &
         intersection_vector(13) &
         = (/ 12_xi, 12_xi, 13_xi, 13_xi, 14_xi, &
         &    15_xi, 15_xi, 20_xi, 21_xi, 23_xi, &
         &    28_xi, 29_xi, 31_xi /)
    INTEGER :: intersection_pos(SIZE(intersection_vector))
    INTEGER, PARAMETER :: ref_intersection_pos(SIZE(intersection_vector)) &
         = (/ 4, 8, 3, 9, 2, 1, 5, 13, 14, 10, 18, 19, 15 /)
    TYPE(xt_idxlist) :: idxvector
    INTEGER :: notfound
    CALL setup_idxvec(idxvector, index_vector)
    notfound = xt_idxlist_get_positions_of_indices(idxvector, &
         intersection_vector, intersection_pos, single_match_only)
    IF (notfound /= 0) &
         CALL test_abort('expected indices not found!', filename, __LINE__)
    CALL check_offsets(intersection_pos, ref_intersection_pos)
    CALL xt_idxlist_delete(idxvector)
  END SUBROUTINE test_positions

  SUBROUTINE test_intersection(index_vector_a, index_vector_b, &
       ref_intersection_indices)
    INTEGER(xt_int_kind), INTENT(in) :: index_vector_a(:), index_vector_b(:), &
         ref_intersection_indices(:)
    ! note: instead of declaring this as the move intuitive idxvector(2),
    ! two distinct variables are used to remain compatible with NAG 5.2
    TYPE(xt_idxlist) :: idxvector1, idxvector2, intersection
    CALL setup_idxvec(idxvector1, index_vector_a)
    CALL setup_idxvec(idxvector2, index_vector_b)
    intersection = xt_idxlist_get_intersection(idxvector1, idxvector2)
    CALL check_idxlist(intersection, ref_intersection_indices)
    CALL xt_idxlist_delete(intersection)
    CALL xt_idxlist_delete(idxvector2)
    CALL xt_idxlist_delete(idxvector1)
  END SUBROUTINE test_intersection

  SUBROUTINE test_intersection_surjective
    INTEGER(xt_int_kind), PARAMETER :: index_vector(3, 2) &
         = RESHAPE((/ 1_xi, 2_xi, 3_xi, 1_xi, 2_xi, 3_xi /), &
         &         SHAPE(index_vector)), &
         ref_intersection_indices(3) = (/ 1_xi, 2_xi, 3_xi /)
    CALL test_intersection(index_vector(:, 1), index_vector(:, 2), &
         ref_intersection_indices)
  END SUBROUTINE test_intersection_surjective

  SUBROUTINE test_intersection_partial
    INTEGER(xt_int_kind), PARAMETER :: index_vector(3, 2) &
         = RESHAPE((/ 1_xi, 2_xi, 3_xi, 2_xi, 3_xi, 4_xi /), &
         &         SHAPE(index_vector)), &
         ref_intersection_indices(2) = (/ 2_xi, 3_xi /)
    CALL test_intersection(index_vector(:, 1), index_vector(:, 2), &
         ref_intersection_indices)
  END SUBROUTINE test_intersection_partial

  SUBROUTINE test_intersection_inverse_partial
    INTEGER(xt_int_kind), PARAMETER :: index_vector(3, 2) &
         = RESHAPE((/ 2_xi, 3_xi, 4_xi, 1_xi, 2_xi, 3_xi /), &
         &         SHAPE(index_vector)), &
         ref_intersection_indices(2) = (/ 2_xi, 3_xi /)
    CALL test_intersection(index_vector(:, 1), index_vector(:, 2), &
         ref_intersection_indices)
  END SUBROUTINE test_intersection_inverse_partial

  SUBROUTINE test_intersection_unsort_partial
    INTEGER(xt_int_kind), PARAMETER :: index_vector(3, 2) &
         = RESHAPE((/ 4_xi, 2_xi, 3_xi, 3_xi, 1_xi, 2_xi /), &
         &         SHAPE(index_vector)), &
         ref_intersection_indices(2) = (/ 2_xi, 3_xi /)
    CALL test_intersection(index_vector(:, 1), index_vector(:, 2), &
         ref_intersection_indices)
  END SUBROUTINE test_intersection_unsort_partial

  SUBROUTINE test_intersection_unsort_inverse_partial
    INTEGER(xt_int_kind), PARAMETER :: index_vector(3, 2) &
         = RESHAPE((/ 3_xi, 1_xi, 2_xi, 4_xi, 2_xi, 3_xi /), &
         &         SHAPE(index_vector)), &
         ref_intersection_indices(2) = (/ 2_xi, 3_xi /)
    CALL test_intersection(index_vector(:, 1), index_vector(:, 2), &
         ref_intersection_indices)
  END SUBROUTINE test_intersection_unsort_inverse_partial

  SUBROUTINE test_idxvec_from_stripes(stripes, ref_indices)
    TYPE(xt_stripe), INTENT(in) :: stripes(:)
    INTEGER(xt_int_kind), INTENT(in) :: ref_indices(:)

    TYPE(xt_idxlist) :: idxvec
    idxvec = xt_idxvec_from_stripes_new(stripes)
    CALL check_idxlist(idxvec, ref_indices)
    CALL xt_idxlist_delete(idxvec)
  END SUBROUTINE test_idxvec_from_stripes

  SUBROUTINE test_stripes1
    TYPE(xt_stripe), PARAMETER :: stripes(2) = &
         (/ xt_stripe(5, 1, 5), xt_stripe(4, -1, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(10) &
         = (/ 5_xi, 6_xi, 7_xi, 8_xi, 9_xi, 4_xi, 3_xi, 2_xi, 1_xi, 0_xi /)
    CALL test_idxvec_from_stripes(stripes, ref_indices)
  END SUBROUTINE test_stripes1

  SUBROUTINE test_stripes2
    TYPE(xt_stripe), PARAMETER :: stripes(3) &
         = (/ xt_stripe(0, 1, 5), xt_stripe(2, 1, 5), xt_stripe(4, 1, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(15) &
         = (/ 0_xi, 1_xi, 2_xi, 3_xi, 4_xi, &
         &    2_xi, 3_xi, 4_xi, 5_xi, 6_xi, &
         &    4_xi, 5_xi, 6_xi, 7_xi, 8_xi /)
    CALL test_idxvec_from_stripes(stripes, ref_indices)
  END SUBROUTINE test_stripes2

  SUBROUTINE test_stripes3
    TYPE(xt_stripe), PARAMETER :: stripes(3) &
         = (/ xt_stripe(2, 1, 5), xt_stripe(0, 1, 5), xt_stripe(4, 1, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(15) &
         = (/ 2_xi, 3_xi, 4_xi, 5_xi, 6_xi, &
         &    0_xi, 1_xi, 2_xi, 3_xi, 4_xi, &
         &    4_xi, 5_xi, 6_xi, 7_xi, 8_xi /)
    CALL test_idxvec_from_stripes(stripes, ref_indices)
  END SUBROUTINE test_stripes3

  SUBROUTINE test_stripes4
    TYPE(xt_stripe), PARAMETER :: stripes(3) &
         = (/ xt_stripe(2, 1, 5), xt_stripe(4, -1, 5), xt_stripe(4, 1, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(15) &
         = (/ 2_xi, 3_xi, 4_xi, 5_xi, 6_xi, &
         &    4_xi, 3_xi, 2_xi, 1_xi, 0_xi, &
         &    4_xi, 5_xi, 6_xi, 7_xi, 8_xi /)
    CALL test_idxvec_from_stripes(stripes, ref_indices)
  END SUBROUTINE test_stripes4

  SUBROUTINE test_stripes5
    TYPE(xt_stripe), PARAMETER :: stripes(3) &
         = (/ xt_stripe(0, 3, 5), xt_stripe(1, 3, 5), xt_stripe(14, -3, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(15) &
         = (/ 0_xi,  3_xi, 6_xi,  9_xi, 12_xi, &
         &    1_xi,  4_xi, 7_xi, 10_xi, 13_xi, &
         &   14_xi, 11_xi, 8_xi,  5_xi,  2_xi /)
    CALL test_idxvec_from_stripes(stripes, ref_indices)
  END SUBROUTINE test_stripes5

  SUBROUTINE test_stripes6
    TYPE(xt_stripe), PARAMETER :: stripes(3) &
         = (/ xt_stripe(0, 3, 5), xt_stripe(2, 3, 5), xt_stripe(14, -3, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(15) &
         = (/ 0_xi,  3_xi, 6_xi,  9_xi, 12_xi, &
         &    2_xi,  5_xi, 8_xi, 11_xi, 14_xi, &
         &   14_xi, 11_xi, 8_xi,  5_xi,  2_xi /)
    CALL test_idxvec_from_stripes(stripes, ref_indices)
  END SUBROUTINE test_stripes6

  SUBROUTINE test_stripes7
    TYPE(xt_stripe), PARAMETER :: stripes(4) = (/ xt_stripe(0, -1, 5), &
         xt_stripe(1, 1, 5), xt_stripe(-5, -1, 5), xt_stripe(6, 1, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(20) &
         = (/ 0_xi, -1_xi, -2_xi, -3_xi, -4_xi, &
         &    1_xi,  2_xi,  3_xi,  4_xi,  5_xi, &
         &   -5_xi, -6_xi, -7_xi, -8_xi, -9_xi, &
         &    6_xi,  7_xi,  8_xi,  9_xi, 10_xi /)
    CALL test_idxvec_from_stripes(stripes, ref_indices)
  END SUBROUTINE test_stripes7

  SUBROUTINE test_get_indices_at_positions(indices, undef_idx, pos)
    INTEGER(xt_int_kind), INTENT(in) :: indices(:), undef_idx
    INTEGER, INTENT(in) :: pos(:)
    INTEGER(xt_int_kind) :: ref_sel_idx(SIZE(pos)), sel_idx(SIZE(pos))
    INTEGER :: i, num_pos, undef_count, ref_undef_count
    TYPE(xt_idxlist) :: idxvec
    CHARACTER(80) :: msg
    num_pos = SIZE(pos)
    idxvec = xt_idxvec_new(indices, SIZE(indices))
    ref_undef_count = 0
    DO i = 1, num_pos
      IF (xt_idxlist_get_index_at_position(idxvec, pos(i), ref_sel_idx(i))) &
           THEN
        ref_sel_idx(i) = undef_idx
        ref_undef_count = ref_undef_count + 1
      END IF
    END DO
    undef_count = xt_idxlist_get_indices_at_positions(idxvec, pos, sel_idx, &
         undef_idx)
    IF (undef_count /= ref_undef_count) THEN
      CALL test_abort("test_idxvec_f.f90: (undef_count /= ref_undef_count)", &
           filename, __LINE__)
    END IF
    DO i = 1, num_pos
      IF (sel_idx(i) /= ref_sel_idx(i)) THEN
        WRITE (msg, '(2(a,i0),a)') "test_idxvec_f.f90: (sel_idx(", i, &
             ") /= ref_sel_idx(", i, "))"
        CALL test_abort(msg, filename, __LINE__)
      END IF
    END DO
    CALL xt_idxlist_delete(idxvec)
  END SUBROUTINE test_get_indices_at_positions

  SUBROUTINE test_get_indices_at_positions1
    INTEGER(xt_int_kind), PARAMETER :: indices(16) &
         = (/ 0_xi,  3_xi,  6_xi,  9_xi, 12_xi, 1_xi,  4_xi, 7_xi, &
         &   10_xi, 13_xi, 14_xi, 11_xi,  8_xi, 5_xi,  2_xi, 1_xi /)
    INTEGER(xt_int_kind), PARAMETER :: undef_idx = -HUGE(undef_idx)
    INTEGER, PARAMETER :: pos(13) &
         = (/ 0, 2, 7, 9, 11, 100, 11, 200, 9, 300, 7, 400, 5 /)
    CALL test_get_indices_at_positions(indices, undef_idx, pos)
  END SUBROUTINE test_get_indices_at_positions1

  SUBROUTINE test_get_indices_at_positions2
    INTEGER(xt_int_kind), PARAMETER :: indices(16) &
         = (/ 0_xi,  3_xi,  6_xi,  9_xi, 12_xi, 1_xi, 4_xi, 7_xi, &
         &   10_xi, 13_xi, 14_xi, 11_xi,  8_xi, 5_xi, 2_xi, 1_xi /)
    INTEGER(xt_int_kind), PARAMETER :: undef_idx = -HUGE(undef_idx)
    INTEGER, PARAMETER :: pos(9) &
         = (/ 0, 2, 7, 9, 11, 11, 9, 7, 5 /)
    CALL test_get_indices_at_positions(indices, undef_idx, pos)
  END SUBROUTINE test_get_indices_at_positions2

  SUBROUTINE test_get_indices_at_positions3
    INTEGER(xt_int_kind), PARAMETER :: indices(16) &
         = (/ 0_xi,  3_xi,  6_xi,  9_xi, 12_xi, 1_xi, 4_xi, 7_xi, &
         &   10_xi, 13_xi, 14_xi, 11_xi,  8_xi, 5_xi, 2_xi, 1_xi /)
    INTEGER(xt_int_kind), PARAMETER :: undef_idx = -HUGE(indices(1))
    INTEGER, PARAMETER :: pos(9) &
         = (/ 100, 102, 107, 109, 1011, 1011, 109, 107, 105 /)
    CALL test_get_indices_at_positions(indices, undef_idx, pos)
  END SUBROUTINE test_get_indices_at_positions3

  SUBROUTINE test_get_positions_of_indices
    INTEGER(xt_int_kind), PARAMETER :: indices(2) = (/ 0_xi, 2_xi /), &
         selection(3) = (/ 1_xi, 2_xi, 3_xi /)
    INTEGER :: i, position, positions(SIZE(selection))
    INTEGER, PARAMETER :: ref_positions(3) = (/ -1, 1, -1 /)
    TYPE(xt_idxlist) :: idxvec

    idxvec = xt_idxvec_new(indices, SIZE(indices))
    IF (.NOT. xt_idxlist_get_position_of_index(idxvec, 1_xt_int_kind, &
         position)) &
         CALL test_abort('xt_idxlist_get_position_of_index did not return &
         &an error', &
         filename, __LINE__)
    IF (.NOT. xt_idxlist_get_position_of_index_off(idxvec, 1_xt_int_kind, &
         position, 0)) &
         CALL test_abort('xt_idxlist_get_position_of_index_off did not return &
         &an error', &
         filename, __LINE__)
    IF (.NOT. xt_idxlist_get_position_of_index_off(idxvec, 0_xt_int_kind, &
         position, 1)) &
         CALL test_abort('xt_idxlist_get_position_of_index_off did not return &
         &an error', &
         filename, __LINE__)
    IF (xt_idxlist_get_positions_of_indices(idxvec, selection, positions, &
         .FALSE.) /= 2) THEN
      CALL test_abort('xt_idxlist_get_positions_of_indices did not return &
           &correct number of matches', &
           filename, __LINE__)
    END IF
    DO i = 1, SIZE(selection)
      IF (positions(i) /= ref_positions(i)) &
           CALL test_abort('xt_idxlist_get_positions_of_indices returned &
           &incorrect position', &
           filename, __LINE__)
    END DO
    CALL xt_idxlist_delete(idxvec)
  END SUBROUTINE test_get_positions_of_indices

  SUBROUTINE test_bounding_box(indices, global_size, global_start_index, &
       ref_bounds)
    INTEGER(xt_int_kind), INTENT(in) :: indices(:), global_size(:), &
         global_start_index
    TYPE(xt_bounds), INTENT(in) :: ref_bounds(:)

    TYPE(xt_bounds) :: bounds(SIZE(global_size))
    INTEGER :: i, ndim
    TYPE(xt_idxlist) :: idxvec
    CHARACTER(80) :: msg

    ndim = SIZE(global_size)
    IF (SIZE(ref_bounds) /= ndim) &
         CALL test_abort('ERROR: inequal dimensions', filename, __LINE__)

    idxvec = xt_idxvec_new(indices, SIZE(indices))

    bounds = xt_idxlist_get_bounding_box(idxvec, global_size, &
         global_start_index)

    DO i = 1, ndim
      IF (bounds(i)%start /= ref_bounds(i)%start) THEN
        WRITE (0, '(2(a,i0))') 'bounds(', i, ')%start=', bounds(i)%start
        WRITE (0, '(2(a,i0))') 'ref_bounds(', i, ')%start=', ref_bounds(i)%start
        WRITE (msg, '(a,i0)') "ERROR: xt_idxlist_get_bounding_box inequal &
             &starts at i=", i
        CALL test_abort(msg, filename, __LINE__)
      END IF
      IF (bounds(i)%size /= ref_bounds(i)%size) THEN
        WRITE (0, '(2(a,i0))') 'bounds(', i, ')%size=', bounds(i)%size
        WRITE (0, '(2(a,i0))') 'ref_bounds(', i, ')%size=', ref_bounds(i)%size
        WRITE (msg, '(a,i0)') "ERROR: xt_idxlist_get_bounding_box inequal &
             &size at i=", i
        CALL test_abort(msg, filename, __LINE__)
      END IF
    END DO
    CALL xt_idxlist_delete(idxvec)
  END SUBROUTINE test_bounding_box

  SUBROUTINE test_bounding_box1
    INTEGER(xt_int_kind), PARAMETER :: indices(2) = (/ 21_xi, 42_xi /), &
         global_size(3) = 4_xi, global_start_index = 0_xi
    TYPE(xt_bounds), PARAMETER :: ref_bounds(3) = xt_bounds(1_xi, 2_xi)
    CALL test_bounding_box(indices, global_size, global_start_index, ref_bounds)
  END SUBROUTINE test_bounding_box1

  SUBROUTINE test_bounding_box2
    INTEGER(xt_int_kind), PARAMETER :: indices(5) &
         = (/ 45_xi, 35_xi, 32_xi, 48_xi, 33_xi /), &
         global_size(3) = (/ 5_xi, 4_xi, 3_xi /), global_start_index = 1_xi
    TYPE(xt_bounds), PARAMETER :: ref_bounds(3) &
         = (/ xt_bounds(2, 2), xt_bounds(2, 2), xt_bounds(1, 2) /)
    CALL test_bounding_box(indices, global_size, global_start_index, ref_bounds)
  END SUBROUTINE test_bounding_box2

  SUBROUTINE test_bounding_box3
    INTEGER(xt_int_kind), PARAMETER :: indices(1) = (/ -1_xi /), &
         global_size(3) = 4_xi, global_start_index = 0_xi
    TYPE(xt_bounds), PARAMETER :: ref_bounds(3) = xt_bounds(0, 0)
    CALL test_bounding_box(indices(1:0), global_size, global_start_index, &
         ref_bounds)
  END SUBROUTINE test_bounding_box3

  SUBROUTINE setup_idxvec(idxlist, index_vector)
    TYPE(xt_idxlist), INTENT(out) :: idxlist
    INTEGER(xt_int_kind), INTENT(in) :: index_vector(:)

    idxlist = xt_idxvec_new(index_vector, SIZE(index_vector))
    CALL check_idxlist(idxlist, index_vector)
  END SUBROUTINE setup_idxvec

  SUBROUTINE compare_stripes(idxlist, ref_stripes)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    TYPE(xt_stripe), INTENT(in) :: ref_stripes(:)

    TYPE(xt_stripe), ALLOCATABLE :: stripes(:)

    CALL xt_idxlist_get_index_stripes(idxlist, stripes)

    CALL check_stripes(stripes, ref_stripes)

  END SUBROUTINE compare_stripes

END PROGRAM test_idxvec
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_xmap_common_f.f90
!! @brief generic Fortran xmap test procedures
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
MODULE test_xmap_common
  USE iso_c_binding, ONLY: c_int
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_int_kind, &
       xt_stripe, xt_idxlist, xt_idxlist_delete, xt_idxvec_new, &
       xt_idxstripes_new, xi => xt_int_kind, &
       xt_xmap, xt_xmap_copy, xt_xmap_delete, &
       xt_xmap_get_num_destinations, xt_xmap_get_num_sources, &
       xt_xmap_get_destination_ranks, xt_xmap_get_source_ranks, &
       xt_mpi_comm_mark_exclusive
  IMPLICIT NONE
  PRIVATE
  INTEGER :: my_rank
  PUBLIC :: xmap_self_test_main, test_self_xmap_construct
  INTERFACE test_self_xmap_construct
    MODULE PROCEDURE test_self_xmap_construct_idxlist
    MODULE PROCEDURE test_self_xmap_construct_indices
    MODULE PROCEDURE test_self_xmap_construct_stripes
  END INTERFACE test_self_xmap_construct
  CHARACTER(len=*), PARAMETER :: filename = 'test_xmap_common_f.f90'
CONTAINS
  SUBROUTINE xmap_self_test_main(xmap_new)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER :: ierror, i, j
    INTEGER :: comms(2)
    INTEGER(xi), PARAMETER :: lsize(2) = (/ 7_xi, 1023_xi /)

    CALL init_mpi
    CALL xt_initialize(mpi_comm_world)
    CALL mpi_comm_rank(mpi_comm_world, my_rank, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)

    comms(1) = mpi_comm_world
    CALL mpi_comm_dup(mpi_comm_world, comms(2), ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)
    CALL xt_mpi_comm_mark_exclusive(comms(2))

    DO i = 1, SIZE(comms)
      DO j = 1, 2
        CALL test_xmap1a(xmap_new, lsize(j), comms(i))
        CALL test_xmap1b(xmap_new, lsize(j), comms(i))
      END DO
      CALL test_xmap2(xmap_new, comms(i))
    END DO

    CALL mpi_comm_free(comms(2), ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)

    IF (test_err_count() /= 0) &
         CALL test_abort("non-zero error count!", filename, __LINE__)
    CALL xt_finalize
    CALL finish_mpi
  END SUBROUTINE xmap_self_test_main

  SUBROUTINE shift_idx(idx, offset)
    INTEGER(xi), INTENT(inout) :: idx(:)
    INTEGER(xi), INTENT(in) :: offset
    INTEGER :: i
    DO i = 1, SIZE(idx)
      idx(i) = idx(i) + INT(my_rank, xi) * offset
    END DO
  END SUBROUTINE shift_idx

  SUBROUTINE assert_xmap_is_to_self(xmap)
    TYPE(xt_xmap) :: xmap
    INTEGER :: rank(1)
    IF (xt_xmap_get_num_destinations(xmap) /= 1) &
         CALL test_abort("error in xmap construction", filename, __LINE__)

    IF (xt_xmap_get_num_sources(xmap) /= 1) &
         CALL test_abort("error in xt_xmap_get_num_sources", filename, __LINE__)
    CALL xt_xmap_get_destination_ranks(xmap, rank)
    IF (rank(1) /= my_rank) &
         CALL test_abort("error in xt_xmap_get_destination_ranks", &
         filename, __LINE__)

    CALL xt_xmap_get_source_ranks(xmap, rank)
    IF (rank(1) /= my_rank) &
         CALL test_abort("error in xt_xmap_get_source_ranks", &
         filename, __LINE__)

  END SUBROUTINE assert_xmap_is_to_self

  SUBROUTINE test_self_xmap_construct_stripes(src_stripes, dst_stripes, &
       xmap_new, comm)
    TYPE(xt_stripe), INTENT(in) :: src_stripes(:), dst_stripes(:)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(in) :: comm
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    src_idxlist = xt_idxstripes_new(src_stripes)
    dst_idxlist = xt_idxstripes_new(dst_stripes)
    CALL test_self_xmap_construct(src_idxlist, dst_idxlist, xmap_new, comm)
  END SUBROUTINE test_self_xmap_construct_stripes

  SUBROUTINE test_self_xmap_construct_indices(src_indices, dst_indices, &
       xmap_new, comm)
    INTEGER(xi), INTENT(in) :: src_indices(:), dst_indices(:)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(in) :: comm
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    src_idxlist = xt_idxvec_new(src_indices)
    dst_idxlist = xt_idxvec_new(dst_indices)
    CALL test_self_xmap_construct(src_idxlist, dst_idxlist, xmap_new, comm)
  END SUBROUTINE test_self_xmap_construct_indices

  SUBROUTINE test_self_xmap_construct_idxlist(src_idxlist, dst_idxlist, &
       xmap_new, comm)
    TYPE(xt_idxlist), INTENT(inout) :: src_idxlist, dst_idxlist
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(in) :: comm

    TYPE(xt_xmap) :: xmap, xmap_copy

    xmap = xmap_new(src_idxlist, dst_idxlist, comm)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    CALL assert_xmap_is_to_self(xmap)
    xmap_copy = xt_xmap_copy(xmap)
    CALL assert_xmap_is_to_self(xmap_copy)

    CALL xt_xmap_delete(xmap)
    CALL xt_xmap_delete(xmap_copy)
  END SUBROUTINE test_self_xmap_construct_idxlist

  SUBROUTINE test_xmap1a(xmap_new, lsize, comm)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER(xi), INTENT(in) :: lsize
    INTEGER, INTENT(in) :: comm

    INTEGER(xt_int_kind) :: src_indices(lsize), dst_indices(lsize), i
    DO i = 1_xi, lsize
      src_indices(i) = i
    END DO
    CALL shift_idx(src_indices, lsize)
    DO i = 1_xi, lsize
      dst_indices(i) = lsize - i + 1_xi
    END DO
    CALL shift_idx(dst_indices, lsize)

    CALL test_self_xmap_construct(src_indices, dst_indices, &
         xmap_new, comm)
  END SUBROUTINE test_xmap1a

  SUBROUTINE test_xmap1b(xmap_new, lsize, comm)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER(xi), INTENT(in) :: lsize
    INTEGER, INTENT(in) :: comm

    TYPE(xt_stripe) :: src_stripe(1), dst_stripe(1)
    src_stripe(1) = xt_stripe(1_xi + INT(my_rank, xi) * lsize, &
         1_xi, INT(lsize, c_int))
    dst_stripe(1) = xt_stripe(INT(my_rank+1, xi) * lsize, &
         -1_xi, INT(lsize, c_int))
    CALL test_self_xmap_construct(src_stripe, dst_stripe, &
         xmap_new, comm)
  END SUBROUTINE test_xmap1b

  SUBROUTINE test_xmap2(xmap_new, comm)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        IMPORT :: xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(in) :: comm

    INTEGER(xi) :: src_index_list(14), dst_index_list(13)
    src_index_list = &
         (/ 5_xi, 67_xi, 4_xi, 5_xi, 13_xi, &
         &  9_xi,  2_xi, 1_xi, 0_xi, 96_xi, &
         & 13_xi, 12_xi, 1_xi, 3_xi /)
    dst_index_list = &
         (/ 5_xi, 4_xi, 3_xi, 96_xi, 1_xi, &
         &  5_xi, 4_xi, 5_xi,  4_xi, 3_xi, &
         & 13_xi, 2_xi, 1_xi /)
    CALL test_self_xmap_construct(src_index_list, dst_index_list, xmap_new, comm)
  END SUBROUTINE test_xmap2

END MODULE test_xmap_common
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_idxstripes_f.f90
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
PROGRAM test_idxstripes_f
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort, &
       run_randomized_tests, init_fortran_random
  USE mpi
  USE test_idxlist_utils, ONLY: check_idxlist, test_err_count, &
       idxlist_pack_unpack_copy
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_bounds, xt_pos_ext, &
       xt_stripe, xt_idxlist, xt_idxlist_delete, xt_idxstripes_new, &
       xt_idxvec_from_stripes_new, xt_int_kind, xt_idxlist_copy, &
       xt_idxvec_from_stripes_new, &
       xt_idxlist_get_index_stripes, xt_idxlist_get_intersection, &
       xt_idxlist_get_index_at_position, xt_idxlist_get_indices_at_positions, &
       xt_idxlist_get_bounding_box, OPERATOR(/=), &
       xt_idxlist_get_pos_exts_of_index_stripes, &
       xt_idxlist_get_num_indices, xt_idxvec_new, &
       xt_idxstripes_from_idxlist_new
  USE iso_c_binding, ONLY: c_int
  IMPLICIT NONE
  INTEGER, PARAMETER :: xi = xt_int_kind
  LOGICAL :: fully_random_tests
  CHARACTER(len=*), PARAMETER :: filename = 'test_idxstripes_f.f90'

  CALL init_mpi
  CALL xt_initialize(mpi_comm_world)
  CALL stripe_test_general1
  CALL stripe_test_general2
  CALL stripe_test_general3
  CALL stripe_test_general4
  CALL stripe_test_general5
  CALL stripe_test_general6
  CALL test_intersection0
  CALL test_intersection1
  CALL test_intersection2
  CALL test_intersection3
  CALL test_intersection4
  CALL test_intersection5
  CALL test_intersection6
  CALL test_intersection7
  CALL test_intersection8
  CALL test_intersection9
  CALL test_intersection10
  CALL test_intersection11
  CALL test_intersection12
  CALL test_intersection13
  CALL test_intersection14
  CALL test_intersection15
  CALL test_intersection_stripe2vec
  CALL test_idxlist_stripes_pos_ext1
  CALL test_idxlist_stripes_pos_ext2
  CALL test_idxlist_stripes_pos_ext3
#if SIZEOF_XT_INT > 2
  CALL test_idxlist_stripes_pos_ext4
  CALL test_idxlist_stripes_pos_ext5
#endif
  CALL test_idxlist_stripes_pos_ext_randomized1(.FALSE.)
  fully_random_tests = run_randomized_tests()
  IF (fully_random_tests) &
       CALL test_idxlist_stripes_pos_ext_randomized1(.TRUE.)
  CALL test_get_pos1
  CALL test_get_pos2
  CALL test_get_pos3
  CALL test_get_pos4
  CALL test_stripe_overlap
  CALL test_stripe_bb1
  CALL test_stripe_bb2
  CALL check_pos_ext1
  CALL check_pos_ext2
  CALL check_pos_ext3
  CALL check_pos_ext4
  CALL check_pos_ext5
  CALL check_pos_ext6
  CALL check_pos_ext7
  CALL check_pos_ext8
  IF (test_err_count() /= 0) &
       CALL test_abort("non-zero error count!", filename, __LINE__)
  CALL xt_finalize
  CALL finish_mpi

CONTAINS
  SUBROUTINE stripe_test_general(stripes, ref_indices)
    TYPE(xt_stripe), INTENT(in) :: stripes(:)
    INTEGER(xt_int_kind), INTENT(in) :: ref_indices(:)

    TYPE(xt_idxlist) :: idxstripes, idxvec
    INTEGER :: num_ext, num_unmatched, num_pos, i
    INTEGER(c_int) :: ext_size
    TYPE(xt_pos_ext), ALLOCATABLE :: pos_ext(:)

    idxstripes = xt_idxstripes_new(stripes, SIZE(stripes))
    CALL do_tests(idxstripes, ref_indices)

    num_unmatched = xt_idxlist_get_pos_exts_of_index_stripes(idxstripes, &
         stripes, pos_ext, .TRUE.)
    IF (num_unmatched /= 0) &
         CALL test_abort("stripes not found", filename, __LINE__)

    num_pos = 0
    IF (ALLOCATED(pos_ext)) THEN
      num_ext = SIZE(pos_ext)
    ELSE
      num_ext = 0
    END IF
    DO i = 1, num_ext
      ext_size = pos_ext(i)%size
      IF (num_pos /= pos_ext(i)%start) &
           CALL test_abort("position/start mismatch", filename, __LINE__)
      num_pos = num_pos + ext_size
    END DO
    IF (num_pos /= xt_idxlist_get_num_indices(idxstripes)) &
         CALL test_abort("index list length/positions overlap mismatch", &
         filename, __LINE__)

    IF (ALLOCATED(pos_ext)) DEALLOCATE(pos_ext)
    CALL xt_idxlist_delete(idxstripes)

    ! test recreation of stripes from reference vector
    idxvec = xt_idxvec_new(ref_indices)
    idxstripes = xt_idxstripes_from_idxlist_new(idxvec)
    CALL check_idxlist(idxstripes, ref_indices)
    CALL xt_idxlist_delete(idxvec)
    CALL xt_idxlist_delete(idxstripes)
  END SUBROUTINE stripe_test_general

  SUBROUTINE stripe_test_general1
    TYPE(xt_stripe), PARAMETER :: stripes(3) = (/ xt_stripe(0, 1, 5), &
         xt_stripe(10, 1, 5), xt_stripe(20, 1, 5) /);
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(15) &
         = (/ 0_xi,  1_xi,  2_xi,  3_xi,  4_xi, &
         &   10_xi, 11_xi, 12_xi, 13_xi, 14_xi, &
         &   20_xi, 21_xi, 22_xi, 23_xi, 24_xi /)
    CALL stripe_test_general(stripes, ref_indices)
  END SUBROUTINE stripe_test_general1

  SUBROUTINE stripe_test_general2
    TYPE(xt_stripe), PARAMETER :: stripes(3) = (/ xt_stripe(0, 1, 5), &
         xt_stripe(10, 2, 5), xt_stripe(20, 3, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(15) &
         = (/ 0_xi,  1_xi,  2_xi,  3_xi,  4_xi, &
         &   10_xi, 12_xi, 14_xi, 16_xi, 18_xi, &
         &   20_xi, 23_xi, 26_xi, 29_xi, 32_xi /)
    CALL stripe_test_general(stripes, ref_indices)
  END SUBROUTINE stripe_test_general2

  SUBROUTINE stripe_test_general3
    TYPE(xt_stripe), PARAMETER :: stripes(2) = (/ xt_stripe(0, 6, 5), &
         xt_stripe(1, 3, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(10) &
         = (/ 0_xi, 6_xi, 12_xi, 18_xi, 24_xi, &
         &    1_xi, 4_xi,  7_xi, 10_xi, 13_xi /)
    CALL stripe_test_general(stripes, ref_indices)
  END SUBROUTINE stripe_test_general3

  SUBROUTINE stripe_test_general4
    TYPE(xt_stripe), PARAMETER :: stripes(2) = (/ xt_stripe(0, -1, 5), &
         xt_stripe(1, 1, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(10) &
         = (/ 0_xi, -1_xi, -2_xi, -3_xi, -4_xi, &
         &    1_xi,  2_xi,  3_xi,  4_xi,  5_xi /)
    CALL stripe_test_general(stripes, ref_indices)
  END SUBROUTINE stripe_test_general4

  SUBROUTINE stripe_test_general5
    TYPE(xt_stripe), PARAMETER :: stripes(2) = (/ xt_stripe(9, -2, 5), &
         xt_stripe(0, 2, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(10) &
         = (/ 9_xi,  7_xi,  5_xi,  3_xi,  1_xi, &
         &    0_xi,  2_xi,  4_xi,  6_xi,  8_xi /)
    CALL stripe_test_general(stripes, ref_indices)
  END SUBROUTINE stripe_test_general5

  SUBROUTINE stripe_test_general6
    TYPE(xt_stripe), PARAMETER :: stripes(1) = (/ xt_stripe(179, -2, 0) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(1) = (/ 0_xi /)
    CALL stripe_test_general(stripes, ref_indices(1:0))
  END SUBROUTINE stripe_test_general6

  SUBROUTINE test_intersection(stripes_a, stripes_b, ref_indices_a, ref_indices_b)
    TYPE(xt_stripe), INTENT(in) :: stripes_a(:), stripes_b(:)
    INTEGER(xt_int_kind), INTENT(in) :: ref_indices_a(:)
    INTEGER(xt_int_kind), OPTIONAL, INTENT(in) :: ref_indices_b(:)
    TYPE(xt_idxlist) :: idxstripes_a, idxstripes_b, intersection(2)

    idxstripes_a = xt_idxstripes_new(stripes_a)
    idxstripes_b = xt_idxstripes_new(stripes_b)
    intersection(1) = xt_idxlist_get_intersection(idxstripes_a, idxstripes_b)
    intersection(2) = xt_idxlist_get_intersection(idxstripes_b, idxstripes_a)
    CALL do_tests(intersection(1), ref_indices_a)
    IF (PRESENT(ref_indices_b)) THEN
      CALL do_tests(intersection(2), ref_indices_b)
    ELSE
      CALL do_tests(intersection(2), ref_indices_a)
    END IF
    CALL xt_idxlist_delete(intersection(2))
    CALL xt_idxlist_delete(intersection(1))
    CALL xt_idxlist_delete(idxstripes_a)
    CALL xt_idxlist_delete(idxstripes_b)
  END SUBROUTINE test_intersection

  SUBROUTINE test_intersection0
    TYPE(xt_stripe), PARAMETER :: stripes_a(1) = (/ xt_stripe(0, 0, 0) /), &
         stripes_b(1) = (/ xt_stripe(1, 1, 8) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(1) = (/ 0_xi /)
    CALL test_intersection(stripes_a(1:0), stripes_b, ref_indices(1:0))
  END SUBROUTINE test_intersection0

  SUBROUTINE test_intersection1
    TYPE(xt_stripe), PARAMETER :: stripes_a(2) = (/ xt_stripe(0, 1, 4), &
         xt_stripe(6, 1, 4) /), &
         stripes_b(1) = (/ xt_stripe(1, 1, 8) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(6) &
         = (/ 1_xi, 2_xi, 3_xi, 6_xi, 7_xi, 8_xi /)
    CALL test_intersection(stripes_a, stripes_b, ref_indices)
  END SUBROUTINE test_intersection1

  SUBROUTINE test_intersection2
    TYPE(xt_stripe), PARAMETER :: stripes_a(3) = (/ xt_stripe(0, 1, 4), &
         xt_stripe(6, 1, 4), xt_stripe(11, 1, 4) /), &
         stripes_b(2) = (/ xt_stripe(1, 1, 7), xt_stripe(9, 1, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(9) &
         = (/ 1_xi, 2_xi, 3_xi, 6_xi, 7_xi, 9_xi, 11_xi, 12_xi, 13_xi /)
    CALL test_intersection(stripes_a, stripes_b, ref_indices)
  END SUBROUTINE test_intersection2

  SUBROUTINE test_intersection3
    TYPE(xt_stripe), PARAMETER :: stripes_a(2) = (/ xt_stripe(0, 1, 3), &
         xt_stripe(8, 1, 3) /), &
         stripes_b(2) = (/ xt_stripe(3, 1, 5), xt_stripe(11, 1, 3) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(1) = (/ -1_xi /)
    CALL test_intersection(stripes_a, stripes_b, ref_indices(1:0))
  END SUBROUTINE test_intersection3

  SUBROUTINE test_intersection4
    TYPE(xt_stripe), PARAMETER :: stripes_a(1) = (/ xt_stripe(0, 1, 10) /), &
         stripes_b(2) = (/ xt_stripe(0, 2, 5), xt_stripe(9, -2, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(10) &
         = (/ 0_xi, 1_xi, 2_xi, 3_xi, 4_xi, 5_xi, 6_xi, 7_xi, 8_xi, 9_xi /)
    CALL test_intersection(stripes_a, stripes_b, ref_indices)
  END SUBROUTINE test_intersection4

  SUBROUTINE test_intersection5
    TYPE(xt_stripe), PARAMETER :: stripes_a(2) = (/ xt_stripe(0, 3, 5), &
         xt_stripe(1, 7, 5) /), &
         stripes_b(2) = (/ xt_stripe(0, 2, 7), xt_stripe(24, -1, 10) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(6) &
         = (/ 0_xi, 6_xi, 8_xi, 12_xi, 15_xi, 22_xi /)
    CALL test_intersection(stripes_a, stripes_b, ref_indices)
  END SUBROUTINE test_intersection5

  SUBROUTINE test_intersection6
    TYPE(xt_stripe), PARAMETER :: stripes_a(1) = (/ xt_stripe(0, 1, 10) /), &
         stripes_b(2) = (/ xt_stripe(5, 1, 5), xt_stripe(4, -1, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(10) &
         = (/ 0_xi, 1_xi, 2_xi, 3_xi, 4_xi, 5_xi, 6_xi, 7_xi, 8_xi, 9_xi /)
    CALL test_intersection(stripes_a, stripes_b, ref_indices)
  END SUBROUTINE test_intersection6

  SUBROUTINE test_intersection7
    TYPE(xt_stripe), PARAMETER :: stripes_a(2) = (/ xt_stripe(0, 1, 10) , &
            xt_stripe(20, 1, 5) /), &
         stripes_b(2) = (/ xt_stripe(3, 1, 5), xt_stripe(17, 1, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(7) &
         = (/ 3_xi, 4_xi, 5_xi, 6_xi, 7_xi, 20_xi, 21_xi /)
    CALL test_intersection(stripes_a, stripes_b, ref_indices)
  END SUBROUTINE test_intersection7

  SUBROUTINE test_intersection8
    TYPE(xt_stripe), PARAMETER :: stripes_a(10) = (/ xt_stripe(0, 1, 2), &
         xt_stripe(3, 1, 2), xt_stripe(5, 1, 2), xt_stripe(8, 1, 2), &
         xt_stripe(10, 1, 2), xt_stripe(14, 1, 2), xt_stripe(17, 1, 2), &
         xt_stripe(20, 1, 2), xt_stripe(23, 1, 2), xt_stripe(25, 1, 2) /), &
         stripes_b(5) = (/ xt_stripe(5, 1, 3), xt_stripe(8, 1, 2), &
         xt_stripe(19, 1, 1), xt_stripe(20, 1, 2), xt_stripe(30, 1, 2) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(6) &
         = (/ 5_xi, 6_xi, 8_xi, 9_xi, 20_xi, 21_xi /)
    CALL test_intersection(stripes_a, stripes_b, ref_indices)
  END SUBROUTINE test_intersection8

  SUBROUTINE test_intersection9
    TYPE(xt_stripe), PARAMETER :: stripes_a(3) = (/ xt_stripe(0, 1, 5), &
         xt_stripe(1, 1, 5), xt_stripe(2, 1, 5) /), &
         stripes_b(1) = (/ xt_stripe(-2, 1, 10) /)
#ifndef __G95__
    INTEGER(xi) :: i
    INTEGER(xt_int_kind), PARAMETER :: ref_indices_a(7) &
         = (/ (i, i=0_xi,6_xi) /), &
#else
    INTEGER :: i
    INTEGER(xt_int_kind), PARAMETER :: ref_indices_a(7) &
         = (/ (INT(i, xi), i=0_xi,6_xi) /), &
#endif
         ref_indices_b(15) = (/ 0_xi, 1_xi, 1_xi, 2_xi, 2_xi, 2_xi, 3_xi, &
         &                      3_xi, 3_xi, 4_xi, 4_xi, 4_xi, 5_xi, 5_xi, 6_xi /)
    CALL test_intersection(stripes_a, stripes_b, ref_indices_a, ref_indices_b)
  END SUBROUTINE test_intersection9

  SUBROUTINE test_intersection10
    TYPE(xt_stripe), PARAMETER :: stripes_a(1) = (/ xt_stripe(0, 2, 5) /), &
         stripes_b(1) = (/ xt_stripe(1, 2, 5) /)
    INTEGER(xt_int_kind), PARAMETER :: dummy(1) = (/ -1_xi /)
    CALL test_intersection(stripes_a, stripes_b, dummy(1:0))
  END SUBROUTINE test_intersection10

  SUBROUTINE test_intersection11
    TYPE(xt_stripe), PARAMETER :: stripes_a(1) = (/ xt_stripe(0, 5, 20) /), &
         stripes_b(1) = (/ xt_stripe(1, 7, 15) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(3) = (/ 15_xi, 50_xi, 85_xi /)
    CALL test_intersection(stripes_a, stripes_b, ref_indices)
  END SUBROUTINE test_intersection11

  ! both ranges overlap in range but have no
  ! indices in common because of stride
  SUBROUTINE test_intersection12
    TYPE(xt_stripe), PARAMETER :: stripes_a(1) = (/ xt_stripe(34, 29, 12) /), &
         stripes_b(1) = (/ xt_stripe(36, 7, 2) /)
    INTEGER(xt_int_kind), PARAMETER :: dummy(1) = (/ -1_xi /)

    CALL test_intersection(stripes_a, stripes_b, dummy(1:0))
  END SUBROUTINE test_intersection12

  ! same as test_intersection12 but with negative stride
  SUBROUTINE test_intersection13
    TYPE(xt_stripe), PARAMETER :: &
         stripes_a(1) = (/ xt_stripe(353, -29, 12) /), &
         stripes_b(1) = (/ xt_stripe(36, 7, 2) /)
    INTEGER(xt_int_kind), PARAMETER :: dummy(1) = (/ -1_xi /)

    CALL test_intersection(stripes_a, stripes_b, dummy(1:0))
  END SUBROUTINE test_intersection13

  SUBROUTINE test_intersection14
    TYPE(xt_stripe), PARAMETER :: &
         stripes_a(1) = (/ xt_stripe(95, -29, 2) /), &
         stripes_b(1) = (/ xt_stripe(81, 14, 2) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(1) = (/ 95_xi /)

    CALL test_intersection(stripes_a, stripes_b, ref_indices)
  END SUBROUTINE test_intersection14

  SUBROUTINE test_intersection15
    TYPE(xt_stripe), PARAMETER :: &
         stripes_a(1) = (/ xt_stripe(546, 14, 2) /), &
         stripes_b(1) = (/ xt_stripe(354, 206, 2) /)
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(1) = (/ 560_xi /)

    CALL test_intersection(stripes_a, stripes_b, ref_indices)
  END SUBROUTINE test_intersection15

  SUBROUTINE test_intersection_stripe2vec
    INTEGER, PARAMETER :: num_stripes = 3
    TYPE(xt_stripe), PARAMETER :: stripes(num_stripes) &
         = (/ xt_stripe(4, 1, 1), xt_stripe(5, 1, 1), xt_stripe(10, -10, 2) /)
    TYPE(xt_idxlist) :: idxvec_a, idxvec_b, intersection
    INTEGER(xt_int_kind), PARAMETER :: index_vector(1) = (/ 5_xi /)
    INTEGER(xt_int_kind) :: intersection_idx
    LOGICAL :: not_found
    idxvec_a = xt_idxvec_from_stripes_new(stripes)
    idxvec_b = xt_idxvec_new(index_vector)
    intersection = xt_idxlist_get_intersection(idxvec_a, idxvec_b)
    IF (xt_idxlist_get_num_indices(intersection) /= 1) &
         CALL test_abort("unexpected number of indices in intersection!", &
         filename, __LINE__)
    not_found = xt_idxlist_get_index_at_position(intersection, 0, &
         intersection_idx)
    IF (not_found .OR. intersection_idx /= index_vector(1)) &
         CALL test_abort("unexpected index in intersection!", &
         filename, __LINE__)
    CALL xt_idxlist_delete(intersection)
    CALL xt_idxlist_delete(idxvec_a)
    CALL xt_idxlist_delete(idxvec_b)
  END SUBROUTINE test_intersection_stripe2vec

  SUBROUTINE test_idxlist_stripes_pos_ext1
    INTEGER, PARAMETER :: num_indices = 223
    INTEGER(xt_int_kind), PARAMETER :: index_vector(num_indices) = (/ &
         3375_xi, 3376_xi, 3379_xi, 3380_xi, 3381_xi, 3387_xi, 3388_xi, &
         3389_xi, 3390_xi, 3391_xi, 3392_xi, 3393_xi, 3421_xi, 3422_xi, &
         3423_xi, 3424_xi, 3425_xi, 3426_xi, 3427_xi, 3444_xi, 3458_xi, &
         3459_xi, 3461_xi, 3462_xi, 3463_xi, 3464_xi, 3465_xi, 3466_xi, &
         3467_xi, 3468_xi, 3469_xi, 3470_xi, 3471_xi, 3472_xi, 3473_xi, &
         3474_xi, 3475_xi, 3476_xi, 3477_xi, 3478_xi, 3479_xi, 3480_xi, &
         3529_xi, 3606_xi, 3607_xi, 3608_xi, 3611_xi, 3612_xi, 3613_xi, &
         3614_xi, 3617_xi, 3620_xi, 3621_xi, 3622_xi, 3623_xi, 3624_xi, &
         3625_xi, 3626_xi, 3627_xi, 3628_xi, 3629_xi, 3630_xi, 3631_xi, &
         3684_xi, 3685_xi, 3686_xi, 3687_xi, 3688_xi, 3689_xi, 3690_xi, &
         3691_xi, 3692_xi, 3693_xi, 3694_xi, 3695_xi, 3696_xi, 3697_xi, &
         3698_xi, 3699_xi, 3700_xi, 3701_xi, 3702_xi, 3703_xi, 3704_xi, &
         3705_xi, 3706_xi, 3707_xi, 3708_xi, 3709_xi, 3713_xi, 3714_xi, &
         3715_xi, 3716_xi, 3717_xi, 3718_xi, 3719_xi, 3720_xi, 3721_xi, &
         3722_xi, 3723_xi, 3724_xi, 3725_xi, 3726_xi, 3727_xi, 3728_xi, &
         3729_xi, 3730_xi, 3731_xi, 3741_xi, 3742_xi, 3931_xi, 3932_xi, &
         3374_xi, 3382_xi, 3385_xi, 3394_xi, 3404_xi, 3408_xi, 3412_xi, &
         3440_xi, 3443_xi, 3457_xi, 3481_xi, 3483_xi, 3527_xi, 3619_xi, &
         3735_xi, 3743_xi, 3925_xi, 3930_xi, 3377_xi, 3378_xi, 3383_xi, &
         3384_xi, 3386_xi, 3395_xi, 3397_xi, 3398_xi, 3400_xi, 3402_xi, &
         3403_xi, 3407_xi, 3409_xi, 3410_xi, 3413_xi, 3420_xi, 3441_xi, &
         3442_xi, 3445_xi, 3448_xi, 3449_xi, 3451_xi, 3460_xi, 3482_xi, &
         3519_xi, 3520_xi, 3526_xi, 3528_xi, 3530_xi, 3592_xi, 3593_xi, &
         3595_xi, 3596_xi, 3597_xi, 3609_xi, 3610_xi, 3615_xi, 3616_xi, &
         3618_xi, 3644_xi, 3710_xi, 3711_xi, 3712_xi, 3732_xi, 3733_xi, &
         3736_xi, 3737_xi, 3748_xi, 3749_xi, 3753_xi, 3754_xi, 3759_xi, &
         3760_xi, 3766_xi, 3767_xi, 3919_xi, 3920_xi, 3924_xi, 3926_xi, &
         3933_xi, 3934_xi, 2589_xi, 2602_xi, 2680_xi, 3326_xi, 3340_xi, &
         3341_xi, 3396_xi, 3401_xi, 3411_xi, 3414_xi, 3418_xi, 3446_xi, &
         3447_xi, 3450_xi, 3515_xi, 3521_xi, 3525_xi, 3582_xi, 3590_xi, &
         3591_xi, 3594_xi, 3642_xi, 3734_xi, 3738_xi, 3747_xi, 3750_xi, &
         3761_xi, 3765_xi, 3865_xi, 3918_xi, 3923_xi, 3935_xi /)
    INTEGER, PARAMETER :: num_stripes = 26
    TYPE(xt_stripe), PARAMETER :: stripes(num_stripes) = (/ &
         xt_stripe(3326, 14,  2), xt_stripe(3341, 33,  1), &
         xt_stripe(3374,  1, 25), xt_stripe(3400,  1,  5), &
         xt_stripe(3407,  1,  8), xt_stripe(3418,  2,  1), &
         xt_stripe(3420,  1,  8), xt_stripe(3440,  1, 12), &
         xt_stripe(3457,  1, 27), xt_stripe(3515,  4,  1), &
         xt_stripe(3519,  1,  3), xt_stripe(3525,  1,  6), &
         xt_stripe(3582,  8,  1), xt_stripe(3590,  1,  8), &
         xt_stripe(3606,  1, 26), xt_stripe(3642,  2,  2), &
         xt_stripe(3684,  1, 55), xt_stripe(3741,  1,  3), &
         xt_stripe(3747,  1,  4), xt_stripe(3753,  1,  2), &
         xt_stripe(3759,  1,  3), xt_stripe(3765,  1,  3), &
         xt_stripe(3865, 53,  1), xt_stripe(3918,  1,  3), &
         xt_stripe(3923,  1,  4), xt_stripe(3930,  1,  6) /)
    TYPE(xt_idxlist) :: idxlist

    idxlist = xt_idxvec_new(index_vector, num_indices)
    CALL check_idxlist_stripes_pos_ext(idxlist, stripes)
    CALL xt_idxlist_delete(idxlist)
  END SUBROUTINE test_idxlist_stripes_pos_ext1

  SUBROUTINE test_idxlist_stripes_pos_ext2
    INTEGER, PARAMETER :: num_indices = 201
    INTEGER(xt_int_kind), PARAMETER :: index_vector(num_indices) = (/ &
         &  178_xi,  179_xi,  180_xi,  181_xi,  182_xi,  183_xi,  184_xi, &
         &  186_xi,  187_xi,  188_xi,  189_xi,  190_xi,  194_xi,  195_xi, &
         &  196_xi,  197_xi,  198_xi,  199_xi,  200_xi,  201_xi,  202_xi, &
         &  203_xi,  204_xi,  205_xi,  206_xi,  207_xi,  208_xi,  209_xi, &
         &  210_xi,  211_xi,  212_xi,  217_xi,  223_xi,  426_xi,  428_xi, &
         &  429_xi,  430_xi,  434_xi,  435_xi,  436_xi,  437_xi,  438_xi, &
         &  439_xi,  440_xi,  442_xi,  443_xi,  444_xi,  445_xi,  446_xi, &
         &  447_xi,  448_xi,  449_xi,  450_xi,  451_xi,  452_xi,  453_xi, &
         &  454_xi,  455_xi,  456_xi,  457_xi,  458_xi,  670_xi,  671_xi, &
         &  672_xi,  673_xi,  674_xi,  675_xi,  676_xi,  677_xi,  682_xi, &
         &  684_xi,  685_xi,  686_xi,  687_xi,  688_xi,  689_xi,  690_xi, &
         &  692_xi,  695_xi,  703_xi,  704_xi,  705_xi,  706_xi,  707_xi, &
         &  894_xi,  895_xi,  896_xi,  897_xi,  898_xi,  899_xi,  900_xi, &
         &  901_xi,  906_xi,  907_xi,  908_xi,  913_xi,  915_xi,  921_xi, &
         &  922_xi,  923_xi,  924_xi,  925_xi,  926_xi,  927_xi, 1096_xi, &
         & 1097_xi, 1098_xi, 1099_xi, 1100_xi, 1101_xi, 1102_xi, 1103_xi, &
         & 1107_xi, 1108_xi, 1109_xi, 1110_xi, 1111_xi, 1113_xi, 1114_xi, &
         & 1119_xi, 1120_xi, 1121_xi, 2095_xi, 2096_xi, 2097_xi, 2098_xi, &
         & 2100_xi, 2102_xi, 2103_xi, 2104_xi, 2105_xi, 2107_xi, 2108_xi, &
         & 2109_xi, 2110_xi, 2112_xi, 2118_xi, 2120_xi, 2121_xi, 2122_xi, &
         & 2123_xi, 2124_xi, 2125_xi, 2127_xi, 2128_xi, 2129_xi, 2130_xi, &
         & 2134_xi, 2140_xi, 2141_xi, 2142_xi, 2143_xi, 2145_xi, 2148_xi, &
         & 2149_xi, 2151_xi, 2152_xi, 2153_xi, 2154_xi, 2155_xi, 2156_xi, &
         &  683_xi,  691_xi,  903_xi,  914_xi, 1105_xi, 1115_xi, 2099_xi, &
         & 2106_xi, 2111_xi, 2115_xi, 2126_xi, 2132_xi, 2139_xi, 2144_xi, &
         & 2147_xi, 2150_xi, 2305_xi,  427_xi,  465_xi,  466_xi,  678_xi, &
         &  693_xi,  902_xi,  909_xi, 1104_xi, 1112_xi, 2101_xi, 2113_xi, &
         & 2114_xi, 2116_xi, 2117_xi, 2119_xi, 2131_xi, 2136_xi, 2138_xi, &
         & 2146_xi, 2297_xi, 2302_xi, 2304_xi, 2307_xi /)
    INTEGER, PARAMETER :: num_stripes = 8
    TYPE(xt_stripe), PARAMETER :: stripes(num_stripes) = (/ &
      xt_stripe(670, 1,  9), xt_stripe(682, 1, 12), &
      xt_stripe(695, 8,  1), xt_stripe(703, 1,  5), &
      xt_stripe(894, 1, 10), xt_stripe(906, 1,  4), &
      xt_stripe(913, 1,  3), xt_stripe(921, 1,  7) /)
    TYPE(xt_idxlist) :: idxlist

    idxlist = xt_idxvec_new(index_vector)
    CALL check_idxlist_stripes_pos_ext(idxlist, stripes)
    CALL xt_idxlist_delete(idxlist)
  END SUBROUTINE test_idxlist_stripes_pos_ext2

  SUBROUTINE test_idxlist_stripes_pos_ext3
    INTEGER, PARAMETER :: num_indices = 1144
    INTEGER(xt_int_kind), PARAMETER :: index_vector(num_indices) = (/ &
      2055_xi, 2056_xi, 2060_xi, 2193_xi, 2199_xi, 2203_xi, 2211_xi, 2212_xi, &
      2278_xi, 2281_xi, 2311_xi, 2312_xi, 2316_xi, 2317_xi, 2322_xi, 2332_xi, &
      2447_xi, 2448_xi, 2452_xi, 2585_xi, 2591_xi, 2595_xi, 2603_xi, 2604_xi, &
      2670_xi, 2673_xi, 2703_xi, 2704_xi, 2708_xi, 2709_xi, 2714_xi, 2724_xi, &
      2839_xi, 2840_xi, 2844_xi, 2977_xi, 2983_xi, 2987_xi, 2995_xi, 2996_xi, &
      3062_xi, 3065_xi, 3095_xi, 3096_xi, 3100_xi, 3101_xi, 3106_xi, 3116_xi, &
      3231_xi, 3232_xi, 3236_xi, 3369_xi, 3375_xi, 3379_xi, 3387_xi, 3388_xi, &
      3454_xi, 3457_xi, 3487_xi, 3488_xi, 3492_xi, 3493_xi, 3498_xi, 3508_xi, &
      3623_xi, 3624_xi, 3628_xi, 3761_xi, 3767_xi, 3771_xi, 3779_xi, 3780_xi, &
      3846_xi, 3849_xi, 3879_xi, 3880_xi, 3884_xi, 3885_xi, 3890_xi, 3900_xi, &
      3997_xi, 4001_xi, 4002_xi, 4053_xi, 4057_xi, 4084_xi, 4085_xi, 4092_xi, &
      4102_xi, 4188_xi, 4192_xi, 4201_xi, 4373_xi, 4377_xi, 4378_xi, 4429_xi, &
      4433_xi, 4460_xi, 4461_xi, 4468_xi, 4478_xi, 4564_xi, 4568_xi, 4577_xi, &
      4749_xi, 4753_xi, 4754_xi, 4805_xi, 4809_xi, 4836_xi, 4837_xi, 4844_xi, &
      4854_xi, 4945_xi, 4953_xi, 5125_xi, 5129_xi, 5130_xi, 5181_xi, 5185_xi, &
      5212_xi, 5213_xi, 5220_xi, 5230_xi, 5321_xi, 5329_xi, 5501_xi, 5505_xi, &
      5506_xi, 5557_xi, 5561_xi, 5588_xi, 5589_xi, 5596_xi, 5606_xi, 5697_xi, &
      5705_xi,  162_xi,  163_xi,  166_xi,  168_xi,  171_xi,  172_xi,  173_xi, &
       177_xi,  181_xi,  362_xi,  363_xi,  367_xi,  369_xi,  375_xi,  378_xi, &
       382_xi,  383_xi,  386_xi,  570_xi,  571_xi,  574_xi,  576_xi,  579_xi, &
       580_xi,  581_xi,  585_xi,  589_xi,  758_xi,  759_xi,  763_xi,  765_xi, &
       769_xi,  774_xi,  775_xi,  778_xi,  962_xi,  963_xi,  966_xi,  968_xi, &
       971_xi,  972_xi,  973_xi,  977_xi,  981_xi, 1150_xi, 1151_xi, 1155_xi, &
      1157_xi, 1161_xi, 1166_xi, 1167_xi, 1170_xi, 1354_xi, 1355_xi, 1358_xi, &
      1360_xi, 1363_xi, 1364_xi, 1365_xi, 1369_xi, 1373_xi, 1542_xi, 1543_xi, &
      1547_xi, 1549_xi, 1553_xi, 1558_xi, 1559_xi, 1562_xi, 1746_xi, 1747_xi, &
      1750_xi, 1752_xi, 1755_xi, 1756_xi, 1757_xi, 1761_xi, 1918_xi, 1919_xi, &
      1923_xi, 1925_xi, 1929_xi, 1934_xi, 1935_xi, 1938_xi, 1988_xi, 1989_xi, &
      2024_xi, 2025_xi, 2032_xi, 2033_xi, 2036_xi, 2038_xi, 2039_xi, 2048_xi, &
      2049_xi, 2053_xi, 2054_xi, 2057_xi, 2058_xi, 2061_xi, 2076_xi, 2077_xi, &
      2091_xi, 2092_xi, 2093_xi, 2095_xi, 2097_xi, 2126_xi, 2127_xi, 2144_xi, &
      2145_xi, 2149_xi, 2150_xi, 2156_xi, 2198_xi, 2204_xi, 2205_xi, 2207_xi, &
      2245_xi, 2253_xi, 2254_xi, 2256_xi, 2268_xi, 2269_xi, 2277_xi, 2279_xi, &
      2280_xi, 2283_xi, 2287_xi, 2298_xi, 2299_xi, 2307_xi, 2308_xi, 2309_xi, &
      2310_xi, 2333_xi, 2334_xi, 2380_xi, 2381_xi, 2416_xi, 2417_xi, 2424_xi, &
      2425_xi, 2428_xi, 2430_xi, 2431_xi, 2440_xi, 2441_xi, 2445_xi, 2446_xi, &
      2449_xi, 2450_xi, 2453_xi, 2468_xi, 2469_xi, 2483_xi, 2484_xi, 2485_xi, &
      2487_xi, 2489_xi, 2518_xi, 2519_xi, 2536_xi, 2537_xi, 2541_xi, 2542_xi, &
      2548_xi, 2590_xi, 2596_xi, 2597_xi, 2599_xi, 2637_xi, 2645_xi, 2646_xi, &
      2648_xi, 2660_xi, 2661_xi, 2669_xi, 2671_xi, 2672_xi, 2675_xi, 2679_xi, &
      2690_xi, 2691_xi, 2699_xi, 2700_xi, 2701_xi, 2702_xi, 2725_xi, 2726_xi, &
      2772_xi, 2773_xi, 2808_xi, 2809_xi, 2816_xi, 2817_xi, 2820_xi, 2822_xi, &
      2823_xi, 2832_xi, 2833_xi, 2837_xi, 2838_xi, 2841_xi, 2842_xi, 2845_xi, &
      2860_xi, 2861_xi, 2875_xi, 2876_xi, 2877_xi, 2879_xi, 2881_xi, 2910_xi, &
      2911_xi, 2928_xi, 2929_xi, 2933_xi, 2934_xi, 2940_xi, 2982_xi, 2988_xi, &
      2989_xi, 2991_xi, 3029_xi, 3037_xi, 3038_xi, 3040_xi, 3052_xi, 3053_xi, &
      3061_xi, 3063_xi, 3064_xi, 3067_xi, 3071_xi, 3082_xi, 3083_xi, 3091_xi, &
      3092_xi, 3093_xi, 3094_xi, 3117_xi, 3118_xi, 3164_xi, 3165_xi, 3200_xi, &
      3201_xi, 3208_xi, 3209_xi, 3212_xi, 3214_xi, 3215_xi, 3224_xi, 3225_xi, &
      3229_xi, 3230_xi, 3233_xi, 3234_xi, 3237_xi, 3252_xi, 3253_xi, 3267_xi, &
      3268_xi, 3269_xi, 3271_xi, 3273_xi, 3302_xi, 3303_xi, 3320_xi, 3321_xi, &
      3325_xi, 3326_xi, 3332_xi, 3374_xi, 3380_xi, 3381_xi, 3383_xi, 3421_xi, &
      3429_xi, 3430_xi, 3432_xi, 3444_xi, 3445_xi, 3453_xi, 3455_xi, 3456_xi, &
      3459_xi, 3463_xi, 3474_xi, 3475_xi, 3483_xi, 3484_xi, 3485_xi, 3486_xi, &
      3509_xi, 3510_xi, 3556_xi, 3557_xi, 3592_xi, 3593_xi, 3600_xi, 3601_xi, &
      3604_xi, 3606_xi, 3607_xi, 3616_xi, 3617_xi, 3621_xi, 3622_xi, 3625_xi, &
      3626_xi, 3629_xi, 3644_xi, 3645_xi, 3659_xi, 3660_xi, 3661_xi, 3663_xi, &
      3665_xi, 3694_xi, 3695_xi, 3712_xi, 3713_xi, 3717_xi, 3718_xi, 3724_xi, &
      3766_xi, 3772_xi, 3773_xi, 3775_xi, 3813_xi, 3821_xi, 3822_xi, 3824_xi, &
      3836_xi, 3837_xi, 3845_xi, 3847_xi, 3848_xi, 3851_xi, 3855_xi, 3866_xi, &
      3867_xi, 3875_xi, 3876_xi, 3877_xi, 3878_xi, 3901_xi, 3902_xi, 3948_xi, &
      3949_xi, 3984_xi, 3985_xi, 3992_xi, 3993_xi, 3996_xi, 3998_xi, 3999_xi, &
      4008_xi, 4009_xi, 4013_xi, 4014_xi, 4017_xi, 4018_xi, 4021_xi, 4036_xi, &
      4037_xi, 4051_xi, 4052_xi, 4054_xi, 4055_xi, 4058_xi, 4090_xi, 4091_xi, &
      4093_xi, 4108_xi, 4109_xi, 4112_xi, 4113_xi, 4114_xi, 4158_xi, 4164_xi, &
      4165_xi, 4193_xi, 4199_xi, 4200_xi, 4212_xi, 4213_xi, 4222_xi, 4223_xi, &
      4225_xi, 4227_xi, 4231_xi, 4242_xi, 4243_xi, 4250_xi, 4251_xi, 4271_xi, &
      4272_xi, 4274_xi, 4324_xi, 4325_xi, 4360_xi, 4361_xi, 4368_xi, 4369_xi, &
      4372_xi, 4374_xi, 4375_xi, 4384_xi, 4385_xi, 4389_xi, 4390_xi, 4393_xi, &
      4394_xi, 4397_xi, 4412_xi, 4413_xi, 4427_xi, 4428_xi, 4430_xi, 4431_xi, &
      4434_xi, 4466_xi, 4467_xi, 4469_xi, 4484_xi, 4485_xi, 4488_xi, 4489_xi, &
      4490_xi, 4534_xi, 4540_xi, 4541_xi, 4569_xi, 4575_xi, 4576_xi, 4588_xi, &
      4589_xi, 4598_xi, 4599_xi, 4601_xi, 4603_xi, 4607_xi, 4618_xi, 4619_xi, &
      4626_xi, 4627_xi, 4647_xi, 4648_xi, 4650_xi, 4700_xi, 4701_xi, 4736_xi, &
      4737_xi, 4744_xi, 4745_xi, 4748_xi, 4750_xi, 4751_xi, 4760_xi, 4761_xi, &
      4765_xi, 4766_xi, 4769_xi, 4770_xi, 4773_xi, 4788_xi, 4789_xi, 4803_xi, &
      4804_xi, 4806_xi, 4807_xi, 4810_xi, 4842_xi, 4843_xi, 4845_xi, 4860_xi, &
      4861_xi, 4864_xi, 4865_xi, 4866_xi, 4910_xi, 4916_xi, 4917_xi, 4951_xi, &
      4952_xi, 4964_xi, 4965_xi, 4974_xi, 4975_xi, 4977_xi, 4979_xi, 4983_xi, &
      4994_xi, 4995_xi, 5002_xi, 5003_xi, 5023_xi, 5024_xi, 5026_xi, 5076_xi, &
      5077_xi, 5112_xi, 5113_xi, 5120_xi, 5121_xi, 5124_xi, 5126_xi, 5127_xi, &
      5136_xi, 5137_xi, 5141_xi, 5142_xi, 5145_xi, 5146_xi, 5149_xi, 5164_xi, &
      5165_xi, 5179_xi, 5180_xi, 5182_xi, 5183_xi, 5186_xi, 5218_xi, 5219_xi, &
      5221_xi, 5236_xi, 5237_xi, 5240_xi, 5241_xi, 5242_xi, 5286_xi, 5292_xi, &
      5293_xi, 5327_xi, 5328_xi, 5340_xi, 5341_xi, 5350_xi, 5351_xi, 5353_xi, &
      5355_xi, 5359_xi, 5370_xi, 5371_xi, 5378_xi, 5379_xi, 5399_xi, 5400_xi, &
      5402_xi, 5452_xi, 5453_xi, 5488_xi, 5489_xi, 5496_xi, 5497_xi, 5500_xi, &
      5502_xi, 5503_xi, 5512_xi, 5513_xi, 5517_xi, 5518_xi, 5521_xi, 5522_xi, &
      5525_xi, 5540_xi, 5541_xi, 5555_xi, 5556_xi, 5558_xi, 5559_xi, 5562_xi, &
      5594_xi, 5595_xi, 5597_xi, 5612_xi, 5613_xi, 5616_xi, 5617_xi, 5618_xi, &
      5662_xi, 5668_xi, 5669_xi, 5703_xi, 5704_xi, 5716_xi, 5717_xi, 5726_xi, &
      5727_xi, 5729_xi, 5731_xi, 5735_xi, 5746_xi, 5747_xi, 5754_xi, 5755_xi, &
      5775_xi, 5776_xi, 5778_xi, 5958_xi, 5959_xi, 5962_xi, 5964_xi, 5967_xi, &
      5968_xi, 5971_xi, 5973_xi, 6154_xi, 6155_xi, 6159_xi, 6161_xi, 6167_xi, &
      6170_xi, 6172_xi, 6173_xi, 6350_xi, 6351_xi, 6354_xi, 6356_xi, 6359_xi, &
      6360_xi, 6363_xi, 6530_xi, 6531_xi, 6535_xi, 6537_xi, 6543_xi, 6546_xi, &
      6548_xi, 6549_xi, 6726_xi, 6727_xi, 6730_xi, 6732_xi, 6735_xi, 6736_xi, &
      6739_xi, 6906_xi, 6907_xi, 6911_xi, 6913_xi, 6919_xi, 6922_xi, 6924_xi, &
      6925_xi, 7102_xi, 7103_xi, 7106_xi, 7108_xi, 7111_xi, 7112_xi, 7115_xi, &
      7282_xi, 7283_xi, 7287_xi, 7289_xi, 7295_xi, 7298_xi, 7300_xi, 7301_xi, &
      7478_xi, 7479_xi, 7482_xi, 7484_xi, 7487_xi, 7488_xi, 7491_xi, 7646_xi, &
      7647_xi, 7651_xi, 7653_xi, 7657_xi, 7660_xi, 7661_xi,  130_xi,  161_xi, &
       169_xi,  170_xi,  336_xi,  361_xi,  366_xi,  384_xi,  538_xi,  569_xi, &
       577_xi,  578_xi,  736_xi,  757_xi,  762_xi,  776_xi,  930_xi,  961_xi, &
       969_xi,  970_xi, 1128_xi, 1149_xi, 1154_xi, 1168_xi, 1322_xi, 1353_xi, &
      1361_xi, 1362_xi, 1520_xi, 1541_xi, 1546_xi, 1560_xi, 1714_xi, 1745_xi, &
      1753_xi, 1754_xi, 1896_xi, 1917_xi, 1922_xi, 1936_xi, 1985_xi, 2019_xi, &
      2031_xi, 2035_xi, 2040_xi, 2044_xi, 2052_xi, 2059_xi, 2062_xi, 2071_xi, &
      2087_xi, 2090_xi, 2094_xi, 2140_xi, 2148_xi, 2153_xi, 2157_xi, 2206_xi, &
      2257_xi, 2263_xi, 2267_xi, 2284_xi, 2288_xi, 2293_xi, 2295_xi, 2305_xi, &
      2306_xi, 2377_xi, 2411_xi, 2423_xi, 2427_xi, 2432_xi, 2436_xi, 2444_xi, &
      2451_xi, 2454_xi, 2463_xi, 2479_xi, 2482_xi, 2486_xi, 2532_xi, 2540_xi, &
      2545_xi, 2549_xi, 2598_xi, 2649_xi, 2655_xi, 2659_xi, 2676_xi, 2680_xi, &
      2685_xi, 2687_xi, 2697_xi, 2698_xi, 2769_xi, 2803_xi, 2815_xi, 2819_xi, &
      2824_xi, 2828_xi, 2836_xi, 2843_xi, 2846_xi, 2855_xi, 2871_xi, 2874_xi, &
      2878_xi, 2924_xi, 2932_xi, 2937_xi, 2941_xi, 2990_xi, 3041_xi, 3047_xi, &
      3051_xi, 3068_xi, 3072_xi, 3077_xi, 3079_xi, 3089_xi, 3090_xi, 3161_xi, &
      3195_xi, 3207_xi, 3211_xi, 3216_xi, 3220_xi, 3228_xi, 3235_xi, 3238_xi, &
      3247_xi, 3263_xi, 3266_xi, 3270_xi, 3316_xi, 3324_xi, 3329_xi, 3333_xi, &
      3382_xi, 3433_xi, 3439_xi, 3443_xi, 3460_xi, 3464_xi, 3469_xi, 3471_xi, &
      3481_xi, 3482_xi, 3553_xi, 3587_xi, 3599_xi, 3603_xi, 3608_xi, 3612_xi, &
      3620_xi, 3627_xi, 3630_xi, 3639_xi, 3655_xi, 3658_xi, 3662_xi, 3708_xi, &
      3716_xi, 3721_xi, 3725_xi, 3774_xi, 3825_xi, 3831_xi, 3835_xi, 3852_xi, &
      3856_xi, 3861_xi, 3863_xi, 3873_xi, 3874_xi, 3945_xi, 3979_xi, 3991_xi, &
      3995_xi, 4000_xi, 4004_xi, 4012_xi, 4019_xi, 4022_xi, 4031_xi, 4033_xi, &
      4047_xi, 4050_xi, 4104_xi, 4106_xi, 4115_xi, 4207_xi, 4221_xi, 4228_xi, &
      4232_xi, 4237_xi, 4249_xi, 4252_xi, 4321_xi, 4355_xi, 4367_xi, 4371_xi, &
      4376_xi, 4380_xi, 4388_xi, 4395_xi, 4398_xi, 4407_xi, 4409_xi, 4423_xi, &
      4426_xi, 4480_xi, 4482_xi, 4491_xi, 4583_xi, 4597_xi, 4604_xi, 4608_xi, &
      4613_xi, 4625_xi, 4628_xi, 4697_xi, 4731_xi, 4743_xi, 4747_xi, 4752_xi, &
      4756_xi, 4764_xi, 4771_xi, 4774_xi, 4783_xi, 4785_xi, 4799_xi, 4802_xi, &
      4856_xi, 4858_xi, 4867_xi, 4959_xi, 4973_xi, 4980_xi, 4984_xi, 4989_xi, &
      5001_xi, 5004_xi, 5073_xi, 5107_xi, 5119_xi, 5123_xi, 5128_xi, 5132_xi, &
      5140_xi, 5147_xi, 5150_xi, 5159_xi, 5161_xi, 5175_xi, 5178_xi, 5232_xi, &
      5234_xi, 5243_xi, 5335_xi, 5349_xi, 5356_xi, 5360_xi, 5365_xi, 5377_xi, &
      5380_xi, 5449_xi, 5483_xi, 5495_xi, 5499_xi, 5504_xi, 5508_xi, 5516_xi, &
      5523_xi, 5526_xi, 5535_xi, 5537_xi, 5551_xi, 5554_xi, 5608_xi, 5610_xi, &
      5619_xi, 5711_xi, 5725_xi, 5732_xi, 5736_xi, 5741_xi, 5753_xi, 5756_xi, &
      5930_xi, 5957_xi, 5965_xi, 5966_xi, 6128_xi, 6153_xi, 6158_xi, 6174_xi, &
      6322_xi, 6349_xi, 6357_xi, 6358_xi, 6504_xi, 6529_xi, 6534_xi, 6550_xi, &
      6698_xi, 6725_xi, 6733_xi, 6734_xi, 6880_xi, 6905_xi, 6910_xi, 6926_xi, &
      7074_xi, 7101_xi, 7109_xi, 7110_xi, 7256_xi, 7281_xi, 7286_xi, 7302_xi, &
      7450_xi, 7477_xi, 7485_xi, 7486_xi, 7624_xi, 7645_xi, 7650_xi, 7662_xi /)
    INTEGER, PARAMETER :: num_stripes = 187
    TYPE(xt_stripe), PARAMETER :: stripes(num_stripes) = (/ &
      xt_stripe(173, 408, 2), xt_stripe(973, 392, 3), xt_stripe(1985, 4, 2), &
      xt_stripe(2044, 4, 2), xt_stripe(2049, 3, 1), xt_stripe(2052, 1, 9), &
      xt_stripe(2062, 131, 2), xt_stripe(2198, 1, 2), xt_stripe(2203, 1, 5), &
      xt_stripe(2211, 1, 2), xt_stripe(2263, 4, 1), xt_stripe(2267, 1, 3), &
      xt_stripe(2277, 1, 5), xt_stripe(2283, 1, 2), xt_stripe(2287, 1, 2), &
      xt_stripe(2293, 2, 2), xt_stripe(2298, 1, 2), xt_stripe(2305, 1, 8), &
      xt_stripe(2316, 1, 2), xt_stripe(2322, 10, 1), xt_stripe(2332, 1, 3), &
      xt_stripe(2377, 4, 2), xt_stripe(2436, 4, 2), xt_stripe(2441, 3, 1), &
      xt_stripe(2444, 1, 9), xt_stripe(2454, 131, 2), xt_stripe(2590, 1, 2), &
      xt_stripe(2595, 1, 5), xt_stripe(2603, 1, 2), xt_stripe(2655, 4, 1), &
      xt_stripe(2659, 1, 3), xt_stripe(2669, 1, 5), xt_stripe(2675, 1, 2), &
      xt_stripe(2679, 1, 2), xt_stripe(2685, 2, 2), xt_stripe(2690, 1, 2), &
      xt_stripe(2697, 1, 8), xt_stripe(2708, 1, 2), xt_stripe(2714, 10, 1), &
      xt_stripe(2724, 1, 3), xt_stripe(2769, 4, 2), xt_stripe(2828, 4, 2), &
      xt_stripe(2833, 3, 1), xt_stripe(2836, 1, 9), xt_stripe(2846, 131, 2), &
      xt_stripe(2982, 1, 2), xt_stripe(2987, 1, 5), xt_stripe(2995, 1, 2), &
      xt_stripe(3047, 4, 1), xt_stripe(3051, 1, 3), xt_stripe(3061, 1, 5), &
      xt_stripe(3067, 1, 2), xt_stripe(3071, 1, 2), xt_stripe(3077, 2, 2), &
      xt_stripe(3082, 1, 2), xt_stripe(3089, 1, 8), xt_stripe(3100, 1, 2), &
      xt_stripe(3106, 10, 1), xt_stripe(3116, 1, 3), xt_stripe(3161, 4, 2), &
      xt_stripe(3220, 4, 2), xt_stripe(3225, 3, 1), xt_stripe(3228, 1, 9), &
      xt_stripe(3238, 131, 2), xt_stripe(3374, 1, 2), xt_stripe(3379, 1, 5), &
      xt_stripe(3387, 1, 2), xt_stripe(3439, 4, 1), xt_stripe(3443, 1, 3), &
      xt_stripe(3453, 1, 5), xt_stripe(3459, 1, 2), xt_stripe(3463, 1, 2), &
      xt_stripe(3469, 2, 2), xt_stripe(3474, 1, 2), xt_stripe(3481, 1, 8), &
      xt_stripe(3492, 1, 2), xt_stripe(3498, 10, 1), xt_stripe(3508, 1, 3), &
      xt_stripe(3553, 4, 2), xt_stripe(3612, 4, 2), xt_stripe(3617, 3, 1), &
      xt_stripe(3620, 1, 9), xt_stripe(3630, 131, 2), xt_stripe(3766, 1, 2), &
      xt_stripe(3771, 1, 5), xt_stripe(3779, 1, 2), xt_stripe(3831, 4, 1), &
      xt_stripe(3835, 1, 3), xt_stripe(3845, 1, 5), xt_stripe(3851, 1, 2), &
      xt_stripe(3855, 1, 2), xt_stripe(3861, 2, 2), xt_stripe(3866, 1, 2), &
      xt_stripe(3873, 1, 8), xt_stripe(3884, 1, 2), xt_stripe(3890, 10, 1), &
      xt_stripe(3900, 1, 3), xt_stripe(3945, 3, 2), xt_stripe(3979, 5, 2), &
      xt_stripe(3985, 6, 1), xt_stripe(3991, 1, 3), xt_stripe(3995, 2, 1), &
      xt_stripe(3997, 1, 6), xt_stripe(4031, 2, 2), xt_stripe(4036, 1, 2), &
      xt_stripe(4047, 3, 1), xt_stripe(4050, 1, 6), xt_stripe(4057, 1, 2), &
      xt_stripe(4084, 1, 2), xt_stripe(4090, 1, 4), xt_stripe(4102, 2, 4), &
      xt_stripe(4109, 3, 1), xt_stripe(4112, 1, 4), xt_stripe(4188, 4, 2), &
      xt_stripe(4193, 6, 1), xt_stripe(4199, 1, 3), xt_stripe(4321, 3, 2), &
      xt_stripe(4355, 5, 2), xt_stripe(4361, 6, 1), xt_stripe(4367, 1, 3), &
      xt_stripe(4371, 2, 1), xt_stripe(4373, 1, 6), xt_stripe(4407, 2, 2), &
      xt_stripe(4412, 1, 2), xt_stripe(4423, 3, 1), xt_stripe(4426, 1, 6), &
      xt_stripe(4433, 1, 2), xt_stripe(4460, 1, 2), xt_stripe(4466, 1, 4), &
      xt_stripe(4478, 2, 4), xt_stripe(4485, 3, 1), xt_stripe(4488, 1, 4), &
      xt_stripe(4564, 4, 2), xt_stripe(4569, 6, 1), xt_stripe(4575, 1, 3), &
      xt_stripe(4697, 3, 2), xt_stripe(4731, 5, 2), xt_stripe(4737, 6, 1), &
      xt_stripe(4743, 1, 3), xt_stripe(4747, 2, 1), xt_stripe(4749, 1, 6), &
      xt_stripe(4783, 2, 2), xt_stripe(4788, 1, 2), xt_stripe(4799, 3, 1), &
      xt_stripe(4802, 1, 6), xt_stripe(4809, 1, 2), xt_stripe(4836, 1, 2), &
      xt_stripe(4842, 1, 4), xt_stripe(4854, 2, 4), xt_stripe(4861, 3, 1), &
      xt_stripe(4864, 1, 4), xt_stripe(4945, 6, 1), xt_stripe(4951, 1, 3), &
      xt_stripe(5107, 5, 2), xt_stripe(5113, 6, 1), xt_stripe(5119, 1, 3), &
      xt_stripe(5123, 2, 1), xt_stripe(5125, 1, 6), xt_stripe(5159, 2, 2), &
      xt_stripe(5164, 1, 2), xt_stripe(5175, 3, 1), xt_stripe(5178, 1, 6), &
      xt_stripe(5185, 1, 2), xt_stripe(5212, 1, 2), xt_stripe(5218, 1, 4), &
      xt_stripe(5230, 2, 4), xt_stripe(5237, 3, 1), xt_stripe(5240, 1, 4), &
      xt_stripe(5321, 6, 1), xt_stripe(5327, 1, 3), xt_stripe(5483, 5, 2), &
      xt_stripe(5489, 6, 1), xt_stripe(5495, 1, 3), xt_stripe(5499, 2, 1), &
      xt_stripe(5501, 1, 6), xt_stripe(5535, 2, 2), xt_stripe(5540, 1, 2), &
      xt_stripe(5551, 3, 1), xt_stripe(5554, 1, 6), xt_stripe(5561, 1, 2), &
      xt_stripe(5588, 1, 2), xt_stripe(5594, 1, 4), xt_stripe(5606, 2, 4), &
      xt_stripe(5613, 3, 1), xt_stripe(5616, 1, 4), xt_stripe(5697, 6, 1), &
      xt_stripe(5703, 1, 3) /)
    TYPE(xt_idxlist) :: idxlist

    idxlist = xt_idxvec_new(index_vector)
    CALL check_idxlist_stripes_pos_ext(idxlist, stripes)
    CALL xt_idxlist_delete(idxlist)
  END SUBROUTINE test_idxlist_stripes_pos_ext3

#if SIZEOF_XT_INT > 2
  SUBROUTINE test_idxlist_stripes_pos_ext4
    INTEGER, PARAMETER :: num_indices = 3
    INTEGER(xt_int_kind), PARAMETER :: index_vector(num_indices) &
         = (/ 328669_xi, 30608_xi, 38403_xi /)
    INTEGER, PARAMETER :: num_stripes = 1
    TYPE(xt_stripe), PARAMETER :: stripes(num_stripes) = (/ &
      xt_stripe(30608_xi, 7795_xi, 2)/)
    TYPE(xt_idxlist) :: idxlist

    idxlist = xt_idxvec_new(index_vector)
    CALL check_idxlist_stripes_pos_ext(idxlist, stripes)
    CALL xt_idxlist_delete(idxlist)
  END SUBROUTINE test_idxlist_stripes_pos_ext4

  SUBROUTINE test_idxlist_stripes_pos_ext5
    INTEGER, PARAMETER :: num_indices = 3
    INTEGER(xt_int_kind), PARAMETER :: index_vector(num_indices) &
         = (/ 679605_xi, 726349_xi, 726346_xi /)
    INTEGER, PARAMETER :: num_stripes = 1
    TYPE(xt_stripe), PARAMETER :: stripes(num_stripes) = (/ &
      xt_stripe(679605_xi, 46741_xi, 2)/)
    TYPE(xt_idxlist) :: idxlist

    idxlist = xt_idxvec_new(index_vector)
    CALL check_idxlist_stripes_pos_ext(idxlist, stripes)
    CALL xt_idxlist_delete(idxlist)
  END SUBROUTINE test_idxlist_stripes_pos_ext5
#endif

  SUBROUTINE test_idxlist_stripes_pos_ext_randomized1(full_random)
    LOGICAL, INTENT(in) :: full_random
    INTEGER, PARAMETER :: num_iterations=128, &
         max_num_indices=1024, max_index=1024

    INTEGER :: i, iteration, num_indices
    INTEGER(xt_int_kind), ALLOCATABLE :: indices(:)
    REAL, ALLOCATABLE :: rvals(:)
    TYPE(xt_idxlist) :: idxlist
    TYPE(xt_stripe), ALLOCATABLE :: stripes(:)
    TYPE(xt_stripe) :: stripes_dummy(1)

    CALL init_fortran_random(full_random)
    ALLOCATE(indices(max_num_indices), rvals(max_num_indices))
    DO iteration = 1, num_iterations
      CALL random_number(rvals(1))
      num_indices = NINT(rvals(1) * REAL(max_num_indices))

      CALL random_number(rvals(1:num_indices))
      DO i = 1, num_indices
        indices(i) = NINT(rvals(i)*REAL((2*max_index)-max_index), xt_int_kind)
      END DO
      idxlist = xt_idxvec_new(indices(1:num_indices))

      CALL xt_idxlist_get_index_stripes(idxlist, stripes)
      IF (ALLOCATED(stripes) .EQV. num_indices == 0) &
         CALL test_abort("get index stripes returned values for empty list", &
         filename, __LINE__)
      IF (num_indices > 0) THEN
        CALL check_idxlist_stripes_pos_ext(idxlist, stripes)
      ELSE
        CALL check_idxlist_stripes_pos_ext(idxlist, stripes_dummy(1:0))
      END IF

      CALL xt_idxlist_delete(idxlist)
    END DO
  END SUBROUTINE test_idxlist_stripes_pos_ext_randomized1

  SUBROUTINE check_idxlist_stripes_pos_ext(idxlist, stripes)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    TYPE(xt_stripe), INTENT(in) :: stripes(:)

    TYPE(xt_pos_ext), ALLOCATABLE :: pos_ext(:)
    INTEGER :: num_stripes, num_ext, num_unmatched
    INTEGER :: abs_pos_ext_size, jsign, i, j, k, send_pos
    INTEGER(xt_int_kind) :: intersection_index, orig_index
    LOGICAL, PARAMETER :: single_match_only = .TRUE.
    LOGICAL :: unmatched_in_intersection, unmatched_in_idxlist
    TYPE(xt_idxlist) :: intersection
    num_stripes = SIZE(stripes)

    num_unmatched = xt_idxlist_get_pos_exts_of_index_stripes( &
         idxlist, num_stripes, stripes, num_ext, pos_ext, single_match_only)

    ! testing of results
    IF (num_unmatched /= 0) &
         CALL test_abort("error in xt_idxlist_get_pos_exts_of_index_stripes", &
         filename, __LINE__)
    intersection = xt_idxvec_from_stripes_new(stripes)
    k = 0
    DO i = 1, num_ext
      abs_pos_ext_size = INT(ABS(pos_ext(i)%size))
      jsign = MERGE(1, -1, pos_ext(i)%size >= 0)
      DO j = 0, abs_pos_ext_size-1
        unmatched_in_intersection &
             = xt_idxlist_get_index_at_position(intersection, k, &
             intersection_index)
        send_pos = pos_ext(i)%start + jsign * j
        unmatched_in_idxlist &
             = xt_idxlist_get_index_at_position(idxlist, send_pos, orig_index)
        IF (unmatched_in_intersection .OR. unmatched_in_idxlist &
             .OR. intersection_index /= orig_index) THEN
          WRITE (0, '(4(a,i0))') "intersection pos ", k, &
               " index ", intersection_index, &
               " orig pos ", send_pos, &
               " index ", orig_index
          CALL test_abort("error in xt_idxlist_get_pos_exts_of_index_stripes", &
               filename, __LINE__)
        END IF
        k = k + 1
      END DO
    END DO
    CALL xt_idxlist_delete(intersection)
  END SUBROUTINE check_idxlist_stripes_pos_ext

  SUBROUTINE test_get_pos(stripes, pos)
    TYPE(xt_stripe), INTENT(in) :: stripes(:)
    INTEGER, INTENT(in) :: pos(:)
    INTEGER(xt_int_kind), PARAMETER :: dummy = 1_xi
    INTEGER(xt_int_kind) :: ref_sel_idx(SIZE(pos)), sel_idx(SIZE(pos))
    INTEGER(xt_int_kind), PARAMETER :: undef_idx = -HUGE(dummy)
    INTEGER :: num_pos, ip, p, ref_undef_count, undef_count
    TYPE(xt_idxlist) :: idxlist
    idxlist = xt_idxstripes_new(stripes)
    num_pos = SIZE(pos)
    ref_undef_count = 0
    DO ip = 1, num_pos
      p = pos(ip)
      IF (xt_idxlist_get_index_at_position(idxlist, p, ref_sel_idx(ip))) THEN
        ref_sel_idx(ip) = undef_idx
        ref_undef_count = ref_undef_count + 1
      END IF
    END DO
    undef_count = xt_idxlist_get_indices_at_positions(idxlist, pos, sel_idx, &
         undef_idx)
    IF (undef_count /= ref_undef_count) &
         CALL test_abort("inequal undef count!", filename, __LINE__)
    IF (ANY(sel_idx /= ref_sel_idx)) &
         CALL test_abort("incorrect index returned for position!", &
         filename, __LINE__)
    CALL xt_idxlist_delete(idxlist)
  END SUBROUTINE test_get_pos

  SUBROUTINE test_get_pos1
    TYPE(xt_stripe), PARAMETER :: stripes(3) = (/ xt_stripe(0, 1, 5), &
         xt_stripe(10, 1, 5), xt_stripe(20, -1, 5) /)
    INTEGER, PARAMETER :: pos(13) = &
         (/   0,   2,   7,   9,  11, &
         &  100,  11, 200,   9, 300, &
         &   18, 400,   5 /)
    CALL test_get_pos(stripes, pos)
  END SUBROUTINE test_get_pos1

  SUBROUTINE test_get_pos2
    TYPE(xt_stripe), PARAMETER :: stripes(4) = (/ xt_stripe(0, 1, 3), &
         xt_stripe(10, 1, 2), xt_stripe(20, -1, 6), xt_stripe(30, -1, 7) /)
    INTEGER, PARAMETER :: pos(19) = &
         (/   -1,    0,    1,    2,    3,    4,   23,    5,    6,    7, &
         &     8,    9,   10,   11,   12,    0,    2,  100, 2000 /)
    CALL test_get_pos(stripes, pos)
  END SUBROUTINE test_get_pos2

  SUBROUTINE test_get_pos3
    TYPE(xt_stripe), PARAMETER :: stripes(4) = (/ xt_stripe(0, 1, 3), &
         xt_stripe(10, 1, 2), xt_stripe(20, -1, 6), xt_stripe(30, -1, 7) /)
    INTEGER, PARAMETER :: pos(13) = &
         (/    4,    7,    2,    5,    9,    0,   10,    6,   11,    8, &
         &    12,    1,    3 /)
    CALL test_get_pos(stripes, pos)
  END SUBROUTINE test_get_pos3

  SUBROUTINE test_get_pos4
    TYPE(xt_stripe), PARAMETER :: stripes(3) = (/ xt_stripe(0, 1, 5), &
         xt_stripe(10, 1, 5), xt_stripe(20, -1, 5) /)
    INTEGER, PARAMETER :: pos(7) = &
         (/  -10,  200,  700,   90,   90,   18,  141 /)
    CALL test_get_pos(stripes, pos)
  END SUBROUTINE test_get_pos4

  SUBROUTINE test_stripe_overlap
    TYPE(xt_stripe), PARAMETER :: stripes(2) = (/ xt_stripe(0, 1, 5), &
         xt_stripe(1, 1, 5) /)
#ifndef __G95__
    INTEGER(xi) :: i, j
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(10) &
         = (/ ((i + j, i=0,4), j = 0, 1) /)
#else
    INTEGER :: i, j
    INTEGER(xt_int_kind), PARAMETER :: ref_indices(10) &
         = (/ ((INT(i + j, xi), i=0,4), j = 0, 1) /)
#endif
    CALL stripe_test_general(stripes, ref_indices)
  END SUBROUTINE test_stripe_overlap

  SUBROUTINE test_stripe_bb(stripes, global_size, global_start_index, bounds_ref)
    TYPE(xt_stripe), INTENT(in) :: stripes(:)
    INTEGER(xt_int_kind), INTENT(in) :: global_size(:), global_start_index
    TYPE(xt_bounds), INTENT(in) :: bounds_ref(:)

    TYPE(xt_bounds) :: bounds(SIZE(global_size))
    TYPE(xt_idxlist) :: idxstripes

    IF (SIZE(global_size) /= SIZE(bounds_ref)) &
         CALL test_abort("size mismatch for bounding-box", filename, __LINE__)
    idxstripes = xt_idxstripes_new(stripes, SIZE(stripes))

    bounds = xt_idxlist_get_bounding_box(idxstripes, global_size, &
         global_start_index)
    IF (ANY(bounds /= bounds_ref)) &
         CALL test_abort("boundary box doesn't match reference", &
         filename, __LINE__)
    CALL xt_idxlist_delete(idxstripes)
  END SUBROUTINE test_stripe_bb

  SUBROUTINE test_stripe_bb1
    TYPE(xt_stripe), PARAMETER :: stripes(1) = (/ xt_stripe(-1, -1, -1) /)
    INTEGER(xt_int_kind), PARAMETER :: global_size(3) = 4_xi, &
         global_start_index = 0
    TYPE(xt_bounds), PARAMETER :: bounds_ref(3) = xt_bounds(0, 0)
    CALL test_stripe_bb(stripes(1:0), global_size, global_start_index, bounds_ref)
  END SUBROUTINE test_stripe_bb1

  SUBROUTINE test_stripe_bb2
    TYPE(xt_stripe), PARAMETER :: stripes(3) = (/ xt_stripe(47, -12, 2), &
         xt_stripe(32, 12, 2), xt_stripe(36, 12, 2) /)
    INTEGER(xt_int_kind), PARAMETER :: global_size(3) = (/ 5_xi, 4_xi, 3_xi /), &
         global_start_index = 1
    TYPE(xt_bounds), PARAMETER :: bounds_ref(3) = (/ xt_bounds(2, 2), &
         xt_bounds(2, 2), xt_bounds(1, 2) /)
    CALL test_stripe_bb(stripes, global_size, global_start_index, bounds_ref)
  END SUBROUTINE test_stripe_bb2

  SUBROUTINE do_tests(idxlist, ref_indices)
    TYPE(xt_idxlist), INTENT(in) :: idxlist
    INTEGER(xt_int_kind), INTENT(in) :: ref_indices(:)

    TYPE(xt_stripe), ALLOCATABLE :: stripes(:)
    TYPE(xt_stripe), PARAMETER :: dummy(1) = (/ xt_stripe(0,0,0) /)
    INTEGER :: num_stripes
    TYPE(xt_idxlist) :: temp_idxlist, idxlist_copy

    CALL check_idxlist(idxlist, ref_indices)
    CALL xt_idxlist_get_index_stripes(idxlist, stripes)
    IF (ALLOCATED(stripes)) THEN
      num_stripes = SIZE(stripes)
      temp_idxlist = xt_idxvec_from_stripes_new(stripes, num_stripes)
    ELSE
      num_stripes = 0
      temp_idxlist = xt_idxvec_from_stripes_new(dummy, num_stripes)
    END IF
    CALL check_idxlist(temp_idxlist, ref_indices)

    CALL xt_idxlist_delete(temp_idxlist)

    IF (ALLOCATED(stripes)) DEALLOCATE(stripes)

    ! test packing and unpacking
    idxlist_copy = idxlist_pack_unpack_copy(idxlist)

    ! check copy
    CALL check_idxlist(idxlist_copy, ref_indices)

    CALL xt_idxlist_delete(idxlist_copy)

    ! test copying
    idxlist_copy = xt_idxlist_copy(idxlist)

    ! check copy
    CALL check_idxlist(idxlist_copy, ref_indices)

    ! clean up
    CALL xt_idxlist_delete(idxlist_copy)
  END SUBROUTINE do_tests

  SUBROUTINE check_pos_ext(stripes, search_stripes, ref_pos_ext, &
       single_match_only, ref_unmatched, test_desc)
    TYPE(xt_stripe), INTENT(in) :: stripes(:), search_stripes(:)
    TYPE(xt_pos_ext), intent(in) :: ref_pos_ext(:)
    LOGICAL, INTENT(in) :: single_match_only
    INTEGER, INTENT(in) :: ref_unmatched
    CHARACTER(len=*) :: test_desc

    INTEGER :: num_search_stripes, num_ref_pos_ext, num_ext, &
         unmatched
    TYPE(xt_idxlist) :: idxstripes
    TYPE(xt_pos_ext), ALLOCATABLE :: pos_ext(:)

    num_search_stripes = SIZE(search_stripes)
    num_ref_pos_ext = SIZE(ref_pos_ext)

    idxstripes = xt_idxstripes_new(stripes)
    unmatched = xt_idxlist_get_pos_exts_of_index_stripes(idxstripes, &
         num_search_stripes, search_stripes, &
         num_ext, pos_ext, single_match_only)
    IF (unmatched /= ref_unmatched) &
         CALL test_abort("error in number of unmatched indices for " &
         // test_desc, filename, __LINE__)
    IF (num_ext < 0 .OR. num_ext /= num_ref_pos_ext) &
         CALL test_abort("error finding " // test_desc, filename, __LINE__)
    IF (ANY(pos_ext /= ref_pos_ext)) &
         CALL test_abort("incorrect position extent length found in "&
         // test_desc, filename, __LINE__)
    DEALLOCATE(pos_ext)
    CALL xt_idxlist_delete(idxstripes)
  END SUBROUTINE check_pos_ext

  SUBROUTINE check_pos_ext1
    INTEGER, PARAMETER :: num_stripes = 1, num_ref_pos_ext = 1, &
         num_ref_unmatched = 0

    TYPE(Xt_stripe), PARAMETER :: stripes(num_stripes) &
         = (/ xt_stripe(1_xi, 1_xi, 10) /), &
         search_stripes(1) = (/ xt_stripe(10_xi, -1_xi, 5) /)

    TYPE(xt_pos_ext), PARAMETER :: ref_pos_ext(num_ref_pos_ext) &
         = (/ xt_pos_ext(9, -5) /)

    CALL check_pos_ext(stripes, search_stripes, ref_pos_ext, .TRUE., &
         num_ref_unmatched, "simple inverted stripe")
  END SUBROUTINE check_pos_ext1

  SUBROUTINE check_pos_ext2
    INTEGER, PARAMETER :: num_stripes = 1, num_ref_pos_ext = 1, &
         num_ref_unmatched = 5

    TYPE(Xt_stripe), PARAMETER :: stripes(num_stripes) &
         = (/ xt_stripe(1_xi, 1_xi, 10) /), &
         search_stripes(2) = xt_stripe(10_xi, -1_xi, 5)

    TYPE(xt_pos_ext), PARAMETER :: ref_pos_ext(num_ref_pos_ext) &
         = (/ xt_pos_ext(9, -5) /)

    CALL check_pos_ext(stripes, search_stripes, ref_pos_ext, .TRUE., &
         num_ref_unmatched, "simple inverted stripe")
  END SUBROUTINE check_pos_ext2

  SUBROUTINE check_pos_ext3
    INTEGER, PARAMETER :: num_stripes = 2, num_ref_pos_ext = 1, &
         num_ref_unmatched = 4

    TYPE(Xt_stripe), PARAMETER :: stripes(num_stripes) &
         = (/ xt_stripe(1_xi, 1_xi, 10), xt_stripe(15_xi, 1_xi, 10) /), &
         search_stripes(1) = xt_stripe(10_xi, 1_xi, 6)

    TYPE(xt_pos_ext), PARAMETER :: ref_pos_ext(num_ref_pos_ext) &
         = (/ xt_pos_ext(9, 2) /)

    CALL check_pos_ext(stripes, search_stripes, ref_pos_ext, .TRUE., &
         num_ref_unmatched, "search inc stripe over inc gap")
  END SUBROUTINE check_pos_ext3

  SUBROUTINE check_pos_ext4
    INTEGER, PARAMETER :: num_stripes = 2, num_ref_pos_ext = 1, &
         num_ref_unmatched = 4

    TYPE(Xt_stripe), PARAMETER :: stripes(num_stripes) &
         = (/ xt_stripe(25_xi, -1_xi, 11), xt_stripe(10_xi, -1_xi, 10) /), &
         search_stripes(1) = xt_stripe(10_xi, 1_xi, 6)

    TYPE(xt_pos_ext), PARAMETER :: ref_pos_ext(num_ref_pos_ext) &
         = (/ xt_pos_ext(11, -2) /)

    CALL check_pos_ext(stripes, search_stripes, ref_pos_ext, .TRUE., &
         num_ref_unmatched, "search inc stripe over dec gap")
  END SUBROUTINE check_pos_ext4

  SUBROUTINE check_pos_ext5
    INTEGER, PARAMETER :: num_stripes = 2, num_ref_pos_ext = 1, &
         num_ref_unmatched = 4

    TYPE(Xt_stripe), PARAMETER :: stripes(num_stripes) &
         = (/ xt_stripe(25_xi, -1_xi, 11), xt_stripe(10_xi, -1_xi, 10) /), &
         search_stripes(1) = xt_stripe(15_xi, -1_xi, 6)

    TYPE(xt_pos_ext), PARAMETER :: ref_pos_ext(num_ref_pos_ext) &
         = (/ xt_pos_ext(10, 2) /)

    CALL check_pos_ext(stripes, search_stripes, ref_pos_ext, .TRUE., &
         num_ref_unmatched, "search dec stripe over dec gap")
  END SUBROUTINE check_pos_ext5

  SUBROUTINE check_pos_ext6
    INTEGER, PARAMETER :: num_stripes = 2, num_ref_pos_ext = 1, &
         num_ref_unmatched = 4

    TYPE(Xt_stripe), PARAMETER :: stripes(num_stripes) &
         = (/ xt_stripe(1_xi, 1_xi, 10), xt_stripe(15_xi, 1_xi, 10) /), &
         search_stripes(1) = xt_stripe(15_xi, -1_xi, 6)

    TYPE(xt_pos_ext), PARAMETER :: ref_pos_ext(num_ref_pos_ext) &
         = (/ xt_pos_ext(10, -2) /)

    CALL check_pos_ext(stripes, search_stripes, ref_pos_ext, .TRUE., &
         num_ref_unmatched, "search dec stripe over inc gap")
  END SUBROUTINE check_pos_ext6

  SUBROUTINE check_pos_ext7
    INTEGER, PARAMETER :: num_stripes = 3, num_ref_pos_ext = 1, &
         num_ref_unmatched = 8

    TYPE(Xt_stripe), PARAMETER :: stripes(num_stripes) &
         = (/ xt_stripe(1_xi, 1_xi, 10), xt_stripe(15_xi, 1_xi, 10), &
         &    xt_stripe(29_xi, 1_xi, 10) /), &
         search_stripes(1) = xt_stripe(32_xi, -1_xi, 30)

    TYPE(xt_pos_ext), PARAMETER :: ref_pos_ext(num_ref_pos_ext) &
         = (/ xt_pos_ext(23, -22) /)

    CALL check_pos_ext(stripes, search_stripes, ref_pos_ext, .TRUE., &
         num_ref_unmatched, "search dec stripe over 2 inc gap")
  END SUBROUTINE check_pos_ext7

  SUBROUTINE check_pos_ext8
    INTEGER, PARAMETER :: num_stripes = 5, num_ref_pos_ext = 5, &
         num_ref_unmatched = 0

    TYPE(Xt_stripe), PARAMETER :: stripes(num_stripes) &
         = (/ xt_stripe(1_xi, 1_xi, 10), xt_stripe(15_xi, 1_xi, 10), &
         &    xt_stripe(29_xi, 1_xi, 10), xt_stripe(14_xi, -1_xi, 4), &
         &    xt_stripe(28_xi, -1_xi, 4) /), &
         search_stripes(1) = xt_stripe(32_xi, -1_xi, 30)

    TYPE(xt_pos_ext), PARAMETER :: ref_pos_ext(num_ref_pos_ext) &
         = (/ xt_pos_ext(23, -4), xt_pos_ext(34, 4), xt_pos_ext(19, -10), &
         &    xt_pos_ext(30, 4), xt_pos_ext(9, -8) /)

    CALL check_pos_ext(stripes, search_stripes, ref_pos_ext, .TRUE., &
         num_ref_unmatched, "search dec stripe over jumbled stripes")
  END SUBROUTINE check_pos_ext8

END PROGRAM test_idxstripes_f
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!

!>
!! @file test_xmap_common_f.f90
!! @brief generic Fortran xmap test procedures
!!
!! @copyright Copyright  (C)  2016 Jörg Behrens <behrens@dkrz.de>
!!                                 Moritz Hanke <hanke@dkrz.de>
!!                                 Thomas Jahns <jahns@dkrz.de>
!!
!! @author Jörg Behrens <behrens@dkrz.de>
!!         Moritz Hanke <hanke@dkrz.de>
!!         Thomas Jahns <jahns@dkrz.de>
!!

!
! Keywords:
! Maintainer: Jörg Behrens <behrens@dkrz.de>
!             Moritz Hanke <hanke@dkrz.de>
!             Thomas Jahns <jahns@dkrz.de>
! URL: https://dkrz-sw.gitlab-pages.dkrz.de/yaxt/
!
! Redistribution and use in source and binary forms, with or without
! modification, are  permitted provided that the following conditions are
! met:
!
! Redistributions of source code must retain the above copyright notice,
! this list of conditions and the following disclaimer.
!
! Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.
!
! Neither the name of the DKRZ GmbH nor the names of its contributors
! may be used to endorse or promote products derived from this software
! without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
! IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
! TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
! OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
! EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
! PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
! PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
! LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
! NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
! SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
!
#include "fc_feature_defs.inc"
#if __INTEL_COMPILER == 1500 && __INTEL_COMPILER_UPDATE == 2
#define YAXT_IMPORT USE yaxt, ONLY:
#else
#define YAXT_IMPORT IMPORT ::
#endif
MODULE test_xmap_common
  USE iso_c_binding, ONLY: c_int
  USE mpi
  USE ftest_common, ONLY: init_mpi, finish_mpi, test_abort
  USE test_idxlist_utils, ONLY: test_err_count
  USE yaxt, ONLY: xt_initialize, xt_finalize, xt_int_kind, &
       xt_stripe, xt_idxlist, xt_idxlist_delete, xt_idxvec_new, &
       xt_idxstripes_new, xi => xt_int_kind, &
       xt_xmap, xt_xmap_copy, xt_xmap_delete, &
       xt_xmap_get_num_destinations, xt_xmap_get_num_sources, &
       xt_xmap_get_destination_ranks, xt_xmap_get_source_ranks, &
       xt_mpi_comm_mark_exclusive, xt_config, xt_config_delete, &
       xt_xmap_dist_dir_custom_new
#if defined HAVE_FC_ABSTRACT_INTERFACE
  USE test_xmap_bucket_tiler, ONLY: tile_bucket_config_new, &
       tile_bucket_config_set_global_dims
#endif
  IMPLICIT NONE
  PRIVATE
  INTEGER :: my_rank
  PUBLIC :: xmap_self_test_main, test_self_xmap_construct
  INTERFACE test_self_xmap_construct
    MODULE PROCEDURE test_self_xmap_construct_idxlist
    MODULE PROCEDURE test_self_xmap_construct_indices
    MODULE PROCEDURE test_self_xmap_construct_stripes
  END INTERFACE test_self_xmap_construct
  CHARACTER(len=*), PARAMETER :: filename = 'test_xmap_common_f.f90'
#if defined HAVE_FC_ABSTRACT_INTERFACE
  PROCEDURE(xt_xmap_dist_dir_custom_new), POINTER :: xmap_custom_new_ptr
  TYPE(xt_config) :: custom_bucket_config
#endif
CONTAINS
  SUBROUTINE xmap_self_test_main(xmap_new, xmap_custom_new)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        YAXT_IMPORT xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
      FUNCTION xmap_custom_new(src_idxlist, dst_idxlist, comm, config) &
           RESULT(res)
        YAXT_IMPORT xt_idxlist, xt_xmap, xt_config
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_config), INTENT(in) :: config
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_custom_new
    END INTERFACE
    INTEGER :: ierror, i, j, world_size
    INTEGER :: comms(2)
    INTEGER(xi), PARAMETER :: lsize(2) = (/ 7_xi, 1023_xi /)

    CALL init_mpi
    CALL xt_initialize(mpi_comm_world)
    CALL mpi_comm_rank(mpi_comm_world, my_rank, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)
    CALL mpi_comm_size(mpi_comm_world, world_size, ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)

    comms(1) = mpi_comm_world
    CALL mpi_comm_dup(mpi_comm_world, comms(2), ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)
    CALL xt_mpi_comm_mark_exclusive(comms(2))

#if defined HAVE_FC_ABSTRACT_INTERFACE
    xmap_custom_new_ptr => xmap_custom_new
    IF (ASSOCIATED(xmap_custom_new_ptr, xt_xmap_dist_dir_custom_new)) THEN
      custom_bucket_config = tile_bucket_config_new(&
           1, (/ 8_xi /), (/ world_size /))
    END IF
#endif

    DO i = 1, SIZE(comms)
      DO j = 1, 2
        CALL test_xmap1a(xmap_new, lsize(j), comms(i))
        CALL test_xmap1b(xmap_new, lsize(j), comms(i))
#if defined HAVE_FC_ABSTRACT_INTERFACE
        IF (ASSOCIATED(xmap_custom_new_ptr, xt_xmap_dist_dir_custom_new)) THEN
          CALL tile_bucket_config_set_global_dims(custom_bucket_config, &
               (/ lsize(j)+1_xi /))
          CALL test_xmap1a(new_custom_bucket_xmap_wrapper, lsize(j), comms(i))
          CALL test_xmap1b(new_custom_bucket_xmap_wrapper, lsize(j), comms(i))
        END IF
#endif
      END DO
#if defined HAVE_FC_ABSTRACT_INTERFACE
        IF (ASSOCIATED(xmap_custom_new_ptr, xt_xmap_dist_dir_custom_new)) THEN
          CALL tile_bucket_config_set_global_dims(custom_bucket_config, &
               (/ 100_xi * INT(world_size, xi) /))
          CALL test_xmap2(new_custom_bucket_xmap_wrapper, comms(i))
        END IF
#endif
      CALL test_xmap2(xmap_new, comms(i))
    END DO

#if defined HAVE_FC_ABSTRACT_INTERFACE
    IF (ASSOCIATED(xmap_custom_new_ptr, xt_xmap_dist_dir_custom_new)) THEN
      CALL xt_config_delete(custom_bucket_config)
    END IF
#endif
    CALL mpi_comm_free(comms(2), ierror)
    IF (ierror /= mpi_success) &
         CALL test_abort("MPI error!", filename, __LINE__)

    IF (test_err_count() /= 0) &
         CALL test_abort("non-zero error count!", filename, __LINE__)
    CALL xt_finalize
    CALL finish_mpi
  END SUBROUTINE xmap_self_test_main

#if defined HAVE_FC_ABSTRACT_INTERFACE
  FUNCTION new_custom_bucket_xmap_wrapper(src_idxlist, dst_idxlist, comm) RESULT(res)
    TYPE(xt_idxlist), INTENT(in) :: src_idxlist
    TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
    INTEGER, INTENT(in) :: comm
    TYPE(xt_xmap) :: res
    res = xmap_custom_new_ptr(src_idxlist, dst_idxlist, comm, &
         custom_bucket_config)
  END FUNCTION new_custom_bucket_xmap_wrapper
#endif

  SUBROUTINE shift_idx(idx, offset)
    INTEGER(xi), INTENT(inout) :: idx(:)
    INTEGER(xi), INTENT(in) :: offset
    INTEGER :: i
    DO i = 1, SIZE(idx)
      idx(i) = idx(i) + INT(my_rank, xi) * offset
    END DO
  END SUBROUTINE shift_idx

  SUBROUTINE assert_xmap_is_to_self(xmap)
    TYPE(xt_xmap) :: xmap
    INTEGER :: rank(1)
    IF (xt_xmap_get_num_destinations(xmap) /= 1) &
         CALL test_abort("error in xmap construction", filename, __LINE__)

    IF (xt_xmap_get_num_sources(xmap) /= 1) &
         CALL test_abort("error in xt_xmap_get_num_sources", filename, __LINE__)
    CALL xt_xmap_get_destination_ranks(xmap, rank)
    IF (rank(1) /= my_rank) &
         CALL test_abort("error in xt_xmap_get_destination_ranks", &
         filename, __LINE__)

    CALL xt_xmap_get_source_ranks(xmap, rank)
    IF (rank(1) /= my_rank) &
         CALL test_abort("error in xt_xmap_get_source_ranks", &
         filename, __LINE__)

  END SUBROUTINE assert_xmap_is_to_self

  SUBROUTINE test_self_xmap_construct_stripes(src_stripes, dst_stripes, &
       xmap_new, comm)
    TYPE(xt_stripe), INTENT(in) :: src_stripes(:), dst_stripes(:)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        YAXT_IMPORT xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(in) :: comm
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    src_idxlist = xt_idxstripes_new(src_stripes)
    dst_idxlist = xt_idxstripes_new(dst_stripes)
    CALL test_self_xmap_construct(src_idxlist, dst_idxlist, xmap_new, comm)
  END SUBROUTINE test_self_xmap_construct_stripes

  SUBROUTINE test_self_xmap_construct_indices(src_indices, dst_indices, &
       xmap_new, comm)
    INTEGER(xi), INTENT(in) :: src_indices(:), dst_indices(:)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        YAXT_IMPORT xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(in) :: comm
    TYPE(xt_idxlist) :: src_idxlist, dst_idxlist
    src_idxlist = xt_idxvec_new(src_indices)
    dst_idxlist = xt_idxvec_new(dst_indices)
    CALL test_self_xmap_construct(src_idxlist, dst_idxlist, xmap_new, comm)
  END SUBROUTINE test_self_xmap_construct_indices

  SUBROUTINE test_self_xmap_construct_idxlist(src_idxlist, dst_idxlist, &
       xmap_new, comm)
    TYPE(xt_idxlist), INTENT(inout) :: src_idxlist, dst_idxlist
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        YAXT_IMPORT xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(in) :: comm

    TYPE(xt_xmap) :: xmap, xmap_copy

    xmap = xmap_new(src_idxlist, dst_idxlist, comm)
    CALL xt_idxlist_delete(src_idxlist)
    CALL xt_idxlist_delete(dst_idxlist)

    CALL assert_xmap_is_to_self(xmap)
    xmap_copy = xt_xmap_copy(xmap)
    CALL assert_xmap_is_to_self(xmap_copy)

    CALL xt_xmap_delete(xmap)
    CALL xt_xmap_delete(xmap_copy)
  END SUBROUTINE test_self_xmap_construct_idxlist

  SUBROUTINE test_xmap1a(xmap_new, lsize, comm)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        YAXT_IMPORT xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER(xi), INTENT(in) :: lsize
    INTEGER, INTENT(in) :: comm

    INTEGER(xt_int_kind) :: src_indices(lsize), dst_indices(lsize), i
    DO i = 1_xi, lsize
      src_indices(i) = i
    END DO
    CALL shift_idx(src_indices, lsize)
    DO i = 1_xi, lsize
      dst_indices(i) = lsize - i + 1_xi
    END DO
    CALL shift_idx(dst_indices, lsize)

    CALL test_self_xmap_construct(src_indices, dst_indices, &
         xmap_new, comm)
  END SUBROUTINE test_xmap1a

  SUBROUTINE test_xmap1b(xmap_new, lsize, comm)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        YAXT_IMPORT xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER(xi), INTENT(in) :: lsize
    INTEGER, INTENT(in) :: comm

    TYPE(xt_stripe) :: src_stripe(1), dst_stripe(1)
    src_stripe(1) = xt_stripe(1_xi + INT(my_rank, xi) * lsize, &
         1_xi, INT(lsize, c_int))
    dst_stripe(1) = xt_stripe(INT(my_rank+1, xi) * lsize, &
         -1_xi, INT(lsize, c_int))
    CALL test_self_xmap_construct(src_stripe, dst_stripe, &
         xmap_new, comm)
  END SUBROUTINE test_xmap1b

  SUBROUTINE test_xmap2(xmap_new, comm)
    INTERFACE
      FUNCTION xmap_new(src_idxlist, dst_idxlist, comm) RESULT(res)
        YAXT_IMPORT xt_idxlist, xt_xmap
        IMPLICIT NONE
        TYPE(xt_idxlist), INTENT(in) :: src_idxlist
        TYPE(xt_idxlist), INTENT(in) :: dst_idxlist
        INTEGER, INTENT(in) :: comm
        TYPE(xt_xmap) :: res
      END FUNCTION xmap_new
    END INTERFACE
    INTEGER, INTENT(in) :: comm

    INTEGER(xi) :: src_index_list(14), dst_index_list(13)
    src_index_list = &
         (/ 5_xi, 67_xi, 4_xi, 5_xi, 13_xi, &
         &  9_xi,  2_xi, 1_xi, 0_xi, 96_xi, &
         & 13_xi, 12_xi, 1_xi, 3_xi /)
    dst_index_list = &
         (/ 5_xi, 4_xi, 3_xi, 96_xi, 1_xi, &
         &  5_xi, 4_xi, 5_xi,  4_xi, 3_xi, &
         & 13_xi, 2_xi, 1_xi /)
    CALL test_self_xmap_construct(src_index_list, dst_index_list, xmap_new, comm)
  END SUBROUTINE test_xmap2

END MODULE test_xmap_common
!
! Local Variables:
! f90-continuation-indent: 5
! coding: utf-8
! indent-tabs-mode: nil
! show-trailing-whitespace: t
! require-trailing-newline: t
! End:
!
